from bloonix.dbi.crud import CRUDV
from bloonix.heaven.validator import Validator
from bloonix.heaven import H

class ChartView(CRUDV):
    def __init__(self):
        self.validator = Validator()
        self.validator.set({
            "name": {
                "type": str,
                "minlength": 1,
                "maxlength": 200,
            }
        })

    def get_all(self, host_id, user_id):
        return self.fetchall(
            condition=[
                "where", ["user_id", user_id],
                "and", ["host_id", host_id],
            ],
            order=["asc", ["name"]])

    def get_chart_view(self, chart_view_id, user_id):
        return self.fetchone(
            condition=[
                "where", ["user_id", user_id],
                "and", ["id", chart_view_id],
            ])

    def update_by_id_and_user_id(self, chart_view_id, user_id, data):
        self.update(
            data=data,
            condition=[
                "where", ["user_id", user_id],
                "and", ["id", chart_view_id],
            ])

    def delete_by_id_and_user_id(self, chart_view_id, user_id):
        self.delete(
            condition=[
                "where", ["user_id", user_id],
                "and", ["id", chart_view_id],
            ])

    def update_data_by_id_and_user_id(self, chart_view_id, user_id, data):
        self.update(
            data={"data": data},
            condition=[
                "where", ["user_id", user_id],
                "and", ["id", chart_view_id],
            ])
