from bloonix.dbi.crud import CRUDV
from bloonix.heaven.validator import Validator
from bloonix import timezone

class Contact(CRUDV):
    def __init__(self):
        self.has_unique_column = {
            "column": "name",
            "err": "err-618",
        }
        self.validator = Validator()
        self.validator.set({
            "name": {
                "type": str,
                "minlength": 1,
                "maxlength": 100
            },
            "timezone": {
                "type": str,
                "list_of_dicts_key": "value",
                "list_of_dicts_options": timezone.as_form(),
                "default": "Europe/Berlin"
            },
            "escalation_time": {
                "type": int,
                "options": [0, 300, 600, 900, 1800, 3600, 7200, 14400, 28800],
                "default": 0
            },
            "enabled": {
                "type": int,
                "options": [0,1],
                "default": 1
            },
        })
