from bloonix.heaven import H
from bloonix.dbi.crud import CRUDV
from bloonix.heaven.validator import Validator

class Regauth(CRUDV):
    def __init__(self):
        self.validator = Validator()
        self.validator.set({
            "name": {
                "type": str,
                "minlength": 1,
                "maxlength": 100
            },
            "description": {
                "type": str,
                "minlength": 0,
                "maxlength": 100
            },
            "tags": {
                "type": list,
                "maxsize": 20,
                "maxlength": 1000,
                "default": [],
                "regex": r"\w",
                "allow_empty": True
            },
            "allowed_tags": {
                "type": list,
                "maxsize": 100,
                "maxlength": 1000,
                "regex": r"\w",
                "default": [],
                "allow_empty": True
            },
            "authkey": {
                "type": str,
                "minlength": 64,
                "maxlength": 1024,
            }
        })

    def get_authkey(self, authkey):
        return self.fetchone(condition=["where", ["authkey", authkey]])
