/* @license
                    GNU AFFERO GENERAL PUBLIC LICENSE
                       Version 3, 19 November 2007

 Copyright (C) 2007 Free Software Foundation, Inc. <https://fsf.org/>
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

                            Preamble

  The GNU Affero General Public License is a free, copyleft license for
software and other kinds of works, specifically designed to ensure
cooperation with the community in the case of network server software.

  The licenses for most software and other practical works are designed
to take away your freedom to share and change the works.  By contrast,
our General Public Licenses are intended to guarantee your freedom to
share and change all versions of a program--to make sure it remains free
software for all its users.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.

  Developers that use our General Public Licenses protect your rights
with two steps: (1) assert copyright on the software, and (2) offer
you this License which gives you legal permission to copy, distribute
and/or modify the software.

  A secondary benefit of defending all users' freedom is that
improvements made in alternate versions of the program, if they
receive widespread use, become available for other developers to
incorporate.  Many developers of free software are heartened and
encouraged by the resulting cooperation.  However, in the case of
software used on network servers, this result may fail to come about.
The GNU General Public License permits making a modified version and
letting the public access it on a server without ever releasing its
source code to the public.

  The GNU Affero General Public License is designed specifically to
ensure that, in such cases, the modified source code becomes available
to the community.  It requires the operator of a network server to
provide the source code of the modified version running there to the
users of that server.  Therefore, public use of a modified version, on
a publicly accessible server, gives the public access to the source
code of the modified version.

  An older license, called the Affero General Public License and
published by Affero, was designed to accomplish similar goals.  This is
a different license, not a version of the Affero GPL, but Affero has
released a new version of the Affero GPL which permits relicensing under
this license.

  The precise terms and conditions for copying, distribution and
modification follow.

                       TERMS AND CONDITIONS

  0. Definitions.

  "This License" refers to version 3 of the GNU Affero General Public License.

  "Copyright" also means copyright-like laws that apply to other kinds of
works, such as semiconductor masks.

  "The Program" refers to any copyrightable work licensed under this
License.  Each licensee is addressed as "you".  "Licensees" and
"recipients" may be individuals or organizations.

  To "modify" a work means to copy from or adapt all or part of the work
in a fashion requiring copyright permission, other than the making of an
exact copy.  The resulting work is called a "modified version" of the
earlier work or a work "based on" the earlier work.

  A "covered work" means either the unmodified Program or a work based
on the Program.

  To "propagate" a work means to do anything with it that, without
permission, would make you directly or secondarily liable for
infringement under applicable copyright law, except executing it on a
computer or modifying a private copy.  Propagation includes copying,
distribution (with or without modification), making available to the
public, and in some countries other activities as well.

  To "convey" a work means any kind of propagation that enables other
parties to make or receive copies.  Mere interaction with a user through
a computer network, with no transfer of a copy, is not conveying.

  An interactive user interface displays "Appropriate Legal Notices"
to the extent that it includes a convenient and prominently visible
feature that (1) displays an appropriate copyright notice, and (2)
tells the user that there is no warranty for the work (except to the
extent that warranties are provided), that licensees may convey the
work under this License, and how to view a copy of this License.  If
the interface presents a list of user commands or options, such as a
menu, a prominent item in the list meets this criterion.

  1. Source Code.

  The "source code" for a work means the preferred form of the work
for making modifications to it.  "Object code" means any non-source
form of a work.

  A "Standard Interface" means an interface that either is an official
standard defined by a recognized standards body, or, in the case of
interfaces specified for a particular programming language, one that
is widely used among developers working in that language.

  The "System Libraries" of an executable work include anything, other
than the work as a whole, that (a) is included in the normal form of
packaging a Major Component, but which is not part of that Major
Component, and (b) serves only to enable use of the work with that
Major Component, or to implement a Standard Interface for which an
implementation is available to the public in source code form.  A
"Major Component", in this context, means a major essential component
(kernel, window system, and so on) of the specific operating system
(if any) on which the executable work runs, or a compiler used to
produce the work, or an object code interpreter used to run it.

  The "Corresponding Source" for a work in object code form means all
the source code needed to generate, install, and (for an executable
work) run the object code and to modify the work, including scripts to
control those activities.  However, it does not include the work's
System Libraries, or general-purpose tools or generally available free
programs which are used unmodified in performing those activities but
which are not part of the work.  For example, Corresponding Source
includes interface definition files associated with source files for
the work, and the source code for shared libraries and dynamically
linked subprograms that the work is specifically designed to require,
such as by intimate data communication or control flow between those
subprograms and other parts of the work.

  The Corresponding Source need not include anything that users
can regenerate automatically from other parts of the Corresponding
Source.

  The Corresponding Source for a work in source code form is that
same work.

  2. Basic Permissions.

  All rights granted under this License are granted for the term of
copyright on the Program, and are irrevocable provided the stated
conditions are met.  This License explicitly affirms your unlimited
permission to run the unmodified Program.  The output from running a
covered work is covered by this License only if the output, given its
content, constitutes a covered work.  This License acknowledges your
rights of fair use or other equivalent, as provided by copyright law.

  You may make, run and propagate covered works that you do not
convey, without conditions so long as your license otherwise remains
in force.  You may convey covered works to others for the sole purpose
of having them make modifications exclusively for you, or provide you
with facilities for running those works, provided that you comply with
the terms of this License in conveying all material for which you do
not control copyright.  Those thus making or running the covered works
for you must do so exclusively on your behalf, under your direction
and control, on terms that prohibit them from making any copies of
your copyrighted material outside their relationship with you.

  Conveying under any other circumstances is permitted solely under
the conditions stated below.  Sublicensing is not allowed; section 10
makes it unnecessary.

  3. Protecting Users' Legal Rights From Anti-Circumvention Law.

  No covered work shall be deemed part of an effective technological
measure under any applicable law fulfilling obligations under article
11 of the WIPO copyright treaty adopted on 20 December 1996, or
similar laws prohibiting or restricting circumvention of such
measures.

  When you convey a covered work, you waive any legal power to forbid
circumvention of technological measures to the extent such circumvention
is effected by exercising rights under this License with respect to
the covered work, and you disclaim any intention to limit operation or
modification of the work as a means of enforcing, against the work's
users, your or third parties' legal rights to forbid circumvention of
technological measures.

  4. Conveying Verbatim Copies.

  You may convey verbatim copies of the Program's source code as you
receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice;
keep intact all notices stating that this License and any
non-permissive terms added in accord with section 7 apply to the code;
keep intact all notices of the absence of any warranty; and give all
recipients a copy of this License along with the Program.

  You may charge any price or no price for each copy that you convey,
and you may offer support or warranty protection for a fee.

  5. Conveying Modified Source Versions.

  You may convey a work based on the Program, or the modifications to
produce it from the Program, in the form of source code under the
terms of section 4, provided that you also meet all of these conditions:

    a) The work must carry prominent notices stating that you modified
    it, and giving a relevant date.

    b) The work must carry prominent notices stating that it is
    released under this License and any conditions added under section
    7.  This requirement modifies the requirement in section 4 to
    "keep intact all notices".

    c) You must license the entire work, as a whole, under this
    License to anyone who comes into possession of a copy.  This
    License will therefore apply, along with any applicable section 7
    additional terms, to the whole of the work, and all its parts,
    regardless of how they are packaged.  This License gives no
    permission to license the work in any other way, but it does not
    invalidate such permission if you have separately received it.

    d) If the work has interactive user interfaces, each must display
    Appropriate Legal Notices; however, if the Program has interactive
    interfaces that do not display Appropriate Legal Notices, your
    work need not make them do so.

  A compilation of a covered work with other separate and independent
works, which are not by their nature extensions of the covered work,
and which are not combined with it such as to form a larger program,
in or on a volume of a storage or distribution medium, is called an
"aggregate" if the compilation and its resulting copyright are not
used to limit the access or legal rights of the compilation's users
beyond what the individual works permit.  Inclusion of a covered work
in an aggregate does not cause this License to apply to the other
parts of the aggregate.

  6. Conveying Non-Source Forms.

  You may convey a covered work in object code form under the terms
of sections 4 and 5, provided that you also convey the
machine-readable Corresponding Source under the terms of this License,
in one of these ways:

    a) Convey the object code in, or embodied in, a physical product
    (including a physical distribution medium), accompanied by the
    Corresponding Source fixed on a durable physical medium
    customarily used for software interchange.

    b) Convey the object code in, or embodied in, a physical product
    (including a physical distribution medium), accompanied by a
    written offer, valid for at least three years and valid for as
    long as you offer spare parts or customer support for that product
    model, to give anyone who possesses the object code either (1) a
    copy of the Corresponding Source for all the software in the
    product that is covered by this License, on a durable physical
    medium customarily used for software interchange, for a price no
    more than your reasonable cost of physically performing this
    conveying of source, or (2) access to copy the
    Corresponding Source from a network server at no charge.

    c) Convey individual copies of the object code with a copy of the
    written offer to provide the Corresponding Source.  This
    alternative is allowed only occasionally and noncommercially, and
    only if you received the object code with such an offer, in accord
    with subsection 6b.

    d) Convey the object code by offering access from a designated
    place (gratis or for a charge), and offer equivalent access to the
    Corresponding Source in the same way through the same place at no
    further charge.  You need not require recipients to copy the
    Corresponding Source along with the object code.  If the place to
    copy the object code is a network server, the Corresponding Source
    may be on a different server (operated by you or a third party)
    that supports equivalent copying facilities, provided you maintain
    clear directions next to the object code saying where to find the
    Corresponding Source.  Regardless of what server hosts the
    Corresponding Source, you remain obligated to ensure that it is
    available for as long as needed to satisfy these requirements.

    e) Convey the object code using peer-to-peer transmission, provided
    you inform other peers where the object code and Corresponding
    Source of the work are being offered to the general public at no
    charge under subsection 6d.

  A separable portion of the object code, whose source code is excluded
from the Corresponding Source as a System Library, need not be
included in conveying the object code work.

  A "User Product" is either (1) a "consumer product", which means any
tangible personal property which is normally used for personal, family,
or household purposes, or (2) anything designed or sold for incorporation
into a dwelling.  In determining whether a product is a consumer product,
doubtful cases shall be resolved in favor of coverage.  For a particular
product received by a particular user, "normally used" refers to a
typical or common use of that class of product, regardless of the status
of the particular user or of the way in which the particular user
actually uses, or expects or is expected to use, the product.  A product
is a consumer product regardless of whether the product has substantial
commercial, industrial or non-consumer uses, unless such uses represent
the only significant mode of use of the product.

  "Installation Information" for a User Product means any methods,
procedures, authorization keys, or other information required to install
and execute modified versions of a covered work in that User Product from
a modified version of its Corresponding Source.  The information must
suffice to ensure that the continued functioning of the modified object
code is in no case prevented or interfered with solely because
modification has been made.

  If you convey an object code work under this section in, or with, or
specifically for use in, a User Product, and the conveying occurs as
part of a transaction in which the right of possession and use of the
User Product is transferred to the recipient in perpetuity or for a
fixed term (regardless of how the transaction is characterized), the
Corresponding Source conveyed under this section must be accompanied
by the Installation Information.  But this requirement does not apply
if neither you nor any third party retains the ability to install
modified object code on the User Product (for example, the work has
been installed in ROM).

  The requirement to provide Installation Information does not include a
requirement to continue to provide support service, warranty, or updates
for a work that has been modified or installed by the recipient, or for
the User Product in which it has been modified or installed.  Access to a
network may be denied when the modification itself materially and
adversely affects the operation of the network or violates the rules and
protocols for communication across the network.

  Corresponding Source conveyed, and Installation Information provided,
in accord with this section must be in a format that is publicly
documented (and with an implementation available to the public in
source code form), and must require no special password or key for
unpacking, reading or copying.

  7. Additional Terms.

  "Additional permissions" are terms that supplement the terms of this
License by making exceptions from one or more of its conditions.
Additional permissions that are applicable to the entire Program shall
be treated as though they were included in this License, to the extent
that they are valid under applicable law.  If additional permissions
apply only to part of the Program, that part may be used separately
under those permissions, but the entire Program remains governed by
this License without regard to the additional permissions.

  When you convey a copy of a covered work, you may at your option
remove any additional permissions from that copy, or from any part of
it.  (Additional permissions may be written to require their own
removal in certain cases when you modify the work.)  You may place
additional permissions on material, added by you to a covered work,
for which you have or can give appropriate copyright permission.

  Notwithstanding any other provision of this License, for material you
add to a covered work, you may (if authorized by the copyright holders of
that material) supplement the terms of this License with terms:

    a) Disclaiming warranty or limiting liability differently from the
    terms of sections 15 and 16 of this License; or

    b) Requiring preservation of specified reasonable legal notices or
    author attributions in that material or in the Appropriate Legal
    Notices displayed by works containing it; or

    c) Prohibiting misrepresentation of the origin of that material, or
    requiring that modified versions of such material be marked in
    reasonable ways as different from the original version; or

    d) Limiting the use for publicity purposes of names of licensors or
    authors of the material; or

    e) Declining to grant rights under trademark law for use of some
    trade names, trademarks, or service marks; or

    f) Requiring indemnification of licensors and authors of that
    material by anyone who conveys the material (or modified versions of
    it) with contractual assumptions of liability to the recipient, for
    any liability that these contractual assumptions directly impose on
    those licensors and authors.

  All other non-permissive additional terms are considered "further
restrictions" within the meaning of section 10.  If the Program as you
received it, or any part of it, contains a notice stating that it is
governed by this License along with a term that is a further
restriction, you may remove that term.  If a license document contains
a further restriction but permits relicensing or conveying under this
License, you may add to a covered work material governed by the terms
of that license document, provided that the further restriction does
not survive such relicensing or conveying.

  If you add terms to a covered work in accord with this section, you
must place, in the relevant source files, a statement of the
additional terms that apply to those files, or a notice indicating
where to find the applicable terms.

  Additional terms, permissive or non-permissive, may be stated in the
form of a separately written license, or stated as exceptions;
the above requirements apply either way.

  8. Termination.

  You may not propagate or modify a covered work except as expressly
provided under this License.  Any attempt otherwise to propagate or
modify it is void, and will automatically terminate your rights under
this License (including any patent licenses granted under the third
paragraph of section 11).

  However, if you cease all violation of this License, then your
license from a particular copyright holder is reinstated (a)
provisionally, unless and until the copyright holder explicitly and
finally terminates your license, and (b) permanently, if the copyright
holder fails to notify you of the violation by some reasonable means
prior to 60 days after the cessation.

  Moreover, your license from a particular copyright holder is
reinstated permanently if the copyright holder notifies you of the
violation by some reasonable means, this is the first time you have
received notice of violation of this License (for any work) from that
copyright holder, and you cure the violation prior to 30 days after
your receipt of the notice.

  Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License.  If your rights have been terminated and not permanently
reinstated, you do not qualify to receive new licenses for the same
material under section 10.

  9. Acceptance Not Required for Having Copies.

  You are not required to accept this License in order to receive or
run a copy of the Program.  Ancillary propagation of a covered work
occurring solely as a consequence of using peer-to-peer transmission
to receive a copy likewise does not require acceptance.  However,
nothing other than this License grants you permission to propagate or
modify any covered work.  These actions infringe copyright if you do
not accept this License.  Therefore, by modifying or propagating a
covered work, you indicate your acceptance of this License to do so.

  10. Automatic Licensing of Downstream Recipients.

  Each time you convey a covered work, the recipient automatically
receives a license from the original licensors, to run, modify and
propagate that work, subject to this License.  You are not responsible
for enforcing compliance by third parties with this License.

  An "entity transaction" is a transaction transferring control of an
organization, or substantially all assets of one, or subdividing an
organization, or merging organizations.  If propagation of a covered
work results from an entity transaction, each party to that
transaction who receives a copy of the work also receives whatever
licenses to the work the party's predecessor in interest had or could
give under the previous paragraph, plus a right to possession of the
Corresponding Source of the work from the predecessor in interest, if
the predecessor has it or can get it with reasonable efforts.

  You may not impose any further restrictions on the exercise of the
rights granted or affirmed under this License.  For example, you may
not impose a license fee, royalty, or other charge for exercise of
rights granted under this License, and you may not initiate litigation
(including a cross-claim or counterclaim in a lawsuit) alleging that
any patent claim is infringed by making, using, selling, offering for
sale, or importing the Program or any portion of it.

  11. Patents.

  A "contributor" is a copyright holder who authorizes use under this
License of the Program or a work on which the Program is based.  The
work thus licensed is called the contributor's "contributor version".

  A contributor's "essential patent claims" are all patent claims
owned or controlled by the contributor, whether already acquired or
hereafter acquired, that would be infringed by some manner, permitted
by this License, of making, using, or selling its contributor version,
but do not include claims that would be infringed only as a
consequence of further modification of the contributor version.  For
purposes of this definition, "control" includes the right to grant
patent sublicenses in a manner consistent with the requirements of
this License.

  Each contributor grants you a non-exclusive, worldwide, royalty-free
patent license under the contributor's essential patent claims, to
make, use, sell, offer for sale, import and otherwise run, modify and
propagate the contents of its contributor version.

  In the following three paragraphs, a "patent license" is any express
agreement or commitment, however denominated, not to enforce a patent
(such as an express permission to practice a patent or covenant not to
sue for patent infringement).  To "grant" such a patent license to a
party means to make such an agreement or commitment not to enforce a
patent against the party.

  If you convey a covered work, knowingly relying on a patent license,
and the Corresponding Source of the work is not available for anyone
to copy, free of charge and under the terms of this License, through a
publicly available network server or other readily accessible means,
then you must either (1) cause the Corresponding Source to be so
available, or (2) arrange to deprive yourself of the benefit of the
patent license for this particular work, or (3) arrange, in a manner
consistent with the requirements of this License, to extend the patent
license to downstream recipients.  "Knowingly relying" means you have
actual knowledge that, but for the patent license, your conveying the
covered work in a country, or your recipient's use of the covered work
in a country, would infringe one or more identifiable patents in that
country that you have reason to believe are valid.

  If, pursuant to or in connection with a single transaction or
arrangement, you convey, or propagate by procuring conveyance of, a
covered work, and grant a patent license to some of the parties
receiving the covered work authorizing them to use, propagate, modify
or convey a specific copy of the covered work, then the patent license
you grant is automatically extended to all recipients of the covered
work and works based on it.

  A patent license is "discriminatory" if it does not include within
the scope of its coverage, prohibits the exercise of, or is
conditioned on the non-exercise of one or more of the rights that are
specifically granted under this License.  You may not convey a covered
work if you are a party to an arrangement with a third party that is
in the business of distributing software, under which you make payment
to the third party based on the extent of your activity of conveying
the work, and under which the third party grants, to any of the
parties who would receive the covered work from you, a discriminatory
patent license (a) in connection with copies of the covered work
conveyed by you (or copies made from those copies), or (b) primarily
for and in connection with specific products or compilations that
contain the covered work, unless you entered into that arrangement,
or that patent license was granted, prior to 28 March 2007.

  Nothing in this License shall be construed as excluding or limiting
any implied license or other defenses to infringement that may
otherwise be available to you under applicable patent law.

  12. No Surrender of Others' Freedom.

  If conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot convey a
covered work so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you may
not convey it at all.  For example, if you agree to terms that obligate you
to collect a royalty for further conveying from those to whom you convey
the Program, the only way you could satisfy both those terms and this
License would be to refrain entirely from conveying the Program.

  13. Remote Network Interaction; Use with the GNU General Public License.

  Notwithstanding any other provision of this License, if you modify the
Program, your modified version must prominently offer all users
interacting with it remotely through a computer network (if your version
supports such interaction) an opportunity to receive the Corresponding
Source of your version by providing access to the Corresponding Source
from a network server at no charge, through some standard or customary
means of facilitating copying of software.  This Corresponding Source
shall include the Corresponding Source for any work covered by version 3
of the GNU General Public License that is incorporated pursuant to the
following paragraph.

  Notwithstanding any other provision of this License, you have
permission to link or combine any covered work with a work licensed
under version 3 of the GNU General Public License into a single
combined work, and to convey the resulting work.  The terms of this
License will continue to apply to the part which is the covered work,
but the work with which it is combined will remain governed by version
3 of the GNU General Public License.

  14. Revised Versions of this License.

  The Free Software Foundation may publish revised and/or new versions of
the GNU Affero General Public License from time to time.  Such new versions
will be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.

  Each version is given a distinguishing version number.  If the
Program specifies that a certain numbered version of the GNU Affero General
Public License "or any later version" applies to it, you have the
option of following the terms and conditions either of that numbered
version or of any later version published by the Free Software
Foundation.  If the Program does not specify a version number of the
GNU Affero General Public License, you may choose any version ever published
by the Free Software Foundation.

  If the Program specifies that a proxy can decide which future
versions of the GNU Affero General Public License can be used, that proxy's
public statement of acceptance of a version permanently authorizes you
to choose that version for the Program.

  Later license versions may give you additional or different
permissions.  However, no additional obligations are imposed on any
author or copyright holder as a result of your choosing to follow a
later version.

  15. Disclaimer of Warranty.

  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

  16. Limitation of Liability.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.

  17. Interpretation of Sections 15 and 16.

  If the disclaimer of warranty and limitation of liability provided
above cannot be given local legal effect according to their terms,
reviewing courts shall apply local law that most closely approximates
an absolute waiver of all civil liability in connection with the
Program, unless a warranty or assumption of liability accompanies a
copy of the Program in return for a fee.

                     END OF TERMS AND CONDITIONS

            How to Apply These Terms to Your New Programs

  If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.

  To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
state the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

Also add information on how to contact you by electronic and paper mail.

  If your software can interact with users remotely through a computer
network, you should also make sure that it provides a way for users to
get its source.  For example, if your program is a web application, its
interface could display a "Source" link that leads users to an archive
of the code.  There are many ways you could offer source, and different
solutions will be better for different programs; see section 13 for the
specific requirements.

  You should also get your employer (if you work as a programmer) or school,
if any, to sign a "copyright disclaimer" for the program, if necessary.
For more information on this, and how to apply and follow the GNU AGPL, see
<https://www.gnu.org/licenses/>.
*/
(function(){"use strict";function BloonixJSFramework(version=0){const Blx={version:version};class Ajax{constructor(){this.defaults={tokenUrl:"/token/csrf",beforeSuccess:false,ignoreErrors:[],errorCallback:{},error:false};this.xhrPool=[];this.jqueryAjaxDefaults={async:true,beforeSend:jqXHR=>this._jqueryBeforeSend(jqXHR),complete:jqXHR=>this._jqueryComplete(jqXHR)}}_jqueryBeforeSend(jqXHR){Log.debug("begin add jqXHR, cur length "+this.xhrPool.length);this.xhrPool.push(jqXHR);Log.debug("end add jqXHR, new length "+this.xhrPool.length)}_jqueryComplete(jqXHR){Log.debug("begin remove jqXHR, cur length "+this.xhrPool.length);const index=this.xhrPool.indexOf(jqXHR);if(index>-1){this.xhrPool.splice(index,1)}Log.debug("end remove jqXHR, new length "+this.xhrPool.length)}abortXHRs(){if(this.xhrPool.length>0){Log.debug("begin abort jqXHR, cur length"+this.xhrPool.length);const xhr=this.xhrPool.shift().abort();this.abortXHRs();Log.debug("end abort jqXHR, new length"+this.xhrPool.length)}}getToken(o){o.token=false;this.request({url:o.tokenUrl,success:result=>{if(o.data===undefined){o.data={}}o.data.token=result.data.token;this.request(o)}})}request(o){Blx.utils.append(o,this.defaults);Blx.utils.append(o.errorCallback,this.defaults.errorCallback);Blx.utils.append(o.ignoreErrors,this.defaults.ignoreErrors);this._request(o)}_request(o){if(o.token===true){this.getToken(o);return}const jqueryOptions=Blx.utils.extend({},this.jqueryAjaxDefaults);jqueryOptions.error=(xhr,ajaxOptions,thrownError)=>this.error(o,xhr,ajaxOptions,thrownError);jqueryOptions.success=(result,status,xhr)=>this.success(o,result,status,xhr);jqueryOptions.url=o.url;jqueryOptions.data=Blx.utils.toJSON(o.data);jqueryOptions.type="post";jqueryOptions.contentType="application/json; charset=utf-8";jqueryOptions.scriptCharset="utf-8";jqueryOptions.dataType="json";jqueryOptions.processData=false;if(o.async!==undefined){jqueryOptions.async=o.async}Log.info("request "+o.url+" (async="+jqueryOptions.async+")");o.startTime=Date.now();$.ajax(jqueryOptions)}error(o,xhr,ajaxOptions,thrownError){Log.error("Request "+o.url+" failed");console.log("xhr",xhr);console.log("ajaxOptions",ajaxOptions);console.log("thrownError",thrownError);if(o.error){o.error(xhr,ajaxOptions,thrownError)}}success(o,result,status,xhr){const runtime=(Date.now()-o.startTime)/1e3;Log.info("request "+o.url+" took "+runtime.toFixed(3)+"s");const contentType=xhr.getResponseHeader("content-type")||"";if(contentType!="application/json; charset=utf-8"){Blx.throwError({message:"Content-Type does not match! Got: <"+contentType+"> Expected: <application/json; charset=utf-8>"})}Log.debug("response status: "+result.status);if(typeof result!="object"){Blx.throwError({message:"invalid response type '"+typeof result+")"})}if(result.status!="ok"&&o.ignoreErrors.includes(result.status)===false){Log.error("request ("+o.url+"):");Log.error(result);if(o.errorCallback[result.status]){o.errorCallback[result.status](result)}else if(o.error){o.error(result)}else{let message=result.status;if(result.data&&result.data.message){message+=" "+result.data.message}else{message+=" an unexpected error occurs"}Blx.errorMessage({message:message})}if(o.cleanupOnErrorCallback){o.cleanupOnErrorCallback(result)}}else{if(o.beforeSuccess!==false){o.beforeSuccess(result)}if(o.success){o.success(result)}}if(o.finish){o.finish(result)}}}Blx.ajax=new Ajax;class Breadcrumb{constructor(o){this.items=0;this.icon=Blx.icon().size(o.iconSize||"tiny").coloring(o.iconColoring||"white");this.list=Blx.create("div").addClass("blx-breadcrumb").hide();$(o.container).html(this.list)}add(text,callback){Log.info(`breadcrumb.add(${text})`);this.list.show();this.items+=1;const link=Blx.create("a").addClass("blx-breadcrumb-item").appendTo(this.list);const icon=Blx.create("span").addClass("blx-breadcrumb-chevron").html(this.icon.span("chevrons-right")).appendTo(link);const span=Blx.create("span").setHTML(text).appendTo(link);if(this.items===1){icon.hide()}this.__update(link,span,text,callback);link.click(()=>{const callback=link.data("blx-callback");if(typeof callback=="string"){Blx.route.to(callback)}else{callback()}});return{update:(text,callback)=>this.__update(link,span,text,callback),remove:()=>this.__remove(link)}}__update(link,span,text,callback){span.text(text);link.data("blx-callback",callback);if(typeof callback=="string"){link.attr("href","#"+callback)}}__remove(link){this.items-=1;link.remove();if(this.items===0){this.list.hide()}else{$(this.list.find(".blx-breadcrumb-chevron")[0]).hide()}}clear(){Log.info("breadcrumb.clear()");this.list.html("");this.list.hide();this.items=0}}Blx.breadcrumb=o=>new Breadcrumb(o);class bSelect{constructor(o){this.config=Blx.utils.config(o,["items","selected","appendTo","onSelect","itemClass"]);this.container=Create("div");for(let i=0;i<this.config.items.length;i++){const item=this.config.items[i];const el=Create("span").addClass("blx-bselect-btn").setHTML(item.name).data(item).appendTo(this.container);if(this.config.itemClass){el.addClass(this.config.itemClass)}if(item.selected===true||this.config.selected===item.value){this.selected=el;el.addClass("blx-bselect-btn-selected")}el.click(()=>{if(this.selected!==false){this.selected.removeClass("blx-bselect-btn-selected")}this.selected=el;this.selected.addClass("blx-bselect-btn-selected");if(this.config.onSelect){this.config.onSelect(this.value())}})}if(this.config.appendTo){this.container.appendTo(this.config.appendTo)}else if(this.config.replaceTo){this.config.replaceTo.html(this.container)}}value(){if(this.selected!==false){return this.selected.data().value}}}Blx.bselect=o=>new bSelect(o);function button(o){o=Blx.utils.config(o,["text","color","size","icon"],{color:"dark",size:"default"});if(o.icon){return Blx.create("div").addClass("blx-btn").addClass(`blx-btn-${o.color}`).prop("title",o.text).css({display:"inline-block",width:"14px",height:"14px"}).append(svgIcons[o.icon])}return Blx.create("div").text(o.text).addClass("blx-btn").addClass(`blx-btn-${o.color}`).addClass(`blx-btn-${o.size}`)}Blx.button=button;class ContentBox{constructor(o){this.config=Blx.utils.config(o,["grow","bodyGrow","title","titleIcon","titleIconColor","titleCentered","subtitle","icons","iconConfig","body","appendTo","replaceTo","headerBorder","footerBorder"],Blx.contentBoxProps);if(this.config.bodyGrow===undefined){this.config.bodyGrow=this.config.grow}Blx.dom({name:"container",addClass:"blx-content-box-container",flex:this.config.grow===true?"column":undefined,boxes:[{name:"headerWrapper",boxes:[{name:"header",flex:"row",nowrap:true,boxes:[{name:"headerLeft",addClass:"blx-content-box-header-left"},{name:"headerMiddle",addClass:"blx-content-box-header-center",scroll:true},{name:"headerRight",addClass:"blx-content-box-header-right"}]},{name:"subtitleWrapper"}]},{name:"control"},{name:"message"},{name:"search"},{name:"filter"},{name:"body",flex:this.config.bodyGrow===true?"grow":undefined,scroll:true},{name:"footerWrapper",boxes:[{name:"footer",flex:"row",scroll:true,boxes:[{name:"footerLeft",addClass:"blx-content-box-footer-left"},{name:"footerMiddle",flex:"grow",addClass:"blx-content-box-footer-center"},{name:"footerRight",addClass:"blx-content-box-footer-right"}]}]}]},this);this.icon=Blx.icon(Blx.utils.setopts(this.config.iconConfig,{size:"default",coloring:"gray",appendTo:this.headerRight}));if(this.config.headerBorder===true){this.header.addClass("blx-content-box-header-border")}if(this.config.footerBorder===true){this.footerWrapper.addClass("blx-content-box-footer-border")}if(this.config.body){this.body.setHTML(this.config.body)}if(this.config.title){this.header.addClass("blx-content-box-header");this.title=Create("div").addClass("blx-content-box-title");if(this.config.titleCentered===true){this.title.appendTo(this.headerMiddle)}else{this.title.appendTo(this.headerLeft)}if(this.config.titleIcon){Blx.icon().size("small").coloring(this.config.titleIconColor).marginRight(10).span(this.config.titleIcon).appendTo(this.title)}Create("span").setHTML(this.config.title).appendTo(this.title)}if(this.config.subtitle){this.subtitle=Create("div").addClass("blx-content-box-subtitle").setHTML(this.config.subtitle).appendTo(this.subtitleWrapper)}if(this.config.replaceTo){this.config.replaceTo.html(this.container)}else if(this.config.appendTo){this.container.appendTo(this.config.appendTo)}this.__order="unset";Blx.resize.add(this.container,()=>{if(this.container.outerWidth()<600){if(this.__order=="unset"){this.__order=3;this.headerMiddle.css("order","3");this.headerMiddle.css("width","100%");this.header.css("flex-wrap","wrap")}}else if(this.__order==3){this.__order="unset";this.headerMiddle.css("order","unset");this.headerMiddle.css("width","auto");this.header.css("flex-wrap","nowrap")}})}create(){throwError("contentBox.create() is deprecated");return this}appendTo(container){this.container.appendTo(container);return this}replaceTo(container){container.html(this.container)}}Blx.contentBox=o=>new ContentBox(o);Blx.contentBoxProps={grow:true,headerBorder:true,footerBorder:true,titleIconColor:"black"};function Create(e,o,t){return $(document.createElement(e),o,t)}Blx.create=Create;var DateFormat=function(){var token=/d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,timezone=/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,timezoneClip=/[^-+\dA-Z]/g,pad=function(val,len){val=String(val);len=len||2;while(val.length<len)val="0"+val;return val};return function(date,mask,utc){var dF=DateFormat;dF.i18n=Blx.text.dateFormat[Blx.text.lang];if(arguments.length==1&&Object.prototype.toString.call(date)=="[object String]"&&!/\d/.test(date)){mask=date;date=undefined}date=date?new Date(date):new Date;if(isNaN(date))throw SyntaxError("invalid date");mask=String(dF.masks[mask]||mask||dF.masks["default"]);if(mask.slice(0,4)=="UTC:"){mask=mask.slice(4);utc=true}var _=utc?"getUTC":"get",d=date[_+"Date"](),D=date[_+"Day"](),m=date[_+"Month"](),y=date[_+"FullYear"](),H=date[_+"Hours"](),M=date[_+"Minutes"](),s=date[_+"Seconds"](),L=date[_+"Milliseconds"](),o=utc?0:date.getTimezoneOffset(),flags={d:d,dd:pad(d),ddd:dF.i18n.dayNames[D],dddd:dF.i18n.dayNames[D+7],m:m+1,mm:pad(m+1),mmm:dF.i18n.monthNames[m],mmmm:dF.i18n.monthNames[m+12],yy:String(y).slice(2),yyyy:y,h:H%12||12,hh:pad(H%12||12),H:H,HH:pad(H),M:M,MM:pad(M),s:s,ss:pad(s),l:pad(L,3),L:pad(L>99?Math.round(L/10):L),t:H<12?"a":"p",tt:H<12?"am":"pm",T:H<12?"A":"P",TT:H<12?"AM":"PM",Z:utc?"UTC":(String(date).match(timezone)||[""]).pop().replace(timezoneClip,""),o:(o>0?"-":"+")+pad(Math.floor(Math.abs(o)/60)*100+Math.abs(o)%60,4),S:["th","st","nd","rd"][d%10>3?0:(d%100-d%10!=10)*d%10]};return mask.replace(token,function($0){return $0 in flags?flags[$0]:$0.slice(1,$0.length-1)})}}();DateFormat.masks={default:"yyyy-mm-dd HH:MM:ss",date:"yyyy-mm-dd",time:"HH:MM:ss",shortDate:"m/d/yy",mediumDate:"mmm d, yyyy",longDate:"mmmm d, yyyy",fullDate:"dddd, mmmm d, yyyy",shortTime:"h:MM TT",mediumTime:"h:MM:ss TT",longTime:"h:MM:ss TT Z",isoDate:"yyyy-mm-dd",isoTime:"HH:MM:ss",isoDateTime:"yyyy-mm-dd'T'HH:MM:ss",isoUtcDateTime:"UTC:yyyy-mm-dd'T'HH:MM:ss'Z'",noSeconds:"yyyy-mm-dd HH:MM",timePlusMs:"HH:MM:ss.l"};Blx.dateFormat=(value,mask,utc)=>DateFormat(value,DateFormat.masks[mask],utc);class DatePager{constructor(o){this.config=Blx.utils.config(o,["appendTo","onSelect","hideOnSelect"],Blx.datePagerProps);const icon=Blx.icon().size("default").coloring(this.config.iconColoring).cursor("pointer");this.container=Blx.create("div").addClass("blx-date-pager");this.date=Date.now();if(this.config.appendTo){this.container.appendTo(this.config.appendTo)}this.prevIcon=Blx.create("div").addClass("blx-date-pager-icon").append(icon.span("chevron-left")).appendTo(this.container);this.dateContainer=Blx.create("div").addClass("blx-date-pager-date-container").appendTo(this.container);this.datepickerBox=Blx.create("div").addClass("blx-date-pager-datepicker").hide().appendTo(this.dateContainer);this.dateBox=Blx.create("div").addClass("blx-date-pager-datebox").data("date",this.date).text(Blx.dateFormat(this.date,"date")).appendTo(this.dateContainer);this.nextIcon=Blx.create("div").addClass("blx-date-pager-icon").append(icon.span("chevron-right")).appendTo(this.container);this.prevIcon.click(()=>{this.date-=864e5;this.dateBox.text(Blx.dateFormat(this.date,"date"));this.config.onSelect(this.getUnixtime(),this.getDate())});this.nextIcon.click(()=>{this.date+=864e5;this.dateBox.text(Blx.dateFormat(this.date,"date"));this.config.onSelect(this.getUnixtime(),this.getDate())});this.datepickerBox.datepicker({dateFormat:"yy-mm-dd",onSelect:date=>{if(this.config.hideOnSelect===true){this.datepickerBox.hide()}this.date=new Date(date).getTime();this.dateBox.text(Blx.dateFormat(this.date,"date"));this.config.onSelect(this.getUnixtime(),this.getDate())}});this.dateBox.click(()=>this.datepickerBox.show())}show(){this.datepickerBox.show()}hide(){this.datepickerBox.hide()}getUnixtime(){return this.date/1e3}getDate(){return Blx.dateFormat(this.date,"date")}appendTo(o){this.container.appendTo(o)}onSelect(o){this.config.onSelect=o}}Blx.datePager=o=>new DatePager(o);Blx.datePagerProps={hideOnSelect:true,iconColoring:"dark"};function flex(o,a){if(!a){a={}}a[o.name]=Create(o.tag||"div");if(o.flex){if(typeof o.flex=="string"){a[o.name].addClass(`blx-flex-${o.flex}`)}else{$.each(o.flex,(i,name)=>{a[o.name].addClass(`blx-flex-${name}`)})}}if(o.nowrap===true){a[o.name].addClass("blx-flex-nowrap")}if(o.wrap===true){a[o.name].addClass("blx-flex-wrap")}if(o.grow===true){a[o.name].addClass("blx-dom-fwh")}if(o.scroll===true){a[o.name].addClass("blx-dom-scroll")}else if(o.scroll===false){a[o.name].addClass("blx-dom-hidden")}if(o.addClass){a[o.name].addClass(o.addClass)}if(o.addId){a[o.name].attr("id",o.addId)}if(o.css){a[o.name].css(o.css)}if(o.boxes){$.each(o.boxes,(i,item)=>{flex(item,a);a[item.name].appendTo(a[o.name])})}a[o.name].attr("data-blx-flex-name",o.name);return a}Blx.dom=flex;class ElementInfo{constructor(o){this.config=o;this.config.appendTo.addClass("bloonix-element-info-container");this.box=Blx.create("div").addClass("bloonix-element-info-box").hide().setHTML(this.config.body).appendTo(this.config.appendTo)}show(time){this.box.css("top",this.config.appendTo.outerHeight()+4);this.box.show(time);setTimeout(()=>{this.box.hide(400)},3e3)}}Blx.elementInfo=o=>new ElementInfo(o);class Form{constructor(o){Blx.utils.config(o,["grow","submitUrl","submitButtonText","showSubmitButton","submitCallback","processDataCallback","appendTo","replaceTo","scrollContainer","options","values","optionsUrl","optionsPostdata","ignoreErrors","errorCallback","errorFallback","onSuccess","elements","messageContainer","splice","addHiddenSubmitButton","showMandatoryFieldsInfo","formInfo","iconSize","iconColoring","iconRadius","overlay"],Blx.formProps,this);if(this.optionsUrl){Blx.ajax.request({url:this.optionsUrl,data:this.optionsPostdata,success:result=>{this.options=result.data.options;this.values=result.data.values;this.__init()}})}else{this.__init()}}__init(){this.attachments={};this.elementsByName={};this.rowsByName={};this.icon=Blx.icon().size(this.iconSize).coloring(this.iconColoring).radius(this.iconRadius).iconClass("blx-form-row-icon");this.container=Blx.create("div").addClass("blx-form-container");if(this.formInfo){const formInfo=Blx.create("div").addClass("blx-form-info").appendTo(this.container);Blx.create("div").addClass("blx-form-info-title").setHTML(Blx.text.get("word.Information")).appendTo(formInfo);Blx.create("span").setHTML(this.formInfo).appendTo(formInfo)}if(this.showMandatoryFieldsInfo){this.mandatoryFieldsInfo=Blx.create("div").addClass("blx-form-mfi").text(Blx.text.get("form.required_fields")).appendTo(this.container)}this.form=Blx.create("form").appendTo(this.container);this.formContainer=Blx.create("div").appendTo(this.form);this.formElButtonsContainer=Blx.create("div").addClass("blx-form-form-el-buttons-container").appendTo(this.form);if(this.showSubmitButton===true&&!this.overlay){this.submitButton=Blx.create("div").addClass("blx-form-submit-button").appendTo(this.form).setHTML(this.submitButtonText||Blx.text.get("action.submit")).click(()=>this.submit())}if(this.replaceTo){this.replaceTo.html(this.container)}if(this.appendTo){this.container.appendTo(this.appendTo)}if(this.addHiddenSubmitButton===true){Blx.create("button").attr("type","submit").hide().appendTo(this.form)}this.form.submit(e=>{e.preventDefault();this.submit();return false});if(this.overlay){this.messageContainer=this.overlay.message;this.container.appendTo(this.overlay.body);const button=this.overlay.addButton({text:Blx.text.get("action.submit"),callback:()=>this.submit()});this.setSubmitButton(button)}if(this.elements){this.addElements(this.elements)}}addElements(elements){$.each(elements,(i,item)=>{const tag=item.tag;delete item["tag"];if(this[tag]===undefined){throw new Error(`tag ${tag} does not exists`)}this[tag](item)})}setSubmitButton(btn){this.submitButton=btn}getValue(o){if(o.value!==undefined){return o.value}if(this.values===undefined){return undefined}if(this.values[o.name]!==undefined){return this.values[o.name]}if(this.splice===true||o.splice===true){const parts=o.name.split(":");if(parts.length>1){const n1=parts[0],n2=parts[1];if(typeof this.values[n1]=="object"){return this.values[n1][n2]}}}}getOptions(o){if(o.options!==undefined){return o}if(this.options!==undefined&&this.options[o.name]!==undefined){return this.options[o.name]}return{options:[]}}getSelectOptions(o){if(o.convertSeconds===true){return Blx.utils.secondsToFormValues(this.getOptions(o).options)}const options=[];$.each(this.getOptions(o).options,(i,item)=>{if(typeof item!="object"){const label=o.label?o.label(item):item;options.push({label:label,value:item})}else{options.push(item)}});return options}div(o){const row=Blx.create("div").addClass("blx-form-info");if(o.title){Blx.create("div").addClass("blx-form-info-title").setHTML(o.title).appendTo(row)}if(o.content){Blx.create("div").setHTML(o.content).appendTo(row)}row.appendTo(this.formContainer)}input(o){o=Blx.utils.config(o,["type","name","text","help","value","options","minlength","maxlength","minvalue","maxvalue","pattern","required","readonly","password","reSendPassword","genpwd","genpwdComplex","deleteIfEmpty","autocomplete","autocompleteUrl","placeholder","ignoreIfEmpty","mono","multiple","appendTo","parseInt","parseFloat"],{type:"text",value:this.getValue(o),parseInt:false,parseFloat:false});const input=Blx.create("input").addClass("blx-form-input");let container=input;if(o.type=="file"){container=Blx.create("div").append(input);if(o.multiple===true){input.attr("multiple",true)}this.handleAttachments(o,input,container)}if(o.mono===true){input.addClass("blx-preformatted")}const icons=[];if(o.password===true){o.origValue=o.value;o.value="**********";input.data("pwv",false);const showPwIcon=this.icon.btn("eye").click(()=>{if(input.data("pwv")===false){input.data("pwv",true);input.val(o.origValue)}else{input.data("pwv",false);input.val(o.value)}});icons.push(showPwIcon);if(o.genpwd){icons.push(this.icon.btn("settings").click(()=>{input.data("pwv",true);o.value=Blx.utils.genRandStr(o.genpwd,o.genpwdComplex);input.focus();input.val(o.value);showPwIcon.hide()}))}}else if(o.genpwd){icons.push(this.icon.btn("settings").click(()=>{input.focus();input.val(Blx.utils.genRandStr(o.genpwd,o.genpwdComplex))}))}let footer;if(o.autocompleteUrl){footer=Blx.create("ul").addClass("blx-form-autocomplete-list").hide();input.on("blur",()=>footer.hide(200));input.on("focus",()=>{Blx.ajax.request({url:o.autocompleteUrl,success:result=>{input.on("keyup",()=>{footer.html("");$.each(Blx.utils.filterDataArray(input.val(),result.data),(i,s)=>{Blx.create("li").text(s).appendTo(footer).click(()=>input.val(s))})});input.trigger("keyup");footer.show(300)}})})}this._saveElement("input",o);this._addAttrs(input,o);this._addRow({el:input,opts:o,container:container,icons:icons,footer:footer})}hidden(o){const input=Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value",this.getValue(o)).appendTo(o.appendTo||this.formContainer);this._saveElement("input",o);return input}label(o){Blx.create("div").attr("data-label",o.name).addClass("blx-form-row-label").setHTML(o.text).appendTo(o.appendTo||this.formContainer)}datetime(o){Blx.utils.append(o,{timeFormat:"HH:mm:ss",dateFormat:"yy-mm-dd",stepMinute:1});const input=Blx.create("input").addClass("blx-form-input").datetimepicker({timeFormat:o.timeFormat,dateFormat:o.dateFormat,stepMinute:o.stepMinute,onSelect:o.onSelect});let value=this.getValue(o);if(value!==undefined){if(/^\d+$/.test(value)){o.value=Blx.utils.unixtimeToDatetime(value,o.replaceNull)}}this._saveElement("input",o);this._addAttrs(input,o);this._addRow({el:input,opts:o,container:input})}date(o){Blx.utils.append(o,{dateFormat:"yy-mm-dd"});const input=Blx.create("input").addClass("blx-form-input").datetimepicker({dateFormat:o.dateFormat,showTimepicker:false,onSelect:o.onSelect});let value=this.getValue(o);if(value!==undefined){if(/^\d+$/.test(value)){o.value=Blx.utils.unixtimeToDate(value,o.replaceNull)}}this._saveElement("input",o);this._addAttrs(input,o);this._addRow({el:input,opts:o,container:input})}dict(o){o.element="dict";o.multipleKeys||=false;this._dictOrArray(o)}array(o){o.element="array";o.multiple=true;this._dictOrArray(o)}_dictOrArray(o){const div=Blx.create("div");const table=Blx.create("table").addClass("blx-form-param-table").appendTo(div);const thRow=Blx.create("tr").appendTo(table);if(o.element=="dict"){Blx.create("th").setHTML(Blx.text.get("word.Name")).appendTo(thRow);Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value","").appendTo(div)}Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value","").appendTo(div);Blx.create("th").text(Blx.text.get("word.Value")).appendTo(thRow);Blx.create("th").appendTo(thRow);$.each(this.getValue(o),(key,value)=>{if(typeof value=="object"){$.each(value,(i,v)=>{this._addDictOrArrayElement(o,key,v,table)})}else{this._addDictOrArrayElement(o,key,value,table)}});this._saveElement(o.element,o);this._addRow({opts:o,container:div,nobg:true});const button=Blx.button().text(`+ ${o.text}`).appendTo(div);button.click(()=>this._addDictOrArrayElement(o,"","",table))}_addDictOrArrayElement(o,key,value,table){const tr=Blx.create("tr").appendTo(table);if(o.element=="dict"){const inputKey=Blx.create("input").attr("type","text").attr("name",o.name).addClass("blx-form-input").val(key);Blx.create("td").addClass("blx-form-param-table-td").html(inputKey).appendTo(tr)}let inputValue;if(o.textarea===true){inputValue=Blx.create("textarea").attr("name",o.name).addClass("blx-form-textarea").val(value);const onKeyUp=()=>inputValue.css("height",inputValue.prop("scrollHeight"));inputValue.on("keyup",onKeyUp);o.renderedCallback=onKeyUp}else{inputValue=Blx.create("input").attr("type","text").attr("name",o.name).addClass("blx-form-input").val(value)}Blx.create("td").addClass("blx-form-param-table-td").html(inputValue).appendTo(tr);const removeButton=Blx.icon().cursor("pointer").coloring(this.paramTableIconColoring).span("circle-x").click(()=>tr.remove());Blx.create("td").addClass("blx-form-param-table-td blx-center").css("width","40px").html(removeButton).appendTo(tr)}paramOpValue(o){if(o.opType=="string"){o.op=[{label:"==",value:"eq"},{label:"!=",value:"ne"},{label:"=~",value:"re"},{label:"!~",value:"rn"}]}else if(o.opType=="number"){o.op=[{label:"==",value:"eq"},{label:"!=",value:"ne"},{label:">",value:"gt"},{label:">=",value:"ge"},{label:"<",value:"lt"},{label:"<=",value:"le"}]}else{o.op=[{label:"==",value:"eq"},{label:"!=",value:"ne"},{label:"=~",value:"re"},{label:"!~",value:"rn"},{label:">",value:"gt"},{label:">=",value:"ge"},{label:"<",value:"lt"},{label:"<=",value:"le"}]}const div=Blx.create("div");for(let i=0;i<3;i++){Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value","").appendTo(div)}this._saveElement("paramOpValue",o);this._addRow({opts:o,container:div,nobg:true});const table=Blx.create("table").addClass("blx-form-param-table").appendTo(div);const button=Blx.button().text(`+ ${o.text}`).appendTo(div);$.each(this.getValue(o),(i,keyOpValue)=>{this._addParamOpValueElement(o,keyOpValue,table)});button.click(()=>this._addParamOpValueElement(o,[],table))}_addParamOpValueElement(o,values,table){const key=values[0],op=values[1],value=values[2];const tr=Blx.create("tr").appendTo(table);const keyCol=Blx.create("td").addClass("blx-form-param-table-td").appendTo(tr);if(o.options){this._select({name:o.name,options:o.options,value:key,selectAnOptionText:"---"}).container.appendTo(keyCol)}else{Blx.create("input").attr("type","text").attr("name",o.name).attr("value",key).addClass("blx-form-input").appendTo(keyCol)}const opSelect=this._select({name:o.name,options:o.op,value:op,selectAnOptionText:"---"});const opCol=Blx.create("td").addClass("blx-form-param-table-td").css("width","40px").html(opSelect.container).appendTo(tr);const valCol=Blx.create("td").addClass("blx-form-param-table-td").appendTo(tr);const valInput=Blx.create("input").attr("type","text").attr("name",o.name).attr("value",value).addClass("blx-form-input").appendTo(valCol);const removeButton=Blx.icon().cursor("pointer").coloring(this.paramTableIconColoring).span("circle-x").click(()=>tr.remove());Blx.create("td").addClass("blx-form-param-table-td blx-center").css("width","40px").html(removeButton).appendTo(tr)}textarea(o){o=Blx.utils.config(o,["type","name","text","help","value","rows","options","minlength","maxlength","pattern","required","readonly","genpwd","genpwdComplex","autocomplete","appendTo","ignoreIfEmpty"],{rows:"auto",required:false,readonly:false,genpwd:false,genpwdComplex:false,value:this.getValue(o)});const textarea=Blx.create("textarea").addClass("blx-form-textarea");const footer=Blx.create("div").addClass("blx-form-textarea-char-count");const rows=o.rows;const value=o.value;o.value=undefined;if(value!==undefined){textarea.val(value)}if(o.rows=="auto"){o.rows=5}const onKeyUp=()=>{if(rows=="auto"){textarea.css("height",textarea.prop("scrollHeight"))}const len=textarea.val().length;if(o.maxlength){footer.text(`${len}/${o.maxlength}`)}else{footer.text(len)}};textarea.on("keyup",onKeyUp);o.renderedCallback=onKeyUp;const icons=[];if(o.genpwd){icons.push(this.icon.btn("settings").click(()=>{textarea.focus();textarea.val(Blx.utils.genRandStr(o.genpwd,o.genpwdComplex))}))}this._saveElement("textarea",o);this._addAttrs(textarea,o);this._addRow({el:textarea,opts:o,container:textarea,icons:icons,footer:footer})}select(o){o=Blx.utils.config(o,["type","name","text","help","value","options","label","orig","required","readonly","selectAnOptionText","caret","onChange","multiple","appendTo","parseInt"],{orig:true,required:false,readonly:false,selectAnOptionText:Blx.text.get("form.select_an_option"),caret:true,value:this.getValue(o),onChange:false});o.options=this.getSelectOptions(o);this._saveElement("select",o);if(o.multiple===true){this._addRow(this._selectMultiple(o))}else if(o.orig===true){this._addRow(this._selectOrig(o))}else{this._addRow(this._select(o))}}_select(o){const container=Blx.create("div").addClass("blx-form-select-container");const input=Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value","").appendTo(container);if(o.caret===true){Blx.create("span").addClass("blx-form-caret-down").appendTo(container)}const valueBox=Blx.create("div").addClass("blx-form-pseudo-select").setHTML(o.selectAnOptionText).appendTo(container);const list=Blx.create("ul").addClass("blx-form-pseudo-select-list").hide().appendTo(container);valueBox.click(e=>{e.stopPropagation();list.css("top",valueBox.outerHeight()+"px");list.show();$(document).one("click",()=>list.hide())});o.options.unshift({label:o.selectAnOptionText,value:""});$.each(o.options,(i,item)=>{const label=item.label||item.name||item.value;const value=this.valueCallback?this.valueCallback(item.value):item.value;const labelClone=this._clone(label);Blx.create("li").setHTML(label).appendTo(list).click(()=>{list.hide();valueBox.setHTML(labelClone);input.val(value);if(o.onChange){o.onChange(value)}});if(item.selected||o.value==item.value){valueBox.setHTML(labelClone);input.val(value)}});return{opts:o,container:container}}_clone(obj){if(typeof obj=="string"){return obj}return obj.clone()}_selectOrig(o){const container=Blx.create("div").addClass("blx-form-select-container");if(o.caret===true){Blx.create("span").addClass("blx-form-caret-down").appendTo(container)}const select=Blx.create("select").addClass("blx-form-select").appendTo(container);Blx.create("option").attr("selected","selected").attr("value","").setHTML(o.selectAnOptionText).appendTo(select);this._addAttrs(select,o);$.each(o.options,(i,item)=>{const label=item.label||item.name||item.value;const value=this.valueCallback?this.valueCallback(item.value):item.value;const option=Blx.create("option").attr("value",value).setHTML(label).appendTo(select);if(item.selected||o.value==item.value){option.attr("selected","selected")}});if(o.onChange){select.change(()=>o.onChange(select.val()))}return{el:select,opts:o,container:container}}_selectMultiple(o){const container=Blx.create("div");const selected={};Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value","").appendTo(container);const button=Blx.button().text("+ "+Blx.text.get("action.add")).appendTo(container);const inputs=Blx.create("div").appendTo(container);const icon=Blx.icon().size("default").cursor("pointer").coloring(this.paramTableIconColoring);const addItem=item=>{const row=Blx.create("div").addClass("blx-form-select-select-item").appendTo(inputs);icon.span("square-x").appendTo(row).click(()=>{row.remove();delete selected[item.value]});Blx.create("span").addClass("blx-form-select-label").setHTML(item.label||item.name||item.value).appendTo(row);Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value",item.value).appendTo(row);selected[item.value]=item};$.each(o.options,(i,item)=>{if(item.selected||o.value&&Array.isArray(o.value)&&Blx.utils.includes(item.value,o.value)){addItem(item)}});button.click(()=>{const overlayBody=Blx.create("div");$.each(o.options,(i,item)=>{const row=Blx.create("div").addClass("blx-form-select-select-item").appendTo(overlayBody);const checked=icon.span("square-check").hide().appendTo(row);const notChecked=icon.span("square").hide().appendTo(row);const label=o.labelCallback?o.labelCallback(item):item.label||item.name||item.value;Blx.create("span").addClass("blx-form-select-label").setHTML(label).appendTo(row);if(selected[item.value]){checked.show()}else{notChecked.show()}checked.click(()=>{checked.hide();notChecked.show();delete selected[item.value]});notChecked.click(()=>{notChecked.hide();checked.show();selected[item.value]=item})});const overlay=Blx.overlay({position:"middle",body:overlayBody,closeCallback:()=>{inputs.html("");$.each(selected,(i,item)=>addItem(item))}}).create()});return{opts:o,container:container,nobg:true}}radioBtn(o){o.element="radio";this._radio_or_checkbox_btn(o);this._saveElement("radio",o)}checkboxBtn(o){o.element="checkbox";this._radio_or_checkbox_btn(o);this._saveElement("checkbox",o)}_radio_or_checkbox_btn(o){o.value=this.getValue(o);o.options=this.getSelectOptions(o);const container=Blx.create("div");if(o.element=="checkbox"){Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value","").appendTo(container)}$.each(o.options,(i,item)=>{const label=Blx.create("label").addClass("blx-form-checkbox-label").appendTo(container);const input=Blx.create("input").attr("type",o.element).attr("name",o.name).attr("value",item.value).addClass("blx-form-checkbox").appendTo(label);if(o.onChange){input.click(()=>o.onChange(item.value))}const inner=Blx.create("span").addClass("blx-form-checkbox-label-inner").setHTML(item.label||item.name||item.value).appendTo(label);if(o.width){inner.css("width",o.width)}if(o.maxWidth){inner.css("max-width",o.maxWidth)}if(item.checked===true||this._checkValues(item.value,o.value)){input.attr("checked","checked")}});this._addRow({opts:o,container:container,nobg:true})}checkOnOff(o){o.value=this.getValue(o);const container=Blx.create("div").addClass("blx-form-onoff-switch");const label=Blx.create("label").addClass("blx-form-onoff-switch-group").appendTo(container);const on=Blx.create("div").addClass("blx-form-onoff-switch-on").setHTML(Blx.text.get("word.Yes")).appendTo(label);const handle=Blx.create("div").addClass("blx-form-onoff-switch-handle").appendTo(label);const off=Blx.create("div").addClass("blx-form-onoff-switch-off").setHTML(Blx.text.get("word.No")).appendTo(label);const input=Blx.create("input").attr("type","hidden").attr("name",o.name).appendTo(label);if(o.value===false||o.value===undefined){o.value=0}else if(o.value===true){o.value=1}input.val(o.value);if(input.val()=="0"){container.addClass("off")}else{container.addClass("on")}if(o.onChange){o.onChange(o.value)}container.click(()=>{if(input.val()=="0"){input.val(1);if(o.onChange){o.onChange(1)}container.removeClass("off");container.addClass("on")}else{input.val(0);if(o.onChange){o.onChange(0)}container.removeClass("on");container.addClass("off")}});o.parseInt=true;this._saveElement("input",o);this._addRow({el:input,opts:o,container:container,nobg:true})}checkYesNo(o){o.value=this.getValue(o);const container=Blx.create("div");const outer1=Blx.create("label").addClass("blx-form-yesno-outer").appendTo(container);const on=Blx.create("input").attr("type","radio").attr("name",o.name).attr("value",1).addClass("blx-form-yesno-radio").appendTo(outer1);Blx.create("span").addClass("blx-form-yesno-inner").appendTo(outer1);Blx.create("span").addClass("blx-form-yesno-on").appendTo(outer1);const outer2=Blx.create("label").addClass("blx-form-yesno-outer").appendTo(container);const off=Blx.create("input").attr("type","radio").attr("name",o.name).attr("value",0).addClass("blx-form-yesno-radio").appendTo(outer2);Blx.create("span").addClass("blx-form-yesno-inner").appendTo(outer2);Blx.create("span").addClass("blx-form-yesno-off1").appendTo(outer2);Blx.create("span").addClass("blx-form-yesno-off2").appendTo(outer2);if(o.value=="1"||o.value===1||o.value===true){on.attr("checked","checked")}else{off.attr("checked","checked")}o.parseInt=true;this._saveElement("input",o);this._addRow({opts:o,container:container,nobg:true})}slider(o){o.value=this.getValue(o);o.options=this.getSelectOptions(o);let checkedPos=0;const container=Blx.create("div").addClass("blx-form-slider-container");$.each(o.options,(i,item)=>{if(item.checked===true||item.value==o.value){checkedPos=i}});const checked=o.options[checkedPos];const range=Blx.create("input").attr("type","range").attr("min",0).attr("max",o.options.length-1).attr("value",checkedPos).attr("step",1).addClass("blx-form-slider").appendTo(container);const input=Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value",checked.value).appendTo(container);const label=Blx.create("label").addClass("blx-form-slider-label").setHTML(checked.label).appendTo(container);range[0].addEventListener("input",()=>{const option=o.options[range.val()];label.setHTML(option.label);input.val(option.value)});this._saveElement("input",o);this._addRow({opts:o,container:container,nobg:true})}table(o){const container=Blx.create("div");o=Blx.utils.config(o,["table","name","parseInt","appendTo","noMargin"],{parseInt:true,noMargin:true});Blx.create("input").attr("type","hidden").attr("name",o.name).attr("value","").appendTo(container);o.table=Blx.utils.setopts(o.table,{grow:false,appendTo:container});o.table.selectable=Blx.utils.setopts(o.table.selectable,{enabled:true,selected:this.getValue(o)});const options=this.getOptions(o);if(options.options&&options.options.length&&!o.table.data&&!o.table.url){o.table.data=options.options}o.tableObject=Blx.table(o.table);this._saveElement("table",o);this._addRow({opts:o,container:container,nobg:true})}submit(){this.data=this.parseFormData();if(this.submitCallback){this.submitCallback(this);return}const overlay=ldsOverlay();const request={url:this.submitUrl,data:this.data,token:this.reqToken,success:result=>{overlay.remove();if(result.status!="ok"){if(result.status=="err-610"){this.markErrors(result.data.failed)}return}if(this.overlay){this.overlay.close()}if(this.onSuccess){this.onSuccess(result.data,this)}else{successMessage({message:Blx.text.get("form.submit_success"),container:this.messageContainer})}},cleanupOnErrorCallback:()=>overlay.remove()};if(this.ignoreErrors){request.ignoreErrors=this.ignoreErrors}if(this.errorCallback){request.errorCallback=this.errorCallback}if(this.errorFallback){request.errorFallback=this.errorFallback}else{request.error=result=>{overlay.remove();errorMessage({message:result.data.message,container:this.messageContainer})}}Blx.ajax.request(request)}getData(){return this.data}parseFormData(){this.removeErrors();const formData=this.form.serializeArray(),data={},dicts={},splices={},paramOpValues={};$.each(formData,(i,e)=>{const item=this.elementsByName[e.name]||{element:"none"};if(item&&item.splice===true||this.splice===true&&e.name.match(/:/)){splices[e.name]=true}if(item.element=="table"){if(item.parseInt===true){const ids=[];$.each(item.tableObject.getSelectedIds(),(i,value)=>{ids.push(parseInt(value))});data[e.name]=ids}else{data[e.name]=item.tableObject.getSelectedIds()}return true}if(item.ignoreIfEmpty===true&&e.value.match(/^\s*$/)){return true}if(item.element=="dict"){if(typeof dicts[e.name]!="object"){dicts[e.name]=[]}dicts[e.name].push(e.value);return true}if(item.element=="paramOpValue"){if(typeof paramOpValues[e.name]!="object"){paramOpValues[e.name]=[]}paramOpValues[e.name].push(e.value);return true}if(item.password===true){if(item.reSendPassword===true&&/^\*+$/.test(e.value)){e.value=item.origValue}else{if(/^\*+$/.test(e.value)||e.value===item.origValue){return true}if(item.deleteIfEmpty===true&&item.password.length===0){return true}}}if(item.parseInt===true&&item.element!="table"&&e.value.match(/^\d+$/)){e.value=parseInt(e.value)}if(item.parseFloat===true&&item.element!="table"&&e.value.match(/^\d+(\.\d+)?$/)){e.value=parseFloat(e.value)}if(item.element.match(/date/)&&e.value=="---"){e.value=0}if(data[e.name]!==undefined||item.element=="checkbox"||item.multiple===true){if(data[e.name]===undefined){data[e.name]=[]}else if(typeof data[e.name]!="object"){if(data[e.name]!==undefined&&data[e.name]!==""){data[e.name]=[data[e.name]]}else{data[e.name]=[]}}if(e.value!==undefined&&e.value!==""){data[e.name].push(e.value)}}else{data[e.name]=e.value}});$.each(dicts,(name,dict)=>{const item=this.elementsByName[name]||{};if(data[name]===undefined){data[name]={}}while(dict.length){const key=dict.shift(),value=dict.shift();if(/^[\r\n\s]*$/.test(key)){continue}if(item.multipleKeys===true&&data[name][key]!==undefined){if(typeof data[name][key]!="object"){data[name][key]=[data[name][key]]}data[name][key].push(value)}else{data[name][key]=value}}});$.each(paramOpValues,(name,arr)=>{data[name]=[];while(arr.length>0){const key=arr.shift(),op=arr.shift(),value=arr.shift();if(key!==""||op!==""||value!==""){data[name].push([key,op,value])}}});$.each(splices,(name,bool)=>{const parts=name.split(":"),n1=parts[0],n2=parts[1];if(typeof data[n1]!="object"){data[n1]={}}data[n1][n2]=data[name];delete data[name]});$.each(this.attachments,(name,list)=>{data[name]=[];$.each(list,function(filename,attachment){data[name].push(attachment)})});if(this.processDataCallback){this.processDataCallback(data)}return data}markErrors(failed){$.each(failed,(name,item)=>{Log.debug("[data-label='"+name+"']");this.form.find("[data-label='"+name+"']").addClass("blx-form-label-rwb");const message=Blx.text.exist(item.status)?Blx.text.get(item.status):item.message;this.form.find("[data-label-error-message='"+name+"']").text(message).show()});errorMessage({message:Blx.text.get("err-610"),container:this.messageContainer})}removeErrors(){$(this.form).find(".blx-form-label-rwb").removeClass("blx-form-label-rwb");$(this.form).find(".blx-form-label-error-message").hide()}_saveElement(element,opts){opts.element=element;this.elementsByName[opts.name]=opts}_checkValues(value,values){if(value===undefined||values===undefined){return false}if(typeof values!="object"){values=[values]}for(let i=0;i<values.length;i++){if(value==values[i]){return true}}return false}getRow(name){return this.rowsByName[name]}createEmptyRow(){return Blx.create("div").addClass("blx-form-row").addClass("blx-form-row-margin").appendTo(this.formContainer)}createEmptyElement(el="div"){return Blx.create(el).appendTo(this.formContainer)}createLabel(name){const label=Blx.create("div").addClass("blx-form-row-label");if(name){label.attr("data-label",name)}return label}_addRow(o){const row=Blx.create("div").addClass("blx-form-row");if(o.opts.noMargin!==true){row.addClass("blx-form-row-margin")}if(o.opts.appendTo){row.appendTo(o.opts.appendTo)}else{row.appendTo(this.formContainer)}this.rowsByName[o.opts.name]=row;const label=Blx.create("div").attr("data-label",o.opts.name).addClass("blx-form-row-label").setHTML(o.opts.text).appendTo(row);const errorMessage=Blx.create("div").attr("data-label-error-message",o.opts.name).addClass("blx-form-label-error-message").hide().appendTo(row);if(o.opts.required===true){Blx.create("span").text(" * ").appendTo(label)}const elWrapper=Blx.create("div").append(o.container).appendTo(row);if(o.nobg===true){elWrapper.addClass("blx-form-row-el-nobg")}else{elWrapper.addClass("blx-form-row-el")}if(o.el){const el=Array.isArray(o.el)?o.el[0]:o.el;if(el.val()){label.addClass("filled")}el.focus(()=>{label.removeClass("filled");label.addClass("focus");elWrapper.addClass("focus")});el.blur(()=>{if(el.val()){label.addClass("filled")}label.removeClass("focus");elWrapper.removeClass("focus")})}const iconContainer=Blx.create("div").addClass("blx-form-row-buttons").appendTo(row);this._addIcons(iconContainer,o.icons);this._addHelp(iconContainer,o.opts);if(o.opts&&o.opts.renderedCallback){o.opts.renderedCallback()}if(o.footer){o.footer.appendTo(row)}}_addAttrs(el,o){$.each(["type","name","rows","pattern","placeholder","autocomplete"],(i,attr)=>{if(o[attr]!==undefined){el.attr(attr,o[attr])}});if(o.value!==undefined){el.val(o.value)}$.each(["required","readonly"],(i,attr)=>{if(o[attr]===true){el.attr(attr,attr)}});const options=this.getOptions(o);$.each(["minvalue","maxvalue","minlength","maxlength"],(i,attr)=>{if(o[attr]!==undefined){el.attr(attr,o[attr])}else if(options[attr]!==undefined){el.attr(attr,options[attr])}})}_addHelp(el,o){const help=[],footnotes=[],options=this.getOptions(o);if(o.help){help.push(Blx.create("div").addClass("blx-form-i-bubble-text").html(o.help))}$.each(["minlength","maxlength","minvalue","maxvalue","default"],(i,attr)=>{let value;if(o[attr]!==undefined&&o[attr]!==null){value=o[attr]}else if(options[attr]!==undefined&&options[attr]!==null){if(attr=="minlength"&&options["minlength"]==0){return true}value=options[attr]}if(value!==undefined){footnotes.push(Blx.create("small").html(Blx.text.get("text."+attr,[value])))}});if(footnotes.length>0){const footnote=Blx.create("div").addClass("blx-form-i-bubble-small");if(help.length>0){footnote.css("margin-top","10px")}$.each(footnotes,(i,el)=>{footnote.append(el)});help.push(footnote)}if(help.length>0){const bubble=Blx.create("div").addClass("blx-form-i-bubble").appendTo(el);$.each(help,(i,el)=>{bubble.append(el)});const onClick=function(){if(bubble.css("display")=="none"){bubble.show()}else{bubble.hide()}};const icon=this.icon.btn("info").appendTo(el);bubble.click(onClick);icon.click(onClick)}}_addIcons(el,icons){$.each(icons,(i,item)=>{item.appendTo(el)})}append(o){this.form.append(o)}handleAttachments(o,input,appendTo){const icon=Blx.icon().size("medium").cursor("pointer");this.attachments[o.name]={};const attatchmentList=Blx.create("ul").addClass("blx-form-attachment-list").appendTo(appendTo);input.change(e=>{if(e.target.files.length==0){return}const errors=[];for(let i=0;i<e.target.files.length;i++){const file=e.target.files[i];const reader=new FileReader;let filename=file.name;if(this.attachments[o.name][file.name]){let i=0;while(this.attachments[o.name][filename]){i+=1;filename=`${file.name} (${i})`}}const data={name:filename,size:file.size,type:file.type};reader.onload=fileData=>{data.content=fileData.target.result;this.attachments[o.name][filename]=data;const li=Create("li").appendTo(attatchmentList);icon.span("x").appendTo(li).click(()=>{li.remove();delete this.attachments[o.name][filename]});Blx.create("span").text(filename).appendTo(li)};reader.readAsDataURL(file)}input.val("")})}}Blx.form=o=>new Form(o);Blx.formProps={ignoreErrors:["err-610"],reqToken:true,showSubmitButton:true,addHiddenSubmitButton:true,showMandatoryFieldsInfo:true,iconSize:"default",iconColoring:"white",iconRadius:"square",paramTableIconColoring:"white"};class Group{constructor(o){this.config=Blx.utils.config(o,["grow","appendTo","replaceTo","progressName","titleIcon","member","noMember","addMember","removeMember","button","postdata","columns","reallyRemove"],{grow:true,reallyRemove:true});this.listMember()}listMember(){this.memberTable=Blx.table({grow:this.config.grow,appendTo:this.config.appendTo,replaceTo:this.config.replaceTo,title:this.config.member.title,titleIcon:this.config.titleIcon,url:this.config.member.url,columns:this.config.columns,headerIcons:[{name:"plus",callback:()=>this.listNoMember()}],selectable:{enabled:true},footerButtons:[{text:this.config.button.remove,callback:table=>{if(this.config.reallyRemove===true){this.reallyRemove()}else{this.process(this.memberTable.getSelected(),this.config.removeMember.url);table.clearSelected()}}}]})}reallyRemove(){const overlay=Blx.overlay({title:Blx.text.get("text.really_removes"),closeText:Blx.text.get("action.abort"),buttons:[{text:Blx.text.get("action.yes_remove"),callback:()=>{this.process(this.memberTable.getSelected(),this.config.removeMember.url);table.clearSelected()},close:true}]}).create();const data=[];$.each(this.memberTable.getSelected(),(i,row)=>{data.push(row)});const table=Blx.table({data:data,columns:this.config.columns,appendTo:overlay.body,visible:{enabled:false},searchable:{enabled:false},sortable:{enabled:false},selectable:{enabled:false}})}listNoMember(){const overlay=Blx.overlay({closeText:Blx.text.get("action.abort"),position:"right"}).create();this.noMemberTable=Blx.table({grow:this.config.grow,appendTo:overlay.body,title:this.config.noMember.title,titleIcon:this.config.titleIcon,url:this.config.noMember.url,columns:this.config.columns,selectable:{enabled:true},footerButtons:[{text:this.config.button.add,callback:table=>{this.process(this.noMemberTable.getSelected(),this.config.addMember.url);table.clearSelected();overlay.close()}}]})}process(data,url){const items=[];$.each(data,(id,row)=>{items.push({url:typeof url=="function"?url(row):url,data:typeof this.postdata=="function"?this.postdata(row):{},token:true,text:row[this.progressName]})});if(items.length>0){Blx.progress({finish:()=>{this.memberTable.clearSelected();this.memberTable.reload()},items:items})}}}Blx.group=o=>new Group(o);class iButton{constructor(o){Blx.utils.append(this,o);this.outer=Create("div").addClass("blx-ibutton-btn");this.icon=Create("div").addClass("halflings halflings-info-sign").appendTo(this.outer);this.bubble=Create("div").addClass("blx-ibutton-bubble").hide().appendTo(this.outer);if(this.title){Create("h2").html(this.title).appendTo(this.bubble)}if(this.desc){Create("p").html(this.desc).appendTo(this.bubble)}if(this.note){Create("small").html(this.note).appendTo(this.bubble)}if(this.html){this.bubble.html(this.html)}if(o.width){this.bubble.css({width:o.width})}if(o.css){this.bubble.css(o.css)}this.bubbleIsVisible=false;if(this.onclick){this.outer.click(()=>this.onclick());return}this.outer.click(()=>{if(this.bubbleIsVisible==true){this.bubbleIsVisible=false;this.bubble.hide();this.icon.removeClass("halflings-remove");this.icon.addClass("halflings-info-sign");this.icon.removeClass("blx-ibutton-active")}else{this.bubbleIsVisible=true;this.bubble.show();this.icon.removeClass("halflings-info-sign");this.icon.addClass("halflings-remove");this.icon.addClass("blx-ibutton-active")}});if(this.appendTo){this.outer.appendTo(this.appendTo)}}appendTo(o){this.outer.appendTo(o)}}Blx.ibutton=o=>new iButton(o);class Icon{constructor(o){this.config=Blx.utils.config(o,["size","coloring","radius","cursor","margin","marginTop","marginRight","marginBottom","marginLeft","appendTo"],{size:"default",coloring:"black",radius:"square-rounded",cursor:"auto"})}size(size){this.config.size=size;return this}coloring(color){this.config.coloring=color;return this}radius(radius){this.config.radius=radius;return this}cursor(cursor){this.config.cursor=cursor;return this}margin(margin){this.config.margin=margin;return this}marginTop(margin){this.config.marginTop=margin;return this}marginRight(margin){this.config.marginRight=margin;return this}marginBottom(margin){this.config.marginBottom=margin;return this}marginLeft(margin){this.config.marginLeft=margin;return this}appendTo(obj){this.config.appendTo=obj;return this}btnClass(cls){this.config.btnClass=cls;return this}offBtnClass(cls){this.config.offBtnClass=cls;return this}iconClass(cls){this.config.iconClass=cls;return this}offIconClass(cls){this.config.offIconClass=cls;return this}btnIconMargin(margin){this.config.btnIconMargin=margin;return this}btn(name){const btn=Create("a").addClass(`blx-btn-icon-outer`).addClass(`blx-btn-icon-outer-${this.config.coloring}`);if(this.config.radius){btn.addClass(`blx-btn-icon-${this.config.radius}`)}const icon=Create("span").addClass("blx-btn-icon").addClass(`blx-btn-icon-${this.config.coloring}`).addClass(`blx-btn-icon-${this.config.size}`).appendTo(btn);if(this.config.btnIconMargin){icon.css("margin",this.config.btnIconMargin)}if(this.config.btnClass){btn.addClass(this.config.btnClass)}if(this.config.iconClass){icon.addClass(this.config.iconClass)}this._setMask(icon,name);this._setConfig(btn);return btn}offBtn(name){const btn=Create("span").addClass(`blx-btn-icon-outer`);const icon=Create("span").addClass("blx-btn-icon").addClass(`blx-btn-icon-${this.config.size}`).addClass(`blx-btn-icon-off-${this.config.coloring}`).appendTo(btn);if(this.config.offBtnClass){btn.addClass(this.config.offBtnClass)}if(this.config.offIconClass){icon.addClass(this.config.offIconClass)}this._setMask(icon,name);this._setConfig(btn);return btn}a(name){const icon=this.__tag("a",name);icon.css("cursor","pointer");icon.css("text-decoration","none");return icon}span(name){return this.__tag("span",name)}__tag(tag,name){const icon=Create(tag).addClass("blx-icon").addClass(`blx-icon-${this.config.size}`).addClass(`blx-icon-${this.config.coloring}`).css("cursor",this.config.cursor);if(this.config.iconClass){icon.addClass(this.config.iconClass)}this._setMask(icon,name);this._setConfig(icon);return icon}_setMask(icon,name){if(!svgIcons[name]){Log.error(`icon '${name}' does not exists`);name="image-minus";icon.addClass("blx-icon-red")}icon.attr("icon-name",name);icon.append(svgIcons[name])}_setConfig(icon){if(this.config.margin!==undefined){icon.css("margin",this.config.margin)}if(this.config.marginTop!==undefined){icon.css("margin-top",this.config.marginTop)}if(this.config.marginRight!==undefined){icon.css("margin-right",this.config.marginRight)}if(this.config.marginBottom!==undefined){icon.css("margin-bottom",this.config.marginBottom)}if(this.config.marginLeft!==undefined){icon.css("margin-left",this.config.marginLeft)}if(this.config.appendTo){icon.appendTo(this.config.appendTo)}}}const IconProps={};Blx.icon=o=>new Icon(o);Blx.iconProps=IconProps;let IntervalCounter=0;class Interval{constructor(o){Blx.utils.config(o,["alias","monitor","callback","interval","maxRuns"],{alias:"none",maxRuns:0},this);this.runs=0;this.id="blx-interval-"+this.alias+"-"+Math.random().toString(36).slice(2)+"-"+ ++IntervalCounter;this.searchId="#"+this.id;this.monitor=$(this.monitor);this.monitor.attr("id",this.id);this.__setTimeout();Log.info(`create new interval object ${this.id} alias ${this.alias} interval ${this.interval}`)}__setTimeout(){var self=this;if(this.interval>0){this.__timeoutObject=setTimeout(function(){self.run()},this.interval)}}setInterval(i){this.interval=i;this.clear();this.__setTimeout()}run(){if($(this.searchId).length===0){this.clear()}else{this.runs+=1;this.callback();if(this.maxRuns>0&&this.runs===this.maxRuns){Log.error("Interval(): max runs exceeded",this.id)}else{this.__setTimeout()}}}clear(){if(this.__timeoutObject){Log.info("Interval(): clear timeout",this.id);clearTimeout(this.__timeoutObject);this.__timeoutObject=false}}}Blx.interval=o=>new Interval(o);jQuery.fn.extend({setHTML:function(obj){if(typeof obj=="string"){this.text(obj)}else{this.html(obj)}return this}});Blx.loading=function(appendTo){return Blx.create("div").addClass("blx-table-loading-info").appendTo(appendTo).append(Blx.create("div").addClass("blx-loader-bars"))};function ldsSpinner(o){o=Blx.utils.config(o,["appendTo","text","type","hide"],{type:1,text:"Loading...",hide:false});const container=Blx.create("div").addClass("blx-lds-spinner-container");const spinner=Blx.create("span").addClass(`blx-lds-spinner${o.type}`).appendTo(container);const text=Blx.create("span").addClass(`blx-lds-spinner${o.type}-text`).text(o.text).appendTo(container);if(o.hide===true){container.hide()}if(o.appendTo){container.appendTo(o.appendTo)}return container}function ldsOverlay(){const outer=Create("div").addClass("blx-loading-overlay").appendTo("body");const inner=Create("div").addClass("blx-loading-overlay-inner").appendTo(outer);Create("div").append(Blx.create("div").addClass("blx-lds-dual-ring")).addClass("blx-loading-overlay-animation").appendTo(inner);Create("div").addClass("blx-loading-overlay-text").text(Blx.text.get("word.Loading_dots")).appendTo(inner);return outer}Blx.lds=ldsSpinner;Blx.ldsOverlay=ldsOverlay;const Log={};Log.cache=[];Log.level=4;Log.levels=["fatal","error","warning","notice","info","debug"];Log.debug=msg=>Log.Log(5,msg);Log.info=msg=>Log.Log(4,msg);Log.notice=msg=>Log.Log(3,msg);Log.warning=msg=>Log.Log(2,msg);Log.error=msg=>Log.Log(1,msg);Log.fatal=msg=>Log.Log(0,msg);Log.Log=function(level,msg){const date=Blx.utils.date("timePlusMs"),levelName=Log.levels[level];if(level<=Log.level){if(level<=1){console.log(`%c ${date} ${levelName}: ${msg}`,"color: #cc0000")}else if(level==2){console.log(`%c ${date} ${levelName}: ${msg}`,"color: #d78f2a")}else{console.log(`${date} ${levelName}: ${msg}`)}}if(level<3){Log.cache.push({date:date,level:level,message:msg});if(Log.cache.length>20){Log.cache.shift()}}};Blx.log=Log;function __Message(s="error",o){if(typeof o=="string"){o={message:o}}o=Blx.utils.config(o,["throwException","container","addClass","message","forceOverlay"],MessageProps);const span=Create("span").addClass(o.addClass[s]).text(o.message);if(o.container&&o.forceOverlay!==true){span.appendTo(o.container);setTimeout(()=>{span.remove()},5e3)}else{const div=Create("div").addClass("blx-message-overlay-outer").appendTo("body");Create("div").addClass("blx-message-overlay-inner").appendTo(div).html(span);setTimeout(()=>{div.remove()},5e3)}if(o.throwException===true){Log.error(o.message);throw new Error(o.message)}return span}const MessageProps={throwException:false,container:Blx.create("div"),addClass:{info:"blx-message-info",error:"blx-message-error",success:"blx-message-success"}};const infoMessage=o=>__Message("info",o);const errorMessage=o=>__Message("error",o);const successMessage=o=>__Message("success",o);const throwError=o=>{if(typeof o=="string"){o={message:o}}o.throwException=true;return __Message("error",o)};Blx.infoMessage=infoMessage;Blx.errorMessage=errorMessage;Blx.successMessage=successMessage;Blx.throwError=throwError;Blx.messageProps=MessageProps;class MoreMenu{constructor(o){this.config=Blx.utils.config(o,["items","appendTo","icon","iconName","iconSize","iconColoring","iconCursor","iconType","showTitle","title","position"],{items:[],iconName:"ellipsis",iconSize:"default",iconColoring:"dark",iconCursor:"pointer",iconType:"span",showTitle:true,title:Blx.text.get("word.Options"),position:"right"});this.menuContainer=Create("div").addClass("blx-more-menu-container").css("float",this.config.position).hide();this.menuIcon=Create("div").addClass("blx-more-menu-icon").appendTo(this.menuContainer);if(this.config.icon===undefined){this.config.icon=Blx.icon();this.config.icon.size(this.config.iconSize).coloring(this.config.iconColoring).cursor(this.config.iconCursor)}const btn=this.config.icon[this.config.iconType](this.config.iconName).appendTo(this.menuIcon);this.menuList=Create("div").addClass(`blx-more-menu-list blx-more-menu-list-${this.config.position}`).appendTo(this.menuContainer).hide();btn.click(e=>{this.menuList.fadeIn(200);e.stopPropagation();$(document).one("click",()=>{this.menuList.fadeOut(200)})});if(this.config.showTitle===true){Create("div").addClass("blx-more-menu-title").setHTML(this.config.title).appendTo(this.menuList)}for(let i=0;i<this.config.items.length;i++){this.add(this.items[i])}if(this.config.appendTo!==false){this.appendTo(this.config.appendTo)}}add(item){this.menuContainer.show();var element;if(item.route){element=Create("a").attr("href","#"+item.route).setHTML(item.text);if(!item.callback){item.callback=()=>Blx.route.to(item.route)}}else{element=Create("span")}element.setHTML(item.text).addClass("blx-more-menu-list-item").appendTo(this.menuList);if(item.callback){element.click(item.callback)}}appendTo(o){this.menuContainer.appendTo(o)}}Blx.moreMenu=o=>new MoreMenu(o);class Navigation{constructor(o){Blx.utils.append(this,o);this.liByName={};this.container=Create("div");if(this.isSubNav===true){this.container.addClass("blx-site-nav-sub")}else{this.container.addClass("blx-site-nav")}if(o.navClass){this.container.addClass(o.navClass)}if(this.hidden){this.container.hide()}if(this.appendTo){this.container.appendTo(this.appendTo)}else if(this.replaceTo){this.replaceTo.html(this.replaceTo)}this.icon=Blx.icon().cursor("pointer").size("medium");if(this.iconConfig!==undefined){this.iconConfig(this.icon)}if(this.items){for(let i=0;i<this.items.length;i++){this.add(this.items[i])}}}add(item){const reg={};if(item.name){this.liByName[item.name]=reg}const el=reg.el=Create("div").addClass("blx-site-nav-item").appendTo(this.container);if(this.itemClass){el.addClass(this.itemClass)}const link=reg.link=Create("a").appendTo(el);if(item.link){link.attr("href",item.link);link.attr("target","_blank")}if(item.route){link.attr("href","#"+item.route)}if(item.icon){const icon=reg.icon=this.icon.span(item.icon).addClass("blx-site-nav-icon").appendTo(link);reg.iconMark=Create("span").addClass("blx-site-nav-icon-mark").hide().text("!").appendTo(icon);if(this.iconOpacity){icon.css("opacity",this.iconOpacity[1]);el.hover(()=>icon.css("opacity",this.iconOpacity[0]),()=>icon.css("opacity",this.iconOpacity[1]))}}const text=reg.text=Create("span").addClass("blx-site-nav-text");if(item.text){text.setHTML(item.text).appendTo(link)}if(item.callback){el.click(()=>this.open(item.callback))}if(this.globalCallback){el.click(()=>this.open(this.globalCallback))}if(item.hasNavigation===true||item.items){const nav=el.nav=new Navigation({appendTo:this.container,hidden:true,isSubNav:true,items:item.items});el.click(()=>{if(nav.container.is(":hidden")){nav.container.show(200)}else{nav.container.hide(100)}});return nav}}showIconMark(name,sign){if(sign){this.liByName[name].iconMark.text(sign)}this.liByName[name].iconMark.show()}hideIconMark(name,sign){this.liByName[name].iconMark.hide()}addTitle(name){const title=Create("div").setHTML(name).addClass("blx-site-nav-title").appendTo(this.container);if(this.titleClass){title.addClass(this.titleClass)}}hideTitle(){this.container.find(".blx-site-nav-title").hide()}showTitle(){this.container.find(".blx-site-nav-title").show()}open(callback){callback()}clickActionCallback(callback){this.globalCallback=callback}}Blx.navigation=o=>new Navigation(o);class Overlay{constructor(o){this.config=Blx.utils.config(o,["title","titleIcon","titleCentered","subtitle","headerBorder","footerBorder","body","closeText","closeCallback","showCloseButton","showHideTime","position","buttons","bodyPadding"],{titleCentered:false,headerBorder:true,footerBorder:true,closeText:Blx.text.get("action.close"),showCloseButton:true,showHideTime:500,position:"right",buttons:[],bodyPadding:true});this.outer=Create("div").addClass("blx-overlay-outer").addClass("blx-overlay-outer-"+this.config.position).css("z-index",this.zIndex()).hide().appendTo("body");this.inner=Create("div").addClass("blx-overlay-inner").addClass("blx-overlay-inner-"+this.config.position).hide().appendTo(this.outer);this.contentBox=Blx.contentBox({bodyGrow:this.config.position=="middle"?false:true,title:this.config.title,titleIcon:this.config.titleIcon,titleCentered:this.config.titleCentered,subtitle:this.config.subtitle,headerBorder:this.config.headerBorder,footerBorder:this.config.footerBorder,appendTo:this.inner});if(this.config.bodyPadding===true){this.body=Create("div").addClass("blx-overlay-body").appendTo(this.contentBox.body)}else{this.body=this.contentBox.body}if(this.config.body){this.config.body.appendTo(this.body)}$.each(["header","headerLeft","headerMiddle","headerRight","subtitleWrapper","subtitle","icon","search","control","message","filter","footer","footerleft","footerMiddle","footerRight"],(i,name)=>{this[name]=this.contentBox[name]});this.buttonBox=Blx.create("span").appendTo(this.footerRight);if(this.config.buttons){$.each(this.config.buttons,(i,button)=>{this.addButton(button)})}}addButton(o){this.footer.show();const appendTo=o.footerRight===true?this.footerRight:this.buttonBox;const button=Blx.button({color:"dark",size:"medium",text:o.text}).appendTo(appendTo);return button.click(()=>{if(o.callback){o.callback(this)}if(o.close===true){this.close()}})}create(){if(this.config.showCloseButton===true){this.addButton({text:this.config.closeText,close:true,footerRight:true})}if(this.config.position=="right"){this.outer.fadeIn(this.config.showHideTime);this.inner.show("slide",{direction:"right"},this.config.showHideTime)}else if(this.config.position=="left"){this.outer.fadeIn(this.config.showHideTime);this.inner.show("slide",{direction:"left"},this.config.showHideTime)}else{this.outer.fadeIn(this.config.showHideTime);this.inner.fadeIn(this.config.showHideTime)}return this}close(){if(this.config.position=="right"){this.outer.fadeOut(this.config.showHideTime);this.inner.hide("slide",{direction:"right"},this.config.showHideTime)}else if(this.config.position=="left"){this.outer.fadeOut(this.config.showHideTime);this.inner.hide("slide",{direction:"left"},this.config.showHideTime)}else{this.outer.fadeOut(this.config.showHideTime);this.inner.fadeOut(this.config.showHideTime)}setTimeout(()=>this.remove(),this.config.showHideTime);if(this.config.closeCallback){this.config.closeCallback(this)}}remove(){this.inner.remove();this.outer.remove()}zIndex(){if(Overlay.zIndex>2147483647){Overlay.zIndex=1e4}const zIndex=Overlay.zIndex=Overlay.zIndex+1;return zIndex}}Overlay.zIndex=1e4;Blx.overlay=o=>new Overlay(o);class ProgressBar{constructor(o){this.config=Blx.utils.config(o,["max","appendTo","value"],{value:0});this.container=Create("div").addClass("blx-progress-bar-container");if(this.config.appendTo){this.container.appendTo(this.config.appendTo)}this.bar=Create("div").addClass("blx-progress-bar").appendTo(this.container);this.update(this.config.val)}update(value){const width=this.container.innerWidth();const setWidth=value==this.config.max?width:parseInt(width/this.config.max*value);this.bar.css("width",setWidth)}}Blx.progressBar=o=>new ProgressBar(o);class Progress{constructor(o){Blx.utils.config(o,["title","max","value","abortOperation","items","autorun","callback","textkey","ignoreErrors","finish"],{max:0,value:0,autorun:true,callback:"ajax",textkey:"action.processing_of"},this);if(this.autorun===true){this.run()}}run(){this.content=Create("div");this.max=this.items.length;this.progressBar=Blx.progressBar({appendTo:this.content,max:this.max,value:this.value});this.processed=Create("p").addClass("blx-progress-bar-status").appendTo(this.content);if(this.appendTo){this.content.appendTo(this.appendTo)}else if(this.container){$(this.container).html(this.content).show()}else{this.createOverlay()}this.next()}createOverlay(){this.overlay=Blx.overlay({title:this.title,body:this.content,position:"middle",closeText:Blx.text.get("action.abort"),closeCallback:()=>{this.abort()}}).create()}next(){if(this.items.length===0||this.abortOperation===true){if(this.finish){this.finish()}if(this.overlay){this.overlay.close()}return}var item=this.items.pop();this.value+=1;this.progressBar.update(this.value);this.processed.html(Blx.text.get(this.textkey,item.text||item.url));this.processed.append(" ");this.processed.append(`(${this.value}/${this.max})`);if(this.callback=="ajax"){Blx.ajax.request({url:item.url,data:item.data,token:item.token,success:res=>{this.next()},ignoreErrors:this.ignoreErrors,cleanupOnErrorCallback:()=>this.overlay.remove()})}else{this.callback(item,this)}}abort(){this.abortOperation=true}}Blx.progress=o=>new Progress(o);class Resize{constructor(){this.cache={};this.isRunning=false;this.reRun=false;$(window).on("resize",()=>this.resize());setInterval(()=>this.checkCache(),6e4)}add(monitor,callback){const id="blx-resize-"+Math.random().toString(36).slice(2)+String(Date.now())+ ++ResizeCounter;$(monitor).attr("id",id);Log.info(`add new resize object #${id} to cache`);this.cache[`#${id}`]={callback:callback,monitor:monitor};return`#${id}`}checkCache(){$.each(this.cache,(searchId,item)=>{if(!$(searchId).length){Log.info(`remove resize object ${searchId} from cache`);delete this.cache[searchId]}})}resize(){if(this.isRunning===true){if(this.reRun===false){this.reRun=setTimeout(()=>{this.reRun=false;this.resize()},250)}Log.info("resize already running");return}this.isRunning=true;$.each(this.cache,(searchId,item)=>{if($(searchId).length>0){item.callback()}else{Log.info(`remove resize object ${searchId} from cache`);delete this.cache[searchId]}});this.isRunning=false}}let ResizeCounter=0;Blx.resize=new Resize;class Route{constructor(o){this.routes={routes:{}};this.beforeParse=function(){};this.afterParse=function(){};this.preCallback=function(){return true};this.clearIntervalObjects=[];this.defaultRoute=""}clearInterval(object,alias){Log.info(`Route: add clearInterval ${object.alias}`);this.clearIntervalObjects.push({object:object,alias:alias})}add(route,callback){Log.debug(`Route add ${route}`);var part=route.split("/");var routes=this.routes;$.each(part,function(i,p){var pattern=false,match=false;if(/^:/.test(p)){pattern=p.replace(/:/,"");p=":pattern";if(pattern=="id"||/_id$/.test(p)){match=new RegExp("^[1-9][0-9]*$")}else if(/^[a-zA-Z_0-9]+\(.+\)$/.test(pattern)){var m=pattern.match(/^([a-zA-Z_0-9]+)(\(.+\))$/);pattern=m[1];match=new RegExp("^"+m[2]+"$")}else{match=new RegExp(".+")}}if(routes.routes[p]==undefined){routes.routes[p]={routes:{}};if(pattern){routes.routes[p].pattern=pattern;routes.routes[p].match=match}}routes=routes.routes[p]});routes.route=route;routes.callback=callback}to(path,args){window.scrollTo(0,0);this.beforeParse(path,args);if(this.clearIntervalObjects.length>0){while(this.clearIntervalObjects.length>0){var object=this.clearIntervalObjects.pop();Log.info(`Route: remove clearInterval ${object.alias}`);clearInterval(object.object)}}if(this.preRoutingCallback){this.preRoutingCallback(path,args)}if(path==undefined){path=window.location.hash}else if(typeof path=="string"){window.location.hash=path}else{path=$(path).attr("href")}if(args===undefined){args={}}Log.info(`Route: process request path: ${path}`);path=path.replace(/^\//,"");path=path.replace(/^#/,"");path=path.replace(/\/$/,"");path=path.split("/");Log.debug("Route: search controller for path: "+path.join("/"));Log.debug("Route: registered routes:");Log.debug(this.routes);let routes;if(path.length){routes=this.routes;for(let i=0;i<path.length;i++){const p=path[i];Log.debug(`Route: check path part: ${p}`);if(routes.routes[p]){Log.debug(`Route: found path part: ${p}`);routes=routes.routes[p]}else if(routes.routes[":pattern"]&&routes.routes[":pattern"].match.test(p)){Log.debug(`Route: found pattern part: ${p}`);routes=routes.routes[":pattern"];Log.debug(`Route: argument: ${routes.pattern}=${p}`);args[routes.pattern]=p}else{Log.info(`Route: route part does not match: ${p}`);this.toDefault();return false}}}else{this.toDefault();return false}if(!routes.callback){this.toDefault();return false}this.afterParse(routes.route,args);if(this.preCallback(routes.route,args)){Log.debug("Route args",args);routes.callback(args)}}toDefault(){this.to(this.defaultRoute)}build(route,data){const path=[];$.each(route.split("/"),(i,item)=>{if(item.match(/^:/)){item=item.replace(/^:/,"");path.push(data[item])}else{path.push(item)}});return path.join("/")}}Blx.route=new Route;function SetLang(o){const config=Blx.utils.config(o,["showLang","lang","url","token","reloadUrl"],{lang:{en:{flag:"gb",text:"English"},de:{flag:"de",text:"Deutsch"},it:{flag:"it",text:"Italiano"}},url:"/set-lang/%s",token:true,reloadUrl:"/"});const content=Create("div");const table=Blx.simpleTable({appendTo:content});for(let i=0;i<config.showLang.length;i++){const lang=config.showLang[i],item=config.lang[lang],url=config.url.replace(/%s/,lang),row=table.row();row.tr.css("cursor","pointer");row.th.css("vertical-align","middle");row.th.html(svgFlag(item.flag)).css("width","30px");row.td.setHTML(item.text);row.tr.click(function(){Blx.ajax.request({url:url,token:config.token,success:function(){location.reload()}})})}Create("p").css("font-size","12px").css("margin-top","15px").setHTML(Blx.text.get("lang.note_select_language")).appendTo(content);Blx.overlay({title:Blx.text.get("lang.select_language"),position:"middle",body:content}).create()}Blx.setLang=SetLang;class SimpleCheckbox{constructor(o){this.config=o;if(o.name){this._createInput()}else{this._createDiv()}}_createInput(){this.label=Create("label").addClass("blx-simple-checkbox-label").appendTo(this.config.appendTo);this.input=Create("input").addClass("blx-simple-checkbox").attr("type","checkbox").attr("name",this.config.name).attr("value",this.config.value).appendTo(this.label);this.inner=Create("span").addClass("blx-simple-checkbox-inner").appendTo(this.label);this.input.change(()=>{if(this.input.prop("checked")===true){this.config.onCallback()}else{this.config.offCallback()}})}_createDiv(){this.label=Create("div").addClass("blx-simple-checkbox-label").appendTo(this.config.appendTo);this.inner=Create("div").addClass("blx-simple-checkbox-inner").appendTo(this.label);this.label.click(()=>{if(this.inner.is(":hidden")){this.inner.css("display","block");this.config.onCallback()}else{this.inner.css("display","none");this.config.offCallback()}})}check(){if(this.config.name){this.input.prop("checked",true)}else{this.inner.css("display","block")}}uncheck(){if(this.config.name){this.input.prop("checked",false)}else{this.inner.css("display","none")}}change(){if(this.config.name){this.input.change()}else if(this.inner.is(":hidden")){this.config.offCallback()}else{this.config.onCallback()}}set(value){if(value===true){this.check()}else if(value===false){this.uncheck()}}checked(){if(this.config.name){return this.input.prop("checked")}return this.inner.is(":hidden")}}Blx.simpleCheckbox=o=>new SimpleCheckbox(o);class SimpleGrid{constructor(o){this.config=Blx.utils.config(o,["appendTo","replaceTo","columns","minWidth","margin"],{columns:2,minWidth:600,margin:5});this.next=0;this.pause=false;this.runResize=false;this.columns=[];this.objects=[];this.max=this.last=this.config.columns;this.container=Blx.create("div").addClass("blx-simple-grid-wrapper");if(this.config.replaceTo){this.config.replaceTo.html(this.container)}else if(this.config.appendTo){this.container.appendTo(this.config.appendTo)}const width=100/this.max;for(let i=0;i<this.config.columns;i++){this.columns.push(Blx.create("div").addClass("blx-simple-grid").css("width",`${width}%`).appendTo(this.container))}this.resize();$(window).resize(()=>this.resize())}add(object){const widget=Blx.create("div").css("padding",this.config.margin);if(object){widget.append(object)}this.objects.push(widget);this._add(widget);return widget}_add(object){object.appendTo(this.columns[this.next]);if(this.next+1>=this.max){this.next=0}else{this.next++}}resize(){if(this.pause===true){this.runResize=true;return}let num=parseInt(this.container.outerWidth()/this.config.minWidth);if(num===0){num=1}this.max=num>this.config.columns?this.config.columns:num;if(this.max!=this.last){this.pause=true;this.last=this.max;this.next=0;const width=100/this.max;$.each(this.columns,(i,column)=>{if(!this.columns[i]){return true}if(this.max>=i){this.columns[i].show().css("width",width+"%")}else{this.columns[i].hide().css("width",0)}});$.each(this.objects,(i,object)=>{this._add(object)});this.pause=false;if(this.runResize===true){this.runResize=false;this.resize()}}}}Blx.simpleGrid=o=>new SimpleGrid(o);class SimpleTable{constructor(o){this.config=Blx.utils.config(o,["fullwidth","appendTo","replaceTo","rows","tdTextAlign","tdWhiteSpace"],{fullwidth:true,tdTextAlign:false,tdWhiteSpace:false});this.tableRows=[];this.table=Create("table").addClass("blx-simple-table");if(this.config.fullwidth==true){this.table.addClass("blx-simple-table-fullwidth")}if(this.config.appendTo){this.table.appendTo(this.config.appendTo)}else if(this.config.replaceTo){$(this.config.replaceTo).html(this.table)}if(this.config.rows){this.rows(this.config.rows)}}rows(rows){$.each(rows,(k,v)=>{this.add(k,v)})}row(){const row={tr:Create("tr").addClass("blx-simple-table-tr"),th:Create("th").addClass("blx-simple-table-th"),td:Create("td").addClass("blx-simple-table-td")};row.tr.appendTo(this.table);row.th.appendTo(row.tr);row.td.appendTo(row.tr);this.tableRows.push(row);return row}add(th,td){const row=this.row();row.th.setHTML(th);row.td.setHTML(td);if(this.config.tdTextAlign){row.td.css("text-align",this.config.tdTextAlign)}if(this.config.tdWhiteSpace){row.td.css("white-space",this.config.tdWhiteSpace)}return row}appendTo(o){this.table.appendTo(o);return this}}Blx.simpleTable=o=>new SimpleTable(o);function svgFlag(countryCode,size){var width,height;if(size=="tiny"){height=9}else if(size=="small"){height=12}else if(size=="medium"){height=15}else if(!size||size=="default"){height=18}else if(size=="tall"){height=21}else if(size=="large"){height=24}else if(size=="huge"){height=27}else if(size=="giant"){height=30}width=height/3*4;return Create("span").css("display","inline-block").css("width",width+"px").css("height",height+"px").css("vertical-align","middle").css("background","url("+svgFlag.path+"/"+countryCode.toLowerCase()+".svg?v="+svgFlag.version+") no-repeat")}svgFlag.tiny=c=>svgFlag(c,"tiny");svgFlag.small=c=>svgFlag(c,"small");svgFlag.medium=c=>svgFlag(c,"medium");svgFlag.default=c=>svgFlag(c,"default");svgFlag.tall=c=>svgFlag(c,"tall");svgFlag.large=c=>svgFlag(c,"large");svgFlag.huge=c=>svgFlag(c,"huge");svgFlag.giant=c=>svgFlag(c,"giant");svgFlag.path="/assets/country-flags";svgFlag.version=Blx.version;Blx.svgFlag=svgFlag;
/* @license 
ISC License

Copyright (c) for portions of Lucide are held by Cole Bemis 2013-2022 as part of Feather (MIT). All other copyright (c) for Lucide are held by Lucide Contributors 2022.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/const svgIcons={"grid-2x2-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3v17a1 1 0 0 1-1 1H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v6a1 1 0 0 1-1 1H3"/> <path d="M16 19h6"/> <path d="M19 22v-6"/> </svg>',warehouse:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 8.35V20a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V8.35A2 2 0 0 1 3.26 6.5l8-3.2a2 2 0 0 1 1.48 0l8 3.2A2 2 0 0 1 22 8.35Z"/> <path d="M6 18h12"/> <path d="M6 14h12"/> <rect width="12" height="12" x="6" y="10"/> </svg>',"arrow-right-from-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 5v14"/> <path d="M21 12H7"/> <path d="m15 18 6-6-6-6"/> </svg>',"bed-single":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 20v-8a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v8"/> <path d="M5 10V6a2 2 0 0 1 2-2h10a2 2 0 0 1 2 2v4"/> <path d="M3 18h18"/> </svg>',"chevron-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 9 6 6 6-6"/> </svg>',"receipt-japanese-yen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="m12 10 3-3"/> <path d="m9 7 3 3v7.5"/> <path d="M9 11h6"/> <path d="M9 15h6"/> </svg>',"clock-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 16.5 12"/> </svg>',hourglass:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 22h14"/> <path d="M5 2h14"/> <path d="M17 22v-4.172a2 2 0 0 0-.586-1.414L12 12l-4.414 4.414A2 2 0 0 0 7 17.828V22"/> <path d="M7 2v4.172a2 2 0 0 0 .586 1.414L12 12l4.414-4.414A2 2 0 0 0 17 6.172V2"/> </svg>',"server-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 2h13a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2h-5"/> <path d="M10 10 2.5 2.5C2 2 2 2.5 2 5v3a2 2 0 0 0 2 2h6z"/> <path d="M22 17v-1a2 2 0 0 0-2-2h-1"/> <path d="M4 14a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h16.5l1-.5.5.5-8-8H4z"/> <path d="M6 18h.01"/> <path d="m2 2 20 20"/> </svg>',"shield-half":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="M12 22V2"/> </svg>',cherry:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 17a5 5 0 0 0 10 0c0-2.76-2.5-5-5-3-2.5-2-5 .24-5 3Z"/> <path d="M12 17a5 5 0 0 0 10 0c0-2.76-2.5-5-5-3-2.5-2-5 .24-5 3Z"/> <path d="M7 14c3.22-2.91 4.29-8.75 5-12 1.66 2.38 4.94 9 5 12"/> <path d="M22 9c-4.29 0-7.14-2.33-10-7 5.71 0 10 4.67 10 7Z"/> </svg>',"circle-arrow-out-down-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12a10 10 0 1 1 10 10"/> <path d="m2 22 10-10"/> <path d="M8 22H2v-6"/> </svg>',"square-arrow-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M8 12h8"/> <path d="m12 16 4-4-4-4"/> </svg>',cylinder:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <ellipse cx="12" cy="5" rx="9" ry="3"/> <path d="M3 5v14a9 3 0 0 0 18 0V5"/> </svg>',"rectangle-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="12" x="2" y="6" rx="2"/> </svg>',"corner-left-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="14 9 9 4 4 9"/> <path d="M20 20h-7a4 4 0 0 1-4-4V4"/> </svg>',milk:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2h8"/> <path d="M9 2v2.789a4 4 0 0 1-.672 2.219l-.656.984A4 4 0 0 0 7 10.212V20a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2v-9.789a4 4 0 0 0-.672-2.219l-.656-.984A4 4 0 0 1 15 4.788V2"/> <path d="M7 15a6.472 6.472 0 0 1 5 0 6.47 6.47 0 0 0 5 0"/> </svg>',luggage:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 20a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2"/> <path d="M8 18V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v14"/> <path d="M10 20h4"/> <circle cx="16" cy="20" r="2"/> <circle cx="8" cy="20" r="2"/> </svg>',locate:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" x2="5" y1="12" y2="12"/> <line x1="19" x2="22" y1="12" y2="12"/> <line x1="12" x2="12" y1="2" y2="5"/> <line x1="12" x2="12" y1="19" y2="22"/> <circle cx="12" cy="12" r="7"/> </svg>',"save-all":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2v3a1 1 0 0 0 1 1h5"/> <path d="M18 18v-6a1 1 0 0 0-1-1h-6a1 1 0 0 0-1 1v6"/> <path d="M18 22H4a2 2 0 0 1-2-2V6"/> <path d="M8 18a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h9.172a2 2 0 0 1 1.414.586l2.828 2.828A2 2 0 0 1 22 6.828V16a2 2 0 0 1-2.01 2z"/> </svg>',"undo-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="17" r="1"/> <path d="M3 7v6h6"/> <path d="M21 17a9 9 0 0 0-9-9 9 9 0 0 0-6 2.3L3 13"/> </svg>',"chevron-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m18 15-6-6-6 6"/> </svg>',"list-music":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15V6"/> <path d="M18.5 18a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5Z"/> <path d="M12 12H3"/> <path d="M16 6H3"/> <path d="M12 18H3"/> </svg>',palette:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="13.5" cy="6.5" r=".5" fill="currentColor"/> <circle cx="17.5" cy="10.5" r=".5" fill="currentColor"/> <circle cx="8.5" cy="7.5" r=".5" fill="currentColor"/> <circle cx="6.5" cy="12.5" r=".5" fill="currentColor"/> <path d="M12 2C6.5 2 2 6.5 2 12s4.5 10 10 10c.926 0 1.648-.746 1.648-1.688 0-.437-.18-.835-.437-1.125-.29-.289-.438-.652-.438-1.125a1.64 1.64 0 0 1 1.668-1.668h1.996c3.051 0 5.555-2.503 5.555-5.554C21.965 6.012 17.461 2 12 2z"/> </svg>',"shield-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 2 20 20"/> <path d="M5 5a1 1 0 0 0-1 1v7c0 5 3.5 7.5 7.67 8.94a1 1 0 0 0 .67.01c2.35-.82 4.48-1.97 5.9-3.71"/> <path d="M9.309 3.652A12.252 12.252 0 0 0 11.24 2.28a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1v7a9.784 9.784 0 0 1-.08 1.264"/> </svg>',construction:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="2" y="6" width="20" height="8" rx="1"/> <path d="M17 14v7"/> <path d="M7 14v7"/> <path d="M17 3v3"/> <path d="M7 3v3"/> <path d="M10 14 2.3 6.3"/> <path d="m14 6 7.7 7.7"/> <path d="m8 6 8 8"/> </svg>',"unlink-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 7h2a5 5 0 0 1 0 10h-2m-6 0H7A5 5 0 0 1 7 7h2"/> </svg>',"check-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 6 7 17l-5-5"/> <path d="m22 10-7.5 7.5L13 16"/> </svg>',webhook:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 16.98h-5.99c-1.1 0-1.95.94-2.48 1.9A4 4 0 0 1 2 17c.01-.7.2-1.4.57-2"/> <path d="m6 17 3.13-5.78c.53-.97.1-2.18-.5-3.1a4 4 0 1 1 6.89-4.06"/> <path d="m12 6 3.13 5.73C15.66 12.7 16.9 13 18 13a4 4 0 0 1 0 8"/> </svg>',cog:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20a8 8 0 1 0 0-16 8 8 0 0 0 0 16Z"/> <path d="M12 14a2 2 0 1 0 0-4 2 2 0 0 0 0 4Z"/> <path d="M12 2v2"/> <path d="M12 22v-2"/> <path d="m17 20.66-1-1.73"/> <path d="M11 10.27 7 3.34"/> <path d="m20.66 17-1.73-1"/> <path d="m3.34 7 1.73 1"/> <path d="M14 12h8"/> <path d="M2 12h2"/> <path d="m20.66 7-1.73 1"/> <path d="m3.34 17 1.73-1"/> <path d="m17 3.34-1 1.73"/> <path d="m11 13.73-4 6.93"/> </svg>',"plane-landing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 22h20"/> <path d="M3.77 10.77 2 9l2-4.5 1.1.55c.55.28.9.84.9 1.45s.35 1.17.9 1.45L8 8.5l3-6 1.05.53a2 2 0 0 1 1.09 1.52l.72 5.4a2 2 0 0 0 1.09 1.52l4.4 2.2c.42.22.78.55 1.01.96l.6 1.03c.49.88-.06 1.98-1.06 2.1l-1.18.15c-.47.06-.95-.02-1.37-.24L4.29 11.15a2 2 0 0 1-.52-.38Z"/> </svg>',"loader-pinwheel":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12c0-2.8 2.2-5 5-5s5 2.2 5 5 2.2 5 5 5 5-2.2 5-5"/> <path d="M7 20.7a1 1 0 1 1 5-8.7 1 1 0 1 0 5-8.6"/> <path d="M7 3.3a1 1 0 1 1 5 8.6 1 1 0 1 0 5 8.6"/> <circle cx="12" cy="12" r="10"/> </svg>',"keyboard-music":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="16" x="2" y="4" rx="2"/> <path d="M6 8h4"/> <path d="M14 8h.01"/> <path d="M18 8h.01"/> <path d="M2 12h20"/> <path d="M6 12v4"/> <path d="M10 12v4"/> <path d="M14 12v4"/> <path d="M18 12v4"/> </svg>',"chart-gantt":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 6h8"/> <path d="M12 16h6"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M8 11h7"/> </svg>',"ice-cream-cone":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 11 4.08 10.35a1 1 0 0 0 1.84 0L17 11"/> <path d="M17 7A5 5 0 0 0 7 7"/> <path d="M17 7a2 2 0 0 1 0 4H7a2 2 0 0 1 0-4"/> </svg>',"list-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 12H3"/> <path d="M16 6H3"/> <path d="M16 18H3"/> <path d="m19 10-4 4"/> <path d="m15 10 4 4"/> </svg>',joystick:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 17a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-2Z"/> <path d="M6 15v-2"/> <path d="M12 15V9"/> <circle cx="12" cy="6" r="3"/> </svg>',computer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="8" x="5" y="2" rx="2"/> <rect width="20" height="8" x="2" y="14" rx="2"/> <path d="M6 18h2"/> <path d="M12 18h6"/> </svg>',"flask-conical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2v7.527a2 2 0 0 1-.211.896L4.72 20.55a1 1 0 0 0 .9 1.45h12.76a1 1 0 0 0 .9-1.45l-5.069-10.127A2 2 0 0 1 14 9.527V2"/> <path d="M8.5 2h7"/> <path d="M7 16h10"/> </svg>',amphora:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2v5.632c0 .424-.272.795-.653.982A6 6 0 0 0 6 14c.006 4 3 7 5 8"/> <path d="M10 5H8a2 2 0 0 0 0 4h.68"/> <path d="M14 2v5.632c0 .424.272.795.652.982A6 6 0 0 1 18 14c0 4-3 7-5 8"/> <path d="M14 5h2a2 2 0 0 1 0 4h-.68"/> <path d="M18 22H6"/> <path d="M9 2h6"/> </svg>',"app-window":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="2" y="4" width="20" height="16" rx="2"/> <path d="M10 4v4"/> <path d="M2 8h20"/> <path d="M6 4v4"/> </svg>',dot:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12.1" cy="12.1" r="1"/> </svg>',"book-type":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 13h4"/> <path d="M12 6v7"/> <path d="M16 8V6H8v2"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> </svg>',"list-tree":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 12h-8"/> <path d="M21 6H8"/> <path d="M21 18h-8"/> <path d="M3 6v4c0 1.1.9 2 2 2h3"/> <path d="M3 10v6c0 1.1.9 2 2 2h3"/> </svg>',torus:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <ellipse cx="12" cy="11" rx="3" ry="2"/> <ellipse cx="12" cy="12.5" rx="10" ry="8.5"/> </svg>',"copy-slash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="12" x2="18" y1="18" y2="12"/> <rect width="14" height="14" x="8" y="8" rx="2" ry="2"/> <path d="M4 16c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h10c1.1 0 2 .9 2 2"/> </svg>',pipette:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 22 1-1h3l9-9"/> <path d="M3 21v-3l9-9"/> <path d="m15 6 3.4-3.4a2.1 2.1 0 1 1 3 3L18 9l.4.4a2.1 2.1 0 1 1-3 3l-3.8-3.8a2.1 2.1 0 1 1 3-3l.4.4Z"/> </svg>',shovel:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 22v-5l5-5 5 5-5 5z"/> <path d="M9.5 14.5 16 8"/> <path d="m17 2 5 5-.5.5a3.53 3.53 0 0 1-5 0s0 0 0 0a3.53 3.53 0 0 1 0-5L17 2"/> </svg>',"chart-bar-big":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <rect x="7" y="13" width="9" height="4" rx="1"/> <rect x="7" y="5" width="12" height="4" rx="1"/> </svg>',"star-half":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17.8 5.8 21 7 14.1 2 9.3l7-1L12 2"/> </svg>',ruler:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.3 15.3a2.4 2.4 0 0 1 0 3.4l-2.6 2.6a2.4 2.4 0 0 1-3.4 0L2.7 8.7a2.41 2.41 0 0 1 0-3.4l2.6-2.6a2.41 2.41 0 0 1 3.4 0Z"/> <path d="m14.5 12.5 2-2"/> <path d="m11.5 9.5 2-2"/> <path d="m8.5 6.5 2-2"/> <path d="m17.5 15.5 2-2"/> </svg>',"git-compare":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18" cy="18" r="3"/> <circle cx="6" cy="6" r="3"/> <path d="M13 6h3a2 2 0 0 1 2 2v7"/> <path d="M11 18H8a2 2 0 0 1-2-2V9"/> </svg>',smile:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M8 14s1.5 2 4 2 4-2 4-2"/> <line x1="9" x2="9.01" y1="9" y2="9"/> <line x1="15" x2="15.01" y1="9" y2="9"/> </svg>',view:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 17v2a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-2"/> <path d="M21 7V5a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v2"/> <circle cx="12" cy="12" r="1"/> <path d="M18.944 12.33a1 1 0 0 0 0-.66 7.5 7.5 0 0 0-13.888 0 1 1 0 0 0 0 .66 7.5 7.5 0 0 0 13.888 0"/> </svg>',"circle-check-big":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.801 10A10 10 0 1 1 17 3.335"/> <path d="m9 11 3 3L22 4"/> </svg>',"a-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.5 13h6"/> <path d="m2 16 4.5-9 4.5 9"/> <path d="M18 16V7"/> <path d="m14 11 4-4 4 4"/> </svg>',"arrow-big-right-dash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 9v6"/> <path d="M9 9h3V5l7 7-7 7v-4H9V9z"/> </svg>',"rail-symbol":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 15h14"/> <path d="M5 9h14"/> <path d="m14 20-5-5 6-6-5-5"/> </svg>',"ferris-wheel":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="2"/> <path d="M12 2v4"/> <path d="m6.8 15-3.5 2"/> <path d="m20.7 7-3.5 2"/> <path d="M6.8 9 3.3 7"/> <path d="m20.7 17-3.5-2"/> <path d="m9 22 3-8 3 8"/> <path d="M8 22h8"/> <path d="M18 18.7a9 9 0 1 0-12 0"/> </svg>',"gallery-vertical-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 2h10"/> <path d="M5 6h14"/> <rect width="18" height="12" x="3" y="10" rx="2"/> </svg>',"circle-arrow-out-down-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22a10 10 0 1 1 10-10"/> <path d="M22 22 12 12"/> <path d="M22 16v6h-6"/> </svg>',"bluetooth-connected":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 7 10 10-5 5V2l5 5L7 17"/> <line x1="18" x2="21" y1="12" y2="12"/> <line x1="3" x2="6" y1="12" y2="12"/> </svg>',hospital:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 6v4"/> <path d="M14 14h-4"/> <path d="M14 18h-4"/> <path d="M14 8h-4"/> <path d="M18 12h2a2 2 0 0 1 2 2v6a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2v-9a2 2 0 0 1 2-2h2"/> <path d="M18 22V4a2 2 0 0 0-2-2H8a2 2 0 0 0-2 2v18"/> </svg>',"calendar-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <rect width="18" height="18" x="3" y="4" rx="2"/> <path d="M3 10h18"/> <path d="m9 16 2 2 4-4"/> </svg>',"file-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M10 9H8"/> <path d="M16 13H8"/> <path d="M16 17H8"/> </svg>',"mail-question":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 10.5V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v12c0 1.1.9 2 2 2h12.5"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> <path d="M18 15.28c.2-.4.5-.8.9-1a2.1 2.1 0 0 1 2.6.4c.3.4.5.8.5 1.3 0 1.3-2 2-2 2"/> <path d="M20 22v.01"/> </svg>',activity:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 12h-2.48a2 2 0 0 0-1.93 1.46l-2.35 8.36a.25.25 0 0 1-.48 0L9.24 2.18a.25.25 0 0 0-.48 0l-2.35 8.36A2 2 0 0 1 4.49 12H2"/> </svg>',"square-parking-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.6 3.6A2 2 0 0 1 5 3h14a2 2 0 0 1 2 2v14a2 2 0 0 1-.59 1.41"/> <path d="M3 8.7V19a2 2 0 0 0 2 2h10.3"/> <path d="m2 2 20 20"/> <path d="M13 13a3 3 0 1 0 0-6H9v2"/> <path d="M9 17v-2.3"/> </svg>',"arrow-big-left-dash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 15V9"/> <path d="M15 15h-3v4l-7-7 7-7v4h3v6z"/> </svg>',"battery-warning":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 17h.01"/> <path d="M10 7v6"/> <path d="M14 7h2a2 2 0 0 1 2 2v6a2 2 0 0 1-2 2h-2"/> <path d="M22 11v2"/> <path d="M6 7H4a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h2"/> </svg>',reply:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="9 17 4 12 9 7"/> <path d="M20 18v-2a4 4 0 0 0-4-4H4"/> </svg>',"repeat-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m17 2 4 4-4 4"/> <path d="M3 11v-1a4 4 0 0 1 4-4h14"/> <path d="m7 22-4-4 4-4"/> <path d="M21 13v1a4 4 0 0 1-4 4H3"/> <path d="M11 10h1v4"/> </svg>',"notepad-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M12 2v4"/> <path d="M16 2v4"/> <rect width="16" height="18" x="4" y="4" rx="2"/> <path d="M8 10h6"/> <path d="M8 14h8"/> <path d="M8 18h5"/> </svg>',"chevrons-left-right-ellipsis":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m18 8 4 4-4 4"/> <path d="m6 8-4 4 4 4"/> <path d="M8 12h.01"/> <path d="M12 12h.01"/> <path d="M16 12h.01"/> </svg>',plug:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22v-5"/> <path d="M9 8V2"/> <path d="M15 8V2"/> <path d="M18 8v5a4 4 0 0 1-4 4h-4a4 4 0 0 1-4-4V8Z"/> </svg>',"file-key-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v6"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <circle cx="4" cy="16" r="2"/> <path d="m10 10-4.5 4.5"/> <path d="m9 11 1 1"/> </svg>',"cloud-rain-wind":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 14.899A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.242"/> <path d="m9.2 22 3-7"/> <path d="m9 13-3 7"/> <path d="m17 13-3 7"/> </svg>',"users-round":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 21a8 8 0 0 0-16 0"/> <circle cx="10" cy="8" r="5"/> <path d="M22 20c0-3.37-2-6.5-4-8a5 5 0 0 0-.45-8.3"/> </svg>',"notebook-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 6h4"/> <path d="M2 10h4"/> <path d="M2 14h4"/> <path d="M2 18h4"/> <rect width="16" height="20" x="4" y="2" rx="2"/> <path d="M9.5 8h5"/> <path d="M9.5 12H16"/> <path d="M9.5 16H14"/> </svg>',"file-video-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <rect width="8" height="6" x="2" y="12" rx="1"/> <path d="m10 15.5 4 2.5v-6l-4 2.5"/> </svg>',"toggle-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="12" x="2" y="6" rx="6" ry="6"/> <circle cx="16" cy="12" r="2"/> </svg>',"copy-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="15" x2="15" y1="12" y2="18"/> <line x1="12" x2="18" y1="15" y2="15"/> <rect width="14" height="14" x="8" y="8" rx="2" ry="2"/> <path d="M4 16c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h10c1.1 0 2 .9 2 2"/> </svg>',beer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 11h1a3 3 0 0 1 0 6h-1"/> <path d="M9 12v6"/> <path d="M13 12v6"/> <path d="M14 7.5c-1 0-1.44.5-3 .5s-2-.5-3-.5-1.72.5-2.5.5a2.5 2.5 0 0 1 0-5c.78 0 1.57.5 2.5.5S9.44 2 11 2s2 1.5 3 1.5 1.72-.5 2.5-.5a2.5 2.5 0 0 1 0 5c-.78 0-1.5-.5-2.5-.5Z"/> <path d="M5 8v12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2V8"/> </svg>',moon:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3a6 6 0 0 0 9 9 9 9 0 1 1-9-9Z"/> </svg>',milestone:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13v8"/> <path d="M12 3v3"/> <path d="M4 6a1 1 0 0 0-1 1v5a1 1 0 0 0 1 1h13a2 2 0 0 0 1.152-.365l3.424-2.317a1 1 0 0 0 0-1.635l-3.424-2.318A2 2 0 0 0 17 6z"/> </svg>',"monitor-pause":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 13V7"/> <path d="M14 13V7"/> <rect width="20" height="14" x="2" y="3" rx="2"/> <path d="M12 17v4"/> <path d="M8 21h8"/> </svg>',"arrow-up-to-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 3h14"/> <path d="m18 13-6-6-6 6"/> <path d="M12 7v14"/> </svg>',car:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 17h2c.6 0 1-.4 1-1v-3c0-.9-.7-1.7-1.5-1.9C18.7 10.6 16 10 16 10s-1.3-1.4-2.2-2.3c-.5-.4-1.1-.7-1.8-.7H5c-.6 0-1.1.4-1.4.9l-1.4 2.9A3.7 3.7 0 0 0 2 12v4c0 .6.4 1 1 1h2"/> <circle cx="7" cy="17" r="2"/> <path d="M9 17h6"/> <circle cx="17" cy="17" r="2"/> </svg>',timer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="10" x2="14" y1="2" y2="2"/> <line x1="12" x2="15" y1="14" y2="11"/> <circle cx="12" cy="14" r="8"/> </svg>',users:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 21v-2a4 4 0 0 0-4-4H6a4 4 0 0 0-4 4v2"/> <circle cx="9" cy="7" r="4"/> <path d="M22 21v-2a4 4 0 0 0-3-3.87"/> <path d="M16 3.13a4 4 0 0 1 0 7.75"/> </svg>',facebook:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 2h-3a5 5 0 0 0-5 5v3H7v4h3v8h4v-8h3l1-4h-4V7a1 1 0 0 1 1-1h3z"/> </svg>',"move-down-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 13V19H13"/> <path d="M5 5L19 19"/> </svg>',"person-standing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="5" r="1"/> <path d="m9 20 3-6 3 6"/> <path d="m6 8 6 2 6-2"/> <path d="M12 10v4"/> </svg>',"square-arrow-out-down-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 21h6a2 2 0 0 0 2-2V5a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v6"/> <path d="m3 21 9-9"/> <path d="M9 21H3v-6"/> </svg>',"eye-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.733 5.076a10.744 10.744 0 0 1 11.205 6.575 1 1 0 0 1 0 .696 10.747 10.747 0 0 1-1.444 2.49"/> <path d="M14.084 14.158a3 3 0 0 1-4.242-4.242"/> <path d="M17.479 17.499a10.75 10.75 0 0 1-15.417-5.151 1 1 0 0 1 0-.696 10.75 10.75 0 0 1 4.446-5.143"/> <path d="m2 2 20 20"/> </svg>',"dollar-sign":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="12" x2="12" y1="2" y2="22"/> <path d="M17 5H9.5a3.5 3.5 0 0 0 0 7h5a3.5 3.5 0 0 1 0 7H6"/> </svg>',ban:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m4.9 4.9 14.2 14.2"/> </svg>',library:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16 6 4 14"/> <path d="M12 6v14"/> <path d="M8 8v12"/> <path d="M4 4v16"/> </svg>',images:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 22H4a2 2 0 0 1-2-2V6"/> <path d="m22 13-1.296-1.296a2.41 2.41 0 0 0-3.408 0L11 18"/> <circle cx="12" cy="8" r="2"/> <rect width="16" height="16" x="6" y="2" rx="2"/> </svg>',"file-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M4.268 21a2 2 0 0 0 1.727 1H18a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v3"/> <path d="m9 18-1.5-1.5"/> <circle cx="5" cy="14" r="3"/> </svg>',"shield-question":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="M9.1 9a3 3 0 0 1 5.82 1c0 2-3 3-3 3"/> <path d="M12 17h.01"/> </svg>',"smartphone-charging":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="20" x="5" y="2" rx="2" ry="2"/> <path d="M12.667 8 10 12h4l-2.667 4"/> </svg>',cloud:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17.5 19H9a7 7 0 1 1 6.71-9h1.79a4.5 4.5 0 1 1 0 9Z"/> </svg>',"gamepad-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="6" x2="10" y1="11" y2="11"/> <line x1="8" x2="8" y1="9" y2="13"/> <line x1="15" x2="15.01" y1="12" y2="12"/> <line x1="18" x2="18.01" y1="10" y2="10"/> <path d="M17.32 5H6.68a4 4 0 0 0-3.978 3.59c-.006.052-.01.101-.017.152C2.604 9.416 2 14.456 2 16a3 3 0 0 0 3 3c1 0 1.5-.5 2-1l1.414-1.414A2 2 0 0 1 9.828 16h4.344a2 2 0 0 1 1.414.586L17 18c.5.5 1 1 2 1a3 3 0 0 0 3-3c0-1.545-.604-6.584-.685-7.258-.007-.05-.011-.1-.017-.151A4 4 0 0 0 17.32 5z"/> </svg>',"arrow-down-from-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 3H5"/> <path d="M12 21V7"/> <path d="m6 15 6 6 6-6"/> </svg>',"calendar-arrow-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14 18 4 4 4-4"/> <path d="M16 2v4"/> <path d="M18 14v8"/> <path d="M21 11.354V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h7.343"/> <path d="M3 10h18"/> <path d="M8 2v4"/> </svg>',nut:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 4V2"/> <path d="M5 10v4a7.004 7.004 0 0 0 5.277 6.787c.412.104.802.292 1.102.592L12 22l.621-.621c.3-.3.69-.488 1.102-.592A7.003 7.003 0 0 0 19 14v-4"/> <path d="M12 4C8 4 4.5 6 4 8c-.243.97-.919 1.952-2 3 1.31-.082 1.972-.29 3-1 .54.92.982 1.356 2 2 1.452-.647 1.954-1.098 2.5-2 .595.995 1.151 1.427 2.5 2 1.31-.621 1.862-1.058 2.5-2 .629.977 1.162 1.423 2.5 2 1.209-.548 1.68-.967 2-2 1.032.916 1.683 1.157 3 1-1.297-1.036-1.758-2.03-2-3-.5-2-4-4-8-4Z"/> </svg>',"list-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 12H3"/> <path d="M16 6H3"/> <path d="M16 18H3"/> <path d="M21 12h-6"/> </svg>',bookmark:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 21-7-4-7 4V5a2 2 0 0 1 2-2h10a2 2 0 0 1 2 2v16z"/> </svg>',"fast-forward":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="13 19 22 12 13 5 13 19"/> <polygon points="2 19 11 12 2 5 2 19"/> </svg>',"globe-lock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.686 15A14.5 14.5 0 0 1 12 22a14.5 14.5 0 0 1 0-20 10 10 0 1 0 9.542 13"/> <path d="M2 12h8.5"/> <path d="M20 6V4a2 2 0 1 0-4 0v2"/> <rect width="8" height="5" x="14" y="6" rx="1"/> </svg>',"party-popper":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5.8 11.3 2 22l10.7-3.79"/> <path d="M4 3h.01"/> <path d="M22 8h.01"/> <path d="M15 2h.01"/> <path d="M22 20h.01"/> <path d="m22 2-2.24.75a2.9 2.9 0 0 0-1.96 3.12c.1.86-.57 1.63-1.45 1.63h-.38c-.86 0-1.6.6-1.76 1.44L14 10"/> <path d="m22 13-.82-.33c-.86-.34-1.82.2-1.98 1.11c-.11.7-.72 1.22-1.43 1.22H17"/> <path d="m11 2 .33.82c.34.86-.2 1.82-1.11 1.98C9.52 4.9 9 5.52 9 6.23V7"/> <path d="M11 13c1.93 1.93 2.83 4.17 2 5-.83.83-3.07-.07-5-2-1.93-1.93-2.83-4.17-2-5 .83-.83 3.07.07 5 2Z"/> </svg>',"circle-play":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polygon points="10 8 16 12 10 16 10 8"/> </svg>',lamp:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2h8l4 10H4L8 2Z"/> <path d="M12 12v6"/> <path d="M8 22v-2c0-1.1.9-2 2-2h4a2 2 0 0 1 2 2v2H8Z"/> </svg>',wine:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 22h8"/> <path d="M7 10h10"/> <path d="M12 15v7"/> <path d="M12 15a5 5 0 0 0 5-5c0-2-.5-4-2-8H9c-1.5 4-2 6-2 8a5 5 0 0 0 5 5Z"/> </svg>',dock:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 8h20"/> <rect width="20" height="16" x="2" y="4" rx="2"/> <path d="M6 16h12"/> </svg>',"hand-platter":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3V2"/> <path d="M5 10a7.1 7.1 0 0 1 14 0"/> <path d="M4 10h16"/> <path d="M2 14h12a2 2 0 1 1 0 4h-2"/> <path d="m15.4 17.4 3.2-2.8a2 2 0 0 1 2.8 2.9l-3.6 3.3c-.7.8-1.7 1.2-2.8 1.2h-4c-1.1 0-2.1-.4-2.8-1.2L5 18"/> <path d="M5 14v7H2"/> </svg>',"pen-tool":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.707 21.293a1 1 0 0 1-1.414 0l-1.586-1.586a1 1 0 0 1 0-1.414l5.586-5.586a1 1 0 0 1 1.414 0l1.586 1.586a1 1 0 0 1 0 1.414z"/> <path d="m18 13-1.375-6.874a1 1 0 0 0-.746-.776L3.235 2.028a1 1 0 0 0-1.207 1.207L5.35 15.879a1 1 0 0 0 .776.746L13 18"/> <path d="m2.3 2.3 7.286 7.286"/> <circle cx="11" cy="11" r="2"/> </svg>',network:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="16" y="16" width="6" height="6" rx="1"/> <rect x="2" y="16" width="6" height="6" rx="1"/> <rect x="9" y="2" width="6" height="6" rx="1"/> <path d="M5 16v-3a1 1 0 0 1 1-1h12a1 1 0 0 1 1 1v3"/> <path d="M12 12V8"/> </svg>',"grid-2x2-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3v17a1 1 0 0 1-1 1H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v6a1 1 0 0 1-1 1H3"/> <path d="m16 19 2 2 4-4"/> </svg>',"hand-coins":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 15h2a2 2 0 1 0 0-4h-3c-.6 0-1.1.2-1.4.6L3 17"/> <path d="m7 21 1.6-1.4c.3-.4.8-.6 1.4-.6h4c1.1 0 2.1-.4 2.8-1.2l4.6-4.4a2 2 0 0 0-2.75-2.91l-4.2 3.9"/> <path d="m2 16 6 6"/> <circle cx="16" cy="9" r="2.9"/> <circle cx="6" cy="5" r="3"/> </svg>',"chart-column-increasing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 17V9"/> <path d="M18 17V5"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M8 17v-3"/> </svg>',"folder-search-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11.5" cy="12.5" r="2.5"/> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> <path d="M13.3 14.3 15 16"/> </svg>',badge:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> </svg>',"candy-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m8.5 8.5-1 1a4.95 4.95 0 0 0 7 7l1-1"/> <path d="M11.843 6.187A4.947 4.947 0 0 1 16.5 7.5a4.947 4.947 0 0 1 1.313 4.657"/> <path d="M14 16.5V14"/> <path d="M14 6.5v1.843"/> <path d="M10 10v7.5"/> <path d="m16 7 1-5 1.367.683A3 3 0 0 0 19.708 3H21v1.292a3 3 0 0 0 .317 1.341L22 7l-5 1"/> <path d="m8 17-1 5-1.367-.683A3 3 0 0 0 4.292 21H3v-1.292a3 3 0 0 0-.317-1.341L2 17l5-1"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"move-diagonal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="13 5 19 5 19 11"/> <polyline points="11 19 5 19 5 13"/> <line x1="19" x2="5" y1="5" y2="19"/> </svg>',dna:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m10 16 1.5 1.5"/> <path d="m14 8-1.5-1.5"/> <path d="M15 2c-1.798 1.998-2.518 3.995-2.807 5.993"/> <path d="m16.5 10.5 1 1"/> <path d="m17 6-2.891-2.891"/> <path d="M2 15c6.667-6 13.333 0 20-6"/> <path d="m20 9 .891.891"/> <path d="M3.109 14.109 4 15"/> <path d="m6.5 12.5 1 1"/> <path d="m7 18 2.891 2.891"/> <path d="M9 22c1.798-1.998 2.518-3.995 2.807-5.993"/> </svg>',"panel-left-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 3v18"/> <path d="m14 9 3 3-3 3"/> </svg>',"book-copy":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 16V4a2 2 0 0 1 2-2h11"/> <path d="M22 18H11a2 2 0 1 0 0 4h10.5a.5.5 0 0 0 .5-.5v-15a.5.5 0 0 0-.5-.5H11a2 2 0 0 0-2 2v12"/> <path d="M5 14H4a2 2 0 1 0 0 4h1"/> </svg>',"trending-up-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.828 14.828 21 21"/> <path d="M21 16v5h-5"/> <path d="m21 3-9 9-4-4-6 6"/> <path d="M21 8V3h-5"/> </svg>',"mail-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.2 8.4c.5.38.8.97.8 1.6v10a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V10a2 2 0 0 1 .8-1.6l8-6a2 2 0 0 1 2.4 0l8 6Z"/> <path d="m22 10-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 10"/> </svg>',"list-ordered":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="10" x2="21" y1="6" y2="6"/> <line x1="10" x2="21" y1="12" y2="12"/> <line x1="10" x2="21" y1="18" y2="18"/> <path d="M4 6h1v4"/> <path d="M4 10h2"/> <path d="M6 18H4c0-1 2-2 2-3s-1-1.5-2-1"/> </svg>',"wine-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 22h8"/> <path d="M7 10h3m7 0h-1.343"/> <path d="M12 15v7"/> <path d="M7.307 7.307A12.33 12.33 0 0 0 7 10a5 5 0 0 0 7.391 4.391M8.638 2.981C8.75 2.668 8.872 2.34 9 2h6c1.5 4 2 6 2 8 0 .407-.05.809-.145 1.198"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"table-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 3H5a2 2 0 0 0-2 2v4m6-6h10a2 2 0 0 1 2 2v4M9 3v18m0 0h10a2 2 0 0 0 2-2V9M9 21H5a2 2 0 0 1-2-2V9m0 0h18"/> </svg>',dog:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11.25 16.25h1.5L12 17z"/> <path d="M16 14v.5"/> <path d="M4.42 11.247A13.152 13.152 0 0 0 4 14.556C4 18.728 7.582 21 12 21s8-2.272 8-6.444a11.702 11.702 0 0 0-.493-3.309"/> <path d="M8 14v.5"/> <path d="M8.5 8.5c-.384 1.05-1.083 2.028-2.344 2.5-1.931.722-3.576-.297-3.656-1-.113-.994 1.177-6.53 4-7 1.923-.321 3.651.845 3.651 2.235A7.497 7.497 0 0 1 14 5.277c0-1.39 1.844-2.598 3.767-2.277 2.823.47 4.113 6.006 4 7-.08.703-1.725 1.722-3.656 1-1.261-.472-1.855-1.45-2.239-2.5"/> </svg>',contact:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 2v2"/> <path d="M7 22v-2a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2v2"/> <path d="M8 2v2"/> <circle cx="12" cy="11" r="3"/> <rect x="3" y="4" width="18" height="18" rx="2"/> </svg>',"file-json":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M10 12a1 1 0 0 0-1 1v1a1 1 0 0 1-1 1 1 1 0 0 1 1 1v1a1 1 0 0 0 1 1"/> <path d="M14 18a1 1 0 0 0 1-1v-1a1 1 0 0 1 1-1 1 1 0 0 1-1-1v-1a1 1 0 0 0-1-1"/> </svg>',"cooking-pot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12h20"/> <path d="M20 12v8a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2v-8"/> <path d="m4 8 16-4"/> <path d="m8.86 6.78-.45-1.81a2 2 0 0 1 1.45-2.43l1.94-.48a2 2 0 0 1 2.43 1.46l.45 1.8"/> </svg>',"hop-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.82 16.12c1.69.6 3.91.79 5.18.85.28.01.53-.09.7-.27"/> <path d="M11.14 20.57c.52.24 2.44 1.12 4.08 1.37.46.06.86-.25.9-.71.12-1.52-.3-3.43-.5-4.28"/> <path d="M16.13 21.05c1.65.63 3.68.84 4.87.91a.9.9 0 0 0 .7-.26"/> <path d="M17.99 5.52a20.83 20.83 0 0 1 3.15 4.5.8.8 0 0 1-.68 1.13c-1.17.1-2.5.02-3.9-.25"/> <path d="M20.57 11.14c.24.52 1.12 2.44 1.37 4.08.04.3-.08.59-.31.75"/> <path d="M4.93 4.93a10 10 0 0 0-.67 13.4c.35.43.96.4 1.17-.12.69-1.71 1.07-5.07 1.07-6.71 1.34.45 3.1.9 4.88.62a.85.85 0 0 0 .48-.24"/> <path d="M5.52 17.99c1.05.95 2.91 2.42 4.5 3.15a.8.8 0 0 0 1.13-.68c.2-2.34-.33-5.3-1.57-8.28"/> <path d="M8.35 2.68a10 10 0 0 1 9.98 1.58c.43.35.4.96-.12 1.17-1.5.6-4.3.98-6.07 1.05"/> <path d="m2 2 20 20"/> </svg>',"circle-arrow-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M8 12h8"/> <path d="m12 16 4-4-4-4"/> </svg>',pen:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.174 6.812a1 1 0 0 0-3.986-3.987L3.842 16.174a2 2 0 0 0-.5.83l-1.321 4.352a.5.5 0 0 0 .623.622l4.353-1.32a2 2 0 0 0 .83-.497z"/> </svg>',"scan-eye":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <circle cx="12" cy="12" r="1"/> <path d="M18.944 12.33a1 1 0 0 0 0-.66 7.5 7.5 0 0 0-13.888 0 1 1 0 0 0 0 .66 7.5 7.5 0 0 0 13.888 0"/> </svg>',maximize:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 3H5a2 2 0 0 0-2 2v3"/> <path d="M21 8V5a2 2 0 0 0-2-2h-3"/> <path d="M3 16v3a2 2 0 0 0 2 2h3"/> <path d="M16 21h3a2 2 0 0 0 2-2v-3"/> </svg>',"bell-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19.3 14.8C20.1 16.4 21 17 21 17H3s3-2 3-9c0-3.3 2.7-6 6-6 1 0 1.9.2 2.8.7"/> <path d="M10.3 21a1.94 1.94 0 0 0 3.4 0"/> <path d="M15 8h6"/> <path d="M18 5v6"/> </svg>',"align-center-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12h20"/> <path d="M10 16v4a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2v-4"/> <path d="M10 8V4a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v4"/> <path d="M20 16v1a2 2 0 0 1-2 2h-2a2 2 0 0 1-2-2v-1"/> <path d="M14 8V7c0-1.1.9-2 2-2h2a2 2 0 0 1 2 2v1"/> </svg>',"user-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 21v-2a4 4 0 0 0-4-4H6a4 4 0 0 0-4 4v2"/> <circle cx="9" cy="7" r="4"/> <line x1="19" x2="19" y1="8" y2="14"/> <line x1="22" x2="16" y1="11" y2="11"/> </svg>',skull:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12.5 17-.5-1-.5 1h1z"/> <path d="M15 22a1 1 0 0 0 1-1v-1a2 2 0 0 0 1.56-3.25 8 8 0 1 0-11.12 0A2 2 0 0 0 8 20v1a1 1 0 0 0 1 1z"/> <circle cx="15" cy="12" r="1"/> <circle cx="9" cy="12" r="1"/> </svg>',rss:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 11a9 9 0 0 1 9 9"/> <path d="M4 4a16 16 0 0 1 16 16"/> <circle cx="5" cy="19" r="1"/> </svg>',"square-chevron-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m10 8 4 4-4 4"/> </svg>',space:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 17v1c0 .5-.5 1-1 1H3c-.5 0-1-.5-1-1v-1"/> </svg>',"clock-6":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 12 16.5"/> </svg>',"file-stack":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 7h-3a2 2 0 0 1-2-2V2"/> <path d="M21 6v6.5c0 .8-.7 1.5-1.5 1.5h-7c-.8 0-1.5-.7-1.5-1.5v-9c0-.8.7-1.5 1.5-1.5H17Z"/> <path d="M7 8v8.8c0 .3.2.6.4.8.2.2.5.4.8.4H15"/> <path d="M3 12v8.8c0 .3.2.6.4.8.2.2.5.4.8.4H11"/> </svg>',"ellipsis-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="1"/> <circle cx="12" cy="5" r="1"/> <circle cx="12" cy="19" r="1"/> </svg>',fuel:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="3" x2="15" y1="22" y2="22"/> <line x1="4" x2="14" y1="9" y2="9"/> <path d="M14 22V4a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v18"/> <path d="M14 13h2a2 2 0 0 1 2 2v2a2 2 0 0 0 2 2a2 2 0 0 0 2-2V9.83a2 2 0 0 0-.59-1.42L18 5"/> </svg>',"bookmark-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 21-7-4-7 4V5a2 2 0 0 1 2-2h10a2 2 0 0 1 2 2v16z"/> <line x1="12" x2="12" y1="7" y2="13"/> <line x1="15" x2="9" y1="10" y2="10"/> </svg>',"file-scan":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10V7l-5-5H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M16 14a2 2 0 0 0-2 2"/> <path d="M20 14a2 2 0 0 1 2 2"/> <path d="M20 22a2 2 0 0 0 2-2"/> <path d="M16 22a2 2 0 0 1-2-2"/> </svg>',"stretch-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="20" x="4" y="2" rx="2"/> <rect width="6" height="20" x="14" y="2" rx="2"/> </svg>',package:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7.5 4.27 9 5.15"/> <path d="M21 8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l7-4A2 2 0 0 0 21 16Z"/> <path d="m3.3 7 8.7 5 8.7-5"/> <path d="M12 22V12"/> </svg>',"rectangle-ellipsis":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="12" x="2" y="6" rx="2"/> <path d="M12 12h.01"/> <path d="M17 12h.01"/> <path d="M7 12h.01"/> </svg>',ear:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 8.5a6.5 6.5 0 1 1 13 0c0 6-6 6-6 10a3.5 3.5 0 1 1-7 0"/> <path d="M15 8.5a2.5 2.5 0 0 0-5 0v1a2 2 0 1 1 0 4"/> </svg>',"flask-round":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2v7.31"/> <path d="M14 9.3V1.99"/> <path d="M8.5 2h7"/> <path d="M14 9.3a6.5 6.5 0 1 1-4 0"/> <path d="M5.52 16h12.96"/> </svg>',"step-back":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="18" x2="18" y1="20" y2="4"/> <polygon points="14,20 4,12 14,4"/> </svg>',"smile-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 11v1a10 10 0 1 1-9-10"/> <path d="M8 14s1.5 2 4 2 4-2 4-2"/> <line x1="9" x2="9.01" y1="9" y2="9"/> <line x1="15" x2="15.01" y1="9" y2="9"/> <path d="M16 5h6"/> <path d="M19 2v6"/> </svg>',"square-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m9 12 2 2 4-4"/> </svg>',martini:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 22h8"/> <path d="M12 11v11"/> <path d="m19 3-7 8-7-8Z"/> </svg>',"badge-swiss-franc":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M11 17V8h4"/> <path d="M11 12h3"/> <path d="M9 16h4"/> </svg>',"equal-not":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="5" x2="19" y1="9" y2="9"/> <line x1="5" x2="19" y1="15" y2="15"/> <line x1="19" x2="5" y1="5" y2="19"/> </svg>',"swiss-franc":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 21V3h8"/> <path d="M6 16h9"/> <path d="M10 9.5h7"/> </svg>',"text-cursor":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 22h-1a4 4 0 0 1-4-4V6a4 4 0 0 1 4-4h1"/> <path d="M7 22h1a4 4 0 0 0 4-4v-1"/> <path d="M7 2h1a4 4 0 0 1 4 4v1"/> </svg>',notebook:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 6h4"/> <path d="M2 10h4"/> <path d="M2 14h4"/> <path d="M2 18h4"/> <rect width="16" height="20" x="4" y="2" rx="2"/> <path d="M16 2v20"/> </svg>',"file-image":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <circle cx="10" cy="12" r="2"/> <path d="m20 17-1.296-1.296a2.41 2.41 0 0 0-3.408 0L9 22"/> </svg>',"mouse-pointer-ban":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.034 2.681a.498.498 0 0 1 .647-.647l9 3.5a.5.5 0 0 1-.033.944L8.204 7.545a1 1 0 0 0-.66.66l-1.066 3.443a.5.5 0 0 1-.944.033z"/> <circle cx="16" cy="16" r="6"/> <path d="m11.8 11.8 8.4 8.4"/> </svg>',croissant:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m4.6 13.11 5.79-3.21c1.89-1.05 4.79 1.78 3.71 3.71l-3.22 5.81C8.8 23.16.79 15.23 4.6 13.11Z"/> <path d="m10.5 9.5-1-2.29C9.2 6.48 8.8 6 8 6H4.5C2.79 6 2 6.5 2 8.5a7.71 7.71 0 0 0 2 4.83"/> <path d="M8 6c0-1.55.24-4-2-4-2 0-2.5 2.17-2.5 4"/> <path d="m14.5 13.5 2.29 1c.73.3 1.21.7 1.21 1.5v3.5c0 1.71-.5 2.5-2.5 2.5a7.71 7.71 0 0 1-4.83-2"/> <path d="M18 16c1.55 0 4-.24 4 2 0 2-2.17 2.5-4 2.5"/> </svg>',"test-tubes":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 2v17.5A2.5 2.5 0 0 1 6.5 22A2.5 2.5 0 0 1 4 19.5V2"/> <path d="M20 2v17.5a2.5 2.5 0 0 1-2.5 2.5a2.5 2.5 0 0 1-2.5-2.5V2"/> <path d="M3 2h7"/> <path d="M14 2h7"/> <path d="M9 16H4"/> <path d="M20 16h-5"/> </svg>',coffee:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2v2"/> <path d="M14 2v2"/> <path d="M16 8a1 1 0 0 1 1 1v8a4 4 0 0 1-4 4H7a4 4 0 0 1-4-4V9a1 1 0 0 1 1-1h14a4 4 0 1 1 0 8h-1"/> <path d="M6 2v2"/> </svg>',gavel:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14.5 12.5-8 8a2.119 2.119 0 1 1-3-3l8-8"/> <path d="m16 16 6-6"/> <path d="m8 8 6-6"/> <path d="m9 7 8 8"/> <path d="m21 11-8-8"/> </svg>',"cloud-fog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 14.899A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.242"/> <path d="M16 17H7"/> <path d="M17 21H9"/> </svg>',shrink:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 15 6 6m-6-6v4.8m0-4.8h4.8"/> <path d="M9 19.8V15m0 0H4.2M9 15l-6 6"/> <path d="M15 4.2V9m0 0h4.8M15 9l6-6"/> <path d="M9 4.2V9m0 0H4.2M9 9 3 3"/> </svg>',"clock-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 14.5 8"/> </svg>',"grid-2x2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 12h18"/> <path d="M12 3v18"/> </svg>',youtube:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.5 17a24.12 24.12 0 0 1 0-10 2 2 0 0 1 1.4-1.4 49.56 49.56 0 0 1 16.2 0A2 2 0 0 1 21.5 7a24.12 24.12 0 0 1 0 10 2 2 0 0 1-1.4 1.4 49.55 49.55 0 0 1-16.2 0A2 2 0 0 1 2.5 17"/> <path d="m10 15 5-3-5-3z"/> </svg>',"circle-user":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <circle cx="12" cy="10" r="3"/> <path d="M7 20.662V19a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2v1.662"/> </svg>',"flame-kindling":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2c1 3 2.5 3.5 3.5 4.5A5 5 0 0 1 17 10a5 5 0 1 1-10 0c0-.3 0-.6.1-.9a2 2 0 1 0 3.3-2C8 4.5 11 2 12 2Z"/> <path d="m5 22 14-4"/> <path d="m5 18 14 4"/> </svg>',"user-round-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 21a8 8 0 0 1 10.434-7.62"/> <circle cx="10" cy="8" r="5"/> <circle cx="18" cy="18" r="3"/> <path d="m19.5 14.3-.4.9"/> <path d="m16.9 20.8-.4.9"/> <path d="m21.7 19.5-.9-.4"/> <path d="m15.2 16.9-.9-.4"/> <path d="m21.7 16.5-.9.4"/> <path d="m15.2 19.1-.9.4"/> <path d="m19.5 21.7-.4-.9"/> <path d="m16.9 15.2-.4-.9"/> </svg>',"badge-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <line x1="8" x2="16" y1="12" y2="12"/> </svg>',anvil:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 10H6a4 4 0 0 1-4-4 1 1 0 0 1 1-1h4"/> <path d="M7 5a1 1 0 0 1 1-1h13a1 1 0 0 1 1 1 7 7 0 0 1-7 7H8a1 1 0 0 1-1-1z"/> <path d="M9 12v5"/> <path d="M15 12v5"/> <path d="M5 20a3 3 0 0 1 3-3h8a3 3 0 0 1 3 3 1 1 0 0 1-1 1H6a1 1 0 0 1-1-1"/> </svg>',sprout:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 20h10"/> <path d="M10 20c5.5-2.5.8-6.4 3-10"/> <path d="M9.5 9.4c1.1.8 1.8 2.2 2.3 3.7-2 .4-3.5.4-4.8-.3-1.2-.6-2.3-1.9-3-4.2 2.8-.5 4.4 0 5.5.8z"/> <path d="M14.1 6a7 7 0 0 0-1.1 4c1.9-.1 3.3-.6 4.3-1.4 1-1 1.6-2.3 1.7-4.6-2.7.1-4 1-4.9 2z"/> </svg>',theater:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 10s3-3 3-8"/> <path d="M22 10s-3-3-3-8"/> <path d="M10 2c0 4.4-3.6 8-8 8"/> <path d="M14 2c0 4.4 3.6 8 8 8"/> <path d="M2 10s2 2 2 5"/> <path d="M22 10s-2 2-2 5"/> <path d="M8 15h8"/> <path d="M2 22v-1a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v1"/> <path d="M14 22v-1a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v1"/> </svg>',"chart-area":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M7 11.207a.5.5 0 0 1 .146-.353l2-2a.5.5 0 0 1 .708 0l3.292 3.292a.5.5 0 0 0 .708 0l4.292-4.292a.5.5 0 0 1 .854.353V16a1 1 0 0 1-1 1H8a1 1 0 0 1-1-1z"/> </svg>',recycle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 19H4.815a1.83 1.83 0 0 1-1.57-.881 1.785 1.785 0 0 1-.004-1.784L7.196 9.5"/> <path d="M11 19h8.203a1.83 1.83 0 0 0 1.556-.89 1.784 1.784 0 0 0 0-1.775l-1.226-2.12"/> <path d="m14 16-3 3 3 3"/> <path d="M8.293 13.596 7.196 9.5 3.1 10.598"/> <path d="m9.344 5.811 1.093-1.892A1.83 1.83 0 0 1 11.985 3a1.784 1.784 0 0 1 1.546.888l3.943 6.843"/> <path d="m13.378 9.633 4.096 1.098 1.097-4.096"/> </svg>',"message-circle-warning":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> <path d="M12 8v4"/> <path d="M12 16h.01"/> </svg>',"indent-increase":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="3 8 7 12 3 16"/> <line x1="21" x2="11" y1="12" y2="12"/> <line x1="21" x2="11" y1="6" y2="6"/> <line x1="21" x2="11" y1="18" y2="18"/> </svg>',clapperboard:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20.2 6 3 11l-.9-2.4c-.3-1.1.3-2.2 1.3-2.5l13.5-4c1.1-.3 2.2.3 2.5 1.3Z"/> <path d="m6.2 5.3 3.1 3.9"/> <path d="m12.4 3.4 3.1 4"/> <path d="M3 11h18v8a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2Z"/> </svg>',"file-chart-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m16 13-3.5 3.5-2-2L8 17"/> </svg>',"square-dashed-bottom-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 9.5 8 12l2 2.5"/> <path d="M14 21h1"/> <path d="m14 9.5 2 2.5-2 2.5"/> <path d="M5 21a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2"/> <path d="M9 21h1"/> </svg>',turtle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12 10 2 4v3a1 1 0 0 0 1 1h2a1 1 0 0 0 1-1v-3a8 8 0 1 0-16 0v3a1 1 0 0 0 1 1h2a1 1 0 0 0 1-1v-3l2-4h4Z"/> <path d="M4.82 7.9 8 10"/> <path d="M15.18 7.9 12 10"/> <path d="M16.93 10H20a2 2 0 0 1 0 4H2"/> </svg>',"replace-all":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 14a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2"/> <path d="M14 4a2 2 0 0 1 2-2"/> <path d="M16 10a2 2 0 0 1-2-2"/> <path d="M20 14a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2"/> <path d="M20 2a2 2 0 0 1 2 2"/> <path d="M22 8a2 2 0 0 1-2 2"/> <path d="m3 7 3 3 3-3"/> <path d="M6 10V5a 3 3 0 0 1 3-3h1"/> <rect x="2" y="14" width="8" height="8" rx="2"/> </svg>',"align-horizontal-justify-center":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="14" x="2" y="5" rx="2"/> <rect width="6" height="10" x="16" y="7" rx="2"/> <path d="M12 2v20"/> </svg>',drill:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 9c0 .6-.4 1-1 1H4a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h9c.6 0 1 .4 1 1Z"/> <path d="M18 6h4"/> <path d="M14 4h3a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1h-3"/> <path d="m5 10-2 8"/> <path d="M12 10v3c0 .6-.4 1-1 1H8"/> <path d="m7 18 2-8"/> <path d="M5 22c-1.7 0-3-1.3-3-3 0-.6.4-1 1-1h7c.6 0 1 .4 1 1v2c0 .6-.4 1-1 1Z"/> </svg>',rewind:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="11 19 2 12 11 5 11 19"/> <polygon points="22 19 13 12 22 5 22 19"/> </svg>',school:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 22v-4a2 2 0 1 0-4 0v4"/> <path d="m18 10 4 2v8a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2v-8l4-2"/> <path d="M18 5v17"/> <path d="m4 6 8-4 8 4"/> <path d="M6 5v17"/> <circle cx="12" cy="9" r="2"/> </svg>',"dice-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="M16 8h.01"/> <path d="M12 12h.01"/> <path d="M8 16h.01"/> </svg>',"receipt-pound-sterling":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M8 13h5"/> <path d="M10 17V9.5a2.5 2.5 0 0 1 5 0"/> <path d="M8 17h7"/> </svg>',"message-square":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> </svg>',smartphone:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="20" x="5" y="2" rx="2" ry="2"/> <path d="M12 18h.01"/> </svg>',"folder-key":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="16" cy="20" r="2"/> <path d="M10 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v2"/> <path d="m22 14-4.5 4.5"/> <path d="m21 15 1 1"/> </svg>',codesandbox:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 16V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l7-4A2 2 0 0 0 21 16z"/> <polyline points="7.5 4.21 12 6.81 16.5 4.21"/> <polyline points="7.5 19.79 7.5 14.6 3 12"/> <polyline points="21 12 16.5 14.6 16.5 19.79"/> <polyline points="3.27 6.96 12 12.01 20.73 6.96"/> <line x1="12" x2="12" y1="22.08" y2="12"/> </svg>',binoculars:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 10h4"/> <path d="M19 7V4a1 1 0 0 0-1-1h-2a1 1 0 0 0-1 1v3"/> <path d="M20 21a2 2 0 0 0 2-2v-3.851c0-1.39-2-2.962-2-4.829V8a1 1 0 0 0-1-1h-4a1 1 0 0 0-1 1v11a2 2 0 0 0 2 2z"/> <path d="M 22 16 L 2 16"/> <path d="M4 21a2 2 0 0 1-2-2v-3.851c0-1.39 2-2.962 2-4.829V8a1 1 0 0 1 1-1h4a1 1 0 0 1 1 1v11a2 2 0 0 1-2 2z"/> <path d="M9 7V4a1 1 0 0 0-1-1H6a1 1 0 0 0-1 1v3"/> </svg>',"square-chevron-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m8 14 4-4 4 4"/> </svg>',"align-vertical-distribute-start":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="6" x="5" y="14" rx="2"/> <rect width="10" height="6" x="7" y="4" rx="2"/> <path d="M2 14h20"/> <path d="M2 4h20"/> </svg>',tickets:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m4.5 8 10.58-5.06a1 1 0 0 1 1.342.488L18.5 8"/> <path d="M6 10V8"/> <path d="M6 14v1"/> <path d="M6 19v2"/> <rect x="2" y="8" width="20" height="13" rx="2"/> </svg>',"map-pin-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19.43 12.935c.357-.967.57-1.955.57-2.935a8 8 0 0 0-16 0c0 4.993 5.539 10.193 7.399 11.799a1 1 0 0 0 1.202 0 32.197 32.197 0 0 0 .813-.728"/> <circle cx="12" cy="10" r="3"/> <path d="m16 18 2 2 4-4"/> </svg>',"hard-drive":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="22" x2="2" y1="12" y2="12"/> <path d="M5.45 5.11 2 12v6a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-6l-3.45-6.89A2 2 0 0 0 16.76 4H7.24a2 2 0 0 0-1.79 1.11z"/> <line x1="6" x2="6.01" y1="16" y2="16"/> <line x1="10" x2="10.01" y1="16" y2="16"/> </svg>',bus:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 6v6"/> <path d="M15 6v6"/> <path d="M2 12h19.6"/> <path d="M18 18h3s.5-1.7.8-2.8c.1-.4.2-.8.2-1.2 0-.4-.1-.8-.2-1.2l-1.4-5C20.1 6.8 19.1 6 18 6H4a2 2 0 0 0-2 2v10h3"/> <circle cx="7" cy="18" r="2"/> <path d="M9 18h5"/> <circle cx="16" cy="18" r="2"/> </svg>',"heading-5":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 12h8"/> <path d="M4 18V6"/> <path d="M12 18V6"/> <path d="M17 13v-3h4"/> <path d="M17 17.7c.4.2.8.3 1.3.3 1.5 0 2.7-1.1 2.7-2.5S19.8 13 18.3 13H17"/> </svg>',"remove-formatting":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 7V4h16v3"/> <path d="M5 20h6"/> <path d="M13 4 8 20"/> <path d="m15 15 5 5"/> <path d="m20 15-5 5"/> </svg>',"list-collapse":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 10 2.5-2.5L3 5"/> <path d="m3 19 2.5-2.5L3 14"/> <path d="M10 6h11"/> <path d="M10 12h11"/> <path d="M10 18h11"/> </svg>',radiation:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 12h.01"/> <path d="M7.5 4.2c-.3-.5-.9-.7-1.3-.4C3.9 5.5 2.3 8.1 2 11c-.1.5.4 1 1 1h5c0-1.5.8-2.8 2-3.4-1.1-1.9-2-3.5-2.5-4.4z"/> <path d="M21 12c.6 0 1-.4 1-1-.3-2.9-1.8-5.5-4.1-7.1-.4-.3-1.1-.2-1.3.3-.6.9-1.5 2.5-2.6 4.3 1.2.7 2 2 2 3.5h5z"/> <path d="M7.5 19.8c-.3.5-.1 1.1.4 1.3 2.6 1.2 5.6 1.2 8.2 0 .5-.2.7-.8.4-1.3-.5-.9-1.4-2.5-2.5-4.3-1.2.7-2.8.7-4 0-1.1 1.8-2 3.4-2.5 4.3z"/> </svg>',focus:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="3"/> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> </svg>',"chevrons-down-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 20 5-5 5 5"/> <path d="m7 4 5 5 5-5"/> </svg>',forklift:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 12H5a2 2 0 0 0-2 2v5"/> <circle cx="13" cy="19" r="2"/> <circle cx="5" cy="19" r="2"/> <path d="M8 19h3m5-17v17h6M6 12V7c0-1.1.9-2 2-2h3l5 5"/> </svg>',watch:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="6"/> <polyline points="12 10 12 12 13 13"/> <path d="m16.13 7.66-.81-4.05a2 2 0 0 0-2-1.61h-2.68a2 2 0 0 0-2 1.61l-.78 4.05"/> <path d="m7.88 16.36.8 4a2 2 0 0 0 2 1.61h2.72a2 2 0 0 0 2-1.61l.81-4.05"/> </svg>',"corner-right-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="10 15 15 20 20 15"/> <path d="M4 4h7a4 4 0 0 1 4 4v12"/> </svg>',"move-up-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 5H19V11"/> <path d="M19 5L5 19"/> </svg>',"badge-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="m9 12 2 2 4-4"/> </svg>',"align-justify":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="3" x2="21" y1="6" y2="6"/> <line x1="3" x2="21" y1="12" y2="12"/> <line x1="3" x2="21" y1="18" y2="18"/> </svg>',split:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 3h5v5"/> <path d="M8 3H3v5"/> <path d="M12 22v-8.3a4 4 0 0 0-1.172-2.872L3 3"/> <path d="m15 9 6-6"/> </svg>',"image-play":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m11 16-5 5"/> <path d="M11 21H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v6.5"/> <path d="M15.765 22a.5.5 0 0 1-.765-.424V13.38a.5.5 0 0 1 .765-.424l5.878 3.674a1 1 0 0 1 0 1.696z"/> <circle cx="9" cy="9" r="2"/> </svg>',file:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> </svg>',paintbrush:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14.622 17.897-10.68-2.913"/> <path d="M18.376 2.622a1 1 0 1 1 3.002 3.002L17.36 9.643a.5.5 0 0 0 0 .707l.944.944a2.41 2.41 0 0 1 0 3.408l-.944.944a.5.5 0 0 1-.707 0L8.354 7.348a.5.5 0 0 1 0-.707l.944-.944a2.41 2.41 0 0 1 3.408 0l.944.944a.5.5 0 0 0 .707 0z"/> <path d="M9 8c-1.804 2.71-3.97 3.46-6.583 3.948a.507.507 0 0 0-.302.819l7.32 8.883a1 1 0 0 0 1.185.204C12.735 20.405 16 16.792 16 15"/> </svg>',"package-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 16h6"/> <path d="M21 10V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l2-1.14"/> <path d="m7.5 4.27 9 5.15"/> <polyline points="3.29 7 12 12 20.71 7"/> <line x1="12" x2="12" y1="22" y2="12"/> </svg>',"refresh-ccw":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 12a9 9 0 0 0-9-9 9.75 9.75 0 0 0-6.74 2.74L3 8"/> <path d="M3 3v5h5"/> <path d="M3 12a9 9 0 0 0 9 9 9.75 9.75 0 0 0 6.74-2.74L21 16"/> <path d="M16 16h5v5"/> </svg>',"list-start":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 12H3"/> <path d="M16 18H3"/> <path d="M10 6H3"/> <path d="M21 18V8a2 2 0 0 0-2-2h-5"/> <path d="m16 8-2-2 2-2"/> </svg>',"git-pull-request":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18" cy="18" r="3"/> <circle cx="6" cy="6" r="3"/> <path d="M13 6h3a2 2 0 0 1 2 2v7"/> <line x1="6" x2="6" y1="9" y2="21"/> </svg>',"panel-right-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M15 3v18"/> <path d="m10 15-3-3 3-3"/> </svg>',bike:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18.5" cy="17.5" r="3.5"/> <circle cx="5.5" cy="17.5" r="3.5"/> <circle cx="15" cy="5" r="1"/> <path d="M12 17.5V14l-3-3 4-3 2 3h2"/> </svg>',"circle-arrow-out-up-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 8V2h6"/> <path d="m2 2 10 10"/> <path d="M12 2A10 10 0 1 1 2 12"/> </svg>',"flask-conical-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 10 4.72 20.55a1 1 0 0 0 .9 1.45h12.76a1 1 0 0 0 .9-1.45l-1.272-2.542"/> <path d="M10 2v2.343"/> <path d="M14 2v6.343"/> <path d="M8.5 2h7"/> <path d="M7 16h9"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"circle-chevron-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m8 14 4-4 4 4"/> </svg>',"washing-machine":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 6h3"/> <path d="M17 6h.01"/> <rect width="18" height="20" x="3" y="2" rx="2"/> <circle cx="12" cy="13" r="5"/> <path d="M12 18a2.5 2.5 0 0 0 0-5 2.5 2.5 0 0 1 0-5"/> </svg>',play:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="6 3 20 12 6 21 6 3"/> </svg>',banana:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 13c3.5-2 8-2 10 2a5.5 5.5 0 0 1 8 5"/> <path d="M5.15 17.89c5.52-1.52 8.65-6.89 7-12C11.55 4 11.5 2 13 2c3.22 0 5 5.5 5 8 0 6.5-4.2 12-10.49 12C5.11 22 2 22 2 20c0-1.5 1.14-1.55 3.15-2.11Z"/> </svg>',tv:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="15" x="2" y="7" rx="2" ry="2"/> <polyline points="17 2 12 7 7 2"/> </svg>',"chart-scatter":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="7.5" cy="7.5" r=".5" fill="currentColor"/> <circle cx="18.5" cy="5.5" r=".5" fill="currentColor"/> <circle cx="11.5" cy="11.5" r=".5" fill="currentColor"/> <circle cx="7.5" cy="16.5" r=".5" fill="currentColor"/> <circle cx="17.5" cy="14.5" r=".5" fill="currentColor"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> </svg>',dribbble:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M19.13 5.09C15.22 9.14 10 10.44 2.25 10.94"/> <path d="M21.75 12.84c-6.62-1.41-12.14 1-16.38 6.32"/> <path d="M8.56 2.75c4.37 6 6 9.42 8 17.72"/> </svg>',"message-circle-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> <path d="M8 12h8"/> <path d="M12 8v8"/> </svg>',"minimize-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="4 14 10 14 10 20"/> <polyline points="20 10 14 10 14 4"/> <line x1="14" x2="21" y1="10" y2="3"/> <line x1="3" x2="10" y1="21" y2="14"/> </svg>',brackets:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 3h3v18h-3"/> <path d="M8 21H5V3h3"/> </svg>',"copy-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="12" x2="18" y1="12" y2="18"/> <line x1="12" x2="18" y1="18" y2="12"/> <rect width="14" height="14" x="8" y="8" rx="2" ry="2"/> <path d="M4 16c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h10c1.1 0 2 .9 2 2"/> </svg>',"philippine-peso":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 11H4"/> <path d="M20 7H4"/> <path d="M7 21V4a1 1 0 0 1 1-1h4a1 1 0 0 1 0 12H7"/> </svg>',copyright:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M14.83 14.83a4 4 0 1 1 0-5.66"/> </svg>',"square-sigma":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M16 8.9V7H8l4 5-4 5h8v-1.9"/> </svg>',"book-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 7v14"/> <path d="M3 18a1 1 0 0 1-1-1V4a1 1 0 0 1 1-1h5a4 4 0 0 1 4 4 4 4 0 0 1 4-4h5a1 1 0 0 1 1 1v13a1 1 0 0 1-1 1h-6a3 3 0 0 0-3 3 3 3 0 0 0-3-3z"/> </svg>',"table-rows-split":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 10h2"/> <path d="M15 22v-8"/> <path d="M15 2v4"/> <path d="M2 10h2"/> <path d="M20 10h2"/> <path d="M3 19h18"/> <path d="M3 22v-6a2 2 135 0 1 2-2h14a2 2 45 0 1 2 2v6"/> <path d="M3 2v2a2 2 45 0 0 2 2h14a2 2 135 0 0 2-2V2"/> <path d="M8 10h2"/> <path d="M9 22v-8"/> <path d="M9 2v4"/> </svg>',"user-round-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 21a8 8 0 0 1 11.873-7"/> <circle cx="10" cy="8" r="5"/> <path d="m17 17 5 5"/> <path d="m22 17-5 5"/> </svg>',"map-pin":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10c0 4.993-5.539 10.193-7.399 11.799a1 1 0 0 1-1.202 0C9.539 20.193 4 14.993 4 10a8 8 0 0 1 16 0"/> <circle cx="12" cy="10" r="3"/> </svg>',"flashlight-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 16v4a2 2 0 0 1-2 2h-4a2 2 0 0 1-2-2V10c0-2-2-2-2-4"/> <path d="M7 2h11v4c0 2-2 2-2 4v1"/> <line x1="11" x2="18" y1="6" y2="6"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"move-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="8 18 12 22 16 18"/> <polyline points="8 6 12 2 16 6"/> <line x1="12" x2="12" y1="2" y2="22"/> </svg>',"stretch-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="6" x="2" y="4" rx="2"/> <rect width="20" height="6" x="2" y="14" rx="2"/> </svg>',"webhook-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 17h-5c-1.09-.02-1.94.92-2.5 1.9A3 3 0 1 1 2.57 15"/> <path d="M9 3.4a4 4 0 0 1 6.52.66"/> <path d="m6 17 3.1-5.8a2.5 2.5 0 0 0 .057-2.05"/> <path d="M20.3 20.3a4 4 0 0 1-2.3.7"/> <path d="M18.6 13a4 4 0 0 1 3.357 3.414"/> <path d="m12 6 .6 1"/> <path d="m2 2 20 20"/> </svg>',"bed-double":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 20v-8a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v8"/> <path d="M4 10V6a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v4"/> <path d="M12 4v6"/> <path d="M2 18h20"/> </svg>',"alarm-clock-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="13" r="8"/> <path d="M5 3 2 6"/> <path d="m22 6-3-3"/> <path d="M6.38 18.7 4 21"/> <path d="M17.64 18.67 20 21"/> <path d="M9 13h6"/> </svg>',"hard-drive-upload":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16 6-4-4-4 4"/> <path d="M12 2v8"/> <rect width="20" height="8" x="2" y="14" rx="2"/> <path d="M6 18h.01"/> <path d="M10 18h.01"/> </svg>',landmark:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="3" x2="21" y1="22" y2="22"/> <line x1="6" x2="6" y1="18" y2="11"/> <line x1="10" x2="10" y1="18" y2="11"/> <line x1="14" x2="14" y1="18" y2="11"/> <line x1="18" x2="18" y1="18" y2="11"/> <polygon points="12 2 20 7 4 7"/> </svg>',"bug-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 7.13V6a3 3 0 0 0-5.14-2.1L8 2"/> <path d="M14.12 3.88 16 2"/> <path d="M22 13h-4v-2a4 4 0 0 0-4-4h-1.3"/> <path d="M20.97 5c0 2.1-1.6 3.8-3.5 4"/> <path d="m2 2 20 20"/> <path d="M7.7 7.7A4 4 0 0 0 6 11v3a6 6 0 0 0 11.13 3.13"/> <path d="M12 20v-8"/> <path d="M6 13H2"/> <path d="M3 21c0-2.1 1.7-3.9 3.8-4"/> </svg>',"fire-extinguisher":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 6.5V3a1 1 0 0 0-1-1h-2a1 1 0 0 0-1 1v3.5"/> <path d="M9 18h8"/> <path d="M18 3h-3"/> <path d="M11 3a6 6 0 0 0-6 6v11"/> <path d="M5 13h4"/> <path d="M17 10a4 4 0 0 0-8 0v10a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2Z"/> </svg>',italic:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="19" x2="10" y1="4" y2="4"/> <line x1="14" x2="5" y1="20" y2="20"/> <line x1="15" x2="9" y1="4" y2="20"/> </svg>',"chart-network":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m13.11 7.664 1.78 2.672"/> <path d="m14.162 12.788-3.324 1.424"/> <path d="m20 4-6.06 1.515"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <circle cx="12" cy="6" r="2"/> <circle cx="16" cy="12" r="2"/> <circle cx="9" cy="15" r="2"/> </svg>',"map-pin-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19.752 11.901A7.78 7.78 0 0 0 20 10a8 8 0 0 0-16 0c0 4.993 5.539 10.193 7.399 11.799a1 1 0 0 0 1.202 0 19 19 0 0 0 .09-.077"/> <circle cx="12" cy="10" r="3"/> <path d="m21.5 15.5-5 5"/> <path d="m21.5 20.5-5-5"/> </svg>',"message-square-diff":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m5 19-2 2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2"/> <path d="M9 10h6"/> <path d="M12 7v6"/> <path d="M9 17h6"/> </svg>',"grip-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="9" r="1"/> <circle cx="19" cy="9" r="1"/> <circle cx="5" cy="9" r="1"/> <circle cx="12" cy="15" r="1"/> <circle cx="19" cy="15" r="1"/> <circle cx="5" cy="15" r="1"/> </svg>',"user-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18" cy="15" r="3"/> <circle cx="9" cy="7" r="4"/> <path d="M10 15H6a4 4 0 0 0-4 4v2"/> <path d="m21.7 16.4-.9-.3"/> <path d="m15.2 13.9-.9-.3"/> <path d="m16.6 18.7.3-.9"/> <path d="m19.1 12.2.3-.9"/> <path d="m19.6 18.7-.4-1"/> <path d="m16.8 12.3-.4-1"/> <path d="m14.3 16.6 1-.4"/> <path d="m20.7 13.8 1-.4"/> </svg>',mail:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="16" x="2" y="4" rx="2"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> </svg>',"circle-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <circle cx="12" cy="12" r="1"/> </svg>',"move-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 8L22 12L18 16"/> <path d="M2 12H22"/> </svg>',"key-round":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.586 17.414A2 2 0 0 0 2 18.828V21a1 1 0 0 0 1 1h3a1 1 0 0 0 1-1v-1a1 1 0 0 1 1-1h1a1 1 0 0 0 1-1v-1a1 1 0 0 1 1-1h.172a2 2 0 0 0 1.414-.586l.814-.814a6.5 6.5 0 1 0-4-4z"/> <circle cx="16.5" cy="7.5" r=".5" fill="currentColor"/> </svg>',"rotate-ccw-square":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 9V7a2 2 0 0 0-2-2h-6"/> <path d="m15 2-3 3 3 3"/> <path d="M20 13v5a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V7a2 2 0 0 1 2-2h2"/> </svg>',tornado:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 4H3"/> <path d="M18 8H6"/> <path d="M19 12H9"/> <path d="M16 16h-6"/> <path d="M11 20H9"/> </svg>',"square-pen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-7"/> <path d="M18.375 2.625a1 1 0 0 1 3 3l-9.013 9.014a2 2 0 0 1-.853.505l-2.873.84a.5.5 0 0 1-.62-.62l.84-2.873a2 2 0 0 1 .506-.852z"/> </svg>',waypoints:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="4.5" r="2.5"/> <path d="m10.2 6.3-3.9 3.9"/> <circle cx="4.5" cy="12" r="2.5"/> <path d="M7 12h10"/> <circle cx="19.5" cy="12" r="2.5"/> <path d="m13.8 17.7 3.9-3.9"/> <circle cx="12" cy="19.5" r="2.5"/> </svg>',"unfold-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 12h6"/> <path d="M8 12H2"/> <path d="M12 2v2"/> <path d="M12 8v2"/> <path d="M12 14v2"/> <path d="M12 20v2"/> <path d="m19 15 3-3-3-3"/> <path d="m5 9-3 3 3 3"/> </svg>',"bluetooth-searching":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 7 10 10-5 5V2l5 5L7 17"/> <path d="M20.83 14.83a4 4 0 0 0 0-5.66"/> <path d="M18 12h.01"/> </svg>',orbit:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="3"/> <circle cx="19" cy="5" r="2"/> <circle cx="5" cy="19" r="2"/> <path d="M10.4 21.9a10 10 0 0 0 9.941-15.416"/> <path d="M13.5 2.1a10 10 0 0 0-9.841 15.416"/> </svg>',"mouse-pointer-click":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 4.1 12 6"/> <path d="m5.1 8-2.9-.8"/> <path d="m6 12-1.9 2"/> <path d="M7.2 2.2 8 5.1"/> <path d="M9.037 9.69a.498.498 0 0 1 .653-.653l11 4.5a.5.5 0 0 1-.074.949l-4.349 1.041a1 1 0 0 0-.74.739l-1.04 4.35a.5.5 0 0 1-.95.074z"/> </svg>',"signal-high":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 20h.01"/> <path d="M7 20v-4"/> <path d="M12 20v-8"/> <path d="M17 20V8"/> </svg>',"music-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="8" cy="18" r="4"/> <path d="M12 18V2l7 4"/> </svg>',"file-symlink":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m10 18 3-3-3-3"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M4 11V4a2 2 0 0 1 2-2h9l5 5v13a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2v-3a2 2 0 0 1 2-2h7"/> </svg>',"lamp-desk":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14 5-3 3 2 7 8-8-7-2Z"/> <path d="m14 5-3 3-3-3 3-3 3 3Z"/> <path d="M9.5 6.5 4 12l3 6"/> <path d="M3 22v-2c0-1.1.9-2 2-2h4a2 2 0 0 1 2 2v2H3Z"/> </svg>',diff:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3v14"/> <path d="M5 10h14"/> <path d="M5 21h14"/> </svg>',ribbon:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 11.22C11 9.997 10 9 10 8a2 2 0 0 1 4 0c0 1-.998 2.002-2.01 3.22"/> <path d="m12 18 2.57-3.5"/> <path d="M6.243 9.016a7 7 0 0 1 11.507-.009"/> <path d="M9.35 14.53 12 11.22"/> <path d="M9.35 14.53C7.728 12.246 6 10.221 6 7a6 5 0 0 1 12 0c-.005 3.22-1.778 5.235-3.43 7.5l3.557 4.527a1 1 0 0 1-.203 1.43l-1.894 1.36a1 1 0 0 1-1.384-.215L12 18l-2.679 3.593a1 1 0 0 1-1.39.213l-1.865-1.353a1 1 0 0 1-.203-1.422z"/> </svg>',"folder-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18" cy="18" r="3"/> <path d="M10.3 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v3.3"/> <path d="m21.7 19.4-.9-.3"/> <path d="m15.2 16.9-.9-.3"/> <path d="m16.6 21.7.3-.9"/> <path d="m19.1 15.2.3-.9"/> <path d="m19.6 21.7-.4-1"/> <path d="m16.8 15.3-.4-1"/> <path d="m14.3 19.6 1-.4"/> <path d="m20.7 16.8 1-.4"/> </svg>',"save-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 13H8a1 1 0 0 0-1 1v7"/> <path d="M14 8h1"/> <path d="M17 21v-4"/> <path d="m2 2 20 20"/> <path d="M20.41 20.41A2 2 0 0 1 19 21H5a2 2 0 0 1-2-2V5a2 2 0 0 1 .59-1.41"/> <path d="M29.5 11.5s5 5 4 5"/> <path d="M9 3h6.2a2 2 0 0 1 1.4.6l3.8 3.8a2 2 0 0 1 .6 1.4V15"/> </svg>',rainbow:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 17a10 10 0 0 0-20 0"/> <path d="M6 17a6 6 0 0 1 12 0"/> <path d="M10 17a2 2 0 0 1 4 0"/> </svg>',"align-vertical-justify-center":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="6" x="5" y="16" rx="2"/> <rect width="10" height="6" x="7" y="2" rx="2"/> <path d="M2 12h20"/> </svg>',album:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <polyline points="11 3 11 11 14 8 17 11 17 3"/> </svg>',headset:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 11h3a2 2 0 0 1 2 2v3a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-5Zm0 0a9 9 0 1 1 18 0m0 0v5a2 2 0 0 1-2 2h-1a2 2 0 0 1-2-2v-3a2 2 0 0 1 2-2h3Z"/> <path d="M21 16v2a4 4 0 0 1-4 4h-5"/> </svg>',wrench:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.7 6.3a1 1 0 0 0 0 1.4l1.6 1.6a1 1 0 0 0 1.4 0l3.77-3.77a6 6 0 0 1-7.94 7.94l-6.91 6.91a2.12 2.12 0 0 1-3-3l6.91-6.91a6 6 0 0 1 7.94-7.94l-3.76 3.76z"/> </svg>',pencil:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.174 6.812a1 1 0 0 0-3.986-3.987L3.842 16.174a2 2 0 0 0-.5.83l-1.321 4.352a.5.5 0 0 0 .623.622l4.353-1.32a2 2 0 0 0 .83-.497z"/> <path d="m15 5 4 4"/> </svg>',"layout-list":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="7" x="3" y="3" rx="1"/> <rect width="7" height="7" x="3" y="14" rx="1"/> <path d="M14 4h7"/> <path d="M14 9h7"/> <path d="M14 15h7"/> <path d="M14 20h7"/> </svg>',"calendar-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <path d="M21 13V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h8"/> <path d="M3 10h18"/> <path d="M16 19h6"/> <path d="M19 16v6"/> </svg>',"case-sensitive":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 15 4-8 4 8"/> <path d="M4 13h6"/> <circle cx="18" cy="12" r="3"/> <path d="M21 9v6"/> </svg>',"file-pen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.5 22H18a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v9.5"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M13.378 15.626a1 1 0 1 0-3.004-3.004l-5.01 5.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> </svg>',"corner-right-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="10 9 15 4 20 9"/> <path d="M4 20h7a4 4 0 0 0 4-4V4"/> </svg>',"message-square-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="m14.5 7.5-5 5"/> <path d="m9.5 7.5 5 5"/> </svg>',"arrow-down-to-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17V3"/> <path d="m6 11 6 6 6-6"/> <path d="M19 21H5"/> </svg>',"door-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 4h3a2 2 0 0 1 2 2v14"/> <path d="M2 20h3"/> <path d="M13 20h9"/> <path d="M10 12v.01"/> <path d="M13 4.562v16.157a1 1 0 0 1-1.242.97L5 20V5.562a2 2 0 0 1 1.515-1.94l4-1A2 2 0 0 1 13 4.561Z"/> </svg>',"a-arrow-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.5 13h6"/> <path d="m2 16 4.5-9 4.5 9"/> <path d="M18 7v9"/> <path d="m14 12 4 4 4-4"/> </svg>',"badge-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <line x1="12" x2="12" y1="8" y2="16"/> <line x1="8" x2="16" y1="12" y2="12"/> </svg>',"file-key":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <circle cx="10" cy="16" r="2"/> <path d="m16 10-4.5 4.5"/> <path d="m15 11 1 1"/> </svg>',"phone-outgoing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="22 8 22 2 16 2"/> <line x1="16" x2="22" y1="8" y2="2"/> <path d="M22 16.92v3a2 2 0 0 1-2.18 2 19.79 19.79 0 0 1-8.63-3.07 19.5 19.5 0 0 1-6-6 19.79 19.79 0 0 1-3.07-8.67A2 2 0 0 1 4.11 2h3a2 2 0 0 1 2 1.72 12.84 12.84 0 0 0 .7 2.81 2 2 0 0 1-.45 2.11L8.09 9.91a16 16 0 0 0 6 6l1.27-1.27a2 2 0 0 1 2.11-.45 12.84 12.84 0 0 0 2.81.7A2 2 0 0 1 22 16.92z"/> </svg>',"shield-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="M9 12h6"/> </svg>',cctv:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16.75 12h3.632a1 1 0 0 1 .894 1.447l-2.034 4.069a1 1 0 0 1-1.708.134l-2.124-2.97"/> <path d="M17.106 9.053a1 1 0 0 1 .447 1.341l-3.106 6.211a1 1 0 0 1-1.342.447L3.61 12.3a2.92 2.92 0 0 1-1.3-3.91L3.69 5.6a2.92 2.92 0 0 1 3.92-1.3z"/> <path d="M2 19h3.76a2 2 0 0 0 1.8-1.1L9 15"/> <path d="M2 21v-4"/> <path d="M7 9h.01"/> </svg>',"heading-4":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 12h8"/> <path d="M4 18V6"/> <path d="M12 18V6"/> <path d="M17 10v4h4"/> <path d="M21 10v8"/> </svg>',battery:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="10" x="2" y="7" rx="2" ry="2"/> <line x1="22" x2="22" y1="11" y2="13"/> </svg>',"circle-equal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 10h10"/> <path d="M7 14h10"/> <circle cx="12" cy="12" r="10"/> </svg>',"venetian-mask":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12a5 5 0 0 0 5 5 8 8 0 0 1 5 2 8 8 0 0 1 5-2 5 5 0 0 0 5-5V7h-5a8 8 0 0 0-5 2 8 8 0 0 0-5-2H2Z"/> <path d="M6 11c1.5 0 3 .5 3 2-2 0-3 0-3-2Z"/> <path d="M18 11c-1.5 0-3 .5-3 2 2 0 3 0 3-2Z"/> </svg>',"circle-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m9 12 2 2 4-4"/> </svg>',"align-center-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v20"/> <path d="M8 10H4a2 2 0 0 1-2-2V6c0-1.1.9-2 2-2h4"/> <path d="M16 10h4a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2h-4"/> <path d="M8 20H7a2 2 0 0 1-2-2v-2c0-1.1.9-2 2-2h1"/> <path d="M16 14h1a2 2 0 0 1 2 2v2a2 2 0 0 1-2 2h-1"/> </svg>',scissors:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="6" cy="6" r="3"/> <path d="M8.12 8.12 12 12"/> <path d="M20 4 8.12 15.88"/> <circle cx="6" cy="18" r="3"/> <path d="M14.8 14.8 20 20"/> </svg>',lock:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="11" x="3" y="11" rx="2" ry="2"/> <path d="M7 11V7a5 5 0 0 1 10 0v4"/> </svg>',"chart-no-axes-column-decreasing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20V10"/> <path d="M18 20v-4"/> <path d="M6 20V4"/> </svg>',"circle-chevron-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m14 16-4-4 4-4"/> </svg>',"align-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="21" x2="3" y1="6" y2="6"/> <line x1="15" x2="3" y1="12" y2="12"/> <line x1="17" x2="3" y1="18" y2="18"/> </svg>',"undo-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 14 4 9l5-5"/> <path d="M4 9h10.5a5.5 5.5 0 0 1 5.5 5.5a5.5 5.5 0 0 1-5.5 5.5H11"/> </svg>',"megaphone-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9.26 9.26 3 11v3l14.14 3.14"/> <path d="M21 15.34V6l-7.31 2.03"/> <path d="M11.6 16.8a3 3 0 1 1-5.8-1.6"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',upload:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15v4a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-4"/> <polyline points="17 8 12 3 7 8"/> <line x1="12" x2="12" y1="3" y2="15"/> </svg>',tablets:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="7" cy="7" r="5"/> <circle cx="17" cy="17" r="5"/> <path d="M12 17h10"/> <path d="m3.46 10.54 7.08-7.08"/> </svg>',"key-square":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.4 2.7a2.5 2.5 0 0 1 3.4 0l5.5 5.5a2.5 2.5 0 0 1 0 3.4l-3.7 3.7a2.5 2.5 0 0 1-3.4 0L8.7 9.8a2.5 2.5 0 0 1 0-3.4z"/> <path d="m14 7 3 3"/> <path d="m9.4 10.6-6.814 6.814A2 2 0 0 0 2 18.828V21a1 1 0 0 0 1 1h3a1 1 0 0 0 1-1v-1a1 1 0 0 1 1-1h1a1 1 0 0 0 1-1v-1a1 1 0 0 1 1-1h.172a2 2 0 0 0 1.414-.586l.814-.814"/> </svg>',"image-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.3 21H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v10l-3.1-3.1a2 2 0 0 0-2.814.014L6 21"/> <path d="m14 19.5 3-3 3 3"/> <path d="M17 22v-5.5"/> <circle cx="9" cy="9" r="2"/> </svg>',"circle-divide":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="8" x2="16" y1="12" y2="12"/> <line x1="12" x2="12" y1="16" y2="16"/> <line x1="12" x2="12" y1="8" y2="8"/> <circle cx="12" cy="12" r="10"/> </svg>',"calendar-x-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <path d="M21 13V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h8"/> <path d="M3 10h18"/> <path d="m17 22 5-5"/> <path d="m17 17 5 5"/> </svg>',contrast:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M12 18a6 6 0 0 0 0-12v12z"/> </svg>',bath:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 6 6.5 3.5a1.5 1.5 0 0 0-1-.5C4.683 3 4 3.683 4 4.5V17a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2v-5"/> <line x1="10" x2="8" y1="5" y2="7"/> <line x1="2" x2="22" y1="12" y2="12"/> <line x1="7" x2="7" y1="19" y2="21"/> <line x1="17" x2="17" y1="19" y2="21"/> </svg>',"arrow-big-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 18v-6H5l7-7 7 7h-4v6H9z"/> </svg>',"wifi-high":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20h.01"/> <path d="M5 12.859a10 10 0 0 1 14 0"/> <path d="M8.5 16.429a5 5 0 0 1 7 0"/> </svg>',"message-circle-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20.5 14.9A9 9 0 0 0 9.1 3.5"/> <path d="m2 2 20 20"/> <path d="M5.6 5.6C3 8.3 2.2 12.5 4 16l-2 6 6-2c3.4 1.8 7.6 1.1 10.3-1.7"/> </svg>',"file-video":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m10 11 5 3-5 3v-6Z"/> </svg>',"file-badge":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22h6a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v3"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M5 17a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"/> <path d="M7 16.5 8 22l-3-1-3 1 1-5.5"/> </svg>',"rows-4":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M21 7.5H3"/> <path d="M21 12H3"/> <path d="M21 16.5H3"/> </svg>',"axis-3d":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 4v16h16"/> <path d="m4 20 7-7"/> </svg>',speaker:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="20" x="4" y="2" rx="2"/> <path d="M12 6h.01"/> <circle cx="12" cy="14" r="4"/> <path d="M12 14h.01"/> </svg>',wand:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 4V2"/> <path d="M15 16v-2"/> <path d="M8 9h2"/> <path d="M20 9h2"/> <path d="M17.8 11.8 19 13"/> <path d="M15 9h.01"/> <path d="M17.8 6.2 19 5"/> <path d="m3 21 9-9"/> <path d="M12.2 6.2 11 5"/> </svg>',slice:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m8 14-6 6h9v-3"/> <path d="M18.37 3.63 8 14l3 3L21.37 6.63a2.12 2.12 0 1 0-3-3Z"/> </svg>',"refresh-cw":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 12a9 9 0 0 1 9-9 9.75 9.75 0 0 1 6.74 2.74L21 8"/> <path d="M21 3v5h-5"/> <path d="M21 12a9 9 0 0 1-9 9 9.75 9.75 0 0 1-6.74-2.74L3 16"/> <path d="M8 16H3v5"/> </svg>',"rotate-3d":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16.466 7.5C15.643 4.237 13.952 2 12 2 9.239 2 7 6.477 7 12s2.239 10 5 10c.342 0 .677-.069 1-.2"/> <path d="m15.194 13.707 3.814 1.86-1.86 3.814"/> <path d="M19 15.57c-1.804.885-4.274 1.43-7 1.43-5.523 0-10-2.239-10-5s4.477-5 10-5c4.838 0 8.873 1.718 9.8 4"/> </svg>',"unfold-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22v-6"/> <path d="M12 8V2"/> <path d="M4 12H2"/> <path d="M10 12H8"/> <path d="M16 12h-2"/> <path d="M22 12h-2"/> <path d="m15 19-3 3-3-3"/> <path d="m15 5-3-3-3 3"/> </svg>',accessibility:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="16" cy="4" r="1"/> <path d="m18 19 1-7-6 1"/> <path d="m5 8 3-3 5.5 3-2.36 3.5"/> <path d="M4.24 14.5a5 5 0 0 0 6.88 6"/> <path d="M13.76 17.5a5 5 0 0 0-6.88-6"/> </svg>',"cassette-tape":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="16" x="2" y="4" rx="2"/> <circle cx="8" cy="10" r="2"/> <path d="M8 12h8"/> <circle cx="16" cy="10" r="2"/> <path d="m6 20 .7-2.9A1.4 1.4 0 0 1 8.1 16h7.8a1.4 1.4 0 0 1 1.4 1l.7 3"/> </svg>',"message-circle-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.5 3.1c-.5 0-1-.1-1.5-.1s-1 .1-1.5.1"/> <path d="M19.3 6.8a10.45 10.45 0 0 0-2.1-2.1"/> <path d="M20.9 13.5c.1-.5.1-1 .1-1.5s-.1-1-.1-1.5"/> <path d="M17.2 19.3a10.45 10.45 0 0 0 2.1-2.1"/> <path d="M10.5 20.9c.5.1 1 .1 1.5.1s1-.1 1.5-.1"/> <path d="M3.5 17.5 2 22l4.5-1.5"/> <path d="M3.1 10.5c0 .5-.1 1-.1 1.5s.1 1 .1 1.5"/> <path d="M6.8 4.7a10.45 10.45 0 0 0-2.1 2.1"/> </svg>',"chart-spline":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M7 16c.5-2 1.5-7 4-7 2 0 2 3 4 3 2.5 0 4.5-5 5-7"/> </svg>',"bus-front":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 6 2 7"/> <path d="M10 6h4"/> <path d="m22 7-2-1"/> <rect width="16" height="16" x="4" y="3" rx="2"/> <path d="M4 11h16"/> <path d="M8 15h.01"/> <path d="M16 15h.01"/> <path d="M6 19v2"/> <path d="M18 21v-2"/> </svg>',"circle-pause":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <line x1="10" x2="10" y1="15" y2="9"/> <line x1="14" x2="14" y1="15" y2="9"/> </svg>',receipt:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M16 8h-6a2 2 0 1 0 0 4h4a2 2 0 1 1 0 4H8"/> <path d="M12 17.5v-11"/> </svg>',text:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 6.1H3"/> <path d="M21 12.1H3"/> <path d="M15.1 18H3"/> </svg>',"circle-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 2 20 20"/> <path d="M8.35 2.69A10 10 0 0 1 21.3 15.65"/> <path d="M19.08 19.08A10 10 0 1 1 4.92 4.92"/> </svg>',"message-circle-reply":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> <path d="m10 15-3-3 3-3"/> <path d="M7 12h7a2 2 0 0 1 2 2v1"/> </svg>',"clipboard-paste":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H9a1 1 0 0 0-1 1v2c0 .6.4 1 1 1h6c.6 0 1-.4 1-1V3c0-.6-.4-1-1-1Z"/> <path d="M8 4H6a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2M16 4h2a2 2 0 0 1 2 2v2M11 14h10"/> <path d="m17 10 4 4-4 4"/> </svg>',"book-image":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m20 13.7-2.1-2.1a2 2 0 0 0-2.8 0L9.7 17"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <circle cx="10" cy="8" r="2"/> </svg>',"skip-back":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="19 20 9 12 19 4 19 20"/> <line x1="5" x2="5" y1="19" y2="5"/> </svg>',kanban:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 5v11"/> <path d="M12 5v6"/> <path d="M18 5v14"/> </svg>',"layout-grid":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="7" x="3" y="3" rx="1"/> <rect width="7" height="7" x="14" y="3" rx="1"/> <rect width="7" height="7" x="14" y="14" rx="1"/> <rect width="7" height="7" x="3" y="14" rx="1"/> </svg>',dumbbell:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.4 14.4 9.6 9.6"/> <path d="M18.657 21.485a2 2 0 1 1-2.829-2.828l-1.767 1.768a2 2 0 1 1-2.829-2.829l6.364-6.364a2 2 0 1 1 2.829 2.829l-1.768 1.767a2 2 0 1 1 2.828 2.829z"/> <path d="m21.5 21.5-1.4-1.4"/> <path d="M3.9 3.9 2.5 2.5"/> <path d="M6.404 12.768a2 2 0 1 1-2.829-2.829l1.768-1.767a2 2 0 1 1-2.828-2.829l2.828-2.828a2 2 0 1 1 2.829 2.828l1.767-1.768a2 2 0 1 1 2.829 2.829z"/> </svg>',omega:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 20h4.5a.5.5 0 0 0 .5-.5v-.282a.52.52 0 0 0-.247-.437 8 8 0 1 1 8.494-.001.52.52 0 0 0-.247.438v.282a.5.5 0 0 0 .5.5H21"/> </svg>',"log-out":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 21H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h4"/> <polyline points="16 17 21 12 16 7"/> <line x1="21" x2="9" y1="12" y2="12"/> </svg>',trees:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 10v.2A3 3 0 0 1 8.9 16H5a3 3 0 0 1-1-5.8V10a3 3 0 0 1 6 0Z"/> <path d="M7 16v6"/> <path d="M13 19v3"/> <path d="M12 19h8.3a1 1 0 0 0 .7-1.7L18 14h.3a1 1 0 0 0 .7-1.7L16 9h.2a1 1 0 0 0 .8-1.7L13 3l-1.4 1.5"/> </svg>',container:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 7.7c0-.6-.4-1.2-.8-1.5l-6.3-3.9a1.72 1.72 0 0 0-1.7 0l-10.3 6c-.5.2-.9.8-.9 1.4v6.6c0 .5.4 1.2.8 1.5l6.3 3.9a1.72 1.72 0 0 0 1.7 0l10.3-6c.5-.3.9-1 .9-1.5Z"/> <path d="M10 21.9V14L2.1 9.1"/> <path d="m10 14 11.9-6.9"/> <path d="M14 19.8v-8.1"/> <path d="M18 17.5V9.4"/> </svg>',"dice-6":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="M16 8h.01"/> <path d="M16 12h.01"/> <path d="M16 16h.01"/> <path d="M8 8h.01"/> <path d="M8 12h.01"/> <path d="M8 16h.01"/> </svg>',undo:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7v6h6"/> <path d="M21 17a9 9 0 0 0-9-9 9 9 0 0 0-6 2.3L3 13"/> </svg>',figma:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 5.5A3.5 3.5 0 0 1 8.5 2H12v7H8.5A3.5 3.5 0 0 1 5 5.5z"/> <path d="M12 2h3.5a3.5 3.5 0 1 1 0 7H12V2z"/> <path d="M12 12.5a3.5 3.5 0 1 1 7 0 3.5 3.5 0 1 1-7 0z"/> <path d="M5 19.5A3.5 3.5 0 0 1 8.5 16H12v3.5a3.5 3.5 0 1 1-7 0z"/> <path d="M5 12.5A3.5 3.5 0 0 1 8.5 9H12v7H8.5A3.5 3.5 0 0 1 5 12.5z"/> </svg>',"corner-up-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="9 14 4 9 9 4"/> <path d="M20 20v-7a4 4 0 0 0-4-4H4"/> </svg>',"calendar-clock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 7.5V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h3.5"/> <path d="M16 2v4"/> <path d="M8 2v4"/> <path d="M3 10h5"/> <path d="M17.5 17.5 16 16.3V14"/> <circle cx="16" cy="16" r="6"/> </svg>',"book-key":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 3 1 1"/> <path d="m20 2-4.5 4.5"/> <path d="M20 8v13a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H14"/> <circle cx="14" cy="8" r="2"/> </svg>',"ice-cream-bowl":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17c5 0 8-2.69 8-6H4c0 3.31 3 6 8 6m-4 4h8m-4-3v3M5.14 11a3.5 3.5 0 1 1 6.71 0"/> <path d="M12.14 11a3.5 3.5 0 1 1 6.71 0"/> <path d="M15.5 6.5a3.5 3.5 0 1 0-7 0"/> </svg>',"calendar-minus-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <rect width="18" height="18" x="3" y="4" rx="2"/> <path d="M3 10h18"/> <path d="M10 16h4"/> </svg>',"square-asterisk":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M12 8v8"/> <path d="m8.5 14 7-4"/> <path d="m8.5 10 7 4"/> </svg>',"tower-control":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18.2 12.27 20 6H4l1.8 6.27a1 1 0 0 0 .95.73h10.5a1 1 0 0 0 .96-.73Z"/> <path d="M8 13v9"/> <path d="M16 22v-9"/> <path d="m9 6 1 7"/> <path d="m15 6-1 7"/> <path d="M12 6V2"/> <path d="M13 2h-2"/> </svg>',"book-a":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="m8 13 4-7 4 7"/> <path d="M9.1 11h5.7"/> </svg>',bone:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 10c.7-.7 1.69 0 2.5 0a2.5 2.5 0 1 0 0-5 .5.5 0 0 1-.5-.5 2.5 2.5 0 1 0-5 0c0 .81.7 1.8 0 2.5l-7 7c-.7.7-1.69 0-2.5 0a2.5 2.5 0 0 0 0 5c.28 0 .5.22.5.5a2.5 2.5 0 1 0 5 0c0-.81-.7-1.8 0-2.5Z"/> </svg>',redo:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 7v6h-6"/> <path d="M3 17a9 9 0 0 1 9-9 9 9 0 0 1 6 2.3l3 2.7"/> </svg>',subscript:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m4 5 8 8"/> <path d="m12 5-8 8"/> <path d="M20 19h-4c0-1.5.44-2 1.5-2.5S20 15.33 20 14c0-.47-.17-.93-.48-1.29a2.11 2.11 0 0 0-2.62-.44c-.42.24-.74.62-.9 1.07"/> </svg>',"clock-12":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12"/> </svg>',trello:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <rect width="3" height="9" x="7" y="7"/> <rect width="3" height="5" x="14" y="7"/> </svg>',compass:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16.24 7.76-1.804 5.411a2 2 0 0 1-1.265 1.265L7.76 16.24l1.804-5.411a2 2 0 0 1 1.265-1.265z"/> <circle cx="12" cy="12" r="10"/> </svg>',"reply-all":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="7 17 2 12 7 7"/> <polyline points="12 17 7 12 12 7"/> <path d="M22 18v-2a4 4 0 0 0-4-4H7"/> </svg>',"navigation-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="12 2 19 21 12 17 5 21 12 2"/> </svg>',"file-check-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m3 15 2 2 4-4"/> </svg>',"tally-4":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 4v16"/> <path d="M9 4v16"/> <path d="M14 4v16"/> <path d="M19 4v16"/> </svg>',strikethrough:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 4H9a3 3 0 0 0-2.83 4"/> <path d="M14 12a4 4 0 0 1 0 8H6"/> <line x1="4" x2="20" y1="12" y2="12"/> </svg>',"square-power":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 7v4"/> <path d="M7.998 9.003a5 5 0 1 0 8-.005"/> <rect x="3" y="3" width="18" height="18" rx="2"/> </svg>',"at-sign":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="4"/> <path d="M16 8v5a3 3 0 0 0 6 0v-1a10 10 0 1 0-4 8"/> </svg>',"folder-sync":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v.5"/> <path d="M12 10v4h4"/> <path d="m12 14 1.535-1.605a5 5 0 0 1 8 1.5"/> <path d="M22 22v-4h-4"/> <path d="m22 18-1.535 1.605a5 5 0 0 1-8-1.5"/> </svg>',"ticket-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9a3 3 0 0 1 0 6v2a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2a3 3 0 0 1 0-6V7a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="M9 12h6"/> <path d="M12 9v6"/> </svg>',"circle-dot-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.1 2.18a9.93 9.93 0 0 1 3.8 0"/> <path d="M17.6 3.71a9.95 9.95 0 0 1 2.69 2.7"/> <path d="M21.82 10.1a9.93 9.93 0 0 1 0 3.8"/> <path d="M20.29 17.6a9.95 9.95 0 0 1-2.7 2.69"/> <path d="M13.9 21.82a9.94 9.94 0 0 1-3.8 0"/> <path d="M6.4 20.29a9.95 9.95 0 0 1-2.69-2.7"/> <path d="M2.18 13.9a9.93 9.93 0 0 1 0-3.8"/> <path d="M3.71 6.4a9.95 9.95 0 0 1 2.7-2.69"/> <circle cx="12" cy="12" r="1"/> </svg>',donut:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20.5 10a2.5 2.5 0 0 1-2.4-3H18a2.95 2.95 0 0 1-2.6-4.4 10 10 0 1 0 6.3 7.1c-.3.2-.8.3-1.2.3"/> <circle cx="12" cy="12" r="3"/> </svg>',"file-spreadsheet":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M8 13h2"/> <path d="M14 13h2"/> <path d="M8 17h2"/> <path d="M14 17h2"/> </svg>',"panel-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 3v18"/> </svg>',"hard-drive-download":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v8"/> <path d="m16 6-4 4-4-4"/> <rect width="20" height="8" x="2" y="14" rx="2"/> <path d="M6 18h.01"/> <path d="M10 18h.01"/> </svg>',"dice-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="M12 12h.01"/> </svg>',"book-audio":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 6v7"/> <path d="M16 8v3"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M8 8v3"/> </svg>',"building-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 22V4a2 2 0 0 1 2-2h8a2 2 0 0 1 2 2v18Z"/> <path d="M6 12H4a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h2"/> <path d="M18 9h2a2 2 0 0 1 2 2v9a2 2 0 0 1-2 2h-2"/> <path d="M10 6h4"/> <path d="M10 10h4"/> <path d="M10 14h4"/> <path d="M10 18h4"/> </svg>',clipboard:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2h2"/> </svg>',mouse:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="5" y="2" width="14" height="20" rx="7"/> <path d="M12 6v4"/> </svg>',"text-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 6H3"/> <path d="M10 12H3"/> <path d="M10 18H3"/> <circle cx="17" cy="15" r="3"/> <path d="m21 19-1.9-1.9"/> </svg>',"file-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m3.2 12.9-.9-.4"/> <path d="m3.2 15.1-.9.4"/> <path d="M4.677 21.5a2 2 0 0 0 1.313.5H18a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v2.5"/> <path d="m4.9 11.2-.4-.9"/> <path d="m4.9 16.8-.4.9"/> <path d="m7.5 10.3-.4.9"/> <path d="m7.5 17.7-.4-.9"/> <path d="m9.7 12.5-.9.4"/> <path d="m9.7 15.5-.9-.4"/> <circle cx="6" cy="14" r="3"/> </svg>',underline:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 4v6a6 6 0 0 0 12 0V4"/> <line x1="4" x2="20" y1="20" y2="20"/> </svg>',"disc-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M6 12c0-1.7.7-3.2 1.8-4.2"/> <circle cx="12" cy="12" r="2"/> <path d="M18 12c0 1.7-.7 3.2-1.8 4.2"/> </svg>',"panel-bottom-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 15h18"/> <path d="m9 10 3-3 3 3"/> </svg>',"panels-top-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 9h18"/> <path d="M9 21V9"/> </svg>',sword:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="14.5 17.5 3 6 3 3 6 3 17.5 14.5"/> <line x1="13" x2="19" y1="19" y2="13"/> <line x1="16" x2="20" y1="16" y2="20"/> <line x1="19" x2="21" y1="21" y2="19"/> </svg>',"thumbs-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 10v12"/> <path d="M15 5.88 14 10h5.83a2 2 0 0 1 1.92 2.56l-2.33 8A2 2 0 0 1 17.5 22H4a2 2 0 0 1-2-2v-8a2 2 0 0 1 2-2h2.76a2 2 0 0 0 1.79-1.11L12 2a3.13 3.13 0 0 1 3 3.88Z"/> </svg>',"panel-left-close":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 3v18"/> <path d="m16 15-3-3 3-3"/> </svg>',"bluetooth-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m17 17-5 5V12l-5 5"/> <path d="m2 2 20 20"/> <path d="M14.5 9.5 17 7l-5-5v4.5"/> </svg>',"wifi-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20h.01"/> <path d="M8.5 16.429a5 5 0 0 1 7 0"/> <path d="M5 12.859a10 10 0 0 1 5.17-2.69"/> <path d="M19 12.859a10 10 0 0 0-2.007-1.523"/> <path d="M2 8.82a15 15 0 0 1 4.177-2.643"/> <path d="M22 8.82a15 15 0 0 0-11.288-3.764"/> <path d="m2 2 20 20"/> </svg>',"file-chart-pie":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M16 22h2a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v3.5"/> <path d="M4.017 11.512a6 6 0 1 0 8.466 8.475"/> <path d="M9 16a1 1 0 0 1-1-1v-4c0-.552.45-1.008.995-.917a6 6 0 0 1 4.922 4.922c.091.544-.365.995-.917.995z"/> </svg>',"pocket-knife":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 2v1c0 1 2 1 2 2S3 6 3 7s2 1 2 2-2 1-2 2 2 1 2 2"/> <path d="M18 6h.01"/> <path d="M6 18h.01"/> <path d="M20.83 8.83a4 4 0 0 0-5.66-5.66l-12 12a4 4 0 1 0 5.66 5.66Z"/> <path d="M18 11.66V22a4 4 0 0 0 4-4V6"/> </svg>',ratio:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="12" height="20" x="6" y="2" rx="2"/> <rect width="20" height="12" x="2" y="6" rx="2"/> </svg>',"a-large-small":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 14h-5"/> <path d="M16 16v-3.5a2.5 2.5 0 0 1 5 0V16"/> <path d="M4.5 13h6"/> <path d="m3 16 4.5-9 4.5 9"/> </svg>',"grid-2x2-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3v17a1 1 0 0 1-1 1H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v6a1 1 0 0 1-1 1H3"/> <path d="m16 16 5 5"/> <path d="m16 21 5-5"/> </svg>',"chevrons-right-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m20 17-5-5 5-5"/> <path d="m4 17 5-5-5-5"/> </svg>',"trending-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="22 7 13.5 15.5 8.5 10.5 2 17"/> <polyline points="16 7 22 7 22 13"/> </svg>',"timer-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2h4"/> <path d="M4.6 11a8 8 0 0 0 1.7 8.7 8 8 0 0 0 8.7 1.7"/> <path d="M7.4 7.4a8 8 0 0 1 10.3 1 8 8 0 0 1 .9 10.2"/> <path d="m2 2 20 20"/> <path d="M12 12v-2"/> </svg>',save:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.2 3a2 2 0 0 1 1.4.6l3.8 3.8a2 2 0 0 1 .6 1.4V19a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2z"/> <path d="M17 21v-7a1 1 0 0 0-1-1H8a1 1 0 0 0-1 1v7"/> <path d="M7 3v4a1 1 0 0 0 1 1h7"/> </svg>',"arrow-down-1-0":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 16 4 4 4-4"/> <path d="M7 20V4"/> <path d="M17 10V4h-2"/> <path d="M15 10h4"/> <rect x="15" y="14" width="4" height="6" ry="2"/> </svg>',"octagon-alert":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 16h.01"/> <path d="M12 8v4"/> <path d="M15.312 2a2 2 0 0 1 1.414.586l4.688 4.688A2 2 0 0 1 22 8.688v6.624a2 2 0 0 1-.586 1.414l-4.688 4.688a2 2 0 0 1-1.414.586H8.688a2 2 0 0 1-1.414-.586l-4.688-4.688A2 2 0 0 1 2 15.312V8.688a2 2 0 0 1 .586-1.414l4.688-4.688A2 2 0 0 1 8.688 2z"/> </svg>',"rocking-chair":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="3.5 2 6.5 12.5 18 12.5"/> <line x1="9.5" x2="5.5" y1="12.5" y2="20"/> <line x1="15" x2="18.5" y1="12.5" y2="20"/> <path d="M2.75 18a13 13 0 0 0 18.5 0"/> </svg>',settings:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.22 2h-.44a2 2 0 0 0-2 2v.18a2 2 0 0 1-1 1.73l-.43.25a2 2 0 0 1-2 0l-.15-.08a2 2 0 0 0-2.73.73l-.22.38a2 2 0 0 0 .73 2.73l.15.1a2 2 0 0 1 1 1.72v.51a2 2 0 0 1-1 1.74l-.15.09a2 2 0 0 0-.73 2.73l.22.38a2 2 0 0 0 2.73.73l.15-.08a2 2 0 0 1 2 0l.43.25a2 2 0 0 1 1 1.73V20a2 2 0 0 0 2 2h.44a2 2 0 0 0 2-2v-.18a2 2 0 0 1 1-1.73l.43-.25a2 2 0 0 1 2 0l.15.08a2 2 0 0 0 2.73-.73l.22-.39a2 2 0 0 0-.73-2.73l-.15-.08a2 2 0 0 1-1-1.74v-.5a2 2 0 0 1 1-1.74l.15-.09a2 2 0 0 0 .73-2.73l-.22-.38a2 2 0 0 0-2.73-.73l-.15.08a2 2 0 0 1-2 0l-.43-.25a2 2 0 0 1-1-1.73V4a2 2 0 0 0-2-2z"/> <circle cx="12" cy="12" r="3"/> </svg>',"folder-heart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v1.5"/> <path d="M13.9 17.45c-1.2-1.2-1.14-2.8-.2-3.73a2.43 2.43 0 0 1 3.44 0l.36.34.34-.34a2.43 2.43 0 0 1 3.45-.01c.95.95 1 2.53-.2 3.74L17.5 21Z"/> </svg>',"cloud-upload":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13v8"/> <path d="M4 14.899A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.242"/> <path d="m8 17 4-4 4 4"/> </svg>',"paw-print":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11" cy="4" r="2"/> <circle cx="18" cy="8" r="2"/> <circle cx="20" cy="16" r="2"/> <path d="M9 10a5 5 0 0 1 5 5v3.5a3.5 3.5 0 0 1-6.84 1.045Q6.52 17.48 4.46 16.84A3.5 3.5 0 0 1 5.5 10Z"/> </svg>',lollipop:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11" cy="11" r="8"/> <path d="m21 21-4.3-4.3"/> <path d="M11 11a2 2 0 0 0 4 0 4 4 0 0 0-8 0 6 6 0 0 0 12 0"/> </svg>',boxes:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.97 12.92A2 2 0 0 0 2 14.63v3.24a2 2 0 0 0 .97 1.71l3 1.8a2 2 0 0 0 2.06 0L12 19v-5.5l-5-3-4.03 2.42Z"/> <path d="m7 16.5-4.74-2.85"/> <path d="m7 16.5 5-3"/> <path d="M7 16.5v5.17"/> <path d="M12 13.5V19l3.97 2.38a2 2 0 0 0 2.06 0l3-1.8a2 2 0 0 0 .97-1.71v-3.24a2 2 0 0 0-.97-1.71L17 10.5l-5 3Z"/> <path d="m17 16.5-5-3"/> <path d="m17 16.5 4.74-2.85"/> <path d="M17 16.5v5.17"/> <path d="M7.97 4.42A2 2 0 0 0 7 6.13v4.37l5 3 5-3V6.13a2 2 0 0 0-.97-1.71l-3-1.8a2 2 0 0 0-2.06 0l-3 1.8Z"/> <path d="M12 8 7.26 5.15"/> <path d="m12 8 4.74-2.85"/> <path d="M12 13.5V8"/> </svg>',"heading-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 12h8"/> <path d="M4 18V6"/> <path d="M12 18V6"/> <path d="m17 12 3-2v8"/> </svg>',"octagon-pause":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 15V9"/> <path d="M14 15V9"/> <path d="M2.586 16.872A2 2 0 0 1 2 15.458V8.542a2 2 0 0 1 .586-1.414l4.542-4.542A2 2 0 0 1 8.542 2h6.916a2 2 0 0 1 1.414.586l4.542 4.542A2 2 0 0 1 22 8.542v6.916a2 2 0 0 1-.586 1.414l-4.542 4.542a2 2 0 0 1-1.414.586H8.542a2 2 0 0 1-1.414-.586z"/> </svg>',"monitor-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9 10 3-3 3 3"/> <path d="M12 13V7"/> <rect width="20" height="14" x="2" y="3" rx="2"/> <path d="M12 17v4"/> <path d="M8 21h8"/> </svg>',"circle-arrow-out-up-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 12A10 10 0 1 1 12 2"/> <path d="M22 2 12 12"/> <path d="M16 2h6v6"/> </svg>',"tv-minimal-play":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 7.75a.75.75 0 0 1 1.142-.638l3.664 2.249a.75.75 0 0 1 0 1.278l-3.664 2.25a.75.75 0 0 1-1.142-.64z"/> <path d="M7 21h10"/> <rect width="20" height="14" x="2" y="3" rx="2"/> </svg>',"between-horizontal-start":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="13" height="7" x="8" y="3" rx="1"/> <path d="m2 9 3 3-3 3"/> <rect width="13" height="7" x="8" y="14" rx="1"/> </svg>',"clock-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 16 10"/> </svg>',chrome:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <circle cx="12" cy="12" r="4"/> <line x1="21.17" x2="12" y1="8" y2="8"/> <line x1="3.95" x2="8.54" y1="6.06" y2="14"/> <line x1="10.88" x2="15.46" y1="21.94" y2="14"/> </svg>',"battery-medium":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="10" x="2" y="7" rx="2" ry="2"/> <line x1="22" x2="22" y1="11" y2="13"/> <line x1="6" x2="6" y1="11" y2="13"/> <line x1="10" x2="10" y1="11" y2="13"/> </svg>',"iteration-ccw":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10c0-4.4-3.6-8-8-8s-8 3.6-8 8 3.6 8 8 8h8"/> <polyline points="16 14 20 18 16 22"/> </svg>',"star-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8.34 8.34 2 9.27l5 4.87L5.82 21 12 17.77 18.18 21l-.59-3.43"/> <path d="M18.42 12.76 22 9.27l-6.91-1L12 2l-1.44 2.91"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"arrow-up-a-z":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 8 4-4 4 4"/> <path d="M7 4v16"/> <path d="M20 8h-5"/> <path d="M15 10V6.5a2.5 2.5 0 0 1 5 0V10"/> <path d="M15 14h5l-5 6h5"/> </svg>',"map-pin-x-inside":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10c0 4.993-5.539 10.193-7.399 11.799a1 1 0 0 1-1.202 0C9.539 20.193 4 14.993 4 10a8 8 0 0 1 16 0"/> <path d="m14.5 7.5-5 5"/> <path d="m9.5 7.5 5 5"/> </svg>',folder:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> </svg>',"rows-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 12h18"/> </svg>',"calendar-check-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <path d="M21 14V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h8"/> <path d="M3 10h18"/> <path d="m16 20 2 2 4-4"/> </svg>',zap:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 14a1 1 0 0 1-.78-1.63l9.9-10.2a.5.5 0 0 1 .86.46l-1.92 6.02A1 1 0 0 0 13 10h7a1 1 0 0 1 .78 1.63l-9.9 10.2a.5.5 0 0 1-.86-.46l1.92-6.02A1 1 0 0 0 11 14z"/> </svg>',"badge-dollar-sign":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M16 8h-6a2 2 0 1 0 0 4h4a2 2 0 1 1 0 4H8"/> <path d="M12 18V6"/> </svg>',"circle-chevron-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m16 10-4 4-4-4"/> </svg>',ship:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 21c.6.5 1.2 1 2.5 1 2.5 0 2.5-2 5-2 1.3 0 1.9.5 2.5 1 .6.5 1.2 1 2.5 1 2.5 0 2.5-2 5-2 1.3 0 1.9.5 2.5 1"/> <path d="M19.38 20A11.6 11.6 0 0 0 21 14l-9-4-9 4c0 2.9.94 5.34 2.81 7.76"/> <path d="M19 13V7a2 2 0 0 0-2-2H7a2 2 0 0 0-2 2v6"/> <path d="M12 10v4"/> <path d="M12 2v3"/> </svg>',globe:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M12 2a14.5 14.5 0 0 0 0 20 14.5 14.5 0 0 0 0-20"/> <path d="M2 12h20"/> </svg>',"plug-zap":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6.3 20.3a2.4 2.4 0 0 0 3.4 0L12 18l-6-6-2.3 2.3a2.4 2.4 0 0 0 0 3.4Z"/> <path d="m2 22 3-3"/> <path d="M7.5 13.5 10 11"/> <path d="M10.5 16.5 13 14"/> <path d="m18 3-4 4h6l-4 4"/> </svg>',highlighter:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9 11-6 6v3h9l3-3"/> <path d="m22 12-4.6 4.6a2 2 0 0 1-2.8 0l-5.2-5.2a2 2 0 0 1 0-2.8L14 4"/> </svg>',"user-pen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11.5 15H7a4 4 0 0 0-4 4v2"/> <path d="M21.378 16.626a1 1 0 0 0-3.004-3.004l-4.01 4.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> <circle cx="10" cy="7" r="4"/> </svg>',info:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M12 16v-4"/> <path d="M12 8h.01"/> </svg>',puzzle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19.439 7.85c-.049.322.059.648.289.878l1.568 1.568c.47.47.706 1.087.706 1.704s-.235 1.233-.706 1.704l-1.611 1.611a.98.98 0 0 1-.837.276c-.47-.07-.802-.48-.968-.925a2.501 2.501 0 1 0-3.214 3.214c.446.166.855.497.925.968a.979.979 0 0 1-.276.837l-1.61 1.61a2.404 2.404 0 0 1-1.705.707 2.402 2.402 0 0 1-1.704-.706l-1.568-1.568a1.026 1.026 0 0 0-.877-.29c-.493.074-.84.504-1.02.968a2.5 2.5 0 1 1-3.237-3.237c.464-.18.894-.527.967-1.02a1.026 1.026 0 0 0-.289-.877l-1.568-1.568A2.402 2.402 0 0 1 1.998 12c0-.617.236-1.234.706-1.704L4.23 8.77c.24-.24.581-.353.917-.303.515.077.877.528 1.073 1.01a2.5 2.5 0 1 0 3.259-3.259c-.482-.196-.933-.558-1.01-1.073-.05-.336.062-.676.303-.917l1.525-1.525A2.402 2.402 0 0 1 12 1.998c.617 0 1.234.236 1.704.706l1.568 1.568c.23.23.556.338.877.29.493-.074.84-.504 1.02-.968a2.5 2.5 0 1 1 3.237 3.237c-.464.18-.894.527-.967 1.02Z"/> </svg>',"roller-coaster":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 19V5"/> <path d="M10 19V6.8"/> <path d="M14 19v-7.8"/> <path d="M18 5v4"/> <path d="M18 19v-6"/> <path d="M22 19V9"/> <path d="M2 19V9a4 4 0 0 1 4-4c2 0 4 1.33 6 4s4 4 6 4a4 4 0 1 0-3-6.65"/> </svg>',"qr-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="5" height="5" x="3" y="3" rx="1"/> <rect width="5" height="5" x="16" y="3" rx="1"/> <rect width="5" height="5" x="3" y="16" rx="1"/> <path d="M21 16h-3a2 2 0 0 0-2 2v3"/> <path d="M21 21v.01"/> <path d="M12 7v3a2 2 0 0 1-2 2H7"/> <path d="M3 12h.01"/> <path d="M12 3h.01"/> <path d="M12 16v.01"/> <path d="M16 12h1"/> <path d="M21 12v.01"/> <path d="M12 21v-1"/> </svg>',"audio-waveform":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 13a2 2 0 0 0 2-2V7a2 2 0 0 1 4 0v13a2 2 0 0 0 4 0V4a2 2 0 0 1 4 0v13a2 2 0 0 0 4 0v-4a2 2 0 0 1 2-2"/> </svg>',lasso:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 22a5 5 0 0 1-2-4"/> <path d="M3.3 14A6.8 6.8 0 0 1 2 10c0-4.4 4.5-8 10-8s10 3.6 10 8-4.5 8-10 8a12 12 0 0 1-5-1"/> <path d="M5 18a2 2 0 1 0 0-4 2 2 0 0 0 0 4z"/> </svg>',"thermometer-sun":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 9a4 4 0 0 0-2 7.5"/> <path d="M12 3v2"/> <path d="m6.6 18.4-1.4 1.4"/> <path d="M20 4v10.54a4 4 0 1 1-4 0V4a2 2 0 0 1 4 0Z"/> <path d="M4 13H2"/> <path d="M6.34 7.34 4.93 5.93"/> </svg>',"lasso-select":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 22a5 5 0 0 1-2-4"/> <path d="M7 16.93c.96.43 1.96.74 2.99.91"/> <path d="M3.34 14A6.8 6.8 0 0 1 2 10c0-4.42 4.48-8 10-8s10 3.58 10 8a7.19 7.19 0 0 1-.33 2"/> <path d="M5 18a2 2 0 1 0 0-4 2 2 0 0 0 0 4z"/> <path d="M14.33 22h-.09a.35.35 0 0 1-.24-.32v-10a.34.34 0 0 1 .33-.34c.08 0 .15.03.21.08l7.34 6a.33.33 0 0 1-.21.59h-4.49l-2.57 3.85a.35.35 0 0 1-.28.14z"/> </svg>',"folder-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 20h16a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.93a2 2 0 0 1-1.66-.9l-.82-1.2A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13c0 1.1.9 2 2 2Z"/> <circle cx="12" cy="13" r="1"/> </svg>',microwave:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="15" x="2" y="4" rx="2"/> <rect width="8" height="7" x="6" y="8" rx="1"/> <path d="M18 8v7"/> <path d="M6 19v2"/> <path d="M18 19v2"/> </svg>',"heart-pulse":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 14c1.49-1.46 3-3.21 3-5.5A5.5 5.5 0 0 0 16.5 3c-1.76 0-3 .5-4.5 2-1.5-1.5-2.74-2-4.5-2A5.5 5.5 0 0 0 2 8.5c0 2.3 1.5 4.05 3 5.5l7 7Z"/> <path d="M3.22 12H9.5l.5-1 2 4.5 2-7 1.5 3.5h5.27"/> </svg>',superscript:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m4 19 8-8"/> <path d="m12 19-8-8"/> <path d="M20 12h-4c0-1.5.442-2 1.5-2.5S20 8.334 20 7.002c0-.472-.17-.93-.484-1.29a2.105 2.105 0 0 0-2.617-.436c-.42.239-.738.614-.899 1.06"/> </svg>',"database-backup":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <ellipse cx="12" cy="5" rx="9" ry="3"/> <path d="M3 12a9 3 0 0 0 5 2.69"/> <path d="M21 9.3V5"/> <path d="M3 5v14a9 3 0 0 0 6.47 2.88"/> <path d="M12 12v4h4"/> <path d="M13 20a5 5 0 0 0 9-3 4.5 4.5 0 0 0-4.5-4.5c-1.33 0-2.54.54-3.41 1.41L12 16"/> </svg>',"square-kanban":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M8 7v7"/> <path d="M12 7v4"/> <path d="M16 7v9"/> </svg>',vote:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9 12 2 2 4-4"/> <path d="M5 7c0-1.1.9-2 2-2h10a2 2 0 0 1 2 2v12H5V7Z"/> <path d="M22 19H2"/> </svg>',"file-pen-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m18 5-2.414-2.414A2 2 0 0 0 14.172 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2"/> <path d="M21.378 12.626a1 1 0 0 0-3.004-3.004l-4.01 4.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> <path d="M8 18h1"/> </svg>',drumstick:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.4 15.63a7.875 6 135 1 1 6.23-6.23 4.5 3.43 135 0 0-6.23 6.23"/> <path d="m8.29 12.71-2.6 2.6a2.5 2.5 0 1 0-1.65 4.65A2.5 2.5 0 1 0 8.7 18.3l2.59-2.59"/> </svg>',"receipt-cent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M12 6.5v11"/> <path d="M15 9.4a4 4 0 1 0 0 5.2"/> </svg>',plus:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 12h14"/> <path d="M12 5v14"/> </svg>',"square-divide":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <line x1="8" x2="16" y1="12" y2="12"/> <line x1="12" x2="12" y1="16" y2="16"/> <line x1="12" x2="12" y1="8" y2="8"/> </svg>',"chart-bar-increasing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M7 11h8"/> <path d="M7 16h12"/> <path d="M7 6h3"/> </svg>',"phone-incoming":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="16 2 16 8 22 8"/> <line x1="22" x2="16" y1="2" y2="8"/> <path d="M22 16.92v3a2 2 0 0 1-2.18 2 19.79 19.79 0 0 1-8.63-3.07 19.5 19.5 0 0 1-6-6 19.79 19.79 0 0 1-3.07-8.67A2 2 0 0 1 4.11 2h3a2 2 0 0 1 2 1.72 12.84 12.84 0 0 0 .7 2.81 2 2 0 0 1-.45 2.11L8.09 9.91a16 16 0 0 0 6 6l1.27-1.27a2 2 0 0 1 2.11-.45 12.84 12.84 0 0 0 2.81.7A2 2 0 0 1 22 16.92z"/> </svg>',"folder-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 10.5 8 13l2 2.5"/> <path d="m14 10.5 2 2.5-2 2.5"/> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2z"/> </svg>',"panel-bottom":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 15h18"/> </svg>',router:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="8" x="2" y="14" rx="2"/> <path d="M6.01 18H6"/> <path d="M10.01 18H10"/> <path d="M15 10v4"/> <path d="M17.84 7.17a4 4 0 0 0-5.66 0"/> <path d="M20.66 4.34a8 8 0 0 0-11.31 0"/> </svg>',"panels-left-bottom":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 3v18"/> <path d="M9 15h12"/> </svg>',"columns-4":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M7.5 3v18"/> <path d="M12 3v18"/> <path d="M16.5 3v18"/> </svg>',"between-vertical-start":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="13" x="3" y="8" rx="1"/> <path d="m15 2-3 3-3-3"/> <rect width="7" height="13" x="14" y="8" rx="1"/> </svg>',component:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5.5 8.5 9 12l-3.5 3.5L2 12l3.5-3.5Z"/> <path d="m12 2 3.5 3.5L12 9 8.5 5.5 12 2Z"/> <path d="M18.5 8.5 22 12l-3.5 3.5L15 12l3.5-3.5Z"/> <path d="m12 15 3.5 3.5L12 22l-3.5-3.5L12 15Z"/> </svg>',sandwich:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 11v3a1 1 0 0 0 1 1h16a1 1 0 0 0 1-1v-3"/> <path d="M12 19H4a1 1 0 0 1-1-1v-2a1 1 0 0 1 1-1h16a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1h-3.83"/> <path d="m3 11 7.77-6.04a2 2 0 0 1 2.46 0L21 11H3Z"/> <path d="M12.97 19.77 7 15h12.5l-3.75 4.5a2 2 0 0 1-2.78.27Z"/> </svg>',"file-box":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.5 22H18a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M3 13.1a2 2 0 0 0-1 1.76v3.24a2 2 0 0 0 .97 1.78L6 21.7a2 2 0 0 0 2.03.01L11 19.9a2 2 0 0 0 1-1.76V14.9a2 2 0 0 0-.97-1.78L8 11.3a2 2 0 0 0-2.03-.01Z"/> <path d="M7 17v5"/> <path d="M11.7 14.2 7 17l-4.7-2.8"/> </svg>',caravan:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 19V9a4 4 0 0 0-4-4H6a4 4 0 0 0-4 4v8a2 2 0 0 0 2 2h2"/> <path d="M2 9h3a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H2"/> <path d="M22 17v1a1 1 0 0 1-1 1H10v-9a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v9"/> <circle cx="8" cy="19" r="2"/> </svg>',"corner-left-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="14 15 9 20 4 15"/> <path d="M20 4h-7a4 4 0 0 0-4 4v12"/> </svg>',pi:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="9" x2="9" y1="4" y2="20"/> <path d="M4 7c0-1.7 1.3-3 3-3h13"/> <path d="M18 20c-1.7 0-3-1.3-3-3V4"/> </svg>',"badge-info":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <line x1="12" x2="12" y1="16" y2="12"/> <line x1="12" x2="12.01" y1="8" y2="8"/> </svg>',github:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 22v-4a4.8 4.8 0 0 0-1-3.5c3 0 6-2 6-5.5.08-1.25-.27-2.48-1-3.5.28-1.15.28-2.35 0-3.5 0 0-1 0-3 1.5-2.64-.5-5.36-.5-8 0C6 2 5 2 5 2c-.3 1.15-.3 2.35 0 3.5A5.403 5.403 0 0 0 4 9c0 3.5 3 5.5 6 5.5-.39.49-.68 1.05-.85 1.65-.17.6-.22 1.23-.15 1.85v4"/> <path d="M9 18c-4.51 2-5-2-7-2"/> </svg>',"message-circle-more":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> <path d="M8 12h.01"/> <path d="M12 12h.01"/> <path d="M16 12h.01"/> </svg>',"archive-restore":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="5" x="2" y="3" rx="1"/> <path d="M4 8v11a2 2 0 0 0 2 2h2"/> <path d="M20 8v11a2 2 0 0 1-2 2h-2"/> <path d="m9 15 3-3 3 3"/> <path d="M12 12v9"/> </svg>',hammer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 12-8.373 8.373a1 1 0 1 1-3-3L12 9"/> <path d="m18 15 4-4"/> <path d="m21.5 11.5-1.914-1.914A2 2 0 0 1 19 8.172V7l-2.26-2.26a6 6 0 0 0-4.202-1.756L9 2.96l.92.82A6.18 6.18 0 0 1 12 8.4V10l2 2h1.172a2 2 0 0 1 1.414.586L18.5 14.5"/> </svg>',"pointer-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 4.5V4a2 2 0 0 0-2.41-1.957"/> <path d="M13.9 8.4a2 2 0 0 0-1.26-1.295"/> <path d="M21.7 16.2A8 8 0 0 0 22 14v-3a2 2 0 1 0-4 0v-1a2 2 0 0 0-3.63-1.158"/> <path d="m7 15-1.8-1.8a2 2 0 0 0-2.79 2.86L6 19.7a7.74 7.74 0 0 0 6 2.3h2a8 8 0 0 0 5.657-2.343"/> <path d="M6 6v8"/> <path d="m2 2 20 20"/> </svg>',"brain-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 5a3 3 0 1 0-5.997.142 4 4 0 0 0-2.526 5.77 4 4 0 0 0 .556 6.588 4 4 0 0 0 7.636 2.106 3.2 3.2 0 0 0 .164-.546c.028-.13.306-.13.335 0a3.2 3.2 0 0 0 .163.546 4 4 0 0 0 7.636-2.106 4 4 0 0 0 .556-6.588 4 4 0 0 0-2.526-5.77A3 3 0 1 0 12 5"/> <path d="M17.599 6.5a3 3 0 0 0 .399-1.375"/> <path d="M6.003 5.125A3 3 0 0 0 6.401 6.5"/> <path d="M3.477 10.896a4 4 0 0 1 .585-.396"/> <path d="M19.938 10.5a4 4 0 0 1 .585.396"/> <path d="M6 18a4 4 0 0 1-1.967-.516"/> <path d="M19.967 17.484A4 4 0 0 1 18 18"/> <circle cx="12" cy="12" r="3"/> <path d="m15.7 10.4-.9.4"/> <path d="m9.2 13.2-.9.4"/> <path d="m13.6 15.7-.4-.9"/> <path d="m10.8 9.2-.4-.9"/> <path d="m15.7 13.5-.9-.4"/> <path d="m9.2 10.9-.9-.4"/> <path d="m10.5 15.7.4-.9"/> <path d="m13.1 9.2.4-.9"/> </svg>',"square-check-big":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 10.5V19a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h12.5"/> <path d="m9 11 3 3L22 4"/> </svg>',weight:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="5" r="3"/> <path d="M6.5 8a2 2 0 0 0-1.905 1.46L2.1 18.5A2 2 0 0 0 4 21h16a2 2 0 0 0 1.925-2.54L19.4 9.5A2 2 0 0 0 17.48 8Z"/> </svg>',goal:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13V2l8 4-8 4"/> <path d="M20.561 10.222a9 9 0 1 1-12.55-5.29"/> <path d="M8.002 9.997a5 5 0 1 0 8.9 2.02"/> </svg>',"between-horizontal-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="13" height="7" x="3" y="3" rx="1"/> <path d="m22 15-3-3 3-3"/> <rect width="13" height="7" x="3" y="14" rx="1"/> </svg>',"monitor-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9 10 2 2 4-4"/> <rect width="20" height="14" x="2" y="3" rx="2"/> <path d="M12 17v4"/> <path d="M8 21h8"/> </svg>',"mail-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 13V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v12c0 1.1.9 2 2 2h8"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> <path d="M19 16v6"/> <path d="M16 19h6"/> </svg>',"tally-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 4v16"/> <path d="M9 4v16"/> </svg>',"git-pull-request-draft":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18" cy="18" r="3"/> <circle cx="6" cy="6" r="3"/> <path d="M18 6V5"/> <path d="M18 11v-1"/> <line x1="6" x2="6" y1="9" y2="21"/> </svg>',"tally-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 4v16"/> <path d="M9 4v16"/> <path d="M14 4v16"/> </svg>',"layout-panel-top":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="7" x="3" y="3" rx="1"/> <rect width="7" height="7" x="3" y="14" rx="1"/> <rect width="7" height="7" x="14" y="14" rx="1"/> </svg>',pilcrow:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 4v16"/> <path d="M17 4v16"/> <path d="M19 4H9.5a4.5 4.5 0 0 0 0 9H13"/> </svg>',"radio-tower":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4.9 16.1C1 12.2 1 5.8 4.9 1.9"/> <path d="M7.8 4.7a6.14 6.14 0 0 0-.8 7.5"/> <circle cx="12" cy="9" r="2"/> <path d="M16.2 4.8c2 2 2.26 5.11.8 7.47"/> <path d="M19.1 1.9a9.96 9.96 0 0 1 0 14.1"/> <path d="M9.5 18h5"/> <path d="m8 22 4-11 4 11"/> </svg>',"shield-alert":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="M12 8v4"/> <path d="M12 16h.01"/> </svg>',shell:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 11a2 2 0 1 1-4 0 4 4 0 0 1 8 0 6 6 0 0 1-12 0 8 8 0 0 1 16 0 10 10 0 1 1-20 0 11.93 11.93 0 0 1 2.42-7.22 2 2 0 1 1 3.16 2.44"/> </svg>',"beer-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 13v5"/> <path d="M17 11.47V8"/> <path d="M17 11h1a3 3 0 0 1 2.745 4.211"/> <path d="m2 2 20 20"/> <path d="M5 8v12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2v-3"/> <path d="M7.536 7.535C6.766 7.649 6.154 8 5.5 8a2.5 2.5 0 0 1-1.768-4.268"/> <path d="M8.727 3.204C9.306 2.767 9.885 2 11 2c1.56 0 2 1.5 3 1.5s1.72-.5 2.5-.5a1 1 0 1 1 0 5c-.78 0-1.5-.5-2.5-.5a3.149 3.149 0 0 0-.842.12"/> <path d="M9 14.6V18"/> </svg>',"file-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M9 15h6"/> </svg>',"refresh-ccw-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 2v6h6"/> <path d="M21 12A9 9 0 0 0 6 5.3L3 8"/> <path d="M21 22v-6h-6"/> <path d="M3 12a9 9 0 0 0 15 6.7l3-2.7"/> <circle cx="12" cy="12" r="1"/> </svg>',"cloud-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 2 20 20"/> <path d="M5.782 5.782A7 7 0 0 0 9 19h8.5a4.5 4.5 0 0 0 1.307-.193"/> <path d="M21.532 16.5A4.5 4.5 0 0 0 17.5 10h-1.79A7.008 7.008 0 0 0 10 5.07"/> </svg>',"dice-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="M15 9h.01"/> <path d="M9 15h.01"/> </svg>',antenna:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12 7 2"/> <path d="m7 12 5-10"/> <path d="m12 12 5-10"/> <path d="m17 12 5-10"/> <path d="M4.5 7h15"/> <path d="M12 16v6"/> </svg>',biohazard:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="11.9" r="2"/> <path d="M6.7 3.4c-.9 2.5 0 5.2 2.2 6.7C6.5 9 3.7 9.6 2 11.6"/> <path d="m8.9 10.1 1.4.8"/> <path d="M17.3 3.4c.9 2.5 0 5.2-2.2 6.7 2.4-1.2 5.2-.6 6.9 1.5"/> <path d="m15.1 10.1-1.4.8"/> <path d="M16.7 20.8c-2.6-.4-4.6-2.6-4.7-5.3-.2 2.6-2.1 4.8-4.7 5.2"/> <path d="M12 13.9v1.6"/> <path d="M13.5 5.4c-1-.2-2-.2-3 0"/> <path d="M17 16.4c.7-.7 1.2-1.6 1.5-2.5"/> <path d="M5.5 13.9c.3.9.8 1.8 1.5 2.5"/> </svg>',"align-horizontal-space-around":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="10" x="9" y="7" rx="2"/> <path d="M4 22V2"/> <path d="M20 22V2"/> </svg>',"arrow-right-to-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 12H3"/> <path d="m11 18 6-6-6-6"/> <path d="M21 5v14"/> </svg>',octagon:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.586 16.726A2 2 0 0 1 2 15.312V8.688a2 2 0 0 1 .586-1.414l4.688-4.688A2 2 0 0 1 8.688 2h6.624a2 2 0 0 1 1.414.586l4.688 4.688A2 2 0 0 1 22 8.688v6.624a2 2 0 0 1-.586 1.414l-4.688 4.688a2 2 0 0 1-1.414.586H8.688a2 2 0 0 1-1.414-.586z"/> </svg>',"square-play":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m9 8 6 4-6 4Z"/> </svg>',"user-round":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="8" r="5"/> <path d="M20 21a8 8 0 0 0-16 0"/> </svg>',bandage:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 10.01h.01"/> <path d="M10 14.01h.01"/> <path d="M14 10.01h.01"/> <path d="M14 14.01h.01"/> <path d="M18 6v11.5"/> <path d="M6 6v12"/> <rect x="2" y="6" width="20" height="12" rx="2"/> </svg>',"phone-missed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="22" x2="16" y1="2" y2="8"/> <line x1="16" x2="22" y1="2" y2="8"/> <path d="M22 16.92v3a2 2 0 0 1-2.18 2 19.79 19.79 0 0 1-8.63-3.07 19.5 19.5 0 0 1-6-6 19.79 19.79 0 0 1-3.07-8.67A2 2 0 0 1 4.11 2h3a2 2 0 0 1 2 1.72 12.84 12.84 0 0 0 .7 2.81 2 2 0 0 1-.45 2.11L8.09 9.91a16 16 0 0 0 6 6l1.27-1.27a2 2 0 0 1 2.11-.45 12.84 12.84 0 0 0 2.81.7A2 2 0 0 1 22 16.92z"/> </svg>',"heart-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" y1="2" x2="22" y2="22"/> <path d="M16.5 16.5 12 21l-7-7c-1.5-1.45-3-3.2-3-5.5a5.5 5.5 0 0 1 2.14-4.35"/> <path d="M8.76 3.1c1.15.22 2.13.78 3.24 1.9 1.5-1.5 2.74-2 4.5-2A5.5 5.5 0 0 1 22 8.5c0 2.12-1.3 3.78-2.67 5.17"/> </svg>',"file-chart-column":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M8 18v-1"/> <path d="M12 18v-6"/> <path d="M16 18v-3"/> </svg>',"folder-tree":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10a1 1 0 0 0 1-1V6a1 1 0 0 0-1-1h-2.5a1 1 0 0 1-.8-.4l-.9-1.2A1 1 0 0 0 15 3h-2a1 1 0 0 0-1 1v5a1 1 0 0 0 1 1Z"/> <path d="M20 21a1 1 0 0 0 1-1v-3a1 1 0 0 0-1-1h-2.9a1 1 0 0 1-.88-.55l-.42-.85a1 1 0 0 0-.92-.6H13a1 1 0 0 0-1 1v5a1 1 0 0 0 1 1Z"/> <path d="M3 5a2 2 0 0 0 2 2h3"/> <path d="M3 3v13a2 2 0 0 0 2 2h3"/> </svg>',"square-arrow-out-down-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 11V5a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h6"/> <path d="m21 21-9-9"/> <path d="M21 15v6h-6"/> </svg>',"step-forward":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="6" x2="6" y1="4" y2="20"/> <polygon points="10,4 20,12 10,20"/> </svg>',"move-3d":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 3v16h16"/> <path d="m5 19 6-6"/> <path d="m2 6 3-3 3 3"/> <path d="m18 16 3 3-3 3"/> </svg>',"git-pull-request-closed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="6" cy="6" r="3"/> <path d="M6 9v12"/> <path d="m21 3-6 6"/> <path d="m21 9-6-6"/> <path d="M18 11.5V15"/> <circle cx="18" cy="18" r="3"/> </svg>',equal:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="5" x2="19" y1="9" y2="9"/> <line x1="5" x2="19" y1="15" y2="15"/> </svg>',"concierge-bell":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 20a1 1 0 0 1-1-1v-1a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v1a1 1 0 0 1-1 1Z"/> <path d="M20 16a8 8 0 1 0-16 0"/> <path d="M12 4v4"/> <path d="M10 4h4"/> </svg>',"contact-round":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 2v2"/> <path d="M17.915 22a6 6 0 0 0-12 0"/> <path d="M8 2v2"/> <circle cx="12" cy="12" r="4"/> <rect x="3" y="4" width="18" height="18" rx="2"/> </svg>',bluetooth:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 7 10 10-5 5V2l5 5L7 17"/> </svg>',"zoom-in":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11" cy="11" r="8"/> <line x1="21" x2="16.65" y1="21" y2="16.65"/> <line x1="11" x2="11" y1="8" y2="14"/> <line x1="8" x2="14" y1="11" y2="11"/> </svg>',"square-arrow-down-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m8 8 8 8"/> <path d="M16 8v8H8"/> </svg>',"volume-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 4.702a.705.705 0 0 0-1.203-.498L6.413 7.587A1.4 1.4 0 0 1 5.416 8H3a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2.416a1.4 1.4 0 0 1 .997.413l3.383 3.384A.705.705 0 0 0 11 19.298z"/> <path d="M16 9a5 5 0 0 1 0 6"/> </svg>',"circle-parking-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m5 5 14 14"/> <path d="M13 13a3 3 0 1 0 0-6H9v2"/> <path d="M9 17v-2.34"/> </svg>',dam:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 11.31c1.17.56 1.54 1.69 3.5 1.69 2.5 0 2.5-2 5-2 1.3 0 1.9.5 2.5 1"/> <path d="M11.75 18c.35.5 1.45 1 2.75 1 2.5 0 2.5-2 5-2 1.3 0 1.9.5 2.5 1"/> <path d="M2 10h4"/> <path d="M2 14h4"/> <path d="M2 18h4"/> <path d="M2 6h4"/> <path d="M7 3a1 1 0 0 0-1 1v16a1 1 0 0 0 1 1h4a1 1 0 0 0 1-1L10 4a1 1 0 0 0-1-1z"/> </svg>',"signal-low":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 20h.01"/> <path d="M7 20v-4"/> </svg>',"chevron-last":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 18 6-6-6-6"/> <path d="M17 6v12"/> </svg>',"arrow-up-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21 16-4 4-4-4"/> <path d="M17 20V4"/> <path d="m3 8 4-4 4 4"/> <path d="M7 4v16"/> </svg>',"ticket-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9a3 3 0 0 1 0 6v2a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2a3 3 0 0 1 0-6V7a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="m9.5 14.5 5-5"/> <path d="m9.5 9.5 5 5"/> </svg>',"arrow-up-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 7h10v10"/> <path d="M7 17 17 7"/> </svg>',tent:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.5 21 14 3"/> <path d="M20.5 21 10 3"/> <path d="M15.5 21 12 15l-3.5 6"/> <path d="M2 21h20"/> </svg>',"shield-ellipsis":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="M8 12h.01"/> <path d="M12 12h.01"/> <path d="M16 12h.01"/> </svg>',table:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3v18"/> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 9h18"/> <path d="M3 15h18"/> </svg>',"tree-deciduous":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 19a4 4 0 0 1-2.24-7.32A3.5 3.5 0 0 1 9 6.03V6a3 3 0 1 1 6 0v.04a3.5 3.5 0 0 1 3.24 5.65A4 4 0 0 1 16 19Z"/> <path d="M12 19v3"/> </svg>',"inspection-panel":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M7 7h.01"/> <path d="M17 7h.01"/> <path d="M7 17h.01"/> <path d="M17 17h.01"/> </svg>',"table-columns-split":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 14v2"/> <path d="M14 20v2"/> <path d="M14 2v2"/> <path d="M14 8v2"/> <path d="M2 15h8"/> <path d="M2 3h6a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H2"/> <path d="M2 9h8"/> <path d="M22 15h-4"/> <path d="M22 3h-2a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h2"/> <path d="M22 9h-4"/> <path d="M5 3v18"/> </svg>',waves:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 6c.6.5 1.2 1 2.5 1C7 7 7 5 9.5 5c2.6 0 2.4 2 5 2 2.5 0 2.5-2 5-2 1.3 0 1.9.5 2.5 1"/> <path d="M2 12c.6.5 1.2 1 2.5 1 2.5 0 2.5-2 5-2 2.6 0 2.4 2 5 2 2.5 0 2.5-2 5-2 1.3 0 1.9.5 2.5 1"/> <path d="M2 18c.6.5 1.2 1 2.5 1 2.5 0 2.5-2 5-2 2.6 0 2.4 2 5 2 2.5 0 2.5-2 5-2 1.3 0 1.9.5 2.5 1"/> </svg>',"folder-output":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 7.5V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2H4a2 2 0 0 1-2-1.5"/> <path d="M2 13h10"/> <path d="m5 10-3 3 3 3"/> </svg>',"table-properties":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 3v18"/> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M21 9H3"/> <path d="M21 15H3"/> </svg>',"message-square-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 17H7l-4 4v-7"/> <path d="M14 17h1"/> <path d="M14 3h1"/> <path d="M19 3a2 2 0 0 1 2 2"/> <path d="M21 14v1a2 2 0 0 1-2 2"/> <path d="M21 9v1"/> <path d="M3 9v1"/> <path d="M5 3a2 2 0 0 0-2 2"/> <path d="M9 3h1"/> </svg>',"map-pin-plus-inside":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10c0 4.993-5.539 10.193-7.399 11.799a1 1 0 0 1-1.202 0C9.539 20.193 4 14.993 4 10a8 8 0 0 1 16 0"/> <path d="M12 7v6"/> <path d="M9 10h6"/> </svg>',"move-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 6L12 2L16 6"/> <path d="M12 2V22"/> </svg>',"paint-bucket":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 11-8-8-8.6 8.6a2 2 0 0 0 0 2.8l5.2 5.2c.8.8 2 .8 2.8 0L19 11Z"/> <path d="m5 2 5 5"/> <path d="M2 13h15"/> <path d="M22 20a2 2 0 1 1-4 0c0-1.6 1.7-2.4 2-4 .3 1.6 2 2.4 2 4Z"/> </svg>',"book-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M8 11h8"/> <path d="M8 7h6"/> </svg>',"book-marked":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2v8l3-3 3 3V2"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> </svg>',"arrow-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 5v14"/> <path d="m19 12-7 7-7-7"/> </svg>',"refresh-cw-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 8L18.74 5.74A9.75 9.75 0 0 0 12 3C11 3 10.03 3.16 9.13 3.47"/> <path d="M8 16H3v5"/> <path d="M3 12C3 9.51 4 7.26 5.64 5.64"/> <path d="m3 16 2.26 2.26A9.75 9.75 0 0 0 12 21c2.49 0 4.74-1 6.36-2.64"/> <path d="M21 12c0 1-.16 1.97-.47 2.87"/> <path d="M21 3v5h-5"/> <path d="M22 22 2 2"/> </svg>',twitter:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 4s-.7 2.1-2 3.4c1.6 10-9.4 17.3-18 11.6 2.2.1 4.4-.6 6-2C3 15.5.5 9.6 3 5c2.2 2.6 5.6 4.1 9 4-.9-4.2 4-6.6 7-3.8 1.1 0 3-1.2 3-1.2z"/> </svg>',"panel-bottom-close":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 15h18"/> <path d="m15 8-3 3-3-3"/> </svg>',tag:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.586 2.586A2 2 0 0 0 11.172 2H4a2 2 0 0 0-2 2v7.172a2 2 0 0 0 .586 1.414l8.704 8.704a2.426 2.426 0 0 0 3.42 0l6.58-6.58a2.426 2.426 0 0 0 0-3.42z"/> <circle cx="7.5" cy="7.5" r=".5" fill="currentColor"/> </svg>',"send-to-back":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="14" y="14" width="8" height="8" rx="2"/> <rect x="2" y="2" width="8" height="8" rx="2"/> <path d="M7 14v1a2 2 0 0 0 2 2h1"/> <path d="M14 7h1a2 2 0 0 1 2 2v1"/> </svg>',"folder-clock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="16" cy="16" r="6"/> <path d="M7 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2"/> <path d="M16 14v2l1 1"/> </svg>',banknote:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="12" x="2" y="6" rx="2"/> <circle cx="12" cy="12" r="2"/> <path d="M6 12h.01M18 12h.01"/> </svg>',award:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15.477 12.89 1.515 8.526a.5.5 0 0 1-.81.47l-3.58-2.687a1 1 0 0 0-1.197 0l-3.586 2.686a.5.5 0 0 1-.81-.469l1.514-8.526"/> <circle cx="12" cy="8" r="6"/> </svg>',plane:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17.8 19.2 16 11l3.5-3.5C21 6 21.5 4 21 3c-1-.5-3 0-4.5 1.5L13 8 4.8 6.2c-.5-.1-.9.1-1.1.5l-.3.5c-.2.5-.1 1 .3 1.3L9 12l-2 3H4l-1 1 3 2 2 3 1-1v-3l3-2 3.5 5.3c.3.4.8.5 1.3.3l.5-.2c.4-.3.6-.7.5-1.2z"/> </svg>',"square-menu":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M7 8h10"/> <path d="M7 12h10"/> <path d="M7 16h10"/> </svg>',"external-link":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 3h6v6"/> <path d="M10 14 21 3"/> <path d="M18 13v6a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2h6"/> </svg>',stamp:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 22h14"/> <path d="M19.27 13.73A2.5 2.5 0 0 0 17.5 13h-11A2.5 2.5 0 0 0 4 15.5V17a1 1 0 0 0 1 1h14a1 1 0 0 0 1-1v-1.5c0-.66-.26-1.3-.73-1.77Z"/> <path d="M14 13V8.5C14 7 15 7 15 5a3 3 0 0 0-3-3c-1.66 0-3 1-3 3s1 2 1 3.5V13"/> </svg>',pizza:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 11h.01"/> <path d="M11 15h.01"/> <path d="M16 16h.01"/> <path d="m2 16 20 6-6-20A20 20 0 0 0 2 16"/> <path d="M5.71 17.11a17.04 17.04 0 0 1 11.4-11.4"/> </svg>',"file-terminal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m8 16 2-2-2-2"/> <path d="M12 18h4"/> </svg>',"file-digit":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <rect width="4" height="6" x="2" y="12" rx="2"/> <path d="M10 12h2v6"/> <path d="M10 18h4"/> </svg>',stethoscope:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 2v2"/> <path d="M5 2v2"/> <path d="M5 3H4a2 2 0 0 0-2 2v4a6 6 0 0 0 12 0V5a2 2 0 0 0-2-2h-1"/> <path d="M8 15a6 6 0 0 0 12 0v-3"/> <circle cx="20" cy="10" r="2"/> </svg>',"list-checks":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 17 2 2 4-4"/> <path d="m3 7 2 2 4-4"/> <path d="M13 6h8"/> <path d="M13 12h8"/> <path d="M13 18h8"/> </svg>',euro:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 10h12"/> <path d="M4 14h9"/> <path d="M19 6a7.7 7.7 0 0 0-5.2-2A7.9 7.9 0 0 0 6 12c0 4.4 3.5 8 7.8 8 2 0 3.8-.8 5.2-2"/> </svg>',"map-pin-house":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 22a1 1 0 0 1-1-1v-4a1 1 0 0 1 .445-.832l3-2a1 1 0 0 1 1.11 0l3 2A1 1 0 0 1 22 17v4a1 1 0 0 1-1 1z"/> <path d="M18 10a8 8 0 0 0-16 0c0 4.993 5.539 10.193 7.399 11.799a1 1 0 0 0 .601.2"/> <path d="M18 22v-3"/> <circle cx="10" cy="10" r="3"/> </svg>',"message-circle-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> <path d="m15 9-6 6"/> <path d="m9 9 6 6"/> </svg>',worm:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 12-1.5 3"/> <path d="M19.63 18.81 22 20"/> <path d="M6.47 8.23a1.68 1.68 0 0 1 2.44 1.93l-.64 2.08a6.76 6.76 0 0 0 10.16 7.67l.42-.27a1 1 0 1 0-2.73-4.21l-.42.27a1.76 1.76 0 0 1-2.63-1.99l.64-2.08A6.66 6.66 0 0 0 3.94 3.9l-.7.4a1 1 0 1 0 2.55 4.34z"/> </svg>',"ticket-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9a3 3 0 0 1 0 6v2a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2a3 3 0 0 1 0-6V7a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="M9 12h6"/> </svg>',beef:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12.5" cy="8.5" r="2.5"/> <path d="M12.5 2a6.5 6.5 0 0 0-6.22 4.6c-1.1 3.13-.78 3.9-3.18 6.08A3 3 0 0 0 5 18c4 0 8.4-1.8 11.4-4.3A6.5 6.5 0 0 0 12.5 2Z"/> <path d="m18.5 6 2.19 4.5a6.48 6.48 0 0 1 .31 2 6.49 6.49 0 0 1-2.6 5.2C15.4 20.2 11 22 7 22a3 3 0 0 1-2.68-1.66L2.4 16.5"/> </svg>',"loader-circle":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 12a9 9 0 1 1-6.219-8.56"/> </svg>',"user-round-pen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 21a8 8 0 0 1 10.821-7.487"/> <path d="M21.378 16.626a1 1 0 0 0-3.004-3.004l-4.01 4.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> <circle cx="10" cy="8" r="5"/> </svg>',"arrow-up-0-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 8 4-4 4 4"/> <path d="M7 4v16"/> <rect x="15" y="4" width="4" height="6" ry="2"/> <path d="M17 20v-6h-2"/> <path d="M15 20h4"/> </svg>',"folder-git-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v5"/> <circle cx="13" cy="12" r="2"/> <path d="M18 19c-2.8 0-5-2.2-5-5v8"/> <circle cx="20" cy="19" r="2"/> </svg>',"calendar-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14 18 4-4 4 4"/> <path d="M16 2v4"/> <path d="M18 22v-8"/> <path d="M21 11.343V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h9"/> <path d="M3 10h18"/> <path d="M8 2v4"/> </svg>',rat:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 5c0-1.7-1.3-3-3-3s-3 1.3-3 3c0 .8.3 1.5.8 2H11c-3.9 0-7 3.1-7 7c0 2.2 1.8 4 4 4"/> <path d="M16.8 3.9c.3-.3.6-.5 1-.7 1.5-.6 3.3.1 3.9 1.6.6 1.5-.1 3.3-1.6 3.9l1.6 2.8c.2.3.2.7.2 1-.2.8-.9 1.2-1.7 1.1 0 0-1.6-.3-2.7-.6H17c-1.7 0-3 1.3-3 3"/> <path d="M13.2 18a3 3 0 0 0-2.2-5"/> <path d="M13 22H4a2 2 0 0 1 0-4h12"/> <path d="M16 9h.01"/> </svg>',"cloud-moon":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.188 8.5A6 6 0 0 1 16 4a1 1 0 0 0 6 6 6 6 0 0 1-3 5.197"/> <path d="M13 16a3 3 0 1 1 0 6H7a5 5 0 1 1 4.9-6Z"/> </svg>',scaling:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-7"/> <path d="M14 15H9v-5"/> <path d="M16 3h5v5"/> <path d="M21 3 9 15"/> </svg>',"arrows-up-from-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m4 6 3-3 3 3"/> <path d="M7 17V3"/> <path d="m14 6 3-3 3 3"/> <path d="M17 17V3"/> <path d="M4 21h16"/> </svg>',"clipboard-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2h2"/> <path d="m15 11-6 6"/> <path d="m9 11 6 6"/> </svg>',sun:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="4"/> <path d="M12 2v2"/> <path d="M12 20v2"/> <path d="m4.93 4.93 1.41 1.41"/> <path d="m17.66 17.66 1.41 1.41"/> <path d="M2 12h2"/> <path d="M20 12h2"/> <path d="m6.34 17.66-1.41 1.41"/> <path d="m19.07 4.93-1.41 1.41"/> </svg>',"gallery-thumbnails":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="14" x="3" y="3" rx="2"/> <path d="M4 21h1"/> <path d="M9 21h1"/> <path d="M14 21h1"/> <path d="M19 21h1"/> </svg>',"list-filter":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 6h18"/> <path d="M7 12h10"/> <path d="M10 18h4"/> </svg>',"cable-car":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 3h.01"/> <path d="M14 2h.01"/> <path d="m2 9 20-5"/> <path d="M12 12V6.5"/> <rect width="16" height="10" x="4" y="12" rx="3"/> <path d="M9 12v5"/> <path d="M15 12v5"/> <path d="M4 17h16"/> </svg>',radar:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19.07 4.93A10 10 0 0 0 6.99 3.34"/> <path d="M4 6h.01"/> <path d="M2.29 9.62A10 10 0 1 0 21.31 8.35"/> <path d="M16.24 7.76A6 6 0 1 0 8.23 16.67"/> <path d="M12 18h.01"/> <path d="M17.99 11.66A6 6 0 0 1 15.77 16.67"/> <circle cx="12" cy="12" r="2"/> <path d="m13.41 10.59 5.66-5.66"/> </svg>',wind:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17.7 7.7a2.5 2.5 0 1 1 1.8 4.3H2"/> <path d="M9.6 4.6A2 2 0 1 1 11 8H2"/> <path d="M12.6 19.4A2 2 0 1 0 14 16H2"/> </svg>',"badge-alert":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <line x1="12" x2="12" y1="8" y2="12"/> <line x1="12" x2="12.01" y1="16" y2="16"/> </svg>',annoyed:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M8 15h8"/> <path d="M8 9h2"/> <path d="M14 9h2"/> </svg>',radio:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4.9 19.1C1 15.2 1 8.8 4.9 4.9"/> <path d="M7.8 16.2c-2.3-2.3-2.3-6.1 0-8.5"/> <circle cx="12" cy="12" r="2"/> <path d="M16.2 7.8c2.3 2.3 2.3 6.1 0 8.5"/> <path d="M19.1 4.9C23 8.8 23 15.1 19.1 19"/> </svg>',"file-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M12 18v-6"/> <path d="m9 15 3 3 3-3"/> </svg>',shuffle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 18h1.4c1.3 0 2.5-.6 3.3-1.7l6.1-8.6c.7-1.1 2-1.7 3.3-1.7H22"/> <path d="m18 2 4 4-4 4"/> <path d="M2 6h1.9c1.5 0 2.9.9 3.6 2.2"/> <path d="M22 18h-5.9c-1.3 0-2.6-.7-3.3-1.8l-.5-.8"/> <path d="m18 14 4 4-4 4"/> </svg>',"pen-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20h9"/> <path d="M16.376 3.622a1 1 0 0 1 3.002 3.002L7.368 18.635a2 2 0 0 1-.855.506l-2.872.838a.5.5 0 0 1-.62-.62l.838-2.872a2 2 0 0 1 .506-.854z"/> </svg>',"corner-up-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="15 14 20 9 15 4"/> <path d="M4 20v-7a4 4 0 0 1 4-4h12"/> </svg>',"lock-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="11" x="3" y="11" rx="2" ry="2"/> <path d="M7 11V7a5 5 0 0 1 9.9-1"/> </svg>',"layout-dashboard":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="9" x="3" y="3" rx="1"/> <rect width="7" height="5" x="14" y="3" rx="1"/> <rect width="7" height="9" x="14" y="12" rx="1"/> <rect width="7" height="5" x="3" y="16" rx="1"/> </svg>',search:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11" cy="11" r="8"/> <path d="m21 21-4.3-4.3"/> </svg>',"arrow-up-from-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m5 9 7-7 7 7"/> <path d="M12 16V2"/> <circle cx="12" cy="21" r="1"/> </svg>',"copy-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="12" x2="18" y1="15" y2="15"/> <rect width="14" height="14" x="8" y="8" rx="2" ry="2"/> <path d="M4 16c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h10c1.1 0 2 .9 2 2"/> </svg>',"table-cells-merge":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 21v-6"/> <path d="M12 9V3"/> <path d="M3 15h18"/> <path d="M3 9h18"/> <rect width="18" height="18" x="3" y="3" rx="2"/> </svg>',"panel-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M15 3v18"/> </svg>',voicemail:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="6" cy="12" r="4"/> <circle cx="18" cy="12" r="4"/> <line x1="6" x2="18" y1="16" y2="16"/> </svg>',"boom-box":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 9V5a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v4"/> <path d="M8 8v1"/> <path d="M12 8v1"/> <path d="M16 8v1"/> <rect width="20" height="12" x="2" y="9" rx="2"/> <circle cx="8" cy="15" r="2"/> <circle cx="16" cy="15" r="2"/> </svg>',"user-round-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 21a8 8 0 0 1 13.292-6"/> <circle cx="10" cy="8" r="5"/> <path d="M22 19h-6"/> </svg>',"monitor-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 17H4a2 2 0 0 1-2-2V5c0-1.5 1-2 1-2"/> <path d="M22 15V5a2 2 0 0 0-2-2H9"/> <path d="M8 21h8"/> <path d="M12 17v4"/> <path d="m2 2 20 20"/> </svg>',soup:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 21a9 9 0 0 0 9-9H3a9 9 0 0 0 9 9Z"/> <path d="M7 21h10"/> <path d="M19.5 12 22 6"/> <path d="M16.25 3c.27.1.8.53.75 1.36-.06.83-.93 1.2-1 2.02-.05.78.34 1.24.73 1.62"/> <path d="M11.25 3c.27.1.8.53.74 1.36-.05.83-.93 1.2-.98 2.02-.06.78.33 1.24.72 1.62"/> <path d="M6.25 3c.27.1.8.53.75 1.36-.06.83-.93 1.2-1 2.02-.05.78.34 1.24.74 1.62"/> </svg>',"house-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.22 2.416a2 2 0 0 0-2.511.057l-7 5.999A2 2 0 0 0 3 10v9a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-7.354"/> <path d="M15 21v-8a1 1 0 0 0-1-1h-4a1 1 0 0 0-1 1v8"/> <path d="M15 6h6"/> <path d="M18 3v6"/> </svg>',"corner-down-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="15 10 20 15 15 20"/> <path d="M4 4v7a4 4 0 0 0 4 4h12"/> </svg>',"square-pilcrow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M12 12H9.5a2.5 2.5 0 0 1 0-5H17"/> <path d="M12 7v10"/> <path d="M16 7v10"/> </svg>',move:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="5 9 2 12 5 15"/> <polyline points="9 5 12 2 15 5"/> <polyline points="15 19 12 22 9 19"/> <polyline points="19 9 22 12 19 15"/> <line x1="2" x2="22" y1="12" y2="12"/> <line x1="12" x2="12" y1="2" y2="22"/> </svg>',"square-arrow-up-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M8 16V8h8"/> <path d="M16 16 8 8"/> </svg>',"file-json-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M4 12a1 1 0 0 0-1 1v1a1 1 0 0 1-1 1 1 1 0 0 1 1 1v1a1 1 0 0 0 1 1"/> <path d="M8 18a1 1 0 0 0 1-1v-1a1 1 0 0 1 1-1 1 1 0 0 1-1-1v-1a1 1 0 0 0-1-1"/> </svg>',"user-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 21v-2a4 4 0 0 0-4-4H6a4 4 0 0 0-4 4v2"/> <circle cx="9" cy="7" r="4"/> <line x1="22" x2="16" y1="11" y2="11"/> </svg>',"list-restart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 6H3"/> <path d="M7 12H3"/> <path d="M7 18H3"/> <path d="M12 18a5 5 0 0 0 9-3 4.5 4.5 0 0 0-4.5-4.5c-1.33 0-2.54.54-3.41 1.41L11 14"/> <path d="M11 10v4h4"/> </svg>',monitor:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="14" x="2" y="3" rx="2"/> <line x1="8" x2="16" y1="21" y2="21"/> <line x1="12" x2="12" y1="17" y2="21"/> </svg>',languages:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m5 8 6 6"/> <path d="m4 14 6-6 2-3"/> <path d="M2 5h12"/> <path d="M7 2h1"/> <path d="m22 22-5-10-5 10"/> <path d="M14 18h6"/> </svg>',"shield-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="m14.5 9.5-5 5"/> <path d="m9.5 9.5 5 5"/> </svg>',thermometer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 4v10.54a4 4 0 1 1-4 0V4a2 2 0 0 1 4 0Z"/> </svg>',"bot-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.67 8H18a2 2 0 0 1 2 2v4.33"/> <path d="M2 14h2"/> <path d="M20 14h2"/> <path d="M22 22 2 2"/> <path d="M8 8H6a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2h12a2 2 0 0 0 1.414-.586"/> <path d="M9 13v2"/> <path d="M9.67 4H12v2.33"/> </svg>',barcode:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 5v14"/> <path d="M8 5v14"/> <path d="M12 5v14"/> <path d="M17 5v14"/> <path d="M21 5v14"/> </svg>',"user-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 21v-2a4 4 0 0 0-4-4H6a4 4 0 0 0-4 4v2"/> <circle cx="9" cy="7" r="4"/> <line x1="17" x2="22" y1="8" y2="13"/> <line x1="22" x2="17" y1="8" y2="13"/> </svg>',"git-commit-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="3"/> <line x1="3" x2="9" y1="12" y2="12"/> <line x1="15" x2="21" y1="12" y2="12"/> </svg>',instagram:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="20" x="2" y="2" rx="5" ry="5"/> <path d="M16 11.37A4 4 0 1 1 12.63 8 4 4 0 0 1 16 11.37z"/> <line x1="17.5" x2="17.51" y1="6.5" y2="6.5"/> </svg>',"mail-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 12.5V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v12c0 1.1.9 2 2 2h7.5"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> <path d="M18 21a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"/> <circle cx="18" cy="18" r="3"/> <path d="m22 22-1.5-1.5"/> </svg>',"book-up-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13V7"/> <path d="M18 2h1a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2"/> <path d="m9 10 3-3 3 3"/> <path d="m9 5 3-3 3 3"/> </svg>',code:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="16 18 22 12 16 6"/> <polyline points="8 6 2 12 8 18"/> </svg>',"search-slash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m13.5 8.5-5 5"/> <circle cx="11" cy="11" r="8"/> <path d="m21 21-4.3-4.3"/> </svg>',"arrow-down-z-a":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 16 4 4 4-4"/> <path d="M7 4v16"/> <path d="M15 4h5l-5 6h5"/> <path d="M15 20v-3.5a2.5 2.5 0 0 1 5 0V20"/> <path d="M20 18h-5"/> </svg>',"bean-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 9c-.64.64-1.521.954-2.402 1.165A6 6 0 0 0 8 22a13.96 13.96 0 0 0 9.9-4.1"/> <path d="M10.75 5.093A6 6 0 0 1 22 8c0 2.411-.61 4.68-1.683 6.66"/> <path d="M5.341 10.62a4 4 0 0 0 6.487 1.208M10.62 5.341a4.015 4.015 0 0 1 2.039 2.04"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"image-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.3 21H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v10l-3.1-3.1a2 2 0 0 0-2.814.014L6 21"/> <path d="m14 19 3 3v-5.5"/> <path d="m17 22 3-3"/> <circle cx="9" cy="9" r="2"/> </svg>',"separator-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="12" x2="12" y1="3" y2="21"/> <polyline points="8 8 4 12 8 16"/> <polyline points="16 16 20 12 16 8"/> </svg>',"chart-pie":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 12c.552 0 1.005-.449.95-.998a10 10 0 0 0-8.953-8.951c-.55-.055-.998.398-.998.95v8a1 1 0 0 0 1 1z"/> <path d="M21.21 15.89A10 10 0 1 1 8 2.83"/> </svg>',"ticket-slash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9a3 3 0 0 1 0 6v2a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2a3 3 0 0 1 0-6V7a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="m9.5 14.5 5-5"/> </svg>',"circle-fading-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2a10 10 0 0 1 7.38 16.75"/> <path d="M12 8v8"/> <path d="M16 12H8"/> <path d="M2.5 8.875a10 10 0 0 0-.5 3"/> <path d="M2.83 16a10 10 0 0 0 2.43 3.4"/> <path d="M4.636 5.235a10 10 0 0 1 .891-.857"/> <path d="M8.644 21.42a10 10 0 0 0 7.631-.38"/> </svg>',map:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.106 5.553a2 2 0 0 0 1.788 0l3.659-1.83A1 1 0 0 1 21 4.619v12.764a1 1 0 0 1-.553.894l-4.553 2.277a2 2 0 0 1-1.788 0l-4.212-2.106a2 2 0 0 0-1.788 0l-3.659 1.83A1 1 0 0 1 3 19.381V6.618a1 1 0 0 1 .553-.894l4.553-2.277a2 2 0 0 1 1.788 0z"/> <path d="M15 5.764v15"/> <path d="M9 3.236v15"/> </svg>',blocks:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="7" x="14" y="3" rx="1"/> <path d="M10 21V8a1 1 0 0 0-1-1H4a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-5a1 1 0 0 0-1-1H3"/> </svg>',fan:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.827 16.379a6.082 6.082 0 0 1-8.618-7.002l5.412 1.45a6.082 6.082 0 0 1 7.002-8.618l-1.45 5.412a6.082 6.082 0 0 1 8.618 7.002l-5.412-1.45a6.082 6.082 0 0 1-7.002 8.618l1.45-5.412Z"/> <path d="M12 12v.01"/> </svg>',"filter-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.013 3H2l8 9.46V19l4 2v-8.54l.9-1.055"/> <path d="m22 3-5 5"/> <path d="m17 3 5 5"/> </svg>',"text-quote":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 6H3"/> <path d="M21 12H8"/> <path d="M21 18H8"/> <path d="M3 12v6"/> </svg>',"map-pin-minus-inside":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10c0 4.993-5.539 10.193-7.399 11.799a1 1 0 0 1-1.202 0C9.539 20.193 4 14.993 4 10a8 8 0 0 1 16 0"/> <path d="M9 10h6"/> </svg>',gift:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="3" y="8" width="18" height="4" rx="1"/> <path d="M12 8v13"/> <path d="M19 12v7a2 2 0 0 1-2 2H7a2 2 0 0 1-2-2v-7"/> <path d="M7.5 8a2.5 2.5 0 0 1 0-5A4.8 8 0 0 1 12 8a4.8 8 0 0 1 4.5-5 2.5 2.5 0 0 1 0 5"/> </svg>',asterisk:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 6v12"/> <path d="M17.196 9 6.804 15"/> <path d="m6.804 9 10.392 6"/> </svg>',check:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 6 9 17l-5-5"/> </svg>',headphones:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 14h3a2 2 0 0 1 2 2v3a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-7a9 9 0 0 1 18 0v7a2 2 0 0 1-2 2h-1a2 2 0 0 1-2-2v-3a2 2 0 0 1 2-2h3"/> </svg>',navigation:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="3 11 22 2 13 21 11 13 3 11"/> </svg>',sailboat:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 18H2a4 4 0 0 0 4 4h12a4 4 0 0 0 4-4Z"/> <path d="M21 14 10 2 3 14h18Z"/> <path d="M10 2v16"/> </svg>',syringe:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m18 2 4 4"/> <path d="m17 7 3-3"/> <path d="M19 9 8.7 19.3c-1 1-2.5 1-3.4 0l-.6-.6c-1-1-1-2.5 0-3.4L15 5"/> <path d="m9 11 4 4"/> <path d="m5 19-3 3"/> <path d="m14 4 6 6"/> </svg>',"tram-front":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="16" x="4" y="3" rx="2"/> <path d="M4 11h16"/> <path d="M12 3v8"/> <path d="m8 19-2 3"/> <path d="m18 22-2-3"/> <path d="M8 15h.01"/> <path d="M16 15h.01"/> </svg>',"folder-open-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 14 1.45-2.9A2 2 0 0 1 9.24 10H20a2 2 0 0 1 1.94 2.5l-1.55 6a2 2 0 0 1-1.94 1.5H4a2 2 0 0 1-2-2V5c0-1.1.9-2 2-2h3.93a2 2 0 0 1 1.66.9l.82 1.2a2 2 0 0 0 1.66.9H18a2 2 0 0 1 2 2v2"/> <circle cx="14" cy="15" r="1"/> </svg>',wifi:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20h.01"/> <path d="M2 8.82a15 15 0 0 1 20 0"/> <path d="M5 12.859a10 10 0 0 1 14 0"/> <path d="M8.5 16.429a5 5 0 0 1 7 0"/> </svg>',"octagon-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.586 16.726A2 2 0 0 1 2 15.312V8.688a2 2 0 0 1 .586-1.414l4.688-4.688A2 2 0 0 1 8.688 2h6.624a2 2 0 0 1 1.414.586l4.688 4.688A2 2 0 0 1 22 8.688v6.624a2 2 0 0 1-.586 1.414l-4.688 4.688a2 2 0 0 1-1.414.586H8.688a2 2 0 0 1-1.414-.586z"/> <path d="M8 12h8"/> </svg>',"between-vertical-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="13" x="3" y="3" rx="1"/> <path d="m9 22 3-3 3 3"/> <rect width="7" height="13" x="14" y="3" rx="1"/> </svg>',minimize:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 3v3a2 2 0 0 1-2 2H3"/> <path d="M21 8h-3a2 2 0 0 1-2-2V3"/> <path d="M3 16h3a2 2 0 0 1 2 2v3"/> <path d="M16 21v-3a2 2 0 0 1 2-2h3"/> </svg>',"bot-message-square":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 6V2H8"/> <path d="m8 18-4 4V8a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v8a2 2 0 0 1-2 2Z"/> <path d="M2 12h2"/> <path d="M9 11v2"/> <path d="M15 11v2"/> <path d="M20 12h2"/> </svg>',server:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="8" x="2" y="2" rx="2" ry="2"/> <rect width="20" height="8" x="2" y="14" rx="2" ry="2"/> <line x1="6" x2="6.01" y1="6" y2="6"/> <line x1="6" x2="6.01" y1="18" y2="18"/> </svg>',"signpost-big":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 9H4L2 7l2-2h6"/> <path d="M14 5h6l2 2-2 2h-6"/> <path d="M10 22V4a2 2 0 1 1 4 0v18"/> <path d="M8 22h8"/> </svg>',trash:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 6h18"/> <path d="M19 6v14c0 1-1 2-2 2H7c-1 0-2-1-2-2V6"/> <path d="M8 6V4c0-1 1-2 2-2h4c1 0 2 1 2 2v2"/> </svg>',signature:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21 17-2.156-1.868A.5.5 0 0 0 18 15.5v.5a1 1 0 0 1-1 1h-2a1 1 0 0 1-1-1c0-2.545-3.991-3.97-8.5-4a1 1 0 0 0 0 5c4.153 0 4.745-11.295 5.708-13.5a2.5 2.5 0 1 1 3.31 3.284"/> <path d="M3 21h18"/> </svg>',"folder-closed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> <path d="M2 10h20"/> </svg>',"image-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 9v10a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h7"/> <line x1="16" x2="22" y1="5" y2="5"/> <circle cx="9" cy="9" r="2"/> <path d="m21 15-3.086-3.086a2 2 0 0 0-2.828 0L6 21"/> </svg>',"circle-ellipsis":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M17 12h.01"/> <path d="M12 12h.01"/> <path d="M7 12h.01"/> </svg>',"align-horizontal-distribute-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="14" x="4" y="5" rx="2"/> <rect width="6" height="10" x="14" y="7" rx="2"/> <path d="M10 2v20"/> <path d="M20 2v20"/> </svg>',"arrow-up-from-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m18 9-6-6-6 6"/> <path d="M12 3v14"/> <path d="M5 21h14"/> </svg>',laptop:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 16V7a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v9m16 0H4m16 0 1.28 2.55a1 1 0 0 1-.9 1.45H3.62a1 1 0 0 1-.9-1.45L4 16"/> </svg>',"lamp-ceiling":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v5"/> <path d="M6 7h12l4 9H2l4-9Z"/> <path d="M9.17 16a3 3 0 1 0 5.66 0"/> </svg>',"square-parking":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 17V7h4a3 3 0 0 1 0 6H9"/> </svg>',"table-cells-split":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 15V9"/> <path d="M3 15h18"/> <path d="M3 9h18"/> <rect width="18" height="18" x="3" y="3" rx="2"/> </svg>',"book-user":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 13a3 3 0 1 0-6 0"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <circle cx="12" cy="8" r="2"/> </svg>',"square-dashed-mouse-pointer":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.034 12.681a.498.498 0 0 1 .647-.647l9 3.5a.5.5 0 0 1-.033.943l-3.444 1.068a1 1 0 0 0-.66.66l-1.067 3.443a.5.5 0 0 1-.943.033z"/> <path d="M5 3a2 2 0 0 0-2 2"/> <path d="M19 3a2 2 0 0 1 2 2"/> <path d="M5 21a2 2 0 0 1-2-2"/> <path d="M9 3h1"/> <path d="M9 21h2"/> <path d="M14 3h1"/> <path d="M3 9v1"/> <path d="M21 9v2"/> <path d="M3 14v1"/> </svg>',"bring-to-front":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="8" y="8" width="8" height="8" rx="2"/> <path d="M4 10a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2"/> <path d="M14 20a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2v-4a2 2 0 0 0-2-2"/> </svg>',"arrow-big-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 6v6h4l-7 7-7-7h4V6h6z"/> </svg>',"pc-case":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="20" x="5" y="2" rx="2"/> <path d="M15 14h.01"/> <path d="M9 6h6"/> <path d="M9 10h6"/> </svg>',"square-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M8 12h8"/> </svg>',"dice-5":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="M16 8h.01"/> <path d="M8 8h.01"/> <path d="M8 16h.01"/> <path d="M16 16h.01"/> <path d="M12 12h.01"/> </svg>',"file-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M9 15h6"/> <path d="M12 18v-6"/> </svg>',umbrella:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 12a10.06 10.06 1 0 0-20 0Z"/> <path d="M12 12v8a2 2 0 0 0 4 0"/> <path d="M12 2v1"/> </svg>',ampersands:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 17c-5-3-7-7-7-9a2 2 0 0 1 4 0c0 2.5-5 2.5-5 6 0 1.7 1.3 3 3 3 2.8 0 5-2.2 5-5"/> <path d="M22 17c-5-3-7-7-7-9a2 2 0 0 1 4 0c0 2.5-5 2.5-5 6 0 1.7 1.3 3 3 3 2.8 0 5-2.2 5-5"/> </svg>',"panel-top-close":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 9h18"/> <path d="m9 16 3-3 3 3"/> </svg>',"monitor-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14.5 12.5-5-5"/> <path d="m9.5 12.5 5-5"/> <rect width="20" height="14" x="2" y="3" rx="2"/> <path d="M12 17v4"/> <path d="M8 21h8"/> </svg>',type:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="4 7 4 4 20 4 20 7"/> <line x1="9" x2="15" y1="20" y2="20"/> <line x1="12" x2="12" y1="4" y2="20"/> </svg>',terminal:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="4 17 10 11 4 5"/> <line x1="12" x2="20" y1="19" y2="19"/> </svg>',"chevrons-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 6 5 5 5-5"/> <path d="m7 13 5 5 5-5"/> </svg>',"user-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 21v-2a4 4 0 0 0-4-4H6a4 4 0 0 0-4 4v2"/> <circle cx="9" cy="7" r="4"/> <polyline points="16 11 18 13 22 9"/> </svg>',meh:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <line x1="8" x2="16" y1="15" y2="15"/> <line x1="9" x2="9.01" y1="9" y2="9"/> <line x1="15" x2="15.01" y1="9" y2="9"/> </svg>',"square-radical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 12h2l2 5 2-10h4"/> <rect x="3" y="3" width="18" height="18" rx="2"/> </svg>',"move-down-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 19H5V13"/> <path d="M19 5L5 19"/> </svg>',"cloud-download":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13v8l-4-4"/> <path d="m12 21 4-4"/> <path d="M4.393 15.269A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.436 8.284"/> </svg>',piano:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18.5 8c-1.4 0-2.6-.8-3.2-2A6.87 6.87 0 0 0 2 9v11a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-8.5C22 9.6 20.4 8 18.5 8"/> <path d="M2 14h20"/> <path d="M6 14v4"/> <path d="M10 14v4"/> <path d="M14 14v4"/> <path d="M18 14v4"/> </svg>',workflow:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="8" x="3" y="3" rx="2"/> <path d="M7 11v4a2 2 0 0 0 2 2h4"/> <rect width="8" height="8" x="13" y="13" rx="2"/> </svg>',"whole-word":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="7" cy="12" r="3"/> <path d="M10 9v6"/> <circle cx="17" cy="12" r="3"/> <path d="M14 7v8"/> <path d="M22 17v1c0 .5-.5 1-1 1H3c-.5 0-1-.5-1-1v-1"/> </svg>',inbox:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="22 12 16 12 14 15 10 15 8 12 2 12"/> <path d="M5.45 5.11 2 12v6a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-6l-3.45-6.89A2 2 0 0 0 16.76 4H7.24a2 2 0 0 0-1.79 1.11z"/> </svg>',"folder-pen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 11.5V5a2 2 0 0 1 2-2h3.9c.7 0 1.3.3 1.7.9l.8 1.2c.4.6 1 .9 1.7.9H20a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2h-9.5"/> <path d="M11.378 13.626a1 1 0 1 0-3.004-3.004l-5.01 5.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> </svg>',"phone-call":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 16.92v3a2 2 0 0 1-2.18 2 19.79 19.79 0 0 1-8.63-3.07 19.5 19.5 0 0 1-6-6 19.79 19.79 0 0 1-3.07-8.67A2 2 0 0 1 4.11 2h3a2 2 0 0 1 2 1.72 12.84 12.84 0 0 0 .7 2.81 2 2 0 0 1-.45 2.11L8.09 9.91a16 16 0 0 0 6 6l1.27-1.27a2 2 0 0 1 2.11-.45 12.84 12.84 0 0 0 2.81.7A2 2 0 0 1 22 16.92z"/> <path d="M14.05 2a9 9 0 0 1 8 7.94"/> <path d="M14.05 6A5 5 0 0 1 18 10"/> </svg>',"message-square-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11.7 3H5a2 2 0 0 0-2 2v16l4-4h12a2 2 0 0 0 2-2v-2.7"/> <circle cx="18" cy="6" r="3"/> </svg>',"square-percent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m15 9-6 6"/> <path d="M9 9h.01"/> <path d="M15 15h.01"/> </svg>',variable:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 21s-4-3-4-9 4-9 4-9"/> <path d="M16 3s4 3 4 9-4 9-4 9"/> <line x1="15" x2="9" y1="9" y2="15"/> <line x1="9" x2="15" y1="9" y2="15"/> </svg>',podcast:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16.85 18.58a9 9 0 1 0-9.7 0"/> <path d="M8 14a5 5 0 1 1 8 0"/> <circle cx="12" cy="11" r="1"/> <path d="M13 17a1 1 0 1 0-2 0l.5 4.5a.5.5 0 1 0 1 0Z"/> </svg>',"indian-rupee":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 3h12"/> <path d="M6 8h12"/> <path d="m6 13 8.5 8"/> <path d="M6 13h3"/> <path d="M9 13c6.667 0 6.667-10 0-10"/> </svg>',"align-vertical-space-between":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="6" x="5" y="15" rx="2"/> <rect width="10" height="6" x="7" y="3" rx="2"/> <path d="M2 21h20"/> <path d="M2 3h20"/> </svg>',nfc:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 8.32a7.43 7.43 0 0 1 0 7.36"/> <path d="M9.46 6.21a11.76 11.76 0 0 1 0 11.58"/> <path d="M12.91 4.1a15.91 15.91 0 0 1 .01 15.8"/> <path d="M16.37 2a20.16 20.16 0 0 1 0 20"/> </svg>',microscope:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 18h8"/> <path d="M3 22h18"/> <path d="M14 22a7 7 0 1 0 0-14h-1"/> <path d="M9 14h2"/> <path d="M9 12a2 2 0 0 1-2-2V6h6v4a2 2 0 0 1-2 2Z"/> <path d="M12 6V3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3"/> </svg>',grab:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 11.5V9a2 2 0 0 0-2-2a2 2 0 0 0-2 2v1.4"/> <path d="M14 10V8a2 2 0 0 0-2-2a2 2 0 0 0-2 2v2"/> <path d="M10 9.9V9a2 2 0 0 0-2-2a2 2 0 0 0-2 2v5"/> <path d="M6 14a2 2 0 0 0-2-2a2 2 0 0 0-2 2"/> <path d="M18 11a2 2 0 1 1 4 0v3a8 8 0 0 1-8 8h-4a8 8 0 0 1-8-8 2 2 0 1 1 4 0"/> </svg>',"folder-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 10v6"/> <path d="M9 13h6"/> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> </svg>',star:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"/> </svg>',presentation:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 3h20"/> <path d="M21 3v11a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V3"/> <path d="m7 21 5-5 5 5"/> </svg>',vault:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <circle cx="7.5" cy="7.5" r=".5" fill="currentColor"/> <path d="m7.9 7.9 2.7 2.7"/> <circle cx="16.5" cy="7.5" r=".5" fill="currentColor"/> <path d="m13.4 10.6 2.7-2.7"/> <circle cx="7.5" cy="16.5" r=".5" fill="currentColor"/> <path d="m7.9 16.1 2.7-2.7"/> <circle cx="16.5" cy="16.5" r=".5" fill="currentColor"/> <path d="m13.4 13.4 2.7 2.7"/> <circle cx="12" cy="12" r="2"/> </svg>',merge:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m8 6 4-4 4 4"/> <path d="M12 2v10.3a4 4 0 0 1-1.172 2.872L4 22"/> <path d="m20 22-5-5"/> </svg>',"chart-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="m19 9-5 5-4-4-3 3"/> </svg>',"bell-electric":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18.8 4A6.3 8.7 0 0 1 20 9"/> <path d="M9 9h.01"/> <circle cx="9" cy="9" r="7"/> <rect width="10" height="6" x="4" y="16" rx="2"/> <path d="M14 19c3 0 4.6-1.6 4.6-1.6"/> <circle cx="20" cy="16" r="2"/> </svg>',mic:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2a3 3 0 0 0-3 3v7a3 3 0 0 0 6 0V5a3 3 0 0 0-3-3Z"/> <path d="M19 10v2a7 7 0 0 1-14 0v-2"/> <line x1="12" x2="12" y1="19" y2="22"/> </svg>',"folder-symlink":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2v-3a2 2 0 0 1 2-2h7"/> <path d="m8 16 3-3-3-3"/> </svg>',"lamp-wall-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 13h6l3 7H8l3-7Z"/> <path d="M14 13V8a2 2 0 0 0-2-2H8"/> <path d="M4 9h2a2 2 0 0 0 2-2V5a2 2 0 0 0-2-2H4v6Z"/> </svg>',import:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3v12"/> <path d="m8 11 4 4 4-4"/> <path d="M8 5H4a2 2 0 0 0-2 2v10a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2h-4"/> </svg>',crosshair:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <line x1="22" x2="18" y1="12" y2="12"/> <line x1="6" x2="2" y1="12" y2="12"/> <line x1="12" x2="12" y1="6" y2="2"/> <line x1="12" x2="12" y1="22" y2="18"/> </svg>',sunset:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 10V2"/> <path d="m4.93 10.93 1.41 1.41"/> <path d="M2 18h2"/> <path d="M20 18h2"/> <path d="m19.07 10.93-1.41 1.41"/> <path d="M22 22H2"/> <path d="m16 6-4 4-4-4"/> <path d="M16 18a4 4 0 0 0-8 0"/> </svg>',"align-horizontal-distribute-start":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="14" x="4" y="5" rx="2"/> <rect width="6" height="10" x="14" y="7" rx="2"/> <path d="M4 2v20"/> <path d="M14 2v20"/> </svg>',castle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 20v-9H2v9a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2Z"/> <path d="M18 11V4H6v7"/> <path d="M15 22v-4a3 3 0 0 0-3-3a3 3 0 0 0-3 3v4"/> <path d="M22 11V9"/> <path d="M2 11V9"/> <path d="M6 4V2"/> <path d="M18 4V2"/> <path d="M10 4V2"/> <path d="M14 4V2"/> </svg>',signal:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 20h.01"/> <path d="M7 20v-4"/> <path d="M12 20v-8"/> <path d="M17 20V8"/> <path d="M22 4v16"/> </svg>',"map-pin-check-inside":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 10c0 4.993-5.539 10.193-7.399 11.799a1 1 0 0 1-1.202 0C9.539 20.193 4 14.993 4 10a8 8 0 0 1 16 0"/> <path d="m9 10 2 2 4-4"/> </svg>',"circle-alert":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <line x1="12" x2="12" y1="8" y2="12"/> <line x1="12" x2="12.01" y1="16" y2="16"/> </svg>',"battery-low":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="10" x="2" y="7" rx="2" ry="2"/> <line x1="22" x2="22" y1="11" y2="13"/> <line x1="6" x2="6" y1="11" y2="13"/> </svg>',"badge-percent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="m15 9-6 6"/> <path d="M9 9h.01"/> <path d="M15 15h.01"/> </svg>',"chart-no-axes-column-increasing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="12" x2="12" y1="20" y2="10"/> <line x1="18" x2="18" y1="20" y2="4"/> <line x1="6" x2="6" y1="20" y2="16"/> </svg>',"shopping-bag":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 2 3 6v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2V6l-3-4Z"/> <path d="M3 6h18"/> <path d="M16 10a4 4 0 0 1-8 0"/> </svg>',"list-todo":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="3" y="5" width="6" height="6" rx="1"/> <path d="m3 17 2 2 4-4"/> <path d="M13 6h8"/> <path d="M13 12h8"/> <path d="M13 18h8"/> </svg>',bird:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 7h.01"/> <path d="M3.4 18H12a8 8 0 0 0 8-8V7a4 4 0 0 0-7.28-2.3L2 20"/> <path d="m20 7 2 .5-2 .5"/> <path d="M10 18v3"/> <path d="M14 17.75V21"/> <path d="M7 18a6 6 0 0 0 3.84-10.61"/> </svg>',armchair:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 9V6a2 2 0 0 0-2-2H7a2 2 0 0 0-2 2v3"/> <path d="M3 16a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-5a2 2 0 0 0-4 0v1.5a.5.5 0 0 1-.5.5h-9a.5.5 0 0 1-.5-.5V11a2 2 0 0 0-4 0z"/> <path d="M5 18v2"/> <path d="M19 18v2"/> </svg>',"table-of-contents":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 12H3"/> <path d="M16 18H3"/> <path d="M16 6H3"/> <path d="M21 12h.01"/> <path d="M21 18h.01"/> <path d="M21 6h.01"/> </svg>',"file-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m9 15 2 2 4-4"/> </svg>',clover:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16.17 7.83 2 22"/> <path d="M4.02 12a2.827 2.827 0 1 1 3.81-4.17A2.827 2.827 0 1 1 12 4.02a2.827 2.827 0 1 1 4.17 3.81A2.827 2.827 0 1 1 19.98 12a2.827 2.827 0 1 1-3.81 4.17A2.827 2.827 0 1 1 12 19.98a2.827 2.827 0 1 1-4.17-3.81A1 1 0 1 1 4 12"/> <path d="m7.83 7.83 8.34 8.34"/> </svg>',"mouse-pointer":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.586 12.586 19 19"/> <path d="M3.688 3.037a.497.497 0 0 0-.651.651l6.5 15.999a.501.501 0 0 0 .947-.062l1.569-6.083a2 2 0 0 1 1.448-1.479l6.124-1.579a.5.5 0 0 0 .063-.947z"/> </svg>',"arrow-down-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 16 4 4 4-4"/> <path d="M7 20V4"/> <path d="m21 8-4-4-4 4"/> <path d="M17 4v16"/> </svg>',mailbox:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 17a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V9.5C2 7 4 5 6.5 5H18c2.2 0 4 1.8 4 4v8Z"/> <polyline points="15,9 18,9 18,11"/> <path d="M6.5 5C9 5 11 7 11 9.5V17a2 2 0 0 1-2 2"/> <line x1="6" x2="7" y1="10" y2="10"/> </svg>',codepen:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="12 2 22 8.5 22 15.5 12 22 2 15.5 2 8.5 12 2"/> <line x1="12" x2="12" y1="22" y2="15.5"/> <polyline points="22 8.5 12 15.5 2 8.5"/> <polyline points="2 15.5 12 8.5 22 15.5"/> <line x1="12" x2="12" y1="2" y2="8.5"/> </svg>',"chart-bar":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M7 16h8"/> <path d="M7 11h12"/> <path d="M7 6h3"/> </svg>',"mic-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" x2="22" y1="2" y2="22"/> <path d="M18.89 13.23A7.12 7.12 0 0 0 19 12v-2"/> <path d="M5 10v2a7 7 0 0 0 12 5"/> <path d="M15 9.34V5a3 3 0 0 0-5.68-1.33"/> <path d="M9 9v3a3 3 0 0 0 5.12 2.12"/> <line x1="12" x2="12" y1="19" y2="22"/> </svg>',church:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 9h4"/> <path d="M12 7v5"/> <path d="M14 22v-4a2 2 0 0 0-4 0v4"/> <path d="M18 22V5.618a1 1 0 0 0-.553-.894l-4.553-2.277a2 2 0 0 0-1.788 0L6.553 4.724A1 1 0 0 0 6 5.618V22"/> <path d="m18 7 3.447 1.724a1 1 0 0 1 .553.894V20a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V9.618a1 1 0 0 1 .553-.894L6 7"/> </svg>',"file-clock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 22h2a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v3"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <circle cx="8" cy="16" r="6"/> <path d="M9.5 17.5 8 16.25V14"/> </svg>',dessert:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="4" r="2"/> <path d="M10.2 3.2C5.5 4 2 8.1 2 13a2 2 0 0 0 4 0v-1a2 2 0 0 1 4 0v4a2 2 0 0 0 4 0v-4a2 2 0 0 1 4 0v1a2 2 0 0 0 4 0c0-4.9-3.5-9-8.2-9.8"/> <path d="M3.2 14.8a9 9 0 0 0 17.6 0"/> </svg>',"fish-symbol":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 16s9-15 20-4C11 23 2 8 2 8"/> </svg>',"folder-lock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="5" x="14" y="17" rx="1"/> <path d="M10 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v2.5"/> <path d="M20 17v-2a2 2 0 1 0-4 0v2"/> </svg>',"log-in":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 3h4a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2h-4"/> <polyline points="10 17 15 12 10 7"/> <line x1="15" x2="3" y1="12" y2="12"/> </svg>',"image-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 5h6"/> <path d="M19 2v6"/> <path d="M21 11.5V19a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h7.5"/> <path d="m21 15-3.086-3.086a2 2 0 0 0-2.828 0L6 21"/> <circle cx="9" cy="9" r="2"/> </svg>',cat:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 5c.67 0 1.35.09 2 .26 1.78-2 5.03-2.84 6.42-2.26 1.4.58-.42 7-.42 7 .57 1.07 1 2.24 1 3.44C21 17.9 16.97 21 12 21s-9-3-9-7.56c0-1.25.5-2.4 1-3.44 0 0-1.89-6.42-.5-7 1.39-.58 4.72.23 6.5 2.23A9.04 9.04 0 0 1 12 5Z"/> <path d="M8 14v.5"/> <path d="M16 14v.5"/> <path d="M11.25 16.25h1.5L12 17l-.75-.75Z"/> </svg>',"list-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 12H3"/> <path d="M16 6H3"/> <path d="M10 18H3"/> <path d="M21 6v10a2 2 0 0 1-2 2h-5"/> <path d="m16 16-2 2 2 2"/> </svg>',"user-round-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 21a8 8 0 0 1 13.292-6"/> <circle cx="10" cy="8" r="5"/> <path d="m16 19 2 2 4-4"/> </svg>',"square-split-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 8V5c0-1 1-2 2-2h10c1 0 2 1 2 2v3"/> <path d="M19 16v3c0 1-1 2-2 2H7c-1 0-2-1-2-2v-3"/> <line x1="4" x2="20" y1="12" y2="12"/> </svg>',"align-start-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="16" x="4" y="6" rx="2"/> <rect width="6" height="9" x="14" y="6" rx="2"/> <path d="M22 2H2"/> </svg>',pyramid:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.5 16.88a1 1 0 0 1-.32-1.43l9-13.02a1 1 0 0 1 1.64 0l9 13.01a1 1 0 0 1-.32 1.44l-8.51 4.86a2 2 0 0 1-1.98 0Z"/> <path d="M12 2v20"/> </svg>',"thumbs-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 14V2"/> <path d="M9 18.12 10 14H4.17a2 2 0 0 1-1.92-2.56l2.33-8A2 2 0 0 1 6.5 2H20a2 2 0 0 1 2 2v8a2 2 0 0 1-2 2h-2.76a2 2 0 0 0-1.79 1.11L12 22a3.13 3.13 0 0 1-3-3.88Z"/> </svg>',"sliders-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="4" x2="4" y1="21" y2="14"/> <line x1="4" x2="4" y1="10" y2="3"/> <line x1="12" x2="12" y1="21" y2="12"/> <line x1="12" x2="12" y1="8" y2="3"/> <line x1="20" x2="20" y1="21" y2="16"/> <line x1="20" x2="20" y1="12" y2="3"/> <line x1="2" x2="6" y1="14" y2="14"/> <line x1="10" x2="14" y1="8" y2="8"/> <line x1="18" x2="22" y1="16" y2="16"/> </svg>',"folder-input":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2v-1"/> <path d="M2 13h10"/> <path d="m9 16 3-3-3-3"/> </svg>',pickaxe:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.531 12.469 6.619 20.38a1 1 0 1 1-3-3l7.912-7.912"/> <path d="M15.686 4.314A12.5 12.5 0 0 0 5.461 2.958 1 1 0 0 0 5.58 4.71a22 22 0 0 1 6.318 3.393"/> <path d="M17.7 3.7a1 1 0 0 0-1.4 0l-4.6 4.6a1 1 0 0 0 0 1.4l2.6 2.6a1 1 0 0 0 1.4 0l4.6-4.6a1 1 0 0 0 0-1.4z"/> <path d="M19.686 8.314a12.501 12.501 0 0 1 1.356 10.225 1 1 0 0 1-1.751-.119 22 22 0 0 0-3.393-6.319"/> </svg>',"phone-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.68 13.31a16 16 0 0 0 3.41 2.6l1.27-1.27a2 2 0 0 1 2.11-.45 12.84 12.84 0 0 0 2.81.7 2 2 0 0 1 1.72 2v3a2 2 0 0 1-2.18 2 19.79 19.79 0 0 1-8.63-3.07 19.42 19.42 0 0 1-3.33-2.67m-2.67-3.34a19.79 19.79 0 0 1-3.07-8.63A2 2 0 0 1 4.11 2h3a2 2 0 0 1 2 1.72 12.84 12.84 0 0 0 .7 2.81 2 2 0 0 1-.45 2.11L8.09 9.91"/> <line x1="22" x2="2" y1="2" y2="22"/> </svg>',"align-end-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="6" x="2" y="4" rx="2"/> <rect width="9" height="6" x="9" y="14" rx="2"/> <path d="M22 22V2"/> </svg>',"arrow-down-to-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v14"/> <path d="m19 9-7 7-7-7"/> <circle cx="12" cy="21" r="1"/> </svg>',"alarm-clock-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6.87 6.87a8 8 0 1 0 11.26 11.26"/> <path d="M19.9 14.25a8 8 0 0 0-9.15-9.15"/> <path d="m22 6-3-3"/> <path d="M6.26 18.67 4 21"/> <path d="m2 2 20 20"/> <path d="M4 4 2 6"/> </svg>',"diamond-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 8v8"/> <path d="M2.7 10.3a2.41 2.41 0 0 0 0 3.41l7.59 7.59a2.41 2.41 0 0 0 3.41 0l7.59-7.59a2.41 2.41 0 0 0 0-3.41L13.7 2.71a2.41 2.41 0 0 0-3.41 0z"/> <path d="M8 12h8"/> </svg>',"russian-ruble":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 11h8a4 4 0 0 0 0-8H9v18"/> <path d="M6 15h8"/> </svg>',"ear-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 18.5a3.5 3.5 0 1 0 7 0c0-1.57.92-2.52 2.04-3.46"/> <path d="M6 8.5c0-.75.13-1.47.36-2.14"/> <path d="M8.8 3.15A6.5 6.5 0 0 1 19 8.5c0 1.63-.44 2.81-1.09 3.76"/> <path d="M12.5 6A2.5 2.5 0 0 1 15 8.5M10 13a2 2 0 0 0 1.82-1.18"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"arrow-up-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 17V7h10"/> <path d="M17 17 7 7"/> </svg>',bolt:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 16V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l7-4A2 2 0 0 0 21 16z"/> <circle cx="12" cy="12" r="4"/> </svg>',"monitor-smartphone":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 8V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v7a2 2 0 0 0 2 2h8"/> <path d="M10 19v-3.96 3.15"/> <path d="M7 19h5"/> <rect width="6" height="10" x="16" y="12" rx="2"/> </svg>',eclipse:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M12 2a7 7 0 1 0 10 10"/> </svg>',"triangle-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 18a2 2 0 0 1-2 2H3c-1.1 0-1.3-.6-.4-1.3L20.4 4.3c.9-.7 1.6-.4 1.6.7Z"/> </svg>',x:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 6 6 18"/> <path d="m6 6 12 12"/> </svg>',"monitor-speaker":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5.5 20H8"/> <path d="M17 9h.01"/> <rect width="10" height="16" x="12" y="4" rx="2"/> <path d="M8 6H4a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4"/> <circle cx="17" cy="15" r="1"/> </svg>',"send-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.714 3.048a.498.498 0 0 0-.683.627l2.843 7.627a2 2 0 0 1 0 1.396l-2.842 7.627a.498.498 0 0 0 .682.627l18-8.5a.5.5 0 0 0 0-.904z"/> <path d="M6 12h16"/> </svg>',"circle-slash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <line x1="9" x2="15" y1="15" y2="9"/> </svg>',"file-x-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m8 12.5-5 5"/> <path d="m3 12.5 5 5"/> </svg>',download:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15v4a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-4"/> <polyline points="7 10 12 15 17 10"/> <line x1="12" x2="12" y1="15" y2="3"/> </svg>',"folder-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> <path d="M12 10v6"/> <path d="m9 13 3-3 3 3"/> </svg>',book:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> </svg>',"disc-album":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <circle cx="12" cy="12" r="5"/> <path d="M12 12h.01"/> </svg>',"utensils-crossed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16 2-2.3 2.3a3 3 0 0 0 0 4.2l1.8 1.8a3 3 0 0 0 4.2 0L22 8"/> <path d="M15 15 3.3 3.3a4.2 4.2 0 0 0 0 6l7.3 7.3c.7.7 2 .7 2.8 0L15 15Zm0 0 7 7"/> <path d="m2.1 21.8 6.4-6.3"/> <path d="m19 5-7 7"/> </svg>',"candy-cane":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5.7 21a2 2 0 0 1-3.5-2l8.6-14a6 6 0 0 1 10.4 6 2 2 0 1 1-3.464-2 2 2 0 1 0-3.464-2Z"/> <path d="M17.75 7 15 2.1"/> <path d="M10.9 4.8 13 9"/> <path d="m7.9 9.7 2 4.4"/> <path d="M4.9 14.7 7 18.9"/> </svg>',leaf:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 20A7 7 0 0 1 9.8 6.1C15.5 5 17 4.48 19 2c1 2 2 4.18 2 8 0 5.5-4.78 10-10 10Z"/> <path d="M2 21c0-3 1.85-5.36 5.08-6C9.5 14.52 12 13 13 12"/> </svg>',"message-square-more":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="M8 10h.01"/> <path d="M12 10h.01"/> <path d="M16 10h.01"/> </svg>',"umbrella-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v1"/> <path d="M15.5 21a1.85 1.85 0 0 1-3.5-1v-8H2a10 10 0 0 1 3.428-6.575"/> <path d="M17.5 12H22A10 10 0 0 0 9.004 3.455"/> <path d="m2 2 20 20"/> </svg>',"arrow-down-narrow-wide":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 16 4 4 4-4"/> <path d="M7 20V4"/> <path d="M11 4h4"/> <path d="M11 8h7"/> <path d="M11 12h10"/> </svg>',"power-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18.36 6.64A9 9 0 0 1 20.77 15"/> <path d="M6.16 6.16a9 9 0 1 0 12.68 12.68"/> <path d="M12 2v4"/> <path d="m2 2 20 20"/> </svg>',"layers-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12.83 2.18a2 2 0 0 0-1.66 0L2.6 6.08a1 1 0 0 0 0 1.83l8.58 3.91a2 2 0 0 0 1.66 0l8.58-3.9a1 1 0 0 0 0-1.83Z"/> <path d="m6.08 9.5-3.5 1.6a1 1 0 0 0 0 1.81l8.6 3.91a2 2 0 0 0 1.65 0l8.58-3.9a1 1 0 0 0 0-1.83l-3.5-1.59"/> <path d="m6.08 14.5-3.5 1.6a1 1 0 0 0 0 1.81l8.6 3.91a2 2 0 0 0 1.65 0l8.58-3.9a1 1 0 0 0 0-1.83l-3.5-1.59"/> </svg>',club:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17.28 9.05a5.5 5.5 0 1 0-10.56 0A5.5 5.5 0 1 0 12 17.66a5.5 5.5 0 1 0 5.28-8.6Z"/> <path d="M12 17.66L12 22"/> </svg>',"pen-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m10 10-6.157 6.162a2 2 0 0 0-.5.833l-1.322 4.36a.5.5 0 0 0 .622.624l4.358-1.323a2 2 0 0 0 .83-.5L14 13.982"/> <path d="m12.829 7.172 4.359-4.346a1 1 0 1 1 3.986 3.986l-4.353 4.353"/> <path d="m2 2 20 20"/> </svg>',"locate-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" x2="5" y1="12" y2="12"/> <line x1="19" x2="22" y1="12" y2="12"/> <line x1="12" x2="12" y1="2" y2="5"/> <line x1="12" x2="12" y1="19" y2="22"/> <path d="M7.11 7.11C5.83 8.39 5 10.1 5 12c0 3.87 3.13 7 7 7 1.9 0 3.61-.83 4.89-2.11"/> <path d="M18.71 13.96c.19-.63.29-1.29.29-1.96 0-3.87-3.13-7-7-7-.67 0-1.33.1-1.96.29"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"mountain-snow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m8 3 4 8 5-5 5 15H2L8 3z"/> <path d="M4.14 15.08c2.62-1.57 5.24-1.43 7.86.42 2.74 1.94 5.49 2 8.23.19"/> </svg>',"notebook-pen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.4 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2v-7.4"/> <path d="M2 6h4"/> <path d="M2 10h4"/> <path d="M2 14h4"/> <path d="M2 18h4"/> <path d="M21.378 5.626a1 1 0 1 0-3.004-3.004l-5.01 5.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> </svg>',"message-square-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="M12 7v6"/> <path d="M9 10h6"/> </svg>',scroll:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 17V5a2 2 0 0 0-2-2H4"/> <path d="M8 21h12a2 2 0 0 0 2-2v-1a1 1 0 0 0-1-1H11a1 1 0 0 0-1 1v1a2 2 0 1 1-4 0V5a2 2 0 1 0-4 0v2a1 1 0 0 0 1 1h3"/> </svg>',"chart-no-axes-column":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="18" x2="18" y1="20" y2="10"/> <line x1="12" x2="12" y1="20" y2="4"/> <line x1="6" x2="6" y1="20" y2="14"/> </svg>',"wrap-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="3" x2="21" y1="6" y2="6"/> <path d="M3 12h15a3 3 0 1 1 0 6h-4"/> <polyline points="16 16 14 18 16 20"/> <line x1="3" x2="10" y1="18" y2="18"/> </svg>',"receipt-swiss-franc":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M10 17V7h5"/> <path d="M10 11h4"/> <path d="M8 15h5"/> </svg>',fence:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 3 2 5v15c0 .6.4 1 1 1h2c.6 0 1-.4 1-1V5Z"/> <path d="M6 8h4"/> <path d="M6 18h4"/> <path d="m12 3-2 2v15c0 .6.4 1 1 1h2c.6 0 1-.4 1-1V5Z"/> <path d="M14 8h4"/> <path d="M14 18h4"/> <path d="m20 3-2 2v15c0 .6.4 1 1 1h2c.6 0 1-.4 1-1V5Z"/> </svg>',"moon-star":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3a6 6 0 0 0 9 9 9 9 0 1 1-9-9"/> <path d="M20 3v4"/> <path d="M22 5h-4"/> </svg>',anchor:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22V8"/> <path d="M5 12H2a10 10 0 0 0 20 0h-3"/> <circle cx="12" cy="5" r="3"/> </svg>',"receipt-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M14 8H8"/> <path d="M16 12H8"/> <path d="M13 16H8"/> </svg>',"map-pin-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18.977 14C19.6 12.701 20 11.343 20 10a8 8 0 0 0-16 0c0 4.993 5.539 10.193 7.399 11.799a1 1 0 0 0 1.202 0 32 32 0 0 0 .824-.738"/> <circle cx="12" cy="10" r="3"/> <path d="M16 18h6"/> </svg>',"file-music":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="14" cy="16" r="2"/> <circle cx="6" cy="18" r="2"/> <path d="M4 12.4V4a2 2 0 0 1 2-2h8.5L20 7.5V20a2 2 0 0 1-2 2h-7.5"/> <path d="M8 18v-7.7L16 9v7"/> </svg>',"file-volume":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 11a5 5 0 0 1 0 6"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M4 6.765V4a2 2 0 0 1 2-2h9l5 5v13a2 2 0 0 1-2 2H6a2 2 0 0 1-.93-.23"/> <path d="M7 10.51a.5.5 0 0 0-.826-.38l-1.893 1.628A1 1 0 0 1 3.63 12H2.5a.5.5 0 0 0-.5.5v3a.5.5 0 0 0 .5.5h1.129a1 1 0 0 1 .652.242l1.893 1.63a.5.5 0 0 0 .826-.38z"/> </svg>',grip:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="5" r="1"/> <circle cx="19" cy="5" r="1"/> <circle cx="5" cy="5" r="1"/> <circle cx="12" cy="12" r="1"/> <circle cx="19" cy="12" r="1"/> <circle cx="5" cy="12" r="1"/> <circle cx="12" cy="19" r="1"/> <circle cx="19" cy="19" r="1"/> <circle cx="5" cy="19" r="1"/> </svg>',divide:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="6" r="1"/> <line x1="5" x2="19" y1="12" y2="12"/> <circle cx="12" cy="18" r="1"/> </svg>',slack:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="3" height="8" x="13" y="2" rx="1.5"/> <path d="M19 8.5V10h1.5A1.5 1.5 0 1 0 19 8.5"/> <rect width="3" height="8" x="8" y="14" rx="1.5"/> <path d="M5 15.5V14H3.5A1.5 1.5 0 1 0 5 15.5"/> <rect width="8" height="3" x="14" y="13" rx="1.5"/> <path d="M15.5 19H14v1.5a1.5 1.5 0 1 0 1.5-1.5"/> <rect width="8" height="3" x="2" y="8" rx="1.5"/> <path d="M8.5 5H10V3.5A1.5 1.5 0 1 0 8.5 5"/> </svg>',"flip-vertical-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m17 3-5 5-5-5h10"/> <path d="m17 21-5-5-5 5h10"/> <path d="M4 12H2"/> <path d="M10 12H8"/> <path d="M16 12h-2"/> <path d="M22 12h-2"/> </svg>',"vibrate-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 8 2 2-2 2 2 2-2 2"/> <path d="m22 8-2 2 2 2-2 2 2 2"/> <path d="M8 8v10c0 .55.45 1 1 1h6c.55 0 1-.45 1-1v-2"/> <path d="M16 10.34V6c0-.55-.45-1-1-1h-4.34"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"hdmi-port":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 9a1 1 0 0 0-1-1H3a1 1 0 0 0-1 1v4a1 1 0 0 0 1 1h1l2 2h12l2-2h1a1 1 0 0 0 1-1Z"/> <path d="M7.5 12h9"/> </svg>',"move-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 18L12 22L16 18"/> <path d="M12 2V22"/> </svg>',satellite:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 7 9 3 5 7l4 4"/> <path d="m17 11 4 4-4 4-4-4"/> <path d="m8 12 4 4 6-6-4-4Z"/> <path d="m16 8 3-3"/> <path d="M9 21a6 6 0 0 0-6-6"/> </svg>',"pound-sterling":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 7c0-5.333-8-5.333-8 0"/> <path d="M10 7v14"/> <path d="M6 21h12"/> <path d="M6 13h10"/> </svg>',"flip-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 3H5a2 2 0 0 0-2 2v14c0 1.1.9 2 2 2h3"/> <path d="M16 3h3a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2h-3"/> <path d="M12 20v2"/> <path d="M12 14v2"/> <path d="M12 8v2"/> <path d="M12 2v2"/> </svg>',beaker:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4.5 3h15"/> <path d="M6 3v16a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2V3"/> <path d="M6 14h12"/> </svg>',newspaper:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h16a2 2 0 0 0 2-2V4a2 2 0 0 0-2-2H8a2 2 0 0 0-2 2v16a2 2 0 0 1-2 2Zm0 0a2 2 0 0 1-2-2v-9c0-1.1.9-2 2-2h2"/> <path d="M18 14h-8"/> <path d="M15 18h-5"/> <path d="M10 6h8v4h-8V6Z"/> </svg>',"square-user":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <circle cx="12" cy="10" r="3"/> <path d="M7 21v-2a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2v2"/> </svg>',spline:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="19" cy="5" r="2"/> <circle cx="5" cy="19" r="2"/> <path d="M5 17A12 12 0 0 1 17 5"/> </svg>',"link-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 17H7A5 5 0 0 1 7 7h2"/> <path d="M15 7h2a5 5 0 1 1 0 10h-2"/> <line x1="8" x2="16" y1="12" y2="12"/> </svg>',guitar:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m11.9 12.1 4.514-4.514"/> <path d="M20.1 2.3a1 1 0 0 0-1.4 0l-1.114 1.114A2 2 0 0 0 17 4.828v1.344a2 2 0 0 1-.586 1.414A2 2 0 0 1 17.828 7h1.344a2 2 0 0 0 1.414-.586L21.7 5.3a1 1 0 0 0 0-1.4z"/> <path d="m6 16 2 2"/> <path d="M8.2 9.9C8.7 8.8 9.8 8 11 8c2.8 0 5 2.2 5 5 0 1.2-.8 2.3-1.9 2.8l-.9.4A2 2 0 0 0 12 18a4 4 0 0 1-4 4c-3.3 0-6-2.7-6-6a4 4 0 0 1 4-4 2 2 0 0 0 1.8-1.2z"/> <circle cx="11.5" cy="12.5" r=".5" fill="currentColor"/> </svg>',"piggy-bank":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 5c-1.5 0-2.8 1.4-3 2-3.5-1.5-11-.3-11 5 0 1.8 0 3 2 4.5V20h4v-2h3v2h4v-4c1-.5 1.7-1 2-2h2v-4h-2c0-1-.5-1.5-1-2V5z"/> <path d="M2 9v1c0 1.1.9 2 2 2h1"/> <path d="M16 11h.01"/> </svg>',"square-slash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <line x1="9" x2="15" y1="15" y2="9"/> </svg>',sunrise:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v8"/> <path d="m4.93 10.93 1.41 1.41"/> <path d="M2 18h2"/> <path d="M20 18h2"/> <path d="m19.07 10.93-1.41 1.41"/> <path d="M22 22H2"/> <path d="m8 6 4-4 4 4"/> <path d="M16 18a4 4 0 0 0-8 0"/> </svg>',"git-pull-request-create-arrow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="5" cy="6" r="3"/> <path d="M5 9v12"/> <path d="m15 9-3-3 3-3"/> <path d="M12 6h5a2 2 0 0 1 2 2v3"/> <path d="M19 15v6"/> <path d="M22 18h-6"/> </svg>',disc:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <circle cx="12" cy="12" r="2"/> </svg>',"toggle-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="12" x="2" y="6" rx="6" ry="6"/> <circle cx="8" cy="12" r="2"/> </svg>',"file-badge-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <circle cx="12" cy="10" r="3"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m14 12.5 1 5.5-3-1-3 1 1-5.5"/> </svg>',ghost:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 10h.01"/> <path d="M15 10h.01"/> <path d="M12 2a8 8 0 0 0-8 8v12l3-3 2.5 2.5L12 19l2.5 2.5L17 19l3 3V10a8 8 0 0 0-8-8z"/> </svg>',"chart-candlestick":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 5v4"/> <rect width="4" height="6" x="7" y="9" rx="1"/> <path d="M9 15v2"/> <path d="M17 3v2"/> <rect width="4" height="8" x="15" y="5" rx="1"/> <path d="M17 13v3"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> </svg>',"picture-in-picture-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 9V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v10c0 1.1.9 2 2 2h4"/> <rect width="10" height="7" x="12" y="13" rx="2"/> </svg>',"monitor-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17v4"/> <path d="m15.2 4.9-.9-.4"/> <path d="m15.2 7.1-.9.4"/> <path d="m16.9 3.2-.4-.9"/> <path d="m16.9 8.8-.4.9"/> <path d="m19.5 2.3-.4.9"/> <path d="m19.5 9.7-.4-.9"/> <path d="m21.7 4.5-.9.4"/> <path d="m21.7 7.5-.9-.4"/> <path d="M22 13v2a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h7"/> <path d="M8 21h8"/> <circle cx="18" cy="6" r="3"/> </svg>',"circle-dollar-sign":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M16 8h-6a2 2 0 1 0 0 4h4a2 2 0 1 1 0 4H8"/> <path d="M12 18V6"/> </svg>',"flip-horizontal-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 7 5 5-5 5V7"/> <path d="m21 7-5 5 5 5V7"/> <path d="M12 20v2"/> <path d="M12 14v2"/> <path d="M12 8v2"/> <path d="M12 2v2"/> </svg>',"chart-no-axes-gantt":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 6h10"/> <path d="M6 12h9"/> <path d="M11 18h7"/> </svg>',"arrow-big-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 15h-6v4l-7-7 7-7v4h6v6z"/> </svg>',sigma:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 7V5a1 1 0 0 0-1-1H6.5a.5.5 0 0 0-.4.8l4.5 6a2 2 0 0 1 0 2.4l-4.5 6a.5.5 0 0 0 .4.8H17a1 1 0 0 0 1-1v-2"/> </svg>',heart:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 14c1.49-1.46 3-3.21 3-5.5A5.5 5.5 0 0 0 16.5 3c-1.76 0-3 .5-4.5 2-1.5-1.5-2.74-2-4.5-2A5.5 5.5 0 0 0 2 8.5c0 2.3 1.5 4.05 3 5.5l7 7Z"/> </svg>',"square-m":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M8 16V8l4 4 4-4v8"/> </svg>',percent:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="19" x2="5" y1="5" y2="19"/> <circle cx="6.5" cy="6.5" r="2.5"/> <circle cx="17.5" cy="17.5" r="2.5"/> </svg>',"credit-card":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="14" x="2" y="5" rx="2"/> <line x1="2" x2="22" y1="10" y2="10"/> </svg>',"bell-ring":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 8a6 6 0 0 1 12 0c0 7 3 9 3 9H3s3-2 3-9"/> <path d="M10.3 21a1.94 1.94 0 0 0 3.4 0"/> <path d="M4 2C2.8 3.7 2 5.7 2 8"/> <path d="M22 8c0-2.3-.8-4.3-2-6"/> </svg>',"search-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m13.5 8.5-5 5"/> <path d="m8.5 8.5 5 5"/> <circle cx="11" cy="11" r="8"/> <path d="m21 21-4.3-4.3"/> </svg>',ampersand:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17.5 12c0 4.4-3.6 8-8 8A4.5 4.5 0 0 1 5 15.5c0-6 8-4 8-8.5a3 3 0 1 0-6 0c0 3 2.5 8.5 12 13"/> <path d="M16 12h3"/> </svg>',"clock-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.228 21.925A10 10 0 1 1 21.994 12.338"/> <path d="M12 6v6l1.562.781"/> <path d="m14 18 4-4 4 4"/> <path d="M18 22v-8"/> </svg>',keyboard:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 8h.01"/> <path d="M12 12h.01"/> <path d="M14 8h.01"/> <path d="M16 12h.01"/> <path d="M18 8h.01"/> <path d="M6 8h.01"/> <path d="M7 16h10"/> <path d="M8 12h.01"/> <rect width="20" height="16" x="2" y="4" rx="2"/> </svg>',cast:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 8V6a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v12a2 2 0 0 1-2 2h-6"/> <path d="M2 12a9 9 0 0 1 8 8"/> <path d="M2 16a5 5 0 0 1 4 4"/> <line x1="2" x2="2.01" y1="20" y2="20"/> </svg>',ungroup:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="6" x="5" y="4" rx="1"/> <rect width="8" height="6" x="11" y="14" rx="1"/> </svg>',"alarm-smoke":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 21c0-2.5 2-2.5 2-5"/> <path d="M16 21c0-2.5 2-2.5 2-5"/> <path d="m19 8-.8 3a1.25 1.25 0 0 1-1.2 1H7a1.25 1.25 0 0 1-1.2-1L5 8"/> <path d="M21 3a1 1 0 0 1 1 1v2a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V4a1 1 0 0 1 1-1z"/> <path d="M6 21c0-2.5 2-2.5 2-5"/> </svg>',forward:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="15 17 20 12 15 7"/> <path d="M4 18v-2a4 4 0 0 1 4-4h12"/> </svg>',"book-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M9 10h6"/> </svg>',"printer-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.5 22H7a1 1 0 0 1-1-1v-6a1 1 0 0 1 1-1h10a1 1 0 0 1 1 1v.5"/> <path d="m16 19 2 2 4-4"/> <path d="M6 18H4a2 2 0 0 1-2-2v-5a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v2"/> <path d="M6 9V3a1 1 0 0 1 1-1h10a1 1 0 0 1 1 1v6"/> </svg>',"flag-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2c3 0 5 2 8 2s4-1 4-1v11"/> <path d="M4 22V4"/> <path d="M4 15s1-1 4-1 5 2 8 2"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"circle-gauge":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.6 2.7a10 10 0 1 0 5.7 5.7"/> <circle cx="12" cy="12" r="2"/> <path d="M13.4 10.6 19 5"/> </svg>',swords:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="14.5 17.5 3 6 3 3 6 3 17.5 14.5"/> <line x1="13" x2="19" y1="19" y2="13"/> <line x1="16" x2="20" y1="16" y2="20"/> <line x1="19" x2="21" y1="21" y2="19"/> <polyline points="14.5 6.5 18 3 21 3 21 6 17.5 9.5"/> <line x1="5" x2="9" y1="14" y2="18"/> <line x1="7" x2="4" y1="17" y2="20"/> <line x1="3" x2="5" y1="19" y2="21"/> </svg>',"panel-right-close":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M15 3v18"/> <path d="m8 9 3 3-3 3"/> </svg>',"case-lower":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="7" cy="12" r="3"/> <path d="M10 9v6"/> <circle cx="17" cy="12" r="3"/> <path d="M14 7v8"/> </svg>',"clock-8":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 8 14"/> </svg>',copyleft:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M9.17 14.83a4 4 0 1 0 0-5.66"/> </svg>',"train-front-tunnel":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 22V12a10 10 0 1 1 20 0v10"/> <path d="M15 6.8v1.4a3 2.8 0 1 1-6 0V6.8"/> <path d="M10 15h.01"/> <path d="M14 15h.01"/> <path d="M10 19a4 4 0 0 1-4-4v-3a6 6 0 1 1 12 0v3a4 4 0 0 1-4 4Z"/> <path d="m9 19-2 3"/> <path d="m15 19 2 3"/> </svg>',ambulance:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 10H6"/> <path d="M14 18V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v11a1 1 0 0 0 1 1h2"/> <path d="M19 18h2a1 1 0 0 0 1-1v-3.28a1 1 0 0 0-.684-.948l-1.923-.641a1 1 0 0 1-.578-.502l-1.539-3.076A1 1 0 0 0 16.382 8H14"/> <path d="M8 8v4"/> <path d="M9 18h6"/> <circle cx="17" cy="18" r="2"/> <circle cx="7" cy="18" r="2"/> </svg>',pointer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 14a8 8 0 0 1-8 8"/> <path d="M18 11v-1a2 2 0 0 0-2-2a2 2 0 0 0-2 2"/> <path d="M14 10V9a2 2 0 0 0-2-2a2 2 0 0 0-2 2v1"/> <path d="M10 9.5V4a2 2 0 0 0-2-2a2 2 0 0 0-2 2v10"/> <path d="M18 11a2 2 0 1 1 4 0v3a8 8 0 0 1-8 8h-2c-2.8 0-4.5-.86-5.99-2.34l-3.6-3.6a2 2 0 0 1 2.83-2.82L7 15"/> </svg>',"cloud-lightning":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 16.326A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 .5 8.973"/> <path d="m13 12-3 5h4l-3 5"/> </svg>',"phone-forwarded":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="18 2 22 6 18 10"/> <line x1="14" x2="22" y1="6" y2="6"/> <path d="M22 16.92v3a2 2 0 0 1-2.18 2 19.79 19.79 0 0 1-8.63-3.07 19.5 19.5 0 0 1-6-6 19.79 19.79 0 0 1-3.07-8.67A2 2 0 0 1 4.11 2h3a2 2 0 0 1 2 1.72 12.84 12.84 0 0 0 .7 2.81 2 2 0 0 1-.45 2.11L8.09 9.91a16 16 0 0 0 6 6l1.27-1.27a2 2 0 0 1 2.11-.45 12.84 12.84 0 0 0 2.81.7A2 2 0 0 1 22 16.92z"/> </svg>',"wallet-cards":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 9a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2"/> <path d="M3 11h3c.8 0 1.6.3 2.1.9l1.1.9c1.6 1.6 4.1 1.6 5.7 0l1.1-.9c.5-.5 1.3-.9 2.1-.9H21"/> </svg>',"circle-fading-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2a10 10 0 0 1 7.38 16.75"/> <path d="m16 12-4-4-4 4"/> <path d="M12 16V8"/> <path d="M2.5 8.875a10 10 0 0 0-.5 3"/> <path d="M2.83 16a10 10 0 0 0 2.43 3.4"/> <path d="M4.636 5.235a10 10 0 0 1 .891-.857"/> <path d="M8.644 21.42a10 10 0 0 0 7.631-.38"/> </svg>',"parking-meter":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 9a3 3 0 1 1 6 0"/> <path d="M12 12v3"/> <path d="M11 15h2"/> <path d="M19 9a7 7 0 1 0-13.6 2.3C6.4 14.4 8 19 8 19h8s1.6-4.6 2.6-7.7c.3-.8.4-1.5.4-2.3"/> <path d="M12 19v3"/> </svg>',"folder-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> <path d="M12 10v6"/> <path d="m15 13-3 3-3-3"/> </svg>',"text-cursor-input":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 4h1a3 3 0 0 1 3 3 3 3 0 0 1 3-3h1"/> <path d="M13 20h-1a3 3 0 0 1-3-3 3 3 0 0 1-3 3H5"/> <path d="M5 16H4a2 2 0 0 1-2-2v-4a2 2 0 0 1 2-2h1"/> <path d="M13 8h7a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2h-7"/> <path d="M9 7v10"/> </svg>',combine:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 18H5a3 3 0 0 1-3-3v-1"/> <path d="M14 2a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2"/> <path d="M20 2a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2"/> <path d="m7 21 3-3-3-3"/> <rect x="14" y="14" width="8" height="8" rx="2"/> <rect x="2" y="2" width="8" height="8" rx="2"/> </svg>',"alarm-clock-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="13" r="8"/> <path d="M5 3 2 6"/> <path d="m22 6-3-3"/> <path d="M6.38 18.7 4 21"/> <path d="M17.64 18.67 20 21"/> <path d="M12 10v6"/> <path d="M9 13h6"/> </svg>',"git-branch-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 3v12"/> <path d="M18 9a3 3 0 1 0 0-6 3 3 0 0 0 0 6z"/> <path d="M6 21a3 3 0 1 0 0-6 3 3 0 0 0 0 6z"/> <path d="M15 6a9 9 0 0 0-9 9"/> <path d="M18 15v6"/> <path d="M21 18h-6"/> </svg>',"tally-5":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 4v16"/> <path d="M9 4v16"/> <path d="M14 4v16"/> <path d="M19 4v16"/> <path d="M22 6 2 18"/> </svg>',"badge-cent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M12 7v10"/> <path d="M15.4 10a4 4 0 1 0 0 4"/> </svg>',sparkles:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9.937 15.5A2 2 0 0 0 8.5 14.063l-6.135-1.582a.5.5 0 0 1 0-.962L8.5 9.936A2 2 0 0 0 9.937 8.5l1.582-6.135a.5.5 0 0 1 .963 0L14.063 8.5A2 2 0 0 0 15.5 9.937l6.135 1.581a.5.5 0 0 1 0 .964L15.5 14.063a2 2 0 0 0-1.437 1.437l-1.582 6.135a.5.5 0 0 1-.963 0z"/> <path d="M20 3v4"/> <path d="M22 5h-4"/> <path d="M4 17v2"/> <path d="M5 18H3"/> </svg>',"package-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16 16 2 2 4-4"/> <path d="M21 10V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l2-1.14"/> <path d="m7.5 4.27 9 5.15"/> <polyline points="3.29 7 12 12 20.71 7"/> <line x1="12" x2="12" y1="22" y2="12"/> </svg>',"scan-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <path d="M7 8h8"/> <path d="M7 12h10"/> <path d="M7 16h6"/> </svg>',copy:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="14" x="8" y="8" rx="2" ry="2"/> <path d="M4 16c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h10c1.1 0 2 .9 2 2"/> </svg>',"rotate-cw":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 12a9 9 0 1 1-9-9c2.52 0 4.93 1 6.74 2.74L21 8"/> <path d="M21 3v5h-5"/> </svg>',backpack:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 10a4 4 0 0 1 4-4h8a4 4 0 0 1 4 4v10a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2z"/> <path d="M8 10h8"/> <path d="M8 18h8"/> <path d="M8 22v-6a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v6"/> <path d="M9 6V4a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v2"/> </svg>',"calendar-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <rect width="18" height="18" x="3" y="4" rx="2"/> <path d="M3 10h18"/> <path d="m14 14-4 4"/> <path d="m10 14 4 4"/> </svg>',menu:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="4" x2="20" y1="12" y2="12"/> <line x1="4" x2="20" y1="6" y2="6"/> <line x1="4" x2="20" y1="18" y2="18"/> </svg>',"move-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 8L2 12L6 16"/> <path d="M2 12H22"/> </svg>',"file-sliders":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M8 12h8"/> <path d="M10 11v2"/> <path d="M8 17h8"/> <path d="M14 16v2"/> </svg>',"volume-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 4.702a.705.705 0 0 0-1.203-.498L6.413 7.587A1.4 1.4 0 0 1 5.416 8H3a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2.416a1.4 1.4 0 0 1 .997.413l3.383 3.384A.705.705 0 0 0 11 19.298z"/> <path d="M16 9a5 5 0 0 1 0 6"/> <path d="M19.364 18.364a9 9 0 0 0 0-12.728"/> </svg>',brush:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9.06 11.9 8.07-8.06a2.85 2.85 0 1 1 4.03 4.03l-8.06 8.08"/> <path d="M7.07 14.94c-1.66 0-3 1.35-3 3.02 0 1.33-2.5 1.52-2 2.02 1.08 1.1 2.49 2.02 4 2.02 2.2 0 4-1.8 4-4.04a3.01 3.01 0 0 0-3-3.02z"/> </svg>',tablet:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="20" x="4" y="2" rx="2" ry="2"/> <line x1="12" x2="12.01" y1="18" y2="18"/> </svg>',"biceps-flexed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.409 13.017A5 5 0 0 1 22 15c0 3.866-4 7-9 7-4.077 0-8.153-.82-10.371-2.462-.426-.316-.631-.832-.62-1.362C2.118 12.723 2.627 2 10 2a3 3 0 0 1 3 3 2 2 0 0 1-2 2c-1.105 0-1.64-.444-2-1"/> <path d="M15 14a5 5 0 0 0-7.584 2"/> <path d="M9.964 6.825C8.019 7.977 9.5 13 8 15"/> </svg>',database:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <ellipse cx="12" cy="5" rx="9" ry="3"/> <path d="M3 5V19A9 3 0 0 0 21 19V5"/> <path d="M3 12A9 3 0 0 0 21 12"/> </svg>',bug:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m8 2 1.88 1.88"/> <path d="M14.12 3.88 16 2"/> <path d="M9 7.13v-1a3.003 3.003 0 1 1 6 0v1"/> <path d="M12 20c-3.3 0-6-2.7-6-6v-3a4 4 0 0 1 4-4h4a4 4 0 0 1 4 4v3c0 3.3-2.7 6-6 6"/> <path d="M12 20v-9"/> <path d="M6.53 9C4.6 8.8 3 7.1 3 5"/> <path d="M6 13H2"/> <path d="M3 21c0-2.1 1.7-3.9 3.8-4"/> <path d="M20.97 5c0 2.1-1.6 3.8-3.5 4"/> <path d="M22 13h-4"/> <path d="M17.2 17c2.1.1 3.8 1.9 3.8 4"/> </svg>',"badge-indian-rupee":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M8 8h8"/> <path d="M8 12h8"/> <path d="m13 17-5-1h1a4 4 0 0 0 0-8"/> </svg>',braces:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 3H7a2 2 0 0 0-2 2v5a2 2 0 0 1-2 2 2 2 0 0 1 2 2v5c0 1.1.9 2 2 2h1"/> <path d="M16 21h1a2 2 0 0 0 2-2v-5c0-1.1.9-2 2-2a2 2 0 0 1-2-2V5a2 2 0 0 0-2-2h-1"/> </svg>',"ticket-percent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9a3 3 0 1 1 0 6v2a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2a3 3 0 1 1 0-6V7a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="M9 9h.01"/> <path d="m15 9-6 6"/> <path d="M15 15h.01"/> </svg>',"clipboard-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2h2"/> <path d="M9 14h6"/> <path d="M12 17v-6"/> </svg>',"heading-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 12h8"/> <path d="M4 18V6"/> <path d="M12 18V6"/> <path d="M21 18h-4c0-4 4-3 4-6 0-1.5-2-2.5-4-1"/> </svg>',"wheat-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 22 10-10"/> <path d="m16 8-1.17 1.17"/> <path d="M3.47 12.53 5 11l1.53 1.53a3.5 3.5 0 0 1 0 4.94L5 19l-1.53-1.53a3.5 3.5 0 0 1 0-4.94Z"/> <path d="m8 8-.53.53a3.5 3.5 0 0 0 0 4.94L9 15l1.53-1.53c.55-.55.88-1.25.98-1.97"/> <path d="M10.91 5.26c.15-.26.34-.51.56-.73L13 3l1.53 1.53a3.5 3.5 0 0 1 .28 4.62"/> <path d="M20 2h2v2a4 4 0 0 1-4 4h-2V6a4 4 0 0 1 4-4Z"/> <path d="M11.47 17.47 13 19l-1.53 1.53a3.5 3.5 0 0 1-4.94 0L5 19l1.53-1.53a3.5 3.5 0 0 1 4.94 0Z"/> <path d="m16 16-.53.53a3.5 3.5 0 0 1-4.94 0L9 15l1.53-1.53a3.49 3.49 0 0 1 1.97-.98"/> <path d="M18.74 13.09c.26-.15.51-.34.73-.56L21 11l-1.53-1.53a3.5 3.5 0 0 0-4.62-.28"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"arrow-down-a-z":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 16 4 4 4-4"/> <path d="M7 20V4"/> <path d="M20 8h-5"/> <path d="M15 10V6.5a2.5 2.5 0 0 1 5 0V10"/> <path d="M15 14h5l-5 6h5"/> </svg>',"library-big":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="18" x="3" y="3" rx="1"/> <path d="M7 3v18"/> <path d="M20.4 18.9c.2.5-.1 1.1-.6 1.3l-1.9.7c-.5.2-1.1-.1-1.3-.6L11.1 5.1c-.2-.5.1-1.1.6-1.3l1.9-.7c.5-.2 1.1.1 1.3.6Z"/> </svg>',"bookmark-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 21-7-4-7 4V5a2 2 0 0 1 2-2h10a2 2 0 0 1 2 2Z"/> <path d="m14.5 7.5-5 5"/> <path d="m9.5 7.5 5 5"/> </svg>',airplay:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 17H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2h-1"/> <path d="m12 15 5 6H7Z"/> </svg>',hand:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 11V6a2 2 0 0 0-2-2a2 2 0 0 0-2 2"/> <path d="M14 10V4a2 2 0 0 0-2-2a2 2 0 0 0-2 2v2"/> <path d="M10 10.5V6a2 2 0 0 0-2-2a2 2 0 0 0-2 2v8"/> <path d="M18 8a2 2 0 1 1 4 0v6a8 8 0 0 1-8 8h-2c-2.8 0-4.5-.86-5.99-2.34l-3.6-3.6a2 2 0 0 1 2.83-2.82L7 15"/> </svg>',"cloud-drizzle":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 14.899A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.242"/> <path d="M8 19v1"/> <path d="M8 14v1"/> <path d="M16 19v1"/> <path d="M16 14v1"/> <path d="M12 21v1"/> <path d="M12 16v1"/> </svg>',ticket:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9a3 3 0 0 1 0 6v2a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2a3 3 0 0 1 0-6V7a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="M13 5v2"/> <path d="M13 17v2"/> <path d="M13 11v2"/> </svg>',history:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 12a9 9 0 1 0 9-9 9.75 9.75 0 0 0-6.74 2.74L3 8"/> <path d="M3 3v5h5"/> <path d="M12 7v5l4 2"/> </svg>',"cloud-sun-rain":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v2"/> <path d="m4.93 4.93 1.41 1.41"/> <path d="M20 12h2"/> <path d="m19.07 4.93-1.41 1.41"/> <path d="M15.947 12.65a4 4 0 0 0-5.925-4.128"/> <path d="M3 20a5 5 0 1 1 8.9-4H13a3 3 0 0 1 2 5.24"/> <path d="M11 20v2"/> <path d="M7 19v2"/> </svg>',trophy:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 9H4.5a2.5 2.5 0 0 1 0-5H6"/> <path d="M18 9h1.5a2.5 2.5 0 0 0 0-5H18"/> <path d="M4 22h16"/> <path d="M10 14.66V17c0 .55-.47.98-.97 1.21C7.85 18.75 7 20.24 7 22"/> <path d="M14 14.66V17c0 .55.47.98.97 1.21C16.15 18.75 17 20.24 17 22"/> <path d="M18 2H6v7a6 6 0 0 0 12 0V2Z"/> </svg>',"file-volume-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M8 15h.01"/> <path d="M11.5 13.5a2.5 2.5 0 0 1 0 3"/> <path d="M15 12a5 5 0 0 1 0 6"/> </svg>',"cloud-hail":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 14.899A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.242"/> <path d="M16 14v2"/> <path d="M8 14v2"/> <path d="M16 20h.01"/> <path d="M8 20h.01"/> <path d="M12 16v2"/> <path d="M12 22h.01"/> </svg>',heading:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 12h12"/> <path d="M6 20V4"/> <path d="M18 20V4"/> </svg>',"circle-arrow-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M12 8v8"/> <path d="m8 12 4 4 4-4"/> </svg>',"chart-bar-stacked":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 13v4"/> <path d="M15 5v4"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <rect x="7" y="13" width="9" height="4" rx="1"/> <rect x="7" y="5" width="12" height="4" rx="1"/> </svg>',"folder-git":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="13" r="2"/> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> <path d="M14 13h3"/> <path d="M7 13h3"/> </svg>',"text-select":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 3a2 2 0 0 0-2 2"/> <path d="M19 3a2 2 0 0 1 2 2"/> <path d="M21 19a2 2 0 0 1-2 2"/> <path d="M5 21a2 2 0 0 1-2-2"/> <path d="M9 3h1"/> <path d="M9 21h1"/> <path d="M14 3h1"/> <path d="M14 21h1"/> <path d="M3 9v1"/> <path d="M21 9v1"/> <path d="M3 14v1"/> <path d="M21 14v1"/> <line x1="7" x2="15" y1="8" y2="8"/> <line x1="7" x2="17" y1="12" y2="12"/> <line x1="7" x2="13" y1="16" y2="16"/> </svg>',medal:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.21 15 2.66 7.14a2 2 0 0 1 .13-2.2L4.4 2.8A2 2 0 0 1 6 2h12a2 2 0 0 1 1.6.8l1.6 2.14a2 2 0 0 1 .14 2.2L16.79 15"/> <path d="M11 12 5.12 2.2"/> <path d="m13 12 5.88-9.8"/> <path d="M8 7h8"/> <circle cx="12" cy="17" r="5"/> <path d="M12 18v-2h-.5"/> </svg>',"arrow-left-from-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9 6-6 6 6 6"/> <path d="M3 12h14"/> <path d="M21 19V5"/> </svg>',"receipt-indian-rupee":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M8 7h8"/> <path d="M12 17.5 8 15h1a4 4 0 0 0 0-8"/> <path d="M8 11h8"/> </svg>',"arrow-big-up-dash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 19h6"/> <path d="M9 15v-3H5l7-7 7 7h-4v3H9z"/> </svg>',"lamp-floor":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 2h6l3 7H6l3-7Z"/> <path d="M12 9v13"/> <path d="M9 22h6"/> </svg>',"database-zap":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <ellipse cx="12" cy="5" rx="9" ry="3"/> <path d="M3 5V19A9 3 0 0 0 15 21.84"/> <path d="M21 5V8"/> <path d="M21 12L18 17H22L19 22"/> <path d="M3 12A9 3 0 0 0 14.59 14.87"/> </svg>',"cloud-moon-rain":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.188 8.5A6 6 0 0 1 16 4a1 1 0 0 0 6 6 6 6 0 0 1-3 5.197"/> <path d="M11 20v2"/> <path d="M3 20a5 5 0 1 1 8.9-4H13a3 3 0 0 1 2 5.24"/> <path d="M7 19v2"/> </svg>',printer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 18H4a2 2 0 0 1-2-2v-5a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2h-2"/> <path d="M6 9V3a1 1 0 0 1 1-1h10a1 1 0 0 1 1 1v6"/> <rect x="6" y="14" width="12" height="8" rx="1"/> </svg>',"train-track":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 17 17 2"/> <path d="m2 14 8 8"/> <path d="m5 11 8 8"/> <path d="m8 8 8 8"/> <path d="m11 5 8 8"/> <path d="m14 2 8 8"/> <path d="M7 22 22 7"/> </svg>',"chevron-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9 18 6-6-6-6"/> </svg>',pause:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="14" y="4" width="4" height="16" rx="1"/> <rect x="6" y="4" width="4" height="16" rx="1"/> </svg>',"graduation-cap":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.42 10.922a1 1 0 0 0-.019-1.838L12.83 5.18a2 2 0 0 0-1.66 0L2.6 9.08a1 1 0 0 0 0 1.832l8.57 3.908a2 2 0 0 0 1.66 0z"/> <path d="M22 10v6"/> <path d="M6 12.5V16a6 3 0 0 0 12 0v-3.5"/> </svg>',"server-crash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 10H4a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2h-2"/> <path d="M6 14H4a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-4a2 2 0 0 0-2-2h-2"/> <path d="M6 6h.01"/> <path d="M6 18h.01"/> <path d="m13 6-4 6h6l-4 6"/> </svg>',"square-square":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="3" y="3" width="18" height="18" rx="2"/> <rect x="8" y="8" width="8" height="8" rx="1"/> </svg>',siren:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 18v-6a5 5 0 1 1 10 0v6"/> <path d="M5 21a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-1a2 2 0 0 0-2-2H7a2 2 0 0 0-2 2z"/> <path d="M21 12h1"/> <path d="M18.5 4.5 18 5"/> <path d="M2 12h1"/> <path d="M12 2v1"/> <path d="m4.929 4.929.707.707"/> <path d="M12 12v6"/> </svg>',bean:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.165 6.598C9.954 7.478 9.64 8.36 9 9c-.64.64-1.521.954-2.402 1.165A6 6 0 0 0 8 22c7.732 0 14-6.268 14-14a6 6 0 0 0-11.835-1.402Z"/> <path d="M5.341 10.62a4 4 0 1 0 5.279-5.28"/> </svg>',volume:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 4.702a.705.705 0 0 0-1.203-.498L6.413 7.587A1.4 1.4 0 0 1 5.416 8H3a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2.416a1.4 1.4 0 0 1 .997.413l3.383 3.384A.705.705 0 0 0 11 19.298z"/> </svg>',"pin-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17v5"/> <path d="M15 9.34V7a1 1 0 0 1 1-1 2 2 0 0 0 0-4H7.89"/> <path d="m2 2 20 20"/> <path d="M9 9v1.76a2 2 0 0 1-1.11 1.79l-1.78.9A2 2 0 0 0 5 15.24V16a1 1 0 0 0 1 1h11"/> </svg>',"arrow-big-down-dash":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 5H9"/> <path d="M15 9v3h4l-7 7-7-7h4V9z"/> </svg>',"sun-medium":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="4"/> <path d="M12 3v1"/> <path d="M12 20v1"/> <path d="M3 12h1"/> <path d="M20 12h1"/> <path d="m18.364 5.636-.707.707"/> <path d="m6.343 17.657-.707.707"/> <path d="m5.636 5.636.707.707"/> <path d="m17.657 17.657.707.707"/> </svg>',"square-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M8 12h8"/> <path d="M12 8v8"/> </svg>',"lock-keyhole":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="16" r="1"/> <rect x="3" y="10" width="18" height="12" rx="2"/> <path d="M7 10V7a5 5 0 0 1 10 0v3"/> </svg>',mails:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="13" x="6" y="4" rx="2"/> <path d="m22 7-7.1 3.78c-.57.3-1.23.3-1.8 0L6 7"/> <path d="M2 8v11c0 1.1.9 2 2 2h14"/> </svg>',"circle-parking":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M9 17V7h4a3 3 0 0 1 0 6H9"/> </svg>',"align-vertical-distribute-center":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 17h-3"/> <path d="M22 7h-5"/> <path d="M5 17H2"/> <path d="M7 7H2"/> <rect x="5" y="14" width="14" height="6" rx="2"/> <rect x="7" y="4" width="10" height="6" rx="2"/> </svg>',popsicle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18.6 14.4c.8-.8.8-2 0-2.8l-8.1-8.1a4.95 4.95 0 1 0-7.1 7.1l8.1 8.1c.9.7 2.1.7 2.9-.1Z"/> <path d="m22 22-5.5-5.5"/> </svg>',"pencil-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20h9"/> <path d="M16.376 3.622a1 1 0 0 1 3.002 3.002L7.368 18.635a2 2 0 0 1-.855.506l-2.872.838a.5.5 0 0 1-.62-.62l.838-2.872a2 2 0 0 1 .506-.854z"/> <path d="m15 5 3 3"/> </svg>',cookie:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2a10 10 0 1 0 10 10 4 4 0 0 1-5-5 4 4 0 0 1-5-5"/> <path d="M8.5 8.5v.01"/> <path d="M16 15.5v.01"/> <path d="M12 12v.01"/> <path d="M11 17v.01"/> <path d="M7 14v.01"/> </svg>',tractor:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m10 11 11 .9a1 1 0 0 1 .8 1.1l-.665 4.158a1 1 0 0 1-.988.842H20"/> <path d="M16 18h-5"/> <path d="M18 5a1 1 0 0 0-1 1v5.573"/> <path d="M3 4h8.129a1 1 0 0 1 .99.863L13 11.246"/> <path d="M4 11V4"/> <path d="M7 15h.01"/> <path d="M8 10.1V4"/> <circle cx="18" cy="18" r="2"/> <circle cx="7" cy="15" r="5"/> </svg>',"signal-zero":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 20h.01"/> </svg>',"panel-top-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 9h18"/> <path d="m15 14-3 3-3-3"/> </svg>',"message-square-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15V5a2 2 0 0 0-2-2H9"/> <path d="m2 2 20 20"/> <path d="M3.6 3.6c-.4.3-.6.8-.6 1.4v16l4-4h10"/> </svg>',"move-diagonal-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="5 11 5 5 11 5"/> <polyline points="19 13 19 19 13 19"/> <line x1="5" x2="19" y1="5" y2="19"/> </svg>',"notebook-tabs":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 6h4"/> <path d="M2 10h4"/> <path d="M2 14h4"/> <path d="M2 18h4"/> <rect width="16" height="20" x="4" y="2" rx="2"/> <path d="M15 2v20"/> <path d="M15 7h5"/> <path d="M15 12h5"/> <path d="M15 17h5"/> </svg>',"chevrons-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m17 11-5-5-5 5"/> <path d="m17 18-5-5-5 5"/> </svg>',"scan-qr-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 12v4a1 1 0 0 1-1 1h-4"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M17 8V7"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M7 17h.01"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <rect x="7" y="7" width="5" height="5" rx="1"/> </svg>',"circle-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M8 12h8"/> </svg>',"zoom-out":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11" cy="11" r="8"/> <line x1="21" x2="16.65" y1="21" y2="16.65"/> <line x1="8" x2="14" y1="11" y2="11"/> </svg>',"square-mouse-pointer":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.034 12.681a.498.498 0 0 1 .647-.647l9 3.5a.5.5 0 0 1-.033.943l-3.444 1.068a1 1 0 0 0-.66.66l-1.067 3.443a.5.5 0 0 1-.943.033z"/> <path d="M21 11V5a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h6"/> </svg>',drum:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 2 8 8"/> <path d="m22 2-8 8"/> <ellipse cx="12" cy="9" rx="10" ry="5"/> <path d="M7 13.4v7.9"/> <path d="M12 14v8"/> <path d="M17 13.4v7.9"/> <path d="M2 9v8a10 5 0 0 0 20 0V9"/> </svg>',"tally-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 4v16"/> </svg>',usb:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="10" cy="7" r="1"/> <circle cx="4" cy="20" r="1"/> <path d="M4.7 19.3 19 5"/> <path d="m21 3-3 1 2 2Z"/> <path d="M9.26 7.68 5 12l2 5"/> <path d="m10 14 5 2 3.5-3.5"/> <path d="m18 12 1-1 1 1-1 1Z"/> </svg>',"chevron-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 18-6-6 6-6"/> </svg>',"arrow-down-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 7 7 17"/> <path d="M17 17H7V7"/> </svg>',"scale-3d":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="19" cy="19" r="2"/> <circle cx="5" cy="5" r="2"/> <path d="M5 7v12h12"/> <path d="m5 19 6-6"/> </svg>',lightbulb:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 14c.2-1 .7-1.7 1.5-2.5 1-.9 1.5-2.2 1.5-3.5A6 6 0 0 0 6 8c0 1 .2 2.2 1.5 3.5.7.7 1.3 1.5 1.5 2.5"/> <path d="M9 18h6"/> <path d="M10 22h4"/> </svg>',"move-up-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 11V5H11"/> <path d="M5 5L19 19"/> </svg>',film:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M7 3v18"/> <path d="M3 7.5h4"/> <path d="M3 12h18"/> <path d="M3 16.5h4"/> <path d="M17 3v18"/> <path d="M17 7.5h4"/> <path d="M17 16.5h4"/> </svg>',"clipboard-copy":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M8 4H6a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2v-2"/> <path d="M16 4h2a2 2 0 0 1 2 2v4"/> <path d="M21 14H11"/> <path d="m15 10-4 4 4 4"/> </svg>',"message-circle-heart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> <path d="M15.8 9.2a2.5 2.5 0 0 0-3.5 0l-.3.4-.35-.3a2.42 2.42 0 1 0-3.2 3.6l3.6 3.5 3.6-3.5c1.2-1.2 1.1-2.7.2-3.7"/> </svg>',"tree-palm":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 8c0-2.76-2.46-5-5.5-5S2 5.24 2 8h2l1-1 1 1h4"/> <path d="M13 7.14A5.82 5.82 0 0 1 16.5 6c3.04 0 5.5 2.24 5.5 5h-3l-1-1-1 1h-3"/> <path d="M5.89 9.71c-2.15 2.15-2.3 5.47-.35 7.43l4.24-4.25.7-.7.71-.71 2.12-2.12c-1.95-1.96-5.27-1.8-7.42.35"/> <path d="M11 15.5c.5 2.5-.17 4.5-1 6.5h4c2-5.5-.5-12-1-14"/> </svg>',"arrow-up-1-0":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 8 4-4 4 4"/> <path d="M7 4v16"/> <path d="M17 10V4h-2"/> <path d="M15 10h4"/> <rect x="15" y="14" width="4" height="6" ry="2"/> </svg>',pentagon:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.83 2.38a2 2 0 0 1 2.34 0l8 5.74a2 2 0 0 1 .73 2.25l-3.04 9.26a2 2 0 0 1-1.9 1.37H7.04a2 2 0 0 1-1.9-1.37L2.1 10.37a2 2 0 0 1 .73-2.25z"/> </svg>',"panel-top-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M14 9h1"/> <path d="M19 9h2"/> <path d="M3 9h2"/> <path d="M9 9h1"/> </svg>',"swatch-book":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 17a4 4 0 0 1-8 0V5a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2Z"/> <path d="M16.7 13H19a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2H7"/> <path d="M 7 17h.01"/> <path d="m11 8 2.3-2.3a2.4 2.4 0 0 1 3.404.004L18.6 7.6a2.4 2.4 0 0 1 .026 3.434L9.9 19.8"/> </svg>',"flag-triangle-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 22V2L7 7l10 5"/> </svg>',hop:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.82 16.12c1.69.6 3.91.79 5.18.85.55.03 1-.42.97-.97-.06-1.27-.26-3.5-.85-5.18"/> <path d="M11.5 6.5c1.64 0 5-.38 6.71-1.07.52-.2.55-.82.12-1.17A10 10 0 0 0 4.26 18.33c.35.43.96.4 1.17-.12.69-1.71 1.07-5.07 1.07-6.71 1.34.45 3.1.9 4.88.62a.88.88 0 0 0 .73-.74c.3-2.14-.15-3.5-.61-4.88"/> <path d="M15.62 16.95c.2.85.62 2.76.5 4.28a.77.77 0 0 1-.9.7 16.64 16.64 0 0 1-4.08-1.36"/> <path d="M16.13 21.05c1.65.63 3.68.84 4.87.91a.9.9 0 0 0 .96-.96 17.68 17.68 0 0 0-.9-4.87"/> <path d="M16.94 15.62c.86.2 2.77.62 4.29.5a.77.77 0 0 0 .7-.9 16.64 16.64 0 0 0-1.36-4.08"/> <path d="M17.99 5.52a20.82 20.82 0 0 1 3.15 4.5.8.8 0 0 1-.68 1.13c-2.33.2-5.3-.32-8.27-1.57"/> <path d="M4.93 4.93 3 3a.7.7 0 0 1 0-1"/> <path d="M9.58 12.18c1.24 2.98 1.77 5.95 1.57 8.28a.8.8 0 0 1-1.13.68 20.82 20.82 0 0 1-4.5-3.15"/> </svg>',"battery-charging":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 7h1a2 2 0 0 1 2 2v6a2 2 0 0 1-2 2h-2"/> <path d="M6 7H4a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h1"/> <path d="m11 7-3 5h4l-3 5"/> <line x1="22" x2="22" y1="11" y2="13"/> </svg>',"chart-column-decreasing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 17V9"/> <path d="M18 17v-3"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M8 17V5"/> </svg>',"screen-share":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 3H4a2 2 0 0 0-2 2v10a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-3"/> <path d="M8 21h8"/> <path d="M12 17v4"/> <path d="m17 8 5-5"/> <path d="M17 3h5v5"/> </svg>',cable:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 21v-2a1 1 0 0 1-1-1v-1a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v1a1 1 0 0 1-1 1"/> <path d="M19 15V6.5a1 1 0 0 0-7 0v11a1 1 0 0 1-7 0V9"/> <path d="M21 21v-2h-4"/> <path d="M3 5h4V3"/> <path d="M7 5a1 1 0 0 1 1 1v1a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V6a1 1 0 0 1 1-1V3"/> </svg>',"folder-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> <path d="m9 13 2 2 4-4"/> </svg>',"clipboard-pen-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1"/> <path d="M8 4H6a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2v-.5"/> <path d="M16 4h2a2 2 0 0 1 1.73 1"/> <path d="M8 18h1"/> <path d="M21.378 12.626a1 1 0 0 0-3.004-3.004l-4.01 4.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> </svg>',"redo-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="17" r="1"/> <path d="M21 7v6h-6"/> <path d="M3 17a9 9 0 0 1 9-9 9 9 0 0 1 6 2.3l3 2.7"/> </svg>',"plug-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 2v6"/> <path d="M15 2v6"/> <path d="M12 17v5"/> <path d="M5 8h14"/> <path d="M6 11V8h12v3a6 6 0 1 1-12 0Z"/> </svg>',"badge-russian-ruble":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M9 16h5"/> <path d="M9 12h5a2 2 0 1 0 0-4h-3v9"/> </svg>',"calendar-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15.2 16.9-.9-.4"/> <path d="m15.2 19.1-.9.4"/> <path d="M16 2v4"/> <path d="m16.9 15.2-.4-.9"/> <path d="m16.9 20.8-.4.9"/> <path d="m19.5 14.3-.4.9"/> <path d="m19.5 21.7-.4-.9"/> <path d="M21 10.5V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h6"/> <path d="m21.7 16.5-.9.4"/> <path d="m21.7 19.5-.9-.4"/> <path d="M3 10h18"/> <path d="M8 2v4"/> <circle cx="18" cy="18" r="3"/> </svg>',"gallery-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 2h18"/> <rect width="18" height="12" x="3" y="6" rx="2"/> <path d="M3 22h18"/> </svg>',"chef-hat":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 21a1 1 0 0 0 1-1v-5.35c0-.457.316-.844.727-1.041a4 4 0 0 0-2.134-7.589 5 5 0 0 0-9.186 0 4 4 0 0 0-2.134 7.588c.411.198.727.585.727 1.041V20a1 1 0 0 0 1 1Z"/> <path d="M6 17h12"/> </svg>',truck:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 18V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v11a1 1 0 0 0 1 1h2"/> <path d="M15 18H9"/> <path d="M19 18h2a1 1 0 0 0 1-1v-3.65a1 1 0 0 0-.22-.624l-3.48-4.35A1 1 0 0 0 17.52 8H14"/> <circle cx="17" cy="18" r="2"/> <circle cx="7" cy="18" r="2"/> </svg>',"panel-bottom-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M14 15h1"/> <path d="M19 15h2"/> <path d="M3 15h2"/> <path d="M9 15h1"/> </svg>',"cloud-snow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 14.899A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.242"/> <path d="M8 15h.01"/> <path d="M8 19h.01"/> <path d="M12 17h.01"/> <path d="M12 21h.01"/> <path d="M16 15h.01"/> <path d="M16 19h.01"/> </svg>',"wallet-minimal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 14h.01"/> <path d="M7 7h12a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14"/> </svg>',"align-end-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="16" x="4" y="2" rx="2"/> <rect width="6" height="9" x="14" y="9" rx="2"/> <path d="M22 22H2"/> </svg>',list:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="8" x2="21" y1="6" y2="6"/> <line x1="8" x2="21" y1="12" y2="12"/> <line x1="8" x2="21" y1="18" y2="18"/> <line x1="3" x2="3.01" y1="6" y2="6"/> <line x1="3" x2="3.01" y1="12" y2="12"/> <line x1="3" x2="3.01" y1="18" y2="18"/> </svg>',square:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> </svg>',"grip-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="9" cy="12" r="1"/> <circle cx="9" cy="5" r="1"/> <circle cx="9" cy="19" r="1"/> <circle cx="15" cy="12" r="1"/> <circle cx="15" cy="5" r="1"/> <circle cx="15" cy="19" r="1"/> </svg>',"user-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="10" cy="7" r="4"/> <path d="M10.3 15H7a4 4 0 0 0-4 4v2"/> <circle cx="17" cy="17" r="3"/> <path d="m21 21-1.9-1.9"/> </svg>',"chart-no-axes-combined":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 16v5"/> <path d="M16 14v7"/> <path d="M20 10v11"/> <path d="m22 3-8.646 8.646a.5.5 0 0 1-.708 0L9.354 8.354a.5.5 0 0 0-.707 0L2 15"/> <path d="M4 18v3"/> <path d="M8 14v7"/> </svg>',ligature:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 20V8c0-2.2 1.8-4 4-4 1.5 0 2.8.8 3.5 2"/> <path d="M6 12h4"/> <path d="M14 12h2v8"/> <path d="M6 20h4"/> <path d="M14 20h4"/> </svg>',"pilcrow-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 3v11"/> <path d="M10 9H7a1 1 0 0 1 0-6h8"/> <path d="M14 3v11"/> <path d="m18 14 4 4H2"/> <path d="m22 18-4 4"/> </svg>',"wifi-zero":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20h.01"/> </svg>',squirrel:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.236 22a3 3 0 0 0-2.2-5"/> <path d="M16 20a3 3 0 0 1 3-3h1a2 2 0 0 0 2-2v-2a4 4 0 0 0-4-4V4"/> <path d="M18 13h.01"/> <path d="M18 6a4 4 0 0 0-4 4 7 7 0 0 0-7 7c0-5 4-5 4-10.5a4.5 4.5 0 1 0-9 0 2.5 2.5 0 0 0 5 0C7 10 3 11 3 17c0 2.8 2.2 5 5 5h10"/> </svg>',wallet:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 7V4a1 1 0 0 0-1-1H5a2 2 0 0 0 0 4h15a1 1 0 0 1 1 1v4h-3a2 2 0 0 0 0 4h3a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1"/> <path d="M3 5v14a2 2 0 0 0 2 2h15a1 1 0 0 0 1-1v-4"/> </svg>',"smartphone-nfc":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="12" x="2" y="6" rx="1"/> <path d="M13 8.32a7.43 7.43 0 0 1 0 7.36"/> <path d="M16.46 6.21a11.76 11.76 0 0 1 0 11.58"/> <path d="M19.91 4.1a15.91 15.91 0 0 1 .01 15.8"/> </svg>',"file-output":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M4 7V4a2 2 0 0 1 2-2 2 2 0 0 0-2 2"/> <path d="M4.063 20.999a2 2 0 0 0 2 1L18 22a2 2 0 0 0 2-2V7l-5-5H6"/> <path d="m5 11-3 3"/> <path d="m5 17-3-3h10"/> </svg>',crop:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 2v14a2 2 0 0 0 2 2h14"/> <path d="M18 22V8a2 2 0 0 0-2-2H2"/> </svg>',carrot:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.27 21.7s9.87-3.5 12.73-6.36a4.5 4.5 0 0 0-6.36-6.37C5.77 11.84 2.27 21.7 2.27 21.7zM8.64 14l-2.05-2.04M15.34 15l-2.46-2.46"/> <path d="M22 9s-1.33-2-3.5-2C16.86 7 15 9 15 9s1.33 2 3.5 2S22 9 22 9z"/> <path d="M15 2s-2 1.33-2 3.5S15 9 15 9s2-1.84 2-3.5C17 3.33 15 2 15 2z"/> </svg>',"file-type-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M2 13v-1h6v1"/> <path d="M5 12v6"/> <path d="M4 18h2"/> </svg>',calculator:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="20" x="4" y="2" rx="2"/> <line x1="8" x2="16" y1="6" y2="6"/> <line x1="16" x2="16" y1="14" y2="18"/> <path d="M16 10h.01"/> <path d="M12 10h.01"/> <path d="M8 10h.01"/> <path d="M12 14h.01"/> <path d="M8 14h.01"/> <path d="M12 18h.01"/> <path d="M8 18h.01"/> </svg>',blend:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="9" cy="9" r="7"/> <circle cx="15" cy="15" r="7"/> </svg>',utensils:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 2v7c0 1.1.9 2 2 2h4a2 2 0 0 0 2-2V2"/> <path d="M7 2v20"/> <path d="M21 15V2a5 5 0 0 0-5 5v6c0 1.1.9 2 2 2h3Zm0 0v7"/> </svg>',"arrow-left-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 3 4 7l4 4"/> <path d="M4 7h16"/> <path d="m16 21 4-4-4-4"/> <path d="M20 17H4"/> </svg>',vibrate:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 8 2 2-2 2 2 2-2 2"/> <path d="m22 8-2 2 2 2-2 2 2 2"/> <rect width="8" height="14" x="8" y="5" rx="1"/> </svg>',drama:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 11h.01"/> <path d="M14 6h.01"/> <path d="M18 6h.01"/> <path d="M6.5 13.1h.01"/> <path d="M22 5c0 9-4 12-6 12s-6-3-6-12c0-2 2-3 6-3s6 1 6 3"/> <path d="M17.4 9.9c-.8.8-2 .8-2.8 0"/> <path d="M10.1 7.1C9 7.2 7.7 7.7 6 8.6c-3.5 2-4.7 3.9-3.7 5.6 4.5 7.8 9.5 8.4 11.2 7.4.9-.5 1.9-2.1 1.9-4.7"/> <path d="M9.1 16.5c.3-1.1 1.4-1.7 2.4-1.4"/> </svg>',"navigation-2-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9.31 9.31 5 21l7-4 7 4-1.17-3.17"/> <path d="M14.53 8.88 12 2l-1.17 3.17"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"book-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="m9 9.5 2 2 4-4"/> </svg>',apple:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20.94c1.5 0 2.75 1.06 4 1.06 3 0 6-8 6-12.22A4.91 4.91 0 0 0 17 5c-2.22 0-4 1.44-5 2-1-.56-2.78-2-5-2a4.9 4.9 0 0 0-5 4.78C2 14 5 22 8 22c1.25 0 2.5-1.06 4-1.06Z"/> <path d="M10 2c1 .5 2 2 2 5"/> </svg>',"tickets-plane":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.5 17h1.227a2 2 0 0 0 1.345-.52L18 12"/> <path d="m12 13.5 3.75.5"/> <path d="m4.5 8 10.58-5.06a1 1 0 0 1 1.342.488L18.5 8"/> <path d="M6 10V8"/> <path d="M6 14v1"/> <path d="M6 19v2"/> <rect x="2" y="8" width="20" height="13" rx="2"/> </svg>',"pilcrow-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 3v11"/> <path d="M14 9h-3a3 3 0 0 1 0-6h9"/> <path d="M18 3v11"/> <path d="M22 18H2l4-4"/> <path d="m6 22-4-4"/> </svg>',"square-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 9.5 8 12l2 2.5"/> <path d="m14 9.5 2 2.5-2 2.5"/> <rect width="18" height="18" x="3" y="3" rx="2"/> </svg>',"file-axis-3d":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m8 18 4-4"/> <path d="M8 10v8h8"/> </svg>',"badge-help":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M9.09 9a3 3 0 0 1 5.83 1c0 2-3 3-3 3"/> <line x1="12" x2="12.01" y1="17" y2="17"/> </svg>',"bell-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8.7 3A6 6 0 0 1 18 8a21.3 21.3 0 0 0 .6 5"/> <path d="M17 17H3s3-2 3-9a4.67 4.67 0 0 1 .3-1.7"/> <path d="M10.3 21a1.94 1.94 0 0 0 3.4 0"/> <path d="m2 2 20 20"/> </svg>',"arrow-left-to-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 19V5"/> <path d="m13 6-6 6 6 6"/> <path d="M7 12h14"/> </svg>',"plane-takeoff":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 22h20"/> <path d="M6.36 17.4 4 17l-2-4 1.1-.55a2 2 0 0 1 1.8 0l.17.1a2 2 0 0 0 1.8 0L8 12 5 6l.9-.45a2 2 0 0 1 2.09.2l4.02 3a2 2 0 0 0 2.1.2l4.19-2.06a2.41 2.41 0 0 1 1.73-.17L21 7a1.4 1.4 0 0 1 .87 1.99l-.38.76c-.23.46-.6.84-1.07 1.08L7.58 17.2a2 2 0 0 1-1.22.18Z"/> </svg>',megaphone:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 11 18-5v12L3 14v-3z"/> <path d="M11.6 16.8a3 3 0 1 1-5.8-1.6"/> </svg>',"battery-full":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="10" x="2" y="7" rx="2" ry="2"/> <line x1="22" x2="22" y1="11" y2="13"/> <line x1="6" x2="6" y1="11" y2="13"/> <line x1="10" x2="10" y1="11" y2="13"/> <line x1="14" x2="14" y1="11" y2="13"/> </svg>',telescope:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m10.065 12.493-6.18 1.318a.934.934 0 0 1-1.108-.702l-.537-2.15a1.07 1.07 0 0 1 .691-1.265l13.504-4.44"/> <path d="m13.56 11.747 4.332-.924"/> <path d="m16 21-3.105-6.21"/> <path d="M16.485 5.94a2 2 0 0 1 1.455-2.425l1.09-.272a1 1 0 0 1 1.212.727l1.515 6.06a1 1 0 0 1-.727 1.213l-1.09.272a2 2 0 0 1-2.425-1.455z"/> <path d="m6.158 8.633 1.114 4.456"/> <path d="m8 21 3.105-6.21"/> <circle cx="12" cy="13" r="2"/> </svg>',lectern:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 12h3a2 2 0 0 0 1.902-1.38l1.056-3.333A1 1 0 0 0 21 6H3a1 1 0 0 0-.958 1.287l1.056 3.334A2 2 0 0 0 5 12h3"/> <path d="M18 6V3a1 1 0 0 0-1-1h-3"/> <rect width="8" height="12" x="8" y="10" rx="1"/> </svg>',"align-horizontal-space-between":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="14" x="3" y="5" rx="2"/> <rect width="6" height="10" x="15" y="7" rx="2"/> <path d="M3 2v20"/> <path d="M21 2v20"/> </svg>',"message-circle-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 9.5 8 12l2 2.5"/> <path d="m14 9.5 2 2.5-2 2.5"/> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22z"/> </svg>',"pencil-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m10 10-6.157 6.162a2 2 0 0 0-.5.833l-1.322 4.36a.5.5 0 0 0 .622.624l4.358-1.323a2 2 0 0 0 .83-.5L14 13.982"/> <path d="m12.829 7.172 4.359-4.346a1 1 0 1 1 3.986 3.986l-4.353 4.353"/> <path d="m15 5 4 4"/> <path d="m2 2 20 20"/> </svg>',coins:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="8" cy="8" r="6"/> <path d="M18.09 10.37A6 6 0 1 1 10.34 18"/> <path d="M7 6h1v4"/> <path d="m16.71 13.88.7.71-2.82 2.82"/> </svg>',"book-heart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 8.2A2.22 2.22 0 0 0 13.8 6c-.8 0-1.4.3-1.8.9-.4-.6-1-.9-1.8-.9A2.22 2.22 0 0 0 8 8.2c0 .6.3 1.2.7 1.6A226.652 226.652 0 0 0 12 13a404 404 0 0 0 3.3-3.1 2.413 2.413 0 0 0 .7-1.7"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> </svg>',"square-arrow-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m12 8-4 4 4 4"/> <path d="M16 12H8"/> </svg>',"rotate-ccw":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 12a9 9 0 1 0 9-9 9.75 9.75 0 0 0-6.74 2.74L3 8"/> <path d="M3 3v5h5"/> </svg>',"gallery-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 3v18"/> <rect width="12" height="18" x="6" y="3" rx="2"/> <path d="M22 3v18"/> </svg>',"file-audio":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17.5 22h.5a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v3"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M2 19a2 2 0 1 1 4 0v1a2 2 0 1 1-4 0v-4a6 6 0 0 1 12 0v4a2 2 0 1 1-4 0v-1a2 2 0 1 1 4 0"/> </svg>',"circle-chevron-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m10 8 4 4-4 4"/> </svg>',"brain-circuit":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 5a3 3 0 1 0-5.997.125 4 4 0 0 0-2.526 5.77 4 4 0 0 0 .556 6.588A4 4 0 1 0 12 18Z"/> <path d="M9 13a4.5 4.5 0 0 0 3-4"/> <path d="M6.003 5.125A3 3 0 0 0 6.401 6.5"/> <path d="M3.477 10.896a4 4 0 0 1 .585-.396"/> <path d="M6 18a4 4 0 0 1-1.967-.516"/> <path d="M12 13h4"/> <path d="M12 18h6a2 2 0 0 1 2 2v1"/> <path d="M12 8h8"/> <path d="M16 8V5a2 2 0 0 1 2-2"/> <circle cx="16" cy="13" r=".5"/> <circle cx="18" cy="3" r=".5"/> <circle cx="20" cy="21" r=".5"/> <circle cx="20" cy="8" r=".5"/> </svg>',minus:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 12h14"/> </svg>',option:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3h6l6 18h6"/> <path d="M14 3h7"/> </svg>',cuboid:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21.12 6.4-6.05-4.06a2 2 0 0 0-2.17-.05L2.95 8.41a2 2 0 0 0-.95 1.7v5.82a2 2 0 0 0 .88 1.66l6.05 4.07a2 2 0 0 0 2.17.05l9.95-6.12a2 2 0 0 0 .95-1.7V8.06a2 2 0 0 0-.88-1.66Z"/> <path d="M10 22v-8L2.25 9.15"/> <path d="m10 14 11.77-6.87"/> </svg>',"brick-wall":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M12 9v6"/> <path d="M16 15v6"/> <path d="M16 3v6"/> <path d="M3 15h18"/> <path d="M3 9h18"/> <path d="M8 15v6"/> <path d="M8 3v6"/> </svg>',"arrow-big-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 9h6V5l7 7-7 7v-4H6V9z"/> </svg>',"dna-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2c-1.35 1.5-2.092 3-2.5 4.5L14 8"/> <path d="m17 6-2.891-2.891"/> <path d="M2 15c3.333-3 6.667-3 10-3"/> <path d="m2 2 20 20"/> <path d="m20 9 .891.891"/> <path d="M22 9c-1.5 1.35-3 2.092-4.5 2.5l-1-1"/> <path d="M3.109 14.109 4 15"/> <path d="m6.5 12.5 1 1"/> <path d="m7 18 2.891 2.891"/> <path d="M9 22c1.35-1.5 2.092-3 2.5-4.5L10 16"/> </svg>',"arrow-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12 19-7-7 7-7"/> <path d="M19 12H5"/> </svg>',snail:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 13a6 6 0 1 0 12 0 4 4 0 1 0-8 0 2 2 0 0 0 4 0"/> <circle cx="10" cy="13" r="8"/> <path d="M2 21h12c4.4 0 8-3.6 8-8V7a2 2 0 1 0-4 0v6"/> <path d="M18 3 19.1 5.2"/> <path d="M22 3 20.9 5.2"/> </svg>',regex:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 3v10"/> <path d="m12.67 5.5 8.66 5"/> <path d="m12.67 10.5 8.66-5"/> <path d="M9 17a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2v-2z"/> </svg>',"circle-help":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M9.09 9a3 3 0 0 1 5.83 1c0 2-3 3-3 3"/> <path d="M12 17h.01"/> </svg>',"mail-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 13V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v12c0 1.1.9 2 2 2h9"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> <path d="m17 17 4 4"/> <path d="m21 17-4 4"/> </svg>',building:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="20" x="4" y="2" rx="2" ry="2"/> <path d="M9 22v-4h6v4"/> <path d="M8 6h.01"/> <path d="M16 6h.01"/> <path d="M12 6h.01"/> <path d="M12 10h.01"/> <path d="M12 14h.01"/> <path d="M16 10h.01"/> <path d="M16 14h.01"/> <path d="M8 10h.01"/> <path d="M8 14h.01"/> </svg>',"folder-kanban":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 20h16a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.93a2 2 0 0 1-1.66-.9l-.82-1.2A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13c0 1.1.9 2 2 2Z"/> <path d="M8 10v4"/> <path d="M12 10v2"/> <path d="M16 10v6"/> </svg>',"file-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m14.5 12.5-5 5"/> <path d="m9.5 12.5 5 5"/> </svg>',"picture-in-picture":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 4.5v5H3m-1-6 6 6m13 0v-3c0-1.16-.84-2-2-2h-7m-9 9v2c0 1.05.95 2 2 2h3"/> <rect width="10" height="7" x="12" y="13.5" ry="2"/> </svg>',"rows-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M21 9H3"/> <path d="M21 15H3"/> </svg>',"search-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m8 11 2 2 4-4"/> <circle cx="11" cy="11" r="8"/> <path d="m21 21-4.3-4.3"/> </svg>',"arrow-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 12h14"/> <path d="m12 5 7 7-7 7"/> </svg>',bell:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 8a6 6 0 0 1 12 0c0 7 3 9 3 9H3s3-2 3-9"/> <path d="M10.3 21a1.94 1.94 0 0 0 3.4 0"/> </svg>',"creative-commons":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M10 9.3a2.8 2.8 0 0 0-3.5 1 3.1 3.1 0 0 0 0 3.4 2.7 2.7 0 0 0 3.5 1"/> <path d="M17 9.3a2.8 2.8 0 0 0-3.5 1 3.1 3.1 0 0 0 0 3.4 2.7 2.7 0 0 0 3.5 1"/> </svg>',"briefcase-medical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 11v4"/> <path d="M14 13h-4"/> <path d="M16 6V4a2 2 0 0 0-2-2h-4a2 2 0 0 0-2 2v2"/> <path d="M18 6v14"/> <path d="M6 6v14"/> <rect width="20" height="14" x="2" y="6" rx="2"/> </svg>',"grid-3x3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 9h18"/> <path d="M3 15h18"/> <path d="M9 3v18"/> <path d="M15 3v18"/> </svg>',cannabis:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22v-4"/> <path d="M7 12c-1.5 0-4.5 1.5-5 3 3.5 1.5 6 1 6 1-1.5 1.5-2 3.5-2 5 2.5 0 4.5-1.5 6-3 1.5 1.5 3.5 3 6 3 0-1.5-.5-3.5-2-5 0 0 2.5.5 6-1-.5-1.5-3.5-3-5-3 1.5-1 4-4 4-6-2.5 0-5.5 1.5-7 3 0-2.5-.5-5-2-7-1.5 2-2 4.5-2 7-1.5-1.5-4.5-3-7-3 0 2 2.5 5 4 6"/> </svg>',"share-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18" cy="5" r="3"/> <circle cx="6" cy="12" r="3"/> <circle cx="18" cy="19" r="3"/> <line x1="8.59" x2="15.42" y1="13.51" y2="17.49"/> <line x1="15.41" x2="8.59" y1="6.51" y2="10.49"/> </svg>',"badge-pound-sterling":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M8 12h4"/> <path d="M10 16V9.5a2.5 2.5 0 0 1 5 0"/> <path d="M8 16h7"/> </svg>',"nut-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 4V2"/> <path d="M5 10v4a7.004 7.004 0 0 0 5.277 6.787c.412.104.802.292 1.102.592L12 22l.621-.621c.3-.3.69-.488 1.102-.592a7.01 7.01 0 0 0 4.125-2.939"/> <path d="M19 10v3.343"/> <path d="M12 12c-1.349-.573-1.905-1.005-2.5-2-.546.902-1.048 1.353-2.5 2-1.018-.644-1.46-1.08-2-2-1.028.71-1.69.918-3 1 1.081-1.048 1.757-2.03 2-3 .194-.776.84-1.551 1.79-2.21m11.654 5.997c.887-.457 1.28-.891 1.556-1.787 1.032.916 1.683 1.157 3 1-1.297-1.036-1.758-2.03-2-3-.5-2-4-4-8-4-.74 0-1.461.068-2.15.192"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',baseline:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 20h16"/> <path d="m6 16 6-12 6 12"/> <path d="M8 12h8"/> </svg>',"octagon-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 9-6 6"/> <path d="M2.586 16.726A2 2 0 0 1 2 15.312V8.688a2 2 0 0 1 .586-1.414l4.688-4.688A2 2 0 0 1 8.688 2h6.624a2 2 0 0 1 1.414.586l4.688 4.688A2 2 0 0 1 22 8.688v6.624a2 2 0 0 1-.586 1.414l-4.688 4.688a2 2 0 0 1-1.414.586H8.688a2 2 0 0 1-1.414-.586z"/> <path d="m9 9 6 6"/> </svg>',"letter-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 12h6"/> <path d="M15 6h6"/> <path d="m3 13 3.553-7.724a.5.5 0 0 1 .894 0L11 13"/> <path d="M3 18h18"/> <path d="M4 11h6"/> </svg>',"separator-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="3" x2="21" y1="12" y2="12"/> <polyline points="8 8 12 4 16 8"/> <polyline points="16 16 12 20 8 16"/> </svg>',store:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 7 4.41-4.41A2 2 0 0 1 7.83 2h8.34a2 2 0 0 1 1.42.59L22 7"/> <path d="M4 12v8a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2v-8"/> <path d="M15 22v-4a2 2 0 0 0-2-2h-2a2 2 0 0 0-2 2v4"/> <path d="M2 7h20"/> <path d="M22 7v3a2 2 0 0 1-2 2a2.7 2.7 0 0 1-1.59-.63.7.7 0 0 0-.82 0A2.7 2.7 0 0 1 16 12a2.7 2.7 0 0 1-1.59-.63.7.7 0 0 0-.82 0A2.7 2.7 0 0 1 12 12a2.7 2.7 0 0 1-1.59-.63.7.7 0 0 0-.82 0A2.7 2.7 0 0 1 8 12a2.7 2.7 0 0 1-1.59-.63.7.7 0 0 0-.82 0A2.7 2.7 0 0 1 4 12a2 2 0 0 1-2-2V7"/> </svg>',gauge:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12 14 4-4"/> <path d="M3.34 19a10 10 0 1 1 17.32 0"/> </svg>',"arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m5 12 7-7 7 7"/> <path d="M12 19V5"/> </svg>',"panel-right-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M15 14v1"/> <path d="M15 19v2"/> <path d="M15 3v2"/> <path d="M15 9v1"/> </svg>',"message-circle-question":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> <path d="M9.09 9a3 3 0 0 1 5.83 1c0 2-3 3-3 3"/> <path d="M12 17h.01"/> </svg>',"panel-top":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 9h18"/> </svg>',"align-center":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="21" x2="3" y1="6" y2="6"/> <line x1="17" x2="7" y1="12" y2="12"/> <line x1="19" x2="5" y1="18" y2="18"/> </svg>',"cup-soda":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 8 1.75 12.28a2 2 0 0 0 2 1.72h4.54a2 2 0 0 0 2-1.72L18 8"/> <path d="M5 8h14"/> <path d="M7 15a6.47 6.47 0 0 1 5 0 6.47 6.47 0 0 0 5 0"/> <path d="m12 8 1-6h2"/> </svg>',"code-xml":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m18 16 4-4-4-4"/> <path d="m6 8-4 4 4 4"/> <path d="m14.5 4-5 16"/> </svg>',twitch:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 2H3v16h5v4l4-4h5l4-4V2zm-10 9V7m5 4V7"/> </svg>',"file-diff":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M9 10h6"/> <path d="M12 13V7"/> <path d="M9 17h6"/> </svg>',"align-horizontal-justify-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="14" x="2" y="5" rx="2"/> <rect width="6" height="10" x="12" y="7" rx="2"/> <path d="M22 2v20"/> </svg>',"square-chevron-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m14 16-4-4 4-4"/> </svg>',citrus:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.66 17.67a1.08 1.08 0 0 1-.04 1.6A12 12 0 0 1 4.73 2.38a1.1 1.1 0 0 1 1.61-.04z"/> <path d="M19.65 15.66A8 8 0 0 1 8.35 4.34"/> <path d="m14 10-5.5 5.5"/> <path d="M14 17.85V10H6.15"/> </svg>',"heading-6":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 12h8"/> <path d="M4 18V6"/> <path d="M12 18V6"/> <circle cx="19" cy="16" r="2"/> <path d="M20 10c-2 2-3 3.5-3 6"/> </svg>',"file-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 12.5 8 15l2 2.5"/> <path d="m14 12.5 2 2.5-2 2.5"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7z"/> </svg>',music:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 18V5l12-2v13"/> <circle cx="6" cy="18" r="3"/> <circle cx="18" cy="16" r="3"/> </svg>',"briefcase-business":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 12h.01"/> <path d="M16 6V4a2 2 0 0 0-2-2h-4a2 2 0 0 0-2 2v2"/> <path d="M22 13a18.15 18.15 0 0 1-20 0"/> <rect width="20" height="14" x="2" y="6" rx="2"/> </svg>',"glass-water":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.2 22H8.8a2 2 0 0 1-2-1.79L5 3h14l-1.81 17.21A2 2 0 0 1 15.2 22Z"/> <path d="M6 12a5 5 0 0 1 6 0 5 5 0 0 0 6 0"/> </svg>',"square-arrow-out-up-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 3h6a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-6"/> <path d="m3 3 9 9"/> <path d="M3 9V3h6"/> </svg>',"keyboard-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M 20 4 A2 2 0 0 1 22 6"/> <path d="M 22 6 L 22 16.41"/> <path d="M 7 16 L 16 16"/> <path d="M 9.69 4 L 20 4"/> <path d="M14 8h.01"/> <path d="M18 8h.01"/> <path d="m2 2 20 20"/> <path d="M20 20H4a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2"/> <path d="M6 8h.01"/> <path d="M8 12h.01"/> </svg>',"shower-head":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m4 4 2.5 2.5"/> <path d="M13.5 6.5a4.95 4.95 0 0 0-7 7"/> <path d="M15 5 5 15"/> <path d="M14 17v.01"/> <path d="M10 16v.01"/> <path d="M13 13v.01"/> <path d="M16 10v.01"/> <path d="M11 20v.01"/> <path d="M17 14v.01"/> <path d="M20 11v.01"/> </svg>',"egg-fried":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11.5" cy="12.5" r="3.5"/> <path d="M3 8c0-3.5 2.5-6 6.5-6 5 0 4.83 3 7.5 5s5 2 5 6c0 4.5-2.5 6.5-7 6.5-2.5 0-2.5 2.5-6 2.5s-7-2-7-5.5c0-3 1.5-3 1.5-5C3.5 10 3 9 3 8Z"/> </svg>',captions:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="14" x="3" y="5" rx="2" ry="2"/> <path d="M7 15h4M15 15h2M7 11h2M13 11h4"/> </svg>',repeat:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m17 2 4 4-4 4"/> <path d="M3 11v-1a4 4 0 0 1 4-4h14"/> <path d="m7 22-4-4 4-4"/> <path d="M21 13v1a4 4 0 0 1-4 4H3"/> </svg>',"circle-power":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 7v4"/> <path d="M7.998 9.003a5 5 0 1 0 8-.005"/> <circle cx="12" cy="12" r="10"/> </svg>',"book-open-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 7v14"/> <path d="M16 12h2"/> <path d="M16 8h2"/> <path d="M3 18a1 1 0 0 1-1-1V4a1 1 0 0 1 1-1h5a4 4 0 0 1 4 4 4 4 0 0 1 4-4h5a1 1 0 0 1 1 1v13a1 1 0 0 1-1 1h-6a3 3 0 0 0-3 3 3 3 0 0 0-3-3z"/> <path d="M6 12h2"/> <path d="M6 8h2"/> </svg>',egg:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22c6.23-.05 7.87-5.57 7.5-10-.36-4.34-3.95-9.96-7.5-10-3.55.04-7.14 5.66-7.5 10-.37 4.43 1.27 9.95 7.5 10z"/> </svg>',"cloud-rain":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 14.899A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.242"/> <path d="M16 14v6"/> <path d="M8 14v6"/> <path d="M12 16v6"/> </svg>',"align-vertical-distribute-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="6" x="5" y="14" rx="2"/> <rect width="10" height="6" x="7" y="4" rx="2"/> <path d="M2 20h20"/> <path d="M2 10h20"/> </svg>',"columns-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 3v18"/> <path d="M15 3v18"/> </svg>',gem:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 3h12l4 6-10 13L2 9Z"/> <path d="M11 3 8 9l4 13 4-13-3-6"/> <path d="M2 9h20"/> </svg>',logs:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 12h8"/> <path d="M13 18h8"/> <path d="M13 6h8"/> <path d="M3 12h1"/> <path d="M3 18h1"/> <path d="M3 6h1"/> <path d="M8 12h1"/> <path d="M8 18h1"/> <path d="M8 6h1"/> </svg>',"map-pin-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19.914 11.105A7.298 7.298 0 0 0 20 10a8 8 0 0 0-16 0c0 4.993 5.539 10.193 7.399 11.799a1 1 0 0 0 1.202 0 32 32 0 0 0 .824-.738"/> <circle cx="12" cy="10" r="3"/> <path d="M16 18h6"/> <path d="M19 15v6"/> </svg>',"mic-vocal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m11 7.601-5.994 8.19a1 1 0 0 0 .1 1.298l.817.818a1 1 0 0 0 1.314.087L15.09 12"/> <path d="M16.5 21.174C15.5 20.5 14.372 20 13 20c-2.058 0-3.928 2.356-6 2-2.072-.356-2.775-3.369-1.5-4.5"/> <circle cx="16" cy="7" r="5"/> </svg>',"ticket-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 9a3 3 0 0 1 0 6v2a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2a3 3 0 0 1 0-6V7a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="m9 12 2 2 4-4"/> </svg>',"flip-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 8V5a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v3"/> <path d="M21 16v3a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-3"/> <path d="M4 12H2"/> <path d="M10 12H8"/> <path d="M16 12h-2"/> <path d="M22 12h-2"/> </svg>',"bell-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18.4 12c.8 3.8 2.6 5 2.6 5H3s3-2 3-9c0-3.3 2.7-6 6-6 1.8 0 3.4.8 4.5 2"/> <path d="M10.3 21a1.94 1.94 0 0 0 3.4 0"/> <path d="M15 8h6"/> </svg>',cigarette:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17 12H3a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h14"/> <path d="M18 8c0-2.5-2-2.5-2-5"/> <path d="M21 16a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1"/> <path d="M22 8c0-2.5-2-2.5-2-5"/> <path d="M7 12v4"/> </svg>',"chart-column-stacked":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 13H7"/> <path d="M19 9h-4"/> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <rect x="15" y="5" width="4" height="12" rx="1"/> <rect x="7" y="8" width="4" height="9" rx="1"/> </svg>',"memory-stick":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 19v-3"/> <path d="M10 19v-3"/> <path d="M14 19v-3"/> <path d="M18 19v-3"/> <path d="M8 11V9"/> <path d="M16 11V9"/> <path d="M12 11V9"/> <path d="M2 15h20"/> <path d="M2 7a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v1.1a2 2 0 0 0 0 3.837V17a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2v-5.1a2 2 0 0 0 0-3.837Z"/> </svg>',university:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="10" r="1"/> <path d="M22 20V8h-4l-6-4-6 4H2v12a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2"/> <path d="M6 17v.01"/> <path d="M6 13v.01"/> <path d="M18 17v.01"/> <path d="M18 13v.01"/> <path d="M14 22v-5a2 2 0 0 0-2-2a2 2 0 0 0-2 2v5"/> </svg>',section:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 5a4 3 0 0 0-8 0c0 4 8 3 8 7a4 3 0 0 1-8 0"/> <path d="M8 19a4 3 0 0 0 8 0c0-4-8-3-8-7a4 3 0 0 1 8 0"/> </svg>',salad:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 21h10"/> <path d="M12 21a9 9 0 0 0 9-9H3a9 9 0 0 0 9 9Z"/> <path d="M11.38 12a2.4 2.4 0 0 1-.4-4.77 2.4 2.4 0 0 1 3.2-2.77 2.4 2.4 0 0 1 3.47-.63 2.4 2.4 0 0 1 3.37 3.37 2.4 2.4 0 0 1-1.1 3.7 2.51 2.51 0 0 1 .03 1.1"/> <path d="m13 12 4-4"/> <path d="M10.9 7.25A3.99 3.99 0 0 0 4 10c0 .73.2 1.41.54 2"/> </svg>',flower:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="3"/> <path d="M12 16.5A4.5 4.5 0 1 1 7.5 12 4.5 4.5 0 1 1 12 7.5a4.5 4.5 0 1 1 4.5 4.5 4.5 4.5 0 1 1-4.5 4.5"/> <path d="M12 7.5V9"/> <path d="M7.5 12H9"/> <path d="M16.5 12H15"/> <path d="M12 16.5V15"/> <path d="m8 8 1.88 1.88"/> <path d="M14.12 9.88 16 8"/> <path d="m8 16 1.88-1.88"/> <path d="M14.12 14.12 16 16"/> </svg>',cpu:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="16" x="4" y="4" rx="2"/> <rect width="6" height="6" x="9" y="9" rx="1"/> <path d="M15 2v2"/> <path d="M15 20v2"/> <path d="M2 15h2"/> <path d="M2 9h2"/> <path d="M20 15h2"/> <path d="M20 9h2"/> <path d="M9 2v2"/> <path d="M9 20v2"/> </svg>',"tent-tree":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="4" cy="4" r="2"/> <path d="m14 5 3-3 3 3"/> <path d="m14 10 3-3 3 3"/> <path d="M17 14V2"/> <path d="M17 14H7l-5 8h20Z"/> <path d="M8 14v8"/> <path d="m9 14 5 8"/> </svg>',unplug:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 5 3-3"/> <path d="m2 22 3-3"/> <path d="M6.3 20.3a2.4 2.4 0 0 0 3.4 0L12 18l-6-6-2.3 2.3a2.4 2.4 0 0 0 0 3.4Z"/> <path d="M7.5 13.5 10 11"/> <path d="M10.5 16.5 13 14"/> <path d="m12 6 6 6 2.3-2.3a2.4 2.4 0 0 0 0-3.4l-2.6-2.6a2.4 2.4 0 0 0-3.4 0Z"/> </svg>',"badge-euro":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="M7 12h5"/> <path d="M15 9.4a4 4 0 1 0 0 5.2"/> </svg>',delete:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 5a2 2 0 0 0-1.344.519l-6.328 5.74a1 1 0 0 0 0 1.481l6.328 5.741A2 2 0 0 0 10 19h10a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2z"/> <path d="m12 9 6 6"/> <path d="m18 9-6 6"/> </svg>',"pencil-ruler":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 7 8.7 2.7a2.41 2.41 0 0 0-3.4 0L2.7 5.3a2.41 2.41 0 0 0 0 3.4L7 13"/> <path d="m8 6 2-2"/> <path d="m18 16 2-2"/> <path d="m17 11 4.3 4.3c.94.94.94 2.46 0 3.4l-2.6 2.6c-.94.94-2.46.94-3.4 0L11 17"/> <path d="M21.174 6.812a1 1 0 0 0-3.986-3.987L3.842 16.174a2 2 0 0 0-.5.83l-1.321 4.352a.5.5 0 0 0 .623.622l4.353-1.32a2 2 0 0 0 .83-.497z"/> <path d="m15 5 4 4"/> </svg>',"japanese-yen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 9.5V21m0-11.5L6 3m6 6.5L18 3"/> <path d="M6 15h12"/> <path d="M6 11h12"/> </svg>',"square-arrow-down-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m16 8-8 8"/> <path d="M16 16H8V8"/> </svg>',"toy-brick":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="12" x="3" y="8" rx="1"/> <path d="M10 8V5c0-.6-.4-1-1-1H6a1 1 0 0 0-1 1v3"/> <path d="M19 8V5c0-.6-.4-1-1-1h-3a1 1 0 0 0-1 1v3"/> </svg>',hotel:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 22v-6.57"/> <path d="M12 11h.01"/> <path d="M12 7h.01"/> <path d="M14 15.43V22"/> <path d="M15 16a5 5 0 0 0-6 0"/> <path d="M16 11h.01"/> <path d="M16 7h.01"/> <path d="M8 11h.01"/> <path d="M8 7h.01"/> <rect x="4" y="2" width="16" height="20" rx="2"/> </svg>',"timer-reset":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2h4"/> <path d="M12 14v-4"/> <path d="M4 13a8 8 0 0 1 8-7 8 8 0 1 1-5.3 14L4 17.6"/> <path d="M9 17H4v5"/> </svg>',"repeat-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m2 9 3-3 3 3"/> <path d="M13 18H7a2 2 0 0 1-2-2V6"/> <path d="m22 15-3 3-3-3"/> <path d="M11 6h6a2 2 0 0 1 2 2v10"/> </svg>',loader:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v4"/> <path d="m16.2 7.8 2.9-2.9"/> <path d="M18 12h4"/> <path d="m16.2 16.2 2.9 2.9"/> <path d="M12 18v4"/> <path d="m4.9 19.1 2.9-2.9"/> <path d="M2 12h4"/> <path d="m4.9 4.9 2.9 2.9"/> </svg>',"bell-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19.4 14.9C20.2 16.4 21 17 21 17H3s3-2 3-9c0-3.3 2.7-6 6-6 .7 0 1.3.1 1.9.3"/> <path d="M10.3 21a1.94 1.94 0 0 0 3.4 0"/> <circle cx="18" cy="8" r="3"/> </svg>',"git-commit-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3v6"/> <circle cx="12" cy="12" r="3"/> <path d="M12 15v6"/> </svg>',"car-taxi-front":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2h4"/> <path d="m21 8-2 2-1.5-3.7A2 2 0 0 0 15.646 5H8.4a2 2 0 0 0-1.903 1.257L5 10 3 8"/> <path d="M7 14h.01"/> <path d="M17 14h.01"/> <rect width="18" height="8" x="3" y="10" rx="2"/> <path d="M5 18v2"/> <path d="M19 18v2"/> </svg>',feather:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.67 19a2 2 0 0 0 1.416-.588l6.154-6.172a6 6 0 0 0-8.49-8.49L5.586 9.914A2 2 0 0 0 5 11.328V18a1 1 0 0 0 1 1z"/> <path d="M16 8 2 22"/> <path d="M17.5 15H9"/> </svg>',"music-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="18" r="4"/> <path d="M16 18V2"/> </svg>',"fold-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22v-6"/> <path d="M12 8V2"/> <path d="M4 12H2"/> <path d="M10 12H8"/> <path d="M16 12h-2"/> <path d="M22 12h-2"/> <path d="m15 19-3-3-3 3"/> <path d="m15 5-3 3-3-3"/> </svg>',"monitor-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13V7"/> <path d="m15 10-3 3-3-3"/> <rect width="20" height="14" x="2" y="3" rx="2"/> <path d="M12 17v4"/> <path d="M8 21h8"/> </svg>',ham:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.144 21.144A7.274 10.445 45 1 0 2.856 10.856"/> <path d="M13.144 21.144A7.274 4.365 45 0 0 2.856 10.856a7.274 4.365 45 0 0 10.288 10.288"/> <path d="M16.565 10.435 18.6 8.4a2.501 2.501 0 1 0 1.65-4.65 2.5 2.5 0 1 0-4.66 1.66l-2.024 2.025"/> <path d="m8.5 16.5-1-1"/> </svg>',"skip-forward":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="5 4 15 12 5 20 5 4"/> <line x1="19" x2="19" y1="5" y2="19"/> </svg>',bold:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 12h9a4 4 0 0 1 0 8H7a1 1 0 0 1-1-1V5a1 1 0 0 1 1-1h7a4 4 0 0 1 0 8"/> </svg>',"settings-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 7h-9"/> <path d="M14 17H5"/> <circle cx="17" cy="17" r="3"/> <circle cx="7" cy="7" r="3"/> </svg>',key:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15.5 7.5 2.3 2.3a1 1 0 0 0 1.4 0l2.1-2.1a1 1 0 0 0 0-1.4L19 4"/> <path d="m21 2-9.6 9.6"/> <circle cx="7.5" cy="15.5" r="5.5"/> </svg>',"layers-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16.02 12 5.48 3.13a1 1 0 0 1 0 1.74L13 21.74a2 2 0 0 1-2 0l-8.5-4.87a1 1 0 0 1 0-1.74L7.98 12"/> <path d="M13 13.74a2 2 0 0 1-2 0L2.5 8.87a1 1 0 0 1 0-1.74L11 2.26a2 2 0 0 1 2 0l8.5 4.87a1 1 0 0 1 0 1.74Z"/> </svg>',"hand-helping":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 12h2a2 2 0 1 0 0-4h-3c-.6 0-1.1.2-1.4.6L3 14"/> <path d="m7 18 1.6-1.4c.3-.4.8-.6 1.4-.6h4c1.1 0 2.1-.4 2.8-1.2l4.6-4.4a2 2 0 0 0-2.75-2.91l-4.2 3.9"/> <path d="m2 13 6 6"/> </svg>',"list-video":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 12H3"/> <path d="M16 6H3"/> <path d="M12 18H3"/> <path d="m16 12 5 3-5 3v-6Z"/> </svg>',"move-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="18 8 22 12 18 16"/> <polyline points="6 8 2 12 6 16"/> <line x1="2" x2="22" y1="12" y2="12"/> </svg>',cake:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 21v-8a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v8"/> <path d="M4 16s.5-1 2-1 2.5 2 4 2 2.5-2 4-2 2.5 2 4 2 2-1 2-1"/> <path d="M2 21h20"/> <path d="M7 8v3"/> <path d="M12 8v3"/> <path d="M17 8v3"/> <path d="M7 4h.01"/> <path d="M12 4h.01"/> <path d="M17 4h.01"/> </svg>',"align-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="21" x2="3" y1="6" y2="6"/> <line x1="21" x2="9" y1="12" y2="12"/> <line x1="21" x2="7" y1="18" y2="18"/> </svg>',"spray-can":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3h.01"/> <path d="M7 5h.01"/> <path d="M11 7h.01"/> <path d="M3 7h.01"/> <path d="M7 9h.01"/> <path d="M3 11h.01"/> <rect width="4" height="4" x="15" y="5"/> <path d="m19 9 2 2v10c0 .6-.4 1-1 1h-6c-.6 0-1-.4-1-1V11l2-2"/> <path d="m13 14 8-2"/> <path d="m13 19 8-2"/> </svg>',proportions:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="16" x="2" y="4" rx="2"/> <path d="M12 9v11"/> <path d="M2 9h13a2 2 0 0 1 2 2v9"/> </svg>',"audio-lines":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 10v3"/> <path d="M6 6v11"/> <path d="M10 3v18"/> <path d="M14 8v7"/> <path d="M18 5v13"/> <path d="M22 10v3"/> </svg>',"clipboard-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2h2"/> <path d="m9 14 2 2 4-4"/> </svg>',laugh:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M18 13a6 6 0 0 1-6 5 6 6 0 0 1-6-5h12Z"/> <line x1="9" x2="9.01" y1="9" y2="9"/> <line x1="15" x2="15.01" y1="9" y2="9"/> </svg>',speech:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8.8 20v-4.1l1.9.2a2.3 2.3 0 0 0 2.164-2.1V8.3A5.37 5.37 0 0 0 2 8.25c0 2.8.656 3.054 1 4.55a5.77 5.77 0 0 1 .029 2.758L2 20"/> <path d="M19.8 17.8a7.5 7.5 0 0 0 .003-10.603"/> <path d="M17 15a3.5 3.5 0 0 0-.025-4.975"/> </svg>',"message-circle":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7.9 20A9 9 0 1 0 4 16.1L2 22Z"/> </svg>',"mail-warning":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 10.5V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v12c0 1.1.9 2 2 2h12.5"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> <path d="M20 14v4"/> <path d="M20 22v.01"/> </svg>',unlink:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m18.84 12.25 1.72-1.71h-.02a5.004 5.004 0 0 0-.12-7.07 5.006 5.006 0 0 0-6.95 0l-1.72 1.71"/> <path d="m5.17 11.75-1.71 1.71a5.004 5.004 0 0 0 .12 7.07 5.006 5.006 0 0 0 6.95 0l1.71-1.71"/> <line x1="8" x2="8" y1="2" y2="5"/> <line x1="2" x2="5" y1="8" y2="8"/> <line x1="16" x2="16" y1="19" y2="22"/> <line x1="19" x2="22" y1="16" y2="16"/> </svg>',"earth-lock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 3.34V5a3 3 0 0 0 3 3"/> <path d="M11 21.95V18a2 2 0 0 0-2-2 2 2 0 0 1-2-2v-1a2 2 0 0 0-2-2H2.05"/> <path d="M21.54 15H17a2 2 0 0 0-2 2v4.54"/> <path d="M12 2a10 10 0 1 0 9.54 13"/> <path d="M20 6V4a2 2 0 1 0-4 0v2"/> <rect width="8" height="5" x="14" y="6" rx="1"/> </svg>',"mail-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 15V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v12c0 1.1.9 2 2 2h8"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> <path d="M16 19h6"/> </svg>',"locate-fixed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" x2="5" y1="12" y2="12"/> <line x1="19" x2="22" y1="12" y2="12"/> <line x1="12" x2="12" y1="2" y2="5"/> <line x1="12" x2="12" y1="19" y2="22"/> <circle cx="12" cy="12" r="7"/> <circle cx="12" cy="12" r="3"/> </svg>',"square-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <circle cx="12" cy="12" r="1"/> </svg>',"message-square-share":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 12v3a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h7"/> <path d="M16 3h5v5"/> <path d="m16 8 5-5"/> </svg>',"square-terminal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 11 2-2-2-2"/> <path d="M11 13h4"/> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> </svg>',hexagon:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 16V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l7-4A2 2 0 0 0 21 16z"/> </svg>',brain:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 5a3 3 0 1 0-5.997.125 4 4 0 0 0-2.526 5.77 4 4 0 0 0 .556 6.588A4 4 0 1 0 12 18Z"/> <path d="M12 5a3 3 0 1 1 5.997.125 4 4 0 0 1 2.526 5.77 4 4 0 0 1-.556 6.588A4 4 0 1 1 12 18Z"/> <path d="M15 13a4.5 4.5 0 0 1-3-4 4.5 4.5 0 0 1-3 4"/> <path d="M17.599 6.5a3 3 0 0 0 .399-1.375"/> <path d="M6.003 5.125A3 3 0 0 0 6.401 6.5"/> <path d="M3.477 10.896a4 4 0 0 1 .585-.396"/> <path d="M19.938 10.5a4 4 0 0 1 .585.396"/> <path d="M6 18a4 4 0 0 1-1.967-.516"/> <path d="M19.967 17.484A4 4 0 0 1 18 18"/> </svg>',"square-arrow-out-up-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 13v6a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h6"/> <path d="m21 3-9 9"/> <path d="M15 3h6v6"/> </svg>',"scan-face":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <path d="M8 14s1.5 2 4 2 4-2 4-2"/> <path d="M9 9h.01"/> <path d="M15 9h.01"/> </svg>',"arrow-down-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 7 10 10"/> <path d="M17 7v10H7"/> </svg>',send:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.536 21.686a.5.5 0 0 0 .937-.024l6.5-19a.496.496 0 0 0-.635-.635l-19 6.5a.5.5 0 0 0-.024.937l7.93 3.18a2 2 0 0 1 1.112 1.11z"/> <path d="m21.854 2.147-10.94 10.939"/> </svg>',"arrow-right-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16 3 4 4-4 4"/> <path d="M20 7H4"/> <path d="m8 21-4-4 4-4"/> <path d="M4 17h16"/> </svg>',"list-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 12H3"/> <path d="M16 6H3"/> <path d="M16 18H3"/> <path d="M18 9v6"/> <path d="M21 12h-6"/> </svg>',"notepad-text-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M12 2v4"/> <path d="M16 2v4"/> <path d="M16 4h2a2 2 0 0 1 2 2v2"/> <path d="M20 12v2"/> <path d="M20 18v2a2 2 0 0 1-2 2h-1"/> <path d="M13 22h-2"/> <path d="M7 22H6a2 2 0 0 1-2-2v-2"/> <path d="M4 14v-2"/> <path d="M4 8V6a2 2 0 0 1 2-2h2"/> <path d="M8 10h6"/> <path d="M8 14h8"/> <path d="M8 18h5"/> </svg>',"align-horizontal-distribute-center":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="14" x="4" y="5" rx="2"/> <rect width="6" height="10" x="14" y="7" rx="2"/> <path d="M17 22v-5"/> <path d="M17 7V2"/> <path d="M7 22v-3"/> <path d="M7 5V2"/> </svg>',"file-plus-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M3 15h6"/> <path d="M6 12v6"/> </svg>',earth:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21.54 15H17a2 2 0 0 0-2 2v4.54"/> <path d="M7 3.34V5a3 3 0 0 0 3 3a2 2 0 0 1 2 2c0 1.1.9 2 2 2a2 2 0 0 0 2-2c0-1.1.9-2 2-2h3.17"/> <path d="M11 21.95V18a2 2 0 0 0-2-2a2 2 0 0 1-2-2v-1a2 2 0 0 0-2-2H2.05"/> <circle cx="12" cy="12" r="10"/> </svg>',"align-start-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="9" height="6" x="6" y="14" rx="2"/> <rect width="16" height="6" x="6" y="4" rx="2"/> <path d="M2 2v20"/> </svg>',"monitor-play":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 7.75a.75.75 0 0 1 1.142-.638l3.664 2.249a.75.75 0 0 1 0 1.278l-3.664 2.25a.75.75 0 0 1-1.142-.64z"/> <path d="M12 17v4"/> <path d="M8 21h8"/> <rect x="2" y="3" width="20" height="14" rx="2"/> </svg>',"bookmark-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 21-7-4-7 4V5a2 2 0 0 1 2-2h10a2 2 0 0 1 2 2Z"/> <path d="m9 10 2 2 4-4"/> </svg>',"diamond-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.7 10.3a2.41 2.41 0 0 0 0 3.41l7.59 7.59a2.41 2.41 0 0 0 3.41 0l7.59-7.59a2.41 2.41 0 0 0 0-3.41L13.7 2.71a2.41 2.41 0 0 0-3.41 0z"/> <path d="M8 12h8"/> </svg>',"book-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17h2"/> <path d="M12 22h2"/> <path d="M12 2h2"/> <path d="M18 22h1a1 1 0 0 0 1-1"/> <path d="M18 2h1a1 1 0 0 1 1 1v1"/> <path d="M20 15v2h-2"/> <path d="M20 8v3"/> <path d="M4 11V9"/> <path d="M4 19.5V15"/> <path d="M4 5v-.5A2.5 2.5 0 0 1 6.5 2H8"/> <path d="M8 22H6.5a1 1 0 0 1 0-5H8"/> </svg>',"circle-slash-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M22 2 2 22"/> </svg>',triangle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13.73 4a2 2 0 0 0-3.46 0l-8 14A2 2 0 0 0 4 21h16a2 2 0 0 0 1.73-3Z"/> </svg>',spade:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 9c-1.5 1.5-3 3.2-3 5.5A5.5 5.5 0 0 0 7.5 20c1.8 0 3-.5 4.5-2 1.5 1.5 2.7 2 4.5 2a5.5 5.5 0 0 0 5.5-5.5c0-2.3-1.5-4-3-5.5l-7-7-7 7Z"/> <path d="M12 18v4"/> </svg>',tags:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 5 6.3 6.3a2.4 2.4 0 0 1 0 3.4L17 19"/> <path d="M9.586 5.586A2 2 0 0 0 8.172 5H3a1 1 0 0 0-1 1v5.172a2 2 0 0 0 .586 1.414L8.29 18.29a2.426 2.426 0 0 0 3.42 0l3.58-3.58a2.426 2.426 0 0 0 0-3.42z"/> <circle cx="6.5" cy="9.5" r=".5" fill="currentColor"/> </svg>',"arrow-down-wide-narrow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 16 4 4 4-4"/> <path d="M7 20V4"/> <path d="M11 4h10"/> <path d="M11 8h7"/> <path d="M11 12h4"/> </svg>',"square-activity":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M17 12h-2l-2 5-2-10-2 5H7"/> </svg>',videotape:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="16" x="2" y="4" rx="2"/> <path d="M2 8h20"/> <circle cx="8" cy="14" r="2"/> <path d="M8 12h8"/> <circle cx="16" cy="14" r="2"/> </svg>',"cigarette-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 12H3a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h13"/> <path d="M18 8c0-2.5-2-2.5-2-5"/> <path d="m2 2 20 20"/> <path d="M21 12a1 1 0 0 1 1 1v2a1 1 0 0 1-.5.866"/> <path d="M22 8c0-2.5-2-2.5-2-5"/> <path d="M7 12v4"/> </svg>',"signal-medium":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 20h.01"/> <path d="M7 20v-4"/> <path d="M12 20v-8"/> </svg>',"clipboard-type":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2h2"/> <path d="M9 12v-1h6v1"/> <path d="M11 17h2"/> <path d="M12 11v6"/> </svg>',"leafy-green":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 22c1.25-.987 2.27-1.975 3.9-2.2a5.56 5.56 0 0 1 3.8 1.5 4 4 0 0 0 6.187-2.353 3.5 3.5 0 0 0 3.69-5.116A3.5 3.5 0 0 0 20.95 8 3.5 3.5 0 1 0 16 3.05a3.5 3.5 0 0 0-5.831 1.373 3.5 3.5 0 0 0-5.116 3.69 4 4 0 0 0-2.348 6.155C3.499 15.42 4.409 16.712 4.2 18.1 3.926 19.743 3.014 20.732 2 22"/> <path d="M2 22 17 7"/> </svg>',"calendar-plus-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <rect width="18" height="18" x="3" y="4" rx="2"/> <path d="M3 10h18"/> <path d="M10 16h4"/> <path d="M12 14v4"/> </svg>',"drafting-compass":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12.99 6.74 1.93 3.44"/> <path d="M19.136 12a10 10 0 0 1-14.271 0"/> <path d="m21 21-2.16-3.84"/> <path d="m3 21 8.02-14.26"/> <circle cx="12" cy="5" r="2"/> </svg>',"git-fork":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="18" r="3"/> <circle cx="6" cy="6" r="3"/> <circle cx="18" cy="6" r="3"/> <path d="M18 9v2c0 .6-.4 1-1 1H7c-.6 0-1-.4-1-1V9"/> <path d="M12 12v3"/> </svg>',"volume-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 4.702a.705.705 0 0 0-1.203-.498L6.413 7.587A1.4 1.4 0 0 1 5.416 8H3a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2.416a1.4 1.4 0 0 1 .997.413l3.383 3.384A.705.705 0 0 0 11 19.298z"/> <line x1="22" x2="16" y1="9" y2="15"/> <line x1="16" x2="22" y1="9" y2="15"/> </svg>',"square-library":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M7 7v10"/> <path d="M11 7v10"/> <path d="m15 7 2 10"/> </svg>',"fold-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12h6"/> <path d="M22 12h-6"/> <path d="M12 2v2"/> <path d="M12 8v2"/> <path d="M12 14v2"/> <path d="M12 20v2"/> <path d="m19 9-3 3 3 3"/> <path d="m5 15 3-3-3-3"/> </svg>',expand:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21 21-6-6m6 6v-4.8m0 4.8h-4.8"/> <path d="M3 16.2V21m0 0h4.8M3 21l6-6"/> <path d="M21 7.8V3m0 0h-4.8M21 3l-6 6"/> <path d="M3 7.8V3m0 0h4.8M3 3l6 6"/> </svg>',"file-question":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17h.01"/> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7z"/> <path d="M9.1 9a3 3 0 0 1 5.82 1c0 2-3 3-3 3"/> </svg>',"messages-square":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 9a2 2 0 0 1-2 2H6l-4 4V4c0-1.1.9-2 2-2h8a2 2 0 0 1 2 2z"/> <path d="M18 9h2a2 2 0 0 1 2 2v11l-4-4h-6a2 2 0 0 1-2-2v-1"/> </svg>',"zap-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.513 4.856 13.12 2.17a.5.5 0 0 1 .86.46l-1.377 4.317"/> <path d="M15.656 10H20a1 1 0 0 1 .78 1.63l-1.72 1.773"/> <path d="M16.273 16.273 10.88 21.83a.5.5 0 0 1-.86-.46l1.92-6.02A1 1 0 0 0 11 14H4a1 1 0 0 1-.78-1.63l4.507-4.643"/> <path d="m2 2 20 20"/> </svg>',calendar:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <rect width="18" height="18" x="3" y="4" rx="2"/> <path d="M3 10h18"/> </svg>',refrigerator:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 6a4 4 0 0 1 4-4h6a4 4 0 0 1 4 4v14a2 2 0 0 1-2 2H7a2 2 0 0 1-2-2V6Z"/> <path d="M5 10h14"/> <path d="M15 7v6"/> </svg>',"mouse-pointer-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4.037 4.688a.495.495 0 0 1 .651-.651l16 6.5a.5.5 0 0 1-.063.947l-6.124 1.58a2 2 0 0 0-1.438 1.435l-1.579 6.126a.5.5 0 0 1-.947.063z"/> </svg>',"land-plot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12 8 6-3-6-3v10"/> <path d="m8 11.99-5.5 3.14a1 1 0 0 0 0 1.74l8.5 4.86a2 2 0 0 0 2 0l8.5-4.86a1 1 0 0 0 0-1.74L16 12"/> <path d="m6.49 12.85 11.02 6.3"/> <path d="M17.51 12.85 6.5 19.15"/> </svg>',"calendar-fold":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <path d="M21 17V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h11Z"/> <path d="M3 10h18"/> <path d="M15 22v-4a2 2 0 0 1 2-2h4"/> </svg>',"calendar-range":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="4" rx="2"/> <path d="M16 2v4"/> <path d="M3 10h18"/> <path d="M8 2v4"/> <path d="M17 14h-6"/> <path d="M13 18H7"/> <path d="M7 14h.01"/> <path d="M17 18h.01"/> </svg>',archive:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="5" x="2" y="3" rx="1"/> <path d="M4 8v11a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V8"/> <path d="M10 12h4"/> </svg>',"scissors-line-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5.42 9.42 8 12"/> <circle cx="4" cy="8" r="2"/> <path d="m14 6-8.58 8.58"/> <circle cx="4" cy="16" r="2"/> <path d="M10.8 14.8 14 18"/> <path d="M16 12h-2"/> <path d="M22 12h-2"/> </svg>',"user-round-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 21a8 8 0 0 1 13.292-6"/> <circle cx="10" cy="8" r="5"/> <path d="M19 16v6"/> <path d="M22 19h-6"/> </svg>',aperture:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m14.31 8 5.74 9.94"/> <path d="M9.69 8h11.48"/> <path d="m7.38 12 5.74-9.94"/> <path d="M9.69 16 3.95 6.06"/> <path d="M14.31 16H2.83"/> <path d="m16.62 12-5.74 9.94"/> </svg>',cloudy:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M17.5 21H9a7 7 0 1 1 6.71-9h1.79a4.5 4.5 0 1 1 0 9Z"/> <path d="M22 10a3 3 0 0 0-3-3h-2.207a5.502 5.502 0 0 0-10.702.5"/> </svg>',"book-lock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 6V4a2 2 0 1 0-4 0v2"/> <path d="M20 15v6a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H10"/> <rect x="12" y="6" width="8" height="5" rx="1"/> </svg>',linkedin:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 8a6 6 0 0 1 6 6v7h-4v-7a2 2 0 0 0-2-2 2 2 0 0 0-2 2v7h-4v-7a6 6 0 0 1 6-6z"/> <rect width="4" height="12" x="2" y="9"/> <circle cx="4" cy="4" r="2"/> </svg>',"door-closed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 20V6a2 2 0 0 0-2-2H8a2 2 0 0 0-2 2v14"/> <path d="M2 20h20"/> <path d="M14 12v.01"/> </svg>',tangent:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="17" cy="4" r="2"/> <path d="M15.59 5.41 5.41 15.59"/> <circle cx="4" cy="17" r="2"/> <path d="M12 22s-4-9-1.5-11.5S22 12 22 12"/> </svg>',"map-pinned":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 8c0 3.613-3.869 7.429-5.393 8.795a1 1 0 0 1-1.214 0C9.87 15.429 6 11.613 6 8a6 6 0 0 1 12 0"/> <circle cx="12" cy="8" r="2"/> <path d="M8.714 14h-3.71a1 1 0 0 0-.948.683l-2.004 6A1 1 0 0 0 3 22h18a1 1 0 0 0 .948-1.316l-2-6a1 1 0 0 0-.949-.684h-3.712"/> </svg>',"square-chart-gantt":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 8h7"/> <path d="M8 12h6"/> <path d="M11 16h5"/> </svg>',"layout-panel-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="7" height="18" x="3" y="3" rx="1"/> <rect width="7" height="7" x="14" y="3" rx="1"/> <rect width="7" height="7" x="14" y="14" rx="1"/> </svg>',angry:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M16 16s-1.5-2-4-2-4 2-4 2"/> <path d="M7.5 8 10 9"/> <path d="m14 9 2.5-1"/> <path d="M9 10h.01"/> <path d="M15 10h.01"/> </svg>',microchip:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 12h2"/> <path d="M18 16h2"/> <path d="M18 20h2"/> <path d="M18 4h2"/> <path d="M18 8h2"/> <path d="M4 12h2"/> <path d="M4 16h2"/> <path d="M4 20h2"/> <path d="M4 4h2"/> <path d="M4 8h2"/> <path d="M8 2a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2V4a2 2 0 0 0-2-2h-1.5c-.276 0-.494.227-.562.495a2 2 0 0 1-3.876 0C9.994 2.227 9.776 2 9.5 2z"/> </svg>',"package-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 10V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l2-1.14"/> <path d="m7.5 4.27 9 5.15"/> <polyline points="3.29 7 12 12 20.71 7"/> <line x1="12" x2="12" y1="22" y2="12"/> <circle cx="18.5" cy="15.5" r="2.5"/> <path d="M20.27 17.27 22 19"/> </svg>',"square-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="m15 9-6 6"/> <path d="m9 9 6 6"/> </svg>',"fish-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 12.47v.03m0-.5v.47m-.475 5.056A6.744 6.744 0 0 1 15 18c-3.56 0-7.56-2.53-8.5-6 .348-1.28 1.114-2.433 2.121-3.38m3.444-2.088A8.802 8.802 0 0 1 15 6c3.56 0 6.06 2.54 7 6-.309 1.14-.786 2.177-1.413 3.058"/> <path d="M7 10.67C7 8 5.58 5.97 2.73 5.5c-1 1.5-1 5 .23 6.5-1.24 1.5-1.24 5-.23 6.5C5.58 18.03 7 16 7 13.33m7.48-4.372A9.77 9.77 0 0 1 16 6.07m0 11.86a9.77 9.77 0 0 1-1.728-3.618"/> <path d="m16.01 17.93-.23 1.4A2 2 0 0 1 13.8 21H9.5a5.96 5.96 0 0 0 1.49-3.98M8.53 3h5.27a2 2 0 0 1 1.98 1.67l.23 1.4M2 2l20 20"/> </svg>',"link-2-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 17H7A5 5 0 0 1 7 7"/> <path d="M15 7h2a5 5 0 0 1 4 8"/> <line x1="8" x2="12" y1="12" y2="12"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"receipt-russian-ruble":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M8 15h5"/> <path d="M8 11h5a2 2 0 1 0 0-4h-3v10"/> </svg>',"test-tube":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.5 2v17.5c0 1.4-1.1 2.5-2.5 2.5c-1.4 0-2.5-1.1-2.5-2.5V2"/> <path d="M8.5 2h7"/> <path d="M14.5 16h-5"/> </svg>',"box-select":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 3a2 2 0 0 0-2 2"/> <path d="M19 3a2 2 0 0 1 2 2"/> <path d="M21 19a2 2 0 0 1-2 2"/> <path d="M5 21a2 2 0 0 1-2-2"/> <path d="M9 3h1"/> <path d="M9 21h1"/> <path d="M14 3h1"/> <path d="M14 21h1"/> <path d="M3 9v1"/> <path d="M21 9v1"/> <path d="M3 14v1"/> <path d="M21 14v1"/> </svg>',"panel-left-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M9 14v1"/> <path d="M9 19v2"/> <path d="M9 3v2"/> <path d="M9 9v1"/> </svg>',glasses:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="6" cy="15" r="4"/> <circle cx="18" cy="15" r="4"/> <path d="M14 15a2 2 0 0 0-2-2 2 2 0 0 0-2 2"/> <path d="M2.5 13 5 7c.7-1.3 1.4-2 3-2"/> <path d="M21.5 13 19 7c-.7-1.3-1.5-2-3-2"/> </svg>',"mail-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 13V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v12c0 1.1.9 2 2 2h8"/> <path d="m22 7-8.97 5.7a1.94 1.94 0 0 1-2.06 0L2 7"/> <path d="m16 19 2 2 4-4"/> </svg>',"spell-check-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 16 6-12 6 12"/> <path d="M8 12h8"/> <path d="M4 21c1.1 0 1.1-1 2.3-1s1.1 1 2.3 1c1.1 0 1.1-1 2.3-1 1.1 0 1.1 1 2.3 1 1.1 0 1.1-1 2.3-1 1.1 0 1.1 1 2.3 1 1.1 0 1.1-1 2.3-1"/> </svg>',"tablet-smartphone":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="10" height="14" x="3" y="8" rx="2"/> <path d="M5 4a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v16a2 2 0 0 1-2 2h-2.4"/> <path d="M8 18h.01"/> </svg>',"ethernet-port":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 20 3-3h2a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v9a2 2 0 0 0 2 2h2l3 3z"/> <path d="M6 8v1"/> <path d="M10 8v1"/> <path d="M14 8v1"/> <path d="M18 8v1"/> </svg>',blinds:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3h18"/> <path d="M20 7H8"/> <path d="M20 11H8"/> <path d="M10 19h10"/> <path d="M8 15h12"/> <path d="M4 3v14"/> <circle cx="4" cy="19" r="2"/> </svg>',"wifi-low":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 20h.01"/> <path d="M8.5 16.429a5 5 0 0 1 7 0"/> </svg>',"receipt-euro":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 2v20l2-1 2 1 2-1 2 1 2-1 2 1 2-1 2 1V2l-2 1-2-1-2 1-2-1-2 1-2-1-2 1Z"/> <path d="M8 12h5"/> <path d="M16 9.5a4 4 0 1 0 0 5.2"/> </svg>',briefcase:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 20V4a2 2 0 0 0-2-2h-4a2 2 0 0 0-2 2v16"/> <rect width="20" height="14" x="2" y="6" rx="2"/> </svg>',droplet:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22a7 7 0 0 0 7-7c0-2-1-3.9-3-5.5s-3.5-4-4-6.5c-.5 2.5-2 4.9-4 6.5C6 11.1 5 13 5 15a7 7 0 0 0 7 7z"/> </svg>',"trending-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="22 17 13.5 8.5 8.5 13.5 2 7"/> <polyline points="16 17 22 17 22 11"/> </svg>',"paintbrush-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 2v2"/> <path d="M14 2v4"/> <path d="M17 2a1 1 0 0 1 1 1v9H6V3a1 1 0 0 1 1-1z"/> <path d="M6 12a1 1 0 0 0-1 1v1a2 2 0 0 0 2 2h2a1 1 0 0 1 1 1v2.9a2 2 0 1 0 4 0V17a1 1 0 0 1 1-1h2a2 2 0 0 0 2-2v-1a1 1 0 0 0-1-1"/> </svg>',"flag-triangle-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 22V2l10 5-10 5"/> </svg>',"clock-9":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 7.5 12"/> </svg>',"wand-sparkles":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21.64 3.64-1.28-1.28a1.21 1.21 0 0 0-1.72 0L2.36 18.64a1.21 1.21 0 0 0 0 1.72l1.28 1.28a1.2 1.2 0 0 0 1.72 0L21.64 5.36a1.2 1.2 0 0 0 0-1.72"/> <path d="m14 7 3 3"/> <path d="M5 6v4"/> <path d="M19 14v4"/> <path d="M10 2v2"/> <path d="M7 8H3"/> <path d="M21 16h-4"/> <path d="M11 3H9"/> </svg>',crown:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11.562 3.266a.5.5 0 0 1 .876 0L15.39 8.87a1 1 0 0 0 1.516.294L21.183 5.5a.5.5 0 0 1 .798.519l-2.834 10.246a1 1 0 0 1-.956.734H5.81a1 1 0 0 1-.957-.734L2.02 6.02a.5.5 0 0 1 .798-.519l4.276 3.664a1 1 0 0 0 1.516-.294z"/> <path d="M5 21h14"/> </svg>',rabbit:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 16a3 3 0 0 1 2.24 5"/> <path d="M18 12h.01"/> <path d="M18 21h-8a4 4 0 0 1-4-4 7 7 0 0 1 7-7h.2L9.6 6.4a1 1 0 1 1 2.8-2.8L15.8 7h.2c3.3 0 6 2.7 6 6v1a2 2 0 0 1-2 2h-1a3 3 0 0 0-3 3"/> <path d="M20 8.54V4a2 2 0 1 0-4 0v3"/> <path d="M7.612 12.524a3 3 0 1 0-1.6 4.3"/> </svg>',"git-compare-arrows":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="5" cy="6" r="3"/> <path d="M12 6h5a2 2 0 0 1 2 2v7"/> <path d="m15 9-3-3 3-3"/> <circle cx="19" cy="18" r="3"/> <path d="M12 18H7a2 2 0 0 1-2-2V9"/> <path d="m9 15 3 3-3 3"/> </svg>',"package-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 9h18v10a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V9Z"/> <path d="m3 9 2.45-4.9A2 2 0 0 1 7.24 3h9.52a2 2 0 0 1 1.8 1.1L21 9"/> <path d="M12 3v6"/> </svg>',"dice-4":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="M16 8h.01"/> <path d="M8 8h.01"/> <path d="M8 16h.01"/> <path d="M16 16h.01"/> </svg>',"clock-5":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 14.5 16"/> </svg>',"square-pi":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M7 7h10"/> <path d="M10 7v10"/> <path d="M16 17a2 2 0 0 1-2-2V7"/> </svg>',"list-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 18H3"/> <path d="m15 18 2 2 4-4"/> <path d="M16 12H3"/> <path d="M16 6H3"/> </svg>',"book-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13V7"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="m9 10 3 3 3-3"/> </svg>',"type-outline":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 16.5a.5.5 0 0 0 .5.5h.5a2 2 0 0 1 0 4H9a2 2 0 0 1 0-4h.5a.5.5 0 0 0 .5-.5v-9a.5.5 0 0 0-.5-.5h-3a.5.5 0 0 0-.5.5V8a2 2 0 0 1-4 0V5a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v3a2 2 0 0 1-4 0v-.5a.5.5 0 0 0-.5-.5h-3a.5.5 0 0 0-.5.5Z"/> </svg>',"git-pull-request-create":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="6" cy="6" r="3"/> <path d="M6 9v12"/> <path d="M13 6h3a2 2 0 0 1 2 2v3"/> <path d="M18 15v6"/> <path d="M21 18h-6"/> </svg>',"sun-moon":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 8a2.83 2.83 0 0 0 4 4 4 4 0 1 1-4-4"/> <path d="M12 2v2"/> <path d="M12 20v2"/> <path d="m4.9 4.9 1.4 1.4"/> <path d="m17.7 17.7 1.4 1.4"/> <path d="M2 12h2"/> <path d="M20 12h2"/> <path d="m6.3 17.7-1.4 1.4"/> <path d="m19.1 4.9-1.4 1.4"/> </svg>',"clipboard-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2h2"/> <path d="M9 14h6"/> </svg>',"message-square-reply":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="m10 7-3 3 3 3"/> <path d="M17 13v-1a2 2 0 0 0-2-2H7"/> </svg>',shield:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> </svg>',"folder-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> <path d="m9.5 10.5 5 5"/> <path d="m14.5 10.5-5 5"/> </svg>',target:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <circle cx="12" cy="12" r="6"/> <circle cx="12" cy="12" r="2"/> </svg>',"monitor-stop":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17v4"/> <path d="M8 21h8"/> <rect x="2" y="3" width="20" height="14" rx="2"/> <rect x="9" y="7" width="6" height="6" rx="1"/> </svg>',"git-graph":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="5" cy="6" r="3"/> <path d="M5 9v6"/> <circle cx="5" cy="18" r="3"/> <path d="M12 3v18"/> <circle cx="19" cy="6" r="3"/> <path d="M16 15.7A9 9 0 0 0 19 9"/> </svg>',pocket:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 3h16a2 2 0 0 1 2 2v6a10 10 0 0 1-10 10A10 10 0 0 1 2 11V5a2 2 0 0 1 2-2z"/> <polyline points="8 10 12 14 16 10"/> </svg>',quote:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 3a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2 1 1 0 0 1 1 1v1a2 2 0 0 1-2 2 1 1 0 0 0-1 1v2a1 1 0 0 0 1 1 6 6 0 0 0 6-6V5a2 2 0 0 0-2-2z"/> <path d="M5 3a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2 1 1 0 0 1 1 1v1a2 2 0 0 1-2 2 1 1 0 0 0-1 1v2a1 1 0 0 0 1 1 6 6 0 0 0 6-6V5a2 2 0 0 0-2-2z"/> </svg>',"book-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13V7"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="m9 10 3-3 3 3"/> </svg>',"chart-column":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M18 17V9"/> <path d="M13 17V5"/> <path d="M8 17v-3"/> </svg>',eraser:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 21-4.3-4.3c-1-1-1-2.5 0-3.4l9.6-9.6c1-1 2.5-1 3.4 0l5.6 5.6c1 1 1 2.5 0 3.4L13 21"/> <path d="M22 21H7"/> <path d="m5 11 9 9"/> </svg>',"thermometer-snowflake":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 12h10"/> <path d="M9 4v16"/> <path d="m3 9 3 3-3 3"/> <path d="M12 6 9 9 6 6"/> <path d="m6 18 3-3 1.5 1.5"/> <path d="M20 4v10.54a4 4 0 1 1-4 0V4a2 2 0 0 1 4 0Z"/> </svg>',touchpad:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="16" x="2" y="4" rx="2"/> <path d="M2 14h20"/> <path d="M12 20v-6"/> </svg>',sheet:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <line x1="3" x2="21" y1="9" y2="9"/> <line x1="3" x2="21" y1="15" y2="15"/> <line x1="9" x2="9" y1="9" y2="21"/> <line x1="15" x2="15" y1="9" y2="21"/> </svg>',"sun-snow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 9a3 3 0 1 0 0 6"/> <path d="M2 12h1"/> <path d="M14 21V3"/> <path d="M10 4V3"/> <path d="M10 21v-1"/> <path d="m3.64 18.36.7-.7"/> <path d="m4.34 6.34-.7-.7"/> <path d="M14 12h8"/> <path d="m17 4-3 3"/> <path d="m14 17 3 3"/> <path d="m21 15-3-3 3-3"/> </svg>',"shield-ban":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="m4.243 5.21 14.39 12.472"/> </svg>',"square-split-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 19H5c-1 0-2-1-2-2V7c0-1 1-2 2-2h3"/> <path d="M16 5h3c1 0 2 1 2 2v10c0 1-1 2-2 2h-3"/> <line x1="12" x2="12" y1="4" y2="20"/> </svg>',layers:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12.83 2.18a2 2 0 0 0-1.66 0L2.6 6.08a1 1 0 0 0 0 1.83l8.58 3.91a2 2 0 0 0 1.66 0l8.58-3.9a1 1 0 0 0 0-1.83Z"/> <path d="m22 17.65-9.17 4.16a2 2 0 0 1-1.66 0L2 17.65"/> <path d="m22 12.65-9.17 4.16a2 2 0 0 1-1.66 0L2 12.65"/> </svg>',"square-scissors":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="20" x="2" y="2" rx="2"/> <circle cx="8" cy="8" r="2"/> <path d="M9.414 9.414 12 12"/> <path d="M14.8 14.8 18 18"/> <circle cx="8" cy="16" r="2"/> <path d="m18 6-8.586 8.586"/> </svg>',"trash-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 6h18"/> <path d="M19 6v14c0 1-1 2-2 2H7c-1 0-2-1-2-2V6"/> <path d="M8 6V4c0-1 1-2 2-2h4c1 0 2 1 2 2v2"/> <line x1="10" x2="10" y1="11" y2="17"/> <line x1="14" x2="14" y1="11" y2="17"/> </svg>',atom:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="1"/> <path d="M20.2 20.2c2.04-2.03.02-7.36-4.5-11.9-4.54-4.52-9.87-6.54-11.9-4.5-2.04 2.03-.02 7.36 4.5 11.9 4.54 4.52 9.87 6.54 11.9 4.5Z"/> <path d="M15.7 15.7c4.52-4.54 6.54-9.87 4.5-11.9-2.03-2.04-7.36-.02-11.9 4.5-4.52 4.54-6.54 9.87-4.5 11.9 2.03 2.04 7.36.02 11.9-4.5Z"/> </svg>',factory:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 20a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2V8l-7 5V8l-7 5V4a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2Z"/> <path d="M17 18h1"/> <path d="M12 18h1"/> <path d="M7 18h1"/> </svg>',"life-buoy":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m4.93 4.93 4.24 4.24"/> <path d="m14.83 9.17 4.24-4.24"/> <path d="m14.83 14.83 4.24 4.24"/> <path d="m9.17 14.83-4.24 4.24"/> <circle cx="12" cy="12" r="4"/> </svg>',flame:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8.5 14.5A2.5 2.5 0 0 0 11 12c0-1.38-.5-2-1-3-1.072-2.143-.224-4.054 2-6 .5 2.5 2 4.9 4 6.5 2 1.6 3 3.5 3 5.5a7 7 0 1 1-14 0c0-1.153.433-2.294 1-3a2.5 2.5 0 0 0 2.5 2.5z"/> </svg>',"flower-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 5a3 3 0 1 1 3 3m-3-3a3 3 0 1 0-3 3m3-3v1M9 8a3 3 0 1 0 3 3M9 8h1m5 0a3 3 0 1 1-3 3m3-3h-1m-2 3v-1"/> <circle cx="12" cy="8" r="2"/> <path d="M12 10v12"/> <path d="M12 22c4.2 0 7-1.667 7-5-4.2 0-7 1.667-7 5Z"/> <path d="M12 22c-4.2 0-7-1.667-7-5 4.2 0 7 1.667 7 5Z"/> </svg>',user:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 21v-2a4 4 0 0 0-4-4H9a4 4 0 0 0-4 4v2"/> <circle cx="12" cy="7" r="4"/> </svg>',infinity:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 12c-2-2.67-4-4-6-4a4 4 0 1 0 0 8c2 0 4-1.33 6-4Zm0 0c2 2.67 4 4 6 4a4 4 0 0 0 0-8c-2 0-4 1.33-6 4Z"/> </svg>',"clipboard-list":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1" ry="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V6a2 2 0 0 1 2-2h2"/> <path d="M12 11h4"/> <path d="M12 16h4"/> <path d="M8 11h.01"/> <path d="M8 16h.01"/> </svg>',"scan-barcode":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <path d="M8 7v10"/> <path d="M12 7v10"/> <path d="M17 7v10"/> </svg>',"align-vertical-justify-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="6" x="5" y="12" rx="2"/> <rect width="10" height="6" x="7" y="2" rx="2"/> <path d="M2 22h20"/> </svg>',"copy-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m12 15 2 2 4-4"/> <rect width="14" height="14" x="8" y="8" rx="2" ry="2"/> <path d="M4 16c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h10c1.1 0 2 .9 2 2"/> </svg>',"file-heart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v2"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M10.29 10.7a2.43 2.43 0 0 0-2.66-.52c-.29.12-.56.3-.78.53l-.35.34-.35-.34a2.43 2.43 0 0 0-2.65-.53c-.3.12-.56.3-.79.53-.95.94-1 2.53.2 3.74L6.5 18l3.6-3.55c1.2-1.21 1.14-2.8.19-3.74Z"/> </svg>',"shopping-basket":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 11-1 9"/> <path d="m19 11-4-7"/> <path d="M2 11h20"/> <path d="m3.5 11 1.6 7.4a2 2 0 0 0 2 1.6h9.8a2 2 0 0 0 2-1.6l1.7-7.4"/> <path d="M4.5 15.5h15"/> <path d="m5 11 4-7"/> <path d="m9 11 1 9"/> </svg>',"square-chevron-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m16 10-4 4-4-4"/> </svg>',fingerprint:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 10a2 2 0 0 0-2 2c0 1.02-.1 2.51-.26 4"/> <path d="M14 13.12c0 2.38 0 6.38-1 8.88"/> <path d="M17.29 21.02c.12-.6.43-2.3.5-3.02"/> <path d="M2 12a10 10 0 0 1 18-6"/> <path d="M2 16h.01"/> <path d="M21.8 16c.2-2 .131-5.354 0-6"/> <path d="M5 19.5C5.5 18 6 15 6 12a6 6 0 0 1 .34-2"/> <path d="M8.65 22c.21-.66.45-1.32.57-2"/> <path d="M9 6.8a6 6 0 0 1 9 5.2v2"/> </svg>',"arrow-down-0-1":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 16 4 4 4-4"/> <path d="M7 20V4"/> <rect x="15" y="4" width="4" height="6" ry="2"/> <path d="M17 20v-6h-2"/> <path d="M15 20h4"/> </svg>',flag:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 15s1-1 4-1 5 2 8 2 4-1 4-1V3s-1 1-4 1-5-2-8-2-4 1-4 1z"/> <line x1="4" x2="4" y1="22" y2="15"/> </svg>',"image-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" x2="22" y1="2" y2="22"/> <path d="M10.41 10.41a2 2 0 1 1-2.83-2.83"/> <line x1="13.5" x2="6" y1="13.5" y2="21"/> <line x1="18" x2="21" y1="12" y2="15"/> <path d="M3.59 3.59A1.99 1.99 0 0 0 3 5v14a2 2 0 0 0 2 2h14c.55 0 1.052-.22 1.41-.59"/> <path d="M21 15V5a2 2 0 0 0-2-2H9"/> </svg>',"folder-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.7 20H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H20a2 2 0 0 1 2 2v4.1"/> <path d="m21 21-1.9-1.9"/> <circle cx="17" cy="17" r="3"/> </svg>',"circle-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m15 9-6 6"/> <path d="m9 9 6 6"/> </svg>',rocket:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4.5 16.5c-1.5 1.26-2 5-2 5s3.74-.5 5-2c.71-.84.7-2.13-.09-2.91a2.18 2.18 0 0 0-2.91-.09z"/> <path d="m12 15-3-3a22 22 0 0 1 2-3.95A12.88 12.88 0 0 1 22 2c0 2.72-.78 7.5-6 11a22.35 22.35 0 0 1-4 2z"/> <path d="M9 12H4s.55-3.03 2-4c1.62-1.08 5 0 5 0"/> <path d="M12 15v5s3.03-.55 4-2c1.08-1.62 0-5 0-5"/> </svg>',fish:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6.5 12c.94-3.46 4.94-6 8.5-6 3.56 0 6.06 2.54 7 6-.94 3.47-3.44 6-7 6s-7.56-2.53-8.5-6Z"/> <path d="M18 12v.5"/> <path d="M16 17.93a9.77 9.77 0 0 1 0-11.86"/> <path d="M7 10.67C7 8 5.58 5.97 2.73 5.5c-1 1.5-1 5 .23 6.5-1.24 1.5-1.24 5-.23 6.5C5.58 18.03 7 16 7 13.33"/> <path d="M10.46 7.26C10.2 5.88 9.17 4.24 8 3h5.8a2 2 0 0 1 1.98 1.67l.23 1.4"/> <path d="m16.01 17.93-.23 1.4A2 2 0 0 1 13.8 21H9.5a5.96 5.96 0 0 0 1.49-3.98"/> </svg>',"book-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14.5 7-5 5"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="m9.5 7 5 5"/> </svg>',"test-tube-diagonal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 7 6.82 21.18a2.83 2.83 0 0 1-3.99-.01a2.83 2.83 0 0 1 0-4L17 3"/> <path d="m16 2 6 6"/> <path d="M12 16H4"/> </svg>',frown:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M16 16s-1.5-2-4-2-4 2-4 2"/> <line x1="9" x2="9.01" y1="9" y2="9"/> <line x1="15" x2="15.01" y1="9" y2="9"/> </svg>',"file-chart-column-increasing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M8 18v-2"/> <path d="M12 18v-4"/> <path d="M16 18v-6"/> </svg>',paperclip:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21.44 11.05-9.19 9.19a6 6 0 0 1-8.49-8.49l8.57-8.57A4 4 0 1 1 18 8.84l-8.59 8.57a2 2 0 0 1-2.83-2.83l8.49-8.48"/> </svg>',"git-branch":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="6" x2="6" y1="3" y2="15"/> <circle cx="18" cy="6" r="3"/> <circle cx="6" cy="18" r="3"/> <path d="M18 9a9 9 0 0 1-9 9"/> </svg>',axe:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m14 12-8.5 8.5a2.12 2.12 0 1 1-3-3L11 9"/> <path d="M15 13 9 7l4-4 6 6h3a8 8 0 0 1-7 7z"/> </svg>',"square-dashed-bottom":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 21a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2"/> <path d="M9 21h1"/> <path d="M14 21h1"/> </svg>',"sticky-note":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 3H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2V8Z"/> <path d="M15 3v4a2 2 0 0 0 2 2h4"/> </svg>',droplets:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 16.3c2.2 0 4-1.83 4-4.05 0-1.16-.57-2.26-1.71-3.19S7.29 6.75 7 5.3c-.29 1.45-1.14 2.84-2.29 3.76S3 11.1 3 12.25c0 2.22 1.8 4.05 4 4.05z"/> <path d="M12.56 6.6A10.97 10.97 0 0 0 14 3.02c.5 2.5 2 4.9 4 6.5s3 3.5 3 5.5a6.98 6.98 0 0 1-11.91 4.97"/> </svg>',ellipsis:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="1"/> <circle cx="19" cy="12" r="1"/> <circle cx="5" cy="12" r="1"/> </svg>',"server-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="3"/> <path d="M4.5 10H4a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2h-.5"/> <path d="M4.5 14H4a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-4a2 2 0 0 0-2-2h-.5"/> <path d="M6 6h.01"/> <path d="M6 18h.01"/> <path d="m15.7 13.4-.9-.3"/> <path d="m9.2 10.9-.9-.3"/> <path d="m10.6 15.7.3-.9"/> <path d="m13.6 15.7-.4-1"/> <path d="m10.8 9.3-.4-1"/> <path d="m8.3 13.6 1-.4"/> <path d="m14.7 10.8 1-.4"/> <path d="m13.4 8.3-.3.9"/> </svg>',"satellite-dish":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 10a7.31 7.31 0 0 0 10 10Z"/> <path d="m9 15 3-3"/> <path d="M17 13a6 6 0 0 0-6-6"/> <path d="M21 13A10 10 0 0 0 11 3"/> </svg>',"volume-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 9a5 5 0 0 1 .95 2.293"/> <path d="M19.364 5.636a9 9 0 0 1 1.889 9.96"/> <path d="m2 2 20 20"/> <path d="m7 7-.587.587A1.4 1.4 0 0 1 5.416 8H3a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2.416a1.4 1.4 0 0 1 .997.413l3.383 3.384A.705.705 0 0 0 11 19.298V11"/> <path d="M9.828 4.172A.686.686 0 0 1 11 4.657v.686"/> </svg>',vegan:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 2a26.6 26.6 0 0 1 10 20c.9-6.82 1.5-9.5 4-14"/> <path d="M16 8c4 0 6-2 6-6-4 0-6 2-6 6"/> <path d="M17.41 3.6a10 10 0 1 0 3 3"/> </svg>',image:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <circle cx="9" cy="9" r="2"/> <path d="m21 15-3.086-3.086a2 2 0 0 0-2.828 0L6 21"/> </svg>',"calendar-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 2v4"/> <path d="M21 11.75V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h7.25"/> <path d="m22 22-1.875-1.875"/> <path d="M3 10h18"/> <path d="M8 2v4"/> <circle cx="18" cy="18" r="3"/> </svg>',"camera-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" x2="22" y1="2" y2="22"/> <path d="M7 7H4a2 2 0 0 0-2 2v9a2 2 0 0 0 2 2h16"/> <path d="M9.5 4h5L17 7h3a2 2 0 0 1 2 2v7.5"/> <path d="M14.121 15.121A3 3 0 1 1 9.88 10.88"/> </svg>',"file-minus-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M3 15h6"/> </svg>',"monitor-dot":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="19" cy="6" r="3"/> <path d="M22 12v3a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h9"/> <path d="M12 17v4"/> <path d="M8 21h8"/> </svg>',"clipboard-pen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="8" height="4" x="8" y="2" rx="1"/> <path d="M16 4h2a2 2 0 0 1 2 2v14a2 2 0 0 1-2 2h-5.5"/> <path d="M4 13.5V6a2 2 0 0 1 2-2h2"/> <path d="M13.378 15.626a1 1 0 1 0-3.004-3.004l-5.01 5.012a2 2 0 0 0-.506.854l-.837 2.87a.5.5 0 0 0 .62.62l2.87-.837a2 2 0 0 0 .854-.506z"/> </svg>',wheat:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 22 16 8"/> <path d="M3.47 12.53 5 11l1.53 1.53a3.5 3.5 0 0 1 0 4.94L5 19l-1.53-1.53a3.5 3.5 0 0 1 0-4.94Z"/> <path d="M7.47 8.53 9 7l1.53 1.53a3.5 3.5 0 0 1 0 4.94L9 15l-1.53-1.53a3.5 3.5 0 0 1 0-4.94Z"/> <path d="M11.47 4.53 13 3l1.53 1.53a3.5 3.5 0 0 1 0 4.94L13 11l-1.53-1.53a3.5 3.5 0 0 1 0-4.94Z"/> <path d="M20 2h2v2a4 4 0 0 1-4 4h-2V6a4 4 0 0 1 4-4Z"/> <path d="M11.47 17.47 13 19l-1.53 1.53a3.5 3.5 0 0 1-4.94 0L5 19l1.53-1.53a3.5 3.5 0 0 1 4.94 0Z"/> <path d="M15.47 13.47 17 15l-1.53 1.53a3.5 3.5 0 0 1-4.94 0L9 15l1.53-1.53a3.5 3.5 0 0 1 4.94 0Z"/> <path d="M19.47 9.47 21 11l-1.53 1.53a3.5 3.5 0 0 1-4.94 0L13 11l1.53-1.53a3.5 3.5 0 0 1 4.94 0Z"/> </svg>',snowflake:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="2" x2="22" y1="12" y2="12"/> <line x1="12" x2="12" y1="2" y2="22"/> <path d="m20 16-4-4 4-4"/> <path d="m4 8 4 4-4 4"/> <path d="m16 4-4 4-4-4"/> <path d="m8 20 4-4 4 4"/> </svg>',"search-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m13 13.5 2-2.5-2-2.5"/> <path d="m21 21-4.3-4.3"/> <path d="M9 8.5 7 11l2 2.5"/> <circle cx="11" cy="11" r="8"/> </svg>',"clock-10":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 8 10"/> </svg>',"laptop-minimal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="12" x="3" y="4" rx="2" ry="2"/> <line x1="2" x2="22" y1="20" y2="20"/> </svg>',"align-horizontal-justify-start":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="6" height="14" x="6" y="5" rx="2"/> <rect width="6" height="10" x="16" y="7" rx="2"/> <path d="M2 2v20"/> </svg>',"folder-root":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 20h16a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.93a2 2 0 0 1-1.66-.9l-.82-1.2A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13c0 1.1.9 2 2 2Z"/> <circle cx="12" cy="13" r="2"/> <path d="M12 15v5"/> </svg>',"circle-percent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m15 9-6 6"/> <path d="M9 9h.01"/> <path d="M15 15h.01"/> </svg>',"circle-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M8 12h8"/> <path d="M12 8v8"/> </svg>',"baggage-claim":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 18H6a2 2 0 0 1-2-2V7a2 2 0 0 0-2-2"/> <path d="M17 14V4a2 2 0 0 0-2-2h-1a2 2 0 0 0-2 2v10"/> <rect width="13" height="8" x="8" y="6" rx="1"/> <circle cx="18" cy="20" r="2"/> <circle cx="9" cy="20" r="2"/> </svg>',folders:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 17a2 2 0 0 0 2-2V9a2 2 0 0 0-2-2h-3.9a2 2 0 0 1-1.69-.9l-.81-1.2a2 2 0 0 0-1.67-.9H8a2 2 0 0 0-2 2v9a2 2 0 0 0 2 2Z"/> <path d="M2 8v11a2 2 0 0 0 2 2h14"/> </svg>',"circuit-board":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M11 9h4a2 2 0 0 0 2-2V3"/> <circle cx="9" cy="9" r="2"/> <path d="M7 21v-4a2 2 0 0 1 2-2h4"/> <circle cx="15" cy="15" r="2"/> </svg>',shirt:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20.38 3.46 16 2a4 4 0 0 1-8 0L3.62 3.46a2 2 0 0 0-1.34 2.23l.58 3.47a1 1 0 0 0 .99.84H6v10c0 1.1.9 2 2 2h8a2 2 0 0 0 2-2V10h2.15a1 1 0 0 0 .99-.84l.58-3.47a2 2 0 0 0-1.34-2.23z"/> </svg>',shrub:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22v-7l-2-2"/> <path d="M17 8v.8A6 6 0 0 1 13.8 20H10A6.5 6.5 0 0 1 7 8a5 5 0 0 1 10 0Z"/> <path d="m14 14-2 2"/> </svg>',"layout-template":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="7" x="3" y="3" rx="1"/> <rect width="9" height="7" x="3" y="14" rx="1"/> <rect width="5" height="7" x="16" y="14" rx="1"/> </svg>',"heart-handshake":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 14c1.49-1.46 3-3.21 3-5.5A5.5 5.5 0 0 0 16.5 3c-1.76 0-3 .5-4.5 2-1.5-1.5-2.74-2-4.5-2A5.5 5.5 0 0 0 2 8.5c0 2.3 1.5 4.05 3 5.5l7 7Z"/> <path d="M12 5 9.04 7.96a2.17 2.17 0 0 0 0 3.08c.82.82 2.13.85 3 .07l2.07-1.9a2.82 2.82 0 0 1 3.79 0l2.96 2.66"/> <path d="m18 15-2-2"/> <path d="m15 18-2-2"/> </svg>',"maximize-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="15 3 21 3 21 9"/> <polyline points="9 21 3 21 3 15"/> <line x1="21" x2="14" y1="3" y2="10"/> <line x1="3" x2="10" y1="21" y2="14"/> </svg>',sparkle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9.937 15.5A2 2 0 0 0 8.5 14.063l-6.135-1.582a.5.5 0 0 1 0-.962L8.5 9.936A2 2 0 0 0 9.937 8.5l1.582-6.135a.5.5 0 0 1 .963 0L14.063 8.5A2 2 0 0 0 15.5 9.937l6.135 1.581a.5.5 0 0 1 0 .964L15.5 14.063a2 2 0 0 0-1.437 1.437l-1.582 6.135a.5.5 0 0 1-.963 0z"/> </svg>',"cake-slice":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="9" cy="7" r="2"/> <path d="M7.2 7.9 3 11v9c0 .6.4 1 1 1h16c.6 0 1-.4 1-1v-9c0-2-3-6-7-8l-3.6 2.6"/> <path d="M16 13H3"/> <path d="M16 17H3"/> </svg>',"scan-line":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <path d="M7 12h10"/> </svg>',"align-vertical-justify-start":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="14" height="6" x="5" y="16" rx="2"/> <rect width="10" height="6" x="7" y="6" rx="2"/> <path d="M2 2h20"/> </svg>',"traffic-cone":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9.3 6.2a4.55 4.55 0 0 0 5.4 0"/> <path d="M7.9 10.7c.9.8 2.4 1.3 4.1 1.3s3.2-.5 4.1-1.3"/> <path d="M13.9 3.5a1.93 1.93 0 0 0-3.8-.1l-3 10c-.1.2-.1.4-.1.6 0 1.7 2.2 3 5 3s5-1.3 5-3c0-.2 0-.4-.1-.5Z"/> <path d="m7.5 12.2-4.7 2.7c-.5.3-.8.7-.8 1.1s.3.8.8 1.1l7.6 4.5c.9.5 2.1.5 3 0l7.6-4.5c.7-.3 1-.7 1-1.1s-.3-.8-.8-1.1l-4.7-2.8"/> </svg>',"video-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.66 6H14a2 2 0 0 1 2 2v2.5l5.248-3.062A.5.5 0 0 1 22 7.87v8.196"/> <path d="M16 16a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2h2"/> <path d="m2 2 20 20"/> </svg>',scale:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16 16 3-8 3 8c-.87.65-1.92 1-3 1s-2.13-.35-3-1Z"/> <path d="m2 16 3-8 3 8c-.87.65-1.92 1-3 1s-2.13-.35-3-1Z"/> <path d="M7 21h10"/> <path d="M12 3v18"/> <path d="M3 7h2c2 0 5-1 7-2 2 1 5 2 7 2h2"/> </svg>',diamond:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.7 10.3a2.41 2.41 0 0 0 0 3.41l7.59 7.59a2.41 2.41 0 0 0 3.41 0l7.59-7.59a2.41 2.41 0 0 0 0-3.41l-7.59-7.59a2.41 2.41 0 0 0-3.41 0Z"/> </svg>',scan:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> </svg>',"circle-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="m16 12-4-4-4 4"/> <path d="M12 16V8"/> </svg>',"message-square-heart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="M14.8 7.5a1.84 1.84 0 0 0-2.6 0l-.2.3-.3-.3a1.84 1.84 0 1 0-2.4 2.8L12 13l2.7-2.7c.9-.9.8-2.1.1-2.8"/> </svg>',radius:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20.34 17.52a10 10 0 1 0-2.82 2.82"/> <circle cx="19" cy="19" r="2"/> <path d="m13.41 13.41 4.18 4.18"/> <circle cx="12" cy="12" r="2"/> </svg>',"navigation-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8.43 8.43 3 11l8 2 2 8 2.57-5.43"/> <path d="M17.39 11.73 22 2l-9.73 4.61"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"square-stack":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 10c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h4c1.1 0 2 .9 2 2"/> <path d="M10 16c-1.1 0-2-.9-2-2v-4c0-1.1.9-2 2-2h4c1.1 0 2 .9 2 2"/> <rect width="8" height="8" x="14" y="14" rx="2"/> </svg>',"bug-play":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.765 21.522a.5.5 0 0 1-.765-.424v-8.196a.5.5 0 0 1 .765-.424l5.878 3.674a1 1 0 0 1 0 1.696z"/> <path d="M14.12 3.88 16 2"/> <path d="M18 11a4 4 0 0 0-4-4h-4a4 4 0 0 0-4 4v3a6.1 6.1 0 0 0 2 4.5"/> <path d="M20.97 5c0 2.1-1.6 3.8-3.5 4"/> <path d="M3 21c0-2.1 1.7-3.9 3.8-4"/> <path d="M6 13H2"/> <path d="M6.53 9C4.6 8.8 3 7.1 3 5"/> <path d="m8 2 1.88 1.88"/> <path d="M9 7.13v-1a3.003 3.003 0 1 1 6 0v1"/> </svg>',"square-arrow-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M12 8v8"/> <path d="m8 12 4 4 4-4"/> </svg>',"calendar-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 19h6"/> <path d="M16 2v4"/> <path d="M21 15V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h8.5"/> <path d="M3 10h18"/> <path d="M8 2v4"/> </svg>',"hand-heart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 14h2a2 2 0 1 0 0-4h-3c-.6 0-1.1.2-1.4.6L3 16"/> <path d="m7 20 1.6-1.4c.3-.4.8-.6 1.4-.6h4c1.1 0 2.1-.4 2.8-1.2l4.6-4.4a2 2 0 0 0-2.75-2.91l-4.2 3.9"/> <path d="m2 15 6 6"/> <path d="M19.5 8.5c.7-.7 1.5-1.6 1.5-2.7A2.73 2.73 0 0 0 16 4a2.78 2.78 0 0 0-5 1.8c0 1.2.8 2 1.5 2.8L16 12Z"/> </svg>',"chevrons-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 17 5-5-5-5"/> <path d="m13 17 5-5-5-5"/> </svg>',"route-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="6" cy="19" r="3"/> <path d="M9 19h8.5c.4 0 .9-.1 1.3-.2"/> <path d="M5.2 5.2A3.5 3.53 0 0 0 6.5 12H12"/> <path d="m2 2 20 20"/> <path d="M21 15.3a3.5 3.5 0 0 0-3.3-3.3"/> <path d="M15 5h-4.3"/> <circle cx="18" cy="5" r="3"/> </svg>',"shopping-cart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="8" cy="21" r="1"/> <circle cx="19" cy="21" r="1"/> <path d="M2.05 2.05h2l2.66 12.42a2 2 0 0 0 2 1.58h9.78a2 2 0 0 0 1.95-1.57l1.65-7.43H5.12"/> </svg>',"ship-wheel":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="8"/> <path d="M12 2v7.5"/> <path d="m19 5-5.23 5.23"/> <path d="M22 12h-7.5"/> <path d="m19 19-5.23-5.23"/> <path d="M12 14.5V22"/> <path d="M10.23 13.77 5 19"/> <path d="M9.5 12H2"/> <path d="M10.23 10.23 5 5"/> <circle cx="12" cy="12" r="2.5"/> </svg>',"spell-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 16 6-12 6 12"/> <path d="M8 12h8"/> <path d="m16 20 2 2 4-4"/> </svg>',"columns-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M12 3v18"/> </svg>',"paint-roller":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="16" height="6" x="2" y="2" rx="2"/> <path d="M10 16v-2a2 2 0 0 1 2-2h8a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2h-2"/> <rect width="4" height="6" x="8" y="16" rx="1"/> </svg>',"house-plug":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 12V8.964"/> <path d="M14 12V8.964"/> <path d="M15 12a1 1 0 0 1 1 1v2a2 2 0 0 1-2 2h-4a2 2 0 0 1-2-2v-2a1 1 0 0 1 1-1z"/> <path d="M8.5 21H5a2 2 0 0 1-2-2v-9a2 2 0 0 1 .709-1.528l7-5.999a2 2 0 0 1 2.582 0l7 5.999A2 2 0 0 1 21 10v9a2 2 0 0 1-2 2h-5a2 2 0 0 1-2-2v-2"/> </svg>',"square-dashed-kanban":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 7v7"/> <path d="M12 7v4"/> <path d="M16 7v9"/> <path d="M5 3a2 2 0 0 0-2 2"/> <path d="M9 3h1"/> <path d="M14 3h1"/> <path d="M19 3a2 2 0 0 1 2 2"/> <path d="M21 9v1"/> <path d="M21 14v1"/> <path d="M21 19a2 2 0 0 1-2 2"/> <path d="M14 21h1"/> <path d="M9 21h1"/> <path d="M5 21a2 2 0 0 1-2-2"/> <path d="M3 14v1"/> <path d="M3 9v1"/> </svg>',clock:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 16 14"/> </svg>',"folder-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 14 1.5-2.9A2 2 0 0 1 9.24 10H20a2 2 0 0 1 1.94 2.5l-1.54 6a2 2 0 0 1-1.95 1.5H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h3.9a2 2 0 0 1 1.69.9l.81 1.2a2 2 0 0 0 1.67.9H18a2 2 0 0 1 2 2v2"/> </svg>',origami:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 12V4a1 1 0 0 1 1-1h6.297a1 1 0 0 1 .651 1.759l-4.696 4.025"/> <path d="m12 21-7.414-7.414A2 2 0 0 1 4 12.172V6.415a1.002 1.002 0 0 1 1.707-.707L20 20.009"/> <path d="m12.214 3.381 8.414 14.966a1 1 0 0 1-.167 1.199l-1.168 1.163a1 1 0 0 1-.706.291H6.351a1 1 0 0 1-.625-.219L3.25 18.8a1 1 0 0 1 .631-1.781l4.165.027"/> </svg>',"package-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 10V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l2-1.14"/> <path d="m7.5 4.27 9 5.15"/> <polyline points="3.29 7 12 12 20.71 7"/> <line x1="12" x2="12" y1="22" y2="12"/> <path d="m17 13 5 5m-5 0 5-5"/> </svg>',"music-4":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 18V5l12-2v13"/> <path d="m9 9 12-2"/> <circle cx="6" cy="18" r="3"/> <circle cx="18" cy="16" r="3"/> </svg>',flashlight:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 6c0 2-2 2-2 4v10a2 2 0 0 1-2 2h-4a2 2 0 0 1-2-2V10c0-2-2-2-2-4V2h12z"/> <line x1="6" x2="18" y1="6" y2="6"/> <line x1="12" x2="12" y1="12" y2="12"/> </svg>',diameter:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="19" cy="19" r="2"/> <circle cx="5" cy="5" r="2"/> <path d="M6.48 3.66a10 10 0 0 1 13.86 13.86"/> <path d="m6.41 6.41 11.18 11.18"/> <path d="M3.66 6.48a10 10 0 0 0 13.86 13.86"/> </svg>',"rectangle-vertical":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="12" height="20" x="6" y="2" rx="2"/> </svg>',"radio-receiver":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 16v2"/> <path d="M19 16v2"/> <rect width="20" height="8" x="2" y="8" rx="2"/> <path d="M18 12h.01"/> </svg>',sofa:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 9V6a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v3"/> <path d="M2 16a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-5a2 2 0 0 0-4 0v1.5a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5V11a2 2 0 0 0-4 0z"/> <path d="M4 18v2"/> <path d="M20 18v2"/> <path d="M12 4v9"/> </svg>',"clock-7":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 9.5 16"/> </svg>',"air-vent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6 12H4a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2h-2"/> <path d="M6 8h12"/> <path d="M18.3 17.7a2.5 2.5 0 0 1-3.16 3.83 2.53 2.53 0 0 1-1.14-2V12"/> <path d="M6.6 15.6A2 2 0 1 0 10 17v-5"/> </svg>',"screen-share-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M13 3H4a2 2 0 0 0-2 2v10a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-3"/> <path d="M8 21h8"/> <path d="M12 17v4"/> <path d="m22 3-5 5"/> <path d="m17 3 5 5"/> </svg>',"lightbulb-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16.8 11.2c.8-.9 1.2-2 1.2-3.2a6 6 0 0 0-9.3-5"/> <path d="m2 2 20 20"/> <path d="M6.3 6.3a4.67 4.67 0 0 0 1.2 5.2c.7.7 1.3 1.5 1.5 2.5"/> <path d="M9 18h6"/> <path d="M10 22h4"/> </svg>',"bookmark-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m19 21-7-4-7 4V5a2 2 0 0 1 2-2h10a2 2 0 0 1 2 2v16z"/> <line x1="15" x2="9" y1="10" y2="10"/> </svg>',"disc-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <circle cx="12" cy="12" r="4"/> <path d="M12 12h.01"/> </svg>',"corner-down-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="9 10 4 15 9 20"/> <path d="M20 4v7a4 4 0 0 1-4 4H4"/> </svg>',"square-arrow-up-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M8 8h8v8"/> <path d="m8 16 8-8"/> </svg>',"square-bottom-dashed-scissors":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h16a2 2 0 0 1 2 2v16a2 2 0 0 1-2 2"/> <path d="M10 22H8"/> <path d="M16 22h-2"/> <circle cx="8" cy="8" r="2"/> <path d="M9.414 9.414 12 12"/> <path d="M14.8 14.8 18 18"/> <circle cx="8" cy="16" r="2"/> <path d="m18 6-8.586 8.586"/> </svg>',circle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> </svg>',webcam:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="10" r="8"/> <circle cx="12" cy="10" r="3"/> <path d="M7 22h10"/> <path d="M12 22v-4"/> </svg>',"file-lock-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v1"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <rect width="8" height="5" x="2" y="13" rx="1"/> <path d="M8 13v-2a2 2 0 1 0-4 0v2"/> </svg>',"git-merge":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="18" cy="18" r="3"/> <circle cx="6" cy="6" r="3"/> <path d="M6 21V9a9 9 0 0 0 9 9"/> </svg>',footprints:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 16v-2.38C4 11.5 2.97 10.5 3 8c.03-2.72 1.49-6 4.5-6C9.37 2 10 3.8 10 5.5c0 3.11-2 5.66-2 8.68V16a2 2 0 1 1-4 0Z"/> <path d="M20 20v-2.38c0-2.12 1.03-3.12 1-5.62-.03-2.72-1.49-6-4.5-6C14.63 6 14 7.8 14 9.5c0 3.11 2 5.66 2 8.68V20a2 2 0 1 0 4 0Z"/> <path d="M16 17h4"/> <path d="M4 13h4"/> </svg>',replace:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14 4a2 2 0 0 1 2-2"/> <path d="M16 10a2 2 0 0 1-2-2"/> <path d="M20 2a2 2 0 0 1 2 2"/> <path d="M22 8a2 2 0 0 1-2 2"/> <path d="m3 7 3 3 3-3"/> <path d="M6 10V5a3 3 0 0 1 3-3h1"/> <rect x="2" y="14" width="8" height="8" rx="2"/> </svg>',"milk-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2h8"/> <path d="M9 2v1.343M15 2v2.789a4 4 0 0 0 .672 2.219l.656.984a4 4 0 0 1 .672 2.22v1.131M7.8 7.8l-.128.192A4 4 0 0 0 7 10.212V20a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2v-3"/> <path d="M7 15a6.47 6.47 0 0 1 5 0 6.472 6.472 0 0 0 3.435.435"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"arrow-up-z-a":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 8 4-4 4 4"/> <path d="M7 4v16"/> <path d="M15 4h5l-5 6h5"/> <path d="M15 20v-3.5a2.5 2.5 0 0 1 5 0V20"/> <path d="M20 18h-5"/> </svg>',"arrow-up-wide-narrow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 8 4-4 4 4"/> <path d="M7 4v16"/> <path d="M11 12h10"/> <path d="M11 16h7"/> <path d="M11 20h4"/> </svg>',slash:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 2 2 22"/> </svg>',"touchpad-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 4a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h16"/> <path d="M2 14h12"/> <path d="M22 14h-2"/> <path d="M12 20v-6"/> <path d="m2 2 20 20"/> <path d="M22 16V6a2 2 0 0 0-2-2H10"/> </svg>',framer:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 16V9h14V2H5l14 14h-7m-7 0 7 7v-7m-7 0h7"/> </svg>',"book-headphones":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M8 12v-2a4 4 0 0 1 8 0v2"/> <circle cx="15" cy="12" r="1"/> <circle cx="9" cy="12" r="1"/> </svg>',command:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 6v12a3 3 0 1 0 3-3H6a3 3 0 1 0 3 3V6a3 3 0 1 0-3 3h12a3 3 0 1 0-3-3"/> </svg>',"message-square-code":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 7.5 8 10l2 2.5"/> <path d="m14 7.5 2 2.5-2 2.5"/> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> </svg>',"square-user-round":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 21a6 6 0 0 0-12 0"/> <circle cx="12" cy="11" r="4"/> <rect width="18" height="18" x="3" y="3" rx="2"/> </svg>',mountain:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m8 3 4 8 5-5 5 15H2L8 3z"/> </svg>',"file-code-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="m5 12-3 3 3 3"/> <path d="m9 18 3-3-3-3"/> </svg>',"package-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 22v-9"/> <path d="M15.17 2.21a1.67 1.67 0 0 1 1.63 0L21 4.57a1.93 1.93 0 0 1 0 3.36L8.82 14.79a1.655 1.655 0 0 1-1.64 0L3 12.43a1.93 1.93 0 0 1 0-3.36z"/> <path d="M20 13v3.87a2.06 2.06 0 0 1-1.11 1.83l-6 3.08a1.93 1.93 0 0 1-1.78 0l-6-3.08A2.06 2.06 0 0 1 4 16.87V13"/> <path d="M21 12.43a1.93 1.93 0 0 0 0-3.36L8.83 2.2a1.64 1.64 0 0 0-1.63 0L3 4.57a1.93 1.93 0 0 0 0 3.36l12.18 6.86a1.636 1.636 0 0 0 1.63 0z"/> </svg>',"badge-japanese-yen":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <path d="m9 8 3 3v7"/> <path d="m12 11 3-3"/> <path d="M9 12h6"/> <path d="M9 16h6"/> </svg>',"calendar-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4.2 4.2A2 2 0 0 0 3 6v14a2 2 0 0 0 2 2h14a2 2 0 0 0 1.82-1.18"/> <path d="M21 15.5V6a2 2 0 0 0-2-2H9.5"/> <path d="M16 2v4"/> <path d="M3 10h7"/> <path d="M21 10h-5.5"/> <path d="m2 2 20 20"/> </svg>',"arrow-up-narrow-wide":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 8 4-4 4 4"/> <path d="M7 4v16"/> <path d="M11 12h4"/> <path d="M11 16h7"/> <path d="M11 20h10"/> </svg>',"file-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M12 12v6"/> <path d="m15 15-3-3-3 3"/> </svg>',"chevrons-up-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m7 15 5 5 5-5"/> <path d="m7 9 5-5 5 5"/> </svg>',"map-pin-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.75 7.09a3 3 0 0 1 2.16 2.16"/> <path d="M17.072 17.072c-1.634 2.17-3.527 3.912-4.471 4.727a1 1 0 0 1-1.202 0C9.539 20.193 4 14.993 4 10a8 8 0 0 1 1.432-4.568"/> <path d="m2 2 20 20"/> <path d="M8.475 2.818A8 8 0 0 1 20 10c0 1.183-.31 2.377-.81 3.533"/> <path d="M9.13 9.13a3 3 0 0 0 3.74 3.74"/> </svg>',"utility-pole":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v20"/> <path d="M2 5h20"/> <path d="M3 3v2"/> <path d="M7 3v2"/> <path d="M17 3v2"/> <path d="M21 3v2"/> <path d="m19 5-7 7-7-7"/> </svg>',"scroll-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 12h-5"/> <path d="M15 8h-5"/> <path d="M19 17V5a2 2 0 0 0-2-2H4"/> <path d="M8 21h12a2 2 0 0 0 2-2v-1a1 1 0 0 0-1-1H11a1 1 0 0 0-1 1v1a2 2 0 1 1-4 0V5a2 2 0 1 0-4 0v2a1 1 0 0 0 1 1h3"/> </svg>',projector:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M5 7 3 5"/> <path d="M9 6V3"/> <path d="m13 7 2-2"/> <circle cx="9" cy="13" r="3"/> <path d="M11.83 12H20a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2v-4a2 2 0 0 1 2-2h2.17"/> <path d="M16 16h2"/> </svg>',"cloud-sun":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v2"/> <path d="m4.93 4.93 1.41 1.41"/> <path d="M20 12h2"/> <path d="m19.07 4.93-1.41 1.41"/> <path d="M15.947 12.65a4 4 0 0 0-5.925-4.128"/> <path d="M13 22H7a5 5 0 1 1 4.9-6H13a3 3 0 0 1 0 6Z"/> </svg>',"square-arrow-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="m16 12-4-4-4 4"/> <path d="M12 16V8"/> </svg>',group:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5c0-1.1.9-2 2-2h2"/> <path d="M17 3h2c1.1 0 2 .9 2 2v2"/> <path d="M21 17v2c0 1.1-.9 2-2 2h-2"/> <path d="M7 21H5c-1.1 0-2-.9-2-2v-2"/> <rect width="7" height="5" x="7" y="7" rx="1"/> <rect width="7" height="5" x="10" y="12" rx="1"/> </svg>',"chart-bar-decreasing":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <path d="M7 11h8"/> <path d="M7 16h3"/> <path d="M7 6h12"/> </svg>',hash:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="4" x2="20" y1="9" y2="9"/> <line x1="4" x2="20" y1="15" y2="15"/> <line x1="10" x2="8" y1="3" y2="21"/> <line x1="16" x2="14" y1="3" y2="21"/> </svg>',"circle-dashed":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.1 2.182a10 10 0 0 1 3.8 0"/> <path d="M13.9 21.818a10 10 0 0 1-3.8 0"/> <path d="M17.609 3.721a10 10 0 0 1 2.69 2.7"/> <path d="M2.182 13.9a10 10 0 0 1 0-3.8"/> <path d="M20.279 17.609a10 10 0 0 1-2.7 2.69"/> <path d="M21.818 10.1a10 10 0 0 1 0 3.8"/> <path d="M3.721 6.391a10 10 0 0 1 2.7-2.69"/> <path d="M6.391 20.279a10 10 0 0 1-2.69-2.7"/> </svg>',gitlab:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m22 13.29-3.33-10a.42.42 0 0 0-.14-.18.38.38 0 0 0-.22-.11.39.39 0 0 0-.23.07.42.42 0 0 0-.14.18l-2.26 6.67H8.32L6.1 3.26a.42.42 0 0 0-.1-.18.38.38 0 0 0-.26-.08.39.39 0 0 0-.23.07.42.42 0 0 0-.14.18L2 13.29a.74.74 0 0 0 .27.83L12 21l9.69-6.88a.71.71 0 0 0 .31-.83Z"/> </svg>',"message-square-quote":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="M8 12a2 2 0 0 0 2-2V8H8"/> <path d="M14 12a2 2 0 0 0 2-2V8h-2"/> </svg>',"book-open-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 21V7"/> <path d="m16 12 2 2 4-4"/> <path d="M22 6V4a1 1 0 0 0-1-1h-5a4 4 0 0 0-4 4 4 4 0 0 0-4-4H3a1 1 0 0 0-1 1v13a1 1 0 0 0 1 1h6a3 3 0 0 1 3 3 3 3 0 0 1 3-3h6a1 1 0 0 0 1-1v-1.3"/> </svg>',"circle-stop":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <rect width="6" height="6" x="9" y="9"/> </svg>',"hard-hat":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 18a1 1 0 0 0 1 1h18a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1H3a1 1 0 0 0-1 1v2z"/> <path d="M10 10V5a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v5"/> <path d="M4 15v-3a6 6 0 0 1 6-6"/> <path d="M14 6a6 6 0 0 1 6 6v3"/> </svg>',files:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 7h-3a2 2 0 0 1-2-2V2"/> <path d="M9 18a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h7l4 4v10a2 2 0 0 1-2 2Z"/> <path d="M3 7.6v12.8A1.6 1.6 0 0 0 4.6 22h9.8"/> </svg>',"alarm-clock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="13" r="8"/> <path d="M12 9v4l2 2"/> <path d="M5 3 2 6"/> <path d="m22 6-3-3"/> <path d="M6.38 18.7 4 21"/> <path d="M17.64 18.67 20 21"/> </svg>',"file-input":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v4"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M2 15h10"/> <path d="m9 18 3-3-3-3"/> </svg>',sticker:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15.5 3H5a2 2 0 0 0-2 2v14c0 1.1.9 2 2 2h14a2 2 0 0 0 2-2V8.5L15.5 3Z"/> <path d="M14 3v4a2 2 0 0 0 2 2h4"/> <path d="M8 13h.01"/> <path d="M16 13h.01"/> <path d="M10 16s.8 1 2 1c1.3 0 2-1 2-1"/> </svg>',bitcoin:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11.767 19.089c4.924.868 6.14-6.025 1.216-6.894m-1.216 6.894L5.86 18.047m5.908 1.042-.347 1.97m1.563-8.864c4.924.869 6.14-6.025 1.215-6.893m-1.215 6.893-3.94-.694m5.155-6.2L8.29 4.26m5.908 1.042.348-1.97M7.48 20.364l3.126-17.727"/> </svg>',dices:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="12" height="12" x="2" y="10" rx="2" ry="2"/> <path d="m17.92 14 3.5-3.5a2.24 2.24 0 0 0 0-3l-5-4.92a2.24 2.24 0 0 0-3 0L10 6"/> <path d="M6 18h.01"/> <path d="M10 14h.01"/> <path d="M15 6h.01"/> <path d="M18 9h.01"/> </svg>',"alarm-clock-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="13" r="8"/> <path d="M5 3 2 6"/> <path d="m22 6-3-3"/> <path d="M6.38 18.7 4 21"/> <path d="M17.64 18.67 20 21"/> <path d="m9 13 2 2 4-4"/> </svg>',"id-card":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 10h2"/> <path d="M16 14h2"/> <path d="M6.17 15a3 3 0 0 1 5.66 0"/> <circle cx="9" cy="11" r="2"/> <rect x="2" y="5" width="20" height="14" rx="2"/> </svg>',currency:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="8"/> <line x1="3" x2="6" y1="3" y2="6"/> <line x1="21" x2="18" y1="3" y2="6"/> <line x1="3" x2="6" y1="21" y2="18"/> <line x1="21" x2="18" y1="21" y2="18"/> </svg>',shapes:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8.3 10a.7.7 0 0 1-.626-1.079L11.4 3a.7.7 0 0 1 1.198-.043L16.3 8.9a.7.7 0 0 1-.572 1.1Z"/> <rect x="3" y="14" width="7" height="7" rx="1"/> <circle cx="17.5" cy="17.5" r="3.5"/> </svg>',handshake:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m11 17 2 2a1 1 0 1 0 3-3"/> <path d="m14 14 2.5 2.5a1 1 0 1 0 3-3l-3.88-3.88a3 3 0 0 0-4.24 0l-.88.88a1 1 0 1 1-3-3l2.81-2.81a5.79 5.79 0 0 1 7.06-.87l.47.28a2 2 0 0 0 1.42.25L21 4"/> <path d="m21 3 1 11h-2"/> <path d="M3 3 2 14l6.5 6.5a1 1 0 1 0 3-3"/> <path d="M3 4h8"/> </svg>',"panels-right-bottom":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M3 15h12"/> <path d="M15 3v18"/> </svg>',"chart-column-big":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 3v16a2 2 0 0 0 2 2h16"/> <rect x="15" y="5" width="4" height="12" rx="1"/> <rect x="7" y="8" width="4" height="9" rx="1"/> </svg>',"circle-user-round":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 20a6 6 0 0 0-12 0"/> <circle cx="12" cy="10" r="4"/> <circle cx="12" cy="12" r="10"/> </svg>',house:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 21v-8a1 1 0 0 0-1-1h-4a1 1 0 0 0-1 1v8"/> <path d="M3 10a2 2 0 0 1 .709-1.528l7-5.999a2 2 0 0 1 2.582 0l7 5.999A2 2 0 0 1 21 10v9a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2z"/> </svg>',cone:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m20.9 18.55-8-15.98a1 1 0 0 0-1.8 0l-8 15.98"/> <ellipse cx="12" cy="19" rx="9" ry="3"/> </svg>',frame:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="22" x2="2" y1="6" y2="6"/> <line x1="22" x2="2" y1="18" y2="18"/> <line x1="6" x2="6" y1="2" y2="22"/> <line x1="18" x2="18" y1="2" y2="22"/> </svg>',haze:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m5.2 6.2 1.4 1.4"/> <path d="M2 13h2"/> <path d="M20 13h2"/> <path d="m17.4 7.6 1.4-1.4"/> <path d="M22 17H2"/> <path d="M22 21H2"/> <path d="M16 13a4 4 0 0 0-8 0"/> <path d="M12 5V2.5"/> </svg>',"heading-3":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 12h8"/> <path d="M4 18V6"/> <path d="M12 18V6"/> <path d="M17.5 10.5c1.7-1 3.5 0 3.5 1.5a2 2 0 0 1-2 2"/> <path d="M17 17.5c2 1.5 4 .3 4-1.5a2 2 0 0 0-2-2"/> </svg>',"file-archive":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 12v-1"/> <path d="M10 18v-2"/> <path d="M10 7V6"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M15.5 22H18a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v16a2 2 0 0 0 .274 1.01"/> <circle cx="10" cy="20" r="2"/> </svg>',"sliders-horizontal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="21" x2="14" y1="4" y2="4"/> <line x1="10" x2="3" y1="4" y2="4"/> <line x1="21" x2="12" y1="12" y2="12"/> <line x1="8" x2="3" y1="12" y2="12"/> <line x1="21" x2="16" y1="20" y2="20"/> <line x1="12" x2="3" y1="20" y2="20"/> <line x1="14" x2="14" y1="2" y2="6"/> <line x1="8" x2="8" y1="10" y2="14"/> <line x1="16" x2="16" y1="18" y2="22"/> </svg>',"folder-minus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 13h6"/> <path d="M20 20a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2Z"/> </svg>',"book-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 7v6"/> <path d="M4 19.5v-15A2.5 2.5 0 0 1 6.5 2H19a1 1 0 0 1 1 1v18a1 1 0 0 1-1 1H6.5a1 1 0 0 1 0-5H20"/> <path d="M9 10h6"/> </svg>',"lock-keyhole-open":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="16" r="1"/> <rect width="18" height="12" x="3" y="10" rx="2"/> <path d="M7 10V7a5 5 0 0 1 9.33-2.5"/> </svg>',"chevrons-left-right":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9 7-5 5 5 5"/> <path d="m15 7 5 5-5 5"/> </svg>',"scan-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <circle cx="12" cy="12" r="3"/> <path d="m16 16-1.9-1.9"/> </svg>',"tv-minimal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M7 21h10"/> <rect width="20" height="14" x="2" y="3" rx="2"/> </svg>',"message-square-warning":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="M12 7v2"/> <path d="M12 13h.01"/> </svg>',"heart-crack":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M19 14c1.49-1.46 3-3.21 3-5.5A5.5 5.5 0 0 0 16.5 3c-1.76 0-3 .5-4.5 2-1.5-1.5-2.74-2-4.5-2A5.5 5.5 0 0 0 2 8.5c0 2.3 1.5 4.05 3 5.5l7 7Z"/> <path d="m12 13-1-1 2-2-3-3 2-2"/> </svg>',bomb:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="11" cy="13" r="9"/> <path d="M14.35 4.65 16.3 2.7a2.41 2.41 0 0 1 3.4 0l1.6 1.6a2.4 2.4 0 0 1 0 3.4l-1.95 1.95"/> <path d="m22 2-1.5 1.5"/> </svg>',bed:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 4v16"/> <path d="M2 8h18a2 2 0 0 1 2 2v10"/> <path d="M2 17h20"/> <path d="M6 8v9"/> </svg>',box:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l7-4A2 2 0 0 0 21 16Z"/> <path d="m3.3 7 8.7 5 8.7-5"/> <path d="M12 22V12"/> </svg>',"pill-bottle":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 11h-4a1 1 0 0 0-1 1v5a1 1 0 0 0 1 1h4"/> <path d="M6 7v13a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2V7"/> <rect width="16" height="5" x="4" y="2" rx="1"/> </svg>',"rotate-cw-square":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 5H6a2 2 0 0 0-2 2v3"/> <path d="m9 8 3-3-3-3"/> <path d="M4 14v4a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2h-2"/> </svg>',"package-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M16 16h6"/> <path d="M19 13v6"/> <path d="M21 10V8a2 2 0 0 0-1-1.73l-7-4a2 2 0 0 0-2 0l-7 4A2 2 0 0 0 3 8v8a2 2 0 0 0 1 1.73l7 4a2 2 0 0 0 2 0l2-1.14"/> <path d="m7.5 4.27 9 5.15"/> <polyline points="3.29 7 12 12 20.71 7"/> <line x1="12" x2="12" y1="22" y2="12"/> </svg>',"file-audio-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 22h14a2 2 0 0 0 2-2V7l-5-5H6a2 2 0 0 0-2 2v2"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <circle cx="3" cy="17" r="1"/> <path d="M2 17v-3a4 4 0 0 1 8 0v3"/> <circle cx="9" cy="17" r="1"/> </svg>',"file-type":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <path d="M9 13v-1h6v1"/> <path d="M12 12v6"/> <path d="M11 18h2"/> </svg>',"redo-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m15 14 5-5-5-5"/> <path d="M20 9H9.5A5.5 5.5 0 0 0 4 14.5A5.5 5.5 0 0 0 9.5 20H13"/> </svg>',gamepad:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <line x1="6" x2="10" y1="12" y2="12"/> <line x1="8" x2="8" y1="10" y2="14"/> <line x1="15" x2="15.01" y1="13" y2="13"/> <line x1="18" x2="18.01" y1="11" y2="11"/> <rect width="20" height="12" x="2" y="6" rx="2"/> </svg>',radical:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 12h3.28a1 1 0 0 1 .948.684l2.298 7.934a.5.5 0 0 0 .96-.044L13.82 4.771A1 1 0 0 1 14.792 4H21"/> </svg>',"square-function":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2" ry="2"/> <path d="M9 17c2 0 2.8-1 2.8-2.8V10c0-2 1-3.3 3.2-3"/> <path d="M9 11.2h5.7"/> </svg>',"align-vertical-space-around":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="10" height="6" x="7" y="9" rx="2"/> <path d="M22 20H2"/> <path d="M22 4H2"/> </svg>',video:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m16 13 5.223 3.482a.5.5 0 0 0 .777-.416V7.87a.5.5 0 0 0-.752-.432L16 10.5"/> <rect x="2" y="6" width="14" height="12" rx="2"/> </svg>',"calendar-heart":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 10h18V6a2 2 0 0 0-2-2H5a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h7"/> <path d="M8 2v4"/> <path d="M16 2v4"/> <path d="M21.29 14.7a2.43 2.43 0 0 0-2.65-.52c-.3.12-.57.3-.8.53l-.34.34-.35-.34a2.43 2.43 0 0 0-2.65-.53c-.3.12-.56.3-.79.53-.95.94-1 2.53.2 3.74L17.5 22l3.6-3.55c1.2-1.21 1.14-2.8.19-3.74Z"/> </svg>',grape:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 5V2l-5.89 5.89"/> <circle cx="16.6" cy="15.89" r="3"/> <circle cx="8.11" cy="7.4" r="3"/> <circle cx="12.35" cy="11.65" r="3"/> <circle cx="13.91" cy="5.85" r="3"/> <circle cx="18.15" cy="10.09" r="3"/> <circle cx="6.56" cy="13.2" r="3"/> <circle cx="10.8" cy="17.44" r="3"/> <circle cx="5" cy="19" r="3"/> </svg>',"egg-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M6.399 6.399C5.362 8.157 4.65 10.189 4.5 12c-.37 4.43 1.27 9.95 7.5 10 3.256-.026 5.259-1.547 6.375-3.625"/> <path d="M19.532 13.875A14.07 14.07 0 0 0 19.5 12c-.36-4.34-3.95-9.96-7.5-10-1.04.012-2.082.502-3.046 1.297"/> <line x1="2" x2="22" y1="2" y2="22"/> </svg>',"train-front":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 3.1V7a4 4 0 0 0 8 0V3.1"/> <path d="m9 15-1-1"/> <path d="m15 15 1-1"/> <path d="M9 19c-2.8 0-5-2.2-5-5v-4a8 8 0 0 1 16 0v4c0 2.8-2.2 5-5 5Z"/> <path d="m8 19-2 3"/> <path d="m16 19 2 3"/> </svg>',"iteration-cw":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 10c0-4.4 3.6-8 8-8s8 3.6 8 8-3.6 8-8 8H4"/> <polyline points="8 22 4 18 8 14"/> </svg>',"indent-decrease":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polyline points="7 8 3 12 7 16"/> <line x1="21" x2="11" y1="12" y2="12"/> <line x1="21" x2="11" y1="6" y2="6"/> <line x1="21" x2="11" y1="18" y2="18"/> </svg>',"gallery-horizontal-end":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2 7v10"/> <path d="M6 5v14"/> <rect width="12" height="18" x="10" y="3" rx="2"/> </svg>',"file-warning":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M12 9v4"/> <path d="M12 17h.01"/> </svg>',wallpaper:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="8" cy="9" r="2"/> <path d="m9 17 6.1-6.1a2 2 0 0 1 2.81.01L22 15V5a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v10a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2"/> <path d="M8 21h8"/> <path d="M12 17v4"/> </svg>',"clock-11":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 9.5 8"/> </svg>',"tree-pine":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m17 14 3 3.3a1 1 0 0 1-.7 1.7H4.7a1 1 0 0 1-.7-1.7L7 14h-.3a1 1 0 0 1-.7-1.7L9 9h-.2A1 1 0 0 1 8 7.3L12 3l4 4.3a1 1 0 0 1-.8 1.7H15l3 3.3a1 1 0 0 1-.7 1.7H17Z"/> <path d="M12 22v-3"/> </svg>',eye:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.062 12.348a1 1 0 0 1 0-.696 10.75 10.75 0 0 1 19.876 0 1 1 0 0 1 0 .696 10.75 10.75 0 0 1-19.876 0"/> <circle cx="12" cy="12" r="3"/> </svg>',"captions-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10.5 5H19a2 2 0 0 1 2 2v8.5"/> <path d="M17 11h-.5"/> <path d="M19 19H5a2 2 0 0 1-2-2V7a2 2 0 0 1 2-2"/> <path d="m2 2 20 20"/> <path d="M7 11h4"/> <path d="M7 15h2.5"/> </svg>',"cloud-cog":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="17" r="3"/> <path d="M4.2 15.1A7 7 0 1 1 15.71 8h1.79a4.5 4.5 0 0 1 2.5 8.2"/> <path d="m15.7 18.4-.9-.3"/> <path d="m9.2 15.9-.9-.3"/> <path d="m10.6 20.7.3-.9"/> <path d="m13.1 14.2.3-.9"/> <path d="m13.6 20.7-.4-1"/> <path d="m10.8 14.3-.4-1"/> <path d="m8.3 18.6 1-.4"/> <path d="m14.7 15.8 1-.4"/> </svg>',power:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 2v10"/> <path d="M18.4 6.6a9 9 0 1 1-12.77.04"/> </svg>',parentheses:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 21s-4-3-4-9 4-9 4-9"/> <path d="M16 3s4 3 4 9-4 9-4 9"/> </svg>',signpost:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 13v8"/> <path d="M12 3v3"/> <path d="M18 6a2 2 0 0 1 1.387.56l2.307 2.22a1 1 0 0 1 0 1.44l-2.307 2.22A2 2 0 0 1 18 13H6a2 2 0 0 1-1.387-.56l-2.306-2.22a1 1 0 0 1 0-1.44l2.306-2.22A2 2 0 0 1 6 6z"/> </svg>',"chevron-first":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m17 18-6-6 6-6"/> <path d="M7 6v12"/> </svg>',"user-round-search":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="10" cy="8" r="5"/> <path d="M2 21a8 8 0 0 1 10.434-7.62"/> <circle cx="18" cy="18" r="3"/> <path d="m22 22-1.9-1.9"/> </svg>',"case-upper":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m3 15 4-8 4 8"/> <path d="M4 13h6"/> <path d="M15 11h4.5a2 2 0 0 1 0 4H15V7h4a2 2 0 0 1 0 4"/> </svg>',phone:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M22 16.92v3a2 2 0 0 1-2.18 2 19.79 19.79 0 0 1-8.63-3.07 19.5 19.5 0 0 1-6-6 19.79 19.79 0 0 1-3.07-8.67A2 2 0 0 1 4.11 2h3a2 2 0 0 1 2 1.72 12.84 12.84 0 0 0 .7 2.81 2 2 0 0 1-.45 2.11L8.09 9.91a16 16 0 0 0 6 6l1.27-1.27a2 2 0 0 1 2.11-.45 12.84 12.84 0 0 0 2.81.7A2 2 0 0 1 22 16.92z"/> </svg>',"triangle-alert":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21.73 18-8-14a2 2 0 0 0-3.48 0l-8 14A2 2 0 0 0 4 21h16a2 2 0 0 0 1.73-3"/> <path d="M12 9v4"/> <path d="M12 17h.01"/> </svg>',"badge-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3.85 8.62a4 4 0 0 1 4.78-4.77 4 4 0 0 1 6.74 0 4 4 0 0 1 4.78 4.78 4 4 0 0 1 0 6.74 4 4 0 0 1-4.77 4.78 4 4 0 0 1-6.75 0 4 4 0 0 1-4.78-4.77 4 4 0 0 1 0-6.76Z"/> <line x1="15" x2="9" y1="9" y2="15"/> <line x1="9" x2="15" y1="9" y2="15"/> </svg>',"shield-plus":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="M9 12h6"/> <path d="M12 9v6"/> </svg>',"file-lock":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <rect width="8" height="6" x="8" y="12" rx="1"/> <path d="M10 12v-2a2 2 0 1 1 4 0v2"/> </svg>',"mouse-off":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 6v.343"/> <path d="M18.218 18.218A7 7 0 0 1 5 15V9a7 7 0 0 1 .782-3.218"/> <path d="M19 13.343V9A7 7 0 0 0 8.56 2.902"/> <path d="M22 22 2 2"/> </svg>',link:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M10 13a5 5 0 0 0 7.54.54l3-3a5 5 0 0 0-7.07-7.07l-1.72 1.71"/> <path d="M14 11a5 5 0 0 0-7.54-.54l-3 3a5 5 0 0 0 7.07 7.07l1.71-1.71"/> </svg>',bot:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 8V4H8"/> <rect width="16" height="12" x="4" y="8" rx="2"/> <path d="M2 14h2"/> <path d="M20 14h2"/> <path d="M15 13v2"/> <path d="M9 13v2"/> </svg>',"clock-arrow-down":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12.338 21.994A10 10 0 1 1 21.925 13.227"/> <path d="M12 6v6l2 1"/> <path d="m14 18 4 4 4-4"/> <path d="M18 14v8"/> </svg>',cross:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 2a2 2 0 0 0-2 2v5H4a2 2 0 0 0-2 2v2c0 1.1.9 2 2 2h5v5c0 1.1.9 2 2 2h2a2 2 0 0 0 2-2v-5h5a2 2 0 0 0 2-2v-2a2 2 0 0 0-2-2h-5V4a2 2 0 0 0-2-2h-2z"/> </svg>',binary:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect x="14" y="14" width="4" height="6" rx="2"/> <rect x="6" y="4" width="4" height="6" rx="2"/> <path d="M6 20h4"/> <path d="M14 10h4"/> <path d="M6 14h2v6"/> <path d="M14 4h2v6"/> </svg>',"calendar-days":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M8 2v4"/> <path d="M16 2v4"/> <rect width="18" height="18" x="3" y="4" rx="2"/> <path d="M3 10h18"/> <path d="M8 14h.01"/> <path d="M12 14h.01"/> <path d="M16 14h.01"/> <path d="M8 18h.01"/> <path d="M12 18h.01"/> <path d="M16 18h.01"/> </svg>',"sun-dim":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="4"/> <path d="M12 4h.01"/> <path d="M20 12h.01"/> <path d="M12 20h.01"/> <path d="M4 12h.01"/> <path d="M17.657 6.343h.01"/> <path d="M17.657 17.657h.01"/> <path d="M6.343 17.657h.01"/> <path d="M6.343 6.343h.01"/> </svg>',heater:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 8c2-3-2-3 0-6"/> <path d="M15.5 8c2-3-2-3 0-6"/> <path d="M6 10h.01"/> <path d="M6 14h.01"/> <path d="M10 16v-4"/> <path d="M14 16v-4"/> <path d="M18 16v-4"/> <path d="M20 6a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2h3"/> <path d="M5 20v2"/> <path d="M19 20v2"/> </svg>',pin:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 17v5"/> <path d="M9 10.76a2 2 0 0 1-1.11 1.79l-1.78.9A2 2 0 0 0 5 15.24V16a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-.76a2 2 0 0 0-1.11-1.79l-1.78-.9A2 2 0 0 1 15 10.76V7a1 1 0 0 1 1-1 2 2 0 0 0 0-4H8a2 2 0 0 0 0 4 1 1 0 0 1 1 1z"/> </svg>',fullscreen:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M3 7V5a2 2 0 0 1 2-2h2"/> <path d="M17 3h2a2 2 0 0 1 2 2v2"/> <path d="M21 17v2a2 2 0 0 1-2 2h-2"/> <path d="M7 21H5a2 2 0 0 1-2-2v-2"/> <rect width="10" height="8" x="7" y="8" rx="1"/> </svg>',baby:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M9 12h.01"/> <path d="M15 12h.01"/> <path d="M10 16c.5.3 1.2.5 2 .5s1.5-.2 2-.5"/> <path d="M19 6.3a9 9 0 0 1 1.8 3.9 2 2 0 0 1 0 3.6 9 9 0 0 1-17.6 0 2 2 0 0 1 0-3.6A9 9 0 0 1 12 3c2 0 3.5 1.1 3.5 2.5s-.9 2.5-2 2.5c-.8 0-1.5-.4-1.5-1"/> </svg>',"file-search-2":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M15 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V7Z"/> <path d="M14 2v4a2 2 0 0 0 2 2h4"/> <circle cx="11.5" cy="14.5" r="2.5"/> <path d="M13.3 16.3 15 18"/> </svg>',magnet:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m6 15-4-4 6.75-6.77a7.79 7.79 0 0 1 11 11L13 22l-4-4 6.39-6.36a2.14 2.14 0 0 0-3-3L6 15"/> <path d="m5 8 4 4"/> <path d="m12 15 4 4"/> </svg>',"circle-arrow-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <path d="M16 12H8"/> <path d="m12 8-4 4 4 4"/> </svg>',"chevrons-left":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m11 17-5-5 5-5"/> <path d="m18 17-5-5 5-5"/> </svg>',filter:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <polygon points="22 3 2 3 10 12.46 10 19 14 21 14 12.46 22 3"/> </svg>',squircle:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M12 3c7.2 0 9 1.8 9 9s-1.8 9-9 9-9-1.8-9-9 1.8-9 9-9"/> </svg>',"switch-camera":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 19H4a2 2 0 0 1-2-2V7a2 2 0 0 1 2-2h5"/> <path d="M13 5h7a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2h-5"/> <circle cx="12" cy="12" r="3"/> <path d="m18 22-3-3 3-3"/> <path d="m6 2 3 3-3 3"/> </svg>',"message-square-text":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"/> <path d="M13 8H7"/> <path d="M17 12H7"/> </svg>',"car-front":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m21 8-2 2-1.5-3.7A2 2 0 0 0 15.646 5H8.4a2 2 0 0 0-1.903 1.257L5 10 3 8"/> <path d="M7 14h.01"/> <path d="M17 14h.01"/> <rect width="18" height="8" x="3" y="10" rx="2"/> <path d="M5 18v2"/> <path d="M19 18v2"/> </svg>',"app-window-mac":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="16" x="2" y="4" rx="2"/> <path d="M6 8h.01"/> <path d="M10 8h.01"/> <path d="M14 8h.01"/> </svg>',"folder-archive":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="15" cy="19" r="2"/> <path d="M20.9 19.8A2 2 0 0 0 22 18V8a2 2 0 0 0-2-2h-7.9a2 2 0 0 1-1.69-.9L9.6 3.9A2 2 0 0 0 7.93 3H4a2 2 0 0 0-2 2v13a2 2 0 0 0 2 2h5.1"/> <path d="M15 11v-1"/> <path d="M15 17v-2"/> </svg>',route:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="6" cy="19" r="3"/> <path d="M9 19h8.5a3.5 3.5 0 0 0 0-7h-11a3.5 3.5 0 0 1 0-7H15"/> <circle cx="18" cy="5" r="3"/> </svg>',camera:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M14.5 4h-5L7 7H4a2 2 0 0 0-2 2v9a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2V9a2 2 0 0 0-2-2h-3l-2.5-3z"/> <circle cx="12" cy="13" r="3"/> </svg>',"lamp-wall-up":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M11 4h6l3 7H8l3-7Z"/> <path d="M14 11v5a2 2 0 0 1-2 2H8"/> <path d="M4 15h2a2 2 0 0 1 2 2v2a2 2 0 0 1-2 2H4v-6Z"/> </svg>',candy:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m9.5 7.5-2 2a4.95 4.95 0 1 0 7 7l2-2a4.95 4.95 0 1 0-7-7Z"/> <path d="M14 6.5v10"/> <path d="M10 7.5v10"/> <path d="m16 7 1-5 1.37.68A3 3 0 0 0 19.7 3H21v1.3c0 .46.1.92.32 1.33L22 7l-5 1"/> <path d="m8 17-1 5-1.37-.68A3 3 0 0 0 4.3 21H3v-1.3a3 3 0 0 0-.32-1.33L2 17l5-1"/> </svg>',"archive-x":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="20" height="5" x="2" y="3" rx="1"/> <path d="M4 8v11a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V8"/> <path d="m9.5 17 5-5"/> <path d="m9.5 12 5 5"/> </svg>',"shield-check":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M20 13c0 5-3.5 7.5-7.66 8.95a1 1 0 0 1-.67-.01C7.5 20.5 4 18 4 13V6a1 1 0 0 1 1-1c2 0 4.5-1.2 6.24-2.72a1.17 1.17 0 0 1 1.52 0C14.51 3.81 17 5 19 5a1 1 0 0 1 1 1z"/> <path d="m9 12 2 2 4-4"/> </svg>',"diamond-percent":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M2.7 10.3a2.41 2.41 0 0 0 0 3.41l7.59 7.59a2.41 2.41 0 0 0 3.41 0l7.59-7.59a2.41 2.41 0 0 0 0-3.41L13.7 2.71a2.41 2.41 0 0 0-3.41 0Z"/> <path d="M9.2 9.2h.01"/> <path d="m14.5 9.5-5 5"/> <path d="M14.7 14.8h.01"/> </svg>',share:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M4 12v8a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2v-8"/> <polyline points="16 6 12 2 8 6"/> <line x1="12" x2="12" y1="2" y2="15"/> </svg>',pill:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="m10.5 20.5 10-10a4.95 4.95 0 1 0-7-7l-10 10a4.95 4.95 0 1 0 7 7Z"/> <path d="m8.5 8.5 7 7"/> </svg>',"square-equal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <rect width="18" height="18" x="3" y="3" rx="2"/> <path d="M7 10h10"/> <path d="M7 14h10"/> </svg>',"clock-4":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="12" cy="12" r="10"/> <polyline points="12 6 12 12 16 14"/> </svg>',"git-pull-request-arrow":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <circle cx="5" cy="6" r="3"/> <path d="M5 9v12"/> <circle cx="19" cy="18" r="3"/> <path d="m15 9-3-3 3-3"/> <path d="M12 6h5a2 2 0 0 1 2 2v7"/> </svg>',popcorn:'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 8a2 2 0 0 0 0-4 2 2 0 0 0-4 0 2 2 0 0 0-4 0 2 2 0 0 0-4 0 2 2 0 0 0 0 4"/> <path d="M10 22 9 8"/> <path d="m14 22 1-14"/> <path d="M20 8c.5 0 .9.4.8 1l-2.6 12c-.1.5-.7 1-1.2 1H7c-.6 0-1.1-.4-1.2-1L3.2 9c-.1-.6.3-1 .8-1Z"/> </svg>',"hand-metal":'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"> <path d="M18 12.5V10a2 2 0 0 0-2-2a2 2 0 0 0-2 2v1.4"/> <path d="M14 11V9a2 2 0 1 0-4 0v2"/> <path d="M10 10.5V5a2 2 0 1 0-4 0v9"/> <path d="m7 15-1.76-1.76a2 2 0 0 0-2.83 2.82l3.6 3.6C7.5 21.14 9.2 22 12 22h2a8 8 0 0 0 8-8V7a2 2 0 1 0-4 0v5"/> </svg>'};Blx.svgIcons=svgIcons;class Table{constructor(o){if(o&&o.visible&&o.visible.enabled===true&&o.visible.url&&!o.visible.columns){Blx.ajax.request({url:o.visible.url,success:result=>{o.visible.columns=result.data;this.init(o)}})}else{this.init(o)}}init(o){this.config=Blx.utils.config(o,["grow","url","data","postdataCallback","appendTo","replaceTo","title","titleIcon","responsive","headerIcons","iconConfig","footerButtons","footerIcons","uid","reload","avoidFlickerOnReload","pager","visible","sortable","searchable","selectable","onRowClick","columns","overlay"],{grow:true,headerIcons:[],footerButtons:[],footerIcons:[],uid:row=>{return row.id},reload:"auto",avoidFlickerOnReload:false,responsive:[]});this.footerButtons={items:[],enable:()=>{$.each(this.footerButtons.items,(i,item)=>{item.css("opacity",1);item.css("cursor","pointer")})},disable:()=>{$.each(this.footerButtons.items,(i,item)=>{item.css("opacity",.5);item.css("cursor","auto")})}};this.pager=Blx.utils.config(this.config.pager,["enabled","offset","limit","icon"],{enabled:"auto",offset:0,limit:50});this.visible=Blx.utils.config(this.config.visible,["enabled","url","columns","callback"]);if(this.visible.enabled===true){const columns=this.visible.columns;this.visible.columns={};$.each(columns,(i,name)=>{this.visible.columns[name]=true})}this.sortable=Blx.utils.config(this.config.sortable,["enabled","sort","columns"],{enabled:"auto",sort:[undefined,"asc"],columns:[]});this.searchable=Blx.utils.config(this.config.searchable,["enabled","columns","value","visible"],{enabled:"auto",columns:[],visible:true});this.selectable=Blx.utils.config(this.config.selectable,["enabled","title","selectCallback","unselectCallback","callback","selected","columns","deletable","iconColor"],{title:Blx.text.get("text.Selected_rows"),cache:{},columns:[],iconColor:Blx.tableProps.selectableIconColor});this.deletable=Blx.utils.config(this.selectable.deletable,["route","title","subtitle","callback","postCallback","ignoreErrors","buttonText","confirmButtonText"],{title:Blx.text.get("text.really_deletes")});if(this.deletable.buttonText===undefined&&this.deletable.confirmButtonText===undefined){this.deletable.buttonText=Blx.text.get("action.delete");this.deletable.confirmButtonText=Blx.text.get("action.yes_delete")}else if(this.deletable.confirmButtonText===undefined){this.deletable.confirmButtonText=this.deletable.buttonText}if(this.deletable.callback||this.deletable.route){this.config.footerButtons.push({text:this.deletable.buttonText||Blx.text.get("action.delete"),callback:()=>this.deleteData()})}if(this.config.overlay!==undefined){if(typeof this.config.overlay=="string"){this.overlay=this.contentBox=Blx.overlay({position:this.config.overlay,title:this.config.title,titleIcon:this.config.titleIcon}).create()}else{this.overlay=this.contentBox=this.config.overlay}}else{this.contentBox=Blx.contentBox({grow:this.config.grow,title:this.config.title,titleIcon:this.config.titleIcon,appendTo:this.config.appendTo,replaceTo:this.config.replaceTo,iconConfig:this.config.iconConfig})}this.body=this.contentBox.body.css("position","relative");this.searchable.container=Blx.create("div").addClass("blx-table-search").appendTo(this.contentBox.headerMiddle);this.addIcon=this.contentBox.icon;this.pager.icon=Blx.icon().size("default").coloring(Blx.tableProps.pagerIconColor);this.pager.container=Blx.create("div").addClass("blx-table-pager-box").appendTo(this.contentBox.footerMiddle);if(this.pager.enabled===false){this.pager.container.hide()}this.buttonContainer=Blx.create("div").addClass("blx-table-button-box").appendTo(this.contentBox.footerLeft).hide();if(this.selectable.enabled===true){this.selectable.counterBtn=this.addFooterButton({text:"0",callback:()=>this.showSelectedRows()});this.selectable.counterBtn.prop("title",Blx.text.get("text.Number_of_selected_rows"));if(this.selectable.columns.length===0){$.each(this.config.columns,(i,col)=>{this.selectable.columns.push(col.name)})}}$.each(this.config.footerButtons,(i,item)=>{this.addFooterButton(item)});$.each(this.config.footerIcons,(i,item)=>{this.addFooterIcon(item)});this.headerContainer=Blx.create("div").addClass("blx-table-header").appendTo(this.body);this.nodata=Blx.create("div").addClass("blx-nodata-text").setHTML(Blx.text.get("err-611")).hide().appendTo(this.body);if(this.config.avoidFlickerOnReload){this.loading=Blx.create("div").addClass("blx-table-loading").appendTo(this.body);Blx.create("div").addClass("blx-lds-spinner2").addClass("blx-lds-spinner2-gray").appendTo(this.loading)}else{this.loading=Blx.create("div").addClass("blx-table-loading-info").hide().appendTo(this.body);Blx.create("div").addClass("blx-loader-bars").appendTo(this.loading)}this.table=Blx.create("table").addClass("blx-table").hide().appendTo(this.body);this.thead=Blx.create("thead").appendTo(this.table);this.theadTR=Blx.create("tr").appendTo(this.thead);this.tbody=Blx.create("tbody").appendTo(this.table);if(this.selectable.enabled===true){$.each(this.selectable.selected,(i,id)=>{this.selectable.cache[id]=true});this.selectable.icon=Blx.icon().size("medium").cursor("pointer").coloring(this.selectable.iconColor);const th=Blx.create("th").addClass("blx-table-th blx-table-checkbox").appendTo(this.theadTR);this.theadCheckboxOn=this.selectable.icon.span("square-check").appendTo(th).hide().click(()=>{$.each(this.rowsById,(id,row)=>{if(row.off.is(":hidden")){row.on.trigger("click")}})});this.theadCheckboxOff=this.selectable.icon.span("square").appendTo(th).click(()=>{$.each(this.rowsById,(id,row)=>{if(row.on.is(":hidden")){row.off.trigger("click")}})});if(this.selectable.name){Blx.create("input").attr("type","hidden").attr("name",this.selectable.name).attr("value","").appendTo(th)}}this.columns=[];this.columnsByName={};this.responsive={enabled:false,columns:{}};$.each(this.config.columns,(i,col)=>{this.columns.push(Object.assign({},col));this.columnsByName[col.name]=col;if(col.responsive===true){this.responsive.columns[col.name]=true}});$.each(this.config.responsive,(i,name)=>{this.responsive.columns[name]=true});if(Blx.utils.size(this.responsive.columns)){this.responsive.enabled=true}$.each(this.columns,(i,col)=>{col.th=Blx.create("th").addClass("blx-table-th").attr("data-name",col.name).setHTML(col.text).appendTo(this.theadTR);if(col.align){col.th.css("text-align",col.align)}if(!this.columnIsVisible(col)){col.th.hide()}if(col.sortable===true&&(this.sortable.enabled=="auto"||this.sortable.enabled===true)){this.sortable.enabled=true;col.th.css("cursor","pointer");col.th.click(()=>{this.sortable.sort[0]=col.name;this.sortable.sort[1]=this.sortable.sort[1]=="asc"?"desc":"asc";this.pager.offset=0;this.reload()})}if(col.searchable!==undefined){if(this.searchable.enabled=="auto"){this.searchable.enabled=true}const item={name:col.name,text:col.text};Object.assign(item,col.searchable);this.searchable.columns.push(item)}if(this.responsive.enabled===true&&this.responsive.columns[col.name]!==true){col.th.addClass("blx-table-resp-600")}});if(this.searchable.enabled===true){this.searchable.tableSearch=Blx.tableSearch({fields:this.searchable.columns,container:this.searchable.container,submitCallback:()=>this.reload(),value:this.searchable.value});this.searchable.icon=this.addIcon.btn("filter").prop("title",Blx.text.get("word.Filter")).click(()=>this.searchable.tableSearch.start());if(this.searchable.visible!==true){this.hideSearch()}}if(this.config.reload===true||this.config.reload=="auto"&&this.config.url){this.addIcon.btn("rotate-cw").prop("title",Blx.text.get("action.reload")).click(()=>this.reload())}if(this.visible.enabled===true){this.addIcon.btn("settings").prop("title",Blx.text.get("text.table_column_settings")).click(()=>this.columnSettings())}if(this.config.headerIcons){$.each(this.config.headerIcons,(i,icon)=>{this.addIcon.btn(icon.name).prop("title",icon.title).click(()=>icon.callback(this))})}this.reload()}hideSearch(){this.searchable.container.hide();this.searchable.icon.hide()}showSearch(){this.searchable.container.show();this.searchable.icon.show()}getSearchValue(){return this.searchable.tableSearch.getValue()}addSearchFilter(logOp,key,compOp,value){this.searchable.tableSearch.addFilter(logOp,key,compOp,value)}addFooterIcon(item){this.buttonContainer.show();if(!this.footerIcon){this.footerIcon=Blx.icon().coloring("black").size("default").appendTo(this.buttonContainer)}const btn=this.footerIcon.btn(item.name).prop("title",item.title).click(()=>{if(Blx.utils.size(this.selectable.cache)>0){item.callback(this)}});if(Blx.utils.size(this.selectable.cache)>0){btn.css("opacity",1).css("cursor","pointer")}else{btn.css("opacity",.5).css("cursor","auto")}this.footerButtons.items.push(btn);return btn}addFooterButton(item){this.buttonContainer.show();const btn=Blx.button({color:"dark",size:"default",text:item.text,icon:item.icon});btn.css("cursor","pointer");btn.appendTo(this.buttonContainer);btn.click(()=>{if(Blx.utils.size(this.selectable.cache)>0){item.callback(this)}});if(Blx.utils.size(this.selectable.cache)>0){btn.css("opacity",1).css("cursor","pointer")}else{btn.css("opacity",.5).css("cursor","auto")}this.footerButtons.items.push(btn);return btn}reload(o){if(o&&o.resetPager===true&&this.pager){this.pager.offset=0}this.body.find(".blx-rwb").removeClass("blx-rwb");if(!this.config.avoidFlickerOnReload){this.tbody.html("");this.table.hide();this.nodata.hide()}this.loading.show();if(this.config.data){const offset=this.pager.offset,size=this.pager.offset+this.pager.limit,data=[];for(let i=this.pager.offset;i<size;i++){if(!this.config.data[i]){break}data.push(this.config.data[i])}this.loading.hide();this.processData(data);this.updatePager(data.length,this.config.data.length);return}const postdata={};if(this.pager.enabled===true||this.pager.enabled=="auto"){postdata.offset=this.pager.offset;postdata.limit=this.pager.limit}if(this.sortable.enabled===true&&this.sortable.sort[0]!==undefined){postdata.sort=this.sortable.sort}if(this.searchable.enabled===true){postdata.query=this.searchable.tableSearch.getValue()}if(this.config.postdataCallback){this._request(this.config.postdataCallback(postdata))}else{this._request(postdata)}}_request(postdata){Blx.ajax.request({url:this.config.url,data:postdata,success:result=>{this.loading.hide();if(this.config.avoidFlickerOnReload){this.tbody.html("")}this.processData(result.data);this.updatePager(result.size,result.total)},errorCallback:{"err-606":()=>{this.loading.hide();this.headerSearch.addClass("blx-rwb")}}})}processData(rows){this.numberOfRows=Array.isArray(rows)?rows.length:0;if(this.selectable.enabled===true){this.theadCheckboxOn.hide();this.theadCheckboxOff.show()}if(this.numberOfRows===0){if(this.config.avoidFlickerOnReload){this.table.hide()}this.nodata.show();return}this.table.show();this.selectedRows=0;this.rowsById={};$.each(rows,(i,row)=>{const id=this.config.uid(row);const tr=Blx.create("tr").addClass("blx-table-tr").attr("data-id",this.config.uid(row)).appendTo(this.tbody);this.rowsById[id]={tr:tr};if(this.selectable.enabled===true){const td=Blx.create("td").addClass("blx-table-checkbox").appendTo(tr),on=this.selectable.icon.span("square-check").hide().appendTo(td),off=this.selectable.icon.span("square").hide().appendTo(td);on.click(()=>{delete this.selectable.cache[id];on.hide();off.show();this.selectedRows--;this.theadCheckboxOn.hide();this.theadCheckboxOff.show();tr.removeClass("blx-table-tr-selected");this.updateSelectedCounter();if(this.selectable.unselectCallback){this.selectable.unselectCallback(row)}});off.click(()=>{this.selectable.cache[id]=row;off.hide();on.show();this.selectedRows++;if(this.selectedRows==this.numberOfRows){this.theadCheckboxOff.hide();this.theadCheckboxOn.show()}this.updateSelectedCounter();tr.addClass("blx-table-tr-selected");if(this.selectable.selectCallback){this.selectable.selectCallback(row)}});this.rowsById[id].td=td;this.rowsById[id].on=on;this.rowsById[id].off=off;if(this.selectable.cache[id]){off.trigger("click")}else{off.show()}}if(this.config.onRowClick){tr.css("cursor","pointer");tr.click(()=>this.config.onRowClick(row,this))}$.each(this.columns,(i,col)=>{const td=Blx.create("td").addClass("blx-table-td").attr("data-name",col.name).appendTo(tr);if(!this.columnIsVisible(col)){td.hide()}if(this.responsive.enabled===true&&this.responsive.columns[col.name]!==true){td.addClass("blx-table-resp-600")}this.addColumnValue(row,col,td)})})}unselect(id){if(this.selectable.cache[id]){if(this.rowsById[id]){this.rowsById[id].on.trigger("click")}else{delete this.selectable.cache[id];this.updateSelectedCounter()}}}select(id,row){if(this.rowsById[id]){this.rowsById[id].off.trigger("click")}else{this.selectable.cache[id]=row;this.updateSelectedCounter()}}updateSelectedCounter(){this.selectable.counterBtn.text(Blx.utils.size(this.selectable.cache));if(Blx.utils.size(this.selectable.cache)===0){this.footerButtons.disable()}else{this.footerButtons.enable()}}addColumnValue(row,col,td,noCallback=false){let value=row[col.name]===undefined?"":row[col.name],origValue=value,el;if(col.route&&col.callback){throw new Error("Table(): mixin route and callback is not allowed")}if(noCallback===true){el=Blx.create("span").addClass("blx-table-span")}else if(col.route){el=Blx.create("a").attr("href","#"+Blx.route.build(col.route,row)).addClass("blx-table-link").click(()=>Blx.route.to(Blx.route.build(col.route,row)))}else if(col.link){el=Blx.create("a").attr("href",Blx.route.build(col.link,row)).addClass("blx-table-link")}else if(col.callback){el=Blx.create("a").addClass("blx-table-link")}else{el=Blx.create("span").addClass("blx-table-span")}if(col.value){value=col.value(row)}if(col.genRouteFromDataArray){value=this.genRouteFromDataArray(col.genRouteFromDataArray,row,value)}if(noCallback===false&&col.callback){el.click(()=>col.callback(row,this))}if(col.convertList&&Array.isArray(value)){value=value.join(", ")}if(col.convertUnixtime){value=this.convertUnixtime(col.convertUnixtime,value)}if(col.convertUnixtimeShort){value=this.convertUnixtime(col.convertUnixtime,value,true)}if(col.convertToEuro){if(typeof value=="number"){value=Blx.create("span").html(Blx.utils.euro(value))}}if(col.cut){if(value.length>col.cut){value=value.slice(0,col.cut-3)+"..."}}if(col.convertBool){if(value=="0"||value===false){value=Blx.text.get("word.No")}else if(value=="1"||value===true){value=Blx.text.get("word.Yes")}}if(col.convertCountryFlag){value=Blx.svgFlag.medium(value)}if(col.convertToTimeString){value=Blx.utils.secondsToStringShortReadable(value)}if(col.secondsToStringReadable){value=Blx.utils.secondsToStringReadable(value)}if(col.appendString){value=value+col.appendString}if(col.highlight&&(origValue===1||origValue==="1"||origValue===true)){el.css("font-style","italic");el.css("font-weight","bold")}if(col.mono===true){el.addClass("blx-preformatted")}if(col.column){col.column(td,row)}else{td.html(el.setHTML(value))}if(col.align){td.css("text-align",col.align)}if(col.whiteSpace){td.css("white-space",col.whiteSpace)}}convertUnixtime(type,value,notToday){if(!value){return"---"}const dateUX=new Date(value*1e3),date=DateFormat(dateUX,DateFormat.masks["date"]);if(type=="date"){return date}const today=DateFormat(new Date,DateFormat.masks["date"]);if(type=="time"||notToday===true&&date==today){return DateFormat(dateUX,DateFormat.masks["time"])}return DateFormat(dateUX,DateFormat.masks["default"])}getSelected(){return this.selectable.cache}getSelectedRows(){const rows=[];$.each(this.selectable.cache,(id,row)=>{rows.push(row)});return rows}getSelectedIds(){const rows=[];$.each(this.selectable.cache,(id,row)=>{rows.push(id)});return rows}clearSelected(){$.each(this.selectable.cache,(id,col)=>this.unselect(id))}genRouteFromDataArray(route,row,value){if(value.length==0){return"---"}const span=Blx.create("span");$.each(value,(i,item)=>{if(i>0){Blx.create("span").text(", ").appendTo(span)}route=Blx.route.build(route,item);Blx.create("a").attr("href","#"+route).addClass("blx-link").setHTML(item.name).click(()=>Blx.route.to(route)).appendTo(span)});return span}updatePager(size,total){Log.debug("table.updatePager()");const from=this.pager.offset+1;const to=this.pager.offset+size>total?total:this.pager.offset+size;const t=total>0?Blx.text.get("action.display_from_to_rows",[from,to,total]):Blx.text.get("action.display_no_hits");const pagerText=Blx.create("span").addClass("blx-table-pager-text blx-table-resp-600").html(t);this.pager.container.html(pagerText);const offset=this.pager.offset,limit=this.pager.limit,icon=this.pager.icon;var firstButton,leftButton,rightButton,lastButton,right=true,left=true;if(offset===0){left=false}if(offset+limit>=total){right=false}if(left===true){firstButton=icon.btn("chevron-first").appendTo(this.pager.container);leftButton=icon.btn("chevron-left").appendTo(this.pager.container);firstButton.click(()=>{this.pager.offset=0;this.reload()});leftButton.click(()=>{this.pager.offset-=limit;if(this.pager.offset<0){this.pager.offset=0}this.reload()})}else{firstButton=icon.offBtn("chevron-first").appendTo(this.pager.container);leftButton=icon.offBtn("chevron-left").appendTo(this.pager.container)}if(right===true){rightButton=icon.btn("chevron-right").appendTo(this.pager.container);lastButton=icon.btn("chevron-last").appendTo(this.pager.container);rightButton.click(()=>{this.pager.offset+=limit;this.reload()});lastButton.click(()=>{this.pager.offset=total-limit;this.reload()})}else{rightButton=icon.offBtn("chevron-right").appendTo(this.pager.container);lastButton=icon.offBtn("chevron-last").appendTo(this.pager.container)}}deleteData(){const overlay=Blx.overlay({title:this.deletable.title,subtitle:this.deletable.subtitle,buttons:[{text:this.deletable.confirmButtonText,callback:()=>this.reallyDeleteData(),close:true}]}).create();this.selectedRowsTable(overlay.body)}reallyDeleteData(){if(this.deletable.callback){this.deletable.callback(this.getSelected());return}const data=[];const rows=[];$.each(this.getSelected(),(i,row)=>{const id=this.config.uid(row);if(this.rowsById[id]){this.rowsById[id].on.trigger("click")}delete this.selectable.cache[id];let progressText=[];$.each(this.selectable.columns,(i,col)=>{progressText.push(row[col])});progressText=progressText.join(",");rows.push(row);data.push({url:this.deletable.url||Blx.route.build(this.deletable.route,row),text:progressText,token:this.deletable.token===undefined?true:this.deletable.token})});let finishCallback;if(this.deletable.postCallback){finishCallback=()=>this.deletable.postCallback(rows)}else{finishCallback=()=>this.reload()}Blx.progress({items:data,finish:finishCallback,ignoreErrors:this.deletable.ignoreErrors||["err-600"]})}showSelectedRows(){const overlay=Blx.overlay({title:this.selectable.title}).create();overlay.addButton({text:Blx.text.get("action.clear_selection"),close:true,callback:()=>this.clearSelected()});this.selectedRowsTable(overlay.body)}selectedRowsTable(container){const gicon=Blx.icon().size("medium").cursor("pointer").coloring("dark");const table=Blx.create("table").addClass("blx-table").appendTo(container);const trHead=Blx.create("tr").appendTo(table);Blx.create("th").addClass("blx-table-th").appendTo(trHead);$.each(this.selectable.columns,(i,name)=>{Blx.create("th").addClass("blx-table-th").setHTML(this.columnsByName[name].text).appendTo(trHead)});$.each(this.selectable.cache,(x,row)=>{const id=this.config.uid(row);const tr=Blx.create("tr").addClass("blx-table-tr").appendTo(table);const icon=Blx.icon().size("medium").cursor("pointer").coloring(Blx.tableProps.selectableIconColor).span("square-x").click(()=>{this.unselect(id);tr.remove()});Blx.create("td").addClass("blx-table-td-vam").css("width","30px").html(icon).appendTo(tr);$.each(this.selectable.columns,(y,name)=>{const td=Blx.create("td").addClass("blx-table-td-vam").appendTo(tr);this.addColumnValue(row,this.columnsByName[name],td,true)})})}columnIsVisible(col){if(col.visible===false){return false}if(col.visible===true){return true}if(this.visible.enabled===true){if(this.visible.columns[col.name]===true){return true}return false}return true}columnSettings(){const table=Blx.simpleTable();const onIcon=Blx.icon().cursor("pointer").coloring(Blx.tableProps.columnSettingsActiveColor);const offIcon=Blx.icon().cursor("pointer").coloring(Blx.tableProps.columnSettingsInactiveColor);$.each(this.columns,(i,col)=>{if(col.visible!==undefined){return true}const row=table.row();row.th.text(col.text);const on=onIcon.span("square-check").hide().appendTo(row.td);const off=offIcon.span("square").hide().appendTo(row.td);if(this.visible.columns[col.name]===true){on.show()}else{off.show()}on.click(()=>{this.table.find(`[data-name='${col.name}']`).hide();delete this.visible.columns[col.name];on.hide();off.show();this.updateTableSettings()});off.click(()=>{this.table.find(`[data-name='${col.name}']`).show();this.visible.columns[col.name]=true;off.hide();on.show();this.updateTableSettings()})});Blx.overlay({title:Blx.text.get("text.table_column_settings"),body:table.table,position:"right"}).create()}updateTableSettings(){if(!this.visible.callback&&!this.visible.url){return}const columns=[];$.each(this.columns,(i,col)=>{if(col.visible!==undefined){return true}if(this.visible.columns[col.name]===true){columns.push(col.name)}});if(this.visible.callback){this.visible.callback(columns)}else{Blx.ajax.request({url:this.visible.url,data:columns,success:function(result){}})}}getVisibleColumns(){const columns=[];$.each(this.columns,(i,col)=>{if(col.visible!==undefined){return true}if(this.visible.columns[col.name]===true){columns.push(col.name)}});return columns}}Blx.table=o=>new Table(o);Blx.tableProps={selectableIconColor:"dark-gray",columnSettingsActiveColor:"gray",columnSettingsInactiveColor:"black",pagerIconColor:"white"};class TableSearch{constructor(o){this.config=Blx.utils.config(o,["container","fields","value","submitCallback","visible","coloring"],{value:[],visible:true,coloring:Blx.tableSearchProps.coloring});this.resultIcon=Blx.icon().size("medium").btnIconMargin(3).radius(false).coloring(this.config.coloring);this.fieldsByName={};$.each(this.config.fields,(i,f)=>{this.fieldsByName[f.name]=f});this.logOp=["and","or"];this.compOp={string:["=~","!~"],int:["==","!=",">",">=","<","<="],bool:["=="],date:["==","!=",">",">=","<","<="],date2x:["==","!=",">",">=","<","<="],autocomplete:["=~","!~"]};this.container=Create("div").addClass("blx-table-search-container").appendTo(this.config.container);this.form=Create("form").appendTo(this.container);Blx.create("button").attr("type","submit").hide().appendTo(this.form);this.form.on("submit",e=>{e.preventDefault();this.submit();return false});this.resultContainer=Create("div").appendTo(this.form);this.initValue()}createOverlay(){const overlay=Blx.overlay({position:"middle"}).create();const selected=Create("div").addClass("blx-table-search-selected").appendTo(overlay.body);const selection=Create("div").addClass("blx-table-search-selection").appendTo(overlay.body);return{overlay:overlay,selected:selected,selection:selection}}start(overlay){const workflow=this.createOverlay();workflow.result=Create("div").addClass("blx-table-search-result-item");workflow.field=undefined;workflow.logOp=undefined;workflow.compOp=undefined;workflow.value=undefined;this.addLogicalOperator(workflow)}hasResultItems(){if(this.resultContainer.find(".blx-table-search-result-item").length>0){return true}return false}addLogicalOperator(workflow){if(workflow.logOp===undefined){if(this.hasResultItems()){this.reqLogicalOperator(workflow);return}else{workflow.logOp="and"}}const text=Create("span").addClass("blx-table-search-result-item-logical-operator").text(Blx.text.get(`op.${workflow.logOp}`)).appendTo(workflow.result);if(this.resultContainer.find(".blx-table-search-result-item").length==0){text.hide()}const input=Create("input").attr("type","hidden").attr("name","logOp").attr("value",workflow.logOp).appendTo(workflow.result);text.click(()=>{if(input.val()=="and"){input.val("or");text.text(Blx.text.get("op.or"));this.submit()}else{input.val("and");text.text(Blx.text.get("op.and"));this.submit()}});this.addField(workflow)}reqLogicalOperator(workflow){const list=Create("ul");workflow.selection.html(list);$.each(["and","or"],(i,op)=>{Create("li").text(Blx.text.get(`op.${op}`)).appendTo(list).click(()=>{workflow.logOp=op;this.addLogicalOperator(workflow)})})}addField(workflow){if(!workflow.field){this.reqField(workflow);return}Create("span").addClass("blx-table-search-result-item-name").text(workflow.field.text).appendTo(workflow.result);Create("input").attr("type","hidden").attr("name","name").attr("value",workflow.field.name).appendTo(workflow.result);this.addComparisonOperator(workflow)}reqField(workflow){const list=Create("ul");workflow.selection.html(list);$.each(this.config.fields,(i,field)=>{Create("li").text(field.text).appendTo(list).click(()=>{workflow.field=field;this.addField(workflow)})})}addComparisonOperator(workflow){if(workflow.compOp===undefined){this.reqComparisonOperator(workflow);return}const text=Create("span").text(workflow.compOp).addClass("blx-table-search-result-item-comparison-operator").appendTo(workflow.result);const input=Create("input").attr("type","hidden").attr("name","compOp").attr("value",workflow.compOp).appendTo(workflow.result);if(this.compOp[workflow.field.type].length>1){text.click(()=>this.changeComparisonOperator(text,input,workflow.field.type))}this.addValue(workflow)}reqComparisonOperator(workflow){if(this.compOp[workflow.field.type].length==1){workflow.compOp=this.compOp[workflow.field.type][0];this.addComparisonOperator(workflow)}else{const list=Create("ul");workflow.selection.html(list);$.each(this.compOp[workflow.field.type],(i,op)=>{Create("li").text(op).appendTo(list).click(()=>{workflow.compOp=op;this.addComparisonOperator(workflow)})})}}changeComparisonOperator(text,input,type){const o=this.createOverlay();const list=Create("ul").appendTo(o.selection);$.each(this.compOp[type],(i,op)=>{Create("li").text(op).appendTo(list).click(()=>{text.text(op);input.val(op);o.overlay.close();this.submit()})})}addValue(workflow){const field=workflow.field;if(field.options){this.addOption(workflow)}else if(field.type=="int"||field.type=="string"){this.addInput(workflow)}else if(field.type=="date"||field.type=="date2x"){this.addDate(workflow)}else if(field.type=="bool"){this.addBool(workflow)}else if(field.type=="autocomplete"){this.addAutocomplete(workflow)}}addOption(workflow){if(workflow.value===undefined){this.reqOption(workflow);return}let itemName;$.each(workflow.field.options,(i,item)=>{if(item.value===workflow.value){itemName=item.name;return false}});const text=Create("span").addClass("blx-table-search-result-item-value").text(itemName).appendTo(workflow.result);const input=Create("input").attr("type","hidden").attr("name",workflow.field.type).attr("value",workflow.value).appendTo(workflow.result);text.click(()=>this.changeOption(text,input,workflow.field.options));this.addResult(workflow)}reqOption(workflow){const list=Create("ul");workflow.selection.html(list);$.each(workflow.field.options,(i,item)=>{Create("li").text(item.name).appendTo(list).click(()=>{workflow.value=item.value;this.addOption(workflow)})})}changeOption(text,input,options){const o=this.createOverlay(),list=Create("ul").appendTo(o.selection);$.each(options,(i,item)=>{Create("li").text(item.name).appendTo(list).click(()=>{text.text(item.name);input.val(item.value);o.overlay.close();this.submit()})})}addInput(workflow){const wrapper=Create("span").addClass("blx-table-search-result-item-value").appendTo(workflow.result);const input=Create("input").attr("type","text").attr("name",workflow.field.type).attr("value",workflow.value).addClass("blx-table-search-result-item-input").appendTo(wrapper);this.addResult(workflow,false);if(workflow.value===undefined){input.trigger("focus")}}addBool(workflow){if(workflow.value===undefined){this.reqBool(workflow);return}const text=Create("span").addClass("blx-table-search-result-item-value").text(Blx.text.get("bool.yesno."+workflow.value)).appendTo(workflow.result);const input=Create("input").attr("type","hidden").attr("name",workflow.field.type).attr("value",workflow.value).appendTo(workflow.result);text.click(()=>{if(input.val()=="0"){input.val(1);text.text(Blx.text.get("bool.yesno.1"))}else{input.val(0);text.text(Blx.text.get("bool.yesno.0"))}this.submit()});this.addResult(workflow)}reqBool(workflow){const list=Create("ul");workflow.selection.html(list);$.each([1,0],(i,bool)=>{Create("li").text(Blx.text.get("bool.yesno."+bool)).appendTo(list).click(()=>{workflow.value=bool;this.addBool(workflow)})})}addDate(workflow){const wrapper=Create("span").addClass("blx-table-search-result-item-value").appendTo(workflow.result);const input=Create("input").attr("type","text").attr("name",workflow.field.type).attr("value",workflow.value).addClass("blx-table-search-result-item-input").appendTo(wrapper).datetimepicker({ampm:false,timeFormat:"HH:mm:ss",dateFormat:"yy-mm-dd",stepMinute:1,onClose:()=>this.submit(),onSelect:()=>this.submit()});this.addResult(workflow,false);if(workflow.value===undefined){input.trigger("focus")}}addAutocomplete(workflow){if(workflow.value===undefined){Blx.ajax.request({url:workflow.field.url,success:result=>this._addAutocomplete(workflow,result)})}else{this._addAutocomplete(workflow)}}_addAutocomplete(workflow,result){const wrapper=Create("span").addClass("blx-table-search-result-item-value").appendTo(workflow.result);const input=Create("input").attr("type","text").attr("name",workflow.field.type).attr("value",workflow.value).addClass("blx-table-search-result-item-input").appendTo(wrapper).on("focus",()=>this.filterAutocomplete(result.data,input));if(workflow.value===undefined){this.addResult(workflow,false);this.filterAutocomplete(result.data,input)}else{this.addResult(workflow,true)}}filterAutocomplete(data,input){const o=this.createOverlay(),list=Create("ul").appendTo(o.selection);const fInput=Create("input").attr("value",input.val()).appendTo(o.selected).trigger("focus");this.updateAutocomplete(o,list,data,input,fInput);fInput.on("keyup",()=>this.updateAutocomplete(o,list,data,input,fInput))}updateAutocomplete(o,list,data,input,fInput){const rx=new RegExp(fInput.val(),"i"),keys={};list.html("");$.each(data,(i,item)=>{if(rx.test(item)){Create("li").text(item).appendTo(list).click(()=>{input.val(item);o.overlay.close();this.submit()})}})}addResult(workflow,submit=true){workflow.result.appendTo(this.resultContainer);this.resultIcon.btn("x").appendTo(workflow.result).click(()=>this.removeResult(workflow));this.stop(workflow);if(workflow.submit!==undefined){submit=workflow.submit}if(submit===true){this.submit()}}removeResult(workflow){workflow.result.remove();if(this.resultContainer.find(".blx-table-search-result-item").length>0){$(this.form.find(".blx-table-search-result-item-logical-operator")[0]).hide()}this.submit()}submit(){if(this.config.submitCallback){this.config.submitCallback()}}stop(workflow){if(workflow.overlay){workflow.overlay.close()}}getValue(){const values=[],data=this.form.serializeArray();let nextType=false;$.each(data,(i,item)=>{if(values.length==0&&item.name=="logOp"){return true}if(item.name=="name"){nextType=this.fieldsByName[item.value].type}if(item.name=="bool"||item.name=="int"){values.push(parseInt(item.value))}else if(item.name=="date2x"){values.push(new Date(item.value).getTime()/1e3)}else{values.push(item.value)}});return values}initValue(){const arr=[...this.config.value];let i=0;while(arr.length>0){const logOp=i==0?"and":arr.shift(),key=arr.shift(),compOp=arr.shift(),value=arr.shift();const workflow={result:Create("div").addClass("blx-table-search-result-item"),field:this.fieldsByName[key],logOp:logOp,compOp:compOp,value:value,submit:false};this.addLogicalOperator(workflow);i=i+1}}addFilter(logOp,key,compOp,value,submit=true){const workflow={result:Create("div").addClass("blx-table-search-result-item"),field:this.fieldsByName[key],logOp:logOp,compOp:compOp,value:value,submit:submit};this.addLogicalOperator(workflow)}}Blx.tableSearch=o=>new TableSearch(o);Blx.tableSearchProps={coloring:"white"};class Text{constructor(){this.text={};this.lang="en";this.dateFormat={en:{dayNames:["So","Mo","Di","Mi","Do","Fr","Sa","Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],monthNames:["Jan","Feb","Mär","Apr","Mai","Jun","Jul","Aug","Sep","Okt","Nov","Dez","Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"]},de:{dayNames:["Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],monthNames:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec","January","February","March","April","May","June","July","August","September","October","November","December"]},it:{dayNames:["Dom","Lun","Mar","Mer","Gio","Ven","Sab","Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"],monthNames:["Gen","Feb","Mar","Apr","Mag","Giu","Lug","Ago","Set","Ott","Nov","Dic","Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"]}}}loremIpsum(){return"Lorem ipsum dolor sit amet, consetetur sadipscing elitr, "+"sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam "+"erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et "+"ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem "+"ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing "+"elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna "+"aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo "+"dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus "+"est Lorem ipsum dolor sit amet."}setLang(lang){this.lang=lang}setText(lang,key,value){if(!this.text[lang]){this.text[lang]={}}this.text[lang][key]=value}exist(key){const text=this.text[this.lang];if(text[key]===undefined){return false}return true}get(key,value,wrap){let text=this.text[this.lang][key];if(typeof text=="undefined"){Blx.throwError({message:`Blx.text.get(${key}) does not exists`});return""}if(typeof value=="undefined"){return text}if(wrap===undefined){if(typeof value!="object"){return text.replace(/%s/,value)}$.each(value,function(index,string){text=text.replace(/%s/,string)})}else{if(typeof value!="object"){value=[value]}const parts=text.split(/(%s)/);text=Create("span");$.each(parts,function(i,t){if(t=="%s"){Blx.create("span").addClass("blx-text-cit").setHTML(value.shift()).appendTo(text)}else if(t!=""){Blx.create("span").setHTML(t).appendTo(text)}})}return text}}Blx.text=new Text;Blx.text.text={de:{"action.abort":"Abbrechen","action.acknowledge":"Bestätigen","action.add":"Hinzufügen","action.add_filter":"Filtern hinzufügen","action.cancel":"Abbrechen","action.clear":"Zurücksetzen","action.clear_acknowledgement":"Bestätigung entfernen","action.clear_selection":"Selektierung entfernen","action.clone":"Klonen","action.close":"Schließen","action.configure":"Konfigurieren","action.create":"Erstellen","action.delete":"Löschen","action.disable":"Ausschalten","action.display_from_to_rows":"%s-%s von %s Treffern","action.display_no_hits":"Keine Treffer","action.edit":"Editieren","action.enable":"Einschalten","action.extsearch":"Erweiterte Suche","action.filter":"Filtern","action.generate":"Generieren","action.generate_string":"String generieren","action.genstr":"Zeichenkette generieren","action.help":"Hilfe","action.list":"Auflisten","action.login":"Einloggen","action.logout":"Ausloggen","action.move_box":"Bewege die Box","action.no_abort":"Nein, abbrechen!","action.operate_as":"Operiere als","action.overview":"Übersicht","action.processing_of":"Verarbeitung von: %s","action.quicksearch":"Schnellsuche","action.redirect":"Umleiten","action.refresh":"Aktualisieren","action.reload":"Reload","action.remove":"Entfernen","action.replace":"Ersetzen","action.resize":"Größe ändern","action.save":"Speichern","action.schedule":"Planen","action.search":"Suchen","action.select":"Auswählen","action.settings":"Einstellungen","action.show_selected_objects":"Ausgewählte Objekte anzeigen","action.submit":"Bestätigen","action.unselect":"Abwählen","action.unselect_all":"Alles abwählen","action.update":"Aktualisieren","action.view":"Einsehen","action.yes_delete":"Ja, löschen!","action.yes_remove":"Ja, entfernen!","bool.enabled.0":"Ausgeschaltet","bool.enabled.1":"Eingeschaltet","bool.yesno.0":"Nein","bool.yesno.1":"Ja","err-301":"Moved Permanently","err-302":"Found","err-404":"Not Found","err-500":"Ein unerwarteter Fehler ist aufgetreten! Bitten kontaktieren Sie den Administrator!","err-600":"Das angeforderte Objekt existiert nicht!","err-601":"Die angeforderten Objekte existieren nicht!","err-602":"Duplikatsfehler: das Objekt existiert bereits!","err-603":"Bitte wählen Sie mindestens ein Objekt aus!","err-604":"Die Aktion ist fehlgeschlagen!","err-605":"Nicht genügend Berechtigungen!","err-606":"Es ist nicht möglich die Anfrage zu parsen!","err-607":"Das Objekt konnte nicht aktualisiert werden!","err-608":"Das Objekt konnte nicht erstellt werden!","err-609":"Das Objekt existiert bereits:","err-610":"Bitte füllen Sie die Felder korrekt aus!","err-611":"Es sind keine Daten verfügbar.","err-612":"Ungültige Daten!","err-613":"Der Benutzer kann nicht gelöscht werden!","err-614":"Das Objekt kann nicht gelöscht werden!","err-615":"Der Admin-Benutzer kann nicht gelöscht werden!","err-616":"Der eigene Account kann nicht gelöscht werden!","err-617":"Das Object existiert bereits","err-618":"Der Name ist bereits vergeben","err-619":"Die E-Mail ist bereits vergeben","err-620":"Die Daten sind unvollständig","err-621":"Der Prozess ist auf einen Timeout gelaufen","err-622":"Ungültige Zeitangaben","err-623":"Der Zeitraum ist zu groß","err-630":"Ihre Session ist abgelaufen. Bitte loggen Sie sich mit Benutzer und Passwort ein!","err-631":"Der Login ist fehlgeschlagen!","err-632":"Der Account ist gesperrt!","err-636":"Der Code ist ungültig!","err-637":"Bitte geben Sie Ihren 2-Faktor-Auth Schlüssel ein!","err-638":"Der Schlüssel ist ungültig!","err-640":"Nicht authorisierter Zugriff!","err-650":"Der Session-Token ist abgelaufen!","err-651":"Diese Aktion erfordert ein Session-Token!","err-652":"CSRF Token ist abgelaufen!","err-660":"Bitte ändern Sie Ihr Passwort!","err-661":"Das Passwort ist ungültig!","err-662":"Das Passwort ist zu kurz!","err-663":"Das Passwort ist zu lang!","err-664":"Die Passwörter stimmen nicht überein!","err-665":"Das neue und alte Passwort dürfen nicht übereinstimmen!","err-666":"Das Passwort entspricht nicht den Anforderungen!","err-699":"Zugriff verweigert!","err-700":"Der Parameter ist Pflicht","err-702":"Der Wert ist zu klein","err-703":"Der Wert ist zu hoch","err-704":"Der Wert ist zu kurz","err-705":"Der Wert ist zu lang","err-706":"Nicht genügend Elemente","err-707":"Zuviele Elemente","err-710":"Der Wert ist ungültig","err-711":"Einer oder mehrere Werte sind ungültig","err-712":"Der Datentyp ist ungültig","err-713":"Das Objekt ist zu klein","err-714":"Das Objekt überschreitet die maximale Größe","err-715":"Der Parameter existiert nicht","err-716":"Ein leeres Objekt ist nicht erlaubt","err-717":"Der Wert muss gesetzt werden","err-718":"Es wird eine Liste von Werten erwartet","err-719":"Der Parameter darf nicht mit anderen Parametern gemixt werden","err-720":"Die Datenstruktur ist fehlerhaft","err-721":"Das Objekt kann nicht editiert werden","form.create_failed":"Die Erstellung war nicht erfolgreich!","form.create_success":"Die Erstellung war erfolgreich!","form.required_fields":"Pflichtfelder sind mit einem Stern markiert (*)","form.select_an_option":"-- Wähle eine Option --","form.submit_failed":"Das Formular wurde nicht erfolgreich übermittelt!","form.submit_success":"Das Formular wurde erfolgreich übermittelt!","form.update_failed":"Das Update war nicht erfolgreich!","form.update_success":"Das Update war erfolgreich!","lang.note_select_language":"Bitte beachten Sie das das Webinterface nach der Auswahl neu geladen wird und Sie eventuell zur Startseite umgeleitet werden!","lang.select_language":"Wähle deine bevorzugte Sprache aus","op.and":"und","op.or":"oder","table.search_syntax.example":"a == b or a == c <br>a like b and c > 60 <br>Boolsche Werte können nur 0 oder 1 sein.","table.search_syntax.example_title":"Beispiele zur Syntax der Suche","table.search_syntax.operators":"Gleich: a == b <br>Nicht gleich: a != b <br>Kleiner als: a < b <br>Kleiner oder gleich: a <= b <br>Größer als: a > b <br>Größer oder gleich: a >= b <br>Wie: a =~ b, a like b","table.search_syntax.operators_title":"Operatoren","text.Background_color":"Hintergrundfarbe","text.Number_of_selected_rows":"Anzahl selektierter Zeilen","text.Overwrite_value":"Wert überschreiben","text.Selected_rows":"Selektierte Zeilen","text.Text_color":"Textfarbe","text.allowed_characters":"Erlaubte Zeichen: %s","text.column_name":"Spaltenname","text.default":"Standardwert: %s","text.max_search_terms":"Maximal erlaubte Suchbegriffe: %s","text.maxlength":"Maximale Länge: %s","text.maxvalue":"Maximaler Wert: %s","text.meta_data":"Metadaten","text.minlength":"Minimale Länge: %s","text.minvalue":"Minimaler Wert: %s","text.range_length":"Länge: %s - %s","text.range_value":"Bereich: %s - %s","text.really_delete":"Soll das folgende Objekt wirklich gelöscht werden?","text.really_deletes":"Soll das folgende Objekte wirklich gelöscht werden?","text.really_remove":"Soll das folgende Objekt wirklich entfernt werden?","text.really_removes":"Soll das folgende Objekte wirklich entfernt werden?","text.search_string":"Suchstring","text.table_column_settings":"Einstellung der Tabellenspalten","word.Absolute":"Absolut","word.Action":"Aktion","word.Active":"Aktiv","word.All":"Alle","word.Chart":"Chart","word.City":"Stadt","word.Closed":"Geschlossen","word.Comment":"Kommentar","word.Config":"Konfiguration","word.Continent":"Kontinent","word.Coordinates":"Koordinaten","word.Country":"Land","word.Date":"Datum","word.Day":"Tag","word.Days":"Tage","word.Default":"Standard","word.Description":"Beschreibung","word.Disabled":"Deaktiviert","word.Enabled":"Aktiviert","word.Filter":"Filter","word.From":"Von","word.Horizontal":"Horizontal","word.Hostname":"Hostname","word.Hosts":"Hosts","word.Hours":"Stunden","word.ID":"ID","word.IP_address":"IP Adresse","word.Inactive":"Inaktiv","word.Information":"Information","word.Interval":"Intervall","word.Language":"Sprache","word.Last":"Letzte","word.Loading":"Lädt","word.Loading_dots":"Lädt...","word.Message":"Nachricht","word.Minutes":"Minuten","word.Month":"Monat","word.Months":"Monate","word.Name":"Name","word.Network_port":"Port","word.No":"Nein","word.Open":"Offen","word.Options":"Optionen","word.Password":"Passwort","word.Pos":"Pos","word.Preset":"Voreinstellung","word.Product":"Produkt","word.Refresh":"Aktualisierung","word.Relative":"Relativ","word.Search":"Suche","word.Search_dots":"Suche...","word.Seconds":"Sekunden","word.Selected":"Ausgewählt","word.Services":"Services","word.Settings":"Einstellungen","word.Step":"%s. Schritt","word.Success":"Erfolgreich","word.Time":"Zeit","word.Timezone":"Zeitzone","word.Title":"Titel","word.To":"Bis","word.Type":"Typ","word.User":"Benutzer","word.Username":"Benutzername","word.Value":"Wert","word.Variables":"Variables","word.Vertical":"Vertikal","word.Yes":"Ja","word.active":"aktiv","word.day":"Tag","word.days":"Tage","word.debug":"Debug","word.disabled":"deaktiviert","word.enabled":"aktiviert","word.hour":"Stunde","word.hours":"Stunden","word.inactive":"inaktiv","word.max":"max","word.minute":"Minute","word.minutes":"Minuten","word.month":"Monat","word.months":"Monate","word.no":"nein","word.resize":"Größe anpassen","word.second":"Sekunde","word.seconds":"Sekunden","word.yes":"ja"},en:{"action.abort":"Abort","action.acknowledge":"Acknowledge","action.add":"Add","action.add_filter":"Add filter","action.cancel":"Cancel","action.clear":"Clear","action.clear_acknowledgement":"Clear acknowledgement","action.clear_selection":"Clear selection","action.clone":"Clone","action.close":"Close","action.configure":"Configure","action.create":"Create","action.delete":"Delete","action.disable":"Disable","action.display_from_to_rows":"%s-%s of %s hits","action.display_no_hits":"No hits","action.edit":"Edit","action.enable":"Enable","action.extsearch":"Extended search","action.filter":"Filter","action.generate":"Generate","action.generate_string":"Generate a random string","action.genstr":"Generate string","action.help":"Help","action.list":"List","action.login":"Login","action.logout":"Logout","action.move_box":"Move the box","action.no_abort":"No, abort!","action.operate_as":"Operate as","action.overview":"Overview","action.processing_of":"Processing: %s","action.quicksearch":"Quick search","action.redirect":"Redirect","action.refresh":"Refresh","action.reload":"Reload","action.remove":"Remove","action.replace":"Replace","action.resize":"Resize","action.save":"Save","action.schedule":"Schedule","action.search":"Search","action.select":"Select","action.settings":"Settings","action.show_selected_objects":"Show selected objects","action.submit":"Submit","action.unselect":"Unselect","action.unselect_all":"Unselect all","action.update":"Update","action.view":"View","action.yes_delete":"Yes, delete!","action.yes_remove":"Yes, remove!","bool.enabled.0":"Disabled","bool.enabled.1":"Enabled","bool.yesno.0":"No","bool.yesno.1":"Yes","err-301":"Moved Permanently","err-302":"Found","err-404":"Not Found","err-500":"An unexpected error occured! Please contact the administrator!","err-600":"The object you requested does not exist!","err-601":"The objects you requested does not exist!","err-602":"Duplication error: this object already exists!","err-603":"Please select at least one object!","err-604":"The action failed!","err-605":"Not enough privileges!","err-606":"Unable to parse request!","err-607":"The object cannot be updated!","err-608":"The object cannot be created!","err-609":"The object already exists:","err-610":"Please fill in the fields correctly!","err-611":"No data available.","err-612":"Invalid data!","err-613":"The user cannot be deleted!","err-614":"The object cannot be deleted!","err-615":"The admin user cannot be deleted!","err-616":"You cannot delete your own account!","err-617":"This object already exists","err-618":"This name is already in use","err-619":"This E-Mail is already in use","err-620":"Missing data","err-621":"The process runs on a timeout","err-622":"Invalid time information","err-623":"The time period is too long","err-630":"Your session is expired. Please login with your username and password!","err-631":"Bad login!","err-632":"Account is locked!","err-636":"The code is not valid!","err-637":"Please enter your 2-factor-auth key!","err-638":"The key is not valid!","err-640":"Unauthorized access!","err-650":"Session token is expired!","err-651":"This action requires a token!","err-652":"CSRF token expired!","err-660":"Please change your password!","err-661":"Incorrect password!","err-662":"The new password is too short!","err-663":"The new password is too long!","err-664":"The passwords doesn't match!","err-665":"The new and the old password cannot be the same!","err-666":"The password does not meet the requirements!","err-699":"Permission denied!","err-700":"The parameter is mandatory","err-702":"The value too low","err-703":"The value too high","err-704":"The value is too short","err-705":"The value is too long","err-706":"Not enough elements","err-707":"Too much elements","err-710":"The value is invalid","err-711":"One or more values are invalid","err-712":"Invalid data type","err-713":"The object size is too short","err-714":"The object exceeded maximum allowed size","err-715":"The parameter does not exists","err-716":"An empty object is not allowed","err-717":"The value is missing","err-718":"Expecting a list of values","err-719":"The parameter may not be mixed with other parameters","err-720":"The data structure is faulty","err-721":"The object cannot be edited","form.create_failed":"The creation was not successful!","form.create_success":"The creation was successful!","form.required_fields":"Mandatory fields are marked with an asterisk (*)","form.select_an_option":"-- Select an option --","form.submit_failed":"The form was not successfully submitted!","form.submit_success":"The form was successfully submitted!","form.update_failed":"The update was not successful!","form.update_success":"The update was successful!","lang.note_select_language":"Please note that the web interface is reloaded after the language were selected and maybe you will be redirected to the start site!","lang.select_language":"Select your preferred language","op.and":"and","op.or":"or","table.search_syntax.example":"a == b or a == c <br>a like b and c > 60 <br>Boolean values can only be 0 or 1.","table.search_syntax.example_title":"Search syntax examples:","table.search_syntax.operators":"Equals: a == b <br>Not Equals: a != b <br>Less than: a < b <br>Less than or equal to: a <= b <br>Greater than: a > b <br>Greater than or equal to: a >= b <br>Like: a =~ b, a like b","table.search_syntax.operators_title":"Operators","text.Background_color":"Background color","text.Number_of_selected_rows":"Number of selected rows","text.Overwrite_value":"Overwrite value","text.Selected_rows":"Selected rows","text.Text_color":"Text color","text.allowed_characters":"Allowed characters: %s","text.column_name":"Column name","text.default":"Default value: %s","text.max_search_terms":"Max allowed search terms: %s","text.maxlength":"Max length: %s","text.maxvalue":"Max value: %s","text.meta_data":"Meta data","text.minlength":"Min length: %s","text.minvalue":"Min value: %s","text.range_length":"Length: %s - %s","text.range_value":"Range: %s - %s","text.really_delete":"Do you really want to delete the following object?","text.really_deletes":"Do you really want to delete the following objects?","text.really_remove":"Do you really want to remove the following object?","text.really_removes":"Do you really want to removes the following objects?","text.search_string":"Search string","text.table_column_settings":"Table column settings","word.Absolute":"Absolute","word.Action":"Action","word.Active":"Active","word.All":"All","word.Chart":"Chart","word.City":"City","word.Closed":"Closed","word.Comment":"Comment","word.Config":"Configuration","word.Continent":"Continent","word.Coordinates":"Coordinates","word.Country":"Country","word.Date":"Date","word.Day":"Day","word.Days":"Days","word.Default":"Default","word.Description":"Description","word.Disabled":"Disabled","word.Enabled":"Enabled","word.Filter":"Filter","word.From":"From","word.Horizontal":"Horizontal","word.Hostname":"Hostname","word.Hosts":"Hosts","word.Hours":"Hours","word.ID":"ID","word.IP_address":"IP address","word.Inactive":"Inactive","word.Information":"Information","word.Interval":"Interval","word.Language":"Language","word.Last":"Last","word.Loading":"Loading","word.Loading_dots":"Loading...","word.Message":"Message","word.Minutes":"Minutes","word.Month":"Month","word.Months":"Months","word.Name":"Name","word.Network_port":"Port","word.No":"No","word.Open":"Open","word.Options":"Options","word.Password":"Password","word.Pos":"Pos","word.Preset":"Preset","word.Product":"Product","word.Refresh":"Refresh","word.Relative":"Relative","word.Search":"Search","word.Search_dots":"Search...","word.Seconds":"Seconds","word.Selected":"Selected","word.Services":"Services","word.Settings":"Settings","word.Step":"%s. Step","word.Success":"Successful","word.Time":"Time","word.Timezone":"Timezone","word.Title":"Title","word.To":"To","word.Type":"Type","word.User":"User","word.Username":"Username","word.Value":"Value","word.Variables":"Variables","word.Vertical":"Vertical","word.Yes":"Yes","word.active":"active","word.day":"day","word.days":"days","word.debug":"Debug","word.disabled":"disabled","word.enabled":"enabled","word.hour":"hour","word.hours":"hours","word.inactive":"inactive","word.max":"max","word.minute":"minute","word.minutes":"minutes","word.month":"month","word.months":"months","word.no":"no","word.resize":"Resize","word.second":"second","word.seconds":"seconds","word.yes":"yes"}};function Timezones(){return[{value:"Africa/Abidjan",name:"Africa/Abidjan"},{value:"Africa/Accra",name:"Africa/Accra"},{value:"Africa/Addis_Ababa",name:"Africa/Addis Ababa"},{value:"Africa/Algiers",name:"Africa/Algiers"},{value:"Africa/Asmara",name:"Africa/Asmara"},{value:"Africa/Bamako",name:"Africa/Bamako"},{value:"Africa/Bangui",name:"Africa/Bangui"},{name:"Africa/Banjul",value:"Africa/Banjul"},{name:"Africa/Bissau",value:"Africa/Bissau"},{value:"Africa/Blantyre",name:"Africa/Blantyre"},{name:"Africa/Brazzaville",value:"Africa/Brazzaville"},{value:"Africa/Bujumbura",name:"Africa/Bujumbura"},{name:"Africa/Cairo",value:"Africa/Cairo"},{value:"Africa/Casablanca",name:"Africa/Casablanca"},{name:"Africa/Ceuta",value:"Africa/Ceuta"},{value:"Africa/Conakry",name:"Africa/Conakry"},{value:"Africa/Dakar",name:"Africa/Dakar"},{value:"Africa/Dar_es_Salaam",name:"Africa/Dar es Salaam"},{name:"Africa/Djibouti",value:"Africa/Djibouti"},{value:"Africa/Douala",name:"Africa/Douala"},{value:"Africa/El_Aaiun",name:"Africa/El Aaiun"},{value:"Africa/Freetown",name:"Africa/Freetown"},{value:"Africa/Gaborone",name:"Africa/Gaborone"},{name:"Africa/Harare",value:"Africa/Harare"},{value:"Africa/Johannesburg",name:"Africa/Johannesburg"},{name:"Africa/Kampala",value:"Africa/Kampala"},{value:"Africa/Khartoum",name:"Africa/Khartoum"},{value:"Africa/Kigali",name:"Africa/Kigali"},{value:"Africa/Kinshasa",name:"Africa/Kinshasa"},{value:"Africa/Lagos",name:"Africa/Lagos"},{value:"Africa/Libreville",name:"Africa/Libreville"},{value:"Africa/Lome",name:"Africa/Lome"},{name:"Africa/Luanda",value:"Africa/Luanda"},{name:"Africa/Lubumbashi",value:"Africa/Lubumbashi"},{name:"Africa/Lusaka",value:"Africa/Lusaka"},{name:"Africa/Malabo",value:"Africa/Malabo"},{value:"Africa/Maputo",name:"Africa/Maputo"},{value:"Africa/Maseru",name:"Africa/Maseru"},{value:"Africa/Mbabane",name:"Africa/Mbabane"},{value:"Africa/Mogadishu",name:"Africa/Mogadishu"},{name:"Africa/Monrovia",value:"Africa/Monrovia"},{value:"Africa/Nairobi",name:"Africa/Nairobi"},{value:"Africa/Ndjamena",name:"Africa/Ndjamena"},{name:"Africa/Niamey",value:"Africa/Niamey"},{value:"Africa/Nouakchott",name:"Africa/Nouakchott"},{name:"Africa/Ouagadougou",value:"Africa/Ouagadougou"},{name:"Africa/Porto-Novo",value:"Africa/Porto-Novo"},{name:"Africa/Sao Tome",value:"Africa/Sao_Tome"},{name:"Africa/Tripoli",value:"Africa/Tripoli"},{value:"Africa/Tunis",name:"Africa/Tunis"},{name:"Africa/Windhoek",value:"Africa/Windhoek"},{name:"America/Adak",value:"America/Adak"},{name:"America/Anchorage",value:"America/Anchorage"},{name:"America/Anguilla",value:"America/Anguilla"},{value:"America/Antigua",name:"America/Antigua"},{name:"America/Araguaina",value:"America/Araguaina"},{value:"America/Argentina/Buenos_Aires",name:"America/Argentina/Buenos Aires"},{value:"America/Argentina/Catamarca",name:"America/Argentina/Catamarca"},{name:"America/Argentina/Cordoba",value:"America/Argentina/Cordoba"},{value:"America/Argentina/Jujuy",name:"America/Argentina/Jujuy"},{value:"America/Argentina/La_Rioja",name:"America/Argentina/La Rioja"},{name:"America/Argentina/Mendoza",value:"America/Argentina/Mendoza"},{name:"America/Argentina/Rio Gallegos",value:"America/Argentina/Rio_Gallegos"},{name:"America/Argentina/Salta",value:"America/Argentina/Salta"},{name:"America/Argentina/San Juan",value:"America/Argentina/San_Juan"},{value:"America/Argentina/San_Luis",name:"America/Argentina/San Luis"},{value:"America/Argentina/Tucuman",name:"America/Argentina/Tucuman"},{name:"America/Argentina/Ushuaia",value:"America/Argentina/Ushuaia"},{value:"America/Aruba",name:"America/Aruba"},{value:"America/Asuncion",name:"America/Asuncion"},{value:"America/Atikokan",name:"America/Atikokan"},{value:"America/Bahia",name:"America/Bahia"},{value:"America/Bahia_Banderas",name:"America/Bahia Banderas"},{name:"America/Barbados",value:"America/Barbados"},{name:"America/Belem",value:"America/Belem"},{value:"America/Belize",name:"America/Belize"},{value:"America/Blanc-Sablon",name:"America/Blanc-Sablon"},{name:"America/Boa Vista",value:"America/Boa_Vista"},{value:"America/Bogota",name:"America/Bogota"},{name:"America/Boise",value:"America/Boise"},{name:"America/Cambridge Bay",value:"America/Cambridge_Bay"},{value:"America/Campo_Grande",name:"America/Campo Grande"},{name:"America/Cancun",value:"America/Cancun"},{value:"America/Caracas",name:"America/Caracas"},{name:"America/Cayenne",value:"America/Cayenne"},{value:"America/Cayman",name:"America/Cayman"},{name:"America/Chicago",value:"America/Chicago"},{name:"America/Chihuahua",value:"America/Chihuahua"},{name:"America/Costa Rica",value:"America/Costa_Rica"},{name:"America/Cuiaba",value:"America/Cuiaba"},{value:"America/Curacao",name:"America/Curacao"},{name:"America/Danmarkshavn",value:"America/Danmarkshavn"},{value:"America/Dawson",name:"America/Dawson"},{value:"America/Dawson_Creek",name:"America/Dawson Creek"},{name:"America/Denver",value:"America/Denver"},{name:"America/Detroit",value:"America/Detroit"},{value:"America/Dominica",name:"America/Dominica"},{name:"America/Edmonton",value:"America/Edmonton"},{value:"America/Eirunepe",name:"America/Eirunepe"},{value:"America/El_Salvador",name:"America/El Salvador"},{name:"America/Fortaleza",value:"America/Fortaleza"},{value:"America/Glace_Bay",name:"America/Glace Bay"},{name:"America/Godthab",value:"America/Godthab"},{value:"America/Goose_Bay",name:"America/Goose Bay"},{value:"America/Grand_Turk",name:"America/Grand Turk"},{name:"America/Grenada",value:"America/Grenada"},{name:"America/Guadeloupe",value:"America/Guadeloupe"},{name:"America/Guatemala",value:"America/Guatemala"},{value:"America/Guayaquil",name:"America/Guayaquil"},{value:"America/Guyana",name:"America/Guyana"},{name:"America/Halifax",value:"America/Halifax"},{value:"America/Havana",name:"America/Havana"},{value:"America/Hermosillo",name:"America/Hermosillo"},{name:"America/Indiana/Indianapolis",value:"America/Indiana/Indianapolis"},{name:"America/Indiana/Knox",value:"America/Indiana/Knox"},{value:"America/Indiana/Marengo",name:"America/Indiana/Marengo"},{value:"America/Indiana/Petersburg",name:"America/Indiana/Petersburg"},{value:"America/Indiana/Tell_City",name:"America/Indiana/Tell City"},{value:"America/Indiana/Vevay",name:"America/Indiana/Vevay"},{name:"America/Indiana/Vincennes",value:"America/Indiana/Vincennes"},{name:"America/Indiana/Winamac",value:"America/Indiana/Winamac"},{name:"America/Inuvik",value:"America/Inuvik"},{name:"America/Iqaluit",value:"America/Iqaluit"},{name:"America/Jamaica",value:"America/Jamaica"},{value:"America/Juneau",name:"America/Juneau"},{value:"America/Kentucky/Louisville",name:"America/Kentucky/Louisville"},{value:"America/Kentucky/Monticello",name:"America/Kentucky/Monticello"},{name:"America/Kralendijk",value:"America/Kralendijk"},{value:"America/La_Paz",name:"America/La Paz"},{name:"America/Lima",value:"America/Lima"},{name:"America/Los Angeles",value:"America/Los_Angeles"},{name:"America/Lower Princes",value:"America/Lower_Princes"},{name:"America/Maceio",value:"America/Maceio"},{value:"America/Managua",name:"America/Managua"},{name:"America/Manaus",value:"America/Manaus"},{value:"America/Marigot",name:"America/Marigot"},{value:"America/Martinique",name:"America/Martinique"},{name:"America/Matamoros",value:"America/Matamoros"},{name:"America/Mazatlan",value:"America/Mazatlan"},{name:"America/Menominee",value:"America/Menominee"},{value:"America/Merida",name:"America/Merida"},{name:"America/Metlakatla",value:"America/Metlakatla"},{name:"America/Mexico City",value:"America/Mexico_City"},{value:"America/Miquelon",name:"America/Miquelon"},{name:"America/Moncton",value:"America/Moncton"},{value:"America/Monterrey",name:"America/Monterrey"},{value:"America/Montevideo",name:"America/Montevideo"},{value:"America/Montreal",name:"America/Montreal"},{name:"America/Montserrat",value:"America/Montserrat"},{name:"America/Nassau",value:"America/Nassau"},{value:"America/New_York",name:"America/New York"},{name:"America/Nipigon",value:"America/Nipigon"},{name:"America/Nome",value:"America/Nome"},{value:"America/Noronha",name:"America/Noronha"},{value:"America/North_Dakota/Beulah",name:"America/North Dakota/Beulah"},{name:"America/North Dakota/Center",value:"America/North_Dakota/Center"},{value:"America/North_Dakota/New_Salem",name:"America/North Dakota/New Salem"},{value:"America/Ojinaga",name:"America/Ojinaga"},{name:"America/Panama",value:"America/Panama"},{value:"America/Pangnirtung",name:"America/Pangnirtung"},{name:"America/Paramaribo",value:"America/Paramaribo"},{value:"America/Phoenix",name:"America/Phoenix"},{name:"America/Port-au-Prince",value:"America/Port-au-Prince"},{value:"America/Port_of_Spain",name:"America/Port of Spain"},{value:"America/Porto_Velho",name:"America/Porto Velho"},{value:"America/Puerto_Rico",name:"America/Puerto Rico"},{value:"America/Rainy_River",name:"America/Rainy River"},{name:"America/Rankin Inlet",value:"America/Rankin_Inlet"},{value:"America/Recife",name:"America/Recife"},{name:"America/Regina",value:"America/Regina"},{value:"America/Resolute",name:"America/Resolute"},{name:"America/Rio Branco",value:"America/Rio_Branco"},{name:"America/Santa Isabel",value:"America/Santa_Isabel"},{value:"America/Santarem",name:"America/Santarem"},{value:"America/Santiago",name:"America/Santiago"},{value:"America/Santo_Domingo",name:"America/Santo Domingo"},{name:"America/Sao Paulo",value:"America/Sao_Paulo"},{name:"America/Scoresbysund",value:"America/Scoresbysund"},{name:"America/Shiprock",value:"America/Shiprock"},{name:"America/Sitka",value:"America/Sitka"},{name:"America/St Barthelemy",value:"America/St_Barthelemy"},{name:"America/St Johns",value:"America/St_Johns"},{value:"America/St_Kitts",name:"America/St Kitts"},{value:"America/St_Lucia",name:"America/St Lucia"},{name:"America/St Thomas",value:"America/St_Thomas"},{name:"America/St Vincent",value:"America/St_Vincent"},{name:"America/Swift Current",value:"America/Swift_Current"},{name:"America/Tegucigalpa",value:"America/Tegucigalpa"},{name:"America/Thule",value:"America/Thule"},{name:"America/Thunder Bay",value:"America/Thunder_Bay"},{value:"America/Tijuana",name:"America/Tijuana"},{name:"America/Toronto",value:"America/Toronto"},{name:"America/Tortola",value:"America/Tortola"},{value:"America/Vancouver",name:"America/Vancouver"},{value:"America/Whitehorse",name:"America/Whitehorse"},{name:"America/Winnipeg",value:"America/Winnipeg"},{name:"America/Yakutat",value:"America/Yakutat"},{value:"America/Yellowknife",name:"America/Yellowknife"},{value:"Antarctica/Casey",name:"Antarctica/Casey"},{name:"Antarctica/Davis",value:"Antarctica/Davis"},{value:"Antarctica/DumontDUrville",name:"Antarctica/DumontDUrville"},{value:"Antarctica/Macquarie",name:"Antarctica/Macquarie"},{value:"Antarctica/Mawson",name:"Antarctica/Mawson"},{value:"Antarctica/McMurdo",name:"Antarctica/McMurdo"},{value:"Antarctica/Palmer",name:"Antarctica/Palmer"},{name:"Antarctica/Rothera",value:"Antarctica/Rothera"},{value:"Antarctica/South_Pole",name:"Antarctica/South Pole"},{name:"Antarctica/Syowa",value:"Antarctica/Syowa"},{value:"Antarctica/Vostok",name:"Antarctica/Vostok"},{name:"Arctic/Longyearbyen",value:"Arctic/Longyearbyen"},{name:"Asia/Aden",value:"Asia/Aden"},{name:"Asia/Almaty",value:"Asia/Almaty"},{value:"Asia/Amman",name:"Asia/Amman"},{value:"Asia/Anadyr",name:"Asia/Anadyr"},{value:"Asia/Aqtau",name:"Asia/Aqtau"},{value:"Asia/Aqtobe",name:"Asia/Aqtobe"},{value:"Asia/Ashgabat",name:"Asia/Ashgabat"},{name:"Asia/Baghdad",value:"Asia/Baghdad"},{value:"Asia/Bahrain",name:"Asia/Bahrain"},{value:"Asia/Baku",name:"Asia/Baku"},{value:"Asia/Bangkok",name:"Asia/Bangkok"},{value:"Asia/Beirut",name:"Asia/Beirut"},{value:"Asia/Bishkek",name:"Asia/Bishkek"},{value:"Asia/Brunei",name:"Asia/Brunei"},{name:"Asia/Choibalsan",value:"Asia/Choibalsan"},{name:"Asia/Chongqing",value:"Asia/Chongqing"},{name:"Asia/Colombo",value:"Asia/Colombo"},{value:"Asia/Damascus",name:"Asia/Damascus"},{value:"Asia/Dhaka",name:"Asia/Dhaka"},{value:"Asia/Dili",name:"Asia/Dili"},{value:"Asia/Dubai",name:"Asia/Dubai"},{value:"Asia/Dushanbe",name:"Asia/Dushanbe"},{value:"Asia/Gaza",name:"Asia/Gaza"},{value:"Asia/Harbin",name:"Asia/Harbin"},{name:"Asia/Ho Chi Minh",value:"Asia/Ho_Chi_Minh"},{name:"Asia/Hong Kong",value:"Asia/Hong_Kong"},{value:"Asia/Hovd",name:"Asia/Hovd"},{name:"Asia/Irkutsk",value:"Asia/Irkutsk"},{value:"Asia/Jakarta",name:"Asia/Jakarta"},{name:"Asia/Jayapura",value:"Asia/Jayapura"},{value:"Asia/Jerusalem",name:"Asia/Jerusalem"},{value:"Asia/Kabul",name:"Asia/Kabul"},{name:"Asia/Kamchatka",value:"Asia/Kamchatka"},{value:"Asia/Karachi",name:"Asia/Karachi"},{name:"Asia/Kashgar",value:"Asia/Kashgar"},{name:"Asia/Kathmandu",value:"Asia/Kathmandu"},{name:"Asia/Kolkata",value:"Asia/Kolkata"},{value:"Asia/Krasnoyarsk",name:"Asia/Krasnoyarsk"},{name:"Asia/Kuala Lumpur",value:"Asia/Kuala_Lumpur"},{name:"Asia/Kuching",value:"Asia/Kuching"},{value:"Asia/Kuwait",name:"Asia/Kuwait"},{value:"Asia/Macau",name:"Asia/Macau"},{name:"Asia/Magadan",value:"Asia/Magadan"},{value:"Asia/Makassar",name:"Asia/Makassar"},{value:"Asia/Manila",name:"Asia/Manila"},{name:"Asia/Muscat",value:"Asia/Muscat"},{name:"Asia/Nicosia",value:"Asia/Nicosia"},{value:"Asia/Novokuznetsk",name:"Asia/Novokuznetsk"},{value:"Asia/Novosibirsk",name:"Asia/Novosibirsk"},{value:"Asia/Omsk",name:"Asia/Omsk"},{name:"Asia/Oral",value:"Asia/Oral"},{name:"Asia/Phnom Penh",value:"Asia/Phnom_Penh"},{name:"Asia/Pontianak",value:"Asia/Pontianak"},{value:"Asia/Pyongyang",name:"Asia/Pyongyang"},{name:"Asia/Qatar",value:"Asia/Qatar"},{name:"Asia/Qyzylorda",value:"Asia/Qyzylorda"},{name:"Asia/Rangoon",value:"Asia/Rangoon"},{name:"Asia/Riyadh",value:"Asia/Riyadh"},{value:"Asia/Sakhalin",name:"Asia/Sakhalin"},{name:"Asia/Samarkand",value:"Asia/Samarkand"},{value:"Asia/Seoul",name:"Asia/Seoul"},{value:"Asia/Shanghai",name:"Asia/Shanghai"},{name:"Asia/Singapore",value:"Asia/Singapore"},{value:"Asia/Taipei",name:"Asia/Taipei"},{name:"Asia/Tashkent",value:"Asia/Tashkent"},{name:"Asia/Tbilisi",value:"Asia/Tbilisi"},{value:"Asia/Tehran",name:"Asia/Tehran"},{value:"Asia/Thimphu",name:"Asia/Thimphu"},{value:"Asia/Tokyo",name:"Asia/Tokyo"},{value:"Asia/Ulaanbaatar",name:"Asia/Ulaanbaatar"},{name:"Asia/Urumqi",value:"Asia/Urumqi"},{name:"Asia/Vientiane",value:"Asia/Vientiane"},{name:"Asia/Vladivostok",value:"Asia/Vladivostok"},{name:"Asia/Yakutsk",value:"Asia/Yakutsk"},{value:"Asia/Yekaterinburg",name:"Asia/Yekaterinburg"},{name:"Asia/Yerevan",value:"Asia/Yerevan"},{name:"Atlantic/Azores",value:"Atlantic/Azores"},{value:"Atlantic/Bermuda",name:"Atlantic/Bermuda"},{name:"Atlantic/Canary",value:"Atlantic/Canary"},{value:"Atlantic/Cape_Verde",name:"Atlantic/Cape Verde"},{name:"Atlantic/Faroe",value:"Atlantic/Faroe"},{name:"Atlantic/Madeira",value:"Atlantic/Madeira"},{name:"Atlantic/Reykjavik",value:"Atlantic/Reykjavik"},{name:"Atlantic/South Georgia",value:"Atlantic/South_Georgia"},{value:"Atlantic/St_Helena",name:"Atlantic/St Helena"},{name:"Atlantic/Stanley",value:"Atlantic/Stanley"},{value:"Australia/Adelaide",name:"Australia/Adelaide"},{name:"Australia/Brisbane",value:"Australia/Brisbane"},{name:"Australia/Broken Hill",value:"Australia/Broken_Hill"},{name:"Australia/Currie",value:"Australia/Currie"},{name:"Australia/Darwin",value:"Australia/Darwin"},{value:"Australia/Eucla",name:"Australia/Eucla"},{name:"Australia/Hobart",value:"Australia/Hobart"},{value:"Australia/Lindeman",name:"Australia/Lindeman"},{value:"Australia/Lord_Howe",name:"Australia/Lord Howe"},{value:"Australia/Melbourne",name:"Australia/Melbourne"},{value:"Australia/Perth",name:"Australia/Perth"},{value:"Australia/Sydney",name:"Australia/Sydney"},{name:"Europe/Amsterdam",value:"Europe/Amsterdam"},{name:"Europe/Andorra",value:"Europe/Andorra"},{name:"Europe/Athens",value:"Europe/Athens"},{name:"Europe/Belgrade",value:"Europe/Belgrade"},{value:"Europe/Berlin",name:"Europe/Berlin"},{name:"Europe/Bratislava",value:"Europe/Bratislava"},{name:"Europe/Brussels",value:"Europe/Brussels"},{name:"Europe/Bucharest",value:"Europe/Bucharest"},{name:"Europe/Budapest",value:"Europe/Budapest"},{value:"Europe/Chisinau",name:"Europe/Chisinau"},{name:"Europe/Copenhagen",value:"Europe/Copenhagen"},{value:"Europe/Dublin",name:"Europe/Dublin"},{value:"Europe/Gibraltar",name:"Europe/Gibraltar"},{name:"Europe/Guernsey",value:"Europe/Guernsey"},{name:"Europe/Helsinki",value:"Europe/Helsinki"},{name:"Europe/Isle of Man",value:"Europe/Isle_of_Man"},{name:"Europe/Istanbul",value:"Europe/Istanbul"},{value:"Europe/Jersey",name:"Europe/Jersey"},{name:"Europe/Kaliningrad",value:"Europe/Kaliningrad"},{name:"Europe/Kiev",value:"Europe/Kiev"},{name:"Europe/Lisbon",value:"Europe/Lisbon"},{value:"Europe/Ljubljana",name:"Europe/Ljubljana"},{value:"Europe/London",name:"Europe/London"},{name:"Europe/Luxembourg",value:"Europe/Luxembourg"},{value:"Europe/Madrid",name:"Europe/Madrid"},{name:"Europe/Malta",value:"Europe/Malta"},{name:"Europe/Mariehamn",value:"Europe/Mariehamn"},{name:"Europe/Minsk",value:"Europe/Minsk"},{name:"Europe/Monaco",value:"Europe/Monaco"},{value:"Europe/Moscow",name:"Europe/Moscow"},{value:"Europe/Oslo",name:"Europe/Oslo"},{value:"Europe/Paris",name:"Europe/Paris"},{name:"Europe/Podgorica",value:"Europe/Podgorica"},{value:"Europe/Prague",name:"Europe/Prague"},{value:"Europe/Riga",name:"Europe/Riga"},{value:"Europe/Rome",name:"Europe/Rome"},{value:"Europe/Samara",name:"Europe/Samara"},{value:"Europe/San_Marino",name:"Europe/San Marino"},{name:"Europe/Sarajevo",value:"Europe/Sarajevo"},{name:"Europe/Simferopol",value:"Europe/Simferopol"},{value:"Europe/Skopje",name:"Europe/Skopje"},{value:"Europe/Sofia",name:"Europe/Sofia"},{name:"Europe/Stockholm",value:"Europe/Stockholm"},{value:"Europe/Tallinn",name:"Europe/Tallinn"},{value:"Europe/Tirane",name:"Europe/Tirane"},{value:"Europe/Uzhgorod",name:"Europe/Uzhgorod"},{name:"Europe/Vaduz",value:"Europe/Vaduz"},{value:"Europe/Vatican",name:"Europe/Vatican"},{name:"Europe/Vienna",value:"Europe/Vienna"},{value:"Europe/Vilnius",name:"Europe/Vilnius"},{name:"Europe/Volgograd",value:"Europe/Volgograd"},{name:"Europe/Warsaw",value:"Europe/Warsaw"},{value:"Europe/Zagreb",name:"Europe/Zagreb"},{name:"Europe/Zaporozhye",value:"Europe/Zaporozhye"},{name:"Europe/Zurich",value:"Europe/Zurich"},{value:"Indian/Antananarivo",name:"Indian/Antananarivo"},{value:"Indian/Chagos",name:"Indian/Chagos"},{value:"Indian/Christmas",name:"Indian/Christmas"},{value:"Indian/Cocos",name:"Indian/Cocos"},{name:"Indian/Comoro",value:"Indian/Comoro"},{value:"Indian/Kerguelen",name:"Indian/Kerguelen"},{value:"Indian/Mahe",name:"Indian/Mahe"},{value:"Indian/Maldives",name:"Indian/Maldives"},{value:"Indian/Mauritius",name:"Indian/Mauritius"},{value:"Indian/Mayotte",name:"Indian/Mayotte"},{name:"Indian/Reunion",value:"Indian/Reunion"},{value:"Pacific/Apia",name:"Pacific/Apia"},{name:"Pacific/Auckland",value:"Pacific/Auckland"},{name:"Pacific/Chatham",value:"Pacific/Chatham"},{value:"Pacific/Chuuk",name:"Pacific/Chuuk"},{value:"Pacific/Easter",name:"Pacific/Easter"},{value:"Pacific/Efate",name:"Pacific/Efate"},{value:"Pacific/Enderbury",name:"Pacific/Enderbury"},{name:"Pacific/Fakaofo",value:"Pacific/Fakaofo"},{value:"Pacific/Fiji",name:"Pacific/Fiji"},{value:"Pacific/Funafuti",name:"Pacific/Funafuti"},{name:"Pacific/Galapagos",value:"Pacific/Galapagos"},{name:"Pacific/Gambier",value:"Pacific/Gambier"},{value:"Pacific/Guadalcanal",name:"Pacific/Guadalcanal"},{name:"Pacific/Guam",value:"Pacific/Guam"},{name:"Pacific/Honolulu",value:"Pacific/Honolulu"},{value:"Pacific/Johnston",name:"Pacific/Johnston"},{value:"Pacific/Kiritimati",name:"Pacific/Kiritimati"},{value:"Pacific/Kosrae",name:"Pacific/Kosrae"},{name:"Pacific/Kwajalein",value:"Pacific/Kwajalein"},{value:"Pacific/Majuro",name:"Pacific/Majuro"},{name:"Pacific/Marquesas",value:"Pacific/Marquesas"},{value:"Pacific/Midway",name:"Pacific/Midway"},{value:"Pacific/Nauru",name:"Pacific/Nauru"},{name:"Pacific/Niue",value:"Pacific/Niue"},{name:"Pacific/Norfolk",value:"Pacific/Norfolk"},{value:"Pacific/Noumea",name:"Pacific/Noumea"},{value:"Pacific/Pago_Pago",name:"Pacific/Pago Pago"},{value:"Pacific/Palau",name:"Pacific/Palau"},{name:"Pacific/Pitcairn",value:"Pacific/Pitcairn"},{name:"Pacific/Pohnpei",value:"Pacific/Pohnpei"},{value:"Pacific/Port_Moresby",name:"Pacific/Port Moresby"},{name:"Pacific/Rarotonga",value:"Pacific/Rarotonga"},{value:"Pacific/Saipan",name:"Pacific/Saipan"},{value:"Pacific/Tahiti",name:"Pacific/Tahiti"},{value:"Pacific/Tarawa",name:"Pacific/Tarawa"},{name:"Pacific/Tongatapu",value:"Pacific/Tongatapu"},{value:"Pacific/Wake",name:"Pacific/Wake"},{name:"Pacific/Wallis",value:"Pacific/Wallis"}]}Blx.timezones=Timezones;class TopNav{constructor(o){this.style={navClass:"blx-top-nav",itemClass:"blx-top-nav-link",itemActiveClass:"blx-top-nav-link-active"};this.config=Blx.utils.config(o,["replaceTo","appendTo","navClass","itemClass","itemActiveClass","clear"]);$.each(["navClass","itemClass","itemActiveClass"],(i,cls)=>{if(this.config[cls]){this.style[cls]=`${this.style[cls]} ${this.config[cls]}`}});this.nav=Create("div").addClass(this.style.navClass);this.nav.hide();this.items={};this.isActive=false;if(this.config.replaceTo){o.replaceTo.html(this.nav)}else if(this.config.appendTo){this.nav.appendTo(this.config.appendTo)}}add(o){this.nav.show();const el=Create("a").addClass(this.style.itemClass).appendTo(this.nav);if(o.route){el.attr("href","#"+o.route);if(o.blank){el.attr("target","_blank")}else{el.click(()=>Blx.route.to(o.route))}}else if(o.callback){el.click(()=>{if(this.beforeCallback){this.beforeCallback()}if(o.route){window.location.hash=o.route}if(this.config.clear){this.config.clear.html("")}this.active(el);o.callback()})}if(o.text){el.setHTML(o.text)}if(o.name!==undefined){if(!o.name){o.name="___empty___"}this.items[o.name]={el:el,o:o}}}active(el){if(this.isActive!==false){this.isActive.removeClass(this.style.itemActiveClass)}this.isActive=el;el.addClass(this.style.itemActiveClass)}run(name){if(!name){name="___empty___"}const item=this.items[name];if(!item){window.location="/"}this.active(item.el);item.o.callback()}setBeforeCallback(callback){this.beforeCallback=callback}clear(){this.nav.html("");this.nav.hide();this.items={};this.beforeCallback=false}}Blx.topNav=o=>new TopNav(o);const Utils={};Utils.exists=function(key,arr){for(k in arr){if(k===key){return true}}return false};Utils.escape=function(str){if(str===undefined||str===false){return""}if(typeof str==="number"){return str}str=str.replace(/&/g,"&amp;");str=str.replace(/</g,"&lt;");str=str.replace(/>/g,"&gt;");str=str.replace(/"/g,"&quot;");str=str.replace(/'/g,"&#39;");return str};Utils.replacePattern=function(str,data){if(/:[a-zA-Z_0-9]+/.test(str)){$.each(str.match(/(:[a-zA-Z_0-9]+)/g),function(i,match){var repKey=match.replace(/:/g,"");str=str.replace(match,data[repKey])})}return str};Utils.replaceString=function(value,object){if(object[value]!==undefined){return object[value]}return object["*"]};Utils.joinHashElements=function(str,hash,array){var ret,toJoin=[];$.each(array,function(i,elem){toJoin.push(hash[elem])});return toJoin.join(str)};Utils.extendArray=function(a,b){if(!a){a=[]}$.each(b,function(i,row){a.push(row)});return a};Utils.visible=function(obj,time){if(!time){time=200}if(obj.is(":hidden")){obj.show(time)}else{obj.hide(time)}};Utils.hexToRGB=function(hex){var result=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);var r=parseInt(result[1],16),g=parseInt(result[2],16),b=parseInt(result[3],16);return[r,g,b]};Utils.rgbToHex=function(color){if(color.substr(0,1)==="#"){return color}var nums=/\((\d+),\s*(\d+),\s*(\d+)/i.exec(color),r=parseInt(nums[2],10).toString(16),g=parseInt(nums[3],10).toString(16),b=parseInt(nums[4],10).toString(16);return"#"+((r.length==1?"0"+r:r)+(g.length==1?"0"+g:g)+(b.length==1?"0"+b:b))};Utils.isHexColor=function(hex){if(typeof hex!="string"){return false}if(!/^#[a-fA-F0-9]{3,6}$/.test(hex)){return false}return true};Utils.includes=function(string,array){var i;for(i in array){if(string===array[i]){return true}}return false};Utils.size=function(obj){var size=0,key;for(key in obj){size++}return size};Utils.genRandStr=function(len,withSpecial){if(len==undefined){len=30}const classes={upper:"ABCDEFGHIJKLMNOPQRSTUVWXYZ",lower:"abcdefghijklmnopqrstuvwxyz",number:"0123456789"};let chars=classes.upper+classes.lower+classes.number;if(withSpecial===true){classes.special="~!@#$%^&*_-+=`|\\(){}[]:;\"'<>,.?/€";chars+=classes.special}let pos={};let arr=[];for(let i=0;i<len;i++){arr.push(i)}let n;for(n in classes){if(arr.length==0){break}const r=Math.floor(Math.random()*arr.length);const p=arr.splice(r,1);pos[p]=n}let str="";for(let i=0;i<len;i++){if(pos[i]){str+=classes[pos[i]].charAt(Math.floor(Math.random()*classes[pos[i]].length))}else{str+=chars.charAt(Math.floor(Math.random()*chars.length))}}return str};Utils.genID=function(){while(true){const id=Utils.genRandStr(8);if($("#"+id).length==0){return id}}};Utils.dump=function(data){return Blx.create("pre").text(JSON.stringify(data,null,"  ")).css({display:"inline-block",padding:"10px",color:"#ffffff","background-color":"rgba(0,0,0,.8)"})};Utils.toJSON=function(obj){return JSON.stringify(obj)};Utils.unixtime=function(){return Math.floor(Date.now()/1e3)};Utils.unixtimeToDate=function(seconds,replaceNull){if(replaceNull!==undefined&&(seconds===0||seconds===undefined||seconds===null)){return replaceNull}var date=new Date(seconds*1e3);return DateFormat(date,DateFormat.masks["date"])};Utils.unixtimeToTime=function(seconds,replaceNull){if(replaceNull!==undefined&&(seconds===0||seconds===undefined||seconds===null)){return replaceNull}var date=new Date(seconds*1e3);return DateFormat(date,DateFormat.masks["time"])};Utils.unixtimeToDatetime=function(seconds,replaceNull){if(replaceNull!==undefined&&(seconds===0||seconds===undefined||seconds===null)){return replaceNull}var date=new Date(seconds*1e3);return DateFormat(date,DateFormat.masks["default"])};Utils.secondsToString=function(seconds){var list=Utils.secondsToStringList(seconds);return list.join(":")};Utils.secondsToStringShortReadable=function(seconds){var list=Utils.secondsToStringList(seconds);var toReturn=[];if(list[0]!="0"){toReturn.push(list[0]+"d")}if(list[1]!="0"){toReturn.push(list[1]+"h")}if(list[2]!="0"){toReturn.push(list[2]+"m")}if(list[3]!="0"){toReturn.push(list[3]+"s")}return toReturn.join(", ")};Utils.secondsToStringReadable=function(seconds){var list=Utils.secondsToStringList(seconds),toJoin=[];if(list[0]>0){list[0]+=list[0]==1?" "+Blx.text.get("word.day"):" "+Blx.text.get("word.days");toJoin.push(list[0])}if(list[1]>0){list[1]+=list[1]==1?" "+Blx.text.get("word.hour"):" "+Blx.text.get("word.hours");toJoin.push(list[1])}if(list[2]>0){list[2]+=list[2]==1?" "+Blx.text.get("word.minute"):" "+Blx.text.get("word.minutes");toJoin.push(list[2])}if(list[3]>0){list[3]+=list[3]==1?" "+Blx.text.get("word.second"):" "+Blx.text.get("word.seconds");toJoin.push(list[3])}return toJoin.join(", ")};Utils.secondsToStringList=function(seconds){var minutes=0,hours=0,days=0;if(seconds>=86400){days=Math.floor(seconds/86400);seconds=seconds%86400}if(seconds>=3600){hours=Math.floor(seconds/3600);seconds=seconds%3600}if(seconds>=60){minutes=Math.floor(seconds/60);seconds=seconds%60}return[days,hours,minutes,seconds]};Utils.secondsToFormValues=function(a,nullStr){var b=[];$.each(a,function(i,n){var unit,value;if(nullStr!=undefined&&n==0){b.push({name:nullStr,value:n});return true}if(n>=86400){value=n/86400;name=value==1?"day":"days"}else if(n>=3600){value=n/3600;name=value==1?"hour":"hours"}else if(n>=60){value=n/60;name=value==1?"minute":"minutes"}else{value=n;name=value==1?"second":"seconds"}b.push({label:value+" "+Blx.text.get("word."+name),value:n})});return b};Utils.getFirstDayOfNextMonth=function(){var date=new Date,year=DateFormat(date,"yyyy"),month=DateFormat(date,"mm");month=parseInt(month)+1;if(month==13){month="01";year=year+1}else if(month<10){month="0"+month}return year+"-"+month+"-01"};Utils.extend=function(a,b){if(a==undefined){a={}}Object.assign(a,b);return a};Utils.append=function(a,b){if(a){var n,c={};for(n in a){if(a[n]!==undefined){c[n]=true}}for(n in b){if(c[n]!==true){a[n]=b[n]}}}};Utils.shift=function(a,b){var n,r={},c={};if(b){for(n in b){c[n]=1}for(n in a){n=a[n];if(c[n]===1){r[n]=b[n];delete b[n]}}}return r};Utils.filterEmptyValues=function(b){var a={};if(b){var n;for(n in b){if(Utils.isNotEmpty(b[n])){a[n]=b[n]}}}return a};Utils.filterDataArray=function(str,arr){const r=[];if(Array.isArray(arr)!==true){return r}const rx=new RegExp(str,"i");var i;for(i in arr){if(typeof arr[i]=="string"&&rx.test(arr[i])){r.push(arr[i])}}return r};Utils.sort=function(o){var a=[];$.each(o,function(i,r){a.push(i)});return a.sort()};Utils.toUnitBytes=function(value,f){let unit=false,opposite=value<0?true:false;if(opposite===true){value*=-1}if(f==undefined){f=1}if(value>=12089258196146292e8){value=value/12089258196146292e8;unit="YB"}else if(value>=11805916207174113e5){value=value/11805916207174113e5;unit="ZB"}else if(value>=0x1000000000000000){value=value/0x1000000000000000;unit="EB"}else if(value>=0x4000000000000){value=value/0x4000000000000;unit="PB"}else if(value>=1099511627776){value=value/1099511627776;unit="TB"}else if(value>=1073741824){value=value/1073741824;unit="GB"}else if(value>=1048576){value=value/1048576;unit="MB"}else if(value>=1024){value=value/1024;unit="KB"}if(opposite===true){value*=-1}if(unit===false){return value}return String(value.toFixed(f))+unit};Utils.toUnit=function(value,f){let unit=false,opposite=value<0?true:false;if(opposite===true){value*=-1}if(f==undefined){f=1}if(value>=1e24){value=value/1e24;unit="y"}else if(value>=1e21){value=value/1e21;unit="z"}else if(value>=1e18){value=value/1e18;unit="e"}else if(value>=1e15){value=value/1e15;unit="p"}else if(value>=1e12){value=value/1e12;unit="t"}else if(value>=1e9){value=value/1e9;unit="g"}else if(value>=1e6){value=value/1e6;unit="m"}else if(value>=1e3){value=value/1e3;unit="k"}if(opposite===true){value*=-1}if(unit===false){return value}return String(value.toFixed(f))+unit};Utils.open=function(href,title,opts){window.open(href,title,opts)};Utils.syntaxHighlightJSON=function(json){return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g,function(match){var cls="color:darkorange;";if(/^"/.test(match)){if(/:$/.test(match)){cls="color:red"}else{cls="color:green"}}else if(/true|false/.test(match)){cls="color:blue"}else if(/null/.test(match)){cls="color:magenta"}return'<span style="'+cls+'">'+match+"</span>"})};Utils.escapeAndSyntaxHightlightJSON=function(json){json=JSON.stringify(json,null,"  ");json=json.replace(/</g,"&lt;");json=json.replace(/>/g,"&gt;");json=json.replace(/\\r/g,"");json=json.replace(/\\n/g,"<br/>");json=Utils.syntaxHighlightJSON(json);return json};Utils.clear=function(o){var div=Create("div").addClass("blx-clear");if(o){div.appendTo(o)}return div};Utils.linebreak=function(o){Create("br").appendTo(o)};Utils.isEmpty=function(x){if(x===undefined||x===false||x.toString().length===0){return true}return false};Utils.isNotEmpty=function(x){if(Utils.isEmpty(x)){return false}return true};Utils.convertCurrency=function(value,currency){value=parseFloat(value).toFixed(2);if(currency=="de"){value=value.replace(/\./,",")}return value};Utils.uniqueIdCounter=0;Utils.uniqueId=function(alias="none"){const counter=++Utils.uniqueIdCounter;const uid=Math.random().toString(36).slice(2);return`blx-utils-uid-${alias}-${uid}-${counter}`};Utils.date=function(mask){return DateFormat(new Date,DateFormat.masks[mask])};Utils.euro=function(n){n=n.toFixed(2);n=n.replace(/\./,",");return n+" &euro;"};Utils.is_touch_enabled=function(){return"ontouchstart"in window||navigator.maxTouchPoints>0||navigator.msMaxTouchPoints>0};Utils.parseCli=function(string){const chars=string.split("");var d=[];while(chars.length>0){var first=chars.shift(),last,value;if(first==" "){continue}if(first=="'"||first=='"'){last=first}else{last=" "}if(last==" "){value=first}else{value=""}while(chars.length>0){var c=chars.shift();if(c=="\\"){if(chars.length==0){return false}value+=chars.shift();continue}if(c==last){break}value+=c;if(chars.length===1&&last!=" "&&chars[0]!=last){return false}}d.push(value)}return d};Utils.setopts=function(a,b,c){if(!c){c={}}Utils.extend(c,a);for(const n in b){if(c[n]===undefined){c[n]=b[n]}}return c};Utils.config=function(opts,params,defaults,assign){if(!assign){assign={}}const test={};for(const n in params){test[params[n]]=true}if(opts){for(const n in opts){if(test[n]!==true){Blx.throwError({message:`param '${n}' does not exists`})}assign[n]=opts[n]}}if(defaults){for(const n in defaults){if(assign[n]===undefined){assign[n]=defaults[n]}}}return assign};Utils.validate=function(opts,rules,assign){if(assign===undefined){assign={}}for(const n in opts){if(rules[n]===undefined){Blx.throwError({message:`valdiate: param ${n} does not exists`})}if(rules.type&&rule.type!="any"){const rx=new RegExp(rule.type);if(!rx.test(typeof n)){Blx.throwError({message:`valdiate: param ${n} has invalid type`})}}assign[n]=opts[n]}for(const n in rules){if(opts[n]===undefined){if(rules[n].default!==undefined){assign[n]=rules[n].default}else if(rules[n].optional===false){Blx.throwError({message:`valdiate: missing mandatory param ${n}`})}}}return assign};Utils.timezone=function(){return Intl.DateTimeFormat().resolvedOptions().timeZone};Utils.resetLocation=function(){window.location="/";history.replaceState(null,null," ");window.location.reload()};Utils.arrayToDict=function(array){const obj={};var i;for(i in array){obj[array[i]]=true}return obj};Blx.utils=Utils;return Blx}window.BloonixJSFramework=BloonixJSFramework})();
/* @license
                    GNU AFFERO GENERAL PUBLIC LICENSE
                       Version 3, 19 November 2007

 Copyright (C) 2007 Free Software Foundation, Inc. <https://fsf.org/>
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

                            Preamble

  The GNU Affero General Public License is a free, copyleft license for
software and other kinds of works, specifically designed to ensure
cooperation with the community in the case of network server software.

  The licenses for most software and other practical works are designed
to take away your freedom to share and change the works.  By contrast,
our General Public Licenses are intended to guarantee your freedom to
share and change all versions of a program--to make sure it remains free
software for all its users.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.

  Developers that use our General Public Licenses protect your rights
with two steps: (1) assert copyright on the software, and (2) offer
you this License which gives you legal permission to copy, distribute
and/or modify the software.

  A secondary benefit of defending all users' freedom is that
improvements made in alternate versions of the program, if they
receive widespread use, become available for other developers to
incorporate.  Many developers of free software are heartened and
encouraged by the resulting cooperation.  However, in the case of
software used on network servers, this result may fail to come about.
The GNU General Public License permits making a modified version and
letting the public access it on a server without ever releasing its
source code to the public.

  The GNU Affero General Public License is designed specifically to
ensure that, in such cases, the modified source code becomes available
to the community.  It requires the operator of a network server to
provide the source code of the modified version running there to the
users of that server.  Therefore, public use of a modified version, on
a publicly accessible server, gives the public access to the source
code of the modified version.

  An older license, called the Affero General Public License and
published by Affero, was designed to accomplish similar goals.  This is
a different license, not a version of the Affero GPL, but Affero has
released a new version of the Affero GPL which permits relicensing under
this license.

  The precise terms and conditions for copying, distribution and
modification follow.

                       TERMS AND CONDITIONS

  0. Definitions.

  "This License" refers to version 3 of the GNU Affero General Public License.

  "Copyright" also means copyright-like laws that apply to other kinds of
works, such as semiconductor masks.

  "The Program" refers to any copyrightable work licensed under this
License.  Each licensee is addressed as "you".  "Licensees" and
"recipients" may be individuals or organizations.

  To "modify" a work means to copy from or adapt all or part of the work
in a fashion requiring copyright permission, other than the making of an
exact copy.  The resulting work is called a "modified version" of the
earlier work or a work "based on" the earlier work.

  A "covered work" means either the unmodified Program or a work based
on the Program.

  To "propagate" a work means to do anything with it that, without
permission, would make you directly or secondarily liable for
infringement under applicable copyright law, except executing it on a
computer or modifying a private copy.  Propagation includes copying,
distribution (with or without modification), making available to the
public, and in some countries other activities as well.

  To "convey" a work means any kind of propagation that enables other
parties to make or receive copies.  Mere interaction with a user through
a computer network, with no transfer of a copy, is not conveying.

  An interactive user interface displays "Appropriate Legal Notices"
to the extent that it includes a convenient and prominently visible
feature that (1) displays an appropriate copyright notice, and (2)
tells the user that there is no warranty for the work (except to the
extent that warranties are provided), that licensees may convey the
work under this License, and how to view a copy of this License.  If
the interface presents a list of user commands or options, such as a
menu, a prominent item in the list meets this criterion.

  1. Source Code.

  The "source code" for a work means the preferred form of the work
for making modifications to it.  "Object code" means any non-source
form of a work.

  A "Standard Interface" means an interface that either is an official
standard defined by a recognized standards body, or, in the case of
interfaces specified for a particular programming language, one that
is widely used among developers working in that language.

  The "System Libraries" of an executable work include anything, other
than the work as a whole, that (a) is included in the normal form of
packaging a Major Component, but which is not part of that Major
Component, and (b) serves only to enable use of the work with that
Major Component, or to implement a Standard Interface for which an
implementation is available to the public in source code form.  A
"Major Component", in this context, means a major essential component
(kernel, window system, and so on) of the specific operating system
(if any) on which the executable work runs, or a compiler used to
produce the work, or an object code interpreter used to run it.

  The "Corresponding Source" for a work in object code form means all
the source code needed to generate, install, and (for an executable
work) run the object code and to modify the work, including scripts to
control those activities.  However, it does not include the work's
System Libraries, or general-purpose tools or generally available free
programs which are used unmodified in performing those activities but
which are not part of the work.  For example, Corresponding Source
includes interface definition files associated with source files for
the work, and the source code for shared libraries and dynamically
linked subprograms that the work is specifically designed to require,
such as by intimate data communication or control flow between those
subprograms and other parts of the work.

  The Corresponding Source need not include anything that users
can regenerate automatically from other parts of the Corresponding
Source.

  The Corresponding Source for a work in source code form is that
same work.

  2. Basic Permissions.

  All rights granted under this License are granted for the term of
copyright on the Program, and are irrevocable provided the stated
conditions are met.  This License explicitly affirms your unlimited
permission to run the unmodified Program.  The output from running a
covered work is covered by this License only if the output, given its
content, constitutes a covered work.  This License acknowledges your
rights of fair use or other equivalent, as provided by copyright law.

  You may make, run and propagate covered works that you do not
convey, without conditions so long as your license otherwise remains
in force.  You may convey covered works to others for the sole purpose
of having them make modifications exclusively for you, or provide you
with facilities for running those works, provided that you comply with
the terms of this License in conveying all material for which you do
not control copyright.  Those thus making or running the covered works
for you must do so exclusively on your behalf, under your direction
and control, on terms that prohibit them from making any copies of
your copyrighted material outside their relationship with you.

  Conveying under any other circumstances is permitted solely under
the conditions stated below.  Sublicensing is not allowed; section 10
makes it unnecessary.

  3. Protecting Users' Legal Rights From Anti-Circumvention Law.

  No covered work shall be deemed part of an effective technological
measure under any applicable law fulfilling obligations under article
11 of the WIPO copyright treaty adopted on 20 December 1996, or
similar laws prohibiting or restricting circumvention of such
measures.

  When you convey a covered work, you waive any legal power to forbid
circumvention of technological measures to the extent such circumvention
is effected by exercising rights under this License with respect to
the covered work, and you disclaim any intention to limit operation or
modification of the work as a means of enforcing, against the work's
users, your or third parties' legal rights to forbid circumvention of
technological measures.

  4. Conveying Verbatim Copies.

  You may convey verbatim copies of the Program's source code as you
receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice;
keep intact all notices stating that this License and any
non-permissive terms added in accord with section 7 apply to the code;
keep intact all notices of the absence of any warranty; and give all
recipients a copy of this License along with the Program.

  You may charge any price or no price for each copy that you convey,
and you may offer support or warranty protection for a fee.

  5. Conveying Modified Source Versions.

  You may convey a work based on the Program, or the modifications to
produce it from the Program, in the form of source code under the
terms of section 4, provided that you also meet all of these conditions:

    a) The work must carry prominent notices stating that you modified
    it, and giving a relevant date.

    b) The work must carry prominent notices stating that it is
    released under this License and any conditions added under section
    7.  This requirement modifies the requirement in section 4 to
    "keep intact all notices".

    c) You must license the entire work, as a whole, under this
    License to anyone who comes into possession of a copy.  This
    License will therefore apply, along with any applicable section 7
    additional terms, to the whole of the work, and all its parts,
    regardless of how they are packaged.  This License gives no
    permission to license the work in any other way, but it does not
    invalidate such permission if you have separately received it.

    d) If the work has interactive user interfaces, each must display
    Appropriate Legal Notices; however, if the Program has interactive
    interfaces that do not display Appropriate Legal Notices, your
    work need not make them do so.

  A compilation of a covered work with other separate and independent
works, which are not by their nature extensions of the covered work,
and which are not combined with it such as to form a larger program,
in or on a volume of a storage or distribution medium, is called an
"aggregate" if the compilation and its resulting copyright are not
used to limit the access or legal rights of the compilation's users
beyond what the individual works permit.  Inclusion of a covered work
in an aggregate does not cause this License to apply to the other
parts of the aggregate.

  6. Conveying Non-Source Forms.

  You may convey a covered work in object code form under the terms
of sections 4 and 5, provided that you also convey the
machine-readable Corresponding Source under the terms of this License,
in one of these ways:

    a) Convey the object code in, or embodied in, a physical product
    (including a physical distribution medium), accompanied by the
    Corresponding Source fixed on a durable physical medium
    customarily used for software interchange.

    b) Convey the object code in, or embodied in, a physical product
    (including a physical distribution medium), accompanied by a
    written offer, valid for at least three years and valid for as
    long as you offer spare parts or customer support for that product
    model, to give anyone who possesses the object code either (1) a
    copy of the Corresponding Source for all the software in the
    product that is covered by this License, on a durable physical
    medium customarily used for software interchange, for a price no
    more than your reasonable cost of physically performing this
    conveying of source, or (2) access to copy the
    Corresponding Source from a network server at no charge.

    c) Convey individual copies of the object code with a copy of the
    written offer to provide the Corresponding Source.  This
    alternative is allowed only occasionally and noncommercially, and
    only if you received the object code with such an offer, in accord
    with subsection 6b.

    d) Convey the object code by offering access from a designated
    place (gratis or for a charge), and offer equivalent access to the
    Corresponding Source in the same way through the same place at no
    further charge.  You need not require recipients to copy the
    Corresponding Source along with the object code.  If the place to
    copy the object code is a network server, the Corresponding Source
    may be on a different server (operated by you or a third party)
    that supports equivalent copying facilities, provided you maintain
    clear directions next to the object code saying where to find the
    Corresponding Source.  Regardless of what server hosts the
    Corresponding Source, you remain obligated to ensure that it is
    available for as long as needed to satisfy these requirements.

    e) Convey the object code using peer-to-peer transmission, provided
    you inform other peers where the object code and Corresponding
    Source of the work are being offered to the general public at no
    charge under subsection 6d.

  A separable portion of the object code, whose source code is excluded
from the Corresponding Source as a System Library, need not be
included in conveying the object code work.

  A "User Product" is either (1) a "consumer product", which means any
tangible personal property which is normally used for personal, family,
or household purposes, or (2) anything designed or sold for incorporation
into a dwelling.  In determining whether a product is a consumer product,
doubtful cases shall be resolved in favor of coverage.  For a particular
product received by a particular user, "normally used" refers to a
typical or common use of that class of product, regardless of the status
of the particular user or of the way in which the particular user
actually uses, or expects or is expected to use, the product.  A product
is a consumer product regardless of whether the product has substantial
commercial, industrial or non-consumer uses, unless such uses represent
the only significant mode of use of the product.

  "Installation Information" for a User Product means any methods,
procedures, authorization keys, or other information required to install
and execute modified versions of a covered work in that User Product from
a modified version of its Corresponding Source.  The information must
suffice to ensure that the continued functioning of the modified object
code is in no case prevented or interfered with solely because
modification has been made.

  If you convey an object code work under this section in, or with, or
specifically for use in, a User Product, and the conveying occurs as
part of a transaction in which the right of possession and use of the
User Product is transferred to the recipient in perpetuity or for a
fixed term (regardless of how the transaction is characterized), the
Corresponding Source conveyed under this section must be accompanied
by the Installation Information.  But this requirement does not apply
if neither you nor any third party retains the ability to install
modified object code on the User Product (for example, the work has
been installed in ROM).

  The requirement to provide Installation Information does not include a
requirement to continue to provide support service, warranty, or updates
for a work that has been modified or installed by the recipient, or for
the User Product in which it has been modified or installed.  Access to a
network may be denied when the modification itself materially and
adversely affects the operation of the network or violates the rules and
protocols for communication across the network.

  Corresponding Source conveyed, and Installation Information provided,
in accord with this section must be in a format that is publicly
documented (and with an implementation available to the public in
source code form), and must require no special password or key for
unpacking, reading or copying.

  7. Additional Terms.

  "Additional permissions" are terms that supplement the terms of this
License by making exceptions from one or more of its conditions.
Additional permissions that are applicable to the entire Program shall
be treated as though they were included in this License, to the extent
that they are valid under applicable law.  If additional permissions
apply only to part of the Program, that part may be used separately
under those permissions, but the entire Program remains governed by
this License without regard to the additional permissions.

  When you convey a copy of a covered work, you may at your option
remove any additional permissions from that copy, or from any part of
it.  (Additional permissions may be written to require their own
removal in certain cases when you modify the work.)  You may place
additional permissions on material, added by you to a covered work,
for which you have or can give appropriate copyright permission.

  Notwithstanding any other provision of this License, for material you
add to a covered work, you may (if authorized by the copyright holders of
that material) supplement the terms of this License with terms:

    a) Disclaiming warranty or limiting liability differently from the
    terms of sections 15 and 16 of this License; or

    b) Requiring preservation of specified reasonable legal notices or
    author attributions in that material or in the Appropriate Legal
    Notices displayed by works containing it; or

    c) Prohibiting misrepresentation of the origin of that material, or
    requiring that modified versions of such material be marked in
    reasonable ways as different from the original version; or

    d) Limiting the use for publicity purposes of names of licensors or
    authors of the material; or

    e) Declining to grant rights under trademark law for use of some
    trade names, trademarks, or service marks; or

    f) Requiring indemnification of licensors and authors of that
    material by anyone who conveys the material (or modified versions of
    it) with contractual assumptions of liability to the recipient, for
    any liability that these contractual assumptions directly impose on
    those licensors and authors.

  All other non-permissive additional terms are considered "further
restrictions" within the meaning of section 10.  If the Program as you
received it, or any part of it, contains a notice stating that it is
governed by this License along with a term that is a further
restriction, you may remove that term.  If a license document contains
a further restriction but permits relicensing or conveying under this
License, you may add to a covered work material governed by the terms
of that license document, provided that the further restriction does
not survive such relicensing or conveying.

  If you add terms to a covered work in accord with this section, you
must place, in the relevant source files, a statement of the
additional terms that apply to those files, or a notice indicating
where to find the applicable terms.

  Additional terms, permissive or non-permissive, may be stated in the
form of a separately written license, or stated as exceptions;
the above requirements apply either way.

  8. Termination.

  You may not propagate or modify a covered work except as expressly
provided under this License.  Any attempt otherwise to propagate or
modify it is void, and will automatically terminate your rights under
this License (including any patent licenses granted under the third
paragraph of section 11).

  However, if you cease all violation of this License, then your
license from a particular copyright holder is reinstated (a)
provisionally, unless and until the copyright holder explicitly and
finally terminates your license, and (b) permanently, if the copyright
holder fails to notify you of the violation by some reasonable means
prior to 60 days after the cessation.

  Moreover, your license from a particular copyright holder is
reinstated permanently if the copyright holder notifies you of the
violation by some reasonable means, this is the first time you have
received notice of violation of this License (for any work) from that
copyright holder, and you cure the violation prior to 30 days after
your receipt of the notice.

  Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License.  If your rights have been terminated and not permanently
reinstated, you do not qualify to receive new licenses for the same
material under section 10.

  9. Acceptance Not Required for Having Copies.

  You are not required to accept this License in order to receive or
run a copy of the Program.  Ancillary propagation of a covered work
occurring solely as a consequence of using peer-to-peer transmission
to receive a copy likewise does not require acceptance.  However,
nothing other than this License grants you permission to propagate or
modify any covered work.  These actions infringe copyright if you do
not accept this License.  Therefore, by modifying or propagating a
covered work, you indicate your acceptance of this License to do so.

  10. Automatic Licensing of Downstream Recipients.

  Each time you convey a covered work, the recipient automatically
receives a license from the original licensors, to run, modify and
propagate that work, subject to this License.  You are not responsible
for enforcing compliance by third parties with this License.

  An "entity transaction" is a transaction transferring control of an
organization, or substantially all assets of one, or subdividing an
organization, or merging organizations.  If propagation of a covered
work results from an entity transaction, each party to that
transaction who receives a copy of the work also receives whatever
licenses to the work the party's predecessor in interest had or could
give under the previous paragraph, plus a right to possession of the
Corresponding Source of the work from the predecessor in interest, if
the predecessor has it or can get it with reasonable efforts.

  You may not impose any further restrictions on the exercise of the
rights granted or affirmed under this License.  For example, you may
not impose a license fee, royalty, or other charge for exercise of
rights granted under this License, and you may not initiate litigation
(including a cross-claim or counterclaim in a lawsuit) alleging that
any patent claim is infringed by making, using, selling, offering for
sale, or importing the Program or any portion of it.

  11. Patents.

  A "contributor" is a copyright holder who authorizes use under this
License of the Program or a work on which the Program is based.  The
work thus licensed is called the contributor's "contributor version".

  A contributor's "essential patent claims" are all patent claims
owned or controlled by the contributor, whether already acquired or
hereafter acquired, that would be infringed by some manner, permitted
by this License, of making, using, or selling its contributor version,
but do not include claims that would be infringed only as a
consequence of further modification of the contributor version.  For
purposes of this definition, "control" includes the right to grant
patent sublicenses in a manner consistent with the requirements of
this License.

  Each contributor grants you a non-exclusive, worldwide, royalty-free
patent license under the contributor's essential patent claims, to
make, use, sell, offer for sale, import and otherwise run, modify and
propagate the contents of its contributor version.

  In the following three paragraphs, a "patent license" is any express
agreement or commitment, however denominated, not to enforce a patent
(such as an express permission to practice a patent or covenant not to
sue for patent infringement).  To "grant" such a patent license to a
party means to make such an agreement or commitment not to enforce a
patent against the party.

  If you convey a covered work, knowingly relying on a patent license,
and the Corresponding Source of the work is not available for anyone
to copy, free of charge and under the terms of this License, through a
publicly available network server or other readily accessible means,
then you must either (1) cause the Corresponding Source to be so
available, or (2) arrange to deprive yourself of the benefit of the
patent license for this particular work, or (3) arrange, in a manner
consistent with the requirements of this License, to extend the patent
license to downstream recipients.  "Knowingly relying" means you have
actual knowledge that, but for the patent license, your conveying the
covered work in a country, or your recipient's use of the covered work
in a country, would infringe one or more identifiable patents in that
country that you have reason to believe are valid.

  If, pursuant to or in connection with a single transaction or
arrangement, you convey, or propagate by procuring conveyance of, a
covered work, and grant a patent license to some of the parties
receiving the covered work authorizing them to use, propagate, modify
or convey a specific copy of the covered work, then the patent license
you grant is automatically extended to all recipients of the covered
work and works based on it.

  A patent license is "discriminatory" if it does not include within
the scope of its coverage, prohibits the exercise of, or is
conditioned on the non-exercise of one or more of the rights that are
specifically granted under this License.  You may not convey a covered
work if you are a party to an arrangement with a third party that is
in the business of distributing software, under which you make payment
to the third party based on the extent of your activity of conveying
the work, and under which the third party grants, to any of the
parties who would receive the covered work from you, a discriminatory
patent license (a) in connection with copies of the covered work
conveyed by you (or copies made from those copies), or (b) primarily
for and in connection with specific products or compilations that
contain the covered work, unless you entered into that arrangement,
or that patent license was granted, prior to 28 March 2007.

  Nothing in this License shall be construed as excluding or limiting
any implied license or other defenses to infringement that may
otherwise be available to you under applicable patent law.

  12. No Surrender of Others' Freedom.

  If conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot convey a
covered work so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you may
not convey it at all.  For example, if you agree to terms that obligate you
to collect a royalty for further conveying from those to whom you convey
the Program, the only way you could satisfy both those terms and this
License would be to refrain entirely from conveying the Program.

  13. Remote Network Interaction; Use with the GNU General Public License.

  Notwithstanding any other provision of this License, if you modify the
Program, your modified version must prominently offer all users
interacting with it remotely through a computer network (if your version
supports such interaction) an opportunity to receive the Corresponding
Source of your version by providing access to the Corresponding Source
from a network server at no charge, through some standard or customary
means of facilitating copying of software.  This Corresponding Source
shall include the Corresponding Source for any work covered by version 3
of the GNU General Public License that is incorporated pursuant to the
following paragraph.

  Notwithstanding any other provision of this License, you have
permission to link or combine any covered work with a work licensed
under version 3 of the GNU General Public License into a single
combined work, and to convey the resulting work.  The terms of this
License will continue to apply to the part which is the covered work,
but the work with which it is combined will remain governed by version
3 of the GNU General Public License.

  14. Revised Versions of this License.

  The Free Software Foundation may publish revised and/or new versions of
the GNU Affero General Public License from time to time.  Such new versions
will be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.

  Each version is given a distinguishing version number.  If the
Program specifies that a certain numbered version of the GNU Affero General
Public License "or any later version" applies to it, you have the
option of following the terms and conditions either of that numbered
version or of any later version published by the Free Software
Foundation.  If the Program does not specify a version number of the
GNU Affero General Public License, you may choose any version ever published
by the Free Software Foundation.

  If the Program specifies that a proxy can decide which future
versions of the GNU Affero General Public License can be used, that proxy's
public statement of acceptance of a version permanently authorizes you
to choose that version for the Program.

  Later license versions may give you additional or different
permissions.  However, no additional obligations are imposed on any
author or copyright holder as a result of your choosing to follow a
later version.

  15. Disclaimer of Warranty.

  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

  16. Limitation of Liability.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.

  17. Interpretation of Sections 15 and 16.

  If the disclaimer of warranty and limitation of liability provided
above cannot be given local legal effect according to their terms,
reviewing courts shall apply local law that most closely approximates
an absolute waiver of all civil liability in connection with the
Program, unless a warranty or assumption of liability accompanies a
copy of the Program in return for a fee.

                     END OF TERMS AND CONDITIONS

            How to Apply These Terms to Your New Programs

  If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.

  To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
state the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

Also add information on how to contact you by electronic and paper mail.

  If your software can interact with users remotely through a computer
network, you should also make sure that it provides a way for users to
get its source.  For example, if your program is a web application, its
interface could display a "Source" link that leads users to an archive
of the code.  There are many ways you could offer source, and different
solutions will be better for different programs; see section 13 for the
specific requirements.

  You should also get your employer (if you work as a programmer) or school,
if any, to sign a "copyright disclaimer" for the program, if necessary.
For more information on this, and how to apply and follow the GNU AGPL, see
<https://www.gnu.org/licenses/>.
*/
(function(){"use strict";const Blx=BloonixJSFramework();Object.assign(Blx.text.text.en,{"chart.add":"Add charts","chart.attr.title":"Chart","chart.authkey":"Authentication key","chart.change_chart_options_here":"↑ Chart options","chart.chart_views":"Chart views","chart.create":"Create chart view","chart.current_chart_view":"Chart view:<br>%s","chart.howto_add":"Press (↑) the chart button to add charts","chart.info":"Chart information","chart.last_days":"Show the last %s days","chart.last_hours":"Show the last %s hours","chart.list":"Charts","chart.metrics":"Metrics","chart.nothing_selected":"No charts selected","chart.options":"Chart options","chart.per_row":"Charts per row","chart.remove":"Remove chart","chart.update":"Update chart view","colorscheme.dark":"Dark","colorscheme.default":"Default","contact.action.en_dis_able.title":"Enable or disable","contact.attr.escalation_time":"Escalation time","contact.attr.name":"Name","contact.create":"Create a new contact","contact.edit":"Edit contact","contact.escalation_time.after":"After %s","contact.escalation_time.always":"Anytime","contact.help.escalation_time":" With the escalation level it's possible to control when a contact gets notified. As example the escalation level of 30 minutes means that the contact is notified if the service is still not OK after 30 minutes.","contact.list":"Contacts","contact.message_service":"Message service","contact.message_services":"Message services","contact.name":"Contact %s","contact.timeperiods":"Message timeperiods","contact_message_service.attr.name":"Name","contact_message_service.attr.notification_level":"Notification level","contact_message_service.attr.send_to":"Send to","contact_message_service.attr.timeperiod":"Time periods","contact_message_service.contact":"Contact","contact_message_service.help.notification_level":"Status level for which you would like to receive a notification.","contact_message_service.help.timeperiod":"Time ranges in which you want to be informed about events.<br><br><p><b>Syntax: DAY-RANGE TIME-RANGE</b></p><br/> <pre> DAY RANGE                       EXAMPLES<br/> ------------------------------------------------------------<br/> Weekday                         Monday<br/> Weekday - Weekday               Monday - Friday<br/> Month                           Januar<br/> Month - Month                   Januar - July<br/> Month Day                       Januar 1<br/> Month Day - Month Day           Januar 1 - July 15<br/> Year                            2010<br/> Year - Year                     2010 - 2012<br/> YYYY-MM-DD                      2010-01-01<br/> YYYY-MM-DD - YYYY-MM-DD         2010-01-01 - 2012-06-15<br/><br/> TIME RANGE                      EXAMPLES<br/> ------------------------------------------------------------<br/> HH:MM - HH:MM                   09:00 - 17:00<br/> HH:MM - HH:MM, HH:MM - HH:MM    00:00 - 08:59, 17:01 - 23:59 </pre> <br/><p><b>Examples:</b></p><br/> <pre> Monday - Friday     09:00 - 17:00<br/> Monday - Friday     00:00 - 08:59, 17:01 - 23:59<br/> Saturday - Sunday   00:00 - 23:59 </pre><br/> <br/><p><b>A minus sign in front means to exclude the time range:</b></p><br/> <pre> Monday - Sunday 00:00 - 23:59     --\x3e all time<br/> - Monday - Sunday 01:00 - 02:00   --\x3e but not between 1 and 2 o'clock </pre>","contactgroup.attr.name":"Name","contactgroup.create":"Create a new contact group","contactgroup.edit":"Edit contact group","contactgroup.list":"Contact groups","contactgroup.text.contact_add_selected":"Add contacts to group","contactgroup.text.contact_member":"Contacts in group","contactgroup.text.contact_no_member":"Contacts not in group","contactgroup.text.contact_remove_selected":"Remove contacts from group","contactgroup.text.contacts":"Contacts","contactgroup.text.host_add_selected":"Add hosts to group","contactgroup.text.host_member":"Hosts in group","contactgroup.text.host_no_member":"Hosts not in group","contactgroup.text.host_remove_selected":"Remove hosts from group","contactgroup.text.hosts":"Hosts","contactgroup.text.service_add_selected":"Add Services to group","contactgroup.text.service_member":"Services in group","contactgroup.text.service_no_member":"Services not in group","contactgroup.text.service_remove_selected":"Remove Services from group","contactgroup.text.services":"Services","dashboard.add_dashlet":"Add a dashlet","dashboard.cancel_edit":"Cancel editing","dashboard.category":"Category of the dashboard","dashboard.clock":"Time of day","dashboard.create":"Create a new dashboard","dashboard.delete":"Delete dashboard","dashboard.edit":"Edit dashboard","dashboard.is_default":"This is the default dashboard.","dashboard.list":"Dashboards","dashboard.name":"Dashbord: %s","dashboard.name_of":"Name of the dashboard","dashboard.open":"Open dashboard","dashboard.remove_dashlet":"Remove the dashlet","dashboard.save":"Save dashboard","dashboard.select_dashlet":"Select the dashlet you want to add to the dashboard","dashboard.set_default":"Set a default","dashboard.update":"Dashboard settings","dashlet.chart.title":"Chart","dashlet.clock.title":"Clock","dashlet.default.reload_interval.0":"disabled","dashlet.default.reload_interval.10":"10 seconds","dashlet.default.reload_interval.120":"2 Minutes","dashlet.default.reload_interval.180":"3 Minutes","dashlet.default.reload_interval.30":"30 seconds","dashlet.default.reload_interval.300":"5 Minutes","dashlet.default.reload_interval.60":"1 Minute","dashlet.default.reload_interval.600":"10 Minutes","dashlet.default.show_columns":"Show or hide columns","dashlet.events.title":"Latest Events","dashlet.host_counter.title":"Number of hosts according to certain criteria","dashlet.hosts.title":"Hosts","dashlet.monitoring_screen.title":"Monitoring screen","dashlet.reload_interval":"Reload interval","dashlet.service_counter.title":"Number of services according to certain criteria","dashlet.service_status.title":"Service status","dashlet.services.title":"Services","dependency.attr.on_host_id":"Depends on host","dependency.attr.on_service_id":"Depends on service","dependency.attr.on_status":"Depends on status","dependency.attr.status":"Suppressed status","dependency.create":"Create a new dependency","dependency.create.step1":"Select a service for which you want to set up a dependency.","dependency.create.step2":"Select the host to which the dependency exists.","dependency.create.step3":"Select a service to which the dependency exists.","dependency.create.step4":"For which status of service %s should notifications be suppressed?","dependency.create.step5":"Which status of service %s of the host %s activates the suppression of the notification?","dependency.itemdesc":"If service %s is in status %s and if the service %s of host %s is in status %s, then notifications are suppressed.","dependency.title":"Dependencies","downtime.attr.begin":"Begin","downtime.attr.description":"Description","downtime.attr.end":"End","downtime.attr.timeslice":"Timeslice","downtime.attr.timezone":"Timezone","downtime.attr.username":"Added by","downtime.fix_time":"Fix time","downtime.fix_time_description":"Attention! Fixed times are automatically deleted after they expire.","downtime.preset":"Preset","downtime.preset_help":"With this option, the current time is used as the start value. The end is the current time plus the selected option.","downtime.timeslice":"Timeslice","downtimes.host_downtimes":"Scheduled downtimes for all services","downtimes.service_downtimes":"Scheduled downtimes for single services","downtimes.title":"Scheduled downtimes","err-800":"Additional services cannot be created because the limit has been reached.","err-801":"This service can only be deleted via the corresponding template.","err-802":"This service can only be changed via the corresponding template.","err-803":"The period must not exceed 7 days","err-804":"The username 'demo' is not allowed","event.attr.duration":"Duration","event.attr.last_status":"Last status","event.attr.tags":"Tags","event.debug":"Extended debug message","event.latest":"Latest events","event.list":"Events","form.absolute_time_range":"Custom date","form.from_time":"From time","form.predefined_time_range":"Predefined time","form.to_time":"To time","group.attr.name":"Group name","group.create":"Create a new group","group.delete":"Delete group","group.edit":"Edit group","group.list":"Host groups","group.name":"Group %s (ID: %s)","group.text.host_add_selected":"Add hosts to group","group.text.host_member":"Hosts in group","group.text.host_no_member":"Hosts not in group","group.text.host_remove_selected":"Remove hosts from group","group.text.hosts":"Hosts","group.text.user_add_selected":"Add users to group","group.text.user_member":"Users in group","group.text.user_no_member":"Users not in group","group.text.user_remove_selected":"Remove users from group","group.text.users":"Users","host.add_to_contactgroup":"Add to contact group","host.add_to_host_group":"Add to host group","host.add_to_location_group":"Add to location group","host.add_to_template_group":"Add to template","host.attr.allow_from":"Allow from","host.attr.country_code":"Location of the host","host.attr.description":"Description","host.attr.enabled":"Enabled","host.attr.hostname":"Hostname","host.attr.id":"Host ID","host.attr.interval":"Interval","host.attr.ipaddr1":"1. IP-Address","host.attr.ipaddr2":"2. IP-Address","host.attr.ipaddr3":"3. IP-Address","host.attr.ipaddr4":"4. IP-Address","host.attr.location_class":"Location class","host.attr.notification_enabled":"Notifications enabled","host.attr.notification_interval":"Notification interval","host.attr.project_class":"Project class","host.attr.retry_interval":"Retry interval","host.attr.status":"Max status","host.attr.sysinfo":"System information","host.attr.timeout":"Timeout","host.attr.variables":"Host variables","host.continue_without_ip_address":"Continue without IP address","host.create":"Create a new host","host.dashlet.active_downtimes":"Services with downtime","host.dashlet.count_events":"Events in the last 24 hours","host.dashlet.flapping_services":"Flapping services","host.dashlet.latest_availability":"Availability in the last 24 hours","host.dashlet.latest_notifications":"Notifications in the last 24 hours","host.dashlet.services_not_ok":"Services not OK","host.delete":"Delete host","host.disabled":"Monitoring of the host is disabled","host.edit":"Edit host (ID %s)","host.get_ip_address":"Query the IP address","host.has_downtime":"Host has active downtime","host.help.allow_from":"Specify source IPs and networks from which the agent is allowed to connect.","host.help.country_code":"Select the location of the host by country code.","host.help.description":"This is a opt description of the host.","host.help.enabled":"Enable or disable the host and all services.","host.help.hostname":"This is the fully qualified hostname.","host.help.interval":"This is the check interval of all services of the host.","host.help.ipaddr":"IP address of the host. <br/><br/>Note that prepend zeros are not allowed: <br/><br/><i>010.005.008.001</i> or <i>0001::0001</i> are not allowed <br/><i>10.5.8.1</i> or <i>1::1</i> are allowed","host.help.location_class":"Examples:<br/> <br/>/EU/Germany/Hamburg/DC1/Rack10 <br/>/EU/France/Nancy/DC3/Rack12","host.help.notification_enabled":"Enable or disable the notifications of all services.","host.help.notification_interval":"This is the notification interval of the host.","host.help.password":"This password is used by the Bloonix Agents that want to collect for services configured with agent location 'localhost'. If an agent wants to connect to the Bloonix server to deliver host statistics then this is only possible if the agent knows the host id and the password.","host.help.project_class":"Examples:<br/> <br/>/Bloonix/Homepage/Loadbalancer <br/>/Bloonix/Homepage/Database <br/>/Bloonix/Mailserver/Mailin <br/>/Bloonix/Mailserver/Mailout","host.help.retry_interval":"This is the retry interval of all services of the host. If a service is not in OK status then the interval is forced to this value.","host.help.sysinfo":"This field allows you to set an external link to you own host documentation, e.g.:<br/><br/>Linktext=https://url/?id=12345","host.help.timeout":"This is the timeout of all services of the host. The timeout counter begins after the interval. If the status of a service is not updated in this time then a critical status is set for the services with the information that it seems that the Bloonix agent is not working.","host.help.variables":"In this field you can define host variables. These variables can be used for thresholds by the configuration of service checks. Example:<br/><br/>HTTP.PORT=9000<br/><br/>This variable could be used in the format <i>%HTTP.PORT%</i> for thresholds. Please note that two variables are pre-defined: <i>IPADDR</i> and <i>HOSTNAME</i>. These variables are replaced with the IP address and the hostname of the host. For further information read the help.<br/><br/>Allowed signs: a-z, A-Z, 0-9, dot and underscore","host.list":"Hosts","host.member_of_contactgroup":"Contact groups membership","host.member_of_host_group":"Host groups membership","host.member_of_location_group":"Location groups membership","host.member_of_template_group":"Template groups membership","host.nav.charts":"Charts","host.nav.contactgroups":"Contact groups","host.nav.dependencies":"Dependencies","host.nav.downtimes":"Downtimes","host.nav.events":"Events","host.nav.groups":"Groups","host.nav.location_groups":"Location groups","host.nav.metadata":"Meta data","host.nav.notifications":"Notifications","host.nav.report":"Report","host.nav.services":"Services","host.nav.templates":"Templates","host.new_host_main_desc":"The host %s was successfully created. You can choose between 2 of the following options to set up the Bloonix agent. The actions must be carried out on the target system that is to be monitored.","host.new_host_setup_command":"Either you execute the following command","host.new_host_setup_manual":"Or enter the following text in the file <b><i>/etc/bloonix/agent/conf.d/host.conf</i></b>","host.new_host_title":"New host configuration","host.notifications_disabled":"Notifications are disabled","host.really_delete":"Do you really want to delete host %s?","host.remove_from_contactgroup":"Remove from contact groups","host.remove_from_host_group":"Remove from host groups","host.remove_from_location_group":"Remove from location groups","host.remove_from_template_group":"Remove from template groups","host.status_count":"Service status","host.title.enter_hostname":"Please enter the hostname for the new host","host.title.groups":"Groups","host.title.services":"Services","host.title.templates":"Templates","host.title.variables":"Variables","location_group.attr.name":"Name","location_group.attr.password":"Password","location_group.create":"Create a new location group","location_group.title":"Location groups","main.fullscreen":"Fullscreen","main.fullscreen_off":"Fullscreen off","main.leave_fullscreen":"Press escape to exit the fullscreen mode","message_service.attr.message_template":"Message template:","message_service.attr.name":"Name","message_service.attr.type":"Type","message_service.attr.variables":"Variables","message_service.create":"Create a new message service","message_service.delete_warning":"Attention: If you delete a messaging service, it will also be removed from all contacts!","message_service.form.title":"Information","message_service.help.message_template":"The message template defines the content of the %message% variable. Since more than one service can appear in the message, a list of all services must be processed in a loop. The loop starts with %begin_loop% and ends with %end_loop%. Service relevant variables are as follows: <br/><br/>%service_id% - the ID of the service <br/>%service_name% - the name of the service <br/>%service_status% - the status of the service <br/>%service_message% - the message of the service <br/><br/>Example: <br/><br/>%begin_loop% <br/>--- <br/>Service ID: %service_id% <br/>Service: %service_name% <br/>Status: %service_status% <br/>Message: %service_message% <br/>%end_loop%","message_service.help.variables":"Predefined variables can be used in the message template as well as in the individual form fields. When setting up SMS notifications, only use %short_message% in the template. Otherwise, the message may be split into multiple SMS, resulting in significant additional costs. <br/> <br/>%host_id% - the host ID <br/>%hostname% - the hostname <br/>%host_description% - the description of the host <br/>%ipaddr% - the 1. IP Adresse of the host <br/>%date% - the date when the message was generated <br/>%unixtime% - the unixtime when the message was generated <br/>%send_to% - the sending address of the contact <br/>%sum_status% - a summary of the status, especially suitable for SMS <br/>%short_message% - a short message that is adjusted to SMS size <br/>%message% - the generated message from the template","message_service.help.variables_title":"Global variables","message_service.http.description":"The message service HTTP is a builtin script from Bloonix. Messages can be sent via an HTTP interface. The data can be sent as URL encoded messages or as JSON.","message_service.http.help.auth_basic":"HTTP auth basic string. The format is user:password.","message_service.http.help.check_content":"The response of the HTTP request can be checked with a regular expression. If the sending of the message was not successful, then the sending will be tried again at the next check interval.","message_service.http.help.data_type":"Postdata url encoded:<br>One parameter and value per line. Parameter and the value will be url encoded. <br><br>JSON data:<br>Pass a JSON string. If no content type is specified, it is set to application/json. <br><br>POST data, raw format:<br>The data will be converted to a bytes string via with encoding utf-8. If no content type is specified, it is set to text/plain.","message_service.http.help.header":"The name is entered in the left column and the value in the right column.","message_service.http.help.insecure":"This option can be used to disable the validation of SSL certificates.","message_service.http.help.postdata":"Data you want to send as post data. The data should be formatted in the way the webserver expects the data.","message_service.http.help.postdata_json":'JSON data for POST requests. The data is not URL encoded. Example: {"message":"%message%"}',"message_service.http.help.postdata_raw":"Raw format.","message_service.http.help.postdata_urlencoded":"The name is entered in the left column and the value in the right column. The data will be url-encoded.","message_service.http.help.user_agent":"The default is Bloonix-Monitoring-Message-Service.","message_service.http.param.auth_basic":"Auth Basic","message_service.http.param.check_content":"Expected HTTP response","message_service.http.param.check_status_code":"Expected HTTP status code","message_service.http.param.data_type":"The type of the POST data.","message_service.http.param.header":"HTTP header","message_service.http.param.insecure":"Allow insecure certificates","message_service.http.param.postdata":"POST data","message_service.http.param.postdata_json":"JSON data","message_service.http.param.postdata_raw":"POST data, raw format","message_service.http.param.postdata_urlencoded":"Postdata url encoded","message_service.http.param.url":"URL","message_service.http.param.user_agent":"User Agent","message_service.list":"Message services","message_service.script.description":"With the message service script you can use your own scripts to send messages. The script must be placed in the directory configured in the Bloonix server with the message_service_script_path parameter. By default this is the path /usr/local/lib/bloonix/message-service. All parameters configured in this form are passed to the script via STDIN in JSON format.","message_service.script.help.params":"The parameters are passed to the script via STDIN.","message_service.script.help.script":"The script that will be used to send the message. The name of the script may only contain the following characters: a-zA-Z_0-9.-","message_service.script.param.params":"Script parameter","message_service.script.param.script":"Script","message_service.sendmail.description":"The messaging service Sendmail is a built-in script in Bloonix. If the parameters <i>SMTP Server</i>, <i>Username</i>, or <i>Password</i> are set, the mail will be sent via SMTP SSL to the SMTP server. If the parameters are not set, the mail will be sent using <i>/usr/sbin/sendmail</i>. For this, an MTA must be installed on the server where the Bloonix server is also running.","message_service.sendmail.help.message":"Here it is best to set %message% as the value. The message is built using the message","message_service.sendmail.help.send_to":"The recipient of the message. With %SEND_TO% the address of the contact is used.","message_service.sendmail.param.host":"SMTP Server","message_service.sendmail.param.message":"Message","message_service.sendmail.param.password":"SMTP Password","message_service.sendmail.param.send_to":"Recipient","message_service.sendmail.param.sender":"Sender","message_service.sendmail.param.subject":"Mail Subject","message_service.sendmail.param.username":"SMTP Username","nav.main.charts":"Charts","nav.main.chpwd":"Change password","nav.main.config":"Configuration","nav.main.contactgroups":"Contact groups","nav.main.contacts":"Contacts","nav.main.dashboard":"Dashboards","nav.main.events":"Events","nav.main.groups":"Host groups","nav.main.help":"Help","nav.main.hosts":"Hosts","nav.main.language":"Language","nav.main.location_groups":"Location groups","nav.main.logout":"Logout","nav.main.message_services":"Message services","nav.main.monitoring":"Overview","nav.main.notification":"Notification","nav.main.registration":"Host registration","nav.main.satellites":"Satellites","nav.main.services":"Services","nav.main.style":"Style settings","nav.main.sys_options":"System settings","nav.main.system_dashboard":"System Dashboard","nav.main.templates":"Templates","nav.main.timeperiods":"Timeperiods","nav.main.timezone":"Timezone","nav.main.user_settings":"My settings","nav.main.users":"Users","plugin.attr.service":"Plugin","regauth.attr.activate":"Activate","regauth.attr.allowed_tags":"Allowed tags","regauth.attr.authkey":"Authentication key","regauth.attr.network":"Host network","regauth.attr.tags":"Default tags","regauth.create":"Create a new authentication keys","regauth.help.activate":"Here you define whether the host should be automatically activated for monitoring.","regauth.help.allowed_tags":"This parameter defines the template tags that may be used during registration.","regauth.help.network":"Only hosts whose IP is in this network can use the authkey.","regauth.help.tags":"Define default template tags that will be automatically assigned to the host.","regauth.list":"Authentication keys","regauth.text.add_additional_groups":"Add addional groups","regauth.text.add_hosts":"Add hosts and activate","regauth.text.contactgroups":"Contact groups","regauth.text.contactgroups_add_selected":"Add contact groups","regauth.text.contactgroups_remove_selected":"Remove contact groups","regauth.text.groups":"Host groups","regauth.text.groups_add_selected":"Add host groups","regauth.text.groups_remove_selected":"Remove host groups","regauth.text.location_groups":"Location groups","regauth.text.location_groups_add_selected":"Add location groups","regauth.text.location_groups_remove_selected":"Remove location groups","regauth.text.templates":"Templates","regauth.text.templates_add_selected":"Add templates","regauth.text.templates_by_tag":"Templates by tags","regauth.text.templates_remove_selected":"Remove templates","registration.auth":"Auth configuration","registration.hosts":"Host registration","report.availability":"Availability","report.event_b15":"Lower than 15 minutes","report.event_b180":"Zwischen 1 and 3 hours","report.event_b30":"Beween 15 and 30 minutes","report.event_b60":"Zwischen 30 and 60 minutes","report.event_bx":"Longer than 3 hours","report.events":"Events","report.events_by_status":"Events by status","report.events_by_time_of_day":"Events by time of day","report.number_of_events_by_duration":"Number of events by duration","report.number_of_tags":"Number of events by tags","report.status_duration_in_percent":"Status duration","report.total_availability":"Total","satellite.attr.authkey":"Authentication key","satellite.attr.city":"City","satellite.attr.country":"Country","satellite.attr.hostname":"Hostname","satellite.attr.ipaddr1":"1. IP address","satellite.attr.ipaddr2":"2. IP address","satellite.attr.port":"Port","satellite.create":"Create a new satellite","satellite.delete":"Delete satellite","satellite.edit":"Edit satellite","satellite.list":"Satellites","service.action.acknowledge":"Acknowledge service status","service.action.acknowledge.title":"Acknowledge the status or clear the status acknowledgements","service.action.downtime.title":"Schedule downtime","service.action.en_dis_able.title":"Enable or disable","service.action.forcecheck":"Force next service check","service.action.forcecheck.title":"Reset the check interval and force the next check","service.action.hosts.title":"The action is performed to all selected hosts and/or services of the host.","service.action.notification.title":"Enable or disable notifications","service.action.notifications.disable":"Disable notifications","service.action.notifications.enable":"Enable notifications","service.action.services.title":"The action is performed to all selected services.","service.attempts":"Attempts","service.attr.acknowledged":"Service status acknowledged","service.attr.agent_version":"Agent version","service.attr.attempt_max":"Max attempts","service.attr.command":"Command","service.attr.description":"Description","service.attr.enabled":"Enabled","service.attr.fd_enabled":"Flap detection enabled","service.attr.fd_flap_count":"Notifiy after X status switches","service.attr.fd_time_range":"Flap detection time range","service.attr.has_downtime":"Service has active downtime","service.attr.host_alive_check":"Host alive check","service.attr.id":"Service ID","service.attr.interval":"Interval","service.attr.is_flapping":"Service is flapping","service.attr.last_check":"Last check","service.attr.message":"Message","service.attr.notification_enabled":"Notifications enabled","service.attr.notification_interval":"Notification interval","service.attr.remote_check":"Remote check","service.attr.retry_interval":"Retry interval","service.attr.service_name":"Service name","service.attr.status":"Status","service.attr.status_since":"Status since","service.attr.tags":"Tags","service.attr.timeout":"Timeout","service.available_variables":"List of available variables","service.available_variables_help":"This service comes from a host template and can only be customized via variables.","service.clone":"Clone service","service.clone_another_host":"Select another host","service.clone_same_host":"Clone to the same host","service.create":"Create a new service","service.default_check_type":"The check is executed from the Bloonix-Server.","service.default_check_type_title":"No satellite","service.disabled":"Check is disabled","service.help.acknowledged":"This option is useful if a service is not OK and if you want to disable the notifications temporary. The notifications will be enabled again if the services switched to the status OK.","service.help.attempt_max":"This option controls when you get a notification of services that are not in status OK. As example a value of 3 means that you get a notification first if the service check returns 3 times in a row a not OK status.","service.help.enabled":"This option enables or disables the service check.","service.help.fd_enabled":"This option enables or disables the flap detection. The flap detection is very useful to detect services that switches between OK and not OK in a very opt time and when the counter of <i>attempt max</i> is never reached. The flap detection checkes how many times a service switched between different states in a given time. If the status switched too many times, then a notification will be triggered.","service.help.fd_flap_count":"This is the threshold for the flap detection. If more than x-times the status switched in a given time a notificaton is triggered.","service.help.fd_time_range":"This is the period the flap detection checks for status switches.","service.help.host_alive_check":"A host alive check is a check that determines if a host is down or alive. If this check returns a critical status then you get a special notification. If another service check returns a critical status at the same time then the notifications will be suppressed. It's recommended to use a ping check as host alive check.","service.help.interval":"This is the check interval of the service. If no value is set, then the interval of the host is inherited.","service.help.notification_enabled":"This option activates or de-activates the notification system.","service.help.notification_interval":"This is the notification interval for the service. As long as the service is not OK you will be re-notified in this interval. If no value is set, then the interval of the host is inherited.","service.help.passive_check":"A passive check is a check which is not checked by Bloonix itself, but by an external service or script. Passive checks have no timeout and are very useful, for example, for SNMP traps. The external service has to report a critical state to the Bloonix-Agent, which in turn reports the state to the Bloonix-Server.","service.help.remote_check":"By default, checks are executed by the Bloonix agent installed on the system to be monitored, such as CPU Load. However, there are checks that can be checked via a network connection. If remote check is enabled, then the check will be executed either from the Bloonix-Server or from a Bloonix-Satellite.","service.help.retry_interval":"This is the retry interval of the service. If a service is not in OK status then the interval is forced to this value. If no value is set, then the retry interval setting of the host is inherited.","service.help.service_name":"This is the display name of the service.","service.help.timeout":"This is the timeout of the service and begins to count after the interval. If the status of the service is not updated in this time then a critical status is set for the service with the information that it seems that the Bloonix agent is not working. If no value is set, then the timeout of the host is inherited.","service.host_enabled":"Host enabled","service.host_notification_enabled":"Host notifications enabled","service.inherited_from_host":"Inherited from the host","service.list":"Services","service.no_variables_defined":"No variables defined.","service.notifications_disabled":"Notifications disabled","service.rotate_check_type":"<b>How it works</b><br/> The satellites are suitable for checking the availability of a service from different locations. At each interval, the service is checked from a different location, rotating across all locations.","service.rotate_check_type_title":"Select satellites","service.select_location_check_type":"Select the type of the check","service.select_plugin":"Select a plugin","service.set_variable_host":"Value from host variables: %s","service.set_variable_template":"Value from template variables: %s","service.status":"Service status","service.status_switched":"The status has changed within the last hour","service.template":"Template: %s","sys_options.attr.event_history":"Event history","sys_options.attr.force_email_usernames":"Force E-Mail usernames","sys_options.attr.has_maintenance":"Enable/Disable global maintenance mode","sys_options.attr.max_password_length":"Max password length","sys_options.attr.min_password_length":"Min password length","sys_options.attr.notification_history":"Notification history","sys_options.attr.password_policy":"Password policy","sys_options.attr.password_policy_letter":"Password policy: regular expression for letters","sys_options.attr.password_policy_lowercase":"Password policy: regular expression for lowercase letters","sys_options.attr.password_policy_number":"Password policy: regular expression for numbers","sys_options.attr.password_policy_special":"Password policy: regular expression for special signs","sys_options.attr.password_policy_uppercase":"Password policy: regular expression for uppercase letters","sys_options.attr.result_history":"Web transaction result history","sys_options.attr.server_names":"Bloonix Server Hostnames","sys_options.attr.stat_history":"Metric history","sys_options.attr.stat_hourly_history":"Aggregated metric history","sys_options.attr.user_tracking_history":"Audit protocol history","sys_options.help.has_maintenance":"Attention!<br/><br/>If you enable the maintenance mode then the complete notification system is disabled until you disable the maintenance mode manually.","sys_options.help.password_policy":"The password policy defines which characters must appear at least once in a password.","sys_options.help.password_policy_regex":"The value is embedded in a regular expression (Python) in square brackets. Example [a-z]. Please specify the value without square brackets.","sys_options.help.password_policy_regex_special":"The value is embedded in a regular expression (Python) in square brackets. Example [;#+]. Please specify the value without square brackets. Please do not use escape character for special characters.","sys_options.help.server_names":"The hostnames or IP addresses of all Bloonix servers must be entered here. This information is used when creating new hosts.","sys_options.help.value_in_days":"Specified in days","sys_options.help.value_in_months":"Specified in months","sys_options.label.letter":"Letter","sys_options.label.lowercase":"Lowercase letter","sys_options.label.number":"Number","sys_options.label.special":"Special sign","sys_options.label.uppercase":"Uppercase letter","sys_options.maintenance.warning":"Attention!<br/><br/>The maintenance mode of Bloonix is active and the notification system is disabled.","template.add_selected_hosts":"Add hosts","template.attr.name":"Name","template.attr.tags":"Tags","template.attr.variables":"Template variables","template.create":"Create a new template","template.delete":"Delete template","template.edit":"Edit template","template.help.tags":"Tags can be used to automatically assign new hosts to a template.","template.hosts":"Hosts","template.hosts_member":"Hosts in group","template.hosts_no_member":"Add hosts to group","template.list":"Host templates","template.remove_selected_hosts":"Remove hosts","template.services":"Services","timeperiod.attr.name":"Name","timeperiod.attr.timeslice":"Time slice","timeperiod.create":"Create a time period","timeperiod.edit":"Edit time period","timeperiod.help.timeslice":"<p><b>Syntax: DAY-RANGE TIME-RANGE</b></p><br/> <pre> DAY RANGE                       EXAMPLES<br/> ------------------------------------------------------------<br/> Weekday                         Monday<br/> Weekday - Weekday               Monday - Friday<br/> Month                           Januar<br/> Month - Month                   Januar - July<br/> Month Day                       Januar 1<br/> Month Day - Month Day           Januar 1 - July 15<br/> Year                            2010<br/> Year - Year                     2010 - 2012<br/> YYYY-MM-DD                      2010-01-01<br/> YYYY-MM-DD - YYYY-MM-DD         2010-01-01 - 2012-06-15<br/><br/> TIME RANGE                      EXAMPLES<br/> ------------------------------------------------------------<br/> HH:MM - HH:MM                   09:00 - 17:00<br/> HH:MM - HH:MM, HH:MM - HH:MM    00:00 - 08:59, 17:01 - 23:59 </pre> <br/><p><b>Examples:</b></p><br/> <pre> Monday - Friday     09:00 - 17:00<br/> Monday - Friday     00:00 - 08:59, 17:01 - 23:59<br/> Saturday - Sunday   00:00 - 23:59 </pre><br/> <br/><p><b>A minus sign in front means to exclude the time range:</b></p><br/> <pre> Monday - Sunday 00:00 - 23:59     --\x3e all time<br/> - Monday - Sunday 01:00 - 02:00   --\x3e but not between 1 and 2 o'clock </pre>","timeperiod.list":"Time periods","user.2fa_enter":"Please enter the code","user.2fa_title":"2 Factor Authentication","user.2fa_trust_browser":"Do you want to trust the browser?","user.2fa_trust_browser_info":"If you trust the browser, we store a special cookie together with part of your IP address for 30 days. If your IP address changes significantly or the cookie is deleted, you will have to log in again with a 2-factor code for security reasons.","user.add_to_group":"Add to group","user.attr.2fa_addr":"2 factor authentication","user.attr.filter_by_group":"Filter by group","user.attr.force_password_change":"Force password change","user.attr.language":"Language","user.attr.last_login":"Last login","user.attr.locked":"Locked","user.attr.name":"Name","user.attr.password":"Password","user.attr.phone":"Phone","user.attr.role":"Role","user.attr.username":"Username","user.change_initial_password":"This seems to be your first login. To continue, you must first change the initial login password. Click the %s button at the password input to get more information about the password requirements.","user.change_password":"Change your password","user.create":"Create a new user","user.current_password":"Current password","user.delete":"Delete user","user.demo":"The demo user cannot be changed.","user.edit":"Edit user","user.groups":"Gruppen","user.help.2fa_addr":"An address is required for 2-factor authentication.","user.help.filter_by_group":"This parameter defines whether the user is only allowed to see the hosts, services and events that are configured in his group. If the parameter is not activated, the user may see all hosts, services and events.","user.help.force_password_change":"If the value is set to 'yes', the user will be prompted to change his password.","user.help.locked":"Locked user can't login to the WebGUI.","user.help.role":"<b>admin</b> - Administrator account with full rights.<br/><br/> <b>operator</b> - Operator account with full rights, but with the exception that operators has no rights to alter user accounts.<br/><br/> <b>user</b> - Default User with read only access.","user.help.username":"The E-Mail of the user, which is used as login name.","user.list":"Users","user.new_password":"New password","user.password_policy.info":"At least one character from each of the following character classes must be included in the password:","user.password_policy_letter":"Letters: %s","user.password_policy_lowercase":"Lowercase letters: %s","user.password_policy_number":"Numbers: %s","user.password_policy_special":"Special signs: %s","user.password_policy_uppercase":"Uppercase letters: %s","user.remove_from_group":"Remove from group","user.repeat_new_password":"Repeat new password","user.welcome":"Hello and welcome to Bloonix","var.timeslice":"<p><b>Syntax: DAY-RANGE TIME-RANGE</b></p><br/> <pre> DAY RANGE                       EXAMPLES<br/> ------------------------------------------------------------<br/> Weekday                         Monday<br/> Weekday - Weekday               Monday - Friday<br/> Month                           Januar<br/> Month - Month                   Januar - July<br/> Month Day                       Januar 1<br/> Month Day - Month Day           Januar 1 - July 15<br/> Year                            2010<br/> Year - Year                     2010 - 2012<br/> YYYY-MM-DD                      2010-01-01<br/> YYYY-MM-DD - YYYY-MM-DD         2010-01-01 - 2012-06-15<br/><br/> TIME RANGE                      EXAMPLES<br/> ------------------------------------------------------------<br/> HH:MM - HH:MM                   09:00 - 17:00<br/> HH:MM - HH:MM, HH:MM - HH:MM    00:00 - 08:59, 17:01 - 23:59 </pre> <br/><p><b>Examples:</b></p><br/> <pre> Monday - Friday     09:00 - 17:00<br/> Monday - Friday     00:00 - 08:59, 17:01 - 23:59<br/> Saturday - Sunday   00:00 - 23:59 </pre><br/> <br/><p><b>A minus sign in front means to exclude the time range:</b></p><br/> <pre> Monday - Sunday 00:00 - 23:59     --\x3e all time<br/> - Monday - Sunday 01:00 - 02:00   --\x3e but not between 1 and 2 o'clock </pre>","wtrm.action.checkDownload":"Check if a file was downloaded","wtrm.action.checkIfElementExists":"Check if an element exists","wtrm.action.checkIfElementHasHTML":"Check if an element contains HTML","wtrm.action.checkIfElementHasNotHTML":"Check if an element does not contain HTML","wtrm.action.checkIfElementHasNotText":"Check if an element does not contain text","wtrm.action.checkIfElementHasNotValue":"Check if an input field or textarea has not a specified value","wtrm.action.checkIfElementHasText":"Check if an element contains text","wtrm.action.checkIfElementHasValue":"Check the value of an input field or textarea","wtrm.action.checkIfElementIsChecked":"Check if a radio button or checkbox is checked","wtrm.action.checkIfElementIsNotChecked":"Check if a radio button or checkbox is not checked","wtrm.action.checkIfElementIsNotSelected":"Check if a value is not selected in a selectbox","wtrm.action.checkIfElementIsSelected":"Check if a value is selected in a selectbox","wtrm.action.checkIfElementMatchText":"Check if an element match text","wtrm.action.checkIfElementNotExists":"Check if an element does not exists","wtrm.action.checkUrl":"Check the URL in the address bar","wtrm.action.doAddCookie":"Add a cookie","wtrm.action.doAuth":"Set auth basic username and password","wtrm.action.doCheck":"Check a radio button or checkbox","wtrm.action.doClick":"Click on a element","wtrm.action.doFill":"Fill data into a input field or textarea","wtrm.action.doSelect":"Select a value from a selectbox","wtrm.action.doSleep":"Suspend the execution","wtrm.action.doSubmit":"Submit a form","wtrm.action.doSwitchToFrame":"Switch to frame","wtrm.action.doSwitchToMainPage":"Switch to main page","wtrm.action.doSwitchToNewPage":"Switch to new created page","wtrm.action.doSwitchToParentFrame":"Switch to parent frame","wtrm.action.doTriggerEvent":"Trigger an event on a element","wtrm.action.doUncheck":"Uncheck a radio button or checkbox","wtrm.action.doUrl":"Go to URL","wtrm.action.doUserAgent":"Set the user agent for all requests","wtrm.action.doWaitForElement":"Wait for element","wtrm.attr.content_type":"Content Type","wtrm.attr.domain":"Domain","wtrm.attr.element":"Element","wtrm.attr.event":"Event","wtrm.attr.filename":"File name","wtrm.attr.hidden":"Hidden","wtrm.attr.html":"HTML","wtrm.attr.ms":"Milliseconds","wtrm.attr.name":"Name","wtrm.attr.parent":"Parent element","wtrm.attr.status":"Status","wtrm.attr.text":"Text","wtrm.attr.url":"URL","wtrm.attr.user_agent":"User Agent","wtrm.attr.value":"Value","wtrm.check":"Check Workflow","wtrm.check_quick":"Quick Check","wtrm.click_info":"Click on a result to view the details here.","wtrm.failed":"Workflow failed:","wtrm.help.element":"The element you want to select. As example: #id, .class, name<br/><br/> It's also possible to search for tags and attributes. Example:<br/><br/> &lt;a&gt; - get the first 'a' tag<br/><br/> &lt;a[5]&gt; - get the fifth 'a' tag<br/><br/> &lt;a a=\"hello\" b=\"world\"&gt; - search for a 'a' tag with the specified attributes and values","wtrm.help.parent":"Specify a parent element in the format '#id'. This can be helpful, for example, if there are several forms on a page and you want to address a specific form.","wtrm.loading":"Waiting for the result...","wtrm.step.checkDownload":"Check if file %s was downloaded","wtrm.step.checkIfElementExists":"Check if the element %s exists","wtrm.step.checkIfElementHasHTML":"Check if the element %s contains %s","wtrm.step.checkIfElementHasNotHTML":"Check if the element %s does NOT contain %s","wtrm.step.checkIfElementHasNotText":"Check if the element %s does NOT contain %s","wtrm.step.checkIfElementHasNotValue":"Check if the input field or textarea with element %s does NOT contain %s","wtrm.step.checkIfElementHasText":"Check if the element %s contains %s","wtrm.step.checkIfElementHasValue":"Check if the input field or textarea with element %s contains %s","wtrm.step.checkIfElementIsChecked":"Check if the radio button or checkbox %s is checked","wtrm.step.checkIfElementIsNotChecked":"Check if the radio button or checkbox %s is NOT checked","wtrm.step.checkIfElementIsNotSelected":"Check if the value %s of the selectbox %s is NOT selected","wtrm.step.checkIfElementIsSelected":"Check if the value %s of the selectbox %s is selected","wtrm.step.checkIfElementMatchText":"Check if the element %s match %s","wtrm.step.checkIfElementNotExists":"Check if the element %s does NOT exists","wtrm.step.checkUrl":"Check if the URL in the address bar is %s","wtrm.step.checkUrlWithContentType":"Check if the URL %s has content type %s","wtrm.step.doAddCookie":"Add cookie %s=%s domain %s","wtrm.step.doAuth":"Authenticte with username %s and password %s","wtrm.step.doCheck":"Check if the radio button or checkbox of element %s with value %s is checked","wtrm.step.doClick":"Click on element %s","wtrm.step.doFill":"Fill element %s with value %s","wtrm.step.doSelect":"Select the value %s from the selectbox %s","wtrm.step.doSleep":"Sleep %sms","wtrm.step.doSubmit":"Submit form %s","wtrm.step.doSwitchToFrame":"Switch to frame %s","wtrm.step.doSwitchToMainPage":"Switch to main page","wtrm.step.doSwitchToNewPage":"Switch to new created page","wtrm.step.doSwitchToParentFrame":"Switch to parent frame","wtrm.step.doTriggerEvent":"Trigger event %s on element %s","wtrm.step.doUncheck":"Uncheck the radio button or checkbox %s with value %s","wtrm.step.doUrl":"Go to URL %s","wtrm.step.doUserAgent":"Set the user agent to %s","wtrm.step.doWaitForElement":"Wait for element %s","wtrm.step.doWaitForElementWithText":"Wait for element %s with text %s","wtrm.step_result.debug":"Debug:","wtrm.step_result.debug_key":"Debug %s:","wtrm.step_result.false":"Failed","wtrm.step_result.message":"Message:","wtrm.step_result.ms":"%sms","wtrm.step_result.runtime":"Runtime:","wtrm.step_result.start":"Start:","wtrm.step_result.status":"Status:","wtrm.step_result.stop":"Stop:","wtrm.step_result.true":"Success","wtrm.title":"Web Transaction Workflow"});Object.assign(Blx.text.text.de,{"chart.add":"Charts hinzufügen","chart.attr.title":"Chart","chart.authkey":"Authentifizierungsschlüssel","chart.change_chart_options_here":"↑ Chart Einstellungen","chart.chart_views":"Chart Ansichten","chart.create":"Eine Chartansicht erstellen","chart.current_chart_view":"Chartansicht:<br>%s","chart.howto_add":"Drücke (↑) den Chart-Button um Charts hinzuzufügen","chart.info":"Chart Informationen","chart.last_days":"Zeige die letzten %s Tage","chart.last_hours":"Zeige die letzten %s Stunden","chart.list":"Charts","chart.metrics":"Metriken","chart.nothing_selected":"Es sind keine Charts ausgewählt","chart.options":"Chart Optionen","chart.per_row":"Charts pro Zeile","chart.remove":"Chart entfernen","chart.update":"Chartansicht updaten","colorscheme.dark":"Dunkel","colorscheme.default":"Standard","contact.action.en_dis_able.title":"Ein- oder ausschalten","contact.attr.escalation_time":"Eskalationszeit","contact.attr.name":"Name","contact.create":"Einen neuen Kontakt erstellen","contact.edit":"Kontakt editieren","contact.escalation_time.after":"Nach %s","contact.escalation_time.always":"Zu jeder Zeit","contact.help.escalation_time":" Mit dem Eskalationslevel kann kontrolliert werden, wann ein Kontakt eine Benachrichtigung erhält. Ein Level von 30 Minuten bedeuted, dass der Konakt nach 30 Minuten benachrichtigt wird, wenn der Service nach 30 Minuten noch immer nicht OK ist.","contact.list":"Kontakte","contact.message_service":"Mitteilungsdienst","contact.message_services":"Mitteilungsdienste","contact.name":"Kontakt %s","contact.timeperiods":"Zeiträume für Mitteilungen","contact_message_service.attr.name":"Name","contact_message_service.attr.notification_level":"Benachrichtigungslevel","contact_message_service.attr.send_to":"Sende zu","contact_message_service.attr.timeperiod":"Zeitbereiche","contact_message_service.contact":"Kontakt","contact_message_service.help.notification_level":"Status Level, für welche man eine Benachrichtigung erhalten möchte.","contact_message_service.help.timeperiod":"Zeitbereiche, in denen man über Ereignisse informiert werden möchte.<br><br><p><b>Syntax: TAG-BEREICH ZEIT-BEREICH</b></p><br/> <pre> TAG BEREICH                     BEISPIELE<br/> ------------------------------------------------------------<br/> Weekday                         Monday<br/> Weekday - Weekday               Monday - Friday<br/> Month                           Januar<br/> Month - Month                   Januar - July<br/> Month Day                       Januar 1<br/> Month Day - Month Day           Januar 1 - July 15<br/> Year                            2010<br/> Year - Year                     2010 - 2012<br/> YYYY-MM-DD                      2010-01-01<br/> YYYY-MM-DD - YYYY-MM-DD         2010-01-01 - 2012-06-15<br/><br/> ZEIT BEREICH                    BEISPIELE<br/> ------------------------------------------------------------<br/> HH:MM - HH:MM                   09:00 - 17:00<br/> HH:MM - HH:MM, HH:MM - HH:MM    00:00 - 08:59, 17:01 - 23:59 </pre> <br/><p><b>Bespiele:</b></p><br/> <pre> Monday - Friday     09:00 - 17:00<br/> Monday - Friday     00:00 - 08:59, 17:01 - 23:59<br/> Saturday - Sunday   00:00 - 23:59 </pre> <br/><p><b>Ein Minuszeichen vor dem Zeitabschnitt bedeuted, dass diese Zeit exkludiert wird:</b></p><br/> <pre> Monday - Sunday 00:00 - 23:59     --\x3e zu jeder Zeit<br/> - Monday - Sunday 01:00 - 02:00   --\x3e aber nicht zwischen 1 und 2 Uhr </pre>","contactgroup.attr.name":"Name","contactgroup.create":"Eine neue Kontaktgruppe erstellen","contactgroup.edit":"Kontaktgruppe editieren","contactgroup.list":"Kontaktgruppen","contactgroup.text.contact_add_selected":"Kontakte der Gruppe hinzufügen","contactgroup.text.contact_member":"Kontakte in der Gruppe","contactgroup.text.contact_no_member":"Kontakte nicht in der Gruppe","contactgroup.text.contact_remove_selected":"Kontakte aus der Gruppe entfernen","contactgroup.text.contacts":"Kontakte","contactgroup.text.host_add_selected":"Hosts der Gruppe hinzufügen","contactgroup.text.host_member":"Hosts in der Gruppe","contactgroup.text.host_no_member":"Hosts nicht in der Gruppe","contactgroup.text.host_remove_selected":"Hosts aus der Gruppe entfernen","contactgroup.text.hosts":"Hosts","contactgroup.text.service_add_selected":"Services der Gruppe hinzufügen","contactgroup.text.service_member":"Services in der Gruppe","contactgroup.text.service_no_member":"Services nicht in der Gruppe","contactgroup.text.service_remove_selected":"Services aus der Gruppe entfernen","contactgroup.text.services":"Services","dashboard.add_dashlet":"Ein Dashlet hinzufügen","dashboard.cancel_edit":"Editieren abbrechen","dashboard.category":"Kategorie des Dashboards","dashboard.clock":"Uhrzeit","dashboard.create":"Ein neues Dashboard erstellen","dashboard.delete":"Dashboard löschen","dashboard.edit":"Dashboard editieren","dashboard.is_default":"Dies ist das standard Dashboard.","dashboard.list":"Dashbords","dashboard.name":"Dashbord: %s","dashboard.name_of":"Name des Dashboards","dashboard.open":"Dashboard öffnen","dashboard.remove_dashlet":"Das Dashlet entfernen","dashboard.save":"Dashboard speichern","dashboard.select_dashlet":"Wähle ein Dashlet aus um es dem Dashboard hinzuzufügen","dashboard.set_default":"Als Standard setzen","dashboard.update":"Dashboard Einstellungen","dashlet.chart.title":"Chart","dashlet.clock.title":"Uhr","dashlet.default.reload_interval.0":"deaktiviert","dashlet.default.reload_interval.10":"10 Sekunden","dashlet.default.reload_interval.120":"2 Minuten","dashlet.default.reload_interval.180":"3 Minuten","dashlet.default.reload_interval.30":"30 Sekunden","dashlet.default.reload_interval.300":"5 Minuten","dashlet.default.reload_interval.60":"1 Minute","dashlet.default.reload_interval.600":"10 Minuten","dashlet.default.show_columns":"Spalten anzeigen oder verstecken","dashlet.events.title":"Aktuellste Ereignisse","dashlet.host_counter.title":"Anzahl von Hosts nach bestimmten Kriterien","dashlet.hosts.title":"Hosts","dashlet.monitoring_screen.title":"Überwachungsbildschirm","dashlet.reload_interval":"Intervall zum Nachladen","dashlet.service_counter.title":"Anzahl von Services nach bestimmten Kriterien","dashlet.service_status.title":"Service Status","dashlet.services.title":"Services","dependency.attr.on_host_id":"Abhängig von Host","dependency.attr.on_service_id":"Abhängig von Service","dependency.attr.on_status":"Abhängig vom Status","dependency.attr.status":"Unterdrückter Status","dependency.create":"Eine neue Abhängigkeit erstellen","dependency.create.step1":"Wähle einen Service aus, für den eine Abhängigkeit eingerichtet werden soll.","dependency.create.step2":"Wähle einen Host aus, zu dem die Abhängigkeit besteht.","dependency.create.step3":"Wähle einen Service aus, zu dem die Abhängigkeit besteht.","dependency.create.step4":"Für welchen Status von Service %s sollen Benachrichtigungen unterdrückt werden?","dependency.create.step5":"Welcher Status von Service %s des Hosts %s aktiviert die Unterdrückung der Benachrichtiung?","dependency.itemdesc":"Wenn sich Service %s im Status %s befindet und der Service %s von Host %s im Status %s ist, dann werden Benachrichtigungen unterdrückt.","dependency.title":"Abhängigkeiten","downtime.attr.begin":"Beginn","downtime.attr.description":"Beschreibung","downtime.attr.end":"Ende","downtime.attr.timeslice":"Zeitabschnitt","downtime.attr.timezone":"Zeitzone","downtime.attr.username":"Erstellt von","downtime.fix_time":"Feste Zeit","downtime.fix_time_description":"Achtung! Feste Zeiten werden automatisch gelöscht, nachdem sie abgelaufen sind.","downtime.preset":"Voreinstellung","downtime.preset_help":"Mit dieser Option wird die aktuelle Uhrzeit als Startwert genommen. Das Ende ist die aktuelle Uhrzeit plus die gewählte Option.","downtime.timeslice":"Zeitraum","downtimes.host_downtimes":"Geplante Wartungsarbeiten für alle Services","downtimes.service_downtimes":"Geplante Wartungsarbeiten für einzelne Services","downtimes.title":"Geplante Wartungsarbeiten","err-800":"Weitere Services können nicht angelegt werden, da das Limit erreicht wurde.","err-801":"Dieser Service kann nur über das dazugehörigen Template gelöscht werden.","err-802":"Dieser Service kann nur über das dazugehörige Template geändert werden.","err-803":"Der Zeitraum darf 7 Tage nicht überschreiten","err-804":"Der Benutzername 'demo' ist nicht erlaubt","event.attr.duration":"Dauer","event.attr.last_status":"Letzter Status","event.attr.tags":"Tags","event.debug":"Erweiterte Meldung zum Debuggen","event.latest":"Aktuellste Ereignisse","event.list":"Ereignisse","form.absolute_time_range":"Feste Zeitangabe","form.from_time":"Startzeit","form.predefined_time_range":"Vordefinierter Zeitraum","form.to_time":"Endzeit","group.attr.name":"Gruppenname","group.create":"Eine neue Gruppe erstellen","group.delete":"Gruppe entfernen","group.edit":"Gruppe editieren","group.list":"Hostgruppen","group.name":"Gruppe %s (ID: %s)","group.text.host_add_selected":"Hosts der Gruppe hinzufügen","group.text.host_member":"Hosts in der Gruppe","group.text.host_no_member":"Hosts nicht in der Gruppe","group.text.host_remove_selected":"Hosts aus der Gruppe entfernen","group.text.hosts":"Hosts","group.text.user_add_selected":"Benutzer der Gruppe hinzufügen","group.text.user_member":"Benutzer in der Gruppe","group.text.user_no_member":"Benutzer nicht in der Gruppe","group.text.user_remove_selected":"Benutzer aus der Gruppe entfernen","group.text.users":"Benutzer","host.add_to_contactgroup":"Kontaktgruppe hinzufügen","host.add_to_host_group":"Host Gruppe hinzufügen","host.add_to_location_group":"Lokationsgruppe hinzufügen","host.add_to_template_group":"Template hinzufügen","host.attr.allow_from":"Erlaubter Zugriff","host.attr.country_code":"Standort des Hosts","host.attr.description":"Beschreibung","host.attr.enabled":"Aktiv","host.attr.hostname":"Hostname","host.attr.id":"Host ID","host.attr.interval":"Intervall","host.attr.ipaddr1":"1. IP-Adresse","host.attr.ipaddr2":"2. IP-Adresse","host.attr.ipaddr3":"3. IP-Adresse","host.attr.ipaddr4":"4. IP-Adresse","host.attr.location_class":"Standortklasse","host.attr.notification_enabled":"Benachrichtigungen aktiv","host.attr.notification_interval":"Benachrichtigungsintervall","host.attr.project_class":"Projektklasse","host.attr.retry_interval":"Wiederholungsintervall","host.attr.status":"Höchster Status","host.attr.sysinfo":"System Informationen","host.attr.timeout":"Timeout","host.attr.variables":"Host Variablen","host.continue_without_ip_address":"Weiter ohne IP Adresse","host.create":"Einen neuen Host erstellen","host.dashlet.active_downtimes":"Services mit Downtime","host.dashlet.count_events":"Ereignisse der letzten 24 Stunden","host.dashlet.flapping_services":"Flapping Services","host.dashlet.latest_availability":"Verfügbarkeit der letzten 24 Stunden","host.dashlet.latest_notifications":"Benachrichtigungen in den letzten 24 Stunden","host.dashlet.services_not_ok":"Services, die nicht OK sind","host.delete":"Host löschen","host.disabled":"Die Überwachung des Hosts ist ausgeschaltet","host.edit":"Host bearbeiten (ID %s)","host.get_ip_address":"Die IP Adresse abfragen","host.has_downtime":"Der Host hat eine aktive Downtime","host.help.allow_from":"Angabe von Quell-IPs und Netze von denen aus sich der Agent verbinden darf.","host.help.country_code":"Der Standort des Hosts nach Länderkürzel.","host.help.description":"Das ist eine kurze Beschreibung zum Host.","host.help.enabled":"Aktiviere oder deaktiviere den Host und alle Services.","host.help.hostname":"Dies ist der vollständig qualifizierte Hostname.","host.help.interval":"Das ist der Prüfungsintervall aller Services des Hosts.","host.help.ipaddr":"Das ist eine IP-Adresse des Hosts. <br/><br/>Bitte beachten Sie dass vorangestellte Nullen nicht erlaubt sind: <br/><br/><i>010.005.008.001</i> oder <i>0001::0001</i> ist nicht erlaubt <br/><i>10.5.8.1</i> oder <i>1::1</i> ist erlaubt","host.help.location_class":"Beispiele:<br/> <br/>/EU/Germany/Hamburg/DC1/Rack10 <br/>/EU/France/Nancy/DC3/Rack12","host.help.notification_enabled":"Aktiere oder deaktiviere die Benachrichtigungen aller Services.","host.help.notification_interval":"Das ist der Benachrichtigungsintervall des Host.","host.help.password":"Dieses Passwort wird für den Bloonix Agenten benötigt. Wenn der Agent Statistiken für einen Host zum Bloonix Server senden möchte dann ist dies nur möglich wenn der Agent die Host-ID und das Passwort kennt.","host.help.project_class":"Beispiele:<br/> <br/>/Bloonix/Homepage/Loadbalancer <br/>/Bloonix/Homepage/Database <br/>/Bloonix/Mailserver/Mailin <br/>/Bloonix/Mailserver/Mailout","host.help.retry_interval":"Das ist der Prüfintervall aller Services des Hosts, aber nur, wenn ein Service nicht im Status OK ist.","host.help.sysinfo":"Hier können Sie einen externen Link zu Ihrer Host-Dokumentation eintragen, zum Beispiel:<br/><br/>Linktext=https://url/?id=12345.","host.help.timeout":"Das ist der Timeout aller Services des Hosts. Der Timeoutzähler beginnt nach dem Intervall. Wenn in dieser Zeit der Status eines Service nicht aktualisiert wurde, dann wird ein kritischer Status gesetzt mit der Information, dass der Bloonix-Agent wohlmöglich ausgefallen ist.","host.help.variables":"In diesem Feld können Host Variablen definiert werden. Diese Variablen können für Schwellwerten bei der Konfiguration von Service-Checks verwendet werden. Beispiel:<br/><br/><b>HTTP.PORT=9000</b><br/><br/>Diese Variable kann dann im Format <i>%HTTP.PORT%</i> für Schwellwerte eingesetzt werden. Bitte beachten Sie das zwei Variablen vordefiniert sind: <i>IPADDR</i> und <i>HOSTNAME</i>. Diese Variablen werden mit der IP-Adresse und dem Hostnamen ersetzt. Weitere Informationen hierzu finden Sie in der Hilfe.<br/><br/>Erlaubte Zeichen: a-z, A-Z, 0-9, Punkt und Unterstrich","host.list":"Hosts","host.member_of_contactgroup":"Kontaktgruppen Mitgliedschaft","host.member_of_host_group":"Hostgruppen Mitgliedschaft","host.member_of_location_group":"Standortgruppen Mitgliedschaft","host.member_of_template_group":"Templategruppen Mitgliedschaft","host.nav.charts":"Charts","host.nav.contactgroups":"Kontaktgruppen","host.nav.dependencies":"Abhängigkeiten","host.nav.downtimes":"Downtimes","host.nav.events":"Events","host.nav.groups":"Gruppen","host.nav.location_groups":"Lokationsgruppen","host.nav.metadata":"Metadaten","host.nav.notifications":"Nachrichten","host.nav.report":"Report","host.nav.services":"Services","host.nav.templates":"Templates","host.new_host_main_desc":"Der Host %s wurde erfolgreich erstellt. Zur Einrichtung des Bloonix-Agenten kannst du zwischen 2 der folgenden Möglichkeiten auswählen. Die Aktionen müssen auf dem Zielsystem ausgeführt werden, welches überwacht werden soll.","host.new_host_setup_command":"Entweder führe das folgende Kommando aus","host.new_host_setup_manual":"Oder trage folgendes Text in die Datei <b><i>/etc/bloonix/agent/conf.d/host.conf</i></b> ein","host.new_host_title":"Eine neue Hostkonfiguration","host.notifications_disabled":"Die Benachrichtigungen sind ausgeschaltet","host.really_delete":"Soll der Host %s wirklich gelöscht werden?","host.remove_from_contactgroup":"Kontaktgruppen entfernen","host.remove_from_host_group":"Hostgruppen entfernen","host.remove_from_location_group":"Standortgruppen entfernen","host.remove_from_template_group":"Templategruppen entfernen","host.status_count":"Service Status","host.title.enter_hostname":"Bitte gib den Hostnamen des neuen Hosts ein","host.title.groups":"Gruppen","host.title.services":"Services","host.title.templates":"Templates","host.title.variables":"Variablen","location_group.attr.name":"Name","location_group.attr.password":"Passwort","location_group.create":"Eine neue Standortgruppe erstellen","location_group.title":"Standortgruppen","main.fullscreen":"Vollbild","main.fullscreen_off":"Vollbild ausschalten","main.leave_fullscreen":"Drücke Escape um den fullscreen modus zu verlassen","message_service.attr.message_template":"Nachrichtentemplate","message_service.attr.name":"Name","message_service.attr.type":"Typ","message_service.attr.variables":"Variablen","message_service.create":"Einen neuen Mitteilungsdienst erstellen","message_service.delete_warning":"Achtung: beim Löschen eines Mitteilungsdienstes wird dieser auch von allen Kontakten entfernt!","message_service.form.title":"Information","message_service.help.message_template":"Mit dem Nachrichtentemplate wird der Inhalt der Variable %message% festgelegt. Da mehr als nur ein Service in der Benachrichtung vorkommen kann, muss eine Liste mit allen Services in einer Schleife abgeabeitet werden. Die Schleife beginnt mit %begin_loop% und endet mit %end_loop%. Service-relevante Variablen sind wie folgt: <br/><br/>%service_id% - der ID des Service <br/>%service_name% - der Name des Service <br/>%service_status% - der Status des Service <br/>%service_message% - die Nachricht des Service <br/><br/>Beispiel: <br/><br/>%begin_loop% <br/>--- <br/>Service ID: %service_id% <br/>Service: %service_name% <br/>Status: %service_status% <br/>Message: %service_message% <br/>%end_loop%","message_service.help.variables":"Im Nachrichtentemplate sowie in den einzelnen Formularfeldern können vordefinierte Variablen verwendet werden. Beim Einrichten von SMS-Nachrichten sollte ausschließlich %short_message% im Template verwendet werden. Andernfalls kann die Nachricht in mehrere SMS aufgeteilt werden, was zu erheblichen Mehrkosten führt. <br/> <br/>%host_id% - die ID des Host <br/>%hostname% - der Hostname <br/>%host_description% - die Beschreibung des Hosts <br/>%ipaddr% - die 1. IP Adresse des Hosts <br/>%date% - das Datum, wann die Nachricht generiert wurde <br/>%unixtime% - die Unixtime, wann die Nachricht generiert wurde <br/>%send_to% - die Sendeadresse des Kontakt <br/>%sum_status% - eine Zusammenfassung des Status, besonders geeignet für SMS <br/>%short_message% - eine Kurznachricht, die auf SMS Größe angepasst wird <br/>%message% - die generierte Nachricht aus dem Nachrichtentemplate","message_service.help.variables_title":"Globale Variablen","message_service.http.description":"Der Messagedienst HTTP ist ein Builtin-Skript von Bloonix. Nachrichten können hiermit über eine HTTP Schnittstelle versendet werden. Die Daten können als URL enkodierte Nachrichten oder als JSON versendet werden.","message_service.http.help.auth_basic":"HTTP Auth Basic String. Das Format ist user:password.","message_service.http.help.check_content":"Die Antwort des HTTP Requests kann mit einem regulärem Ausruck geprüft werden. Wenn der Versand der Nachricht nicht erfolgreich war, wird der Versand beim nächsten Prüfintervall erneut versucht.","message_service.http.help.data_type":"Postdata URL enkodiert:<br>Ein Parameter und Wert pro Zeile. Parameter und Wert werden URL enkodiert. <br><br>JSON Daten:<br>Gib einen JSON String ein. Wenn kein Content-Type angegeben wird, dann wird dieser auf application/json gesetzt. <br><br>POST Daten, Rohformat:<br>Die Daten werden in einen Bytestring via encoding utf-8 konvertiert. Wenn kein Content-Type angegeben wird, dann wird dieser auf text/plain gesetzt.","message_service.http.help.header":"In der linken Spalte wird der Name und in der rechten Spalte der Wert eingetragen.","message_service.http.help.insecure":"Mit dieser Option kann die Validierung von SSL Zertifikaten deaktiviert werden.","message_service.http.help.postdata":"POST Daten, die zum Webserver gesendet werden sollen. Die Daten sollten so formatiert sein wie sie vom Webserver erwartet werden. Wenn es keine JSON Daten sind, dann werden Newlines durch ein & Zeichen ersetzt.","message_service.http.help.postdata_json":'JSON Daten für einen POST Request. Die Daten werden nicht URL enkodiert. Beispiel: {"message":"%message%"}',"message_service.http.help.postdata_raw":"Unbehandelte Daten.","message_service.http.help.postdata_urlencoded":"In der linken Spalte wird der Name und in der rechten Spalte der Wert eingetragen. Die Daten werden URL enkodiert.","message_service.http.help.user_agent":"Der Standard ist Bloonix-Monitoring-Message-Service.","message_service.http.param.auth_basic":"Auth Basic","message_service.http.param.check_content":"Erwartete HTTP Antwort","message_service.http.param.check_status_code":"Erwarteter HTTP Statuscode","message_service.http.param.data_type":"Der Typ der POST Daten.","message_service.http.param.header":"HTTP Request Header","message_service.http.param.insecure":"Erlaube unsichere Zertifikate","message_service.http.param.postdata":"POST Daten","message_service.http.param.postdata_json":"JSON Daten","message_service.http.param.postdata_raw":"POST Daten, Rohformat","message_service.http.param.postdata_urlencoded":"Postdaten URL enkodiert","message_service.http.param.url":"URL","message_service.http.param.user_agent":"User Agent","message_service.list":"Mitteilungsdienste","message_service.script.description":"Mit dem Messagedienst Skript können Sie eigene Skripte zum Versenden von Nachrichten verwenden. Das Skript muss in dem Verzeichnis abgelegt werden, welches im Bloonix Server mit dem Parameter message_service_script_path konfiguriert ist. Standardmäßig ist das der Pfad /usr/local/lib/bloonix/message-service. Alle Parameter, welche in diesem Formular konfiguriert sind, werden an das Skript über STDIN im JSON Format übergeben.","message_service.script.help.params":"Die Parameter werden über STDIN an das Skript übergeben.","message_service.script.help.script":"Das Skript, welches zur Versendung der Nachricht verwendet wird. Der Name des Skript darf nur folgende Zeichen enthalten: a-zA-Z_0-9.-","message_service.script.param.params":"Skript Parameter","message_service.script.param.script":"Skript","message_service.sendmail.description":"Der Nachrichtendienst Sendmail ist ein Builtin-Skript von Bloonix. Wenn die Parameter <i>SMTP Server</i>, <i>Benutzername</i> oder <i>Passwort</i> gesetzt sind, dann wird die Mail per SMTP SSL an den SMPT Server gesendet. Sollten die Parameter nicht gesetzt sein, dann wird die Mail über <i>/usr/sbin/sendmail</i> versendet. Dazu muss ein MTA auf dem Server installiert sein, wo auch der Bloonix-Server läuft.","message_service.sendmail.help.message":"Hier setzt man am Besten %message% als Wert. Die Nachricht wird über das Nachrichtentemplate gebaut.","message_service.sendmail.help.send_to":"Der Empfänger der Nachricht. Mit %SEND_TO% wird automatisch die Adresse des Kontakts verwendet.","message_service.sendmail.param.host":"SMTP Server","message_service.sendmail.param.message":"Message","message_service.sendmail.param.password":"SMTP Passwort","message_service.sendmail.param.send_to":"Empfänger","message_service.sendmail.param.sender":"Absender","message_service.sendmail.param.subject":"Mail Betreff","message_service.sendmail.param.username":"SMTP Benutzername","nav.main.charts":"Charts","nav.main.chpwd":"Passwort ändern","nav.main.config":"Konfiguration","nav.main.contactgroups":"Kontaktgruppen","nav.main.contacts":"Kontakte","nav.main.dashboard":"Dashboards","nav.main.events":"Ereignisse","nav.main.groups":"Hostgruppen","nav.main.help":"Hilfe","nav.main.hosts":"Hosts","nav.main.language":"Sprache","nav.main.location_groups":"Standortgruppen","nav.main.logout":"Ausloggen","nav.main.message_services":"Mitteilungsdienste","nav.main.monitoring":"Übersicht","nav.main.notification":"Benachrichtigung","nav.main.registration":"Host Registration","nav.main.satellites":"Satelliten","nav.main.services":"Services","nav.main.style":"Style Einstellungen","nav.main.sys_options":"Systemeinstellungen","nav.main.system_dashboard":"System Dashboard","nav.main.templates":"Templates","nav.main.timeperiods":"Zeitperioden","nav.main.timezone":"Zeitzone","nav.main.user_settings":"Meine Einstellungen","nav.main.users":"Benutzer","plugin.attr.service":"Plugin","regauth.attr.activate":"Aktivieren","regauth.attr.allowed_tags":"Erlaubte Tags","regauth.attr.authkey":"Authentifizierungsschlüssel","regauth.attr.network":"Host Netzwerk","regauth.attr.tags":"Standard Tags","regauth.create":"Einen neuen Authentifizierungsschlüssel erstellen","regauth.help.activate":"Hier wird definiert, ob der Host automatisch zur Überwachung aktiviert werden soll.","regauth.help.allowed_tags":"Mit diesem Parameter werden die Templatelabel defniert, die bei der Registrierung verwendet werden dürfen.","regauth.help.network":"Nur Hosts dessen IP sich in diesem Netz befinden können den Authkey verwenden.","regauth.help.tags":"Definiere standard templatelabel, die dem Host automatisch zugeordnet werden.","regauth.list":"Authentifizierungsschlüssel","regauth.text.add_additional_groups":"Weitere Gruppen hinzufügen","regauth.text.add_hosts":"Hosts hinzufügen und aktivieren","regauth.text.contactgroups":"Kontaktgruppen","regauth.text.contactgroups_add_selected":"Kontaktgruppen hinzufügen","regauth.text.contactgroups_remove_selected":"Kontaktgruppen entfernen","regauth.text.groups":"Host Gruppen","regauth.text.groups_add_selected":"Host Gruppen hinzufügen","regauth.text.groups_remove_selected":"Host Gruppen entfernen","regauth.text.location_groups":"Lokationsgruppen","regauth.text.location_groups_add_selected":"Lokationsgruppe hinzufügen","regauth.text.location_groups_remove_selected":"Lokationsgruppe entfernen","regauth.text.templates":"Templates","regauth.text.templates_add_selected":"Templates hinzufügen","regauth.text.templates_by_tag":"Templates nach Tags","regauth.text.templates_remove_selected":"Templates entfernen","registration.auth":"Auth Konfiguration","registration.hosts":"Host Registration","report.availability":"Verfügbarkeit","report.event_b15":"Kleiner als 15 Minuten","report.event_b180":"Zwischen 1 und 3 Stunden","report.event_b30":"Zwischen 15 und 30 Minuten","report.event_b60":"Zwischen 30 und 60 Minuten","report.event_bx":"Länger als 3 Stunden","report.events":"Ereignisse","report.events_by_status":"Ereignisse nach Status","report.events_by_time_of_day":"Ereignisse nach Tageszeit","report.number_of_events_by_duration":"Anzahl Ereignisse nach Statusdauer","report.number_of_tags":"Anzahl Ereignisse nach Markierung","report.status_duration_in_percent":"Statusdauer","report.total_availability":"Total","satellite.attr.authkey":"Authentifizierungsschlüssel","satellite.attr.city":"Stadt","satellite.attr.country":"Land","satellite.attr.hostname":"Hostname","satellite.attr.ipaddr1":"1. IP Adresse","satellite.attr.ipaddr2":"2. IP Adresse","satellite.attr.port":"Port","satellite.create":"Einen neuen Satelliten erstellen","satellite.delete":"Delete satellite","satellite.edit":"Satellit editieren","satellite.list":"Satelliten","service.action.acknowledge":"Service Status bestätigen","service.action.acknowledge.title":"Den Status bestätigen oder Bestätigung aufheben","service.action.downtime.title":"Wartungsarbeit einrichten","service.action.en_dis_able.title":"Ein- oder ausschalten","service.action.forcecheck":"Den nächsten Service Check forcieren","service.action.forcecheck.title":"Den Checkinterval zurücksetzen und den nächsten Check forcieren","service.action.hosts.title":"Die Aktion wird für alle ausgewählten Hosts und/oder Services der Host ausgeführt.","service.action.notification.title":"Benachrichtigung ein- oder ausschalten","service.action.notifications.disable":"Benachrichtigungen ausschalten","service.action.notifications.enable":"Benachrichtigungen einschalten","service.action.services.title":"Die Aktion wird für alle ausgwählten Services ausgeführt.","service.attempts":"Versuche","service.attr.acknowledged":"Bestätigt","service.attr.agent_version":"Agenten Version","service.attr.attempt_max":"Maximale Versuche","service.attr.command":"Kommando","service.attr.description":"Beschreibung","service.attr.enabled":"Aktiv","service.attr.fd_enabled":"Erkennung von Statuswechseln eingeschaltet","service.attr.fd_flap_count":"Maximale Anzahl von Statuswechsel","service.attr.fd_time_range":"Zeitraum zur Erkennung von Statuswechsel","service.attr.has_downtime":"Der Service hat eine aktive Downtime","service.attr.host_alive_check":"Host-Alive-Check","service.attr.id":"Service ID","service.attr.interval":"Intervall","service.attr.is_flapping":"Der Service flappt den Status","service.attr.last_check":"Letzte Prüfung","service.attr.message":"Nachricht","service.attr.notification_enabled":"Benachrichtigungen eingeschaltet","service.attr.notification_interval":"Benachrichtigungsintervall","service.attr.remote_check":"Remote Check","service.attr.retry_interval":"Wiederholungsintervall","service.attr.service_name":"Servicename","service.attr.status":"Status","service.attr.status_since":"Status seit","service.attr.tags":"Tags","service.attr.timeout":"Timeout","service.available_variables":"Liste der verfügbaren Variablen","service.available_variables_help":"Dieser Service stammt aus einem Host-Template und kann nur über Variablen angepasst werden.","service.clone":"Service klonen","service.clone_another_host":"Einen anderen Host auswählen","service.clone_same_host":"Service zum gleichen Host klonen","service.create":"Einen neuen Service erstellen","service.default_check_type":"Der Check wird vom Bloonix-Server ausgeführt.","service.default_check_type_title":"Standard","service.disabled":"Check ist ausgeschaltet","service.help.acknowledged":"Diese Option ist hilfreich wenn ein Service nicht OK ist und Sie das Benachrichtiungen temporär ausschalten möchten. Die Benachrichtigungen werden automatisch wieder eingeschaltet, wenn der Service in den Status OK gewechselt ist.","service.help.attempt_max":"Diese Option kontrolliert, wann Sie eine Benachrichtiung erhalten, wenn ein Service nicht OK ist. Ein Wert von 3 bedeuted zum Beispiel, dass eine Serviceprüfung 3 Mal hintereinander fehlschlagen darf, bis Sie eine Benachrichtigung erhalten.","service.help.enabled":"Diese Option aktiviert oder deaktiviert den Service.","service.help.fd_enabled":"Diese Option aktiviert oder deaktiviert die Erkennung von zu häufigen Statuswechseln (Flap Detection). Wenn ein Service zu häufig in einem kurzen Zeitraum den Status wechselt, ohne das der Prüfzähler für die maximale Anzahl erlaubter Fehlschläge erreicht wird, so greift diese Funtion. Für die Erkennung wird die Anzahl von Statuswechseln in einem bestimmten Zeitraum gemessen. Wenn der Status in diesem Zeitraum zu häufig wechselte, wird ein kritisches Ereignis ausgelöst.","service.help.fd_flap_count":"Dies ist die maximale Anzahl von Statuswelchseln, die in einem bestimmten Zeitraum auftreten dürfen.","service.help.fd_time_range":"Dies ist der Zeitbereich, in dem die Statuswechsel gemessen werden.","service.help.host_alive_check":"Ein Host-Alive-Check ist ein Check der feststellt, ob ein Host UP oder DOWN ist. Wenn dieser Service Check einen kritischen Status liefert, erhalten Sie eine besondere Nachricht. Wenn andere Services des Hosts ebenfalls in einem kritischen Status sind, während der Host-Alive-Check kritisch ist, dann werden die Benachrichtiungen anderer Services unterdrückt. Es wird empfohlen einen Ping-Check als Host-Alive-Check zu definieren.","service.help.interval":"Das ist der Prüfungsintervall des Service. Wenn kein Wert gesetzt ist, dann wird der Intervall des Hosts vererbt.","service.help.notification_enabled":"Diese Option aktiviert oder deaktiviert Benachrichtigungen für den Service.","service.help.notification_interval":"Dies ist der Benachrichtigungsintervall für Services. Solange der Service nicht OK ist, erhalten Sie in diesem Intervall erneut Benachrichtigungen. Wenn kein Wert gesetzt ist, dann wird der Intervall des Hosts vererbt.","service.help.passive_check":"Ein passiver Check ist ein Check, der nicht von Bloonix selbst geprüft wird, sondern von einem externen Service oder Skriptund haben keinen Timeout. Passive Checks eignen sich zum Beispiel für SNMP Traps. Dabei meldet ein externer Service einen kritischen Status an den Bloonix-Agenten, dieser wiederrum meldet den Status an den Bloonix-Server.","service.help.remote_check":"Standardmäßig werden Checks vom Bloonix Agenten ausgeführt, welcher auf dem zu überwachenden System installiert ist, wie zum Beispiel die CPU Load. Es gibt jedoch Checks, die man über eine Netzwerkverbindung prüfen kann. Wenn Remote-Check aktiviert ist, dann wird der Check entweder vom Bloonix-Server oder von einem Bloonix-Satelliten ausgeführt.","service.help.retry_interval":"Das ist der Prüfintervall des Service, aber nur, wenn ein Service nicht im Status OK ist. Wenn kein Wert gesetzt ist, dann wird der Intervall des Hosts vererbt.","service.help.service_name":"Dies ist der Anzeigename des Service.","service.help.timeout":"Das ist der Timeout des Service. Der Timeoutzähler beginnt nach dem Intervall. Wenn in dieser Zeit der Status des Service nicht aktualisiert wurde, dann wird ein kritischer Status gesetzt mit der Information, dass der Bloonix-Agent wohlmöglich ausgefallen ist. Wenn kein Wert gesetzt ist, dann wird der Timeout des Hosts vererbt.","service.host_enabled":"Host aktiv","service.host_notification_enabled":"Host Benachrichtigungen eingeschaltet","service.inherited_from_host":"Vererbt vom Host","service.list":"Services","service.no_variables_defined":"Es sind keine Variablen definiert.","service.notifications_disabled":"Benachrichtigungen sind ausgeschaltet","service.rotate_check_type":"<b>Funktionsweise</b><br/> Die Satelliten eignen sich um die Verfügbarkeit eines Dienstes von verschiedenen Standorten zu prüfen. Mit jedem Intervall findet die Prüfung des Dienstes von einem anderen Standort statt, dabei wird über alle Standorte rotiert.","service.rotate_check_type_title":"Satelliten auswählen","service.select_location_check_type":"Wähle den Typ des Checks","service.select_plugin":"Wähle ein Plugin aus","service.set_variable_host":"Wert aus den Host Variablen: %s","service.set_variable_template":"Wert aus den Template Variablen: %s","service.status":"Service Status","service.status_switched":"Der Status hat innerhalb der letzten Stunde gewechselt","service.template":"Template: %s","sys_options.attr.event_history":"Aufbewahrungszeit für Ereignisse","sys_options.attr.force_email_usernames":"Benutzernamen im E-Mail Format forcieren","sys_options.attr.has_maintenance":"Globale Modus für Wartungsarbeiten aktivieren/deaktivieren","sys_options.attr.max_password_length":"Maximallänge für Passwörter","sys_options.attr.min_password_length":"Mindestlänge für Passwörter","sys_options.attr.notification_history":"Aufbewahrungszeit für Benachrichtigungen","sys_options.attr.password_policy":"Passwortrichtlinie","sys_options.attr.password_policy_letter":"Passwortrichtlinie: Regulärer Audruck für Buchstaben","sys_options.attr.password_policy_lowercase":"Passwortrichtlinie: Regulärer Audruck für Kleinbuchstaben","sys_options.attr.password_policy_number":"Passwortrichtlinie: Regulärer Audruck für Zahlen","sys_options.attr.password_policy_special":"Passwortrichtlinie: Regulärer Ausdruck für Sonderzeichen","sys_options.attr.password_policy_uppercase":"Passwortrichtlinie: Regulärer Audruck für Großbuchstaben","sys_options.attr.result_history":"Aufbewahrungszeit für Ergebnisse von Webtransaktionen","sys_options.attr.server_names":"Bloonix Server Hostnamen","sys_options.attr.stat_history":"Aufbewahrungszeit für Metriken","sys_options.attr.stat_hourly_history":"Aggregierte Aufbewahrungszeit für Metriken","sys_options.attr.user_tracking_history":"Aufbewahrungszeit für Audit‑Protokollierung","sys_options.help.has_maintenance":"Achtung!<br/><br/>Wenn Sie den Wartungsmodus aktivieren, so wird das gesamte Benachrichtiungssystem deaktiviert und das solange, bis Sie den Wartungsmodus manuell wieder deaktivieren.","sys_options.help.password_policy":"Mit der Passwortrichtlinie wird festgelegt, welche Zeichen mindestens einmal in einem Passwort vorkommen müssen.","sys_options.help.password_policy_regex":"Der Wert wird in einem regulären Ausdruck (Python) in eckigen Klammern eingebettet. Beispiel [a-z]. Den Wert bitte ohne eckige Klammern angeben.","sys_options.help.password_policy_regex_special":"Der Wert wird in einem regulären Ausdruck (Python) in eckigen Klammern eingebettet. Beispiel [;#+]. Den Wert bitte ohne eckige Klammern angeben. Bitte verwenden Sie kein Escape-Zeichen für Sonderzeichen.","sys_options.help.server_names":"Hier müssen die Hostnamen oder IP Adressen aller Bloonix Server eingetragen werden. Diese Information wird bei der Erstellung neuer Hosts verwendet.","sys_options.help.value_in_days":"Angabe in Tagen","sys_options.help.value_in_months":"Angabe in Monaten","sys_options.label.letter":"Buchstabe","sys_options.label.lowercase":"Kleinbuchstabe","sys_options.label.number":"Zahl","sys_options.label.special":"Sonderzeichen","sys_options.label.uppercase":"Großbuchstabe","sys_options.maintenance.warning":"Achtung!<br/><br/>Der Wartundgmodus von Bloonix ist aktiv und das Benachrichtigungssystem ist deaktiviert.","template.add_selected_hosts":"Hosts hinzufügen","template.attr.name":"Name","template.attr.tags":"Tags","template.attr.variables":"Template Variablen","template.create":"Ein neues Template erstellen","template.delete":"Template löschen","template.edit":"Template editieren","template.help.tags":"Tags können genutzt werden um neue Hosts automatisch einem Template zuzuordnen.","template.hosts":"Hosts","template.hosts_member":"Hosts in der Gruppe","template.hosts_no_member":"Hosts der Gruppe hinzufügen","template.list":"Host-Templates","template.remove_selected_hosts":"Hosts entfernen","template.services":"Services","timeperiod.attr.name":"Name","timeperiod.attr.timeslice":"Zeitabschnitt","timeperiod.create":"Zeitbereich erstellen","timeperiod.edit":"Zeitbereich editieren","timeperiod.help.timeslice":"<p><b>Syntax: TAG-BEREICH ZEIT-BEREICH</b></p><br/> <pre> TAG BEREICH                     BEISPIELE<br/> ------------------------------------------------------------<br/> Weekday                         Monday<br/> Weekday - Weekday               Monday - Friday<br/> Month                           Januar<br/> Month - Month                   Januar - July<br/> Month Day                       Januar 1<br/> Month Day - Month Day           Januar 1 - July 15<br/> Year                            2010<br/> Year - Year                     2010 - 2012<br/> YYYY-MM-DD                      2010-01-01<br/> YYYY-MM-DD - YYYY-MM-DD         2010-01-01 - 2012-06-15<br/><br/> ZEIT BEREICH                    BEISPIELE<br/> ------------------------------------------------------------<br/> HH:MM - HH:MM                   09:00 - 17:00<br/> HH:MM - HH:MM, HH:MM - HH:MM    00:00 - 08:59, 17:01 - 23:59 </pre> <br/><p><b>Bespiele:</b></p><br/> <pre> Monday - Friday     09:00 - 17:00<br/> Monday - Friday     00:00 - 08:59, 17:01 - 23:59<br/> Saturday - Sunday   00:00 - 23:59 </pre> <br/><p><b>Ein Minuszeichen vor dem Zeitabschnitt bedeuted, dass diese Zeit exkludiert wird:</b></p><br/> <pre> Monday - Sunday 00:00 - 23:59     --\x3e zu jeder Zeit<br/> - Monday - Sunday 01:00 - 02:00   --\x3e aber nicht zwischen 1 und 2 Uhr </pre>","timeperiod.list":"Zeitbereiche","user.2fa_enter":"Bitte geben Sie den Code ein","user.2fa_title":"2 Faktor Authentifizierung","user.2fa_trust_browser":"Möchten Sie den Browser vertrauen?","user.2fa_trust_browser_info":"Wenn Sie dem Browser vertrauen, speichern wir einen speziellen Cookie zusammen mit einem Teil Ihrer IP-Adresse für 30 Tage. Falls sich Ihre IP-Adresse stark ändert oder der Cookie gelöscht wird, müssen Sie sich aus Sicherheitsgründen erneut mit einem 2-Faktor-Code anmelden.","user.add_to_group":"Zur Gruppe hinzufügen","user.attr.2fa_addr":"2 Faktor Authentifizierung","user.attr.filter_by_group":"Filter nach Gruppen","user.attr.force_password_change":"Passwortänderung erzwingen","user.attr.language":"Sprache","user.attr.last_login":"Letzter Login","user.attr.locked":"Gesperrt","user.attr.name":"Name","user.attr.password":"Passwort","user.attr.phone":"Telefon","user.attr.role":"Rolle","user.attr.username":"Benutzername","user.change_initial_password":"Dies scheint dein erster Login zu sein. Um fortfahren zu können, muss zunächst das initiale Login-Passwort geändert werden. Klicke auf den %s Button an der Passworteingabe, um mehr über die Anforderungen zum Passwort zu erhalten.","user.change_password":"Ihr Password ändern","user.create":"Einen neuen User erstellen","user.current_password":"Aktuelles Passwort","user.delete":"User löschen","user.demo":"Der Demo Benutzer kann nicht geändert werden.","user.edit":"User editieren","user.groups":"Groups","user.help.2fa_addr":"Für die 2 Faktor Authentifizierung wird eine Adresse benötigt.","user.help.filter_by_group":"Mit diesem Parameter wird festgelegt, ob der User nur die Hosts, Services und Events sehen darf, welche in seiner Gruppe konfiguriert sind. Ist der Parameter nicht aktiviert, so darf der User alle Hosts, Services und Events sehen.","user.help.force_password_change":"Steht der Wert auf 'ja', so wird der Benutzer dazu aufgefordert sein Passwort zu ändern.","user.help.locked":"Gesperrte Benuzer können sich nicht einloggen.","user.help.role":"<b>admin</b> - Administrator Account mit vollen Rechten<br/><br/> <b>operator</b> - Operator Account mit vollen Rechten, mit der Ausnahme, dass Operatoren keine Benutzer verwalten können.<br/><br/> <b>user</b> - Benutzer mit schreibgeschütztem Zugriff.","user.help.username":"Die E-Mail des Benutzers, welche als Loginname benutzt wird.","user.list":"Benutzer","user.new_password":"Neues Passwort","user.password_policy.info":"Von jeder der folgenden Charakterklassen muss mindestens ein Zeichen im Passwort enthalten sein:","user.password_policy_letter":"Buchstaben: %s","user.password_policy_lowercase":"Kleinbuchstaben: %s","user.password_policy_number":"Zahlen: %s","user.password_policy_special":"Spezielle Charakter: %s","user.password_policy_uppercase":"Großbuchstaben: %s","user.remove_from_group":"Aus Gruppe entfernen","user.repeat_new_password":"Passwort wiederholen","user.welcome":"Hallo und Willkommen bei Bloonix","var.timeslice":"<p><b>Syntax: TAG-BEREICH ZEIT-BEREICH</b></p><br/> <pre> TAG BEREICH                     BEISPIELE<br/> ------------------------------------------------------------<br/> Weekday                         Monday<br/> Weekday - Weekday               Monday - Friday<br/> Month                           Januar<br/> Month - Month                   Januar - July<br/> Month Day                       Januar 1<br/> Month Day - Month Day           Januar 1 - July 15<br/> Year                            2010<br/> Year - Year                     2010 - 2012<br/> YYYY-MM-DD                      2010-01-01<br/> YYYY-MM-DD - YYYY-MM-DD         2010-01-01 - 2012-06-15<br/><br/> ZEIT BEREICH                    BEISPIELE<br/> ------------------------------------------------------------<br/> HH:MM - HH:MM                   09:00 - 17:00<br/> HH:MM - HH:MM, HH:MM - HH:MM    00:00 - 08:59, 17:01 - 23:59 </pre> <br/><p><b>Bespiele:</b></p><br/> <pre> Monday - Friday     09:00 - 17:00<br/> Monday - Friday     00:00 - 08:59, 17:01 - 23:59<br/> Saturday - Sunday   00:00 - 23:59 </pre> <br/><p><b>Ein Minuszeichen vor dem Zeitabschnitt bedeuted, dass diese Zeit exkludiert wird:</b></p><br/> <pre> Monday - Sunday 00:00 - 23:59     --\x3e zu jeder Zeit<br/> - Monday - Sunday 01:00 - 02:00   --\x3e aber nicht zwischen 1 und 2 Uhr </pre>","wtrm.action.checkDownload":"Prüfe ob eine Datei heruntergeladen wurde","wtrm.action.checkIfElementExists":"Prüfe ob ein Element existiert","wtrm.action.checkIfElementHasHTML":"Prüfe ob ein Element HTML enthält","wtrm.action.checkIfElementHasNotHTML":"Prüfe ob ein Element kein HTML enthält","wtrm.action.checkIfElementHasNotText":"Prüfe ob ein Element einen bestimmten Text nicht enthält","wtrm.action.checkIfElementHasNotValue":"Prüfe das ein Inputfeld oder eine Textarea einen Wert nicht enthält","wtrm.action.checkIfElementHasText":"Prüfe ob ein Element einen bestimmten Text enthält","wtrm.action.checkIfElementHasValue":"Prüfe den Wert eines Inputfeldes oder einer Textarea","wtrm.action.checkIfElementIsChecked":"Prüfe ob ein Radio Button oder eine Checkbox ausgewählt ist","wtrm.action.checkIfElementIsNotChecked":"Prüfe ob ein Radio Button oder eine Checkbox nicht ausgewählt ist","wtrm.action.checkIfElementIsNotSelected":"Prüfe ob ein bestimmter Wert eines Selectfeldes nicht ausgewählt ist","wtrm.action.checkIfElementIsSelected":"Prüfe ob ein bestimmter Wert eines Selectfeldes ausgewählt ist","wtrm.action.checkIfElementMatchText":"Prüfe den Text eines Elements mitteln RegEx","wtrm.action.checkIfElementNotExists":"Prüfe ob ein Element nicht existiert","wtrm.action.checkUrl":"Prüfe die URL in der Addresszeile","wtrm.action.doAddCookie":"Einen Cookie hinzufügen","wtrm.action.doAuth":"Auth Basic Benutzername und Passwort festlegen","wtrm.action.doCheck":"Einen Radio Button oder eine Checkbox auswählen","wtrm.action.doClick":"Auf ein Element klicken","wtrm.action.doFill":"Daten in ein Input-Feld oder eine Textarea eintragen","wtrm.action.doSelect":"Ein Feld aus einem Selectfeld auswählen","wtrm.action.doSleep":"Die Ausführung aussetzen","wtrm.action.doSubmit":"Ein Forumular absenden","wtrm.action.doSwitchToFrame":"Zu einem Frame wechseln","wtrm.action.doSwitchToMainPage":"Zur Hauptseite welchseln","wtrm.action.doSwitchToNewPage":"Zu einer neu erstellten Seite wechseln","wtrm.action.doSwitchToParentFrame":"Zum Elternframe wechseln","wtrm.action.doTriggerEvent":"Ein Event auf ein Element auslösen","wtrm.action.doUncheck":"Einen Radio Button oder eine Checkbox abwählen","wtrm.action.doUrl":"Eine URL aufrufen","wtrm.action.doUserAgent":"User Agent für alle Anfragen festlegen","wtrm.action.doWaitForElement":"Auf ein Element warten","wtrm.attr.content_type":"Content Type","wtrm.attr.domain":"Domain","wtrm.attr.element":"Element","wtrm.attr.event":"Event","wtrm.attr.filename":"Dateiname","wtrm.attr.hidden":"Verstecken","wtrm.attr.html":"HTML","wtrm.attr.ms":"Millisekunden","wtrm.attr.name":"Name","wtrm.attr.parent":"Elternelement","wtrm.attr.status":"Status","wtrm.attr.text":"Text","wtrm.attr.url":"URL","wtrm.attr.user_agent":"User Agent","wtrm.attr.value":"Wert","wtrm.check":"Workflow prüfen","wtrm.check_quick":"Schnellprüfung","wtrm.click_info":"Klicken Sie auf ein Ergebnis, um sich die Details hier anzeigen zu lassen.","wtrm.failed":"Workflow fehlgeschlagen:","wtrm.help.element":"Das Element, welches verändert oder geprüft werden soll. Zum Beispiel: #id, .class, name<br/><br/> Es ist ebenfalls möglich nach Tags und Attributen zu suchen. Bespiel:<br/><br/> &lt;a&gt; - der erste gefundene 'a' Tag<br/><br/> &lt;a[5]&gt; - der fünfte 'a' Tag<br/><br/> &lt;a a=\"hello\" b=\"world\"&gt; - suche nach einem 'a' Tag mit speziellen Attributen und Werten","wtrm.help.parent":"Gib ein Elternelement im Format '#id' an. Das kann hilfreich sein, wenn es zum Beispiel mehrere Formulare auf einer Seite gibt und man ein bestimmtes Formular ansprechen möchte.","wtrm.loading":"Es wird auf das Ergebnis gewartet...","wtrm.step.checkDownload":"Check if file %s was downloaded","wtrm.step.checkIfElementExists":"Check if the element %s exists","wtrm.step.checkIfElementHasHTML":"Check if the element %s contains %s","wtrm.step.checkIfElementHasNotHTML":"Check if the element %s does NOT contain %s","wtrm.step.checkIfElementHasNotText":"Check if the element %s does NOT contain %s","wtrm.step.checkIfElementHasNotValue":"Check if the input field or textarea with element %s does NOT contain %s","wtrm.step.checkIfElementHasText":"Check if the element %s contains %s","wtrm.step.checkIfElementHasValue":"Check if the input field or textarea with element %s contains %s","wtrm.step.checkIfElementIsChecked":"Check if the radio button or checkbox %s is checked","wtrm.step.checkIfElementIsNotChecked":"Check if the radio button or checkbox %s is NOT checked","wtrm.step.checkIfElementIsNotSelected":"Check if the value %s of the selectbox %s is NOT selected","wtrm.step.checkIfElementIsSelected":"Check if the value %s of the selectbox %s is selected","wtrm.step.checkIfElementMatchText":"Check if the element %s match %s","wtrm.step.checkIfElementNotExists":"Check if the element %s does NOT exists","wtrm.step.checkUrl":"Check if the URL in the address bar is %s","wtrm.step.checkUrlWithContentType":"Check if the URL %s has content type %s","wtrm.step.doAddCookie":"Add cookie %s=%s domain %s","wtrm.step.doAuth":"Authentifiziere mit Benutzer %s und Passwort %s","wtrm.step.doCheck":"Check the radio button or checkbox of element %s with value %s","wtrm.step.doClick":"Click on element %s","wtrm.step.doFill":"Fill element %s with value %s","wtrm.step.doSelect":"Select the value %s from the selectbox %s","wtrm.step.doSleep":"Sleep %sms","wtrm.step.doSubmit":"Submit form %s","wtrm.step.doSwitchToFrame":"Switch to frame %s","wtrm.step.doSwitchToMainPage":"Switch to main page","wtrm.step.doSwitchToNewPage":"Switch to new created page","wtrm.step.doSwitchToParentFrame":"Switch to parent frame","wtrm.step.doTriggerEvent":"Trigger event %s on element %s","wtrm.step.doUncheck":"Uncheck the radio button or checkbox %s with value %s","wtrm.step.doUrl":"Go to URL %s","wtrm.step.doUserAgent":"Setze den User Agent auf %s","wtrm.step.doWaitForElement":"Wait for element %s","wtrm.step.doWaitForElementWithText":"Wait for element %s with text %s","wtrm.step_result.debug":"Debug:","wtrm.step_result.debug_key":"Debug %s:","wtrm.step_result.false":"Fehler","wtrm.step_result.message":"Nachricht:","wtrm.step_result.ms":"%sms","wtrm.step_result.runtime":"Lautzeit:","wtrm.step_result.start":"Start:","wtrm.step_result.status":"Status:","wtrm.step_result.stop":"Stop:","wtrm.step_result.true":"Erfolgreich","wtrm.title":"Arbeitsablauf der Web-Transaktion"});class BlxApp{constructor(){this.tableColumns={};this.statusById=["OK","INFO","NOTICE","WARNING","ALERT","CRITICAL","UNKNOWN"];this.statusIconsById=["circle-check","info","circle-alert","triangle-alert","bomb","flame","circle-help"]}run(version,lang,nonce,style){console.info(`%c
                                               
    COOL ADMINS USES                           
     _    __ _____ _____ __  __ __ __   __     
    | |__|  |     |     |  \\|  |__|\\  \\/  /    
    |  . |  |  |  |  |  |      |  | >    <     
    |____|__|_____|_____|__|\\__|__|/__/\\__\\    
                                               
`,"background-color: #2a2a39; color: #ffffff; text-decoration: none;");Blx.log.info(`Run Bloonix Application v${version}`);this.version=version;this.lang=lang;this.nonce=nonce;this.style=style;this.iconColor1=this.style=="default"?"black":"white";this.iconColor2=this.style=="default"?"gray":"dark";this.iconColor3=this.style=="default"?"dark-gray":"gray";this.iconColor4=this.style=="default"?"black":"white";this.iconColor5=this.style=="default"?"gray":"dark-gray";this.iconColor6=this.style=="default"?"dark":"gray";this.iconColor7=this.style=="default"?"white":"black";this.whiteShape=`/assets/bloonix/img/bloonix-shape-white.svg?${this.version}`;this.whiteText=`/assets/bloonix/img/bloonix-text-white.svg?${this.version}`;this.whiteLogo=`/assets/bloonix/img/bloonix-white.svg?${this.version}`;this.assetsPath="/assets";this.initDOM();this.initMods();this.initBase();Blx.ajax.request({url:"/user",errorCallback:{"err-637":()=>(new ConfigUser).twoFactorAuth(),"err-660":()=>(new ConfigUser).changePassword(true)},success:result=>{Blx.log.info(`logged in as ${result.data.username} with role ${result.data.role}`);this.user=result.data;this.initSiteNav();this.initContentNav();this.initRoutes();this.initStatusBox()}})}initMods(){Blx.text.lang=this.lang;Blx.svgFlag.path=`${this.assetsPath}/extra/country-flags`;Blx.svgFlag.version=this.version;Blx.messageProps.container=this.messageContainer;Blx.contentBoxProps.iconConfig={coloring:this.iconColor2};Blx.contentBoxProps.titleIconColor=this.iconColor1;Blx.formProps.iconColoring=this.iconColor2;Blx.formProps.paramTableIconColoring=this.iconColor1;Blx.tableProps.selectableIconColor=this.iconColor3;Blx.tableProps.columnSettingsActiveColor=this.iconColor4;Blx.tableProps.columnSettingsInactiveColor=this.iconColor5;Blx.tableProps.pagerIconColor=this.iconColor7;Blx.tableSearchProps.coloring=this.iconColor7;Blx.datePagerProps.iconColoring=this.iconColor6;tableStatusIcon.coloring(blxapp.iconColor1);Blx.ajax.defaults.errorCallback={"err-630":()=>{window.location="/login"},"err-660":Blx.utils.resetLocation,"err-605":()=>this.notEnoughPrivileges()};Blx.ajax.defaults.beforeSuccess=result=>{var infoBox=$("#bloonix-important-info-box").draggable(),messageType=infoBox.data("message-type")||0;if(result.maintenance===1||result.version!==this.version){if(!infoBox.length){infoBox=Blx.create("div").attr("id","bloonix-important-info-box").appendTo("body")}if(result.maintenance===1){if(messageType!==1){infoBox.data("message-type",1);infoBox.text("ATTENTION: maintenance mode active")}}else if(result.version!==this.version){if(messageType!==2){infoBox.data("message-type",2);infoBox.text("The web application version changed. Please reload the browser page.")}}}else if(result.maintenance===0&&messageType!==0){$("#bloonix-important-info-box").remove()}}}notEnoughPrivileges(){const m=Blx.create("div").css("text-align","center").html(Blx.create("div").text(Blx.text.get("err-605")).css({display:"inline-block",margin:"30px auto",padding:"20px","background-color":"#00e7ff",color:"#333333","text-align":"center","font-size":"15px","font-weight":"bold"}));if(/^(#config|#\/config)/.test(window.location.hash)){this.body.html(m);return}const overlay=Blx.overlay({body:m,position:"middle",headerBorder:false});overlay.body.css("background-color","#00e7ff");overlay.create()}clear(){Blx.ajax.abortXHRs();this.body.html("");this.clearControlIcons();this.breadcrumb.clear();this.topNav.clear();this.subNav.clear()}initBase(){if(Blx.utils.is_touch_enabled()===true){this.origTooltip=jQuery.fn.tooltip;jQuery.fn.tooltip=function(){return this}}}initDOM(){Blx.dom({name:"container",flex:"row",nowrap:true,addClass:"bloonix-container",boxes:[{name:"containerLeft",addClass:"bloonix-container-left bloonix-fullscreen"},{name:"containerRight",addClass:"bloonix-container-right",flex:["grow","column"],boxes:[{name:"controlContainer",addClass:"bloonix-control-container bloonix-fullscreen",flex:"row",boxes:[{name:"shapeContainer"},{name:"controlIconsContainer",addClass:"bloonix-control-icons-container"},{name:"siteControlIcons",addClass:"bloonix-control-icons-container"},{name:"breadcrumbContainer",addClass:"bloonix-breadcrumb-container",flex:"grow"},{name:"statusContainer",addClass:"bloonix-header-status"}]},{name:"topNavContainer",addClass:"bloonix-top-nav-container bloonix-fullscreen"},{name:"messageContainer",addClass:"bloonix-message-container"},{name:"subNavContainer",addClass:"bloonix-sub-nav-container bloonix-fullscreen"},{name:"bodyWrapper",flex:"grow",boxes:[{name:"body",addClass:"bloonix-body",grow:true,scroll:true}]}]}]},this);$("body").html(this.container);this.shapeLogo=Blx.create("div").addClass("bloonix-shape").appendTo(this.shapeContainer).append(Blx.create("img").attr("src",this.whiteShape));this.controlIcon=Blx.icon().size("tall").coloring("black").btnClass("bloonix-control-icons");this.menuIcon=this.controlIcon.btn("menu").appendTo(this.controlIconsContainer);this.fullscreenIcon=this.controlIcon.btn("expand").appendTo(this.controlIconsContainer).prop("title",Blx.text.get("main.fullscreen")).click(()=>this.switchToFullscreen(true));this.fullscreenIconOff=this.controlIcon.btn("shrink").appendTo(this.controlIconsContainer).prop("title",Blx.text.get("main.fullscreen_off")).click(()=>this.switchToFullscreen(false)).hide();this.breadcrumb=Blx.breadcrumb({size:"tall",container:this.breadcrumbContainer})}addControlIcon(o){this.siteControlIcons.show();const icon=this.controlIcon.btn(o.name).prop("title",o.title).click(o.click);if(o.hide===true){icon.hide()}icon.appendTo(this.siteControlIcons);return icon}clearControlIcons(){this.siteControlIcons.html("");this.siteControlIcons.hide()}switchToFullscreen(on){if(on===false){$(".bloonix-fullscreen").show(200);this.fullscreenIcon.show();this.fullscreenIconOff.hide()}else if(on===true){$(".bloonix-fullscreen").hide(200);this.fullscreenIcon.hide();this.fullscreenIconOff.show();Blx.infoMessage(Blx.text.get("main.leave_fullscreen"));$(document).one("keydown",event=>{if(event.key=="Escape"){this.switchToFullscreen(false)}})}}initStatusBox(){this.statusBoxes=[];const statusIcon=Blx.icon().size("supertiny").coloring("gray");for(let i=6;i>=0;i--){const icon=this.statusIconsById[i],item={};this.statusBoxes.unshift(item);const span=Blx.create("span").addClass("bloonix-header-status-icon").appendTo(this.statusContainer).click(()=>Blx.route.to("services",{searchableValue:["status","==",i]}));statusIcon.span(icon).css("margin-right","5px").addClass("bloonix-status-text-"+i).appendTo(span);item.countBox=Blx.create("span").addClass("bloonix-status-text-"+i).setHTML(0).appendTo(span)}const getStatus=show=>{Blx.ajax.request({url:"/services/status",success:result=>{$.each(result.data.status,(i,num)=>{this.statusBoxes[i].countBox.setHTML(num)});if(show){this.statusContainer.show("slide",{direction:"left"},500)}}})};getStatus(true);Blx.interval({monitor:this.statusContainer,interval:3e4,callback:getStatus})}initSiteNav(){let navStyle=this.user.settings.nav||"compact";let visible=false;this.siteNavContainer=Blx.create("div").addClass("bloonix-site-nav-container").appendTo(this.containerLeft);const navHeader=Blx.create("div").addClass("bloonix-nav-header").appendTo(this.siteNavContainer);Blx.create("div").addClass("bloonix-shape").appendTo(navHeader).append(Blx.create("img").attr("src",this.whiteShape));Blx.create("div").addClass("bloonix-text").appendTo(navHeader).append(Blx.create("img").attr("src",this.whiteText));const navHeaderIcon=Blx.icon().coloring("gray").size("small").cursor("pointer").iconClass("bloonix-nav-header-icon").appendTo(navHeader);const setNavStyle=navHeaderIcon.span("settings");this.siteNav=Blx.navigation({navClass:"bloonix-site-nav",itemClass:"bloonix-site-nav-item",titleClass:"bloonix-site-nav-title",appendTo:this.siteNavContainer,iconConfig:icon=>{icon.coloring("white")}});this.siteNav.addTitle(Blx.text.get("nav.main.monitoring"));this.siteNav.add({icon:"layout-dashboard",route:"dashboard",text:Blx.text.get("nav.main.dashboard"),callback:()=>Blx.route.to("dashboard")});this.siteNav.add({icon:"server",route:"hosts",text:Blx.text.get("nav.main.hosts"),callback:()=>Blx.route.to("hosts")});this.siteNav.add({icon:"layers",route:"services",text:Blx.text.get("nav.main.services"),callback:()=>Blx.route.to("services")});this.siteNav.add({icon:"calendar",route:"events",text:Blx.text.get("nav.main.events"),callback:()=>Blx.route.to("events")});this.siteNav.add({icon:"chart-area",route:"charts",text:Blx.text.get("nav.main.charts"),callback:()=>Blx.route.to("charts")});if(this.user.role=="admin"||this.user.role=="operator"){this.siteNav.add({icon:"bell-ring",route:"notifications",text:Blx.text.get("host.nav.notifications"),callback:()=>Blx.route.to("notifications")});this.siteNav.addTitle(Blx.text.get("nav.main.config"));this.siteNav.add({icon:"layers",route:"config/templates",text:Blx.text.get("nav.main.templates"),callback:()=>Blx.route.to("config/templates")});this.siteNav.add({icon:"group",route:"config/groups",text:Blx.text.get("nav.main.groups"),callback:()=>Blx.route.to("config/groups")});if(this.user.role=="admin"){this.siteNav.add({icon:"user",route:"config/users",text:Blx.text.get("nav.main.users"),callback:()=>Blx.route.to("config/users")})}this.siteNav.add({icon:"globe",route:"config/satellites",text:Blx.text.get("nav.main.satellites"),callback:()=>Blx.route.to("config/satellites")});this.siteNav.add({icon:"square-asterisk",route:"config/location-groups",text:Blx.text.get("nav.main.location_groups"),callback:()=>Blx.route.to("config/location-groups")});this.siteNav.add({icon:"settings-2",route:"config/sys-options",text:Blx.text.get("nav.main.sys_options"),callback:()=>Blx.route.to("config/sys-options")});this.siteNav.add({name:"registration",icon:"file-pen-line",route:"config/registration",text:Blx.text.get("nav.main.registration"),callback:()=>Blx.route.to("config/registration")});const checkRegCount=()=>{Blx.ajax.request({url:"/config/registration/hosts/count",success:result=>{console.log;if(result.data>0){this.siteNav.showIconMark("registration")}else{this.siteNav.hideIconMark("registration")}}})};setInterval(checkRegCount,6e4);setTimeout(checkRegCount,3e3);this.siteNav.add({icon:"user-round",route:"config/contacts",text:Blx.text.get("nav.main.contacts"),callback:()=>Blx.route.to("config/contacts")});this.siteNav.add({icon:"users-round",route:"config/contactgroups",text:Blx.text.get("nav.main.contactgroups"),callback:()=>Blx.route.to("config/contactgroups")});this.siteNav.add({icon:"siren",route:"config/message-services",text:Blx.text.get("nav.main.message_services"),callback:()=>Blx.route.to("config/message-services")})}this.siteNav.addTitle(Blx.text.get("nav.main.user_settings"));this.siteNav.add({icon:"flag",text:Blx.text.get("nav.main.language"),callback:()=>(new ConfigUser).changeLang()});this.siteNav.add({icon:"clock",text:Blx.text.get("nav.main.timezone"),callback:()=>(new ConfigUser).changeTimezone()});this.siteNav.add({icon:"key-round",text:Blx.text.get("nav.main.chpwd"),callback:()=>(new ConfigUser).changePassword()});this.siteNav.add({icon:"paintbrush",text:Blx.text.get("nav.main.style"),callback:()=>(new ConfigUser).changeStyle()});this.siteNav.addTitle("");this.siteNav.add({icon:"log-out",text:Blx.text.get("action.logout"),callback:()=>{window.location="/logout"}});const updateNav=()=>{if(navStyle=="compact"){this.menuIcon.hide();this.shapeLogo.hide();this.siteNavContainer.addClass("bloonix-site-nav-container-minimal");this.containerLeft.addClass("bloonix-site-nav-container-minimal");this.siteNavContainer.removeClass("bloonix-site-nav-container-visible");this.siteNavContainer.removeClass("bloonix-site-nav-container-invisible")}else if(navStyle=="visible"){this.menuIcon.hide();this.shapeLogo.hide();this.siteNavContainer.addClass("bloonix-site-nav-container-visible");this.containerLeft.addClass("bloonix-site-nav-container-visible");this.siteNavContainer.removeClass("bloonix-site-nav-container-minimal");this.containerLeft.removeClass("bloonix-site-nav-container-minimal");this.siteNavContainer.removeClass("bloonix-site-nav-container-invisible")}else if(navStyle=="hidden"){this.menuIcon.show();this.shapeLogo.show();this.siteNavContainer.addClass("bloonix-site-nav-container-invisible");this.siteNavContainer.removeClass("bloonix-site-nav-container-visible");this.containerLeft.removeClass("bloonix-site-nav-container-visible");this.siteNavContainer.removeClass("bloonix-site-nav-container-minimal");this.containerLeft.removeClass("bloonix-site-nav-container-minimal")}};this.menuIcon.click(e=>{e.stopPropagation();this.siteNavContainer.addClass("bloonix-site-nav-container-visible");$(document).one("click",()=>{this.siteNavContainer.removeClass("bloonix-site-nav-container-visible")})});setNavStyle.click(e=>{if(navStyle=="compact"){navStyle="visible"}else if(navStyle=="visible"){navStyle="hidden"}else if(navStyle=="hidden"){navStyle="compact"}Blx.ajax.request({url:`/user/set-nav/${navStyle}`});this.user.settings.nav=navStyle;updateNav()});this.__compactNavVisible=false;this.siteNavContainer.on("mouseenter",()=>{if(navStyle=="compact"){this.__compactNavVisible=true;this.siteNavContainer.addClass("bloonix-site-nav-container-visible");$(document).one("click",()=>{this.__compactNavVisible=false;this.siteNavContainer.removeClass("bloonix-site-nav-container-visible")})}});this.siteNavContainer.on("mouseleave",()=>{if(navStyle=="compact"&&this.__compactNavVisible===true){$(document).trigger("click")}});updateNav()}initContentNav(){this.topNav=Blx.topNav({appendTo:this.topNavContainer,navClass:"bloonix-top-nav",itemClass:"bloonix-top-nav-item",itemActiveClass:"bloonix-top-nav-item-active"});this.subNav=Blx.topNav({appendTo:this.topNavContainer,navClass:"bloonix-sub-nav",itemClass:"bloonix-sub-nav-item",itemActiveClass:"bloonix-sub-nav-item-active"})}initRoutes(){Blx.route.beforeParse=()=>this.clear();Blx.route.defaultRoute="dashboard";Blx.route.to()}getOptions(url,callback){Blx.ajax.request({url:url,success:result=>{callback(result.data.options,result.data.values)}})}createServiceStatusTableColumn(td,row,col){if(col===undefined){col="status"}const statusName=parseInt(row[col]);td.addClass("bloonix-status-column-bg");td.addClass("bloonix-status-bg").addClass(`bloonix-status-bg-${row[col]}`).addClass("bloonix-status-td").text(blxapp.statusById[statusName])}getStatusByName(states){const arr=[];$.each(states,(i,s)=>{arr.push(blxapp.statusById[s])});return arr.join(",")}}const blxpage={list:function(o){if(!o.appendTo&&!o.replaceTo){o.replaceTo=blxapp.body}return Blx.table(o)},overlayForm:function(o){if(o.optionsUrl&&!o.options){this.getOptions(o,"overlayForm");return}const c=Blx.utils.shift(["title","titleIcon","subtitle","tableObject","onSuccess","optionsUrl","getElements","overlayPosition"],o);const overlay=Blx.overlay({title:c.title,titleIcon:c.titleIcon,position:c.overlayPosition||"right"});if(c.subtitle){Blx.create("div").addClass("bloonix-form-subtitle").setHTML(c.subtitle).appendTo(overlay.subtitleWrapper)}o.messageContainer=overlay.message;o.appendTo=overlay.body;o.showSubmitButton=false;o.onSuccess=(resultData,form)=>{overlay.close();if(c.tableObject){c.tableObject.reload()}if(c.onSuccess){c.onSuccess(resultData,form)}};if(o.submitCallback){const sc=o.submitCallback;o.submitCallback=form=>sc(form,overlay)}const form=Blx.form(o);const button=overlay.addButton({text:Blx.text.get("action.submit"),callback:()=>form.submit()});form.setSubmitButton(button);overlay.create();Blx.create("div").addClass("bloonix-overlay-form-padding-bottom").appendTo(overlay.body);if(c.getElements){c.getElements(form)}return form},form:function(o){if(!o.options||!o.values){this.getOptions(o,"form");return}const c=Blx.utils.shift(["grow","optionsUrl","title","titleIcon","breadcrumbText","breadcrumbRoute","replaceTo","appendTo","getElements"],o);if(c.breadcrumbText&&c.breadcrumbRoute){blxapp.breadcrumb.add(c.breadcrumbText,c.breadcrumbRoute)}if(!c.appendTo&&!c.replaceTo){c.replaceTo=blxapp.body}const contentBox=Blx.contentBox({grow:c.grow===undefined?true:c.grow,title:c.title,titleIcon:c.titleIcon,replaceTo:c.replaceTo,appendTo:c.appendTo});o.appendTo=contentBox.body;const form=Blx.form(o);if(c.getElements){c.getElements(form)}return form},getOptions:function(o,fn){Blx.ajax.request({url:o.optionsUrl,success:result=>{o.options=result.data.options;o.values=result.data.values;this[fn](o)}})}};const blxTableColumns={columns:{}};blxTableColumns.set=function(table,columns){if(blxTableColumns.columns[table]===undefined){blxTableColumns.columns[table]={}}$.each(columns,(name,callback)=>{blxTableColumns.columns[table][name]=callback})};blxTableColumns.get=function(table,columns){const ret=[];$.each(columns,(i,name)=>{const column=blxTableColumns.columns[table][name]();if(column.name===undefined){column.name=name}ret.push(column)});return ret};blxTableColumns.getAll=function(table,except){const ret=[];$.each(blxTableColumns.columns[table],(name,callback)=>{if(except&&Blx.utils.includes(name,except)){return true}const column=callback();if(column.name===undefined){column.name=name}ret.push(column)});return ret};Blx.route.add("charts",args=>{blxapp.breadcrumb.add(Blx.text.get("chart.list"),"charts");new ServiceCharts});class ServiceCharts{constructor(args={}){this.appendTo=args.appendTo||blxapp.body;this.hostId=args.hostId||0;this.dashboardCallback=args.dashboardCallback;this.chartView=false;this.chartViewOptions={interval:60,last:10800,type:"avg",charts_per_row:3};if(this.hostId>0){this.url=`/hosts/${this.hostId}/charts`}else{this.url="/hosts/charts"}if(this.dashboardCallback){this.overlay=Blx.overlay({position:"full"});this.appendTo=this.overlay.body;this.overlay.create()}else{this.addControlIcon()}this.addChartSelectionBox()}addControlIcon(){this.controlIcon=blxapp.addControlIcon({name:"chart-area",title:Blx.text.get("chart.add"),click:()=>this.manageChartDashboard()});this.controlIconInfo=Blx.elementInfo({appendTo:this.controlIcon,body:Blx.text.get("chart.change_chart_options_here")})}manageChartDashboard(){if(this.grid){this.saveGridConfig();this.grid.removeAll();this.gridContainer.remove()}this.selectChartsBox.show()}saveGridConfig(){this.gridConfig={};$.each(this.grid.getWidgets(),(i,w)=>{const id=`${w.data.service_id}-${w.data.chart_id}`;this.gridConfig[id]=w})}addChartSelectionBox(){this.selectChartsBox=Blx.create("div").addClass("bloonix-fwh").appendTo(this.appendTo);this.flexContainer=Blx.create("div").addClass("blx-flex-row blx-flex-grow bloonix-fwh").appendTo(this.selectChartsBox);this.leftBox=Blx.create("div").addClass("bloonix-chart-selection-left").appendTo(this.flexContainer);this.rightBox=Blx.create("div").addClass("bloonix-chart-selection-right").appendTo(this.flexContainer);this.addChartOptions();this.addChartTable()}addChartOptions(){const values=this.chartViewOptions;const contentBox=Blx.contentBox({title:Blx.text.get("word.Options"),appendTo:this.leftBox});if(!this.dashboardCallback){contentBox.icon.btn("folder-open").prop("title",Blx.text.get("chart.chart_views")).click(()=>this.listChartsViews())}this.form=Blx.form({appendTo:contentBox.body,submitButtonText:Blx.text.get("action.generate"),submitCallback:form=>{if(this.dashboardCallback){this.addChartToDashboard(form.data)}else{this.generateCharts(form.data);this.controlIconInfo.show()}},showMandatoryFieldsInfo:false,showSubmitButton:false});const row=this.form.createEmptyElement().addClass("bloonix-chart-form-row");const rowBtn=Blx.create("div").appendTo(row);const rowLast=Blx.create("div").appendTo(row);const rowFix=Blx.create("div").appendTo(row).hide();const lastBtn=Blx.create("span").addClass("bloonix-chart-form-short-btn").addClass("bloonix-chart-form-short-btn-selected").text(Blx.text.get("form.predefined_time_range")).appendTo(rowBtn);if(!this.dashboardCallback){Blx.create("span").text("|").appendTo(rowBtn);const fixBtn=Blx.create("span").addClass("bloonix-chart-form-short-btn").text(Blx.text.get("form.absolute_time_range")).appendTo(rowBtn);lastBtn.click(()=>{rowFix.hide();fixBtn.removeClass("bloonix-chart-form-short-btn-selected");rowLast.show();lastBtn.addClass("bloonix-chart-form-short-btn-selected")});fixBtn.click(()=>{rowLast.hide();lastBtn.removeClass("bloonix-chart-form-short-btn-selected");rowFix.show();fixBtn.addClass("bloonix-chart-form-short-btn-selected")});this.form.datetime({name:"from_time",text:Blx.text.get("form.from_time"),appendTo:rowFix});this.form.datetime({name:"to_time",text:Blx.text.get("form.to_time"),appendTo:rowFix})}this.form.radioBtn({name:"last",parseInt:true,options:this.radioBtnSeconds([10800,21600,43200,86400,259200,604800]),value:values.last,appendTo:rowLast});this.form.radioBtn({name:"interval",text:Blx.text.get("word.Interval"),parseInt:true,options:this.radioBtnSeconds([30,60,120,180,300]),value:values.interval,appendTo:this.form.createEmptyElement().addClass("bloonix-chart-form-row")});this.form.radioBtn({name:"type",text:Blx.text.get("word.Type"),parseInt:true,options:[{value:"avg",label:"AVG"},{value:"min",label:"MIN"},{value:"max",label:"MAX"}],value:values.type,appendTo:this.form.createEmptyElement().addClass("bloonix-chart-form-row")});if(!this.dashboardCallback){this.form.radioBtn({name:"charts_per_row",text:Blx.text.get("chart.per_row"),options:[1,2,3,4,5,6],value:values.charts_per_row,appendTo:this.form.createEmptyElement().addClass("bloonix-chart-form-row")})}if(this.chartView){this.chartViewNameBox=Blx.create("div").addClass("bloonix-chart-view-title").html(Blx.text.get("chart.current_chart_view",this.chartView.name)).appendTo(this.form.createEmptyElement().addClass("bloonix-chart-form-row"))}const btnRow=this.form.createEmptyRow().css("padding-top","20px");Blx.button({size:"large"}).text(Blx.text.get("action.generate")).appendTo(btnRow).click(()=>this.form.submit());if(!this.dashboardCallback){Blx.button({size:"large"}).text(Blx.text.get("action.save")).click(()=>this.saveChartView()).appendTo(btnRow)}}loadChartView(chartViewId){Blx.ajax.request({url:`/chart-views/${chartViewId}`,success:result=>{this.chartView=result.data;this.chartViewOptions=result.data.data.options;this.chartRowsSelected=[];$.each(result.data.data.charts,(i,item)=>{this.chartRowsSelected.push(`${item.service_id}-${item.chart_id}`)});blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("chart.list"),"charts");blxapp.breadcrumb.add(result.data.name);this.selectChartsBox.remove();this.addChartSelectionBox()}})}saveChartView(){if(this.chartTable.getSelectedRows().length==0){this.noChartsSelected();return}if(this.chartView!==false){this.updateChartViewData()}else{this.createChartView()}}createChartView(){blxpage.overlayForm({title:Blx.text.get("chart.create"),submitUrl:this.hostId?`/hosts/${this.hostId}/chart-views/create`:"/chart-views/create",optionsUrl:"/chart-views/options",onSuccess:data=>{this.chartView=data;this.updateChartViewData()},elements:this.getChartViewFormElements()})}updateChartView(chartView){blxpage.overlayForm({title:Blx.text.get("chart.update"),submitUrl:`/chart-views/${chartView.id}/update`,optionsUrl:`/chart-views/${chartView.id}/options`,onSuccess:()=>this.chartViewTable.reload(),elements:this.getChartViewFormElements()})}getChartViewFormElements(){return[{tag:"input",name:"name",text:Blx.text.get("word.Name")}]}updateChartViewData(){const charts=[];$.each(this.chartTable.getSelected(),(i,chart)=>{charts.push({service_id:chart.service_id,chart_id:chart.chart_id})});Blx.ajax.request({url:`/chart-views/${this.chartView.id}/update-data`,data:{options:this.form.parseFormData(),charts:charts},success:result=>{Blx.successMessage(Blx.text.get("form.update_success"))}})}noChartsSelected(){Blx.errorMessage({message:Blx.text.get("chart.nothing_selected")})}radioBtnSeconds(arr){const options=[];for(const v of arr){options.push({value:v,label:Blx.utils.secondsToStringShortReadable(v)})}return options}addChartTable(){this.chartTable=Blx.table({replaceTo:this.rightBox,title:Blx.text.get("chart.list"),titleIcon:"chart-area",url:this.url,uid:row=>row.service_id+"-"+row.chart_id,searchable:{enabled:true},selectable:{enabled:true,selected:this.chartRowsSelected},visible:{enabled:true},columns:this.getColumns()})}getColumns(){const columns=[];columns.push({name:"host_id",text:Blx.text.get("host.attr.id"),searchable:{type:"int"},sortable:true});if(this.hostId==0){columns.push({name:"hostname",text:Blx.text.get("host.attr.hostname"),searchable:{type:"string"},sortable:true,responsive:true,visible:true})}columns.push({name:"service_id",text:Blx.text.get("service.attr.id"),searchable:{type:"int"},sortable:true,responsive:true});columns.push({name:"service_name",text:Blx.text.get("service.attr.service_name"),searchable:{type:"string"},sortable:true,responsive:true,visible:true});columns.push({name:"plugin_service",text:Blx.text.get("plugin.attr.service"),searchable:{type:"string"},sortable:true,visible:true});columns.push({name:"chart_title",text:Blx.text.get("chart.attr.title"),searchable:{type:"string"},sortable:true,responsive:true,visible:true});return columns}listChartsViews(){const overlay=Blx.overlay().create();this.chartViewTable=Blx.table({title:Blx.text.get("chart.chart_views"),appendTo:overlay.body,url:this.hostId?`/hosts/${this.hostId}/chart-views`:"/chart-views",selectable:{enabled:true,columns:["name"],deletable:{route:"/chart-views/:id/delete"}},columns:[{name:"id",text:Blx.text.get("word.ID")},{name:"icons",visible:true,responsive:true,value:row=>{const span=Blx.create("span");tableStatusIcon.span("folder-pen").prop("title",Blx.text.get("action.edit")).css("cursor","pointer").click(()=>this.updateChartView(row)).appendTo(span);return span},visible:true},{name:"name",text:Blx.text.get("word.Name"),responsive:true,callback:row=>{overlay.close();this.loadChartView(row.id)}}]})}addChartToDashboard(o){if(this.chartTable.getSelectedIds().length==0){this.noChartsSelected();return}$.each(this.chartTable.getSelected(),(i,row)=>{this.dashboardCallback({name:"chart",config:{host_id:this.hostId||row.host_id,service_id:row.service_id,chart_id:row.chart_id,last:o.last,type:o.type,interval:o.interval*1e3},w:4,h:8})});this.overlay.close()}generateCharts(o){if(this.chartTable.getSelectedIds().length==0){this.noChartsSelected();return}this.num=0;this.selectChartsBox.hide();this.gridContainer=Blx.create("div").appendTo(this.appendTo);this.grid=new Grid({container:this.gridContainer});this.grid.enableResize(false);$.each(this.chartTable.getSelected(),(i,row)=>{this.createChart({host_id:this.hostId||row.host_id,service_id:row.service_id,chart_id:row.chart_id,last:o.last,from_time:o.from_time,to_time:o.to_time,type:o.type,interval:o.interval,charts_per_row:o.charts_per_row})})}createChart(o){const gridId=`${o.service_id}-${o.chart_id}`;let x,y,w=12/o.charts_per_row,h=8;if(this.gridConfig&&this.gridConfig[gridId]&&parseInt(this.gridConfig[gridId].w)==w){x=this.gridConfig[gridId].x;y=this.gridConfig[gridId].y;w=this.gridConfig[gridId].w;h=this.gridConfig[gridId].h}const widget=this.grid.addWidget({x:x,y:y,w:w,h:h,data:{host_id:o.host_id,service_id:o.service_id,chart_id:o.chart_id}});const chart=new ServiceChart({container:widget.gridContent,host_id:o.host_id,service_id:o.service_id,chart_id:o.chart_id,last:o.last,from_time:o.from_time,to_time:o.to_time,type:o.type,interval:o.interval,remove:()=>{this.chartTable.unselect(gridId);widget.remove();this.num-=1;if(this.num===0){this.manageChartDashboard()}}}).create();widget.addObject(chart);this.num+=1}}class ServiceChart{constructor(o){this.config=Blx.utils.config(o,["container","host_id","service_id","chart_id","from_time","to_time","last","type","interval","satellite_id","datapoints","remove"]);Blx.resize.add(this.config.container,()=>this.resize())}create(){this.chartBox=Blx.create("div").addClass("bloonix-chart-box").appendTo(this.config.container);this.chartContent=Blx.create("div").addClass("bloonix-fwh").appendTo(this.chartBox);Blx.loading(this.chartContent);this.iconBox=Blx.create("div").addClass("bloonix-chart-info-icon").appendTo(this.chartBox);this.menu=Blx.moreMenu({appendTo:this.iconBox,position:"right"});this.menu.add({text:Blx.text.get("chart.info"),callback:()=>this.showPluginInfo()});if(this.config.remove){this.menu.add({text:Blx.text.get("chart.remove"),callback:()=>this.removeChart()})}this.reload();if(!this.config.from_time&&!this.config.to_time&&this.config.interval){Blx.interval({alias:"chart",monitor:this.chartBox,callback:()=>this.reload(),interval:this.config.interval*1e3})}return this}reload(){const postdata={type:this.config.type};if(this.config.satellite_id){postdata.satellite_id=this.config.satellite_id}if(this.config.from_time){postdata.from_time=this.config.from_time;if(this.config.to_time){postdata.to_time=this.config.to_time}}else{postdata.last=parseInt(this.config.last)}postdata.datapoints=parseInt(this.chartContent.innerWidth());Blx.ajax.request({url:`/hosts/${this.config.host_id}/services/${this.config.service_id}/charts/${this.config.chart_id}/data`,data:postdata,success:result=>this.draw(result.data)})}draw(data){this.plugin=data.plugin;this.series=data.chart.series;this.chartContent.html("");this.chart=drawChart(data,this.config.type,this.chartContent)}showPluginInfo(){const overlay=Blx.overlay({title:this.plugin.service,position:"middle"}).create();const table=Blx.simpleTable({appendTo:overlay.body});$.each(this.series,(i,item)=>{const metric=this.plugin.metrics[item.name];const row=table.row();row.th.text(metric.name);row.td.text(metric.description)})}removeChart(){this.config.remove();this.config.container.remove()}resize(){if(this.chart){this.chart.resize()}}}function drawChart(o,type,container){let titleColor,labelColor,gridLineColor;if(blxapp.style=="default"){titleColor="#404040";labelColor="#505050";gridLineColor="#e1e1e1"}else{titleColor="#c1c1c1";labelColor="#b1b1b1";gridLineColor="#333333"}container.css("position","relative");const labelBox=Blx.create("div").css("width","12px").css("height","100%").css("position","absolute").css("top",0).css("left",0).appendTo(container);const labelFlex=Blx.create("div").css("display","flex").css("justify-content","center").css("align-items","center").css("width","100%").css("height","100%").appendTo(labelBox);const label=Blx.create("div").text(o.chart.ylabel).css("color",labelColor).css("font-weight","normal").css("font-size","12px").css("line-height","12px").css("writing-mode","vertical-lr").css("transform","rotate(180deg)").appendTo(labelFlex);const newContainer=Blx.create("div").css("width","100%").css("height","100%").appendTo(container);container=newContainer;const datatype=o.chart.unit,legendData=[],series=[],colorNames={},opposite={};$.each(o.chart.series,(i,item)=>{const itemName=o.plugin.metrics[item.name].name;opposite[itemName]=item.opposite;colorNames[itemName]=item.color;legendData.push({name:o.plugin.metrics[item.name].name,itemStyle:{color:item.color}});const s={name:itemName,type:"line",showSymbol:false,lineStyle:{width:1,color:item.color},emphasis:{focus:"series"},data:o.data[item.name]};if(o.chart.chart_type=="area"){s.areaStyle={color:item.color}}if(o.chart.stack===1){s.stack="Total"}series.push(s)});const option={animation:false,textStyle:{fontFamily:"Roboto"},title:{text:`(${type}) ${o.service.hostname} :: ${o.service.service_name}`,itemGap:5,padding:10,textStyle:{color:titleColor,fontWeight:"normal",fontSize:"13px"},subtext:o.chart.title,subtextStyle:{color:labelColor,fontWeight:"normal",fontSize:"12px",fontWeight:"300"}},tooltip:{trigger:"axis",position:function(pos,params,dom,rect,size){const obj={top:40};obj[["left","right"][+(pos[0]<size.viewSize[0]/2)]]=5;return obj},formatter:params=>{const box=Blx.create("div");Blx.create("div").css("color","#000000").css("font-size","13px").css("line-height","15px").css("font-weight","bold").text(Blx.dateFormat(params[0].data[0],"default")).appendTo(box);if(datatype){Blx.create("div").text(`Datatype: ${datatype}`).appendTo(box)}$.each(params,(i,item)=>{const value=datatype=="bytes"?Blx.utils.toUnitBytes(item.data[1],2):Blx.utils.toUnit(item.data[1],2);Blx.create("div").css("color",colorNames[item.seriesName]).css("font-size","13px").css("line-height","15px").css("font-weight","bold").text(`${item.seriesName}: ${value}`).appendTo(box)});return box[0]},axisPointer:{type:"cross",label:{backgroundColor:"#6a7985"}}},legend:{type:"scroll",data:legendData,bottom:0,icon:"rect",itemHeight:12,itemWidth:20,padding:[20,20,0,20],textStyle:{color:labelColor}},grid:{left:25,right:10,bottom:30,containLabel:true},xAxis:[{type:"time",splitNumber:5,axisLabel:{hideOverlap:true}}],yAxis:[{splitNumber:8,splitLine:{lineStyle:{color:gridLineColor}},axisLabel:{color:labelColor,fontWeight:"normal",fontSize:"12px",formatter:(value,index)=>{if(datatype=="bytes"){return Blx.utils.toUnitBytes(value,1)}return Blx.utils.toUnit(value,1)}}}],series:series};const chart=echarts.init(container[0]);chart.setOption(option);return chart}Blx.route.add("config/contactgroups",args=>new ConfigContactgroups(args).list());Blx.route.add("config/contactgroups/:id",args=>new ConfigContactgroups(args).edit());Blx.route.add("config/contactgroups/:id/:action",args=>new ConfigContactgroups(args).edit());Blx.route.add("config/contactgroups/create",args=>new ConfigContactgroups(args).create());class ConfigContactgroups{constructor(args){this.contactgroupId=args.id;this.action=args.action;this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.contactgroups"),"config/contactgroups")}list(){blxpage.list({title:Blx.text.get("contactgroup.list"),titleIcon:"users-round",url:"/config/contactgroups",headerIcons:[{name:"plus",title:Blx.text.get("contactgroup.create"),callback:()=>this.create()}],selectable:{enabled:true,columns:["name"],deletable:{route:"/config/contactgroups/:id/delete"}},columns:[{name:"name",text:Blx.text.get("contactgroup.attr.name"),route:"config/contactgroups/:id",searchable:{type:"string"},sortable:true,responsive:true},{name:"description",text:Blx.text.get("word.Description"),searchable:{type:"string"},sortable:true}]})}create(){blxpage.overlayForm({title:Blx.text.get("contactgroup.create"),optionsUrl:"/config/contactgroups/options",submitUrl:"/config/contactgroups/create",elements:this.form(),onSuccess:data=>{Blx.route.to(`config/contactgroups/${data.id}`)}})}edit(){Blx.ajax.request({url:`/config/contactgroups/${this.contactgroupId}`,success:result=>{blxapp.breadcrumb.add(result.data.name,`/config/contactgroups/${this.contactgroupId}`);blxapp.topNav.add({name:"",text:Blx.text.get("text.meta_data"),route:`config/contactgroups/${this.contactgroupId}`,callback:()=>this.editMetaData()});blxapp.topNav.add({name:"contacts",text:Blx.text.get("contactgroup.text.contacts"),route:`config/contactgroups/${this.contactgroupId}/contacts`,callback:()=>this.editContacts()});blxapp.topNav.add({name:"hosts",text:Blx.text.get("contactgroup.text.hosts"),route:`config/contactgroups/${this.contactgroupId}/hosts`,callback:()=>this.editHosts()});blxapp.topNav.add({name:"services",text:Blx.text.get("contactgroup.text.services"),route:`config/contactgroups/${this.contactgroupId}/services`,callback:()=>this.editServices()});blxapp.topNav.run(this.action)}})}editMetaData(){Blx.ajax.request({url:`/config/contactgroups/${this.contactgroupId}/options`,success:result=>{blxpage.form({title:result.data.values.name,titleIcon:"users-round",submitUrl:`/config/contactgroups/${this.contactgroupId}/update`,options:result.data.options,values:result.data.values,elements:this.form()})}})}editHosts(){const contentBox=Blx.contentBox({grow:true,replaceTo:blxapp.body});Blx.group({progressName:"hostname",appendTo:contentBox.body,member:{title:Blx.text.get("contactgroup.text.host_member"),url:`/config/contactgroups/${this.contactgroupId}/hosts/member`},noMember:{title:Blx.text.get("contactgroup.text.host_no_member"),url:`/config/contactgroups/${this.contactgroupId}/hosts/no-member`},addMember:{url:row=>{return`/config/contactgroups/${this.contactgroupId}/hosts/${row.id}/add`}},removeMember:{url:row=>{return`/config/contactgroups/${this.contactgroupId}/hosts/${row.id}/remove`}},button:{add:Blx.text.get("contactgroup.text.host_add_selected"),remove:Blx.text.get("contactgroup.text.host_remove_selected")},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),searchable:{type:"string"},sortable:true,responsive:true},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true,responsive:true},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"autocomplete",url:"/hosts/directory/project"},sortable:true},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"autocomplete",url:"/hosts/directory/location"},sortable:true}]})}editServices(){const contentBox=Blx.contentBox({grow:true,replaceTo:blxapp.body});Blx.group({progressName:"service_name",appendTo:contentBox.body,member:{title:Blx.text.get("contactgroup.text.service_member"),url:`/config/contactgroups/${this.contactgroupId}/services/member`},noMember:{title:Blx.text.get("contactgroup.text.service_no_member"),url:`/config/contactgroups/${this.contactgroupId}/services/no-member`},addMember:{url:row=>{return`/config/contactgroups/${this.contactgroupId}/services/${row.id}/add`}},removeMember:{url:row=>{return`/config/contactgroups/${this.contactgroupId}/services/${row.id}/remove`}},button:{add:Blx.text.get("contactgroup.text.service_add_selected"),remove:Blx.text.get("contactgroup.text.service_remove_selected")},columns:[{name:"hostname",text:Blx.text.get("word.Hostname"),searchable:{type:"string"},sortable:true,responsive:true},{name:"service_name",text:Blx.text.get("service.attr.service_name"),searchable:{type:"string"},sortable:true,responsive:true}]})}editContacts(){const contentBox=Blx.contentBox({grow:true,replaceTo:blxapp.body});Blx.group({progressName:"name",appendTo:contentBox.body,member:{title:Blx.text.get("contactgroup.text.contact_member"),url:`/config/contactgroups/${this.contactgroupId}/contacts/member`},noMember:{title:Blx.text.get("contactgroup.text.contact_no_member"),url:`/config/contactgroups/${this.contactgroupId}/contacts/no-member`},addMember:{url:row=>{return`/config/contactgroups/${this.contactgroupId}/contacts/${row.id}/add`}},removeMember:{url:row=>{return`/config/contactgroups/${this.contactgroupId}/contacts/${row.id}/remove`}},button:{add:Blx.text.get("contactgroup.text.contact_add_selected"),remove:Blx.text.get("contactgroup.text.contact_remove_selected")},columns:[{name:"name",text:Blx.text.get("word.Name"),searchable:{type:"string"},sortable:true,responsive:true}]})}form(){return[{tag:"input",name:"name",text:Blx.text.get("word.Name"),maxlength:100,required:true},{tag:"input",name:"description",text:Blx.text.get("word.Description"),maxlength:100,required:false}]}}Blx.route.add("config/contacts",args=>new ConfigContacts(args).list());Blx.route.add("config/contacts/:id",args=>new ConfigContacts(args).edit());Blx.route.add("config/contacts/create",args=>new ConfigContacts(args).create());class ConfigContacts{constructor(args){this.contactId=args.id;this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.contacts"),"config/contacts")}list(){blxpage.list({title:Blx.text.get("contact.list"),titleIcon:"user-round",url:"/config/contacts",headerIcons:[{name:"plus",title:Blx.text.get("contact.create"),callback:()=>this.create()}],selectable:{enabled:true,columns:["name"],deletable:{route:"/config/contacts/:id/delete"}},footerIcons:[{name:"circle-off",title:Blx.text.get("contact.action.en_dis_able.title"),callback:table=>this.enOrDisable(table)}],columns:[{name:"name",text:Blx.text.get("contact.attr.name"),route:"config/contacts/:id",searchable:{type:"string"},sortable:true,responsive:true},{name:"escalation_time",text:Blx.text.get("contact.attr.escalation_time"),sortable:true,value:row=>{if(row.escalation_time===0){return Blx.text.get("contact.escalation_time.always")}return Blx.text.get("contact.escalation_time.after",Blx.utils.secondsToStringReadable(row.escalation_time))}},{name:"timezone",text:Blx.text.get("word.Timezone")},{name:"enabled",text:Blx.text.get("word.Enabled"),convertBool:"yn",searchable:{type:"bool"}}]})}create(){blxpage.form({title:Blx.text.get("contact.create"),breadcrumbText:Blx.text.get("contact.create"),breadcrumbRoute:"config/contacts/create",optionsUrl:"/config/contacts/options",submitUrl:"/config/contacts/create",elements:this.form(),onSuccess:data=>Blx.route.to("config/contacts/"+data.id)})}edit(){Blx.ajax.request({url:"/config/contacts/"+this.contactId,success:result=>{blxapp.breadcrumb.add(result.data.name,"/config/contacts/"+this.contactId);this.editMetadata()}})}enOrDisable(table){const overlay=Blx.overlay({title:Blx.text.get("contact.action.en_dis_able.title"),position:"middle"});overlay.body.css("text-align","center");Blx.button().text(Blx.text.get("action.enable")).appendTo(overlay.body).click(()=>this._enOrDisable(1,table,overlay));Blx.button().text(Blx.text.get("action.disable")).appendTo(overlay.body).click(()=>this._enOrDisable(0,table,overlay));overlay.create()}_enOrDisable(value,table,overlay){overlay.close();const items=[];$.each(table.getSelectedRows(),(i,item)=>{items.push({url:`/config/contacts/${item.id}/update`,data:{enabled:value},token:true})});Blx.progress({items:items,finish:()=>table.reload()})}editMetadata(){Blx.ajax.request({url:"/config/contacts/"+this.contactId+"/options",success:result=>{blxpage.form({grow:false,appendTo:blxapp.body,title:Blx.text.get("contact.name",result.data.values.name),titleIcon:"user-round",submitUrl:"/config/contacts/"+this.contactId+"/update",options:result.data.options,values:result.data.values,elements:this.form()});this.listMessageServices()}})}listMessageServices(){const table=blxpage.list({grow:false,appendTo:blxapp.body,title:Blx.text.get("contact.message_services"),titleIcon:"siren",url:"/config/contacts/"+this.contactId+"/message-services",headerIcons:[{name:"plus",callback:()=>this.loadMessageServiceOptions(false,table)}],selectable:{enabled:true,columns:["id","name","send_to"],deletable:{route:"/config/contacts/"+this.contactId+"/message-services/:id/remove",buttonText:Blx.text.get("action.remove")}},columns:[{name:"name",text:Blx.text.get("contact_message_service.attr.name"),callback:row=>this.loadMessageServiceOptions(row.id,table),responsive:true},{name:"send_to",text:Blx.text.get("contact_message_service.attr.send_to"),responsive:true},{name:"notification_level",text:Blx.text.get("contact_message_service.attr.notification_level"),value:row=>blxapp.getStatusByName(row.notification_level)},{name:"timeperiods",text:Blx.text.get("contact.timeperiods"),value:row=>{const div=Blx.create("div");$.each(row.timeperiods,(i,v)=>{Blx.create("div").text(v).appendTo(div)});return div}},{name:"enabled",text:Blx.text.get("word.Enabled"),convertBool:"yn"}]})}loadMessageServiceOptions(cmsId,table){Blx.ajax.request({url:cmsId?"/config/contacts/"+this.contactId+"/message-services/"+cmsId+"/options":"/config/contacts/"+this.contactId+"/message-services/options",success:result=>{this.showMessageServiceForm(result.data.options,result.data.values,cmsId,table)}})}showMessageServiceForm(options,values,cmsId,table){blxpage.overlayForm({title:Blx.text.get("contact.message_service"),titleIcon:"siren",tableObject:table,submitUrl:cmsId?"/config/contacts/"+this.contactId+"/message-services/"+cmsId+"/update":"/config/contacts/"+this.contactId+"/message-services/add",options:options,values:values,submitButtonText:cmsId?Blx.text.get("action.update"):Blx.text.get("action.add"),elements:[{tag:"select",name:"message_service_id",text:Blx.text.get("contact_message_service.attr.name")},{tag:"input",name:"send_to",text:Blx.text.get("contact_message_service.attr.send_to")},{tag:"checkboxBtn",name:"notification_level",text:Blx.text.get("contact_message_service.attr.notification_level"),help:Blx.text.get("contact_message_service.help.notification_level"),parseInt:true},{tag:"array",name:"timeperiods",text:Blx.text.get("contact_message_service.attr.timeperiod"),help:Blx.text.get("contact_message_service.help.timeperiod"),parseInt:true},{tag:"checkYesNo",name:"enabled",text:Blx.text.get("word.Enabled")}]})}form(){return[{tag:"input",name:"name",text:Blx.text.get("contact.attr.name"),maxlength:100,required:true},{tag:"select",name:"timezone",text:Blx.text.get("word.Timezone"),required:true},{tag:"select",orig:true,name:"escalation_time",text:Blx.text.get("contact.attr.escalation_time"),help:Blx.text.get("contact.help.escalation_time"),label:value=>{if(value===0){return Blx.text.get("contact.escalation_time.always")}return Blx.text.get("contact.escalation_time.after",Blx.utils.secondsToStringReadable(value))}},{tag:"checkOnOff",name:"enabled",text:Blx.text.get("word.Enabled")}]}}class ConfigDowntimes{constructor(args){this.hostId=args.hostId;this.appendTo=args.appendTo;this.replaceTo=args.replaceTo;if(this.replaceTo){this.replaceTo.html("");this.appendTo=this.replaceTo;this.replaceTo=undefined}}list(){const simpleGrid=Blx.simpleGrid({replaceTo:this.appendTo});this.hostDowntimesTable=blxpage.list({grow:false,appendTo:simpleGrid.add(),title:Blx.text.get("downtimes.host_downtimes"),titleIcon:"alarm-clock-minus",url:`/config/hosts/${this.hostId}/downtimes`,headerIcons:[{name:"plus",callback:table=>this.createHostDowntimeForm()}],selectable:{enabled:true,columns:["id","begin","end","timeslice","description"],deletable:{route:`/config/hosts/${this.hostId}/downtimes/:id/remove`,buttonText:Blx.text.get("action.remove"),confirmButtonText:Blx.text.get("action.remove")}},columns:getDowntimeColumns(false)});this.serviceDowntimesTable=blxpage.list({grow:false,appendTo:simpleGrid.add(),title:Blx.text.get("downtimes.service_downtimes"),titleIcon:"alarm-clock-minus",url:`/config/hosts/${this.hostId}/downtimes/services`,headerIcons:[{name:"plus",callback:table=>this.createServiceDowntimeForm()}],selectable:{enabled:true,columns:["id","service_name","begin","end","timeslice","description"],deletable:{route:`/config/hosts/${this.hostId}/downtimes/services/:id/remove`,buttonText:Blx.text.get("action.remove"),confirmButtonText:Blx.text.get("action.remove")}},columns:getDowntimeColumns(true)})}listHostDowntimes(){this.hostDowntimesTable=blxpage.list({grow:false,appendTo:this.appendTo,title:Blx.text.get("downtimes.host_downtimes"),titleIcon:"alarm-clock-minus",url:`/config/hosts/${this.hostId}/downtimes`,headerIcons:[{name:"plus",callback:table=>this.createHostDowntimeForm()}],selectable:{enabled:true,columns:["id","begin","end","timeslice","description"],deletable:{route:`/config/hosts/${this.hostId}/downtimes/:id/remove`,buttonText:Blx.text.get("action.remove"),confirmButtonText:Blx.text.get("action.remove")}},columns:getDowntimeColumns(false)})}listServiceDowntimes(){this.serviceDowntimesTable=blxpage.list({grow:false,appendTo:this.appendTo,title:Blx.text.get("downtimes.service_downtimes"),titleIcon:"alarm-clock-minus",url:`/config/hosts/${this.hostId}/downtimes/services`,headerIcons:[{name:"plus",callback:table=>this.createServiceDowntimeForm()}],selectable:{enabled:true,columns:["id","service_name","begin","end","timeslice","description"],deletable:{route:`/config/hosts/${this.hostId}/downtimes/services/:id/remove`,buttonText:Blx.text.get("action.remove"),confirmButtonText:Blx.text.get("action.remove")}},columns:getDowntimeColumns(true)})}createHostDowntimeForm(table){new DowntimeForm({urlBaseSubmit:`/config/hosts/${this.hostId}/downtimes/add`,urlBaseOptions:`/config/hosts/${this.hostId}/downtimes/options`,onSuccess:()=>this.hostDowntimesTable.reload()}).create()}createServiceDowntimeForm(){new DowntimeForm({urlBaseSubmit:`/config/hosts/${this.hostId}/downtimes/services/add`,urlBaseOptions:`/config/hosts/${this.hostId}/downtimes/services/options`,withServices:true,onSuccess:()=>this.serviceDowntimesTable.reload()}).create()}}function getDowntimeColumns(withService){const cols=[{name:"id",text:Blx.text.get("word.ID"),visible:false},{name:"begin",text:Blx.text.get("downtime.attr.begin"),convertUnixtime:true},{name:"end",text:Blx.text.get("downtime.attr.end"),convertUnixtime:true},{name:"timeslice",text:Blx.text.get("downtime.attr.timeslice")},{name:"timezone",text:Blx.text.get("downtime.attr.timezone")},{name:"description",text:Blx.text.get("downtime.attr.description")},{name:"active",text:Blx.text.get("word.Active"),convertBool:true}];if(withService===true){cols.splice(1,0,{name:"service_name",text:Blx.text.get("service.attr.service_name")})}return cols}class DowntimeForm{constructor(o){this.config=o}create(){this.overlay=Blx.overlay({title:this.config.title,titleIcon:this.config.titleIcon}).create();this.navContainer=Blx.create("div").appendTo(this.overlay.control);this.messageContainer=Blx.create("div").appendTo(this.overlay.message);this.formContainer=Blx.create("div").css("padding-top","30px").appendTo(this.overlay.body);this.overlay.addButton({text:Blx.text.get("action.submit"),callback:()=>this.form.submit()});const nav=Blx.topNav({replaceTo:this.navContainer});nav.add({name:"fixtime",text:Blx.text.get("downtime.fix_time"),callback:()=>this.createFormElements("fixtime")});nav.add({name:"timeslice",text:Blx.text.get("downtime.timeslice"),callback:()=>this.createFormElements("timeslice")});nav.add({name:"preset",text:Blx.text.get("downtime.preset"),callback:()=>this.createFormElements("preset")});nav.run("fixtime")}createFormElements(type){this.type=type;const formOptions={replaceTo:this.formContainer,showSubmitButton:false,messageContainer:this.messageContainer,onSuccess:(resultData,form)=>{this.overlay.close();if(this.config.onSuccess){this.config.onSuccess(this,resultData,form)}},elements:[]};if(this.config.submitCallback){formOptions.submitCallback=form=>this.config.submitCallback(this,form)}if(this.config.urlBaseSubmit){formOptions.submitUrl=`${this.config.urlBaseSubmit}/${type}`}if(this.config.urlBaseOptions){formOptions.optionsUrl=`${this.config.urlBaseOptions}/${type}`}this.addDefaultFormElements(formOptions.elements);if(type=="fixtime"){this.addFixtimeFormElements(formOptions.elements)}else if(type=="timeslice"){this.addTimesliceFormElements(formOptions.elements)}else if(type=="preset"){this.addPresetFormElements(formOptions.elements)}if(type=="fixtime"||type=="preset"){formOptions.formInfo=Blx.create("div").css("color","#bb0000").text(Blx.text.get("downtime.fix_time_description"))}if(this.config.withServices===true){this.addServiceFormElements(formOptions.elements)}this.form=Blx.form(formOptions)}addDefaultFormElements(f){f.push({tag:"input",name:"description",text:Blx.text.get("word.Description"),required:true});f.push({tag:"select",name:"timezone",text:Blx.text.get("word.Timezone"),required:true})}addFixtimeFormElements(f){f.push({tag:"datetime",name:"begin",text:Blx.text.get("downtime.attr.begin"),timeFormat:"HH:mm",required:true});f.push({tag:"datetime",name:"end",text:Blx.text.get("downtime.attr.end"),timeFormat:"HH:mm",required:true})}addTimesliceFormElements(f){f.push({tag:"array",name:"timeslice",text:Blx.text.get("downtime.attr.timeslice"),help:Blx.text.get("timeperiod.help.timeslice"),required:true})}addPresetFormElements(f){f.push({tag:"radioBtn",name:"preset",text:Blx.text.get("downtime.preset"),help:Blx.text.get("downtime.preset_help"),convertSeconds:true,required:true})}addServiceFormElements(f){f.push({tag:"table",name:"service_ids",table:{title:Blx.text.get("host.title.services"),columns:[{name:"id",text:Blx.text.get("word.ID")},{name:"service_name",text:Blx.text.get("service.attr.service_name")}]}})}getType(){return this.type}}Blx.route.add("config/groups",args=>new ConfigGroups(args).list());Blx.route.add("config/groups/:id",args=>new ConfigGroups(args).edit());Blx.route.add("config/groups/:id/:action",args=>new ConfigGroups(args).edit());Blx.route.add("config/groups/create",args=>new ConfigGroups(args).create());class ConfigGroups{constructor(args){this.groupId=args.id;this.action=args.action;this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.groups"),"config/groups")}list(){this.table=blxpage.list({title:Blx.text.get("group.list"),titleIcon:"group",url:"/config/groups",headerIcons:[{name:"plus",title:Blx.text.get("group.create"),callback:()=>this.create()}],selectable:{enabled:true,columns:["name"],deletable:{route:"/config/groups/:id/delete"}},columns:[{name:"name",text:Blx.text.get("group.attr.name"),route:"config/groups/:id",searchable:{type:"string"},sortable:true,responsive:true},{name:"description",text:Blx.text.get("word.Description"),searchable:{type:"string"},sortable:true}]})}create(){blxpage.overlayForm({tableObject:this.table,title:Blx.text.get("group.create"),titleIcon:"group",optionsUrl:"/config/groups/options",submitUrl:"/config/groups/create",elements:this.form(),onSuccess:data=>{Blx.route.to(`config/groups/${data.id}`)}})}edit(){Blx.ajax.request({url:`/config/groups/${this.groupId}`,success:result=>{blxapp.breadcrumb.add(result.data.name,`/config/groups/${this.groupId}`);blxapp.topNav.add({name:"",text:Blx.text.get("text.meta_data"),route:`config/groups/${this.groupId}`,callback:()=>this.editMetaData()});blxapp.topNav.add({name:"hosts",text:Blx.text.get("group.text.hosts"),route:`config/groups/${this.groupId}/hosts`,callback:()=>this.editHosts()});blxapp.topNav.add({name:"users",text:Blx.text.get("group.text.users"),route:`config/groups/${this.groupId}/users`,callback:()=>this.editUsers()});blxapp.topNav.run(this.action)}})}editMetaData(groupId){Blx.ajax.request({url:`/config/groups/${this.groupId}/options`,success:result=>{blxpage.form({title:result.data.values.name,titleIcon:"group",submitUrl:`/config/groups/${this.groupId}/update`,options:result.data.options,values:result.data.values,elements:this.form()})}})}editHosts(){const contentBox=Blx.contentBox({grow:true,replaceTo:blxapp.body});Blx.group({progressName:"hostname",appendTo:contentBox.body,member:{title:Blx.text.get("group.text.host_member"),url:`/config/groups/${this.groupId}/hosts/member`},noMember:{title:Blx.text.get("group.text.host_no_member"),url:`/config/groups/${this.groupId}/hosts/no-member`},addMember:{url:row=>{return`/config/groups/${this.groupId}/hosts/${row.id}/add`}},removeMember:{url:row=>{return`/config/groups/${this.groupId}/hosts/${row.id}/remove`}},button:{add:Blx.text.get("group.text.host_add_selected"),remove:Blx.text.get("group.text.host_remove_selected")},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),searchable:{type:"string"},sortable:true,responsive:true},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true,responsive:true},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"autocomplete",url:"/hosts/directory/project"},sortable:true},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"autocomplete",url:"/hosts/directory/location"},sortable:true}]})}editUsers(){const contentBox=Blx.contentBox({grow:true,replaceTo:blxapp.body});Blx.group({progressName:"username",appendTo:contentBox.body,member:{title:Blx.text.get("group.text.user_member"),url:`/config/groups/${this.groupId}/users/member`},noMember:{title:Blx.text.get("group.text.user_no_member"),url:`/config/groups/${this.groupId}/users/no-member`},addMember:{url:row=>{return`/config/groups/${this.groupId}/users/${row.id}/add`}},removeMember:{url:row=>{return`/config/groups/${this.groupId}/users/${row.id}/remove`}},button:{add:Blx.text.get("group.text.user_add_selected"),remove:Blx.text.get("group.text.user_remove_selected")},columns:[{name:"username",text:Blx.text.get("word.Username"),searchable:{type:"string"},sortable:true,responsive:true}]})}form(){return[{tag:"input",name:"name",text:Blx.text.get("group.attr.name"),required:true},{tag:"input",name:"description",text:Blx.text.get("word.Description"),required:false}]}}class ConfigHost{constructor(args={}){this.hostId=args.hostId}create(successCallback){const overlay=Blx.overlay({title:Blx.text.get("host.title.enter_hostname"),position:"middle",closeText:Blx.text.get("action.abort"),buttons:[{text:Blx.text.get("host.get_ip_address"),callback:()=>this._create(input.val()),close:true}]}).create();const content=Blx.create("div").appendTo(overlay.body);const form=Blx.create("form").appendTo(content);const input=Blx.create("input").addClass("bloonix-form-input").attr("type","text").attr("placeholder",Blx.text.get("word.Hostname")).appendTo(form).focus();form.submit(e=>{e.preventDefault();overlay.close();this._create(input.val(),successCallback);return false})}_create(hostname,successCallback){Blx.ajax.request({url:"/config/hosts/dnsreq",data:{hostname:hostname},success:result=>{let ip4=result.data.v4||"",ip6=result.data.v6||"";blxpage.overlayForm({title:Blx.text.get("host.create"),titleIcon:"server-cog",optionsUrl:"/config/hosts/options",submitUrl:"/config/hosts/create",getElements:form=>this.addFormElements(form,"create",hostname,ip4,ip6,Blx.utils.genRandStr(40)),onSuccess:data=>this.showInfoBox(data,successCallback)})}})}showInfoBox(data,successCallback){const bloonix_init_host=[];bloonix_init_host.push("bloonix-init-host");bloonix_init_host.push(`--host-id ${data.id}`);bloonix_init_host.push(`--password ${data.password}`);bloonix_init_host.push(`--server ${data.bloonix_server_names}`);if(data.bloonix_proxy_id!==undefined){bloonix_init_host.push(`--proxy ${data.bloonix_proxy_id}`)}const bloonix_agent_config=[];bloonix_agent_config.push("host {\n");if(data.bloonix_proxy_id!==undefined){bloonix_agent_config.push(`    proxy ${data.bloonix_proxy_id}\n`)}bloonix_agent_config.push(`    host_id ${data.id}\n`);bloonix_agent_config.push(`    password ${data.password}\n`);bloonix_agent_config.push("}");const content=Blx.create("div").addClass("blx-text-box").append(Blx.create("p").html(Blx.text.get("host.new_host_main_desc",data.hostname)),Blx.create("p").html(Blx.text.get("host.new_host_setup_command")),Blx.create("pre").text(bloonix_init_host.join(" \\\n    ")),Blx.create("p").html(Blx.text.get("host.new_host_setup_manual")),Blx.create("pre").text(bloonix_agent_config.join("")));Blx.overlay({title:Blx.text.get("host.new_host_title"),body:content,closeCallback:successCallback}).create()}edit(successCallback){Blx.ajax.request({url:`/config/hosts/${this.hostId}/options`,success:result=>{blxpage.overlayForm({title:Blx.text.get("host.edit",this.hostId),titleIcon:"server-cog",values:result.data.values,options:result.data.options,submitUrl:`/config/hosts/${this.hostId}/update`,onSuccess:successCallback,getElements:form=>this.addFormElements(form,"update")})}})}addFormElements(form,action,hostname,ip4=undefined,ip6=undefined,password){if(action=="create"){addHostGroupElements(form)}form.input({name:"hostname",text:Blx.text.get("host.attr.hostname"),help:Blx.text.get("host.help.hostname"),maxlength:100,required:true,value:hostname});form.input({name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),help:Blx.text.get("host.help.ipaddr"),maxlength:45,required:true,value:ip4?ip4:ip6});form.input({name:"ipaddr2",text:Blx.text.get("host.attr.ipaddr2"),help:Blx.text.get("host.help.ipaddr"),maxlength:45,value:ip4?ip6:undefined});form.input({name:"ipaddr3",text:Blx.text.get("host.attr.ipaddr3"),help:Blx.text.get("host.help.ipaddr"),maxlength:45});form.input({name:"ipaddr4",text:Blx.text.get("host.attr.ipaddr4"),help:Blx.text.get("host.help.ipaddr"),maxlength:45});form.input({name:"description",text:Blx.text.get("host.attr.description"),help:Blx.text.get("host.help.description"),maxlength:100});form.textarea({name:"comment",text:Blx.text.get("word.Comment"),maxlength:400});form.textarea({name:"sysinfo",text:Blx.text.get("host.attr.sysinfo"),help:Blx.text.get("host.help.sysinfo"),maxlength:400});form.input({name:"password",text:Blx.text.get("word.Password"),help:Blx.text.get("host.help.password"),minlength:30,maxlength:128,password:true,autocomplete:"off",required:true,genpwd:40,value:password});form.array({name:"allow_from",text:Blx.text.get("host.attr.allow_from"),help:Blx.text.get("host.help.allow_from")});form.select({name:"country_code",text:Blx.text.get("host.attr.country_code"),help:Blx.text.get("host.help.country_code")});form.input({name:"location_class",text:Blx.text.get("host.attr.location_class"),help:Blx.text.get("host.help.location_class"),maxlength:100,autocompleteUrl:"/hosts/directory/location"});form.input({name:"project_class",text:Blx.text.get("host.attr.project_class"),help:Blx.text.get("host.help.project_class"),maxlength:100,autocompleteUrl:"/hosts/directory/project"});form.checkOnOff({name:"enabled",text:Blx.text.get("host.attr.enabled"),help:Blx.text.get("host.help.enabled")});form.slider({name:"notification_interval",text:Blx.text.get("host.attr.notification_interval"),help:Blx.text.get("host.help.notification_interval"),convertSeconds:true});form.checkOnOff({name:"notification_enabled",text:Blx.text.get("host.attr.notification_enabled"),help:Blx.text.get("host.help.notification_enabled")});const variablesBox=form.createEmptyRow().addClass("bloonix-info-container").hide();Blx.create("h1").text(Blx.text.get("service.available_variables")).appendTo(variablesBox);if(this.hostId){Blx.ajax.request({url:`/config/hosts/${this.hostId}/variables`,success:result=>{if(result.data.length>0){variablesBox.show()}$.each(result.data,(i,row)=>{Blx.create("h2").text(Blx.text.get("service.template",row.name)).appendTo(variablesBox);Blx.simpleTable({fullwidth:false,appendTo:variablesBox,rows:row.variables})})}})}form.dict({name:"variables",text:Blx.text.get("template.attr.variables")})}}function addHostGroupElements(form){form.select({name:"template_id",text:Blx.text.get("host.add_to_template_group"),multiple:true,parseInt:true});form.select({name:"group_id",text:Blx.text.get("host.add_to_host_group"),multiple:true,parseInt:true});form.select({name:"location_group_id",text:Blx.text.get("host.add_to_location_group"),multiple:true,parseInt:true});form.select({name:"contactgroup_id",text:Blx.text.get("host.add_to_contactgroup"),multiple:true,parseInt:true})}class ConfigHostDependencies{constructor(args){this.hostId=args.hostId;this.appendTo=args.appendTo;this.replaceTo=args.replaceTo}list(){this.table=blxpage.list({title:Blx.text.get("dependency.title"),titleIcon:"share-2",url:`/config/hosts/${this.hostId}/dependencies`,appendTo:this.appendTo,replaceTo:this.replaceTo,headerIcons:[{name:"plus",callback:()=>this.add(),title:Blx.text.get("dependency.create")}],selectable:{enabled:true,columns:["id","service_name","on_hostname","on_service_name"],deletable:{route:`/config/hosts/${this.hostId}/dependencies/:id/remove`,buttonText:Blx.text.get("action.remove")}},columns:[{name:"id",text:Blx.text.get("word.ID")},{name:"service_name",text:Blx.text.get("service.attr.service_name")},{name:"status",text:Blx.text.get("dependency.attr.status"),value:row=>blxapp.getStatusByName(row.status)},{name:"on_hostname",text:Blx.text.get("dependency.attr.on_host_id"),route:"/hosts/:on_host_id/dependencies"},{name:"on_service_name",text:Blx.text.get("dependency.attr.on_service_id")},{name:"on_status",text:Blx.text.get("dependency.attr.on_status"),value:row=>blxapp.getStatusByName(row.on_status)}]})}add(){this.overlay=Blx.overlay({title:Blx.text.get("dependency.create"),titleIcon:"share-2"}).create();this.selectService()}selectService(){Blx.table({title:Blx.text.get("dependency.create.step1"),url:`/config/hosts/${this.hostId}/services`,replaceTo:this.overlay.body,pager:{enabled:false},sortable:{enabled:true},searchable:{enabled:true},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"service_name",text:Blx.text.get("service.attr.service_name"),searchable:{type:"string"},sortable:true},{name:"host_alive_check",text:Blx.text.get("service.attr.host_alive_check"),convertBool:true,highlight:true}],onRowClick:row=>this.selectOnHost(row)})}selectOnHost(service){Blx.table({title:Blx.text.get("dependency.create.step2"),url:`/config/hosts/except/${this.hostId}`,replaceTo:this.overlay.body,pager:{enabled:true},searchable:{enabled:true},sortable:{enabled:true},columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"hostname",text:Blx.text.get("host.attr.hostname"),sortable:true,searchable:{type:"string"}}],onRowClick:row=>this.selectOnService(service,row)})}selectOnService(service,onHost){Blx.table({title:Blx.text.get("dependency.create.step3"),url:`/config/hosts/${onHost.id}/services`,replaceTo:this.overlay.body,pager:{enabled:false},searchable:{enabled:true},sortable:{enabled:true},columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"service_name",text:Blx.text.get("service.attr.service_name"),sortable:true,searchable:{type:"string"}},{name:"host_alive_check",text:Blx.text.get("service.attr.host_alive_check"),convertBool:true,highlight:true}],onRowClick:row=>this.dependencyForm(service,onHost,row)})}dependencyForm(service,onHost,onService){this.overlay.body.html("");const form=Blx.form({appendTo:this.overlay.body,submitUrl:`/config/hosts/${this.hostId}/dependencies/add`,messageContainer:this.messageContainer,onSuccess:()=>{this.overlay.close();this.table.reload()}});form.hidden({name:"service_id",value:service.id});form.hidden({name:"on_service_id",value:onService.id});form.checkboxBtn({name:"status",text:Blx.text.get("dependency.create.step4",[service.service_name],true),options:[{label:"NOTICE",value:2},{label:"WARNING",value:3},{label:"ALERT",value:4},{label:"CRITICAL",value:5}],value:[2,3,4,5,6],parseInt:true});form.checkboxBtn({name:"on_status",text:Blx.text.get("dependency.create.step5",[onService.service_name,onHost.hostname],true),options:[{label:"INFO",value:1},{label:"NOTICE",value:2},{label:"WARNING",value:3},{label:"ALERT",value:4},{label:"CRITICAL",value:5}],value:[1,5],parseInt:true})}}class ConfigHostGroups{constructor(args){this.hostId=args.hostId;this.replaceTo=args.replaceTo;this.appendTo=args.appendTo;Blx.group({progressName:"groups",appendTo:this.appendTo,replaceTo:this.replaceTo,member:{title:Blx.text.get("host.member_of_host_group"),url:`/config/hosts/${this.hostId}/groups/member`},noMember:{title:Blx.text.get("host.add_to_host_group"),url:`/config/hosts/${this.hostId}/groups/no-member`},addMember:{url:row=>{return`/config/hosts/${this.hostId}/groups/${row.id}/add`}},removeMember:{url:row=>{return`/config/hosts/${this.hostId}/groups/${row.id}/remove`}},button:{add:Blx.text.get("host.add_to_host_group"),remove:Blx.text.get("host.remove_from_host_group")},columns:[{name:"name",text:Blx.text.get("group.attr.name"),searchable:{type:"string"},sortable:true,responsive:true},{name:"description",text:Blx.text.get("word.Description"),searchable:{type:"string"},sortable:true}]})}}class ConfigHostLocationGroups{constructor(args){this.hostId=args.hostId;this.replaceTo=args.replaceTo;this.appendTo=args.appendTo;Blx.group({progressName:"location-groups",appendTo:this.appendTo,replaceTo:this.replaceTo,member:{title:Blx.text.get("host.member_of_location_group"),url:`/config/hosts/${this.hostId}/location-groups/member`},noMember:{title:Blx.text.get("host.add_to_location_group"),url:`/config/hosts/${this.hostId}/location-groups/no-member`},addMember:{url:row=>{return`/config/hosts/${this.hostId}/location-groups/${row.id}/add`}},removeMember:{url:row=>{return`/config/hosts/${this.hostId}/location-groups/${row.id}/remove`}},button:{add:Blx.text.get("host.add_to_location_group"),remove:Blx.text.get("host.remove_from_location_group")},columns:[{name:"name",text:Blx.text.get("group.attr.name"),searchable:{type:"string"},sortable:true,responsive:true},{name:"description",text:Blx.text.get("word.Description"),searchable:{type:"string"},sortable:true}]})}}class ConfigHostTemplates{constructor(args){this.hostId=args.hostId;this.replaceTo=args.replaceTo;this.appendTo=args.appendTo;Blx.group({progressName:"templates",appendTo:this.appendTo,replaceTo:this.replaceTo,member:{title:Blx.text.get("host.member_of_template_group"),url:`/config/hosts/${this.hostId}/templates/member`},noMember:{title:Blx.text.get("host.add_to_template_group"),url:`/config/hosts/${this.hostId}/templates/no-member`},addMember:{url:row=>{return`/config/hosts/${this.hostId}/templates/${row.id}/add`}},removeMember:{url:row=>{return`/config/hosts/${this.hostId}/templates/${row.id}/remove`}},button:{add:Blx.text.get("host.add_to_template_group"),remove:Blx.text.get("host.remove_from_template_group")},columns:[{name:"name",text:Blx.text.get("template.attr.name"),searchable:{type:"string"},sortable:true,responsive:true},{name:"tags",text:Blx.text.get("template.attr.tags"),searchable:{type:"string"},sortable:true}]})}}class ConfigHostContactGroups{constructor(args){this.hostId=args.hostId;this.replaceTo=args.replaceTo;this.appendTo=args.appendTo;Blx.group({progressName:"contactgroup",appendTo:this.appendTo,replaceTo:this.replaceTo,member:{title:Blx.text.get("host.member_of_contactgroup"),url:`/config/hosts/${this.hostId}/contactgroups/member`},noMember:{title:Blx.text.get("host.add_to_contactgroup"),url:`/config/hosts/${this.hostId}/contactgroups/no-member`},addMember:{url:row=>{return`/config/hosts/${this.hostId}/contactgroups/${row.id}/add`}},removeMember:{url:row=>{return`/config/hosts/${this.hostId}/contactgroups/${row.id}/remove`}},button:{add:Blx.text.get("host.add_to_contactgroup"),remove:Blx.text.get("host.remove_from_contactgroup")},columns:[{name:"name",text:Blx.text.get("group.attr.name"),searchable:{type:"string"},sortable:true,responsive:true},{name:"description",text:Blx.text.get("word.Description"),searchable:{type:"string"},sortable:true}]})}}Blx.route.add("config/message-services",args=>new ConfigMessageService(args).list());class ConfigMessageService{constructor(args){this.messageServiceId=this.id;this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.message_services"),"config/message_service")}list(){this.table=blxpage.list({title:Blx.text.get("message_service.list"),titleIcon:"siren",url:"/config/message-services",headerIcons:[{name:"plus",title:Blx.text.get("message_service.create"),callback:()=>this.listPlugins()}],selectable:{enabled:true,columns:["name"],deletable:{route:"/config/message-services/:id/delete",subtitle:Blx.create("div").addClass("bloonix-warning-message").text(Blx.text.get("message_service.delete_warning"))}},columns:[{name:"name",text:Blx.text.get("word.Name"),callback:row=>this.edit(row)},{name:"enabled",text:Blx.text.get("word.Enabled"),convertBool:"yn"}]})}listPlugins(){const icon=Blx.icon().size("tall").coloring(blxapp.iconColor1);const overlay=Blx.overlay({title:Blx.text.get("service.select_plugin")}).create();const table=Blx.create("table").addClass("bloonix-select-table").appendTo(overlay.body);$.each(this.getPlugins(),(i,plugin)=>{const tr=Blx.create("tr").appendTo(table).click(()=>{overlay.close();this.create(plugin)});Blx.create("td").html(icon.span(plugin.icon)).appendTo(tr);Blx.create("td").setHTML(plugin.name).appendTo(tr)})}create(plugin){const form=blxpage.overlayForm({tableObject:this.table,title:Blx.text.get("message_service.create"),titleIcon:"siren",optionsUrl:`/config/message-services/options/${plugin.builtin}`,submitUrl:`/config/message-services/create/${plugin.builtin}`,getElements:form=>this.addFormElements(plugin.builtin,form),formInfo:Blx.create("span").html(Blx.text.get(`message_service.${plugin.builtin}.description`)),processDataCallback:data=>this.processDataCallback(data,plugin.builtin)})}edit(data){Blx.ajax.request({url:`/config/message-services/${data.id}`,success:result=>{const builtin=result.data.builtin;blxpage.overlayForm({tableObject:this.table,title:data.name,titleIcon:"siren",submitUrl:`/config/message-services/${data.id}/update`,optionsUrl:`/config/message-services/${data.id}/options`,getElements:form=>this.addFormElements(builtin,form),formInfo:Blx.create("span").html(Blx.text.get(`message_service.${builtin}.description`)),processDataCallback:data=>this.processDataCallback(data,builtin)})}})}processDataCallback(data,builtin){if(builtin=="http"){if(data.data_type=="url-encoded"){delete data.postdata_json;delete data.postdata_raw}else if(data.data_type=="json"){delete data.postdata_urlencoded;delete data.postdata_raw}else if(data.data_type=="raw"){delete data.postdata_json;delete data.postdata_urlencoded}else{delete data.postdata_raw;delete data.postdata_json;delete data.postdata_urlencoded}delete data.data_type}return data}addFormSendmail(form){form.input({name:"host",text:Blx.text.get("message_service.sendmail.param.host")});form.input({name:"username",text:Blx.text.get("message_service.sendmail.param.username")});form.input({name:"password",text:Blx.text.get("message_service.sendmail.param.password"),password:true,reSendPassword:true,autocomplete:"off"});form.input({name:"sender",text:Blx.text.get("message_service.sendmail.param.sender"),required:true});form.input({name:"send_to",text:Blx.text.get("message_service.sendmail.param.send_to"),help:Blx.text.get("message_service.sendmail.help.send_to"),required:true});form.input({name:"subject",text:Blx.text.get("message_service.sendmail.param.subject"),required:true});form.input({name:"message",text:Blx.text.get("message_service.sendmail.param.message"),required:true})}addFormHTTP(form){form.input({name:"url",text:Blx.text.get("message_service.http.param.url")});form.input({name:"auth_basic",text:Blx.text.get("message_service.http.param.auth_basic"),help:Blx.text.get("message_service.http.help.auth_basic")});form.input({name:"user_agent",text:Blx.text.get("message_service.http.param.user_agent"),help:Blx.text.get("message_service.http.help.user_agent"),maxlength:120});form.checkYesNo({name:"inscure",text:Blx.text.get("message_service.http.param.insecure"),help:Blx.text.get("message_service.http.help.insecure")});form.dict({name:"header",text:Blx.text.get("message_service.http.param.header")});const postDataRaw=Blx.create("div").hide();const postDataJSON=Blx.create("div").hide();const postDataUrlEncoded=Blx.create("div").hide();const onChange=value=>{if(value=="url-encoded"){postDataRaw.hide();postDataJSON.hide();postDataUrlEncoded.show()}else if(value=="json"){postDataRaw.hide();postDataUrlEncoded.hide();postDataJSON.show()}else if(value=="raw"){postDataJSON.hide();postDataUrlEncoded.hide();postDataRaw.show()}};const postDataBox=form.createEmptyRow().css("border","1px solid #e1e1e1");Blx.create("div").addClass("bloonix-form-row-title").text("POST data").appendTo(postDataBox);let postDataValue;if(form.values.postdata_raw!==undefined&&form.values.postdata_raw!==null){postDataValue="raw"}else if(form.values.postdata_json!==undefined&&form.values.postdata_json!==null){postDataValue="json"}else if(form.values.postdata_urlencoded!==undefined&&form.values.postdata_urlencoded!==null){postDataValue="url-encoded"}form.radioBtn({name:"data_type",text:Blx.text.get("message_service.http.param.data_type"),help:Blx.text.get("message_service.http.help.data_type"),onChange:value=>onChange(value),appendTo:postDataBox,value:postDataValue,options:[{value:"url-encoded",label:Blx.text.get("message_service.http.param.postdata_urlencoded")},{value:"json",label:Blx.text.get("message_service.http.param.postdata_json")},{value:"raw",label:Blx.text.get("message_service.http.param.postdata_raw")}]});postDataRaw.appendTo(postDataBox);postDataJSON.appendTo(postDataBox);postDataUrlEncoded.appendTo(postDataBox);form.textarea({name:"postdata_raw",text:Blx.text.get("message_service.http.param.postdata_raw"),help:Blx.text.get("message_service.http.help.postdata_raw"),appendTo:postDataRaw});form.textarea({name:"postdata_json",text:Blx.text.get("message_service.http.param.postdata_json"),help:Blx.text.get("message_service.http.help.postdata_json"),appendTo:postDataJSON});form.dict({name:"postdata_urlencoded",text:Blx.text.get("message_service.http.param.postdata_urlencoded"),help:Blx.text.get("message_service.http.help.postdata_urlencoded"),appendTo:postDataUrlEncoded,multipleKeys:true});onChange(postDataValue);form.input({name:"check_status_code",text:Blx.text.get("message_service.http.param.check_status_code")});form.input({name:"check_content",text:Blx.text.get("message_service.http.param.check_content"),help:Blx.text.get("message_service.http.help.check_content")})}addFormScript(form){form.input({name:"script",text:Blx.text.get("message_service.script.param.script"),help:Blx.text.get("message_service.script.help.script")});form.dict({multipleKeys:true,name:"params",text:Blx.text.get("message_service.script.param.params"),help:Blx.text.get("message_service.script.help.params")})}addFormDefaults(form){form.input({name:"name",text:Blx.text.get("message_service.attr.name"),required:true});form.checkYesNo({name:"enabled",text:Blx.text.get("word.Enabled")});form.div({title:Blx.text.get("message_service.help.variables_title"),content:Blx.create("span").html(Blx.text.get("message_service.help.variables"))});form.textarea({name:"message_template",rows:20,text:Blx.text.get("message_service.attr.message_template"),help:Blx.text.get("message_service.help.message_template")})}addFormElements(builtin,form){this.addFormDefaults(form);if(builtin=="sendmail"){return this.addFormSendmail(form)}else if(builtin=="http"){return this.addFormHTTP(form)}else if(builtin=="script"){return this.addFormScript(form)}}getPlugins(){return[{builtin:"sendmail",name:"Sendmail",icon:"mail"},{builtin:"http",name:"HTTP",icon:"globe"},{builtin:"script",name:"Script",icon:"code"}]}}Blx.route.add("config/registration",args=>new ConfigRegistration(args,"hosts"));Blx.route.add("config/registration/authkeys",args=>new ConfigRegistration(args,"auth"));Blx.route.add("config/registration/authkeys/:id",args=>new ConfigRegistration(args,"auth"));class ConfigRegistration{constructor(args,action){this.regauthId=args.id;blxapp.topNav.add({name:"hosts",text:Blx.text.get("registration.hosts"),route:"config/registration",callback:()=>this.listHosts()});blxapp.topNav.add({name:"auth",text:Blx.text.get("registration.auth"),route:"config/registration/authkeys",callback:()=>{blxapp.breadcrumb.add(Blx.text.get("registration.auth"),"config/registration/authkeys");if(this.regauthId){this.getAuthkey(this.regauthId)}else{this.listAuthkeys()}}});blxapp.topNav.run(action)}listHosts(){blxapp.breadcrumb.add(Blx.text.get("nav.main.registration"),"config/registration");this.table=blxpage.list({title:"Hosts",url:"/config/registration/hosts",uid:row=>{return row.host_id},visible:{enabled:true,columns:["host_id","hostname","ipaddr1","project_class","location_class","templates_by_tags","templates","contactgroups","location_groups","groups"]},selectable:{enabled:true,columns:["hostname"],deletable:{route:"/config/registration/hosts/:host_id/delete"}},footerButtons:[{text:Blx.text.get("regauth.text.add_hosts"),callback:table=>this.activateHostsForm(table)}],columns:[{name:"host_id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),searchable:{type:"string"},sortable:true,responsive:true,callback:row=>this.formUpdateHost(row)},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true},{name:"ipaddr2",text:Blx.text.get("host.attr.ipaddr2"),searchable:{type:"string"},sortable:true},{name:"ipaddr3",text:Blx.text.get("host.attr.ipaddr3"),searchable:{type:"string"},sortable:true},{name:"ipaddr4",text:Blx.text.get("host.attr.ipaddr4"),searchable:{type:"string"},sortable:true},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"string"},sortable:true},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"string"},sortable:true},{name:"country_code",text:Blx.text.get("host.attr.country_code"),searchable:{type:"string"},sortable:true},{name:"tags",text:Blx.text.get("template.attr.tags"),searchable:{type:"string"},sortable:true,convertList:true},{name:"templates_by_tags",text:Blx.text.get("regauth.text.templates_by_tag"),searchable:{type:"string"},value:row=>{const box=Blx.create("div");$.each(row.templates_by_tags,(i,item)=>{Blx.create("div").text(`${item.name} (${item.tag})`).appendTo(box)});return box}},{name:"templates",text:Blx.text.get("regauth.text.templates"),value:row=>{const box=Blx.create("div");$.each(row.templates,(i,item)=>Blx.create("div").text(item.name).appendTo(box));return box}},{name:"contactgroups",text:Blx.text.get("regauth.text.contactgroups"),value:row=>{const box=Blx.create("div");$.each(row.contactgroups,(i,item)=>Blx.create("div").text(item.name).appendTo(box));return box}},{name:"location_groups",text:Blx.text.get("regauth.text.location_groups"),value:row=>{const box=Blx.create("div");$.each(row.location_groups,(i,item)=>Blx.create("div").text(item.name).appendTo(box));return box}},{name:"groups",text:Blx.text.get("regauth.text.groups"),value:row=>{const box=Blx.create("div");$.each(row.groups,(i,item)=>Blx.create("div").text(item.name).appendTo(box));return box}}]})}formUpdateHost(host){const form=blxpage.overlayForm({title:host.hostname,optionsUrl:`/config/registration/hosts/${host.host_id}/options`,submitUrl:`/config/registration/hosts/${host.host_id}/update`,getElements:form=>this.getFormUpdateHostElements(form),onSuccess:()=>this.table.reload()})}getFormUpdateHostElements(form){form.input({name:"hostname",text:Blx.text.get("host.attr.hostname"),help:Blx.text.get("host.help.hostname"),maxlength:100,required:true});form.input({name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),help:Blx.text.get("host.help.ipaddr"),maxlength:45,required:true});form.input({name:"ipaddr2",text:Blx.text.get("host.attr.ipaddr2"),help:Blx.text.get("host.help.ipaddr"),maxlength:45});form.input({name:"ipaddr3",text:Blx.text.get("host.attr.ipaddr3"),help:Blx.text.get("host.help.ipaddr"),maxlength:45});form.input({name:"ipaddr4",text:Blx.text.get("host.attr.ipaddr4"),help:Blx.text.get("host.help.ipaddr"),maxlength:45});form.textarea({name:"sysinfo",text:Blx.text.get("host.attr.sysinfo"),help:Blx.text.get("host.help.sysinfo"),maxlength:400});form.select({name:"country_code",text:Blx.text.get("host.attr.country_code"),help:Blx.text.get("host.help.country_code")});form.input({name:"location_class",text:Blx.text.get("host.attr.location_class"),help:Blx.text.get("host.help.location_class"),maxlength:100});form.input({name:"project_class",text:Blx.text.get("host.attr.project_class"),help:Blx.text.get("host.help.project_class"),maxlength:100});form.array({name:"tags",text:Blx.text.get("template.attr.tags")});form.dict({name:"variables",text:Blx.text.get("template.attr.variables")})}activateHostsForm(table){Blx.ajax.request({url:"/config/registration/hosts/activate/options",success:result=>{const form=blxpage.overlayForm({title:Blx.text.get("regauth.text.add_additional_groups"),options:result.data,submitCallback:(form,overlay)=>this.activateHosts(table,form,overlay)});addHostGroupElements(form)}})}activateHosts(table,form,overlay){overlay.close();const progressData=[];$.each(table.getSelected(),(i,item)=>{progressData.push({url:`/config/registration/hosts/${item.host_id}/activate`,text:item.hostname,token:true,data:form.data})});Blx.progress({items:progressData,finish:()=>{table.clearSelected();table.reload()}})}listAuthkeys(){this.table=blxpage.list({title:Blx.text.get("regauth.list"),url:"/config/registration/authkeys",headerIcons:[{name:"plus",title:Blx.text.get("regauth.create"),callback:()=>this.createAuthkey()}],visible:{enabled:true,columns:["name","description"]},pager:{enabled:false},selectable:{enabled:true,columns:["name"],deletable:{route:"/config/registration/authkeys/:id/delete"}},columns:[{name:"id",text:Blx.text.get("word.ID")},{name:"name",text:Blx.text.get("word.Name"),responsive:true,route:"config/registration/authkeys/:id"},{name:"description",text:Blx.text.get("word.Description")},{name:"tags",text:Blx.text.get("regauth.attr.tags"),help:Blx.text.get("regauth.help.tags"),maxlength:1024,convertList:true},{name:"allowed_tags",text:Blx.text.get("regauth.attr.allowed_tags"),help:Blx.text.get("regauth.help.allowed_tags"),maxlength:1024,convertList:true},{tag:"textarea",name:"authkey",text:Blx.text.get("regauth.attr.authkey"),minlength:64,maxlength:500,genpwd:64,required:true,autocomplete:"off"}]})}createAuthkey(){blxpage.overlayForm({submitUrl:"/config/registration/authkeys/create",optionsUrl:"/config/registration/authkeys/options",onSuccess:data=>Blx.route.to(`config/registration/authkeys/${data.id}`),elements:this.getFormElements()})}getAuthkey(id){Blx.ajax.request({url:`/config/registration/authkeys/${id}`,success:result=>this.editAuthkey(result.data)})}editAuthkey(item){const grid=Blx.simpleGrid({replaceTo:blxapp.body});this.leftContainer=grid.add();this.rightContainer=grid.add();blxapp.breadcrumb.add(item.name,`config/registration/authkeys/${item.id}`);blxpage.form({grow:false,appendTo:this.leftContainer,submitUrl:`/config/registration/authkeys/${item.id}/update`,optionsUrl:`/config/registration/authkeys/${item.id}/options`,elements:this.getFormElements()});Blx.group({grow:false,progressName:"name",appendTo:Blx.create("div").css("margin-bottom","15px").appendTo(this.rightContainer),member:{title:Blx.text.get("regauth.text.contactgroups"),url:`/config/registration/authkeys/${this.regauthId}/contactgroups/member`},noMember:{title:Blx.text.get("regauth.text.contactgroups"),url:`/config/registration/authkeys/${this.regauthId}/contactgroups/no-member`},addMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/contactgroups/${row.id}/add`}},removeMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/contactgroups/${row.id}/remove`}},button:{add:Blx.text.get("regauth.text.contactgroups_add_selected"),remove:Blx.text.get("regauth.text.contactgroups_remove_selected")},columns:[{name:"name",text:Blx.text.get("word.Name"),searchable:{type:"string"},responsive:true}]});Blx.group({grow:false,progressName:"name",appendTo:Blx.create("div").css("margin-bottom","15px").appendTo(this.rightContainer),member:{title:Blx.text.get("regauth.text.groups"),url:`/config/registration/authkeys/${this.regauthId}/groups/member`},noMember:{title:Blx.text.get("regauth.text.groups"),url:`/config/registration/authkeys/${this.regauthId}/groups/no-member`},addMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/groups/${row.id}/add`}},removeMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/groups/${row.id}/remove`}},button:{add:Blx.text.get("regauth.text.groups_add_selected"),remove:Blx.text.get("regauth.text.groups_remove_selected")},columns:[{name:"name",text:Blx.text.get("word.Name"),searchable:{type:"string"},responsive:true}]});Blx.group({grow:false,progressName:"name",appendTo:Blx.create("div").css("margin-bottom","15px").appendTo(this.rightContainer),member:{title:Blx.text.get("regauth.text.location_groups"),url:`/config/registration/authkeys/${this.regauthId}/location-groups/member`},noMember:{title:Blx.text.get("regauth.text.location_groups"),url:`/config/registration/authkeys/${this.regauthId}/location-groups/no-member`},addMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/location-groups/${row.id}/add`}},removeMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/location-groups/${row.id}/remove`}},button:{add:Blx.text.get("regauth.text.location_groups_add_selected"),remove:Blx.text.get("regauth.text.location_groups_remove_selected")},columns:[{name:"name",text:Blx.text.get("word.Name"),searchable:{type:"string"},responsive:true}]});Blx.group({grow:false,progressName:"name",appendTo:Blx.create("div").css("margin-bottom","15px").appendTo(this.rightContainer),member:{title:Blx.text.get("regauth.text.templates"),url:`/config/registration/authkeys/${this.regauthId}/templates/member`},noMember:{title:Blx.text.get("regauth.text.templates"),url:`/config/registration/authkeys/${this.regauthId}/templates/no-member`},addMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/templates/${row.id}/add`}},removeMember:{url:row=>{return`/config/registration/authkeys/${this.regauthId}/templates/${row.id}/remove`}},button:{add:Blx.text.get("regauth.text.templates_add_selected"),remove:Blx.text.get("regauth.text.templates_remove_selected")},columns:[{name:"name",text:Blx.text.get("word.Name"),searchable:{type:"string"},responsive:true}]})}getFormElements(){return[{tag:"input",name:"name",text:Blx.text.get("word.Name"),maxlength:100,required:true},{tag:"input",name:"description",text:Blx.text.get("word.Description"),maxlength:100},{tag:"array",name:"tags",text:Blx.text.get("regauth.attr.tags"),help:Blx.text.get("regauth.help.tags")},{tag:"array",name:"allowed_tags",text:Blx.text.get("regauth.attr.allowed_tags"),help:Blx.text.get("regauth.help.allowed_tags")},{tag:"textarea",name:"authkey",text:Blx.text.get("regauth.attr.authkey"),minlength:64,maxlength:1024,required:true,genpwd:64}]}}class ConfigService{constructor(args){this.schema=args.schema;this.objId=args.objId;this.serviceId=args.serviceId;this.icon=Blx.icon().size("tiny")}create(){const icon=Blx.icon().size("default").coloring(blxapp.iconColor1);Blx.ajax.request({url:"/config/plugins",success:result=>{const overlay=Blx.overlay({title:Blx.text.get("service.select_plugin")}).create();const table=Blx.create("table").addClass("bloonix-select-table").appendTo(overlay.body);$.each(result.data,(i,plugin)=>{const tr=Blx.create("tr").appendTo(table).click(()=>{overlay.close();this.createService(plugin.command)});let pluginIcon;if(plugin.category.match(/Webserver/)){pluginIcon="globe"}else if(plugin.category.match(/Database/)){pluginIcon="database"}else if(plugin.category.match(/CMS/)){pluginIcon="boxes"}else if(plugin.category.match(/Mail/)){pluginIcon="mail"}else if(plugin.category.match(/Network/)){pluginIcon="network"}else if(plugin.category.match(/Caching/)){pluginIcon="atom"}else if(plugin.category.match(/Temperature/)){pluginIcon="thermometer"}else{pluginIcon="cpu"}Blx.create("td").html(icon.span(pluginIcon)).appendTo(tr);Blx.create("td").text(plugin.service).appendTo(tr);const td=Blx.create("td").appendTo(tr);Blx.create("div").text(plugin.description).appendTo(td);Blx.create("div").text(`Command: ${plugin.command}`).appendTo(td)})}})}createService(command){this.createOrEdit(`/config/${this.schema}/${this.objId}/services/options/${command}`,`/config/${this.schema}/${this.objId}/services/create/${command}`)}edit(){this.createOrEdit(`/config/${this.schema}/${this.objId}/services/${this.serviceId}/options`,`/config/${this.schema}/${this.objId}/services/${this.serviceId}/update`)}clone(hostId,serviceId,command){this.createOrEdit(`/config/${this.schema}/${hostId}/services/${serviceId}/options`,`/config/${this.schema}/${this.objId}/services/create/${command}`)}createOrEdit(optionsUrl,submitUrl){Blx.ajax.request({url:optionsUrl,success:result=>{this.options=result.data.options;this.values=result.data.values;this.plugin=result.data.plugin;this.variables=result.data.variables;this.form=blxpage.overlayForm({title:`Check: ${this.plugin.service}`,subtitle:`Command: ${this.plugin.command}`,titleIcon:"atom",submitUrl:submitUrl,options:this.options,values:this.values,splice:true,onSuccess:()=>{if(this.schema=="templates"){Blx.route.to(`config/${this.schema}/${this.objId}/services`)}else{Blx.route.to(`${this.schema}/${this.objId}/services`)}},processDataCallback:data=>{if(this.plugin.command=="check-wtrm"){data.command_options.workflow=this.wtrm.getWorkflowData()}}});this.addFormElements()}})}secondsToReadableString(value){if(value===0){return Blx.text.get("service.inherited_from_host")}return Blx.utils.secondsToStringReadable(value)}addFormElements(){this.form.input({name:"service_name",text:Blx.text.get("service.attr.service_name"),help:Blx.text.get("service.help.service_name"),maxlength:100,required:true});this.form.input({name:"description",text:Blx.text.get("word.Description"),maxlength:100});if(this.plugin.network_service>0){this.createSatelliteContainer()}if(this.schema=="hosts"){this.form.checkOnOff({name:"enabled",text:Blx.text.get("service.attr.enabled"),help:Blx.text.get("service.help.enabled")});this.form.checkOnOff({name:"acknowledged",text:Blx.text.get("service.attr.acknowledged"),help:Blx.text.get("service.help.acknowledged")});this.form.checkOnOff({name:"notification_enabled",text:Blx.text.get("service.attr.notification_enabled"),help:Blx.text.get("service.help.notification_enabled")});this.form.textarea({name:"comment",text:Blx.text.get("word.Comment")})}this.form.checkOnOff({name:"host_alive_check",text:Blx.text.get("service.attr.host_alive_check"),help:Blx.text.get("service.help.host_alive_check")});this.form.slider({name:"interval",text:Blx.text.get("service.attr.interval"),help:Blx.text.get("service.help.interval"),label:this.secondsToReadableString});this.form.slider({name:"retry_interval",text:Blx.text.get("service.attr.retry_interval"),help:Blx.text.get("service.help.retry_interval"),label:this.secondsToReadableString});this.form.slider({name:"attempt_max",text:Blx.text.get("service.attr.attempt_max"),help:Blx.text.get("service.help.attempt_max")});this.form.slider({name:"notification_interval",text:Blx.text.get("service.attr.notification_interval"),help:Blx.text.get("service.help.notification_interval"),label:this.secondsToReadableString});this.form.checkOnOff({name:"fd_enabled",text:Blx.text.get("service.attr.fd_enabled"),help:Blx.text.get("service.help.fd_enabled")});this.form.slider({name:"fd_time_range",text:Blx.text.get("service.attr.fd_time_range"),help:Blx.text.get("service.help.fd_time_range"),label:this.secondsToReadableString});this.form.slider({name:"fd_flap_count",text:Blx.text.get("service.attr.fd_flap_count"),help:Blx.text.get("service.help.fd_flap_count")});if(Blx.utils.size(this.variables)>0){const variablesBox=this.form.createEmptyRow().addClass("bloonix-info-container");Blx.create("h1").text(Blx.text.get("service.available_variables")).appendTo(variablesBox);Blx.simpleTable({appendTo:variablesBox,rows:this.variables})}$.each(this.plugin.options_order,(i,opt)=>{const options=this.plugin.options[opt],metrics=this.plugin.metrics,strings=this.plugin.strings,metricOrder={},stringOrder={},metricOptions=[],stringOptions=[];$.each(metrics,(key,item)=>{metricOrder[item.name]=key});$.each(Blx.utils.sort(metricOrder),(i,name)=>{metricOptions.push({label:name,value:metricOrder[name]})});$.each(strings,(key,item)=>{stringOrder[item.name]=key});$.each(Blx.utils.sort(stringOrder),(i,name)=>{stringOptions.push({label:name,value:stringOrder[name]})});if(options.datatype=="wtrm"){this.wtrm=new WTRM(this.form);this.wtrm.create(this.values["command_options:workflow"])}else if(options.datatype=="metric_condition"){console.log(options);this.form.paramOpValue({name:`command_options:${opt}`,text:options.name,help:options.description,opType:"number",options:metricOptions})}else if(options.datatype=="string_condition"){this.form.paramOpValue({name:`command_options:${opt}`,text:options.name,help:options.description,opType:"string",options:stringOptions})}else if(options.datatype=="json_condition"){this.form.paramOpValue({name:`command_options:${opt}`,text:options.name,help:options.description,opType:"any",options:undefined})}else if(options.datatype=="bool"){this.form.checkOnOff({name:`command_options:${opt}`,text:options.name,help:options.description,ignoreIfEmpty:true})}else if(options.datatype=="json-kv"){this.form.dict({name:`command_options:${opt}`,text:options.name,help:options.description,ignoreIfEmpty:true})}else if(options.multiple===true){this.form.array({name:`command_options:${opt}`,text:options.name,help:options.description,multiple:options.multiple,textarea:options.datatype=="lstr"||options.datatype=="json-raw"})}else if(options.datatype=="lstr"||options.datatype=="json-raw"){this.form.textarea({name:`command_options:${opt}`,text:options.name,help:options.description,ignoreIfEmpty:true})}else{this.form.input({name:`command_options:${opt}`,text:options.name,help:options.description,placeholder:options.example,ignoreIfEmpty:true})}})}createSatelliteContainer(){this.satelliteOuterContainer=Blx.create("div").addClass("bloonix-info-container").hide();this.satelliteInnerContainer=Blx.create("div").appendTo(this.satelliteOuterContainer);this.form.checkOnOff({name:"remote_check",text:Blx.text.get("service.attr.remote_check"),help:Blx.text.get("service.help.remote_check"),onChange:value=>{if(this.plugin.network_service==1&&value===1){this.satelliteOuterContainer.show();this.createSatelliteForm()}else{this.satelliteOuterContainer.hide();this.satelliteInnerContainer.html("")}}});this.form.createEmptyRow().html(this.satelliteOuterContainer)}createSatelliteForm(){this.satelliteInnerContainer.html("");Blx.ajax.request({url:"/config/satellites",success:result=>{this.satellites=result.data;this.satelliteTypeContainer=Blx.create("div").addClass("bloonix-satellite-type-container").css("margin-top","20px");this.form.radioBtn({appendTo:this.satelliteInnerContainer,text:Blx.text.get("service.select_location_check_type"),name:"satellite_type",options:[{label:Blx.text.get("service.default_check_type_title"),value:0},{label:Blx.text.get("service.rotate_check_type_title"),value:1}],parseInt:true,onChange:value=>this.createSatelliteTypeForm(value),value:this.values.satellite_type||0});this.satelliteTypeContainer.appendTo(this.satelliteInnerContainer);this.createSatelliteTypeForm(this.values.satellite_type||0)}})}createSatelliteTypeForm(type){this.satelliteTypeContainer.html("");if(type==0){this.createDefaultSatelliteForm()}else if(type==1){this.createRotateSatelliteForm()}}createDefaultSatelliteForm(){Blx.create("div").addClass("bloonix-form-row").html(Blx.text.get("service.default_check_type")).appendTo(this.satelliteTypeContainer)}createSatelliteSelectOptions(){const options=[];$.each(this.satellites,(i,item)=>{options.push({label:Blx.create("span").addClass("bloonix-flag-svg-line").append(Blx.svgFlag.medium(item.country)).append(`${item.name} - ${item.hostname}`),value:item.id})});return options}createRotateSatelliteForm(){Blx.create("div").addClass("bloonix-form-row").html(Blx.text.get("service.rotate_check_type")).appendTo(this.satelliteTypeContainer);this.createSatelliteTableForm()}createSatelliteTableForm(){this.form.table({name:"satellites",appendTo:this.satelliteTypeContainer,table:{title:Blx.text.get("satellite.list"),data:this.satellites,columns:[{name:"country",text:Blx.text.get("word.Country"),responsive:true,convertCountryFlag:true},{name:"name",text:Blx.text.get("word.Name"),responsive:true},{name:"hostname",text:Blx.text.get("satellite.attr.hostname"),responsive:true}]}})}}function setServiceDowntime(target,table){new DowntimeForm({title:Blx.text.get("service.action.downtime.title"),urlBaseSubmit:"/config/hosts/downtimes/validate",urlBaseOptions:"/config/hosts/downtimes/options",onSuccess:(downtimeForm,resultData,form)=>{const data=form.getData(),type=downtimeForm.getType(),items=[];$.each(table.getSelectedRows(),(i,row)=>{items.push({url:row.service_name?`/config/hosts/${row.host_id}/downtimes/services/add/${type}`:`/config/hosts/${row.id}/downtimes/add/${type}`,token:true,data:row.service_name?Object.assign({service_ids:[row.id]},data):data})});Blx.progress({items:items,finish:()=>table.reload()})}}).create()}function setServiceAcknowledgement(target,table){runServiceAction({target:target,table:table,title:Blx.text.get("service.action.acknowledge.title"),buttons:[{action:"acknowledge",text:Blx.text.get("service.action.acknowledge")},{action:"clear-acknowledgement",text:Blx.text.get("action.clear_acknowledgement")}]})}function setServiceNotification(target,table){runServiceAction({target:target,table:table,title:Blx.text.get("service.action.notification.title"),buttons:[{action:"enable-notifications",text:Blx.text.get("service.action.notifications.enable")},{action:"disable-notifications",text:Blx.text.get("service.action.notifications.disable")}]})}function setServiceEnOrDisable(target,table){runServiceAction({target:target,table:table,title:Blx.text.get("service.action.en_dis_able.title"),buttons:[{action:"enable",text:Blx.text.get("action.enable")},{action:"disable",text:Blx.text.get("action.disable")}]})}function setServiceForceNextCheck(target,table){runServiceAction({target:target,table:table,title:Blx.text.get("service.action.forcecheck.title"),buttons:[{action:"force-check",text:Blx.text.get("service.action.forcecheck")}]})}function runServiceAction(o){const overlay=createOverlayForServiceSetting(o.target,o.title);overlay.body.css("text-align","center");$.each(o.buttons,(i,item)=>{Blx.button().text(item.text).appendTo(overlay.body).click(()=>{overlay.close();processServiceAction(item.action,o.target,o.table)})})}function processServiceAction(action,target,table){const items=[];$.each(table.getSelectedIds(),(i,id)=>{items.push({url:`/config/${target}/${id}/action/${action}`,token:true})});Blx.progress({items:items,finish:()=>table.reload()})}function createOverlayForServiceSetting(target,title){const overlay=Blx.overlay({title:title,position:"middle"}).create();const body=Blx.create("div").text(Blx.text.get(`service.action.${target}.title`)).css("padding","8px 0").appendTo(overlay.body);return overlay}Blx.route.add("config/satellites",args=>new ConfigSatellites(args).list());class ConfigSatellites{constructor(args){this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.satellites"),"config/satellites")}list(){this.table=blxpage.list({title:Blx.text.get("satellite.list"),titleIcon:"globe",url:"/config/satellites",headerIcons:[{name:"plus",text:Blx.text.get("satellite.create"),callback:()=>this.create()}],selectable:{enabled:true,columns:["name","hostname","country"],deletable:{route:"/config/satellites/:id/delete"}},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"name",text:Blx.text.get("word.Name"),searchable:{type:"string"},sortable:true},{name:"hostname",text:Blx.text.get("satellite.attr.hostname"),callback:row=>this.edit(row),searchable:{type:"string"},sortable:true,responsive:true},{name:"port",text:Blx.text.get("word.Network_port"),searchable:{type:"int"},sortable:true},{name:"country",text:Blx.text.get("word.Country"),searchable:{type:"string"},sortable:true,convertCountryFlag:true}]})}create(){blxpage.overlayForm({tableObject:this.table,title:Blx.text.get("satellite.create"),titleIcon:"globe",optionsUrl:"/config/satellites/options",submitUrl:"/config/satellites/create",elements:this.form()})}edit(data){blxpage.overlayForm({tableObject:this.table,title:data.hostname,titleIcon:"globe",submitUrl:"/config/satellites/"+data.id+"/update",optionsUrl:"/config/satellites/"+data.id+"/options",elements:this.form()})}form(){return[{tag:"input",name:"name",text:Blx.text.get("word.Name"),maxlength:100,required:true},{tag:"input",name:"description",text:Blx.text.get("word.Description"),maxlength:100},{tag:"input",name:"hostname",text:Blx.text.get("satellite.attr.hostname"),maxlength:50,required:true},{tag:"input",name:"port",text:Blx.text.get("satellite.attr.port"),maxlength:5,required:true},{tag:"select",name:"country",text:Blx.text.get("satellite.attr.country"),required:true},{tag:"textarea",name:"authkey",text:Blx.text.get("satellite.attr.authkey"),minlength:64,maxlength:500,genpwd:64,required:true,autocomplete:"off"}]}}Blx.route.add("config/sys-options",args=>new ConfigSysOptions(args).list());class ConfigSysOptions{constructor(args){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.sys_options"),"config/sys-options")}list(){const contentBox=Blx.contentBox({grow:true,title:Blx.text.get("nav.main.sys_options"),titleIcon:"settings-2",replaceTo:blxapp.body});this.icon=Blx.icon().size("small").coloring(blxapp.iconColor1);this.table=Blx.create("table").addClass("bloonix-table-settings").appendTo(contentBox.body);Blx.ajax.request({url:"/config/system/settings",success:result=>{this.data=result.data;this.createRow("has_maintenance");this.createRow("event_history");this.createRow("stat_history");this.createRow("stat_hourly_history");this.createRow("result_history");this.createRow("notification_history");this.createRow("user_tracking_history");this.createRow("server_names");this.createRow("force_email_usernames");this.createRow("min_password_length");this.createRow("max_password_length");this.createRow("password_policy");this.createRow("password_policy_letter");this.createRow("password_policy_lowercase");this.createRow("password_policy_uppercase");this.createRow("password_policy_number");this.createRow("password_policy_special")}})}createRow(key){const tr=Blx.create("tr").appendTo(this.table).click(()=>this.edit(key,td));const th=Blx.create("th").text(Blx.text.get("sys_options.attr."+key)).appendTo(tr);const td=Blx.create("td").addClass("blx-preformatted").appendTo(tr);if(key==="password_policy"){td.text(this.getPasswordPolicy(this.data.password_policy))}else if(key==="has_maintenance"){td.text(Blx.text.get(`bool.enabled.${this.data.has_maintenance}`))}else if(key==="force_email_usernames"){td.text(Blx.text.get(`bool.yesno.${this.data.force_email_usernames}`))}else if(key==="event_history"||key==="stat_history"||key==="result_history"){td.text(this.data[key]+" "+Blx.text.get("word.days"))}else if(key==="stat_hourly_history"){td.text(this.data[key]+" "+Blx.text.get("word.months"))}else if(key==="notification_history"||key==="user_tracking_history"){td.text(this.data[key]+" "+Blx.text.get("word.days"))}else{td.text(this.data[key])}Blx.create("td").html(this.icon.span("pencil")).appendTo(tr)}edit(key,td){const elements=this.form();blxpage.overlayForm({submitUrl:"/config/system/settings/update",title:Blx.text.get("sys_options.attr."+key),titleIcon:"settings-2",showMandatoryFieldsInfo:false,options:{password_policy:{options:[{label:Blx.text.get("sys_options.label.letter"),value:"letter"},{label:Blx.text.get("sys_options.label.lowercase"),value:"lowercase"},{label:Blx.text.get("sys_options.label.uppercase"),value:"uppercase"},{label:Blx.text.get("sys_options.label.number"),value:"number"},{label:Blx.text.get("sys_options.label.special"),value:"special"}]},force_email_usernames:{options:[0,1]}},elements:[elements[key]],onSuccess:data=>{this.data[key]=data[key];if(key=="password_policy"){td.text(this.getPasswordPolicy(data[key]))}else if(key=="force_email_usernames"){td.text(Blx.text.get(`bool.yesno.${data[key]}`))}else if(key==="has_maintenance"){td.text(Blx.text.get(`bool.enabled.${data[key]}`))}else{td.text(data[key])}}})}form(key){return{has_maintenance:{tag:"checkYesNo",name:"has_maintenance",text:Blx.text.get("sys_options.attr.has_maintenance"),help:Blx.text.get("sys_options.help.has_maintenance"),value:this.data.has_maintenance},event_history:{tag:"input",name:"event_history",text:Blx.text.get("sys_options.attr.event_history"),help:Blx.text.get("sys_options.help.value_in_days"),value:this.data.event_history},stat_history:{tag:"input",name:"stat_history",text:Blx.text.get("sys_options.attr.stat_history"),help:Blx.text.get("sys_options.help.value_in_days"),value:this.data.stat_history},stat_hourly_history:{tag:"input",name:"stat_hourly_history",text:Blx.text.get("sys_options.attr.stat_hourly_history"),help:Blx.text.get("sys_options.help.value_in_months"),value:this.data.stat_hourly_history},result_history:{tag:"input",name:"result_history",text:Blx.text.get("sys_options.attr.result_history"),help:Blx.text.get("sys_options.help.value_in_days"),value:this.data.result_history},notification_history:{tag:"input",name:"notification_history",text:Blx.text.get("sys_options.attr.notification_history"),help:Blx.text.get("sys_options.help.value_in_days"),value:this.data.notification_history},user_tracking_history:{tag:"input",name:"user_tracking_history",text:Blx.text.get("sys_options.attr.user_tracking_history"),help:Blx.text.get("sys_options.help.value_in_days"),value:this.data.user_tracking_history},server_names:{tag:"input",name:"server_names",text:Blx.text.get("sys_options.attr.server_names"),help:Blx.text.get("sys_options.help.server_names"),value:this.data.server_names},force_email_usernames:{tag:"checkOnOff",name:"force_email_usernames",text:Blx.text.get("sys_options.attr.force_email_usernames"),value:this.data.force_email_usernames},min_password_length:{tag:"input",name:"min_password_length",text:Blx.text.get("sys_options.attr.min_password_length"),value:this.data.min_password_length},max_password_length:{tag:"input",name:"max_password_length",text:Blx.text.get("sys_options.attr.max_password_length"),value:this.data.max_password_length},password_policy:{tag:"checkboxBtn",name:"password_policy",text:Blx.text.get("sys_options.attr.password_policy"),help:Blx.text.get("sys_options.help.password_policy"),value:this.data.password_policy},password_policy_letter:{tag:"input",name:"password_policy_letter",help:Blx.text.get("sys_options.help.password_policy_regex"),value:this.data.password_policy_letter},password_policy_lowercase:{tag:"input",name:"password_policy_lowercase",text:Blx.text.get("sys_options.attr.password_policy_lowercase"),help:Blx.text.get("sys_options.help.password_policy_regex"),value:this.data.password_policy_lowercase},password_policy_uppercase:{tag:"input",name:"password_policy_uppercase",text:Blx.text.get("sys_options.attr.password_policy_uppercase"),help:Blx.text.get("sys_options.help.password_policy_regex"),value:this.data.password_policy_uppercase},password_policy_number:{tag:"input",name:"password_policy_number",text:Blx.text.get("sys_options.attr.password_policy_number"),help:Blx.text.get("sys_options.help.password_policy_regex"),value:this.data.password_policy_number},password_policy_special:{tag:"input",name:"password_policy_special",text:Blx.text.get("sys_options.attr.password_policy_special"),help:Blx.text.get("sys_options.help.password_policy_regex_special"),value:this.data.password_policy_special,mono:true}}}getPasswordPolicy(arr){const password_policy=[];$.each(arr,(i,key)=>{password_policy.push(Blx.text.get("sys_options.label."+key))});return password_policy.join(", ")}}Blx.route.add("config/location-groups",args=>new ConfigLocationGroups(args).list());Blx.route.add("config/location-groups/:id",args=>new ConfigLocationGroups(args).edit());Blx.route.add("config/location-groups/:id/:action",args=>new ConfigLocationGroups(args).edit());Blx.route.add("config/location-groups/create",args=>new ConfigLocationGroups(args).create());class ConfigLocationGroups{constructor(args){this.locationGroupId=args.id;this.action=args.action;this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.location_groups"),"config/location-groups")}list(){this.table=blxpage.list({title:Blx.text.get("location_group.title"),titleIcon:"square-asterisk",url:"/config/location-groups",headerIcons:[{name:"plus",text:Blx.text.get("location_group.create"),callback:()=>this.create()}],selectable:{enabled:true,columns:["id","name"],deletable:{route:"/config/location-groups/:id/delete"}},columns:[{name:"id",text:Blx.text.get("word.ID")},{name:"name",text:Blx.text.get("location_group.attr.name"),route:"config/location-groups/:id"},{name:"description",text:Blx.text.get("word.Description")}]})}create(){blxpage.overlayForm({tableObject:this.table,title:Blx.text.get("location_group.create"),titleIcon:"square-asterisk",submitUrl:"/config/location-groups/create",elements:this.form(Blx.utils.genRandStr(64)),onSuccess:data=>{Blx.route.to("config/location-groups/"+data.id)}})}edit(){Blx.ajax.request({url:"/config/location-groups/"+this.locationGroupId,success:result=>{blxapp.breadcrumb.add(result.data.name,"/config/location-groups/"+this.locationGroupId);blxapp.topNav.add({name:"",text:Blx.text.get("text.meta_data"),route:"config/location-groups/"+this.locationGroupId,callback:()=>this.editMetaData()});blxapp.topNav.add({name:"hosts",text:Blx.text.get("group.text.hosts"),route:"config/location-groups/"+this.locationGroupId+"/hosts",callback:()=>this.editHosts()});blxapp.topNav.run(this.action)}})}editMetaData(){Blx.ajax.request({url:"/config/location-groups/"+this.locationGroupId+"/options",success:result=>{blxpage.form({title:result.data.values.name+`, ID: ${this.locationGroupId}`,titleIcon:"square-asterisk",submitUrl:"/config/location-groups/"+this.locationGroupId+"/update",options:result.data.options,values:result.data.values,elements:this.form()})}})}editHosts(){const contentBox=Blx.contentBox({grow:true,replaceTo:blxapp.body});Blx.group({progressName:"hostname",appendTo:contentBox.body,member:{title:Blx.text.get("group.text.host_member"),url:"/config/location-groups/"+this.locationGroupId+"/hosts/member"},noMember:{title:Blx.text.get("group.text.host_no_member"),url:"/config/location-groups/"+this.locationGroupId+"/hosts/no-member"},addMember:{url:row=>{return"/config/location-groups/"+this.locationGroupId+"/hosts/"+row.id+"/add"}},removeMember:{url:row=>{return"/config/location-groups/"+this.locationGroupId+"/hosts/"+row.id+"/remove"}},button:{add:Blx.text.get("group.text.host_add_selected"),remove:Blx.text.get("group.text.host_remove_selected")},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),searchable:{type:"string"},sortable:true,responsive:true},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true,responsive:true},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"autocomplete",url:"/hosts/directory/project"},sortable:true},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"autocomplete",url:"/hosts/directory/location"},sortable:true}]})}form(password){return[{tag:"input",name:"name",text:Blx.text.get("location_group.attr.name"),maxlength:100,required:true},{tag:"input",name:"description",text:Blx.text.get("word.Description"),maxlength:100,required:false},{tag:"input",name:"password",text:Blx.text.get("word.Password"),minlength:30,maxlength:128,password:true,required:true,genpwd:64,value:password},{tag:"array",name:"allow_from",text:Blx.text.get("host.attr.allow_from"),help:Blx.text.get("host.help.allow_from")}]}}Blx.route.add("config/templates",args=>new ConfigTemplates(args).list());Blx.route.add("config/templates/:id",args=>new ConfigTemplates(args).edit());Blx.route.add("config/templates/:id/:action",args=>new ConfigTemplates(args).edit());Blx.route.add("config/templates/create",args=>new ConfigTemplates(args).create());class ConfigTemplates{constructor(args){this.templateId=args.id;this.action=args.action;this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.templates"),"config/templates")}list(){blxpage.list({title:Blx.text.get("template.list"),titleIcon:"layers",url:"/config/templates",headerIcons:[{name:"plus",text:Blx.text.get("template.create"),callback:()=>this.create()}],selectable:{enabled:true,columns:["name"],deletable:{route:"/config/templates/:id/delete"}},columns:[{name:"name",text:Blx.text.get("template.attr.name"),route:"config/templates/:id",searchable:{type:"string"},sortable:true,responsive:true},{name:"tags",text:Blx.text.get("template.attr.tags"),searchable:{type:"string"},sortable:true,convertList:true}]})}create(){blxpage.overlayForm({title:Blx.text.get("template.create"),titleIcon:"layers",optionsUrl:"/config/templates/options",submitUrl:"/config/templates/create",elements:this.form(),onSuccess:data=>{Blx.route.to(`config/templates/${data.id}`)}})}edit(){Blx.ajax.request({url:`/config/templates/${this.templateId}`,success:result=>{blxapp.breadcrumb.add(result.data.name,`/config/templates/${this.templateId}`);blxapp.topNav.add({name:"",text:Blx.text.get("text.meta_data"),route:`config/templates/${this.templateId}`,callback:()=>this.editMetaData(this.templateId)});blxapp.topNav.add({name:"services",text:Blx.text.get("template.services"),route:`config/templates/${this.templateId}/services`,callback:()=>this.listServices()});blxapp.topNav.add({name:"hosts",text:Blx.text.get("template.hosts"),route:`config/templates/${this.templateId}/hosts`,callback:()=>this.editHosts(this.templateId)});blxapp.topNav.run(this.action)}})}editMetaData(){Blx.ajax.request({url:`/config/templates/${this.templateId}/options`,success:result=>{blxpage.form({title:result.data.values.name,titleIcon:"layers",options:result.data.options,values:result.data.values,submitUrl:`/config/templates/${this.templateId}/update`,elements:this.form()})}})}editHosts(){const contentBox=Blx.contentBox({grow:true,replaceTo:blxapp.body});Blx.group({progressName:"hostname",appendTo:contentBox.body,titleIcon:"server",member:{title:Blx.text.get("template.hosts_member"),url:`/config/templates/${this.templateId}/hosts/member`},noMember:{title:Blx.text.get("template.hosts_no_member"),url:`/config/templates/${this.templateId}/hosts/no-member`},addMember:{url:row=>{return`/config/templates/${this.templateId}/hosts/${row.id}/add`}},removeMember:{url:row=>{return`/config/templates/${this.templateId}/hosts/${row.id}/remove`}},button:{add:Blx.text.get("template.add_selected_hosts"),remove:Blx.text.get("template.remove_selected_hosts")},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),searchable:{type:"string"},sortable:true,responsive:true},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true,responsive:true},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"autocomplete",url:"/hosts/directory/project"},sortable:true},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"autocomplete",url:"/hosts/directory/location"},sortable:true}]})}form(){return[{tag:"input",name:"name",text:Blx.text.get("template.attr.name"),maxlength:100,required:true},{tag:"textarea",name:"description",text:Blx.text.get("word.Description"),maxlength:1e3},{tag:"array",name:"tags",text:Blx.text.get("template.attr.tags"),help:Blx.text.get("template.help.tags")},{tag:"dict",name:"variables",text:Blx.text.get("template.attr.variables")}]}listServices(){this.table=blxpage.list({title:Blx.text.get("host.title.services"),titleIcon:"atom",appendTo:this.appendTo,replaceTo:this.replaceTo,url:`/config/templates/${this.templateId}/services`,headerIcons:[{name:"plus",callback:()=>{new ConfigService({schema:"templates",objId:this.templateId}).create()}}],selectable:{enabled:true,columns:["service_name","command"],deletable:{route:`/config/templates/${this.templateId}/services/:id/delete`}},columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"service_name",text:Blx.text.get("service.attr.service_name"),callback:row=>{new ConfigService({schema:"templates",objId:this.templateId,serviceId:row.id}).edit()},sortable:true,searchable:{type:"string"},responsive:true},{name:"command",text:Blx.text.get("service.attr.command"),sortable:true,searchable:{type:"string"}},{name:"remote_check",text:Blx.text.get("service.attr.remote_check"),searchable:{type:"bool"},sortable:true,convertBool:true},{name:"host_alive_check",text:Blx.text.get("service.attr.host_alive_check"),sortable:true,searchable:{type:"bool"},convertBool:true,highlight:true},{name:"interval",text:Blx.text.get("service.attr.interval"),secondsToStringReadable:true,sortable:true,searchable:{type:"int"}},{name:"retry_interval",text:Blx.text.get("service.attr.retry_interval"),secondsToStringReadable:true,sortable:true,searchable:{type:"int"}},{name:"attempt_max",text:Blx.text.get("service.attr.attempt_max"),sortable:true,searchable:{type:"int"}}]})}}Blx.route.add("config/users",args=>new ConfigUsers(args).list());class ConfigUsers{constructor(args){this.init()}init(){blxapp.breadcrumb.clear();blxapp.breadcrumb.add(Blx.text.get("nav.main.users"),"config/users")}list(){this.table=blxpage.list({title:Blx.text.get("user.create"),titleIcon:"user",url:"/config/users",headerIcons:[{name:"plus",text:Blx.text.get("user.create"),callback:()=>this.create()}],selectable:{enabled:true,columns:["username","name"],deletable:{route:"/config/users/:id/delete"}},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"username",text:Blx.text.get("user.attr.username"),callback:row=>this.edit(row),searchable:{type:"string"},sortable:true,responsive:true},{name:"name",text:Blx.text.get("user.attr.name"),searchable:{type:"string"},sortable:true,responsive:false},{name:"phone",text:Blx.text.get("user.attr.phone"),searchable:{type:"string"},responsive:false},{name:"groups",text:Blx.text.get("user.groups"),sortable:false,genRouteFromDataArray:"config/groups/:id/users"},{name:"role",text:Blx.text.get("user.attr.role"),searchable:{type:"string"},sortable:true,responsive:false},{name:"last_login",text:Blx.text.get("user.attr.last_login"),searchable:"time",sortable:true,responsive:false,convertUnixtime:true},{name:"locked",text:Blx.text.get("user.attr.locked"),searchable:{type:"bool"},sortable:true,responsive:false,convertBool:true}]})}create(){blxUserGetPasswordPolicy(help=>this.createOrEdit({tableObject:this.table,title:Blx.text.get("user.create"),titleIcon:"user",submitUrl:"/config/users/create",optionsUrl:"/config/users/options",elements:this.form(false,true,help)}))}edit(data){blxUserGetPasswordPolicy(help=>this.createOrEdit({tableObject:this.table,title:data.username,titleIcon:"user",submitUrl:"/config/users/"+data.id+"/update",optionsUrl:"/config/users/"+data.id+"/options",elements:this.form(true,false,help,data.id)}))}createOrEdit(opts){blxpage.overlayForm(opts)}form(passwordTrue,passwordRequired,passwordOpts,userId){const elements=[];elements.push({tag:"input",name:"username",text:Blx.text.get("user.attr.username"),help:Blx.text.get("user.help.username"),maxlength:50,required:true});elements.push({tag:"input",name:"name",text:Blx.text.get("user.attr.name"),maxlength:50,required:false});elements.push({tag:"input",name:"phone",text:Blx.text.get("user.attr.phone"),maxlength:30,required:false});if(userId!=1){elements.push({tag:"checkYesNo",name:"locked",text:Blx.text.get("user.attr.locked"),help:Blx.text.get("user.help.locked")});elements.push({tag:"select",name:"role",text:Blx.text.get("user.attr.role"),help:Blx.text.get("user.help.role"),required:true})}elements.push({tag:"checkYesNo",name:"filter_by_group",text:Blx.text.get("user.attr.filter_by_group"),help:Blx.text.get("user.help.filter_by_group"),required:false});elements.push({tag:"textarea",name:"comment",text:Blx.text.get("word.Comment"),maxlength:500,required:false});elements.push({tag:"select",name:"timezone",text:Blx.text.get("word.Timezone"),required:true});elements.push({tag:"input",name:"password",text:Blx.text.get("word.Password"),help:passwordOpts.help,minlength:passwordOpts.min_password_length,maxlength:passwordOpts.max_password_length,required:passwordRequired,password:passwordTrue,autocomplete:"off",deleteIfEmpty:true,genpwd:16,genpwdComplex:true});elements.push({tag:"input",name:"2fa_addr",text:Blx.text.get("user.attr.2fa_addr"),help:Blx.text.get("user.help.2fa_addr")});if(userId!=1){elements.push({tag:"checkYesNo",name:"force_password_change",text:Blx.text.get("user.attr.force_password_change"),help:Blx.text.get("user.help.force_password_change")})}return elements}}function blxUserGetPasswordPolicy(callback){Blx.ajax.request({url:"/user/password-options",success:result=>{var help=Blx.create("div");Blx.create("div").css("padding-bottom","15px").text(Blx.text.get("user.password_policy.info")).appendTo(help);$.each(result.data.password_policy,(k,v)=>{Blx.create("div").css("padding-left","15px").text(Blx.text.get("user."+k,[v])).appendTo(help)});callback({help:help,min_password_length:result.data.min_password_length,max_password_length:result.data.max_password_length})}})}class ConfigUser{changeLang(){Blx.setLang({showLang:["en","de"],url:"/user/set-lang/%s"})}changeTimezone(){Blx.ajax.request({url:"/user",success:result=>{const form=blxpage.overlayForm({submitUrl:"/user/set-timezone",options:{timezone:{options:Blx.timezones()}},values:{timezone:result.data.timezone}});form.select({name:"timezone",text:Blx.text.get("word.Timezone")})}})}changeStyle(){const overlay=Blx.overlay({title:Blx.text.get("nav.main.style"),position:"middle"}).create();const body=Blx.create("div").addClass("bloonix-center").appendTo(overlay.body);Blx.button().text(Blx.text.get("colorscheme.default")).appendTo(body).click(()=>this._changeStyle("default"));Blx.button().text(Blx.text.get("colorscheme.dark")).appendTo(body).click(()=>this._changeStyle("dark"))}_changeStyle(style){Blx.ajax.request({url:`/user/set-style/${style}`,token:true,success:result=>location.reload()})}changePassword(force){blxUserGetPasswordPolicy(help=>this.changePasswordCallback(force,help))}changePasswordCallback(force,passwordOpts){const overlayOptions={title:Blx.text.get("user.change_password")};if(force){overlayOptions.position="center";overlayOptions.showCloseButton=false;overlayOptions.body=Blx.create("div").addClass("bloonix-welcome");Blx.create("h1").text(Blx.text.get("user.welcome")).appendTo(overlayOptions.body);const icon=Blx.icon().size("small").coloring("black").span("info");Blx.create("p").html(Blx.text.get("user.change_initial_password",[icon],true)).appendTo(overlayOptions.body)}const overlay=Blx.overlay(overlayOptions);const form=Blx.form({appendTo:overlay.body,submitUrl:"/user/set-password",showSubmitButton:false,messageContainer:overlay.message,onSuccess:()=>{if(force===true){Blx.utils.resetLocation()}else{overlay.close()}}});form.input({name:"current_password",text:Blx.text.get("user.current_password"),type:"password",required:true});form.input({name:"new_password",text:Blx.text.get("user.new_password"),type:"password",required:true,help:passwordOpts.help,minlength:passwordOpts.min_password_length,maxlength:passwordOpts.max_password_length});form.input({name:"repeat_new_password",text:Blx.text.get("user.repeat_new_password"),type:"password",required:true});overlay.addButton({text:Blx.text.get("action.submit"),callback:()=>form.submit()});if(force===true){overlay.addButton({text:Blx.text.get("action.logout"),callback:()=>{window.location="/logout"}})}overlay.create()}twoFactorAuth(){const overlay=Blx.overlay({title:Blx.text.get("user.2fa_title"),titleCentered:true,position:"center",closeText:Blx.text.get("action.abort"),closeCallback:()=>{window.location="/logout"}}).create();const body=Blx.create("div").css("max-width","300px").css("margin","auto").appendTo(overlay.body);const form=Blx.form({appendTo:body,submitUrl:"/two-fa-auth",messageContainer:overlay.message,onSuccess:()=>{window.location="/"}});form.input({name:"2fa_code",text:Blx.text.get("user.2fa_enter"),required:true});form.checkYesNo({name:"2fa_trust_browser",text:Blx.text.get("user.2fa_trust_browser"),help:Blx.text.get("user.2fa_trust_browser_info"),required:true,value:0})}}class WTRM{constructor(form){this.steps={};this.stepInternalId=0;this.form=form;this.icon=Blx.icon().size("small").coloring("dark-gray").cursor("pointer");this.actionsByType=[{type:"Header",actions:["doAuth","doUserAgent","doAddCookie"]},{type:"URL",actions:["doUrl","checkUrl"]},{type:"Event",actions:["doTriggerEvent"]},{type:"DOM",actions:["doWaitForElement","doSleep","doSwitchToFrame","doSwitchToParentFrame","doSwitchToNewPage","doSwitchToMainPage","doClick","checkIfElementExists","checkIfElementNotExists","checkIfElementHasText","checkIfElementMatchText","checkIfElementHasNotText","checkIfElementHasHTML","checkIfElementHasNotHTML"]},{type:"Form",actions:["doFill","doSubmit","doCheck","doUncheck","doSelect","checkIfElementHasValue","checkIfElementHasNotValue","checkIfElementIsChecked","checkIfElementIsNotChecked","checkIfElementIsSelected","checkIfElementIsNotSelected"]},{type:"Download",actions:["checkDownload"]}]}create(workflow){this.container=this.form.createEmptyRow();this.stepCounter=0;this.headerBox=Blx.create("div").appendTo(this.container);this.workflowBox=Blx.create("div").addClass("bloonix-wtrm-workflow").appendTo(this.container).sortable({stop:()=>this.reNumberSteps()});this.workflowDebugBox=Blx.create("div").addClass("bloonix-wtrm-result-debug-container").hide().appendTo(this.container);this.footerBox=Blx.create("div").appendTo(this.container);this.form.createLabel("command_options:workflow").text(Blx.text.get("wtrm.title")).appendTo(this.headerBox);this.loading=Blx.lds({appendTo:this.headerBox,text:Blx.text.get("wtrm.loading"),hide:true});this.actionButtonsTop=Blx.create("div").appendTo(this.headerBox);this.createButton("+ "+Blx.text.get("word.Action")).appendTo(this.actionButtonsTop).click(()=>this.listActions());this.createButton(Blx.text.get("wtrm.check")).appendTo(this.actionButtonsTop).click(()=>this.checkWorkflow());this.createButton(Blx.text.get("wtrm.check_quick")).appendTo(this.actionButtonsTop).click(()=>this.checkWorkflow("quick"));this.actionButtonsBottom=Blx.create("div").appendTo(this.footerBox);this.addStepButton=this.createButton("+ "+Blx.text.get("word.Action")).appendTo(this.actionButtonsBottom).hide().click(()=>this.listActions());if(workflow){$.each(workflow,(i,step)=>this._addStep(step.action,step))}}checkWorkflow(quick){this.loading.show();this.actionButtonsTop.hide();this.actionButtonsBottom.hide();quick||="";this.workflowDebugBox.html("").hide();this.container.find(".bloonix-wtrm-step-result-table").remove();this.container.find(".bloonix-wtrm-step-result-image").remove();Blx.ajax.request({token:true,url:`/config/wtrm/check/${quick}`,data:{workflow:this.getWorkflowData()},error:()=>{this.actionButtonsTop.show();this.actionButtonsBottom.show()},success:result=>{this.loading.hide();this.actionButtonsTop.show();this.actionButtonsBottom.show();showWtrmWorkflowResult(result.data,this.container.find(".bloonix-wtrm-step"),this.workflowDebugBox)}})}listActions(){const overlay=Blx.overlay().create();const table=Blx.create("table").addClass("bloonix-select-table").appendTo(overlay.body);$.each(this.actionsByType,(x,item)=>{$.each(item.actions,(y,action)=>{const tr=Blx.create("tr").appendTo(table);Blx.create("td").text(item.type).appendTo(tr);Blx.create("td").text(Blx.text.get(`wtrm.action.${action}`)).appendTo(tr);tr.click(()=>{overlay.close();this.addStep(action)})})})}processStepData(data){for(let k in data){if(data[k]===null||data[k]===undefined||data[k]==""){delete data[k]}}}addStep(action){const elements=this.getElements(action);if(elements.length===0){this._addStep(action,{})}else{blxpage.overlayForm({title:Blx.text.get(`wtrm.action.${action}`),overlayPosition:"middle",submitUrl:`/config/wtrm/validate/${action}`,optionsUrl:`/config/wtrm/options/${action}`,onSuccess:data=>this._addStep(action,data),elements:elements,processDataCallback:data=>this.processStepData(data)})}}updateStep(step){const action=step.data("action");const intId=step.data("internal-id");const elements=this.getElements(action);Blx.ajax.request({url:`/config/wtrm/options/${action}`,success:result=>{blxpage.overlayForm({title:Blx.text.get(`wtrm.action.${action}`),overlayPosition:"middle",submitUrl:`/config/wtrm/validate/${action}`,options:result.data.options,values:step.data("form-data"),onSuccess:data=>{step.data("form-data",data);this.steps[intId].elText.html(wtrmText[action](data))},elements:elements,processDataCallback:data=>this.processStepData(data)})}})}_addStep(action,data){this.stepCounter+=1;this.stepInternalId+=1;this.steps[this.stepInternalId]={};if(this.stepCounter>=5){this.addStepButton.show()}const step=Blx.create("div").addClass("bloonix-wtrm-step").data("id",this.stepCounter).attr("data-internal-id",this.stepInternalId).data("action",action).data("form-data",data).appendTo(this.workflowBox);this.steps[this.stepInternalId].elStep=step;const icons=Blx.create("div").addClass("bloonix-wtrm-step-icons").appendTo(step);this.icon.span("x").appendTo(icons).click(()=>{const intId=step.data("internal-id");step.remove();this.steps[intId]=undefined;this.reNumberSteps()});this.steps[this.stepInternalId].elNumber=Blx.create("div").addClass("bloonix-wtrm-step-number").text(Blx.text.get("word.Step",this.stepCounter)).appendTo(step);this.steps[this.stepInternalId].elText=Blx.create("div").addClass("bloonix-wtrm-step-text").html(wtrmText[action](data)).appendTo(step);if(data!==false){this.icon.span("settings").appendTo(icons).click(()=>this.updateStep(step))}}reNumberSteps(){this.stepCounter=0;this.container.find(".bloonix-wtrm-step").each((i,el)=>{const step=$(el);const intId=step.data("internal-id");this.stepCounter+=1;this.steps[intId].elNumber.text(Blx.text.get("word.Step",this.stepCounter))});if(this.stepCounter<5){this.addStepButton.hide()}}getWorkflowData(){const data=[];this.container.find(".bloonix-wtrm-step").each((i,el)=>{const formData=$(el).data("form-data");formData.action=$(el).data("action");formData.id=$(el).data("id");data.push(formData);this.processStepData(formData)});return data}getElements(action){const elements=[];if(action==="doAuth"){elements.push(this.el_username({required:true}));elements.push(this.el_password({required:true}))}else if(action==="doUserAgent"){elements.push(this.el_userAgent({required:true}))}else if(action==="doAddCookie"){elements.push(this.el_name({required:true}));elements.push(this.el_value({required:true}));elements.push(this.el_domain({required:true}))}else if(action==="doUrl"){elements.push(this.el_url({required:true}));elements.push(this.el_status({required:true}));elements.push(this.el_contentType())}else if(action==="checkUrl"){elements.push(this.el_url({required:true}));elements.push(this.el_status({required:true}));elements.push(this.el_contentType())}else if(action==="doTriggerEvent"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_event())}else if(action==="doWaitForElement"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_text())}else if(action==="doSleep"){elements.push(this.el_ms({required:true}))}else if(action==="doSwitchToFrame"){elements.push(this.el_name({required:true}))}else if(action==="doSwitchToParentFrame"){}else if(action==="doSwitchToNewPage"){}else if(action==="doSwitchToMainPage"){}else if(action==="checkIfElementExists"){elements.push(this.el_parent());elements.push(this.el_element({required:true}))}else if(action==="checkIfElementNotExists"){elements.push(this.el_parent());elements.push(this.el_element({required:true}))}else if(action==="checkIfElementHasText"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_text({required:true}))}else if(action==="checkIfElementMatchText"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_text({required:true}))}else if(action==="checkIfElementHasNotText"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_text({required:true}))}else if(action==="checkIfElementHasHTML"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_html({required:true}))}else if(action==="checkIfElementHasNotHTML"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_html({required:true}))}else if(action==="doFill"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_value({required:true}));elements.push(this.el_hidden());elements.push(this.el_event())}else if(action==="doClick"){elements.push(this.el_parent());elements.push(this.el_element({required:true}))}else if(action==="doSubmit"){elements.push(this.el_parent());elements.push(this.el_element({required:true}))}else if(action==="doCheck"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_value())}else if(action==="doUncheck"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_value())}else if(action==="doSelect"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_value())}else if(action==="checkIfElementHasValue"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_value({required:true}));elements.push(this.el_hidden())}else if(action==="checkIfElementHasNotValue"){elements.push(this.el_parent());elements.push(this.el_element({required:true}));elements.push(this.el_value({required:true}));elements.push(this.el_hidden())}else if(action==="checkIfElementIsChecked"){elements.push(this.el_parent());elements.push(this.el_element());elements.push(this.el_value())}else if(action==="checkIfElementIsNotChecked"){elements.push(this.el_parent());elements.push(this.el_element());elements.push(this.el_value())}else if(action==="checkIfElementIsSelected"){elements.push(this.el_parent());elements.push(this.el_element());elements.push(this.el_value())}else if(action==="checkIfElementIsNotSelected"){elements.push(this.el_parent());elements.push(this.el_element());elements.push(this.el_value())}else if(action==="checkDownload"){elements.push(this.el_filename())}return elements}el_username(o){o||={required:false};return{tag:"input",name:"username",text:Blx.text.get("word.Username"),required:o.required}}el_password(o){o||={required:false};return{tag:"input",name:"password",text:Blx.text.get("word.Password"),password:true,required:o.required}}el_parent(o){o||={required:false};return{tag:"input",name:"parent",text:Blx.text.get("wtrm.attr.parent"),help:Blx.text.get("wtrm.help.parent"),required:o.required}}el_element(o){o||={required:false};return{tag:"input",name:"element",text:Blx.text.get("wtrm.attr.element"),help:Blx.text.get("wtrm.help.element"),required:o.required}}el_value(o){o||={required:false};return{tag:"input",name:"value",text:Blx.text.get("wtrm.attr.value"),required:o.required}}el_contentType(o){o||={required:false};return{tag:"input",name:"contentType",text:Blx.text.get("wtrm.attr.content_type"),required:o.required}}el_domain(o){o||={required:false};return{tag:"input",name:"domain",text:Blx.text.get("wtrm.attr.domain"),required:o.required}}el_event(o){o||={required:false};return{tag:"radioBtn",name:"event",options:["change","keypress","keyup","keydown","focus","mousedown","mouseup"],text:Blx.text.get("wtrm.attr.event"),required:o.required}}el_hidden(o){o||={required:false};return{tag:"checkYesNo",name:"hidden",text:Blx.text.get("wtrm.attr.hidden"),required:o.required}}el_html(o){o||={required:false};return{tag:"input",name:"html",text:Blx.text.get("wtrm.attr.html"),required:o.required}}el_ms(o){o||={required:false};return{tag:"input",name:"ms",text:Blx.text.get("wtrm.attr.ms"),required:o.required}}el_name(o){o||={required:false};return{tag:"input",name:"name",text:Blx.text.get("wtrm.attr.name"),required:o.required}}el_status(o){o||={required:false};return{tag:"input",name:"status",text:Blx.text.get("wtrm.attr.status"),required:o.required}}el_text(o){o||={required:false};return{tag:"input",name:"text",text:Blx.text.get("wtrm.attr.text"),required:o.required}}el_url(o){o||={required:false};return{tag:"input",name:"url",text:Blx.text.get("wtrm.attr.url"),required:o.required}}el_userAgent(o){o||={required:false};return{tag:"input",name:"userAgent",text:Blx.text.get("wtrm.attr.user_agent"),required:o.required}}el_filename(o){o||={required:false};return{tag:"input",name:"filename",text:Blx.text.get("wtrm.attr.filename"),required:o.required}}createButton(text){return Blx.button({size:"default",color:"dark",text:text})}}function getWtrmElementName(data){if(data.parent){return`${data.parent} -> ${data.element}`}return data.element}const wtrmText={doAuth:data=>{return Blx.text.get("wtrm.step.doAuth",[data.username,"xxxxxxxx"],true)},doUserAgent:data=>{return Blx.text.get("wtrm.step.doUserAgent",[data.userAgent],true)},doUrl:data=>{return Blx.text.get("wtrm.step.doUrl",[data.url],true)},doFill:data=>{const value=data.hidden?"xxxxxxxx":data.value;return Blx.text.get("wtrm.step.doFill",[getWtrmElementName(data),value],true)},doTriggerEvent:data=>{return Blx.text.get("wtrm.step.doTriggerEvent",[data.event,getWtrmElementName(data)],true)},doClick:data=>{return Blx.text.get("wtrm.step.doClick",[getWtrmElementName(data)],true)},doSubmit:data=>{return Blx.text.get("wtrm.step.doSubmit",[getWtrmElementName(data)],true)},doCheck:data=>{return Blx.text.get("wtrm.step.doCheck",[getWtrmElementName(data),data.value],true)},doUncheck:data=>{return Blx.text.get("wtrm.step.doUncheck",[getWtrmElementName(data),data.value],true)},doSelect:data=>{return Blx.text.get("wtrm.step.doSelect",[data.value,getWtrmElementName(data)],true)},doWaitForElement:data=>{return Blx.text.get("wtrm.step.doWaitForElement",[getWtrmElementName(data)],true)},doSleep:data=>{return Blx.text.get("wtrm.step.doSleep",[data.ms],true)},doSwitchToFrame:data=>{return Blx.text.get("wtrm.step.doSwitchToFrame",[data.name],true)},doSwitchToParentFrame:data=>{return Blx.text.get("wtrm.step.doSwitchToParentFrame")},doSwitchToNewPage:data=>{return Blx.text.get("wtrm.step.doSwitchToNewPage")},doSwitchToMainPage:data=>{return Blx.text.get("wtrm.step.doSwitchToMainPage")},doAddCookie:data=>{return Blx.text.get("wtrm.step.doAddCookie",[data.name,data.value,data.domain],true)},checkUrl:data=>{return Blx.text.get("wtrm.step.checkUrl",[data.url],true)},checkUrlWithContentType:data=>{return Blx.text.get("wtrm.step.checkUrlWithContentType",[data.url,data.contentType],true)},checkIfElementExists:data=>{return Blx.text.get("wtrm.step.checkIfElementExists",[getWtrmElementName(data)],true)},checkIfElementNotExists:data=>{return Blx.text.get("wtrm.step.checkIfElementNotExists",[getWtrmElementName(data)],true)},checkIfElementHasText:data=>{return Blx.text.get("wtrm.step.checkIfElementHasText",[getWtrmElementName(data),data.text],true)},checkIfElementHasNotText:data=>{return Blx.text.get("wtrm.step.checkIfElementHasNotText",[getWtrmElementName(data),data.text],true)},checkIfElementMatchText:data=>{return Blx.text.get("wtrm.step.checkIfElementMatchText",[getWtrmElementName(data),data.text],true)},checkIfElementHasHTML:data=>{return Blx.text.get("wtrm.step.checkIfElementHasHTML",[getWtrmElementName(data),data.html],true)},checkIfElementHasNotHTML:data=>{return Blx.text.get("wtrm.step.checkIfElementHasNotHTML",[getWtrmElementName(data),data.html],true)},checkIfElementHasValue:data=>{const value=data.hidden?"xxxxxxxx":data.value;return Blx.text.get("wtrm.step.checkIfElementHasValue",[getWtrmElementName(data),value],true)},checkIfElementHasNotValue:data=>{const value=data.hidden?"xxxxxxxx":data.value;return Blx.text.get("wtrm.step.checkIfElementHasNotValue",[getWtrmElementName(data),value],true)},checkIfElementIsChecked:data=>{return Blx.text.get("wtrm.step.checkIfElementIsChecked",[getWtrmElementName(data)],true)},checkIfElementIsNotChecked:data=>{return Blx.text.get("wtrm.step.checkIfElementIsNotChecked",[getWtrmElementName(data)],true)},checkIfElementIsSelected:data=>{return Blx.text.get("wtrm.step.checkIfElementIsSelected",[data.value,getWtrmElementName(data)],true)},checkIfElementIsNotSelected:data=>{return Blx.text.get("wtrm.step.checkIfElementIsNotSelected",[data.value,getWtrmElementName(data)],true)},checkDownload:data=>{return Blx.text.get("wtrm.step.checkDownload",[data.filename])}};const showWtrmWorkflowResult=function(steps,stepBoxes,debugContainer){const container=Blx.create("div");const createRow=function(table,name,value){const tr=Blx.create("tr").appendTo(table);Blx.create("td").text(name).appendTo(tr);Blx.create("td").text(value).appendTo(tr)};if(!debugContainer){debugContainer=Blx.create("div").addClass("bloonix-wtrm-result-debug-container").hide().appendTo(container)}$.each(steps,(i,item)=>{if(item.status=="done"||item.status=="err"){if(item.status=="err"){Blx.create("div").text(Blx.text.get("wtrm.failed")).addClass("bloonix-wtrm-result-debug-box-title").appendTo(debugContainer);Blx.create("div").text(item.message).addClass("bloonix-wtrm-result-debug-box-error-message").appendTo(debugContainer)}if(typeof item.debug=="object"){$.each(item.debug,(key,arr)=>{if(arr.length>0){debugContainer.show();const box=Blx.create("div").addClass("bloonix-wtrm-result-debug-box").appendTo(debugContainer);Blx.create("div").addClass("bloonix-wtrm-result-debug-box-title").text(Blx.text.get("wtrm.step_result.debug_key",key)).appendTo(box);$.each(arr,(i,line)=>{Blx.create("div").addClass("bloonix-wtrm-result-debug-text").text(line).appendTo(box)})}})}return false}const data=item.data;const step=data.step;const action=step.action;const success=data.success===true?"true":"false";let stepBox;if(stepBoxes){stepBox=$(stepBoxes[i])}else{stepBox=Blx.create("div").addClass("bloonix-wtrm-step").appendTo(container);Blx.create("div").addClass("bloonix-wtrm-step-number").text(Blx.text.get("word.Step",i+1)).appendTo(stepBox);Blx.create("div").addClass("bloonix-wtrm-step-text").html(wtrmText[action](step)).appendTo(stepBox)}const table=Blx.create("table").addClass("bloonix-wtrm-step-result-table").appendTo(stepBox);createRow(table,Blx.text.get("wtrm.step_result.status"),Blx.text.get(`wtrm.step_result.${success}`));createRow(table,Blx.text.get("wtrm.step_result.runtime"),Blx.text.get("wtrm.step_result.ms",[data.stop-data.start]));if(data.message){createRow(table,Blx.text.get("wtrm.step_result.message"),data.message)}if(data.image){const img=Blx.create("div").addClass("bloonix-wtrm-step-result-image").appendTo(stepBox);Blx.create("img").attr("src","data:image/png;base64,"+data.image).appendTo(img);img.click(()=>{const d1=Blx.create("div").addClass("bloonix-wtrm-step-result-image-overlay").appendTo("body");const d2=Blx.create("div").addClass("bloonix-wtrm-step-result-image-overlay-image").appendTo(d1);Blx.create("img").attr("src","data:image/png;base64,"+data.image).appendTo(d2).click(()=>d1.remove())})}if(typeof data.debug=="object"){if(data.debug.length>0){createRow(table,Blx.text.get("wtrm.step_result.debug"),data.debug.length==1?data.debug[0]:JSON.stringify(data.debug,null,"  "))}}});return container};Blx.route.add("dashboard",()=>new Dashboard({id:"default"}).run());Blx.route.add("dashboard/:id",args=>new Dashboard(args).run());class Dashboard{constructor(args){this.dashboard={id:args.id};this.breadcrumbTitle=false;blxapp.breadcrumb.add(Blx.text.get("dashboard.list"),()=>this.listDashboards())}run(){this.init();this.loadDashboard()}init(){this.initHTML();this.initGrid()}destroy(){this.grid.destroy();this.container.remove();blxapp.clearControlIcons()}reload(){this.destroy();this.run()}initHTML(){this.container=Blx.create("div").addClass("bloonix-dashboard-container").appendTo(blxapp.body);this.content=Blx.create("div").addClass("bloonix-dashboard-content").appendTo(this.container);this.icons=[];this.editIcons=[];this.icons.push(blxapp.addControlIcon({name:"folder-open",title:Blx.text.get("dashboard.open"),click:()=>this.listDashboards()}));this.icons.push(blxapp.addControlIcon({name:"settings",title:Blx.text.get("dashboard.update"),click:()=>this.createOrUpdateDashboard("update")}));this.icons.push(blxapp.addControlIcon({name:"plus",title:Blx.text.get("dashboard.create"),click:()=>this.createOrUpdateDashboard("create")}));this.icons.push(blxapp.addControlIcon({name:"folder-pen",title:Blx.text.get("dashboard.edit"),click:()=>this.editDashboard()}));this.editIcons.push(blxapp.addControlIcon({name:"plus",title:Blx.text.get("dashboard.add_dashlet"),hide:true,click:()=>this.listDashlets()}));this.editIcons.push(blxapp.addControlIcon({name:"ban",title:Blx.text.get("dashboard.cancel_edit"),hide:true,click:()=>this.cancelEditDashboard()}));this.editIcons.push(blxapp.addControlIcon({name:"save",title:Blx.text.get("dashboard.save"),hide:true,click:()=>this.saveDashboard()}))}initGrid(){this.gridStackContainer=Blx.create("div").addClass("grid-stack").appendTo(this.content);this.grid=GridStack.init({cellHeight:"40px",margin:"4px",resizable:{handles:"ne,se,nw,sw"},animate:false,nonce:blxapp.nonce});this.grid.on("resizestop",(ev,el)=>{if($(el).data("dashlet-object").resize){$(el).data("dashlet-object").resize()}});this.lockGrid()}lockGrid(){this.grid.enableMove(false);this.grid.enableResize(false)}unlockGrid(){this.grid.enableMove(true);this.grid.enableResize(true)}setTitle(){if(this.breadcrumbTitle===false){this.breadcrumbTitle=blxapp.breadcrumb.add(this.dashboard.name,"dashboard/"+this.dashboard.id)}else{this.breadcrumbTitle.update(this.dashboard.name,"dashboard/"+this.dashboard.id)}}createOrUpdateDashboard(action){let title,submitUrl,name,isDefault,onSuccess;if(action=="update"){title=Blx.text.get("dashboard.update");submitUrl="/user/dashboard/"+this.dashboard.id+"/update";name=this.dashboard.name;onSuccess=data=>{this.dashboard.name=data.name;this.setTitle()}}else if(action=="create"){title=Blx.text.get("dashboard.create");submitUrl="/user/dashboard/create";onSuccess=data=>{this.destroy();this.init();Blx.route.to("dashboard/"+data.id)}}blxpage.overlayForm({title:title,submitUrl:submitUrl,onSuccess:onSuccess,options:{name:{minlength:1,maxlength:100}},values:{name:name},elements:[{tag:"input",name:"name",text:Blx.text.get("word.Name")}]})}loadDashboard(){Blx.ajax.request({url:"/user/dashboard/"+this.dashboard.id,success:result=>this._loadDashboard(result.data)})}_loadDashboard(data){this.dashboard=data;this.setTitle();$.each(data.dashlets,(i,item)=>{this.addDashlet(item)})}editDashboard(){$.each(this.icons,(i,icon)=>icon.hide());$.each(this.editIcons,(i,icon)=>icon.show());this.container.find(".bloonix-dashlet-menu").show();this.container.find(".bloonix-dashlet-container").addClass("bloonix-dashlet-container-border");this.gridStackContainer.find(".grid-stack-item").each((i,e)=>{const el=$(e);if(el.data("dashlet-object").edit){el.data("dashlet-object").edit(true)}});this.unlockGrid()}cancelEditDashboard(){this.reload()}saveDashboard(){this.lockGrid();$.each(this.icons,(i,icon)=>icon.show());$.each(this.editIcons,(i,icon)=>icon.hide());this.container.find(".bloonix-dashlet-menu").hide();this.container.find(".bloonix-dashlet-container-border").removeClass("bloonix-dashlet-container-border");const data=[];$.each(this.grid.save(),(i,item)=>{const content=$(item.content);const uid=content.data("dashlet-uid");const widget=$(`#${uid}`);data.push({name:widget.data("dashlet-name"),config:widget.data("dashlet-config"),x:item.x,y:item.y,w:item.w,h:item.h});if(widget.data("dashlet-object").edit){widget.data("dashlet-object").edit(false)}});Blx.ajax.request({url:"/user/dashboard/"+this.dashboard.id+"/update",data:{dashlets:data},token:true})}listDashboards(){const overlay=Blx.overlay({bodyPadding:false});Blx.table({title:Blx.text.get("dashboard.list"),url:"/user/dashboards",appendTo:overlay.body,selectable:{enabled:true,columns:["name"],deletable:{route:"/user/dashboard/:id/delete",postCallback:rows=>{overlay.close();$.each(rows,(i,item)=>{if(item.id==this.dashboard.id){this.dashboard.id="default";this.destroy();this.run()}})}}},columns:[{name:"name",text:Blx.text.get("word.Name"),callback:row=>{overlay.close();Blx.route.to("dashboard/"+row.id)}}]});overlay.create()}addDashlet(o){if(!Dashboard.dashlets[o.name]){Blx.log.error("dashlet '"+o.name+"' does not exists");return}const widget=this.grid.addWidget({w:o.w||4,h:o.h||6,x:o.x,y:o.y});if(!o.config){o.config={}}const uid=Blx.utils.uniqueId("dashboard");$(widget).data("dashlet-name",o.name).data("dashlet-config",o.config).attr("id",uid);const dashletContainer=Blx.create("div").addClass("bloonix-dashlet-container blx-flex-column").attr("data-dashlet-uid",uid).appendTo(widget.getElementsByClassName("grid-stack-item-content")[0]);const dashletMenuContainer=Blx.create("div").addClass("bloonix-dashlet-menu").appendTo(dashletContainer).hide();const dashletHeaderContainer=Blx.create("div").addClass("bloonix-dashlet-header").appendTo(dashletContainer);const dashletContentContainer=Blx.create("div").addClass("bloonix-dashlet-content blx-flex-grow").appendTo(dashletContainer);const dashletFooterContainer=Blx.create("div").addClass("bloonix-dashlet-footer").appendTo(dashletContainer);const icon=Blx.icon().size("default").coloring("black").radius("square");function addMenuIcon(name){return icon.btn(name).appendTo(dashletMenuContainer)}addMenuIcon("x").prop("title",Blx.text.get("dashboard.remove_dashlet")).click(()=>this.grid.removeWidget(widget));function addMenuIntervalIcon(callback){addMenuIcon("timer").prop("title",Blx.text.get("dashlet.reload_interval")).click(()=>{const overlay=Blx.overlay({position:"middle",title:Blx.text.get("dashlet.reload_interval")}).create();Blx.bselect({appendTo:Blx.create("div").addClass("bloonix-dashboard-interval-menu").appendTo(overlay.body),itemClass:"bloonix-dashboard-interval-menu-item",selected:o.config.interval,onSelect:value=>{callback(value);overlay.close()},items:[{name:Blx.text.get("dashlet.default.reload_interval.0"),value:0},{name:Blx.text.get("dashlet.default.reload_interval.10"),value:1e4},{name:Blx.text.get("dashlet.default.reload_interval.30"),value:3e4},{name:Blx.text.get("dashlet.default.reload_interval.60"),value:6e4},{name:Blx.text.get("dashlet.default.reload_interval.120"),value:12e4},{name:Blx.text.get("dashlet.default.reload_interval.180"),value:18e4},{name:Blx.text.get("dashlet.default.reload_interval.300"),value:3e5},{name:Blx.text.get("dashlet.default.reload_interval.600"),value:6e5}]})})}const dashlet={config:$(widget).data("dashlet-config"),menuContainer:dashletMenuContainer,container:dashletContainer,header:dashletHeaderContainer,content:dashletContentContainer,footer:dashletFooterContainer,addMenuIcon:addMenuIcon,addMenuIntervalIcon:addMenuIntervalIcon};const dashletObject=new Dashboard.dashlets[o.name].cls(dashlet);$(widget).data("dashlet-object",dashletObject);return{dashlet:dashlet,dashletObject:dashletObject}}addNewDashlet(name,config,w,h){const o=this.addDashlet({name:name,config:config,w:w||4,h:h||6});o.dashlet.menuContainer.addClass("bloonix-dashlet-menu").show();o.dashlet.container.addClass("bloonix-dashlet-container-border");if(o.dashletObject.edit){o.dashletObject.edit(true)}}listDashlets(){const overlay=Blx.overlay({title:Blx.text.get("dashboard.add_dashlet")}).create();const table=Blx.simpleTable({appendTo:overlay.body});$.each(Dashboard.dashlets,(name,dashlet)=>{const row=table.add(dashlet.title,"");row.tr.css("cursor","pointer");row.tr.click(()=>{overlay.close();dashlet.configure(o=>this.addNewDashlet(o.name,o.config||{},o.w||4,o.h||6))})})}}Dashboard.dashlets={};Dashboard.register=function(o){if(!o||!o.name||Dashboard.dashlets[o.name]){throw new Error("unable to register dashlet",o.name)}Dashboard.dashlets[o.name]=Blx.utils.config(o,["title","name","cls","configure"],{configure:add=>add({name:o.name})})};class DashletChart{constructor(o){this.container=o.content;this.config=o.config;this.addMenuIcon=o.addMenuIcon;if(this.config.refresh){this.config.interval=this.config.refresh;delete this.config.refresh}const inner=Blx.create("div").css("width","calc(100% - 12px)").css("height","calc(100% - 12px)").css("margin","6px").appendTo(this.container);this.chart=new ServiceChart({container:inner,host_id:this.config.host_id,service_id:this.config.service_id,chart_id:this.config.chart_id,last:this.config.last,type:this.config.type}).create();this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.chart.reload()});this.lastOptions=[];$.each([10800,21600,43200,86400,259200,604800],(i,item)=>{let time,textString;if(item>86400){time=item/86400;textString="chart.last_days"}else{time=item/3600;textString="chart.last_hours"}this.lastOptions.push({name:Blx.text.get(textString,time),value:item});this.chart.menu.add({text:Blx.text.get(textString,time),callback:()=>{this.chart.config.last=item;this.chart.reload()}})});o.addMenuIntervalIcon(value=>{this.config.interval=value;if(this.interval){this.interval.setInterval(value)}});this.addMenuIcon("history").prop("title",Blx.text.get("action.configure")).click(()=>this.configure())}configure(){const overlay=Blx.overlay({position:"middle",title:Blx.text.get("form.predefined_time_range")}).create();Blx.bselect({appendTo:Blx.create("div").addClass("bloonix-dashboard-last-time-menu").appendTo(overlay.body),selected:this.config.last,itemClass:"bloonix-dashboard-last-time-item",onSelect:value=>{this.config.last=value;this.chart.config.last=value;overlay.close();this.chart.reload()},items:this.lastOptions})}resize(){this.chart.resize()}}Dashboard.register({name:"chart",title:Blx.text.get("dashlet.chart.title"),cls:DashletChart,configure:add=>new ServiceCharts({dashboardCallback:add})});class DashletClock{constructor(o){this.container=o.content;this.config=o.config;this.addMenuIcon=o.addMenuIcon;this.container.css("position","relative");this.clockWrapper=Blx.create("div").css("display","inline-block").css("position","absolute").css("top","50%").css("left","50%").css("-webkit-transform","translateX(-50%) translateY(-50%)").css("-moz-transform","translateX(-50%) translateY(-50%)").css("transform","translateX(-50%) translateY(-50%)").appendTo(this.container);this.createMenu();this.reload();this.interval=Blx.interval({monitor:this.clockWrapper,interval:1e3,callback:()=>this.reload()})}createMenu(){const items=[{value:"analog",icon:"clock"},{value:"digital",icon:"grip-horizontal"}];$.each(items,(i,item)=>{this.addMenuIcon(item.icon).prop("title",item.text).click(()=>{this.config.type=item.value;this.reload()})})}reload(){if(this.config.type=="digital"){this.digitalClock()}else{this.analogClock()}}digitalClock(){const time=Blx.create("div").css("font-family","monospace").css("font-size","2.5vi").css("font-weight","bold").css("color",blxapp.style=="default"?"#333333":"#b243ff").text(Blx.dateFormat(Date.now(),"time"));this.clockWrapper.html(time)}analogClock(){var width=this.container.width(),height=this.container.height();if(width>height){width=height}else{height=width}let fillStyle,secondStrokeColor,minuteStrokeColor,hourStrokeColor;if(blxapp.style=="default"){fillStyle="#ffffff";secondStrokeColor="#0288d1";minuteStrokeColor="#111111";hourStrokeColor="#111111"}else{fillStyle="#202020";secondStrokeColor="#9d7bff";minuteStrokeColor="#444444";hourStrokeColor="#444444"}var canvas=document.createElement("canvas"),context=canvas.getContext("2d"),size=height/2,radius=size*.9;canvas.width=width;canvas.height=height;context.translate(size,size);context.beginPath();context.arc(0,0,radius,0,2*Math.PI);context.fillStyle=fillStyle;context.fill();for(var i=1;i<=60;i++){var angle=Math.PI/30*i,sineAngle=Math.sin(angle),cosAngle=-Math.cos(angle),x1,x2,x3,x4,lw;if(i%5==0){context.strokeStyle="#8f8f8f";lw=parseInt(height/60);context.lineWidth=lw<3?3:lw;x1=sineAngle*(radius-height/12);x2=cosAngle*(radius-height/12);x3=sineAngle*(radius-5);x4=cosAngle*(radius-5)}else{context.strokeStyle="#a1a1a1";lw=parseInt(height/150);context.lineWidth=lw<2?2:lw;x1=sineAngle*(radius-height/20);x2=cosAngle*(radius-height/20);x3=sineAngle*(radius-5);x4=cosAngle*(radius-5)}context.beginPath();context.moveTo(x1,x2);context.lineTo(x3,x4);context.stroke()}var date=new Date,hours=date.getHours(),minutes=date.getMinutes(),seconds=date.getSeconds(),angle,x,y,lw;context.strokeStyle=secondStrokeColor;context.beginPath();lw=parseInt(height/200);context.lineWidth=lw<2?2:lw;angle=Math.PI/30*seconds,x=Math.sin(angle)*(radius-height/9),y=-Math.cos(angle)*(radius-height/9);context.moveTo(0,0);context.lineTo(x,y);context.stroke();context.closePath();context.strokeStyle=minuteStrokeColor;context.beginPath();lw=parseInt(height/80);context.lineWidth=lw<3?3:lw;angle=Math.PI/30*(minutes+seconds/60);x=Math.sin(angle)*(radius-height/9);y=-Math.cos(angle)*(radius-height/9);context.moveTo(0,0);context.lineTo(x,y);context.stroke();context.closePath();context.strokeStyle=hourStrokeColor;context.beginPath();lw=parseInt(height/50);context.lineWidth=lw<5?5:lw;angle=Math.PI/6*(hours+minutes/60+seconds/3600);x=Math.sin(angle)*(radius-height/4);y=-Math.cos(angle)*(radius-height/4);context.moveTo(0,0);context.lineTo(x,y);context.stroke();context.closePath();context.beginPath();context.arc(0,0,radius*.08,0,2*Math.PI);context.fillStyle="#111111";context.fill();this.clockWrapper.html(canvas)}}Dashboard.register({name:"clock",title:Blx.text.get("dashlet.clock.title"),cls:DashletClock,configure:add=>add({config:{type:"analog"},name:"clock",w:2,h:6})});class DashletEvents{constructor(o){this.container=o.content;this.config=o.config;this.table=Blx.table({url:"/events",appendTo:this.container,avoidFlickerOnReload:true,title:Blx.text.get("dashlet.events.title"),searchable:{visible:false,value:this.config.query},visible:{enabled:true,columns:this.config.visible},columns:blxTableColumns.getAll("event")});this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.reload()});o.addMenuIntervalIcon(value=>{this.config.interval=value;this.interval.setInterval(value)})}reload(){this.table.reload()}edit(on){if(on===true){this.table.showSearch()}else if(on===false){this.table.hideSearch();this.config.query=this.table.getSearchValue();this.config.visible=this.table.getVisibleColumns()}}}Dashboard.register({name:"events",title:Blx.text.get("dashlet.events.title"),cls:DashletEvents,configure:add=>add({name:"events",config:{interval:3e4,visible:["time","hostname","service_name","last_status","status","message"]},w:6,h:10})});class DashletHosts{constructor(o){this.container=o.content;this.config=o.config;this.table=Blx.table({url:"/hosts",appendTo:this.container,avoidFlickerOnReload:true,title:Blx.text.get("host.list"),searchable:{enabled:true,visible:false,value:this.config.query},visible:{enabled:true,columns:this.config.visible},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),route:"hosts/:id",searchable:{type:"string"},sortable:true,responsive:true},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true,responsive:true},{name:"ipaddr2",text:Blx.text.get("host.attr.ipaddr2"),searchable:{type:"string"},sortable:true},{name:"ipaddr3",text:Blx.text.get("host.attr.ipaddr3"),searchable:{type:"string"},sortable:true},{name:"ipaddr4",text:Blx.text.get("host.attr.ipaddr4"),searchable:{type:"string"},sortable:true},{name:"status_count",text:Blx.text.get("host.status_count"),column:(td,row)=>{const div=Blx.create("div").appendTo(td);$.each([6,5,4,3,2,1,0],(i,s)=>{if(row.status_count[s]){Blx.create("span").addClass("bloonix-status-bg-"+s).addClass("bloonix-status-square").text(row.status_count[s]).appendTo(div)}})},responsive:true},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"string"},sortable:true},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"string"},sortable:true},{name:"enabled",text:Blx.text.get("host.attr.enabled"),convertBool:"yn",searchable:{type:"bool"},sortable:true},{name:"notification_interval",text:Blx.text.get("host.attr.notification_interval"),searchable:{type:"int"},sortable:true},{name:"country_code",text:Blx.text.get("host.attr.country_code"),searchable:{type:"string"},sortable:true}]});this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.reload()});o.addMenuIntervalIcon(value=>{this.config.interval=value;this.interval.setInterval(value)})}reload(){this.table.reload()}edit(on){if(on===true){this.table.showSearch()}else if(on===false){this.table.hideSearch();this.config.query=this.table.getSearchValue();this.config.visible=this.table.getVisibleColumns()}}}Dashboard.register({name:"hosts",title:Blx.text.get("dashlet.hosts.title"),cls:DashletHosts,configure:add=>add({name:"hosts",config:{interval:3e4,visible:["hostname","ipaddr1","status_count"]},w:6,h:10})});class DashletMonitoringScreen{constructor(o){this.container=o.content.css("background-color","transparent");this.config=o.config;this.addMenuIcon=o.addMenuIcon;this.addMenuIcon("settings").prop("title",Blx.text.get("action.configure")).click(()=>this.configure());this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.reload()});o.addMenuIntervalIcon(value=>{this.config.interval=value;this.interval.setInterval(value)});this.reload()}reload(){Blx.ajax.request({url:"/services/summary",data:{offset:0,limit:2e3,sort:["status","desc","host_id","asc"],query:this.config.query},success:result=>this.process(result.data)})}process(data){const container=Blx.create("div").addClass("bloonix-dashlet-monitoring-service-container");$.each(data,(i,host)=>{const wrapper=Blx.create("div").addClass("bloonix-dashlet-monitoring-service-box").addClass(`bloonix-status-bg-${host.highest_status}`).appendTo(container).click(()=>Blx.route.to(`hosts/${host.host_id}/services`));const box=Blx.create("div").addClass("bloonix-dashlet-monitoring-service").appendTo(wrapper);const project_class=host.project_class.replace(/^\//,"");Blx.create("h1").text(host.hostname).appendTo(box);if(project_class){Blx.create("h2").text(project_class).appendTo(box)}Blx.create("h3").text(host.ipaddr1).appendTo(box);const services=[];$.each([6,5,4,3,2],(i,s)=>{$.each(host.by_status[s],(s,service)=>{services.push(service.service_name)})});if(services.length==0){$.each(host.by_status[1],(s,service)=>{services.push(service.service_name)})}if(services.length==0){services.push("ALL SERVICES OK")}const serviceBox=Blx.create("h4").text(services.join(", ")).appendTo(box)});this.container.html(container)}configure(){const overlay=Blx.overlay({closeText:Blx.text.get("action.abort")}).create();Blx.create("div").text(Blx.text.get("word.Filter")).appendTo(overlay.body);const filterContainer=Blx.create("div").css("border","1px solid #555555").css("padding","20px").appendTo(overlay.body);const tableSearch=Blx.tableSearch({container:filterContainer,value:this.config.query,fields:[{name:"id",text:Blx.text.get("word.ID"),type:"int"},{name:"hostname",text:Blx.text.get("host.attr.hostname"),type:"string"},{name:"project_class",text:Blx.text.get("host.attr.project_class"),type:"autocomplete",url:"/hosts/directory/project"},{name:"location_class",text:Blx.text.get("host.attr.location_class"),type:"autocomplete",url:"/hosts/directory/location"},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),type:"string"},{name:"service_name",text:Blx.text.get("service.attr.service_name"),type:"string"},{name:"status",text:Blx.text.get("service.attr.status"),type:"int",options:[{name:"OK",value:0},{name:"INFO",value:1},{name:"NOTICE",value:2},{name:"WARNING",value:3},{name:"ALERT",value:4},{name:"CRITICAL",value:5},{name:"UNKNOWN",value:6}]},{name:"acknowledged",text:Blx.text.get("service.attr.acknowledged"),type:"bool"},{name:"message",text:Blx.text.get("service.attr.message"),type:"string"}]});Blx.button({size:"medium"}).text(Blx.text.get("action.add_filter")).click(()=>tableSearch.start()).appendTo(overlay.body);overlay.addButton({text:Blx.text.get("action.submit"),close:true,callback:()=>{this.config.query=tableSearch.getValue();this.reload()}})}}Dashboard.register({name:"monitoringScreen",title:Blx.text.get("dashlet.monitoring_screen.title"),cls:DashletMonitoringScreen,configure:add=>add({name:"monitoringScreen",config:{interval:3e4,query:["acknowledged","==",0]},w:12,h:20})});class DashletServices{constructor(o){this.container=o.content;this.config=o.config;this.table=Blx.table({url:"/services",appendTo:this.container,avoidFlickerOnReload:true,title:Blx.text.get("host.title.services"),searchable:{visible:false,value:this.config.query},visible:{enabled:true,columns:this.config.visible},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("host.attr.hostname"),route:"hosts/:host_id",searchable:{type:"string"},responsive:true},{name:"service_name",text:Blx.text.get("service.attr.service_name"),searchable:{type:"string"},responsive:true},{name:"icons",visible:true,responsive:true,value:row=>setServiceStatusIcons(row)},{name:"status",text:Blx.text.get("service.attr.status"),column:blxapp.createServiceStatusTableColumn,searchable:setServiceSearchableStatus(),sortable:true,responsive:true},{name:"last_check",text:Blx.text.get("service.attr.last_check"),sortable:true,searchable:{type:"date2x"},convertUnixtimeShort:true},{name:"attempt_counter",text:Blx.text.get("service.attempts"),sortable:true,value:row=>{return row.attempt_counter+"/"+row.attempt_max}},{name:"acknowledged",text:Blx.text.get("service.attr.acknowledged"),searchable:{type:"bool"},convertBool:"yn"},{name:"notification_enabled",text:Blx.text.get("service.attr.notification_enabled"),searchable:{type:"bool"},convertBool:"yn"},{name:"tags",text:Blx.text.get("service.attr.tags"),searchable:{type:"string"}},{name:"message",text:Blx.text.get("service.attr.message"),searchable:{type:"string"},sortable:true}]});this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.reload()});o.addMenuIntervalIcon(value=>{this.config.interval=value;this.interval.setInterval(value)})}reload(){this.table.reload()}edit(on){if(on===true){this.table.showSearch()}else if(on===false){this.table.hideSearch();this.config.query=this.table.getSearchValue();this.config.visible=this.table.getVisibleColumns()}}}Dashboard.register({name:"services",title:Blx.text.get("dashlet.services.title"),cls:DashletServices,configure:add=>add({name:"services",config:{interval:3e4,visible:["hostname","service_name","status","message"]},w:6,h:10})});class DashletServiceStatus{constructor(o){this.container=o.content;this.config=o.config;this.addMenuIcon=o.addMenuIcon;this.addMenuIntervalIcon=o.addMenuIntervalIcon;this.icon=Blx.icon().coloring("black").size("tiny").marginRight("3px");this.initStruct();this.createBoxes();this.createMenu();this.reload();this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.reload()})}reload(){Blx.ajax.request({url:"/services/status",success:result=>{$.each(result.data.status,(i,num)=>{i=parseInt(i);this.boxes[i].text(num)})}})}initStruct(){this.container.html("");this.statusContainer=Blx.create("div").addClass(`bloonix-dashlet-service-status-wrapper ${this.config.size}`).appendTo(this.container);Blx.create("div").addClass("bloonix-clear").appendTo(this.container)}createBoxes(){this.boxes={};for(let i=6;i>=0;i--){const box=Blx.create("div").addClass("bloonix-dashlet-service-status-box").addClass(`bloonix-status-bg-${i}`).appendTo(this.statusContainer).click(()=>Blx.route.to("services",{searchableValue:["status","==",i]}));const span=Blx.create("div").appendTo(box);const num=Blx.create("div").addClass("bloonix-dashlet-service-status-num").appendTo(span);Blx.create("div").appendTo(span).append(this.icon.span(blxapp.statusIconsById[i]),Blx.create("span").text(blxapp.statusById[i]).addClass("bloonix-dashlet-service-status-text"));this.boxes[i]=num}}createMenu(){this.addMenuIntervalIcon(value=>{this.config.interval=value;this.interval.setInterval(value)});const items=[{text:Blx.text.get("word.Horizontal"),value:"s6x1",icon:"move-horizontal"},{text:Blx.text.get("word.Vertical"),value:"s1x6",icon:"move-vertical"}];$.each(items,(i,item)=>{this.addMenuIcon(item.icon).prop("title",item.text).click(()=>{this.statusContainer.removeClass(this.config.size);this.statusContainer.addClass(item.value);this.config.size=item.value})})}}Dashboard.register({name:"serviceStatus",title:Blx.text.get("dashlet.service_status.title"),cls:DashletServiceStatus,configure:add=>add({name:"serviceStatus",config:{interval:3e4,size:"s6x1"},w:8,h:6})});class DashletServiceCounter{constructor(o){this.container=o.content;this.config=o.config;this.addMenuIcon=o.addMenuIcon;this.addMenuIcon("settings").prop("title",Blx.text.get("action.configure")).click(()=>this.configure());this.counterContainer=Blx.create("div").addClass("bloonix-dashlet-service-counter").appendTo(this.container).css("cursor","pointer").click(()=>Blx.route.to("services",{searchableValue:this.config.query}));this.counter=Blx.create("div").appendTo(this.counterContainer);this.title=Blx.create("div").appendTo(this.counterContainer);this.setConfig();this.reload();this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.reload()});o.addMenuIntervalIcon(value=>{this.config.interval=value;this.interval.setInterval(value)})}setConfig(){if(typeof this.config.backgroundColor=="string"&&this.config.backgroundColor!="auto"){this.counterContainer.css("background-color",this.config.backgroundColor)}if(typeof this.config.color=="string"&&this.config.color!="auto"){this.counterContainer.css("color",this.config.color)}if(typeof this.config.title=="string"){this.title.text(this.config.title)}}reload(){Blx.ajax.request({url:"/services",data:{limit:0,query:this.config.query},success:result=>{this.counter.text(result.total)}})}configure(){const configContainer=Blx.create("div");Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("word.Search")).appendTo(configContainer);const tableSearchContainer=Blx.create("div").addClass("bloonix-form-value-box").appendTo(configContainer);const tableSearch=Blx.tableSearch({container:tableSearchContainer,value:this.config.query,fields:[{name:"hostname",text:Blx.text.get("host.attr.hostname"),type:"string"},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),type:"string"},{name:"service_name",text:Blx.text.get("service.attr.service_name"),type:"string"},{name:"status",text:Blx.text.get("service.attr.status"),type:"int",options:[{name:"OK",value:0},{name:"INFO",value:1},{name:"NOTICE",value:2},{name:"WARNING",value:3},{name:"ALERT",value:4},{name:"CRITICAL",value:5},{name:"UNKNOWN",value:6}]},{name:"project_class",text:Blx.text.get("host.attr.project_class"),type:"autocomplete",url:"/hosts/directory/project"},{name:"location_class",text:Blx.text.get("host.attr.location_class"),type:"autocomplete",url:"/hosts/directory/location"},{name:"enabled",text:Blx.text.get("service.attr.enabled"),type:"bool"},{name:"host_enabled",text:Blx.text.get("service.host_enabled"),type:"bool"},{name:"acknowledged",text:Blx.text.get("service.attr.acknowledged"),type:"bool"},{name:"notification_enabled",text:Blx.text.get("service.attr.notification_enabled"),type:"bool"},{name:"host_notification_enabled",text:Blx.text.get("service.host_notification_enabled"),type:"bool"},{name:"is_flapping",text:Blx.text.get("service.attr.is_flapping"),type:"bool"},{name:"has_downtime",text:Blx.text.get("service.attr.has_downtime"),type:"bool"},{name:"tags",text:Blx.text.get("service.attr.tags"),type:"string"},{name:"attempt_counter",text:Blx.text.get("service.attempts"),type:"int"},{name:"status_since",text:Blx.text.get("service.attr.status_since"),type:"date2x"},{name:"last_check",text:Blx.text.get("service.attr.last_check"),type:"date2x"},{name:"message",text:Blx.text.get("service.attr.message"),type:"string"},{name:"agent_version",text:Blx.text.get("service.attr.agent_version"),type:"string"}]});Blx.button({size:"medium"}).text(Blx.text.get("word.Filter")).appendTo(configContainer).click(()=>tableSearch.start());Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("word.Title")).appendTo(configContainer);const titleInput=Blx.create("input").val(this.config.title).addClass("bloonix-form-input").appendTo(configContainer);Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("text.Background_color")).appendTo(configContainer);const bgInput=Blx.create("input").val(this.config.backgroundColor).addClass("bloonix-form-input").appendTo(configContainer);Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("text.Text_color")).appendTo(configContainer);const fgInput=Blx.create("input").val(this.config.color).addClass("bloonix-form-input").appendTo(configContainer);const overlay=Blx.overlay();overlay.addButton({text:Blx.text.get("action.submit"),callback:()=>{this.config.title=titleInput.val();this.config.backgroundColor=bgInput.val();this.config.color=fgInput.val();this.config.query=tableSearch.getValue();this.setConfig();this.reload();overlay.close()}});overlay.body.html(configContainer);overlay.create()}}Dashboard.register({name:"serviceCounter",title:Blx.text.get("dashlet.service_counter.title"),cls:DashletServiceCounter,configure:add=>add({name:"serviceCounter",config:{interval:3e4,title:"Number of services",backgroundColor:"auto",color:"auto"},w:2,h:6})});class DashletHostCounter{constructor(o){this.container=o.content;this.config=o.config;this.addMenuIcon=o.addMenuIcon;this.addMenuIcon("settings").prop("title",Blx.text.get("action.configure")).click(()=>this.configure());this.counterContainer=Blx.create("div").addClass("bloonix-dashlet-service-counter").appendTo(this.container).css("cursor","pointer").click(()=>Blx.route.to("hosts",{searchableValue:this.config.query}));this.counter=Blx.create("div").appendTo(this.counterContainer);this.title=Blx.create("div").appendTo(this.counterContainer);this.setConfig();this.reload();this.interval=Blx.interval({monitor:o.content,interval:this.config.interval,callback:()=>this.reload()});o.addMenuIntervalIcon(value=>{this.config.interval=value;this.interval.setInterval(value)})}setConfig(){if(typeof this.config.backgroundColor=="string"&&this.config.backgroundColor!="auto"){this.counterContainer.css("background-color",this.config.backgroundColor)}if(typeof this.config.color=="string"&&this.config.color!="auto"){this.counterContainer.css("color",this.config.color)}if(typeof this.config.title=="string"){this.title.text(this.config.title)}}reload(){Blx.ajax.request({url:"/hosts",data:{limit:0,query:this.config.query},success:result=>{this.counter.text(result.total)}})}configure(){const configContainer=Blx.create("div");Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("word.Search")).appendTo(configContainer);const tableSearchContainer=Blx.create("div").addClass("bloonix-form-value-box").appendTo(configContainer);const tableSearch=Blx.tableSearch({container:tableSearchContainer,value:this.config.query,fields:[{name:"hostname",text:Blx.text.get("host.attr.hostname"),type:"string"},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),type:"string"},{name:"project_class",text:Blx.text.get("host.attr.project_class"),type:"autocomplete",url:"/hosts/directory/project"},{name:"location_class",text:Blx.text.get("host.attr.location_class"),type:"autocomplete",url:"/hosts/directory/location"},{name:"enabled",text:Blx.text.get("host.attr.enabled"),type:"bool"},{name:"notification_enabled",text:Blx.text.get("host.attr.notification_enabled"),type:"bool"}]});Blx.button({size:"medium"}).text(Blx.text.get("word.Filter")).appendTo(configContainer).click(()=>tableSearch.start());Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("word.Title")).appendTo(configContainer);const titleInput=Blx.create("input").val(this.config.title).addClass("bloonix-form-input").appendTo(configContainer);Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("text.Background_color")).appendTo(configContainer);const bgInput=Blx.create("input").val(this.config.backgroundColor).addClass("bloonix-form-input").appendTo(configContainer);Blx.create("div").addClass("bloonix-form-label").text(Blx.text.get("text.Text_color")).appendTo(configContainer);const fgInput=Blx.create("input").val(this.config.color).addClass("bloonix-form-input").appendTo(configContainer);const overlay=Blx.overlay();overlay.addButton({text:Blx.text.get("action.submit"),callback:()=>{this.config.title=titleInput.val();this.config.backgroundColor=bgInput.val();this.config.color=fgInput.val();this.config.query=tableSearch.getValue();this.setConfig();this.reload();overlay.close()}});overlay.body.html(configContainer);overlay.create()}}Dashboard.register({name:"hostCounter",title:Blx.text.get("dashlet.host_counter.title"),cls:DashletHostCounter,configure:add=>add({name:"hostCounter",config:{interval:3e4,title:"Number of hosts",backgroundColor:"auto",color:"auto"},w:2,h:6})});class DashletHostStatusWorldmap{constructor(o){this.container=o.content;this.config=o.config;this.worldmapContainer=Blx.create("div").addClass("bloonix-fwh").appendTo(this.container);worldmap({appendTo:this.worldmapContainer,onClick:code=>Blx.route.to("hosts",{searchableValue:["country_code","==",code]}),data:{de:{UNKNOWN:0,CRITICAL:0,ALERT:0,WARNING:0,NOTICE:0,INFO:0,OK:0}}})}resize(){this.worldmapContainer.resize()}}Dashboard.register({name:"host_status_worldmap",title:"Worldmap",cls:DashletHostStatusWorldmap});Blx.route.add("events",args=>{blxapp.breadcrumb.add(Blx.text.get("event.list"),"events");Blx.ajax.request({url:"/user/table-settings/event",success:result=>{listEvents({title:Blx.text.get("event.list"),url:"/events",visible:{enabled:true,url:"/user/table-settings/event",columns:result.data},columns:blxTableColumns.getAll("event")})}})});function listEvents(o){const datePager=Blx.datePager();const table=blxpage.list({title:o.title,titleIcon:"calendar",url:o.url,postdataCallback:postdata=>{postdata.date=datePager.getDate();return postdata},searchable:{enabled:true},visible:o.visible,columns:o.columns});datePager.onSelect(()=>{table.reload({resetPager:true})});datePager.appendTo(table.headerContainer)}function setEventDebugIcons(row){const span=Blx.create("span");if(row.debug){tableStatusIcon.span("info").css("cursor","pointer").attr("title",Blx.text.get("event.debug")).appendTo(span).click(()=>{Blx.overlay({position:"full",body:Blx.create("pre").text(JSON.stringify(row.debug,null,"  "))}).create()})}return span}blxTableColumns.set("event",{time:()=>({text:Blx.text.get("word.Time"),sortable:true,convertUnixtimeShort:true,responsive:true}),icons:()=>({visible:true,responsive:true,value:row=>setEventDebugIcons(row)}),host_id:()=>({text:Blx.text.get("host.attr.id"),searchable:{type:"int"},sortable:true,responsive:true}),hostname:()=>({text:Blx.text.get("word.Hostname"),route:"hosts/:host_id",searchable:{type:"string"},sortable:true,responsive:true}),service_id:()=>({text:Blx.text.get("service.attr.id"),searchable:{type:"int"},sortable:true,responsive:true}),service_name:()=>({text:Blx.text.get("service.attr.service_name"),searchable:{type:"string"},sortable:true,responsive:true}),last_status:()=>({text:Blx.text.get("event.attr.last_status"),column:(td,row)=>blxapp.createServiceStatusTableColumn(td,row,"last_status"),searchable:setServiceSearchableStatus(),sortable:true}),status:()=>({text:Blx.text.get("service.attr.status"),column:blxapp.createServiceStatusTableColumn,searchable:setServiceSearchableStatus(),sortable:true,responsive:true}),attempts:()=>({text:Blx.text.get("service.attempts"),searchable:{type:"int"},sortable:true}),duration:()=>({text:Blx.text.get("event.attr.duration"),searchable:{type:"int"},sortable:true,convertToTimeString:true}),tags:()=>({text:Blx.text.get("event.attr.tags"),searchable:{type:"string"},sortable:true}),message:()=>({text:Blx.text.get("service.attr.message"),searchable:{type:"string"},sortable:true})});class Grid{constructor(o){this.config=Blx.utils.config(o,["container","gridConfig","resizable","alias"],{container:blxapp.body,resizable:{handles:"se,sw"},alias:"none"});this.config.gridConfig=Blx.utils.setopts(this.config.gridConfig,{cellHeight:"40px",margin:"4px",resizable:this.config.resizable,animate:false,nonce:blxapp.nonce});this.gridStackContainer=Blx.create("div").addClass("grid-stack").appendTo(this.config.container);this.grid=GridStack.init(this.config.gridConfig);this.grid.on("resizestop",(ev,el)=>{if($(el).data("dashlet-object")&&$(el).data("dashlet-object").resize){$(el).data("dashlet-object").resize()}})}addWidget(o){const w=this.grid.addWidget({w:o.w,h:o.h,x:o.x,y:o.y});const widget=$(w).addClass("bloonix-gridstack-item").data("config",o.data);const gridContainer=Blx.create("div").addClass("bloonix-dashlet-container").appendTo(widget.find(".grid-stack-item-content")[0]);const gridContent=Blx.create("div").addClass("bloonix-dashlet-content").appendTo(gridContainer);if(o.object){widget.data("dashlet-object",o.object)}return{widget:widget,gridContainer:gridContainer,gridContent:gridContent,addObject:object=>widget.data("dashlet-object",object),remove:()=>this.grid.removeWidget(w)}}getWidgets(){const widgets=[];this.config.container.find(".bloonix-gridstack-item").each((i,el)=>{el=$(el);widgets.push({x:el.attr("gs-x"),y:el.attr("gs-y"),w:el.attr("gs-w"),h:el.attr("gs-h"),data:el.data("config")})});return widgets}removeAll(){this.grid.removeAll()}on(t,c){this.grid.on(t,c)}lock(){this.grid.enableMove(false);this.grid.enableResize(false)}unlock(){this.grid.enableMove(true);this.grid.enableResize(true)}enableResize(tf){this.grid.enableResize(tf)}enableMove(tf){this.grid.enableMove(tf)}destroy(){this.grid.destroy()}}Blx.route.add("hosts",args=>new Hosts(args,"list"));Blx.route.add("hosts/:id",args=>new Hosts(args,"metadata"));Blx.route.add("hosts/:id/metadata",args=>new Hosts(args,"metadata"));Blx.route.add("hosts/:id/services",args=>new Hosts(args,"services"));Blx.route.add("hosts/:id/services/:service_id",args=>new Hosts(args,"services"));Blx.route.add("hosts/:id/events",args=>new Hosts(args,"events"));Blx.route.add("hosts/:id/charts",args=>new Hosts(args,"charts"));Blx.route.add("hosts/:id/report",args=>new Hosts(args,"report"));Blx.route.add("hosts/:id/report/:service_id",args=>new Hosts(args,"report"));Blx.route.add("hosts/:id/downtimes",args=>new Hosts(args,"downtimes"));Blx.route.add("hosts/:id/dependencies",args=>new Hosts(args,"dependencies"));Blx.route.add("hosts/:id/notifications",args=>new Hosts(args,"notifications"));Blx.route.add("hosts/:id/templates",args=>new Hosts(args,"templates"));Blx.route.add("hosts/:id/contact-groups",args=>new Hosts(args,"contact-groups"));Blx.route.add("hosts/:id/groups",args=>new Hosts(args,"groups"));Blx.route.add("hosts/:id/location-groups",args=>new Hosts(args,"location-groups"));class Hosts{constructor(args,action){this.hostId=args.id;this.serviceId=args.service_id;this.action=action;this.fromTime=args.fromTime||Blx.dateFormat(Date.now(),"date");this.toTime=args.toTime||Blx.dateFormat(Date.now(),"date");blxapp.breadcrumb.add(Blx.text.get("host.list"),"hosts");if(action=="list"){this.list(args.searchableValue)}else{this.show()}}list(searchableValue){const headerIcons=[];let deletable;if(blxapp.user.role=="admin"||blxapp.user.role=="operator"){headerIcons.push({name:"plus",title:Blx.text.get("host.create"),callback:()=>{const c=new ConfigHost;c.create(()=>Blx.route.to("/hosts"))}});deletable={route:"/config/hosts/:id/delete"}}const table=blxpage.list({grow:true,title:Blx.text.get("host.list"),titleIcon:"server",url:"/hosts",headerIcons:headerIcons,searchable:{enabled:true,value:searchableValue},selectable:{enabled:true,columns:["id","hostname","ipaddr1"],deletable:deletable},visible:{enabled:true,url:"/user/table-settings/host"},footerIcons:setHostActionIcons(),columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),route:"hosts/:id",searchable:{type:"string"},sortable:true,responsive:true},{name:"icons",visible:true,responsive:true,value:row=>setHostStatusIcons(row)},{name:"description",text:Blx.text.get("word.Description"),sortable:true,searchable:{type:"string"}},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true},{name:"ipaddr2",text:Blx.text.get("host.attr.ipaddr2"),searchable:{type:"string"},sortable:true},{name:"ipaddr3",text:Blx.text.get("host.attr.ipaddr3"),searchable:{type:"string"},sortable:true},{name:"ipaddr4",text:Blx.text.get("host.attr.ipaddr4"),searchable:{type:"string"},sortable:true},{name:"status",text:Blx.text.get("host.attr.status"),column:blxapp.createServiceStatusTableColumn},{name:"status_count",text:Blx.text.get("host.status_count"),column:(td,row)=>{td.css("vertical-align","middle");const div=Blx.create("div").appendTo(td);$.each([6,5,4,3,2,1,0],(i,s)=>{if(row.status_count[s]){Blx.create("span").addClass(`bloonix-status-bg-${s}`).addClass("bloonix-status-square").text(row.status_count[s]).appendTo(div)}})},responsive:true},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"autocomplete",url:"/hosts/directory/project"},sortable:true,callback:(row,table)=>{table.addSearchFilter("and","project_class","=~",row.project_class)}},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"autocomplete",url:"/hosts/directory/location"},sortable:true,callback:(row,table)=>{table.addSearchFilter("and","location_class","=~",row.location_class)}},{name:"enabled",text:Blx.text.get("host.attr.enabled"),convertBool:"yn",searchable:{type:"bool"},sortable:true},{name:"notification_interval",text:Blx.text.get("host.attr.notification_interval"),searchable:{type:"int"},sortable:true},{name:"notification_enabled",text:Blx.text.get("host.attr.notification_enabled"),convertBool:"yn",searchable:{type:"bool"},sortable:true},{name:"country_code",text:Blx.text.get("host.attr.country_code"),searchable:{type:"string"},sortable:true}]})}show(){Blx.ajax.request({url:`/hosts/${this.hostId}`,success:result=>{this.host=result.data;this.body=blxapp.body;blxapp.breadcrumb.add(result.data.hostname,`hosts/${this.hostId}`);blxapp.topNav.add({name:"metadata",text:Blx.text.get("host.nav.metadata"),route:`hosts/${this.hostId}`,callback:()=>this.showHost()});blxapp.topNav.add({name:"services",text:Blx.text.get("host.nav.services"),route:`hosts/${this.hostId}/services`,callback:()=>this.showServices()});blxapp.topNav.add({name:"events",text:Blx.text.get("host.nav.events"),route:`hosts/${this.hostId}/events`,callback:()=>this.showEvents()});blxapp.topNav.add({name:"charts",text:Blx.text.get("host.nav.charts"),route:`hosts/${this.hostId}/charts`,callback:()=>this.showCharts()});blxapp.topNav.add({name:"report",text:Blx.text.get("host.nav.report"),route:`hosts/${this.hostId}/report`,callback:()=>this.showReport()});blxapp.topNav.add({name:"downtimes",text:Blx.text.get("host.nav.downtimes"),route:`hosts/${this.hostId}/downtimes`,callback:()=>this.showDowntimes()});blxapp.topNav.add({name:"dependencies",text:Blx.text.get("host.nav.dependencies"),route:`hosts/${this.hostId}/dependencies`,callback:()=>this.showDependencies()});if(blxapp.user.role=="admin"||blxapp.user.role=="operator"){blxapp.topNav.add({name:"templates",text:Blx.text.get("host.nav.templates"),route:`hosts/${this.hostId}/templates`,callback:()=>new ConfigHostTemplates({replaceTo:blxapp.body,hostId:this.hostId})});blxapp.topNav.add({name:"contact-groups",text:Blx.text.get("host.nav.contactgroups"),route:`hosts/${this.hostId}/contact-groups`,callback:()=>new ConfigHostContactGroups({replaceTo:blxapp.body,hostId:this.hostId})});blxapp.topNav.add({name:"groups",text:Blx.text.get("host.nav.groups"),route:`hosts/${this.hostId}/groups`,callback:()=>new ConfigHostGroups({replaceTo:blxapp.body,hostId:this.hostId})});blxapp.topNav.add({name:"location-groups",text:Blx.text.get("host.nav.location_groups"),route:`hosts/${this.hostId}/location-groups`,callback:()=>new ConfigHostLocationGroups({replaceTo:blxapp.body,hostId:this.hostId})});blxapp.topNav.add({name:"notifications",text:Blx.text.get("host.nav.notifications"),route:`hosts/${this.hostId}/notifications`,callback:()=>this.showNotifications()})}blxapp.topNav.run(this.action)}})}showHost(){const grid=new Grid({container:this.body});grid.lock();this.showHostMetaData(grid);this.showHostServiceStatus(grid);this.showHostCountServicesWithDowntimes(grid);this.showHostCountServicesAreFlapping(grid);this.showHostCountEvents(grid);this.showHostAvailabilitySummary(grid);this.showHostCountNotifications(grid)}showHostMetaData(grid){const widget=grid.addWidget({w:3,h:12});const contentBox=Blx.contentBox({title:this.host.hostname,appendTo:widget.gridContent});const table=Blx.simpleTable({appendTo:contentBox.body});if(blxapp.user.role=="admin"||blxapp.user.role=="operator"){contentBox.icon.btn("folder-pen").prop("title",Blx.text.get("action.edit")).click(()=>{const c=new ConfigHost({hostId:this.hostId});c.edit(()=>Blx.route.to(`hosts/${this.hostId}`))});contentBox.icon.btn("x").prop("title",Blx.text.get("action.delete")).click(()=>this.deleteHost())}let row=table.row();row.th.text(Blx.text.get("host.attr.ipaddr1"));row.td.text(this.host.ipaddr1);row=table.row();row.th.text(Blx.text.get("host.attr.ipaddr2"));row.td.text(this.host.ipaddr2);row=table.row();row.th.text(Blx.text.get("host.attr.ipaddr3"));row.td.text(this.host.ipaddr3);row=table.row();row.th.text(Blx.text.get("host.attr.ipaddr4"));row.td.text(this.host.ipaddr4);row=table.row();row.th.text(Blx.text.get("host.attr.description"));row.td.text(this.host.description);row=table.row();row.th.text(Blx.text.get("host.attr.sysinfo"));if(this.host.sysinfo){const m=/^([^=]+)=(http.+)/.exec(this.host.sysinfo);if(m){Blx.create("a").addClass("blx-link").text(m[1]).attr("href",m[2]).attr("target","_blank").appendTo(row.td)}else{row.td.text(this.host.sysinfo)}}row=table.row();row.th.text(Blx.text.get("host.attr.enabled"));row.td.text(Blx.text.get(`bool.yesno.${this.host.enabled}`));row=table.row();row.th.text(Blx.text.get("host.attr.notification_enabled"));row.td.text(Blx.text.get(`bool.yesno.${this.host.notification_enabled}`));row=table.row();row.th.text(Blx.text.get("host.attr.notification_interval"));row.td.text(Blx.utils.secondsToStringReadable(this.host.notification_interval));row=table.row();row.th.text(Blx.text.get("host.attr.country_code"));if(this.host.country_code){Blx.create("span").addClass("bloonix-flag-svg-line").append(Blx.svgFlag.medium(this.host.country_code)).appendTo(row.td)}row=table.row();row.th.text(Blx.text.get("host.attr.project_class"));row.td.text(this.host.project_class);row=table.row();row.th.text(Blx.text.get("host.attr.location_class"));row.td.text(this.host.location_class)}deleteHost(){const overlay=Blx.overlay({title:Blx.text.get("host.delete"),position:"middle",closeText:Blx.text.get("action.no_abort")}).create();overlay.body.css("text-align","center");Blx.create("div").text(Blx.text.get("host.really_delete",[this.host.hostname])).appendTo(overlay.body);Blx.button({text:Blx.text.get("action.yes_delete")}).css("margin","20px auto 0 auto").appendTo(overlay.body).click(()=>{overlay.close();Blx.ajax.request({url:`/config/hosts/${this.hostId}/delete`,token:true,success:result=>Blx.route.to("hosts")})})}showHostServiceStatus(grid){const counter=this.createCounterBox(grid,Blx.text.get("host.dashlet.services_not_ok"),`/hosts/${this.hostId}/services`);Blx.ajax.request({url:`/hosts/${this.hostId}/count-not-ok`,success:result=>counter.text(result.data)})}showHostCountEvents(grid){const counter=this.createCounterBox(grid,Blx.text.get("host.dashlet.count_events"),`/hosts/${this.hostId}/events`);Blx.ajax.request({url:`/hosts/${this.hostId}/count-events`,success:result=>counter.text(result.data)})}showHostAvailabilitySummary(grid){const counter=this.createCounterBox(grid,Blx.text.get("host.dashlet.latest_availability"),`/hosts/${this.hostId}/report`);Blx.ajax.request({url:`/hosts/${this.hostId}/latest-availability`,success:result=>counter.text(`${result.data}%`)})}showHostCountServicesWithDowntimes(grid){const counter=this.createCounterBox(grid,Blx.text.get("host.dashlet.active_downtimes"),`/hosts/${this.hostId}/downtimes`);Blx.ajax.request({url:`/hosts/${this.hostId}/count-downtime`,success:result=>counter.text(result.data)})}showHostCountServicesAreFlapping(grid){const counter=this.createCounterBox(grid,Blx.text.get("host.dashlet.flapping_services"),`/hosts/${this.hostId}/services`);Blx.ajax.request({url:`/hosts/${this.hostId}/count-flapping`,success:result=>counter.text(result.data)})}showHostCountNotifications(grid){const counter=this.createCounterBox(grid,Blx.text.get("host.dashlet.latest_notifications"),`/hosts/${this.hostId}/notifications`);Blx.ajax.request({url:`/hosts/${this.hostId}/count-notifications`,success:result=>counter.text(result.data)})}createCounterBox(grid,text,route){const widget=grid.addWidget({w:2,h:4});const box=Blx.create("div").addClass("bloonix-dashlet-service-counter").appendTo(widget.gridContent);if(route){box.click(()=>Blx.route.to(route))}const counter=Blx.create("div").text(0).appendTo(box);Blx.create("div").text(text).appendTo(box);return counter}showServices(){blxapp.breadcrumb.add(Blx.text.get("host.nav.services"),`hosts/${this.hostId}/services`);if(this.serviceId){this.showService()}else{this.showServiceList()}}showService(){Blx.ajax.request({url:`/hosts/${this.hostId}/services/${this.serviceId}`,success:result=>{blxapp.breadcrumb.add(result.data.service_name,`hosts/${this.hostId}/services/${this.serviceId}`);if(serviceDashboards[result.data.command]){serviceDashboards[result.data.command].callback(this.hostId,result.data)}}})}showServiceList(){const headerIcons=[];const selectable={enabled:true};let editServiceCallback;if(blxapp.user.role=="admin"||blxapp.user.role=="operator"){headerIcons.push({name:"plus",callback:()=>{new ConfigService({schema:"hosts",objId:this.hostId}).create()}});selectable.columns=["id","service_name"];selectable.deletable={route:`/config/hosts/${this.hostId}/services/:id/delete`};editServiceCallback=row=>this.editService(row)}const table=blxpage.list({grow:true,title:Blx.text.get("service.list"),titleIcon:"layers",url:`/hosts/${this.hostId}/services`,headerIcons:headerIcons,selectable:selectable,searchable:{enabled:true},sortable:{enabled:true},visible:{enabled:true},footerIcons:setServiceActionIcons(),columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"service_name",text:Blx.text.get("service.attr.service_name"),column:(td,row)=>setServiceDashboardColumn(td,row),sortable:true,searchable:{type:"string"},responsive:true,visible:true},{name:"icons",visible:true,responsive:true,value:row=>setServiceStatusIcons(row,true,editServiceCallback),visible:true},{name:"status",text:Blx.text.get("service.attr.status"),column:blxapp.createServiceStatusTableColumn,sortable:true,searchable:setServiceSearchableStatus(),responsive:true,visible:true},{name:"attempt_counter",text:Blx.text.get("service.attempts"),sortable:true,searchable:{type:"int"},value:row=>{return`${row.attempt_counter}/${row.attempt_max}`},visible:true},{name:"status_since",text:Blx.text.get("service.attr.status_since"),sortable:true,searchable:{type:"date2x"},convertUnixtimeShort:true,visible:true},{name:"last_check",text:Blx.text.get("service.attr.last_check"),sortable:true,searchable:{type:"date2x"},visible:true,convertUnixtimeShort:true},{name:"agent_version",text:Blx.text.get("service.attr.agent_version"),sortable:true,searchable:{type:"string"}},{name:"tags",text:Blx.text.get("service.attr.tags"),sortable:true,searchable:{type:"string"},visible:true},{name:"message",text:Blx.text.get("service.attr.message"),sortable:true,searchable:{type:"string"},visible:true}]})}editService(item){if(item.template_id){this.getVariables(item.id)}else{new ConfigService({schema:"hosts",objId:this.hostId,serviceId:item.id}).edit()}}getVariables(serviceId){Blx.ajax.request({url:`/config/hosts/${this.hostId}/services/${serviceId}/variables`,success:result=>this.editVariables(result.data,serviceId)})}editVariables(data,serviceId){const overlay=Blx.overlay({title:Blx.text.get("service.available_variables"),closeText:Blx.text.get("action.abort")}).create();const box=Blx.create("div").addClass("bloonix-variables-box").appendTo(overlay.body);Blx.create("div").text(Blx.text.get("service.available_variables_help")).appendTo(box);if(Blx.utils.size(data)==0){Blx.create("br").appendTo(box);Blx.create("div").text(Blx.text.get("service.no_variables_defined")).appendTo(box);return}const inputs={};$.each(data,(key,schemata)=>{let inputValue="";Blx.create("div").addClass("bloonix-variables-key").text(key).appendTo(box);$.each(schemata,(schema,value)=>{if(schema=="service"){inputValue=value}else{Blx.create("div").addClass("bloonix-variables-value").text(Blx.text.get(`service.set_variable_${schema}`,value)).appendTo(box)}});Blx.create("span").text(Blx.text.get("text.Overwrite_value")).appendTo(box);inputs[key]=Blx.create("input").attr("type","text").attr("name",key).attr("value",inputValue).addClass("bloonix-variables-input").appendTo(box)});overlay.addButton({text:Blx.text.get("action.submit"),callback:()=>{const data={};$.each(inputs,(key,input)=>{const value=input.val();if(value.length&&!/^\s*$/.test(value)){data[key]=value}});Blx.ajax.request({token:true,url:`/config/hosts/${this.hostId}/services/${serviceId}/variables/update`,data:{variables:data},success:result=>overlay.close()})}})}showEvents(){blxapp.breadcrumb.add(Blx.text.get("host.nav.events"),`hosts/${this.hostId}/events`);listEvents({title:Blx.text.get("host.nav.events"),url:`hosts/${this.hostId}/events`,visible:{enabled:true,columns:["time","service_name","last_status","status","attempts","duration","message"]},columns:blxTableColumns.getAll("event",["host_id","hostname"])})}showCharts(){blxapp.breadcrumb.add(Blx.text.get("host.nav.charts"),`hosts/${this.hostId}/charts`);new ServiceCharts({hostId:this.hostId})}showReport(){blxapp.breadcrumb.add(Blx.text.get("host.nav.report"),`hosts/${this.hostId}/report`);if(this.serviceId){this.showServiceReport()}else{this.showHostReport()}}showHostReport(){const tableForm=Blx.create("div").addClass("bloonix-table-form");const fromTimeBox=Blx.create("div").addClass("bloonix-table-form-item").appendTo(tableForm);Blx.create("label").text(Blx.text.get("form.from_time")).appendTo(fromTimeBox);const fromTimeInput=Blx.create("input").val(Blx.dateFormat(Date.now(),"date")).appendTo(fromTimeBox).datepicker({dateFormat:"yy-mm-dd"});const toTimeBox=Blx.create("div").addClass("bloonix-table-form-item").appendTo(tableForm);Blx.create("label").text(Blx.text.get("form.to_time")).appendTo(toTimeBox);const toTimeInput=Blx.create("input").val(Blx.dateFormat(Date.now(),"date")).appendTo(toTimeBox).datepicker({dateFormat:"yy-mm-dd"});const table=Blx.table({title:Blx.text.get("host.nav.report"),titleIcon:"file-chart-pie",appendTo:this.body,url:`/hosts/${this.hostId}/report`,searchable:{enabled:false},visible:{enabled:true},pager:{enabled:false},postdataCallback:postdata=>{if(fromTimeInput.val()){postdata.from_time=fromTimeInput.val()+" 00:00:00"}if(toTimeInput.val()){postdata.to_time=toTimeInput.val()+" 23:59:59"}return postdata},columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"service_name",text:Blx.text.get("service.attr.service_name"),callback:row=>Blx.route.to(`hosts/${row.host_id}/report/${row.id}`,{fromTime:fromTimeInput.val(),toTime:toTimeInput.val()}),visible:true},{name:"availability",text:Blx.text.get("report.availability"),value:row=>`${row.availability}%`,visible:true},{name:"status_duration_in_percent",column:(td,row)=>{const box=Blx.create("div").addClass("bloonix-availability-bar").appendTo(td);$.each(["0","1","2","3","4","5","6"],(i,s)=>{if(row.status_duration_in_percent[i]>0){Blx.create("div").css("width",row.status_duration_in_percent[i]+"%").addClass(`bloonix-status-bg-${s}`).appendTo(box)}});return box},visible:true},{name:"status_duration_in_percent",text:Blx.text.get("report.status_duration_in_percent"),value:row=>{const box=Blx.create("span");$.each(["0","1","2","3","4","5","6"],(i,s)=>{Blx.create("span").html(row.status_duration_in_percent[s]+"%&nbsp;&nbsp;&nbsp;").addClass(`bloonix-status-text-${s}`).appendTo(box)});return box},visible:true},{name:"total_number_of_events",text:Blx.text.get("report.events"),visible:true},{name:"events_by_status",text:Blx.text.get("report.events_by_status"),value:row=>{const box=Blx.create("span");$.each(["0","1","2","3","4","5","6"],(i,s)=>{Blx.create("span").html(row.events_by_status[s]+"&nbsp;&nbsp;&nbsp;").addClass(`bloonix-status-text-${s}`).appendTo(box)});return box},visible:true}]});const reload=()=>{if(fromTimeInput.val()&&toTimeInput.val()){table.reload()}};tableForm.appendTo(table.headerContainer);fromTimeInput.on("change",()=>reload());toTimeInput.on("change",()=>reload())}showServiceReport(){const grid=new Grid({container:this.body});grid.lock();this.showServiceReportForm(grid);const postdata={};if(this.fromTimeInput.val()){postdata.from_time=this.fromTimeInput.val()+" 00:00:00"}if(this.toTimeInput.val()){postdata.to_time=this.toTimeInput.val()+" 23:59:59"}Blx.ajax.request({url:`/hosts/${this.hostId}/report/${this.serviceId}`,data:postdata,success:result=>{const service=result.data;blxapp.breadcrumb.add(service.service_name,`hosts/${this.hostId}/report/${this.serviceId}`);this.showServiceReportNumberOfEventsByHour(service,grid);this.showServiceReportAvailability(service,grid);this.showServiceReportStatusDuration(service,grid);this.showServiceReportNumberOfEvents(service,grid);this.showServiceReportNumberOfTags(service,grid);this.showServiceReportEventsByDuration(service,grid)}})}showServiceReportForm(grid){const widget=grid.addWidget({w:12,h:2});const tableForm=Blx.create("div").addClass("bloonix-table-form").appendTo(widget.gridContent);const fromTimeBox=Blx.create("div").addClass("bloonix-table-form-item").appendTo(tableForm);Blx.create("label").text(Blx.text.get("form.from_time")).appendTo(fromTimeBox);this.fromTimeInput=Blx.create("input").val(this.fromTime).appendTo(fromTimeBox).datepicker({dateFormat:"yy-mm-dd"});const toTimeBox=Blx.create("div").addClass("bloonix-table-form-item").appendTo(tableForm);Blx.create("label").text(Blx.text.get("form.to_time")).appendTo(toTimeBox);this.toTimeInput=Blx.create("input").val(this.toTime).appendTo(toTimeBox).datepicker({dateFormat:"yy-mm-dd"});const route=()=>{if(!this.fromTimeInput.val()||!this.toTimeInput.val()){return}Blx.route.to(`hosts/${this.hostId}/report/${this.serviceId}`,{fromTime:this.fromTimeInput.val(),toTime:this.toTimeInput.val()})};this.fromTimeInput.on("change",route);this.toTimeInput.on("change",route)}showServiceReportNumberOfEventsByHour(service,grid){const widget=grid.addWidget({w:3,h:19});const contentBox=Blx.contentBox({title:Blx.text.get("report.events_by_time_of_day"),appendTo:widget.gridContent});const table=Blx.simpleTable({appendTo:contentBox.body});for(let i=0;i<24;i++){const t=i<10?`0${i}`:i;const row=table.row();row.th.text(`${t}:00 - ${t}:59`);$.each(["0","1","2","3","4","5","6"],(x,s)=>{const span=Blx.create("span").html(service.events_by_hour[i][s]+"&nbsp;&nbsp;&nbsp;").addClass(`bloonix-status-text-${s}`).appendTo(row.td);if(service.events_by_hour[i][s]==0){span.css("opacity",.3)}else{span.css("font-weight","bold")}})}}showServiceReportAvailability(service,grid){const widget=grid.addWidget({w:3,h:8});const contentBox=Blx.contentBox({title:Blx.text.get("report.availability"),appendTo:widget.gridContent});const table=Blx.simpleTable({appendTo:contentBox.body});let row=table.row();row.th.text(Blx.text.get("report.total_availability"));row.td.text(service.availability+"%");$.each(["0","1","2","3","4","5","6"],(x,s)=>{row=table.row();row.th.text(blxapp.statusById[x]);row.td.text(service.status_duration_in_percent[s]+"%");row.td.addClass(`bloonix-status-text-${s}`)})}showServiceReportStatusDuration(service,grid){const widget=grid.addWidget({w:3,h:8});const contentBox=Blx.contentBox({title:Blx.text.get("report.status_duration_in_percent"),appendTo:widget.gridContent});const table=Blx.simpleTable({appendTo:contentBox.body});let row=table.row();row.th.text(Blx.text.get("report.total_availability"));row.td.text(Blx.utils.secondsToStringReadable(service.total_time));$.each(["0","1","2","3","4","5","6"],(x,s)=>{row=table.row();row.th.text(blxapp.statusById[x]);row.td.text(Blx.utils.secondsToStringReadable(service.status_duration[s])||"-");row.td.addClass(`bloonix-status-text-${s}`)})}showServiceReportNumberOfEvents(service,grid){const widget=grid.addWidget({w:3,h:8});const contentBox=Blx.contentBox({title:Blx.text.get("report.events_by_status"),appendTo:widget.gridContent});const table=Blx.simpleTable({appendTo:contentBox.body});let row=table.row();row.th.text(Blx.text.get("report.total_availability"));row.td.text(service.total_number_of_events);$.each(["0","1","2","3","4","5","6"],(x,s)=>{row=table.row();row.th.text(blxapp.statusById[x]);row.td.text(service.events_by_status[s]);row.td.addClass(`bloonix-status-text-${s}`)})}showServiceReportNumberOfTags(service,grid){const widget=grid.addWidget({w:3,h:8});const contentBox=Blx.contentBox({title:Blx.text.get("report.number_of_tags"),appendTo:widget.gridContent});const table=Blx.simpleTable({appendTo:contentBox.body});$.each(service.number_of_tags,(name,value)=>{const row=table.row();row.th.text(name);row.td.text(value)})}showServiceReportEventsByDuration(service,grid){const widget=grid.addWidget({w:3,h:8});const contentBox=Blx.contentBox({title:Blx.text.get("report.number_of_events_by_duration"),appendTo:widget.gridContent});const table=Blx.simpleTable({appendTo:contentBox.body});$.each(["b15","b30","b60","b180","bx"],(i,b)=>{const row=table.row();row.th.text(Blx.text.get(`report.event_${b}`));$.each(["0","1","2","3","4","5","6"],(x,s)=>{Blx.create("span").html(service.events_by_duration[b][s]+"&nbsp;&nbsp;&nbsp;").addClass(`bloonix-status-text-${s}`).appendTo(row.td)})})}showDowntimes(){blxapp.breadcrumb.add(Blx.text.get("host.nav.downtimes"),`hosts/${this.hostId}/downtimes`);if(blxapp.user.role=="admin"||blxapp.user.role=="operator"){new ConfigDowntimes({hostId:this.hostId,replaceTo:blxapp.body}).list()}else{const simpleGrid=Blx.simpleGrid({replaceTo:this.body});blxpage.list({grow:false,appendTo:simpleGrid.add(),url:`/hosts/${this.hostId}/host-downtimes`,title:Blx.text.get("downtimes.host_downtimes"),titleIcon:"alarm-clock-minus",searchable:{enabled:false},sortable:{enabled:false},columns:getDowntimeColumns(false)});blxpage.list({grow:false,appendTo:simpleGrid.add(),url:`/hosts/${this.hostId}/service-downtimes`,title:Blx.text.get("downtimes.service_downtimes"),titleIcon:"alarm-clock-minus",searchable:{enabled:false},sortable:{enabled:false},columns:getDowntimeColumns(true)})}}showDependencies(){if(blxapp.user.role=="admin"||blxapp.user.role=="operator"){blxapp.breadcrumb.add(Blx.text.get("host.nav.dependencies"),`hosts/${this.hostId}/dependencies`);blxapp.subNav.add({name:"chart",text:Blx.text.get("word.Chart"),callback:()=>this.showDependencyChart()});blxapp.subNav.add({name:"config",text:Blx.text.get("word.Config"),callback:()=>new ConfigHostDependencies({hostId:this.hostId,replaceTo:blxapp.body}).list()});blxapp.subNav.run("chart")}else{this.showDependencyChart()}}showDependencyChart(){Blx.ajax.request({url:`hosts/${this.hostId}/dependencies`,success:result=>{const chartBox=Blx.create("div").addClass("bloonix-tree-chart");this.body.html(chartBox);if(result.data.tree.children.length==0){Blx.create("div").addClass("blx-nodata-text").setHTML(Blx.text.get("err-611")).appendTo(chartBox);return}const chart=echarts.init(chartBox[0]);const data=result.data.tree;const services=result.data.services;const host=result.data.host;chart.setOption({tooltip:{trigger:"item",triggerOn:"mousemove",formatter:e=>{const hostnameText=Blx.text.get("host.attr.hostname"),hostIdText=Blx.text.get("host.attr.id"),serviceNameText=Blx.text.get("service.attr.service_name");if(!e.value){return Blx.create("box").append(Blx.create("div").text(`${hostIdText}: ${host.id}`),Blx.create("div").text(`${hostnameText}: ${host.hostname}`))[0]}const hostname=services[e.value].hostname,hostId=services[e.value].host_id,serviceName=services[e.value].service_name,serviceIdText=Blx.text.get("service.attr.id");return Blx.create("box").append(Blx.create("div").text(`${hostIdText}: ${hostId}`),Blx.create("div").text(`${hostnameText}: ${hostname}`),Blx.create("div").text(`${serviceIdText}: ${e.value}`),Blx.create("div").text(`${serviceNameText}: ${serviceName}`))[0]}},series:[{type:"tree",data:[data],edgeShape:"polyline",label:{backgroundColor:"#ffffff",position:"left",verticalAlign:"middle",align:"right"},expandAndCollapse:true,animationDuration:550,animationDurationUpdate:750}]});Blx.resize.add(chartBox,()=>chart.resize())}})}showNotifications(){blxapp.breadcrumb.add(Blx.text.get("host.nav.notifications"),`hosts/${this.hostId}/notifications`);blxpage.list({title:Blx.text.get("host.nav.notifications"),url:`/hosts/${this.hostId}/notifications`,searchable:{enabled:true},sortable:{enabled:true},visible:{enabled:true,columns:["time","message_service_name","success","send_to","contact","message"]},columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"time",text:Blx.text.get("word.Time"),convertUnixtimeShort:true,sortable:true,searchable:{type:"date2x"}},{name:"contact",text:Blx.text.get("contact_message_service.contact"),sortable:true,searchable:{type:"string"}},{name:"send_to",text:Blx.text.get("contact_message_service.attr.send_to"),sortable:true,searchable:{type:"string"}},{name:"message_service_name",text:Blx.text.get("contact.message_service"),sortable:true,searchable:{type:"string"}},{name:"icons",visible:true,responsive:true,value:row=>{const span=Blx.create("span");if(row.success===0){tableStatusIcon.span("info").css("cursor","pointer").appendTo(span).click(()=>{Blx.overlay({position:"middle",body:Blx.create("div").text(row.error)}).create()})}return span}},{name:"success",text:Blx.text.get("word.Success"),convertBool:"yn",searchable:{type:"bool"},column:(td,row)=>{td.addClass("bloonix-status-column-bg");td.addClass("bloonix-status-bg");td.addClass("bloonix-status-td");if(row.success==1){td.addClass(`bloonix-status-bg-0`);td.text(Blx.text.get("bool.yesno.1"))}else{td.addClass(`bloonix-status-bg-5`);td.text(Blx.text.get("bool.yesno.0"))}}},{name:"message",text:Blx.text.get("message_service.sendmail.param.message"),searchable:{type:"string"},cut:200}]})}}function setHostActionIcons(){return[{name:"wrench",title:Blx.text.get("service.action.downtime.title"),callback:table=>setServiceDowntime("hosts",table)},{name:"square-check",title:Blx.text.get("service.action.acknowledge.title"),callback:table=>setServiceAcknowledgement("hosts",table)},{name:"bell-off",title:Blx.text.get("service.action.notification.title"),callback:table=>setServiceNotification("hosts",table)},{name:"circle-off",title:Blx.text.get("service.action.en_dis_able.title"),callback:table=>setServiceEnOrDisable("hosts",table)},{name:"refresh-ccw",title:Blx.text.get("service.action.forcecheck.title"),callback:table=>setServiceForceNextCheck("hosts",table)}]}function setHostStatusIcons(item){const span=Blx.create("span");if(item["enabled"]===0){tableStatusIcon.span("circle-off").attr("title",Blx.text.get("host.disabled")).appendTo(span)}if(item["notification_enabled"]===0){tableStatusIcon.span("bell-off").attr("title",Blx.text.get("host.notifications_disabled")).appendTo(span)}return span}Blx.route.add("notifications",args=>new Notifications(args,"list"));class Notifications{constructor(args){blxapp.breadcrumb.add(Blx.text.get("host.nav.notifications"),`notifications`);const date=Date.now()-86400*7*1e3;blxpage.list({title:Blx.text.get("host.nav.notifications"),url:`/notifications`,searchable:{enabled:true,value:["time",">=",Blx.dateFormat(Date.now()-86400*7*1e3,"default")]},sortable:{enabled:true},visible:{enabled:true,columns:["time","message_service_name","success","send_to","contact","message"]},columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"time",text:Blx.text.get("word.Time"),convertUnixtimeShort:true,sortable:true,searchable:{type:"date2x"}},{name:"contact",text:Blx.text.get("contact_message_service.contact"),sortable:true,searchable:{type:"string"}},{name:"send_to",text:Blx.text.get("contact_message_service.attr.send_to"),sortable:true,searchable:{type:"string"}},{name:"message_service_name",text:Blx.text.get("contact.message_service"),sortable:true,searchable:{type:"string"}},{name:"icons",visible:true,responsive:true,value:row=>{const span=Blx.create("span");if(row.success===0){tableStatusIcon.span("info").css("cursor","pointer").appendTo(span).click(()=>{Blx.overlay({position:"middle",body:Blx.create("div").text(row.error)}).create()})}return span}},{name:"success",text:Blx.text.get("word.Success"),convertBool:"yn",searchable:{type:"bool"},column:(td,row)=>{td.addClass("bloonix-status-column-bg");td.addClass("bloonix-status-bg");td.addClass("bloonix-status-td");if(row.success==1){td.addClass(`bloonix-status-bg-0`);td.text(Blx.text.get("bool.yesno.1"))}else{td.addClass(`bloonix-status-bg-5`);td.text(Blx.text.get("bool.yesno.0"))}}},{name:"message",text:Blx.text.get("message_service.sendmail.param.message"),searchable:{type:"string"},cut:200}]})}}Blx.route.add("services",args=>(new Services).list(args));class Services{constructor(){blxapp.breadcrumb.add(Blx.text.get("service.list"),"services")}list(args){const table=blxpage.list({title:Blx.text.get("service.list"),titleIcon:"layers",url:"/services",searchable:{enabled:true,value:args.searchableValue,columns:[{name:"enabled",text:Blx.text.get("service.attr.enabled"),type:"bool"},{name:"host_enabled",text:Blx.text.get("service.host_enabled"),type:"bool"},{name:"notification_enabled",text:Blx.text.get("service.attr.notification_enabled"),type:"bool"},{name:"host_notification_enabled",text:Blx.text.get("service.host_notification_enabled"),type:"bool"},{name:"acknowledged",text:Blx.text.get("service.attr.acknowledged"),type:"bool"},{name:"is_flapping",text:Blx.text.get("service.attr.is_flapping"),type:"bool"},{name:"has_downtime",text:Blx.text.get("service.attr.has_downtime"),type:"bool"},{name:"remote_check",text:Blx.text.get("service.attr.remote_check"),type:"bool"}]},selectable:{enabled:true,columns:["id","hostname","service_name"]},visible:{enabled:true,url:"/user/table-settings/service"},footerIcons:setServiceActionIcons(),columns:[{name:"id",text:Blx.text.get("word.ID"),sortable:true,searchable:{type:"int"}},{name:"hostname",text:Blx.text.get("host.attr.hostname"),route:"hosts/:host_id",sortable:true,searchable:{type:"string"},responsive:true},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),sortable:true,searchable:{type:"string"}},{name:"service_name",text:Blx.text.get("service.attr.service_name"),column:(td,row)=>setServiceDashboardColumn(td,row),sortable:true,searchable:{type:"string"},responsive:true},{name:"command",text:Blx.text.get("service.attr.command"),sortable:true,searchable:{type:"string"}},{name:"icons",visible:true,responsive:true,value:row=>setServiceStatusIcons(row)},{name:"project_class",text:Blx.text.get("host.attr.project_class"),searchable:{type:"autocomplete",url:"/hosts/directory/project"},sortable:true},{name:"location_class",text:Blx.text.get("host.attr.location_class"),searchable:{type:"autocomplete",url:"/hosts/directory/location"},sortable:true},{name:"status",text:Blx.text.get("service.attr.status"),column:blxapp.createServiceStatusTableColumn,sortable:true,searchable:setServiceSearchableStatus(),responsive:true},{name:"attempt_counter",text:Blx.text.get("service.attempts"),sortable:true,searchable:{type:"int"},value:row=>{return`${row.attempt_counter}/${row.attempt_max}`}},{name:"status_since",text:Blx.text.get("service.attr.status_since"),sortable:true,searchable:{type:"date2x"},convertUnixtimeShort:true},{name:"last_check",text:Blx.text.get("service.attr.last_check"),sortable:true,searchable:{type:"date2x"},convertUnixtimeShort:true},{name:"agent_version",text:Blx.text.get("service.attr.agent_version"),sortable:true,searchable:{type:"string"}},{name:"tags",text:Blx.text.get("service.attr.tags"),sortable:true,searchable:{type:"string"}},{name:"message",text:Blx.text.get("service.attr.message"),sortable:true,searchable:{type:"string"}}]})}}function setServiceActionIcons(){return[{name:"wrench",title:Blx.text.get("service.action.downtime.title"),callback:table=>setServiceDowntime("services",table)},{name:"square-check",title:Blx.text.get("service.action.acknowledge.title"),callback:table=>setServiceAcknowledgement("services",table)},{name:"bell-off",title:Blx.text.get("service.action.notification.title"),callback:table=>setServiceNotification("services",table)},{name:"circle-off",title:Blx.text.get("service.action.en_dis_able.title"),callback:table=>setServiceEnOrDisable("services",table)},{name:"refresh-ccw",title:Blx.text.get("service.action.forcecheck.title"),callback:table=>setServiceForceNextCheck("services",table)}]}function setServiceStatusIcons(item,withTemplate,editCallback){const span=Blx.create("span");if(editCallback){tableStatusIcon.span("folder-pen").prop("title",Blx.text.get("action.edit")).css("cursor","pointer").click(()=>editCallback(item)).appendTo(span);if(!item.template_id){tableStatusIcon.span("copy-plus").prop("title",Blx.text.get("action.clone")).css("cursor","pointer").click(()=>cloneServiceCallback(item)).appendTo(span)}}if(withTemplate===true&&item.template_id&&(blxapp.user.role=="admin"||blxapp.user.role=="operator")){tableStatusIcon.a("layers").attr("href",`#config/templates/${item.template_id}`).attr("target","_blank").prop("title",Blx.text.get("service.template",item.template_name)).appendTo(span)}if(item["enabled"]===0||item["host_enabled"]===0){tableStatusIcon.span("circle-off").prop("title",Blx.text.get("service.disabled")).appendTo(span)}if(item["notification_enabled"]===0||item["host_notification_enabled"]===0){tableStatusIcon.span("bell-off").prop("title",Blx.text.get("service.notifications_disabled")).appendTo(span)}if(item["acknowledged"]===1){tableStatusIcon.span("square-check").prop("title",Blx.text.get("service.attr.acknowledged")).appendTo(span)}if(item["is_flapping"]===1){tableStatusIcon.span("arrow-up-down").prop("title",Blx.text.get("service.attr.is_flapping")).appendTo(span)}if(item["has_downtime"]===1){tableStatusIcon.span("wrench").prop("title",Blx.text.get("service.attr.has_downtime")).appendTo(span)}if(Date.now()/1e3-item["status_since"]<3600){tableStatusIcon.span("zap").prop("title",Blx.text.get("service.status_switched")).appendTo(span)}return span}function cloneServiceCallback(item){const overlay=Blx.overlay({title:Blx.text.get("service.clone"),position:"middle"});const div=Blx.create("div").addClass("bloonix-center").appendTo(overlay.body);Blx.button().text(Blx.text.get("service.clone_same_host")).click(()=>{overlay.close();cloneServiceToHost(item,item.host_id)}).appendTo(div);Blx.button().text(Blx.text.get("service.clone_another_host")).click(()=>{overlay.close();cloneServiceSelectHost(item)}).appendTo(div);overlay.create()}function cloneServiceSelectHost(item){const overlay=Blx.overlay({title:Blx.text.get("host.list"),titleIcon:"server"}).create();const table=blxpage.list({overlay:overlay,url:"/hosts",searchable:{enabled:true},columns:[{name:"id",text:Blx.text.get("word.ID"),searchable:{type:"int"},sortable:true},{name:"hostname",text:Blx.text.get("word.Hostname"),callback:row=>{overlay.close();cloneServiceToHost(item,row.id)},searchable:{type:"string"},sortable:true,responsive:true},{name:"description",text:Blx.text.get("word.Description"),sortable:true,searchable:{type:"string"}},{name:"ipaddr1",text:Blx.text.get("host.attr.ipaddr1"),searchable:{type:"string"},sortable:true}]})}function cloneServiceToHost(item,targetHostId){new ConfigService({schema:"hosts",objId:targetHostId}).clone(item.host_id,item.id,item.command)}function setServiceSearchableStatus(){return{type:"int",options:[{name:"OK",value:0},{name:"INFO",value:1},{name:"NOTICE",value:2},{name:"WARNING",value:3},{name:"ALERT",value:4},{name:"CRITICAL",value:5},{name:"UNKNOWN",value:6}]}}function setServiceDashboardColumn(td,row){if(serviceDashboards[row.command]&&serviceDashboards[row.command].satellite_type===row.satellite_type){Blx.create("a").attr("href",`#hosts/${row.host_id}/services/${row.id}`).addClass("blx-table-link").text(row.service_name).click(()=>Blx.route.to(`hosts/${row.host_id}/services/${row.id}`)).appendTo(td)}else{Blx.create("span").addClass("blx-table-span").text(row.service_name).appendTo(td)}}const serviceDashboards={};serviceDashboards.register=(command,satellite_type,callback)=>{serviceDashboards[command]={satellite_type:satellite_type,callback:callback}};class ServiceDashboardCheckWTRM{constructor(hostId,service){this.hostId=hostId;this.service=service;this.createDOM();this.createTable()}createDOM(){this.container=Blx.create("div").addClass("bloonix-fwh").appendTo(blxapp.body);this.flexContainer=Blx.create("div").addClass("blx-flex-row blx-flex-grow bloonix-fwh").appendTo(this.container);this.leftBox=Blx.create("div").addClass("bloonix-wtrm-dashboard-table-box").addClass("blx-flex-grow").appendTo(this.flexContainer);this.rightBox=Blx.create("div").addClass("bloonix-wtrm-dashboard-result-box").appendTo(this.flexContainer).hide();Blx.resize.add(this.rightBox,()=>this.resize());this.chartBox=Blx.create("div").addClass("bloonix-wtrm-dashboard-chart-box").appendTo(this.rightBox);this.contentBox=Blx.contentBox({appendTo:this.rightBox})}createTable(){this.datePager=Blx.datePager();this.table=blxpage.list({appendTo:this.leftBox,title:this.service.service_name,url:`/hosts/${this.hostId}/services/${this.service.id}/search`,postdataCallback:postdata=>{postdata.date=this.datePager.getDate();return postdata},pager:{enabled:false},columns:[{name:"time",text:Blx.text.get("word.Time"),convertUnixtime:true,responsive:true,callback:row=>this.show(row)},{name:"status",text:Blx.text.get("service.attr.status"),column:blxapp.createServiceStatusTableColumn,responsive:true},{name:"message",text:Blx.text.get("service.attr.message")}]});this.datePager.onSelect(()=>this.table.reload());this.datePager.appendTo(this.table.headerContainer)}show(row){this.rightBox.show();this.contentBox.body.html(Blx.create("div").addClass("blx-table-loading-info").append(Blx.create("div").addClass("blx-loader-bars")));Blx.ajax.request({url:`/hosts/${this.hostId}/services/${this.service.id}/data`,data:{time:row.time},success:result=>{this.contentBox.body.html(showWtrmWorkflowResult(result.data.data));this.createChart(result.data.data,row.message)}})}createChart(data,subtitle){let titleColor,labelColor,gridLineColor;if(blxapp.style=="default"){titleColor="#404040";labelColor="#505050"}else{titleColor="#c1c1c1";labelColor="#b1b1b1";gridLineColor="#333333"}const steps=[];const series=[];$.each(data,(i,item)=>{if(item.status=="ok"||item.status=="err"){steps.push(i+1);series.push(item.data.took)}if(item.status!="ok"){return false}});const option={animation:false,textStyle:{fontFamily:"Roboto"},title:{text:"Web transaction - step result",itemGap:5,padding:10,textStyle:{color:titleColor,fontWeight:"normal",fontSize:"13px"},subtext:subtitle,subtextStyle:{color:labelColor,fontWeight:"normal",fontSize:"12px",fontWeight:"300"}},legend:{},grid:{left:25,right:10,bottom:30,containLabel:true},xAxis:{data:steps},yAxis:[{type:"value",name:"ms",nameLocation:"center",nameGap:30,nameTextStyle:{color:labelColor,fontWeight:"normal",fontSize:"12px"},splitLine:{lineStyle:{color:gridLineColor}}}],series:{type:"line",data:series,areaStyle:{}}};this.chart=echarts.init(this.chartBox[0]);this.chart.setOption(option)}resize(){if(this.chart&&this.chart.resize){this.chart.resize()}}}serviceDashboards.register("check-wtrm",0,(hostId,service)=>new ServiceDashboardCheckWTRM(hostId,service));class ServiceDashboardCheckBySatellite{constructor(hostId,service,chartId,metrics){this.hostId=hostId;this.service=service;this.chartId=chartId;this.metrics=metrics;this.appendTo=blxapp.body;this.createDOM();this.getPlugin()}createDOM(){this.selectChartsBox=Blx.create("div").addClass("bloonix-fwh").appendTo(this.appendTo);this.flexContainer=Blx.create("div").addClass("blx-flex-row blx-flex-grow bloonix-fwh").appendTo(this.selectChartsBox);this.leftBox=Blx.create("div").addClass("bloonix-chart-selection-left").appendTo(this.flexContainer);this.rightBox=Blx.create("div").addClass("bloonix-chart-selection-right").appendTo(this.flexContainer);this.chartBox=Blx.create("div").addClass("bloonix-satellite-chart-box");this.tableBox=Blx.create("div").addClass("blx-flex-grow");Blx.create("div").addClass("blx-flex-column blx-flex-grow").appendTo(this.rightBox).append(this.chartBox).append(this.tableBox)}createForm(){const contentBox=Blx.contentBox({appendTo:this.leftBox});this.form=Blx.form({appendTo:contentBox.body,showMandatoryFieldsInfo:false,showSubmitButton:false});this.timeType="predefined";const row=this.form.createEmptyElement().addClass("bloonix-chart-form-row");const rowBtn=Blx.create("div").appendTo(row);const rowLast=Blx.create("div").appendTo(row);const rowFix=Blx.create("div").appendTo(row).hide();const lastBtn=Blx.create("span").addClass("bloonix-chart-form-short-btn").addClass("bloonix-chart-form-short-btn-selected").text(Blx.text.get("form.predefined_time_range")).appendTo(rowBtn);Blx.create("span").text("|").appendTo(rowBtn);const fixBtn=Blx.create("span").addClass("bloonix-chart-form-short-btn").text(Blx.text.get("form.absolute_time_range")).appendTo(rowBtn);lastBtn.click(()=>{rowFix.hide();fixBtn.removeClass("bloonix-chart-form-short-btn-selected");rowLast.show();lastBtn.addClass("bloonix-chart-form-short-btn-selected");this.timeType="predefined"});fixBtn.click(()=>{rowLast.hide();lastBtn.removeClass("bloonix-chart-form-short-btn-selected");rowFix.show();fixBtn.addClass("bloonix-chart-form-short-btn-selected");this.timeType="custom"});this.form.date({name:"from_time",text:Blx.text.get("form.from_time"),appendTo:rowFix,onSelect:()=>this.checkTimeForReload()});this.form.date({name:"to_time",text:Blx.text.get("form.to_time"),appendTo:rowFix,onSelect:()=>this.checkTimeForReload()});this.form.radioBtn({name:"last",parseInt:true,options:this.radioBtnSeconds([10800,21600,43200,86400,259200,604800]),value:10800,appendTo:rowLast,onChange:()=>this.reload()});this.form.radioBtn({name:"type",text:Blx.text.get("word.Type"),parseInt:true,options:[{value:"avg",label:"AVG"},{value:"min",label:"MIN"},{value:"max",label:"MAX"}],value:"avg",appendTo:this.form.createEmptyElement().addClass("bloonix-chart-form-row"),onChange:()=>this.reload()});this.form.table({appendTo:this.form.createEmptyElement(),name:"satellite_id",table:{title:Blx.text.get("satellite.list"),url:"/satellites",sortable:{enabled:true},selectable:{selectCallback:()=>this.reload(),unselectCallback:()=>this.reload()},columns:[{name:"country",text:Blx.text.get("word.Country"),responsive:true,convertCountryFlag:true,sortable:true},{name:"name",text:Blx.text.get("word.Name"),responsive:true,sortable:true}]}});this.createDashboard()}radioBtnSeconds(arr){const options=[];for(const v of arr){options.push({value:v,label:Blx.utils.secondsToStringShortReadable(v)})}return options}getPlugin(){Blx.ajax.request({url:`/hosts/${this.hostId}/services/${this.service.id}/plugin`,success:result=>{this.plugin=result.data;this.getSatellites()}})}getSatellites(){Blx.ajax.request({url:"/satellites",success:result=>{this.satellites=result.data;this.satellitesById={};$.each(this.satellites,(i,item)=>{this.satellitesById[item.id]=item});this.createForm()}})}createDashboard(){this.createChart();this.createMetricsTable()}createChart(){this.chartBox.html("");const formData=this.form.parseFormData();let from_time,to_time,last;if(this.timeType=="predefined"){last=formData.last}else{from_time=formData.from_time+" 00:00:00";to_time=formData.to_time+" 23:59:59"}this.chart=new ServiceChart({container:this.chartBox,host_id:this.hostId,service_id:this.service.id,chart_id:this.chartId,last:last,from_time:from_time,to_time:to_time,type:formData.type,satellite_id:formData.satellite_id}).create()}createMetricsTable(){const columns=[{name:"time",text:Blx.text.get("word.Time"),convertUnixtimeShort:true}];$.each(this.metrics,(i,name)=>{columns.push({name:name,text:this.plugin.metrics[name]["name"],align:"right",value:row=>{const value=row[name];const unit=this.plugin.metrics[name].unit;if(unit=="ms"){return value.toFixed(1)+" ms"}if(unit=="percent"){return value+"%"}return value+"s"}})});columns.push({name:"country",text:Blx.text.get("word.Country"),value:row=>{const id=row.satellite_id.toString();const span=Blx.create("span");if(this.satellitesById[id]){Blx.svgFlag(this.satellitesById[id].country,"medium").appendTo(span);Blx.create("span").css("line-height","20px").css("display","inline-block").css("padding-left","6px").text(this.satellitesById[id].name).appendTo(span)}return span}});this.table=Blx.table({appendTo:this.tableBox,url:`/hosts/${this.hostId}/services/${this.service.id}/charts/data`,postdataCallback:data=>{const formData=this.form.parseFormData();data.satellite_id=formData.satellite_id;if(this.timeType=="predefined"){data.last=formData.last}else{data.from_time=formData.from_time;data.to_time=formData.to_time}return data},columns:columns})}checkTimeForReload(){const formData=this.form.parseFormData();if(formData.from_time&&formData.to_time){this.reload()}}reload(){this.table.reload();this.createChart()}}serviceDashboards.register("check-http",1,(hostId,service)=>{new ServiceDashboardCheckBySatellite(hostId,service,"check-http-1",["time_total"])});serviceDashboards.register("check-linux-ping",1,(hostId,service)=>{new ServiceDashboardCheckBySatellite(hostId,service,"check-linux-ping-1",["rta","loss"])});const tableStatusIcon=Blx.icon().size("tiny").marginRight(2).marginLeft(2).coloring("black");function worldmap(o){const data={};const colors={};const region={};const fillColor={UNKNOWN:"#eb6841",CRITICAL:"#cc333f",ALERT:"#de4f59",WARNING:"#faa732",INFO:"#328afa",OK:"#5fbf5f",defaultFill:"#c9c9c9"};$.each(o.data,function(k,v){const country=k.toLowerCase();let color="OK";if(v.UNKNOWN>0){color="UNKNOWN"}else if(v.CRITICAL>0){color="CRITICAL"}else if(v.ALERT>0){color="ALERT"}else if(v.WARNING>0){color="WARNING"}else if(v.NOTICE>0){color="NOTICE"}else if(v.INFO>0){color="INFO"}colors[country]=fillColor[color];data[country]={UNKNOWN:v.UNKNOWN,CRITICAL:v.CRITICAL,ALERT:v.ALERT,WARNING:v.WARNING,NOTICE:v.NOTICE,INFO:v.INFO,OK:v.OK}});$(".jqvmap-label").remove();o.appendTo.html("").off().vectorMap({map:"world_en",backgroundColor:"transparent",borderColor:"#ffffff",borderOpacity:1,borderWidth:1,color:"#c9c9c9",colors:colors,enableZoom:true,hoverColor:"#7555d3",hoverOpacity:null,normalizeFunction:"linear",selectedColor:null,selectedRegion:null,showTooltip:true,onRegionClick:(element,code,region)=>{o.appendTo.html("").off();$(".jqvmap-label").remove();o.onClick(code.toUpperCase())},onLabelShow:(element,label,code)=>{label.css({"z-index":"10005",position:"fixed"});let mapData;if(data[code]){mapData=data[code]}else{mapData={OK:0,INFO:0,WARNING:0,CRITICAL:0,UNKNOWN:0}}const div='<div class="map-tooltip"><span class="f32"><span class="flag '+code+'"></span></span> '+worldmap.regions[code]+"<br/><b>Unknown: </b>"+mapData.UNKNOWN+"<br/><b>Critical: </b>"+mapData.CRITICAL+"<br/><b>Warning: </b>"+mapData.WARNING+"<br/><b>Info: </b>"+mapData.INFO+"<br/><b>Ok: </b>"+mapData.OK+"</div>";label.html(div)}})}worldmap.regions={ae:"United Arab Emirates",af:"Afghanistan",ag:"Antigua and Barbuda",al:"Albania",am:"Armenia",ao:"Angola",ar:"Argentina",at:"Austria",au:"Australia",az:"Azerbaijan",ba:"Bosnia and Herzegovina",bb:"Barbados",bd:"Bangladesh",be:"Belgium",bf:"Burkina Faso",bg:"Bulgaria",bi:"Burundi",bj:"Benin",bn:"Brunei Darussalam",bo:"Bolivia",br:"Brazil",bs:"Bahamas",bt:"Bhutan",bw:"Botswana",by:"Belarus",bz:"Belize",ca:"Canada",cd:"Congo",cf:"Central African Republic",cg:"Congo",ch:"Switzerland",ci:"Cote d'Ivoire",cl:"Chile",cm:"Cameroon",cn:"China",co:"Colombia",cr:"Costa Rica",cu:"Cuba",cv:"Cape Verde",cy:"Cyprus",cz:"Czech Republic",de:"Germany",dj:"Djibouti",dk:"Denmark",dm:"Dominica",do:"Dominican Republic",dz:"Algeria",ec:"Ecuador",ee:"Estonia",eg:"Egypt",er:"Eritrea",es:"Spain",et:"Ethiopia",fi:"Finland",fj:"Fiji",fk:"Falkland Islands",fr:"France",ga:"Gabon",gb:"United Kingdom",gd:"Grenada",ge:"Georgia",gf:"French Guiana",gh:"Ghana",gl:"Greenland",gm:"Gambia",gn:"Guinea",gq:"Equatorial Guinea",gr:"Greece",gt:"Guatemala",gw:"Guinea-Bissau",gy:"Guyana",hn:"Honduras",hr:"Croatia",ht:"Haiti",hu:"Hungary",id:"Indonesia",ie:"Ireland",il:"Israel",in:"India",iq:"Iraq",ir:"Iran",is:"Iceland",it:"Italy",jm:"Jamaica",jo:"Jordan",jp:"Japan",ke:"Kenya",kg:"Kyrgyz Republic",kh:"Cambodia",km:"Comoros",kn:"Saint Kitts and Nevis",kp:"North Korea",kr:"South Korea",kw:"Kuwait",kz:"Kazakhstan",la:"Lao People's Democratic Republic",lb:"Lebanon",lc:"Saint Lucia",lk:"Sri Lanka",lr:"Liberia",ls:"Lesotho",lt:"Lithuania",lv:"Latvia",ly:"Libya",ma:"Morocco",md:"Moldova",mg:"Madagascar",mk:"Macedonia",ml:"Mali",mm:"Myanmar",mn:"Mongolia",mr:"Mauritania",mt:"Malta",mu:"Mauritius",mv:"Maldives",mw:"Malawi",mx:"Mexico",my:"Malaysia",mz:"Mozambique",na:"Namibia",nc:"New Caledonia",ne:"Niger",ng:"Nigeria",ni:"Nicaragua",nl:"Netherlands",no:"Norway",np:"Nepal",nz:"New Zealand",om:"Oman",pa:"Panama",pe:"Peru",pf:"French Polynesia",pg:"Papua New Guinea",ph:"Philippines",pk:"Pakistan",pl:"Poland",pt:"Portugal",py:"Paraguay",qa:"Qatar",re:"Reunion",ro:"Romania",rs:"Serbia",ru:"Russian Federation",rw:"Rwanda",sa:"Saudi Arabia",sb:"Solomon Islands",sc:"Seychelles",sd:"Sudan",se:"Sweden",si:"Slovenia",sk:"Slovakia",sl:"Sierra Leone",sn:"Senegal",so:"Somalia",sr:"Suriname",st:"Sao Tome and Principe",sv:"El Salvador",sy:"Syrian Arab Republic",sz:"Swaziland",td:"Chad",tg:"Togo",th:"Thailand",tj:"Tajikistan",tl:"Timor-Leste",tm:"Turkmenistan",tn:"Tunisia",tr:"Turkey",tt:"Trinidad and Tobago",tw:"Taiwan",tz:"Tanzania",ua:"Ukraine",ug:"Uganda",us:"United States of America",uy:"Uruguay",uz:"Uzbekistan",ve:"Venezuela",vn:"Vietnam",vu:"Vanuatu",ye:"Yemen",za:"South Africa",zm:"Zambia",zw:"Zimbabwe"};window.blxapp=new BlxApp})();$(document).ready(function(){blxapp.run($("meta[name=bloonix-version]").attr("content"),$("meta[name=bloonix-lang]").attr("content"),$("meta[name=bloonix-nonce]").attr("content"),$("meta[name=bloonix-style]").attr("content"))});
